/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/base/common/types","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/base/common/map","os","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","fs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/platform/telemetry/common/telemetryUtils","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/registry/common/platform","vs/base/common/performance","vs/base/parts/ipc/common/ipc","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/codicons","vs/editor/common/core/range","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/mime","vs/base/common/processes","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/functional","vs/base/common/json","path","net","vs/base/common/hash","vs/base/common/glob","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/node/zip","vs/base/common/decorators","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/themables","vs/editor/common/core/position","vs/base/common/stopwatch","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminal","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/amd","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/node/extpath","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","https","yauzl","yazl","http","vs/server/node/server.main"],be=function(le){for(var e=[],S=0,L=le.length;S<L;S++)e[S]=pe[le[S]];return e};define(pe[140],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class S{static get(){const o=new Map,A=new Map,k=new Map,R=new Map;function b(h,g){h.has(g.detail)||h.set(g.detail,-g.timestamp)}function m(h,g){const p=h.get(g.detail);p&&(p>=0||h.set(g.detail,p+g.timestamp))}let T=[];typeof le.getStats=="function"&&(T=le.getStats().slice(0).sort((h,g)=>h.timestamp-g.timestamp));for(const h of T)switch(h.type){case 10:b(o,h);break;case 11:case 12:m(o,h);break;case 21:b(A,h);break;case 22:m(A,h);break;case 33:b(k,h);break;case 34:m(k,h);break;case 31:b(R,h);break;case 32:m(R,h);break}let y=0;k.forEach(h=>y+=h);function v(h){const g=[];return h.forEach((p,r)=>g.push([r,p])),g}return{amdLoad:v(o),amdInvoke:v(A),nodeRequire:v(k),nodeEval:v(R),nodeRequireTotal:y}}static toMarkdownTable(o,A){let k="";const R=[];return o.forEach((b,m)=>{R[m]=b.length}),A.forEach(b=>{b.forEach((m,T)=>{typeof m>"u"&&(m=b[T]="-");const y=m.toString().length;R[T]=Math.max(y,R[T])})}),o.forEach((b,m)=>{k+=`| ${b+" ".repeat(R[m]-b.toString().length)} `}),k+=`|
`,o.forEach((b,m)=>{k+=`| ${"-".repeat(R[m])} `}),k+=`|
`,A.forEach(b=>{b.forEach((m,T)=>{typeof m<"u"&&(k+=`| ${m+" ".repeat(R[T]-m.toString().length)} `)}),k+=`|
`}),k}}e.LoaderStats=S}),define(pe[91],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function S(k){return(R,b,m)=>{let T=null,y=null;if(typeof m.value=="function"?(T="value",y=m.value):typeof m.get=="function"&&(T="get",y=m.get),!y)throw new Error("not supported");m[T]=k(y,b)}}function L(k,R,b){let m=null,T=null;if(typeof b.value=="function"?(m="value",T=b.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(m="get",T=b.get),!T)throw new Error("not supported");const y=`$memoize$${R}`;b[m]=function(...v){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,v)}),this[y]}}e.memoize=L;function o(k,R,b){return S((m,T)=>{const y=`$debounce$${T}`,v=`$debounce$result$${T}`;return function(...h){this[v]||(this[v]=b?b():void 0),clearTimeout(this[y]),R&&(this[v]=R(this[v],...h),h=[this[v]]),this[y]=setTimeout(()=>{m.apply(this,h),this[v]=b?b():void 0},k)}})}e.debounce=o;function A(k,R,b){return S((m,T)=>{const y=`$throttle$timer$${T}`,v=`$throttle$result$${T}`,h=`$throttle$lastRun$${T}`,g=`$throttle$pending$${T}`;return function(...p){if(this[v]||(this[v]=b?b():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),R&&(this[v]=R(this[v],...p)),this[g])return;const r=this[h]+k;r<=Date.now()?(this[h]=Date.now(),m.apply(this,[this[v]]),this[v]=b?b():void 0):(this[g]=!0,this[y]=setTimeout(()=>{this[g]=!1,this[h]=Date.now(),m.apply(this,[this[v]]),this[v]=b?b():void 0},r-Date.now()))}})}e.throttle=A}),define(pe[11],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?D.isErrorNoTelemetry(n)?new D(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.ErrorHandler=S,e.errorHandler=new S;function L(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function o(t){if(!t||typeof t!="object")return!1;const n=t;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=o;function A(t){m(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=A;function k(t){m(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=k;function R(t){if(t instanceof Error){const{name:n,message:s}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:n,message:s,stack:i,noTelemetry:D.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=R;const b="Canceled";function m(t){return t instanceof T?!0:t instanceof Error&&t.name===b&&t.message===b}e.isCancellationError=m;class T extends Error{constructor(){super(b),this.name=this.message}}e.CancellationError=T;function y(){const t=new Error(b);return t.name=t.message,t}e.canceled=y;function v(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=v;function h(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=h;function g(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function p(t){const n=new Error(`${t} has been disposed`);return n.name="DISPOSED",n}e.disposed=p;function r(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=r;class f extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=f;class c extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=c;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=u;class D extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof D)return n;const s=new D;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=D;class O extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,O.prototype)}}e.BugIndicatingError=O}),define(pe[18],be([1,0,11]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L(z,W=0){return z[z.length-(1+W)]}e.tail=L;function o(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=o;function A(z,W,q=(H,Q)=>H===Q){if(z===W)return!0;if(!z||!W||z.length!==W.length)return!1;for(let H=0,Q=z.length;H<Q;H++)if(!q(z[H],W[H]))return!1;return!0}e.equals=A;function k(z,W){const q=z.length-1;W<q&&(z[W]=z[q]),z.pop()}e.removeFastWithoutKeepingOrder=k;function R(z,W,q){return b(z.length,H=>q(z[H],W))}e.binarySearch=R;function b(z,W){let q=0,H=z-1;for(;q<=H;){const Q=(q+H)/2|0,G=W(Q);if(G<0)q=Q+1;else if(G>0)H=Q-1;else return Q}return-(q+1)}e.binarySearch2=b;function m(z,W){let q=0,H=z.length;if(H===0)return 0;for(;q<H;){const Q=Math.floor((q+H)/2);W(z[Q])?H=Q:q=Q+1}return q}e.findFirstInSorted=m;function T(z,W,q){if(z=z|0,z>=W.length)throw new TypeError("invalid index");const H=W[Math.floor(W.length*Math.random())],Q=[],G=[],Z=[];for(const ce of W){const Ee=q(ce,H);Ee<0?Q.push(ce):Ee>0?G.push(ce):Z.push(ce)}return z<Q.length?T(z,Q,q):z<Q.length+Z.length?Z[0]:T(z-(Q.length+Z.length),G,q)}e.quickSelect=T;function y(z,W){const q=[];let H;for(const Q of z.slice(0).sort(W))!H||W(H[0],Q)!==0?(H=[Q],q.push(H)):H.push(Q);return q}e.groupBy=y;function v(z,W,q){const H=[];function Q(ce,Ee,De){if(Ee===0&&De.length===0)return;const ke=H[H.length-1];ke&&ke.start+ke.deleteCount===ce?(ke.deleteCount+=Ee,ke.toInsert.push(...De)):H.push({start:ce,deleteCount:Ee,toInsert:De})}let G=0,Z=0;for(;;){if(G===z.length){Q(G,0,W.slice(Z));break}if(Z===W.length){Q(G,z.length-G,[]);break}const ce=z[G],Ee=W[Z],De=q(ce,Ee);De===0?(G+=1,Z+=1):De<0?(Q(G,1,[]),G+=1):De>0&&(Q(G,0,[Ee]),Z+=1)}return H}e.sortedDiff=v;function h(z,W,q){const H=v(z,W,q),Q=[],G=[];for(const Z of H)Q.push(...z.slice(Z.start,Z.start+Z.deleteCount)),G.push(...Z.toInsert);return{removed:Q,added:G}}e.delta=h;function g(z,W,q){if(q===0)return[];const H=z.slice(0,q).sort(W);return r(z,W,H,q,z.length),H}e.top=g;function p(z,W,q,H,Q){return q===0?Promise.resolve([]):new Promise((G,Z)=>{(async()=>{const ce=z.length,Ee=z.slice(0,q).sort(W);for(let De=q,ke=Math.min(q+H,ce);De<ce;De=ke,ke=Math.min(ke+H,ce)){if(De>q&&await new Promise(Fe=>setTimeout(Fe)),Q&&Q.isCancellationRequested)throw new S.CancellationError;r(z,W,Ee,De,ke)}return Ee})().then(G,Z)})}e.topAsync=p;function r(z,W,q,H,Q){for(const G=q.length;H<Q;H++){const Z=z[H];if(W(Z,q[G-1])<0){q.pop();const ce=m(q,Ee=>W(Z,Ee)<0);q.splice(ce,0,Z)}}}function f(z){return z.filter(W=>!!W)}e.coalesce=f;function c(z){let W=0;for(let q=0;q<z.length;q++)z[q]&&(z[W]=z[q],W+=1);z.length=W}e.coalesceInPlace=c;function u(z,W,q){z.splice(q,0,z.splice(W,1)[0])}e.move=u;function D(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=D;function O(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=O;function t(z,W=q=>q){const q=new Set;return z.filter(H=>{const Q=W(H);return q.has(Q)?!1:(q.add(Q),!0)})}e.distinct=t;function n(z){const W=new Set;return q=>{const H=z(q);return W.has(H)?!1:(W.add(H),!0)}}e.uniqueFilter=n;function s(z,W){const q=i(z,W);if(q!==-1)return z[q]}e.findLast=s;function i(z,W){for(let q=z.length-1;q>=0;q--){const H=z[q];if(W(H))return q}return-1}e.lastIndex=i;function a(z,W){return z.length>0?z[0]:W}e.firstOrDefault=a;function l(z,W){return z.length>0?z[z.length-1]:W}e.lastOrDefault=l;function d(z,W,q=(H,Q)=>H===Q){let H=0;for(let Q=0,G=Math.min(z.length,W.length);Q<G&&q(z[Q],W[Q]);Q++)H++;return H}e.commonPrefixLength=d;function I(z){return[].concat(...z)}e.flatten=I;function C(z,W){let q=typeof W=="number"?z:0;typeof W=="number"?q=z:(q=0,W=z);const H=[];if(q<=W)for(let Q=q;Q<W;Q++)H.push(Q);else for(let Q=q;Q>W;Q--)H.push(Q);return H}e.range=C;function E(z,W,q){return z.reduce((H,Q)=>(H[W(Q)]=q?q(Q):Q,H),Object.create(null))}e.index=E;function w(z,W){return z.push(W),()=>N(z,W)}e.insert=w;function N(z,W){const q=z.indexOf(W);if(q>-1)return z.splice(q,1),W}e.remove=N;function $(z,W,q){const H=z.slice(0,W),Q=z.slice(W);return H.concat(q,Q)}e.arrayInsert=$;function se(z,W){let q;if(typeof W=="number"){let H=W;q=()=>{const Q=Math.sin(H++)*179426549;return Q-Math.floor(Q)}}else q=Math.random;for(let H=z.length-1;H>0;H-=1){const Q=Math.floor(q()*(H+1)),G=z[H];z[H]=z[Q],z[Q]=G}}e.shuffle=se;function he(z,W){const q=z.indexOf(W);q>-1&&(z.splice(q,1),z.unshift(W))}e.pushToStart=he;function ae(z,W){const q=z.indexOf(W);q>-1&&(z.splice(q,1),z.push(W))}e.pushToEnd=ae;function ue(z,W){for(const q of W)z.push(q)}e.pushMany=ue;function ge(z,W){return Array.isArray(z)?z.map(W):W(z)}e.mapArrayOrNot=ge;function _(z){return Array.isArray(z)?z:[z]}e.asArray=_;function ie(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=ie;function V(z,W){for(const q of z){const H=W(q);if(H!==void 0)return H}}e.mapFind=V;function J(z,W,q){const H=ne(z,W),Q=z.length,G=q.length;z.length=Q+G;for(let Z=Q-1;Z>=H;Z--)z[Z+G]=z[Z];for(let Z=0;Z<G;Z++)z[Z+H]=q[Z]}e.insertInto=J;function U(z,W,q,H){const Q=ne(z,W),G=z.splice(Q,q);return J(z,Q,H),G}e.splice=U;function ne(z,W){return W<0?Math.max(W+z.length,0):Math.min(W,z.length)}var x;(function(z){function W(Q){return Q<0}z.isLessThan=W;function q(Q){return Q>0}z.isGreaterThan=q;function H(Q){return Q===0}z.isNeitherLessOrGreaterThan=H,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(x||(e.CompareResult=x={}));function re(z,W){return(q,H)=>W(z(q),z(H))}e.compareBy=re;function Y(...z){return(W,q)=>{for(const H of z){const Q=H(W,q);if(!x.isNeitherLessOrGreaterThan(Q))return Q}return x.neitherLessOrGreaterThan}}e.tieBreakComparators=Y;const ee=(z,W)=>z-W;e.numberComparator=ee;function j(z,W){if(z.length===0)return;let q=z[0];for(let H=1;H<z.length;H++){const Q=z[H];W(Q,q)>0&&(q=Q)}return q}e.findMaxBy=j;function P(z,W){if(z.length===0)return;let q=z[0];for(let H=1;H<z.length;H++){const Q=z[H];W(Q,q)>=0&&(q=Q)}return q}e.findLastMaxBy=P;function M(z,W){return j(z,(q,H)=>-W(q,H))}e.findMinBy=M;class K{constructor(W){this.f=W,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(W){let q=this.c;for(;q<this.f.length&&W(this.f[q]);)q++;const H=q===this.c?null:this.f.slice(this.c,q);return this.c=q,H}takeFromEndWhile(W){let q=this.d;for(;q>=0&&W(this.f[q]);)q--;const H=q===this.d?null:this.f.slice(q+1,this.d+1);return this.d=q,H}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const W=this.f[this.c];return this.c++,W}removeLast(){const W=this.f[this.d];return this.d--,W}takeCount(W){const q=this.f.slice(this.c,this.c+W);return this.c+=W,q}}e.ArrayQueue=K;class te{constructor(W){this.iterate=W}forEach(W){this.iterate(q=>(W(q),!0))}toArray(){const W=[];return this.iterate(q=>(W.push(q),!0)),W}filter(W){return new te(q=>this.iterate(H=>W(H)?q(H):!0))}map(W){return new te(q=>this.iterate(H=>q(W(H))))}some(W){let q=!1;return this.iterate(H=>(q=W(H),!q)),q}findFirst(W){let q;return this.iterate(H=>W(H)?(q=H,!1):!0),q}findLast(W){let q;return this.iterate(H=>(W(H)&&(q=H),!0)),q}findLastMaxBy(W){let q,H=!0;return this.iterate(Q=>((H||x.isGreaterThan(W(Q,q)))&&(H=!1,q=Q),!0)),q}}e.CallbackIterable=te,te.empty=new te(z=>{})}),define(pe[92],be([1,0,11]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(b,m){if(!b)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=L;function o(b,m="Unreachable"){throw new Error(m)}e.assertNever=o;function A(b){if(!b)throw new S.BugIndicatingError("Assertion Failed")}e.assert=A;function k(b){if(!b()){debugger;b(),(0,S.onUnexpectedError)(new S.BugIndicatingError("Assertion Failed"))}}e.assertFn=k;function R(b,m){let T=0;for(;T<b.length-1;){const y=b[T],v=b[T+1];if(!m(y,v))return!1;T++}return!0}e.checkAdjacentItems=R}),define(pe[71],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(L){const o=this;let A=!1,k;return function(){return A||(A=!0,k=L.apply(o,arguments)),k}}e.once=S}),define(pe[46],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(L){function o(D){return D&&typeof D=="object"&&typeof D[Symbol.iterator]=="function"}L.is=o;const A=Object.freeze([]);function k(){return A}L.empty=k;function*R(D){yield D}L.single=R;function b(D){return o(D)?D:R(D)}L.wrap=b;function m(D){return D||A}L.from=m;function T(D){return!D||D[Symbol.iterator]().next().done===!0}L.isEmpty=T;function y(D){return D[Symbol.iterator]().next().value}L.first=y;function v(D,O){for(const t of D)if(O(t))return!0;return!1}L.some=v;function h(D,O){for(const t of D)if(O(t))return t}L.find=h;function*g(D,O){for(const t of D)O(t)&&(yield t)}L.filter=g;function*p(D,O){let t=0;for(const n of D)yield O(n,t++)}L.map=p;function*r(...D){for(const O of D)for(const t of O)yield t}L.concat=r;function f(D,O,t){let n=t;for(const s of D)n=O(n,s);return n}L.reduce=f;function*c(D,O,t=D.length){for(O<0&&(O+=D.length),t<0?t+=D.length:t>D.length&&(t=D.length);O<t;O++)yield D[O]}L.slice=c;function u(D,O=Number.POSITIVE_INFINITY){const t=[];if(O===0)return[t,D];const n=D[Symbol.iterator]();for(let s=0;s<O;s++){const i=n.next();if(i.done)return[t,L.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return n}}]}L.consume=u})(S||(e.Iterable=S={}))}),define(pe[72],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var o;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(o||(e.ParseErrorCode=o={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function k(t,n=!1){let s=0;const i=t.length;let a="",l=0,d=16,I=0;function C(ae){let ue=0,ge=0;for(;ue<ae;){const _=t.charCodeAt(s);if(_>=48&&_<=57)ge=ge*16+_-48;else if(_>=65&&_<=70)ge=ge*16+_-65+10;else if(_>=97&&_<=102)ge=ge*16+_-97+10;else break;s++,ue++}return ue<ae&&(ge=-1),ge}function E(ae){s=ae,a="",l=0,d=16,I=0}function w(){const ae=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&m(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&m(t.charCodeAt(s)))for(s++;s<t.length&&m(t.charCodeAt(s));)s++;else return I=3,t.substring(ae,s);let ue=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&m(t.charCodeAt(s))){for(s++;s<t.length&&m(t.charCodeAt(s));)s++;ue=s}else I=3;return t.substring(ae,ue)}function N(){let ae="",ue=s;for(;;){if(s>=i){ae+=t.substring(ue,s),I=2;break}const ge=t.charCodeAt(s);if(ge===34){ae+=t.substring(ue,s),s++;break}if(ge===92){if(ae+=t.substring(ue,s),s++,s>=i){I=2;break}switch(t.charCodeAt(s++)){case 34:ae+='"';break;case 92:ae+="\\";break;case 47:ae+="/";break;case 98:ae+="\b";break;case 102:ae+="\f";break;case 110:ae+=`
`;break;case 114:ae+="\r";break;case 116:ae+="	";break;case 117:{const ie=C(4);ie>=0?ae+=String.fromCharCode(ie):I=4;break}default:I=5}ue=s;continue}if(ge>=0&&ge<=31)if(b(ge)){ae+=t.substring(ue,s),I=2;break}else I=6;s++}return ae}function $(){if(a="",I=0,l=s,s>=i)return l=i,d=17;let ae=t.charCodeAt(s);if(R(ae)){do s++,a+=String.fromCharCode(ae),ae=t.charCodeAt(s);while(R(ae));return d=15}if(b(ae))return s++,a+=String.fromCharCode(ae),ae===13&&t.charCodeAt(s)===10&&(s++,a+=`
`),d=14;switch(ae){case 123:return s++,d=1;case 125:return s++,d=2;case 91:return s++,d=3;case 93:return s++,d=4;case 58:return s++,d=6;case 44:return s++,d=5;case 34:return s++,a=N(),d=10;case 47:{const ue=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!b(t.charCodeAt(s));)s++;return a=t.substring(ue,s),d=12}if(t.charCodeAt(s+1)===42){s+=2;const ge=i-1;let _=!1;for(;s<ge;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,_=!0;break}s++}return _||(s++,I=1),a=t.substring(ue,s),d=13}return a+=String.fromCharCode(ae),s++,d=16}case 45:if(a+=String.fromCharCode(ae),s++,s===i||!m(t.charCodeAt(s)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=w(),d=11;default:for(;s<i&&se(ae);)s++,ae=t.charCodeAt(s);if(l!==s){switch(a=t.substring(l,s),a){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return a+=String.fromCharCode(ae),s++,d=16}}function se(ae){if(R(ae)||b(ae))return!1;switch(ae){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function he(){let ae;do ae=$();while(ae>=12&&ae<=15);return ae}return{setPosition:E,getPosition:()=>s,scan:n?he:$,getToken:()=>d,getTokenValue:()=>a,getTokenOffset:()=>l,getTokenLength:()=>s-l,getTokenError:()=>I}}e.createScanner=k;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function b(t){return t===10||t===13||t===8232||t===8233}function m(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function y(t,n){const s=[],i=new Object;let a;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function I(C,E,w,N){l.value=C,l.offset=E,l.length=w,l.type=N,l.colonOffset=void 0,a=l}try{u(t,{onObjectBegin:(C,E)=>{if(n<=C)throw i;a=void 0,d=n>C,s.push("")},onObjectProperty:(C,E,w)=>{if(n<E||(I(C,E,w,"property"),s[s.length-1]=C,n<=E+w))throw i},onObjectEnd:(C,E)=>{if(n<=C)throw i;a=void 0,s.pop()},onArrayBegin:(C,E)=>{if(n<=C)throw i;a=void 0,s.push(0)},onArrayEnd:(C,E)=>{if(n<=C)throw i;a=void 0,s.pop()},onLiteralValue:(C,E,w)=>{if(n<E||(I(C,E,w,O(C)),n<=E+w))throw i},onSeparator:(C,E,w)=>{if(n<=E)throw i;if(C===":"&&a&&a.type==="property")a.colonOffset=E,d=!1,a=void 0;else if(C===","){const N=s[s.length-1];typeof N=="number"?s[s.length-1]=N+1:(d=!0,s[s.length-1]=""),a=void 0}}})}catch(C){if(C!==i)throw C}return{path:s,previousNode:a,isAtPropertyKey:d,matches:C=>{let E=0;for(let w=0;E<C.length&&w<s.length;w++)if(C[E]===s[w]||C[E]==="*")E++;else if(C[E]!=="**")return!1;return E===C.length}}}e.getLocation=y;function v(t,n=[],s=A.DEFAULT){let i=null,a=[];const l=[];function d(C){Array.isArray(a)?a.push(C):i!==null&&(a[i]=C)}return u(t,{onObjectBegin:()=>{const C={};d(C),l.push(a),a=C,i=null},onObjectProperty:C=>{i=C},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const C=[];d(C),l.push(a),a=C,i=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:d,onError:(C,E,w)=>{n.push({error:C,offset:E,length:w})}},s),a[0]}e.parse=v;function h(t,n=[],s=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(C){i.type==="property"&&(i.length=C-i.offset,i=i.parent)}function l(C){return i.children.push(C),C}u(t,{onObjectBegin:C=>{i=l({type:"object",offset:C,length:-1,parent:i,children:[]})},onObjectProperty:(C,E,w)=>{i=l({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:C,offset:E,length:w,parent:i})},onObjectEnd:(C,E)=>{i.length=C+E-i.offset,i=i.parent,a(C+E)},onArrayBegin:(C,E)=>{i=l({type:"array",offset:C,length:-1,parent:i,children:[]})},onArrayEnd:(C,E)=>{i.length=C+E-i.offset,i=i.parent,a(C+E)},onLiteralValue:(C,E,w)=>{l({type:O(C),offset:E,length:w,parent:i,value:C}),a(E+w)},onSeparator:(C,E,w)=>{i.type==="property"&&(C===":"?i.colonOffset=E:C===","&&a(E))},onError:(C,E,w)=>{n.push({error:C,offset:E,length:w})}},s);const I=i.children[0];return I&&delete I.parent,I}e.parseTree=h;function g(t,n){if(!t)return;let s=t;for(const i of n)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const l of s.children)if(Array.isArray(l.children)&&l.children[0].value===i){s=l.children[1],a=!0;break}if(!a)return}else{const a=i;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}e.findNodeAtLocation=g;function p(t){if(!t.parent||!t.parent.children)return[];const n=p(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=p;function r(t){switch(t.type){case"array":return t.children.map(r);case"object":{const n=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(n[s.children[0].value]=r(i))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=r;function f(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=f;function c(t,n,s=!1){if(f(t,n,s)){const i=t.children;if(Array.isArray(i))for(let a=0;a<i.length&&i[a].offset<=n;a++){const l=c(i[a],n,s);if(l)return l}return t}}e.findNodeAtOffset=c;function u(t,n,s=A.DEFAULT){const i=k(t,!1);function a(re){return re?()=>re(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(re){return re?Y=>re(Y,i.getTokenOffset(),i.getTokenLength()):()=>!0}const d=a(n.onObjectBegin),I=l(n.onObjectProperty),C=a(n.onObjectEnd),E=a(n.onArrayBegin),w=a(n.onArrayEnd),N=l(n.onLiteralValue),$=l(n.onSeparator),se=a(n.onComment),he=l(n.onError),ae=s&&s.disallowComments,ue=s&&s.allowTrailingComma;function ge(){for(;;){const re=i.scan();switch(i.getTokenError()){case 4:_(14);break;case 5:_(15);break;case 3:_(13);break;case 1:ae||_(11);break;case 2:_(12);break;case 6:_(16);break}switch(re){case 12:case 13:ae?_(10):se();break;case 16:_(1);break;case 15:case 14:break;default:return re}}}function _(re,Y=[],ee=[]){if(he(re),Y.length+ee.length>0){let j=i.getToken();for(;j!==17;){if(Y.indexOf(j)!==-1){ge();break}else if(ee.indexOf(j)!==-1)break;j=ge()}}}function ie(re){const Y=i.getTokenValue();return re?N(Y):I(Y),ge(),!0}function V(){switch(i.getToken()){case 11:{let re=0;try{re=JSON.parse(i.getTokenValue()),typeof re!="number"&&(_(2),re=0)}catch{_(2)}N(re);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return ge(),!0}function J(){return i.getToken()!==10?(_(3,[],[2,5]),!1):(ie(!1),i.getToken()===6?($(":"),ge(),x()||_(4,[],[2,5])):_(5,[],[2,5]),!0)}function U(){d(),ge();let re=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(re||_(4,[],[]),$(","),ge(),i.getToken()===2&&ue)break}else re&&_(6,[],[]);J()||_(4,[],[2,5]),re=!0}return C(),i.getToken()!==2?_(7,[2],[]):ge(),!0}function ne(){E(),ge();let re=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(re||_(4,[],[]),$(","),ge(),i.getToken()===4&&ue)break}else re&&_(6,[],[]);x()||_(4,[],[4,5]),re=!0}return w(),i.getToken()!==4?_(8,[4],[]):ge(),!0}function x(){switch(i.getToken()){case 3:return ne();case 1:return U();case 10:return ie(!0);default:return V()}}return ge(),i.getToken()===17?s.allowEmptyContent?!0:(_(4,[],[]),!1):x()?(i.getToken()!==17&&_(9,[],[]),!0):(_(4,[],[]),!1)}e.visit=u;function D(t,n){const s=k(t),i=[];let a,l=0,d;do switch(d=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:l!==d&&i.push(t.substring(l,d)),n!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,n)),l=s.getPosition();break}while(a!==17);return i.join("")}e.stripComments=D;function O(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=O}),define(pe[93],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class S{constructor(o){this.d=o,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(o){this.c=o}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=S}),define(pe[2],be([1,0,71,46]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const o=!1;let A=null;function k(l){A=l}if(e.setDisposableTracker=k,o){const l="__is_disposable_tracked__";k(new class{trackDisposable(d){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[l]||console.log(I)},3e3)}setParent(d,I){if(d&&d!==c.None)try{d[l]=!0}catch{}}markAsDisposed(d){if(d&&d!==c.None)try{d[l]=!0}catch{}}markAsSingleton(d){}})}function R(l){return A?.trackDisposable(l),l}function b(l){A?.markAsDisposed(l)}function m(l,d){A?.setParent(l,d)}function T(l,d){if(A)for(const I of l)A.setParent(I,d)}function y(l){return A?.markAsSingleton(l),l}e.markAsSingleton=y;function v(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=v;function h(l){if(L.Iterable.is(l)){const d=[];for(const I of l)if(I)try{I.dispose()}catch(C){d.push(C)}if(d.length===1)throw d[0];if(d.length>1)throw new AggregateError(d,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=h;function g(l){for(const d of l)v(d)&&d.dispose();return[]}e.disposeIfDisposable=g;function p(...l){const d=r(()=>h(l));return T(l,d),d}e.combinedDisposable=p;function r(l){const d=R({dispose:(0,S.once)(()=>{b(d),l()})});return d}e.toDisposable=r;class f{constructor(){this.f=new Set,this.g=!1,R(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return m(d,this),this.g?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(d),d}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this.q=new f,R(this),m(this.q,this)}dispose(){b(this),this.q.dispose()}B(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(d)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class u{constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(d){this.b||d===this.a||(this.a?.dispose(),d&&m(d,this),this.a=d)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const d=this.a;return this.a=void 0,d&&m(d,null),d}}e.MutableDisposable=u;class D{constructor(d){this.b=d,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=D;class O{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(d){let I=d;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,b(this))},this}}e.SafeDisposable=O;class t{constructor(){this.a=new Map}acquire(d,...I){let C=this.a.get(d);C||(C={counter:0,object:this.b(d,...I)},this.a.set(d,C));const{object:E}=C,w=(0,S.once)(()=>{--C.counter===0&&(this.c(d,C.object),this.a.delete(d))});return C.counter++,{object:E,dispose:w}}}e.ReferenceCollection=t;class n{constructor(d){this.a=d}async acquire(d,...I){const C=this.a.acquire(d,...I);try{return{object:await C.object,dispose:()=>C.dispose()}}catch(E){throw C.dispose(),E}}}e.AsyncReferenceCollection=n;class s{constructor(d){this.object=d}dispose(){}}e.ImmortalReference=s;function i(l){const d=new f;try{l(d)}finally{d.dispose()}}e.disposeOnReturn=i;class a{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(d){return this.a.has(d)}get(d){return this.a.get(d)}set(d,I,C=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),C||this.a.get(d)?.dispose(),this.a.set(d,I)}deleteAndDispose(d){this.a.get(d)?.dispose(),this.a.delete(d)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=a}),define(pe[94],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(A){this.element=A,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class L{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let A=this.a;for(;A!==S.Undefined;){const k=A.next;A.prev=S.Undefined,A.next=S.Undefined,A=k}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,k){const R=new S(A);if(this.a===S.Undefined)this.a=R,this.b=R;else if(k){const m=this.b;this.b=R,R.prev=m,m.next=R}else{const m=this.a;this.a=R,R.next=m,m.prev=R}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(R))}}shift(){if(this.a!==S.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==S.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==S.Undefined&&A.next!==S.Undefined){const k=A.prev;k.next=A.next,A.next.prev=k}else A.prev===S.Undefined&&A.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):A.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):A.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==S.Undefined;)yield A.element,A=A.next}}e.LinkedList=L}),define(pe[27],be([1,0]),function(le,e){"use strict";var S,L,o;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(p,r,f){let c=p.get(r);return c===void 0&&(c=f,p.set(r,c)),c}e.getOrSet=A;function k(p){const r=[];return p.forEach((f,c)=>{r.push(`${c} => ${f}`)}),`Map(${p.size}) {${r.join(", ")}}`}e.mapToString=k;function R(p){const r=[];return p.forEach(f=>{r.push(f)}),`Set(${p.size}) {${r.join(", ")}}`}e.setToString=R;class b{constructor(r,f){this.uri=r,this.value=f}}class m{constructor(r,f){this[S]="ResourceMap",r instanceof m?(this.b=new Map(r.b),this.c=f??m.a):(this.b=new Map,this.c=r??m.a)}set(r,f){return this.b.set(this.c(r),new b(r,f)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,f){typeof f<"u"&&(r=r.bind(f));for(const[c,u]of this.b)r(u.value,u.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}e.ResourceMap=m,m.a=p=>p.toString();class T{constructor(r,f){this[L]="ResourceSet",!r||typeof r=="function"?this.a=new m(r):(this.a=new m(f),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,f){this.a.forEach((c,u)=>r.call(f,u,u,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=T;var y;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class v{constructor(){this[o]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,f=0){const c=this.a.get(r);if(c)return f!==0&&this.j(c,f),c.value}set(r,f,c=0){let u=this.a.get(r);if(u)u.value=f,c!==0&&this.j(u,c);else{switch(u={key:r,value:f,next:void 0,previous:void 0},c){case 0:this.h(u);break;case 1:this.g(u);break;case 2:this.h(u);break;default:this.h(u);break}this.a.set(r,u),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const f=this.a.get(r);if(f)return this.a.delete(r),this.i(f),this.d--,f.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,f){const c=this.e;let u=this.b;for(;u;){if(f?r.bind(f)(u.value,u.key,this):r(u.value,u.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,f=this.e;let c=this.b;const u={[Symbol.iterator](){return u},next(){if(r.e!==f)throw new Error("LinkedMap got modified during iteration.");if(c){const D={value:c.key,done:!1};return c=c.next,D}else return{value:void 0,done:!0}}};return u}values(){const r=this,f=this.e;let c=this.b;const u={[Symbol.iterator](){return u},next(){if(r.e!==f)throw new Error("LinkedMap got modified during iteration.");if(c){const D={value:c.value,done:!1};return c=c.next,D}else return{value:void 0,done:!0}}};return u}entries(){const r=this,f=this.e;let c=this.b;const u={[Symbol.iterator](){return u},next(){if(r.e!==f)throw new Error("LinkedMap got modified during iteration.");if(c){const D={value:[c.key,c.value],done:!1};return c=c.next,D}else return{value:void 0,done:!0}}};return u}[(o=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let f=this.b,c=this.size;for(;f&&c>r;)this.a.delete(f.key),f=f.next,c--;this.b=f,this.d=c,f&&(f.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const f=r.next,c=r.previous;if(!f||!c)throw new Error("Invalid list");f.previous=c,c.next=f}r.next=void 0,r.previous=void 0,this.e++}j(r,f){if(!this.b||!this.c)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(r===this.b)return;const c=r.next,u=r.previous;r===this.c?(u.next=void 0,this.c=u):(c.previous=u,u.next=c),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(f===2){if(r===this.c)return;const c=r.next,u=r.previous;r===this.b?(c.previous=void 0,this.b=c):(c.previous=u,u.next=c),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((f,c)=>{r.push([c,f])}),r}fromJSON(r){this.clear();for(const[f,c]of r)this.set(f,c)}}e.LinkedMap=v;class h extends v{constructor(r,f=1){super(),this.k=r,this.l=Math.min(Math.max(0,f),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,f=2){return super.get(r,f)}peek(r){return super.get(r,0)}set(r,f){return super.set(r,f,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=h;class g{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let f=this.a.get(r)||0;return f===0?!1:(f--,f===0?this.a.delete(r):this.a.set(r,f),!0)}has(r){return this.a.has(r)}}e.CounterSet=g}),function(le,e){typeof define=="function"&&define.amd?define(pe[141],be([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(z,W){for(var q=0;q<W.length;q++){var H=W[q];H.enumerable=H.enumerable||!1,H.configurable=!0,"value"in H&&(H.writable=!0),Object.defineProperty(z,H.key,H)}}function S(z,W,q){return W&&e(z.prototype,W),q&&e(z,q),Object.defineProperty(z,"prototype",{writable:!1}),z}function L(z,W){if(z){if(typeof z=="string")return o(z,W);var q=Object.prototype.toString.call(z).slice(8,-1);if(q==="Object"&&z.constructor&&(q=z.constructor.name),q==="Map"||q==="Set")return Array.from(z);if(q==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(q))return o(z,W)}}function o(z,W){(W==null||W>z.length)&&(W=z.length);for(var q=0,H=new Array(W);q<W;q++)H[q]=z[q];return H}function A(z,W){var q=typeof Symbol<"u"&&z[Symbol.iterator]||z["@@iterator"];if(q)return(q=q.call(z)).next.bind(q);if(Array.isArray(z)||(q=L(z))||W&&z&&typeof z.length=="number"){q&&(z=q);var H=0;return function(){return H>=z.length?{done:!0}:{done:!1,value:z[H++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=k();function R(z){le.defaults=z}var b=/[&<>"']/,m=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(W){return v[W]};function g(z,W){if(W){if(b.test(z))return z.replace(m,h)}else if(T.test(z))return z.replace(y,h);return z}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(z){return z.replace(p,function(W,q){return q=q.toLowerCase(),q==="colon"?":":q.charAt(0)==="#"?q.charAt(1)==="x"?String.fromCharCode(parseInt(q.substring(2),16)):String.fromCharCode(+q.substring(1)):""})}var f=/(^|[^\[])\^/g;function c(z,W){z=typeof z=="string"?z:z.source,W=W||"";var q={replace:function(Q,G){return G=G.source||G,G=G.replace(f,"$1"),z=z.replace(Q,G),q},getRegex:function(){return new RegExp(z,W)}};return q}var u=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function O(z,W,q){if(z){var H;try{H=decodeURIComponent(r(q)).replace(u,"").toLowerCase()}catch{return null}if(H.indexOf("javascript:")===0||H.indexOf("vbscript:")===0||H.indexOf("data:")===0)return null}W&&!D.test(q)&&(q=a(W,q));try{q=encodeURI(q).replace(/%25/g,"%")}catch{return null}return q}var t={},n=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(z,W){t[" "+z]||(n.test(z)?t[" "+z]=z+"/":t[" "+z]=C(z,"/",!0)),z=t[" "+z];var q=z.indexOf(":")===-1;return W.substring(0,2)==="//"?q?W:z.replace(s,"$1")+W:W.charAt(0)==="/"?q?W:z.replace(i,"$1")+W:z+W}var l={exec:function(){}};function d(z){for(var W=1,q,H;W<arguments.length;W++){q=arguments[W];for(H in q)Object.prototype.hasOwnProperty.call(q,H)&&(z[H]=q[H])}return z}function I(z,W){var q=z.replace(/\|/g,function(G,Z,ce){for(var Ee=!1,De=Z;--De>=0&&ce[De]==="\\";)Ee=!Ee;return Ee?"|":" |"}),H=q.split(/ \|/),Q=0;if(H[0].trim()||H.shift(),H.length>0&&!H[H.length-1].trim()&&H.pop(),H.length>W)H.splice(W);else for(;H.length<W;)H.push("");for(;Q<H.length;Q++)H[Q]=H[Q].trim().replace(/\\\|/g,"|");return H}function C(z,W,q){var H=z.length;if(H===0)return"";for(var Q=0;Q<H;){var G=z.charAt(H-Q-1);if(G===W&&!q)Q++;else if(G!==W&&q)Q++;else break}return z.slice(0,H-Q)}function E(z,W){if(z.indexOf(W[1])===-1)return-1;for(var q=z.length,H=0,Q=0;Q<q;Q++)if(z[Q]==="\\")Q++;else if(z[Q]===W[0])H++;else if(z[Q]===W[1]&&(H--,H<0))return Q;return-1}function w(z){z&&z.sanitize&&!z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(z,W){if(W<1)return"";for(var q="";W>1;)W&1&&(q+=z),W>>=1,z+=z;return q+z}function $(z,W,q,H){var Q=W.href,G=W.title?g(W.title):null,Z=z[1].replace(/\\([\[\]])/g,"$1");if(z[0].charAt(0)!=="!"){H.state.inLink=!0;var ce={type:"link",raw:q,href:Q,title:G,text:Z,tokens:H.inlineTokens(Z)};return H.state.inLink=!1,ce}return{type:"image",raw:q,href:Q,title:G,text:g(Z)}}function se(z,W){var q=z.match(/^(\s+)(?:```)/);if(q===null)return W;var H=q[1];return W.split(`
`).map(function(Q){var G=Q.match(/^\s+/);if(G===null)return Q;var Z=G[0];return Z.length>=H.length?Q.slice(H.length):Q}).join(`
`)}var he=function(){function z(q){this.options=q||le.defaults}var W=z.prototype;return W.space=function(H){var Q=this.rules.block.newline.exec(H);if(Q&&Q[0].length>0)return{type:"space",raw:Q[0]}},W.code=function(H){var Q=this.rules.block.code.exec(H);if(Q){var G=Q[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Q[0],codeBlockStyle:"indented",text:this.options.pedantic?G:C(G,`
`)}}},W.fences=function(H){var Q=this.rules.block.fences.exec(H);if(Q){var G=Q[0],Z=se(G,Q[3]||"");return{type:"code",raw:G,lang:Q[2]?Q[2].trim():Q[2],text:Z}}},W.heading=function(H){var Q=this.rules.block.heading.exec(H);if(Q){var G=Q[2].trim();if(/#$/.test(G)){var Z=C(G,"#");(this.options.pedantic||!Z||/ $/.test(Z))&&(G=Z.trim())}return{type:"heading",raw:Q[0],depth:Q[1].length,text:G,tokens:this.lexer.inline(G)}}},W.hr=function(H){var Q=this.rules.block.hr.exec(H);if(Q)return{type:"hr",raw:Q[0]}},W.blockquote=function(H){var Q=this.rules.block.blockquote.exec(H);if(Q){var G=Q[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Q[0],tokens:this.lexer.blockTokens(G,[]),text:G}}},W.list=function(H){var Q=this.rules.block.list.exec(H);if(Q){var G,Z,ce,Ee,De,ke,Fe,ze,me,Se,we,Ue,Be=Q[1].trim(),et=Be.length>1,He={type:"list",raw:"",ordered:et,start:et?+Be.slice(0,-1):"",loose:!1,items:[]};Be=et?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=et?Be:"[*+-]");for(var Ve=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");H&&(Ue=!1,!(!(Q=Ve.exec(H))||this.rules.block.hr.test(H)));){if(G=Q[0],H=H.substring(G.length),ze=Q[2].split(`
`,1)[0],me=H.split(`
`,1)[0],this.options.pedantic?(Ee=2,we=ze.trimLeft()):(Ee=Q[2].search(/[^ ]/),Ee=Ee>4?1:Ee,we=ze.slice(Ee),Ee+=Q[1].length),ke=!1,!ze&&/^ *$/.test(me)&&(G+=me+`
`,H=H.substring(me.length+1),Ue=!0),!Ue)for(var Ze=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ke=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}(?:```|~~~)"),Xe=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}#");H&&(Se=H.split(`
`,1)[0],ze=Se,this.options.pedantic&&(ze=ze.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ke.test(ze)||Xe.test(ze)||Ze.test(ze)||it.test(H)));){if(ze.search(/[^ ]/)>=Ee||!ze.trim())we+=`
`+ze.slice(Ee);else if(!ke)we+=`
`+ze;else break;!ke&&!ze.trim()&&(ke=!0),G+=Se+`
`,H=H.substring(Se.length+1)}He.loose||(Fe?He.loose=!0:/\n *\n *$/.test(G)&&(Fe=!0)),this.options.gfm&&(Z=/^\[[ xX]\] /.exec(we),Z&&(ce=Z[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:G,task:!!Z,checked:ce,loose:!1,text:we}),He.raw+=G}He.items[He.items.length-1].raw=G.trimRight(),He.items[He.items.length-1].text=we.trimRight(),He.raw=He.raw.trimRight();var fe=He.items.length;for(De=0;De<fe;De++){this.lexer.state.top=!1,He.items[De].tokens=this.lexer.blockTokens(He.items[De].text,[]);var Ce=He.items[De].tokens.filter(function(Re){return Re.type==="space"}),Te=Ce.every(function(Re){for(var Oe=Re.raw.split(""),$e=0,Ge=A(Oe),qe;!(qe=Ge()).done;){var tt=qe.value;if(tt===`
`&&($e+=1),$e>1)return!0}return!1});!He.loose&&Ce.length&&Te&&(He.loose=!0,He.items[De].loose=!0)}return He}},W.html=function(H){var Q=this.rules.block.html.exec(H);if(Q){var G={type:"html",raw:Q[0],pre:!this.options.sanitizer&&(Q[1]==="pre"||Q[1]==="script"||Q[1]==="style"),text:Q[0]};if(this.options.sanitize){var Z=this.options.sanitizer?this.options.sanitizer(Q[0]):g(Q[0]);G.type="paragraph",G.text=Z,G.tokens=this.lexer.inline(Z)}return G}},W.def=function(H){var Q=this.rules.block.def.exec(H);if(Q){Q[3]&&(Q[3]=Q[3].substring(1,Q[3].length-1));var G=Q[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:G,raw:Q[0],href:Q[2],title:Q[3]}}},W.table=function(H){var Q=this.rules.block.table.exec(H);if(Q){var G={type:"table",header:I(Q[1]).map(function(Fe){return{text:Fe}}),align:Q[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Q[3]&&Q[3].trim()?Q[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(G.header.length===G.align.length){G.raw=Q[0];var Z=G.align.length,ce,Ee,De,ke;for(ce=0;ce<Z;ce++)/^ *-+: *$/.test(G.align[ce])?G.align[ce]="right":/^ *:-+: *$/.test(G.align[ce])?G.align[ce]="center":/^ *:-+ *$/.test(G.align[ce])?G.align[ce]="left":G.align[ce]=null;for(Z=G.rows.length,ce=0;ce<Z;ce++)G.rows[ce]=I(G.rows[ce],G.header.length).map(function(Fe){return{text:Fe}});for(Z=G.header.length,Ee=0;Ee<Z;Ee++)G.header[Ee].tokens=this.lexer.inline(G.header[Ee].text);for(Z=G.rows.length,Ee=0;Ee<Z;Ee++)for(ke=G.rows[Ee],De=0;De<ke.length;De++)ke[De].tokens=this.lexer.inline(ke[De].text);return G}}},W.lheading=function(H){var Q=this.rules.block.lheading.exec(H);if(Q)return{type:"heading",raw:Q[0],depth:Q[2].charAt(0)==="="?1:2,text:Q[1],tokens:this.lexer.inline(Q[1])}},W.paragraph=function(H){var Q=this.rules.block.paragraph.exec(H);if(Q){var G=Q[1].charAt(Q[1].length-1)===`
`?Q[1].slice(0,-1):Q[1];return{type:"paragraph",raw:Q[0],text:G,tokens:this.lexer.inline(G)}}},W.text=function(H){var Q=this.rules.block.text.exec(H);if(Q)return{type:"text",raw:Q[0],text:Q[0],tokens:this.lexer.inline(Q[0])}},W.escape=function(H){var Q=this.rules.inline.escape.exec(H);if(Q)return{type:"escape",raw:Q[0],text:g(Q[1])}},W.tag=function(H){var Q=this.rules.inline.tag.exec(H);if(Q)return!this.lexer.state.inLink&&/^<a /i.test(Q[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Q[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Q[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Q[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Q[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):g(Q[0]):Q[0]}},W.link=function(H){var Q=this.rules.inline.link.exec(H);if(Q){var G=Q[2].trim();if(!this.options.pedantic&&/^</.test(G)){if(!/>$/.test(G))return;var Z=C(G.slice(0,-1),"\\");if((G.length-Z.length)%2===0)return}else{var ce=E(Q[2],"()");if(ce>-1){var Ee=Q[0].indexOf("!")===0?5:4,De=Ee+Q[1].length+ce;Q[2]=Q[2].substring(0,ce),Q[0]=Q[0].substring(0,De).trim(),Q[3]=""}}var ke=Q[2],Fe="";if(this.options.pedantic){var ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ke);ze&&(ke=ze[1],Fe=ze[3])}else Fe=Q[3]?Q[3].slice(1,-1):"";return ke=ke.trim(),/^</.test(ke)&&(this.options.pedantic&&!/>$/.test(G)?ke=ke.slice(1):ke=ke.slice(1,-1)),$(Q,{href:ke&&ke.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},Q[0],this.lexer)}},W.reflink=function(H,Q){var G;if((G=this.rules.inline.reflink.exec(H))||(G=this.rules.inline.nolink.exec(H))){var Z=(G[2]||G[1]).replace(/\s+/g," ");if(Z=Q[Z.toLowerCase()],!Z||!Z.href){var ce=G[0].charAt(0);return{type:"text",raw:ce,text:ce}}return $(G,Z,G[0],this.lexer)}},W.emStrong=function(H,Q,G){G===void 0&&(G="");var Z=this.rules.inline.emStrong.lDelim.exec(H);if(Z&&!(Z[3]&&G.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ce=Z[1]||Z[2]||"";if(!ce||ce&&(G===""||this.rules.inline.punctuation.exec(G))){var Ee=Z[0].length-1,De,ke,Fe=Ee,ze=0,me=Z[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,Q=Q.slice(-1*H.length+Ee);(Z=me.exec(Q))!=null;)if(De=Z[1]||Z[2]||Z[3]||Z[4]||Z[5]||Z[6],!!De){if(ke=De.length,Z[3]||Z[4]){Fe+=ke;continue}else if((Z[5]||Z[6])&&Ee%3&&!((Ee+ke)%3)){ze+=ke;continue}if(Fe-=ke,!(Fe>0)){if(ke=Math.min(ke,ke+Fe+ze),Math.min(Ee,ke)%2){var Se=H.slice(1,Ee+Z.index+ke);return{type:"em",raw:H.slice(0,Ee+Z.index+ke+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var we=H.slice(2,Ee+Z.index+ke-1);return{type:"strong",raw:H.slice(0,Ee+Z.index+ke+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},W.codespan=function(H){var Q=this.rules.inline.code.exec(H);if(Q){var G=Q[2].replace(/\n/g," "),Z=/[^ ]/.test(G),ce=/^ /.test(G)&&/ $/.test(G);return Z&&ce&&(G=G.substring(1,G.length-1)),G=g(G,!0),{type:"codespan",raw:Q[0],text:G}}},W.br=function(H){var Q=this.rules.inline.br.exec(H);if(Q)return{type:"br",raw:Q[0]}},W.del=function(H){var Q=this.rules.inline.del.exec(H);if(Q)return{type:"del",raw:Q[0],text:Q[2],tokens:this.lexer.inlineTokens(Q[2])}},W.autolink=function(H,Q){var G=this.rules.inline.autolink.exec(H);if(G){var Z,ce;return G[2]==="@"?(Z=g(this.options.mangle?Q(G[1]):G[1]),ce="mailto:"+Z):(Z=g(G[1]),ce=Z),{type:"link",raw:G[0],text:Z,href:ce,tokens:[{type:"text",raw:Z,text:Z}]}}},W.url=function(H,Q){var G;if(G=this.rules.inline.url.exec(H)){var Z,ce;if(G[2]==="@")Z=g(this.options.mangle?Q(G[0]):G[0]),ce="mailto:"+Z;else{var Ee;do Ee=G[0],G[0]=this.rules.inline._backpedal.exec(G[0])[0];while(Ee!==G[0]);Z=g(G[0]),G[1]==="www."?ce="http://"+Z:ce=Z}return{type:"link",raw:G[0],text:Z,href:ce,tokens:[{type:"text",raw:Z,text:Z}]}}},W.inlineText=function(H,Q){var G=this.rules.inline.text.exec(H);if(G){var Z;return this.lexer.state.inRawBlock?Z=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):g(G[0]):G[0]:Z=g(this.options.smartypants?Q(G[0]):G[0]),{type:"text",raw:G[0],text:Z}}},z}(),ae={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ae._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ae._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ae.def=c(ae.def).replace("label",ae._label).replace("title",ae._title).getRegex(),ae.bullet=/(?:[*+-]|\d{1,9}[.)])/,ae.listItemStart=c(/^( *)(bull) */).replace("bull",ae.bullet).getRegex(),ae.list=c(ae.list).replace(/bull/g,ae.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ae.def.source+")").getRegex(),ae._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ae._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ae.html=c(ae.html,"i").replace("comment",ae._comment).replace("tag",ae._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ae.paragraph=c(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.blockquote=c(ae.blockquote).replace("paragraph",ae.paragraph).getRegex(),ae.normal=d({},ae),ae.gfm=d({},ae.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ae.gfm.table=c(ae.gfm.table).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.gfm.paragraph=c(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ae.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.pedantic=d({},ae.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ae._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:c(ae.normal._paragraph).replace("hr",ae.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ae.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ue={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ue._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ue.punctuation=c(ue.punctuation).replace(/punctuation/g,ue._punctuation).getRegex(),ue.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ue.escapedEmSt=/\\\*|\\_/g,ue._comment=c(ae._comment).replace("(?:-->|$)","-->").getRegex(),ue.emStrong.lDelim=c(ue.emStrong.lDelim).replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimAst=c(ue.emStrong.rDelimAst,"g").replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimUnd=c(ue.emStrong.rDelimUnd,"g").replace(/punct/g,ue._punctuation).getRegex(),ue._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ue._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ue._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ue.autolink=c(ue.autolink).replace("scheme",ue._scheme).replace("email",ue._email).getRegex(),ue._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ue.tag=c(ue.tag).replace("comment",ue._comment).replace("attribute",ue._attribute).getRegex(),ue._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ue._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ue._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ue.link=c(ue.link).replace("label",ue._label).replace("href",ue._href).replace("title",ue._title).getRegex(),ue.reflink=c(ue.reflink).replace("label",ue._label).replace("ref",ae._label).getRegex(),ue.nolink=c(ue.nolink).replace("ref",ae._label).getRegex(),ue.reflinkSearch=c(ue.reflinkSearch,"g").replace("reflink",ue.reflink).replace("nolink",ue.nolink).getRegex(),ue.normal=d({},ue),ue.pedantic=d({},ue.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",ue._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ue._label).getRegex()}),ue.gfm=d({},ue.normal,{escape:c(ue.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ue.gfm.url=c(ue.gfm.url,"i").replace("email",ue.gfm._extended_email).getRegex(),ue.breaks=d({},ue.gfm,{br:c(ue.br).replace("{2,}","*").getRegex(),text:c(ue.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ge(z){return z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function _(z){var W="",q,H,Q=z.length;for(q=0;q<Q;q++)H=z.charCodeAt(q),Math.random()>.5&&(H="x"+H.toString(16)),W+="&#"+H+";";return W}var ie=function(){function z(q){this.tokens=[],this.tokens.links=Object.create(null),this.options=q||le.defaults,this.options.tokenizer=this.options.tokenizer||new he,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var H={block:ae.normal,inline:ue.normal};this.options.pedantic?(H.block=ae.pedantic,H.inline=ue.pedantic):this.options.gfm&&(H.block=ae.gfm,this.options.breaks?H.inline=ue.breaks:H.inline=ue.gfm),this.tokenizer.rules=H}z.lex=function(H,Q){var G=new z(Q);return G.lex(H)},z.lexInline=function(H,Q){var G=new z(Q);return G.inlineTokens(H)};var W=z.prototype;return W.lex=function(H){H=H.replace(/\r\n|\r/g,`
`),this.blockTokens(H,this.tokens);for(var Q;Q=this.inlineQueue.shift();)this.inlineTokens(Q.src,Q.tokens);return this.tokens},W.blockTokens=function(H,Q){var G=this;Q===void 0&&(Q=[]),this.options.pedantic?H=H.replace(/\t/g,"    ").replace(/^ +$/gm,""):H=H.replace(/^( *)(\t+)/gm,function(Fe,ze,me){return ze+"    ".repeat(me.length)});for(var Z,ce,Ee,De;H;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Fe){return(Z=Fe.call({lexer:G},H,Q))?(H=H.substring(Z.raw.length),Q.push(Z),!0):!1}))){if(Z=this.tokenizer.space(H)){H=H.substring(Z.raw.length),Z.raw.length===1&&Q.length>0?Q[Q.length-1].raw+=`
`:Q.push(Z);continue}if(Z=this.tokenizer.code(H)){H=H.substring(Z.raw.length),ce=Q[Q.length-1],ce&&(ce.type==="paragraph"||ce.type==="text")?(ce.raw+=`
`+Z.raw,ce.text+=`
`+Z.text,this.inlineQueue[this.inlineQueue.length-1].src=ce.text):Q.push(Z);continue}if(Z=this.tokenizer.fences(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.heading(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.hr(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.blockquote(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.list(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.html(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.def(H)){H=H.substring(Z.raw.length),ce=Q[Q.length-1],ce&&(ce.type==="paragraph"||ce.type==="text")?(ce.raw+=`
`+Z.raw,ce.text+=`
`+Z.raw,this.inlineQueue[this.inlineQueue.length-1].src=ce.text):this.tokens.links[Z.tag]||(this.tokens.links[Z.tag]={href:Z.href,title:Z.title});continue}if(Z=this.tokenizer.table(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.lheading(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Ee=H,this.options.extensions&&this.options.extensions.startBlock&&function(){var Fe=1/0,ze=H.slice(1),me=void 0;G.options.extensions.startBlock.forEach(function(Se){me=Se.call({lexer:this},ze),typeof me=="number"&&me>=0&&(Fe=Math.min(Fe,me))}),Fe<1/0&&Fe>=0&&(Ee=H.substring(0,Fe+1))}(),this.state.top&&(Z=this.tokenizer.paragraph(Ee))){ce=Q[Q.length-1],De&&ce.type==="paragraph"?(ce.raw+=`
`+Z.raw,ce.text+=`
`+Z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ce.text):Q.push(Z),De=Ee.length!==H.length,H=H.substring(Z.raw.length);continue}if(Z=this.tokenizer.text(H)){H=H.substring(Z.raw.length),ce=Q[Q.length-1],ce&&ce.type==="text"?(ce.raw+=`
`+Z.raw,ce.text+=`
`+Z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ce.text):Q.push(Z);continue}if(H){var ke="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return this.state.top=!0,Q},W.inline=function(H,Q){return Q===void 0&&(Q=[]),this.inlineQueue.push({src:H,tokens:Q}),Q},W.inlineTokens=function(H,Q){var G=this;Q===void 0&&(Q=[]);var Z,ce,Ee,De=H,ke,Fe,ze;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(ke=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)me.includes(ke[0].slice(ke[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,ke.index)+"["+N("a",ke[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ke=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,ke.index)+"["+N("a",ke[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ke=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,ke.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;H;)if(Fe||(ze=""),Fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(Z=we.call({lexer:G},H,Q))?(H=H.substring(Z.raw.length),Q.push(Z),!0):!1}))){if(Z=this.tokenizer.escape(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.tag(H)){H=H.substring(Z.raw.length),ce=Q[Q.length-1],ce&&Z.type==="text"&&ce.type==="text"?(ce.raw+=Z.raw,ce.text+=Z.text):Q.push(Z);continue}if(Z=this.tokenizer.link(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.reflink(H,this.tokens.links)){H=H.substring(Z.raw.length),ce=Q[Q.length-1],ce&&Z.type==="text"&&ce.type==="text"?(ce.raw+=Z.raw,ce.text+=Z.text):Q.push(Z);continue}if(Z=this.tokenizer.emStrong(H,De,ze)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.codespan(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.br(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.del(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.autolink(H,_)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(!this.state.inLink&&(Z=this.tokenizer.url(H,_))){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Ee=H,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,Ue=H.slice(1),Be=void 0;G.options.extensions.startInline.forEach(function(et){Be=et.call({lexer:this},Ue),typeof Be=="number"&&Be>=0&&(we=Math.min(we,Be))}),we<1/0&&we>=0&&(Ee=H.substring(0,we+1))}(),Z=this.tokenizer.inlineText(Ee,ge)){H=H.substring(Z.raw.length),Z.raw.slice(-1)!=="_"&&(ze=Z.raw.slice(-1)),Fe=!0,ce=Q[Q.length-1],ce&&ce.type==="text"?(ce.raw+=Z.raw,ce.text+=Z.text):Q.push(Z);continue}if(H){var Se="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return Q},S(z,null,[{key:"rules",get:function(){return{block:ae,inline:ue}}}]),z}(),V=function(){function z(q){this.options=q||le.defaults}var W=z.prototype;return W.code=function(H,Q,G){var Z=(Q||"").match(/\S*/)[0];if(this.options.highlight){var ce=this.options.highlight(H,Z);ce!=null&&ce!==H&&(G=!0,H=ce)}return H=H.replace(/\n$/,"")+`
`,Z?'<pre><code class="'+this.options.langPrefix+g(Z,!0)+'">'+(G?H:g(H,!0))+`</code></pre>
`:"<pre><code>"+(G?H:g(H,!0))+`</code></pre>
`},W.blockquote=function(H){return`<blockquote>
`+H+`</blockquote>
`},W.html=function(H){return H},W.heading=function(H,Q,G,Z){if(this.options.headerIds){var ce=this.options.headerPrefix+Z.slug(G);return"<h"+Q+' id="'+ce+'">'+H+"</h"+Q+`>
`}return"<h"+Q+">"+H+"</h"+Q+`>
`},W.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},W.list=function(H,Q,G){var Z=Q?"ol":"ul",ce=Q&&G!==1?' start="'+G+'"':"";return"<"+Z+ce+`>
`+H+"</"+Z+`>
`},W.listitem=function(H){return"<li>"+H+`</li>
`},W.checkbox=function(H){return"<input "+(H?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},W.paragraph=function(H){return"<p>"+H+`</p>
`},W.table=function(H,Q){return Q&&(Q="<tbody>"+Q+"</tbody>"),`<table>
<thead>
`+H+`</thead>
`+Q+`</table>
`},W.tablerow=function(H){return`<tr>
`+H+`</tr>
`},W.tablecell=function(H,Q){var G=Q.header?"th":"td",Z=Q.align?"<"+G+' align="'+Q.align+'">':"<"+G+">";return Z+H+("</"+G+`>
`)},W.strong=function(H){return"<strong>"+H+"</strong>"},W.em=function(H){return"<em>"+H+"</em>"},W.codespan=function(H){return"<code>"+H+"</code>"},W.br=function(){return this.options.xhtml?"<br/>":"<br>"},W.del=function(H){return"<del>"+H+"</del>"},W.link=function(H,Q,G){if(H=O(this.options.sanitize,this.options.baseUrl,H),H===null)return G;var Z='<a href="'+g(H)+'"';return Q&&(Z+=' title="'+Q+'"'),Z+=">"+G+"</a>",Z},W.image=function(H,Q,G){if(H=O(this.options.sanitize,this.options.baseUrl,H),H===null)return G;var Z='<img src="'+H+'" alt="'+G+'"';return Q&&(Z+=' title="'+Q+'"'),Z+=this.options.xhtml?"/>":">",Z},W.text=function(H){return H},z}(),J=function(){function z(){}var W=z.prototype;return W.strong=function(H){return H},W.em=function(H){return H},W.codespan=function(H){return H},W.del=function(H){return H},W.html=function(H){return H},W.text=function(H){return H},W.link=function(H,Q,G){return""+G},W.image=function(H,Q,G){return""+G},W.br=function(){return""},z}(),U=function(){function z(){this.seen={}}var W=z.prototype;return W.serialize=function(H){return H.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},W.getNextSafeSlug=function(H,Q){var G=H,Z=0;if(this.seen.hasOwnProperty(G)){Z=this.seen[H];do Z++,G=H+"-"+Z;while(this.seen.hasOwnProperty(G))}return Q||(this.seen[H]=Z,this.seen[G]=0),G},W.slug=function(H,Q){Q===void 0&&(Q={});var G=this.serialize(H);return this.getNextSafeSlug(G,Q.dryrun)},z}(),ne=function(){function z(q){this.options=q||le.defaults,this.options.renderer=this.options.renderer||new V,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new U}z.parse=function(H,Q){var G=new z(Q);return G.parse(H)},z.parseInline=function(H,Q){var G=new z(Q);return G.parseInline(H)};var W=z.prototype;return W.parse=function(H,Q){Q===void 0&&(Q=!0);var G="",Z,ce,Ee,De,ke,Fe,ze,me,Se,we,Ue,Be,et,He,Ve,Ze,it,Ke,Xe,fe=H.length;for(Z=0;Z<fe;Z++){if(we=H[Z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(Xe=this.options.extensions.renderers[we.type].call({parser:this},we),Xe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){G+=Xe||"";continue}switch(we.type){case"space":continue;case"hr":{G+=this.renderer.hr();continue}case"heading":{G+=this.renderer.heading(this.parseInline(we.tokens),we.depth,r(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{G+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for(me="",ze="",De=we.header.length,ce=0;ce<De;ce++)ze+=this.renderer.tablecell(this.parseInline(we.header[ce].tokens),{header:!0,align:we.align[ce]});for(me+=this.renderer.tablerow(ze),Se="",De=we.rows.length,ce=0;ce<De;ce++){for(Fe=we.rows[ce],ze="",ke=Fe.length,Ee=0;Ee<ke;Ee++)ze+=this.renderer.tablecell(this.parseInline(Fe[Ee].tokens),{header:!1,align:we.align[Ee]});Se+=this.renderer.tablerow(ze)}G+=this.renderer.table(me,Se);continue}case"blockquote":{Se=this.parse(we.tokens),G+=this.renderer.blockquote(Se);continue}case"list":{for(Ue=we.ordered,Be=we.start,et=we.loose,De=we.items.length,Se="",ce=0;ce<De;ce++)Ve=we.items[ce],Ze=Ve.checked,it=Ve.task,He="",Ve.task&&(Ke=this.renderer.checkbox(Ze),et?Ve.tokens.length>0&&Ve.tokens[0].type==="paragraph"?(Ve.tokens[0].text=Ke+" "+Ve.tokens[0].text,Ve.tokens[0].tokens&&Ve.tokens[0].tokens.length>0&&Ve.tokens[0].tokens[0].type==="text"&&(Ve.tokens[0].tokens[0].text=Ke+" "+Ve.tokens[0].tokens[0].text)):Ve.tokens.unshift({type:"text",text:Ke}):He+=Ke),He+=this.parse(Ve.tokens,et),Se+=this.renderer.listitem(He,it,Ze);G+=this.renderer.list(Se,Ue,Be);continue}case"html":{G+=this.renderer.html(we.text);continue}case"paragraph":{G+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(Se=we.tokens?this.parseInline(we.tokens):we.text;Z+1<fe&&H[Z+1].type==="text";)we=H[++Z],Se+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);G+=Q?this.renderer.paragraph(Se):Se;continue}default:{var Ce='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(Ce);return}else throw new Error(Ce)}}}return G},W.parseInline=function(H,Q){Q=Q||this.renderer;var G="",Z,ce,Ee,De=H.length;for(Z=0;Z<De;Z++){if(ce=H[Z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(Ee=this.options.extensions.renderers[ce.type].call({parser:this},ce),Ee!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ce.type))){G+=Ee||"";continue}switch(ce.type){case"escape":{G+=Q.text(ce.text);break}case"html":{G+=Q.html(ce.text);break}case"link":{G+=Q.link(ce.href,ce.title,this.parseInline(ce.tokens,Q));break}case"image":{G+=Q.image(ce.href,ce.title,ce.text);break}case"strong":{G+=Q.strong(this.parseInline(ce.tokens,Q));break}case"em":{G+=Q.em(this.parseInline(ce.tokens,Q));break}case"codespan":{G+=Q.codespan(ce.text);break}case"br":{G+=Q.br();break}case"del":{G+=Q.del(this.parseInline(ce.tokens,Q));break}case"text":{G+=Q.text(ce.text);break}default:{var ke='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}}return G},z}();function x(z,W,q){if(typeof z>"u"||z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");if(typeof W=="function"&&(q=W,W=null),W=d({},x.defaults,W||{}),w(W),q){var H=W.highlight,Q;try{Q=ie.lex(z,W)}catch(De){return q(De)}var G=function(ke){var Fe;if(!ke)try{W.walkTokens&&x.walkTokens(Q,W.walkTokens),Fe=ne.parse(Q,W)}catch(ze){ke=ze}return W.highlight=H,ke?q(ke):q(null,Fe)};if(!H||H.length<3||(delete W.highlight,!Q.length))return G();var Z=0;x.walkTokens(Q,function(De){De.type==="code"&&(Z++,setTimeout(function(){H(De.text,De.lang,function(ke,Fe){if(ke)return G(ke);Fe!=null&&Fe!==De.text&&(De.text=Fe,De.escaped=!0),Z--,Z===0&&G()})},0))}),Z===0&&G();return}function ce(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,W.silent)return"<p>An error occurred:</p><pre>"+g(De.message+"",!0)+"</pre>";throw De}try{var Ee=ie.lex(z,W);if(W.walkTokens){if(W.async)return Promise.all(x.walkTokens(Ee,W.walkTokens)).then(function(){return ne.parse(Ee,W)}).catch(ce);x.walkTokens(Ee,W.walkTokens)}return ne.parse(Ee,W)}catch(De){ce(De)}}x.options=x.setOptions=function(z){return d(x.defaults,z),R(x.defaults),x},x.getDefaults=k,x.defaults=le.defaults,x.use=function(){for(var z=arguments.length,W=new Array(z),q=0;q<z;q++)W[q]=arguments[q];var H=d.apply(void 0,[{}].concat(W)),Q=x.defaults.extensions||{renderers:{},childTokens:{}},G;W.forEach(function(Z){if(Z.extensions&&(G=!0,Z.extensions.forEach(function(Ee){if(!Ee.name)throw new Error("extension name required");if(Ee.renderer){var De=Q.renderers?Q.renderers[Ee.name]:null;De?Q.renderers[Ee.name]=function(){for(var ke=arguments.length,Fe=new Array(ke),ze=0;ze<ke;ze++)Fe[ze]=arguments[ze];var me=Ee.renderer.apply(this,Fe);return me===!1&&(me=De.apply(this,Fe)),me}:Q.renderers[Ee.name]=Ee.renderer}if(Ee.tokenizer){if(!Ee.level||Ee.level!=="block"&&Ee.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Q[Ee.level]?Q[Ee.level].unshift(Ee.tokenizer):Q[Ee.level]=[Ee.tokenizer],Ee.start&&(Ee.level==="block"?Q.startBlock?Q.startBlock.push(Ee.start):Q.startBlock=[Ee.start]:Ee.level==="inline"&&(Q.startInline?Q.startInline.push(Ee.start):Q.startInline=[Ee.start]))}Ee.childTokens&&(Q.childTokens[Ee.name]=Ee.childTokens)})),Z.renderer&&function(){var Ee=x.defaults.renderer||new V,De=function(ze){var me=Ee[ze];Ee[ze]=function(){for(var Se=arguments.length,we=new Array(Se),Ue=0;Ue<Se;Ue++)we[Ue]=arguments[Ue];var Be=Z.renderer[ze].apply(Ee,we);return Be===!1&&(Be=me.apply(Ee,we)),Be}};for(var ke in Z.renderer)De(ke);H.renderer=Ee}(),Z.tokenizer&&function(){var Ee=x.defaults.tokenizer||new he,De=function(ze){var me=Ee[ze];Ee[ze]=function(){for(var Se=arguments.length,we=new Array(Se),Ue=0;Ue<Se;Ue++)we[Ue]=arguments[Ue];var Be=Z.tokenizer[ze].apply(Ee,we);return Be===!1&&(Be=me.apply(Ee,we)),Be}};for(var ke in Z.tokenizer)De(ke);H.tokenizer=Ee}(),Z.walkTokens){var ce=x.defaults.walkTokens;H.walkTokens=function(Ee){var De=[];return De.push(Z.walkTokens.call(this,Ee)),ce&&(De=De.concat(ce.call(this,Ee))),De}}G&&(H.extensions=Q),x.setOptions(H)})},x.walkTokens=function(z,W){for(var q=[],H=function(){var ce=G.value;switch(q=q.concat(W.call(x,ce)),ce.type){case"table":{for(var Ee=A(ce.header),De;!(De=Ee()).done;){var ke=De.value;q=q.concat(x.walkTokens(ke.tokens,W))}for(var Fe=A(ce.rows),ze;!(ze=Fe()).done;)for(var me=ze.value,Se=A(me),we;!(we=Se()).done;){var Ue=we.value;q=q.concat(x.walkTokens(Ue.tokens,W))}break}case"list":{q=q.concat(x.walkTokens(ce.items,W));break}default:x.defaults.extensions&&x.defaults.extensions.childTokens&&x.defaults.extensions.childTokens[ce.type]?x.defaults.extensions.childTokens[ce.type].forEach(function(Be){q=q.concat(x.walkTokens(ce[Be],W))}):ce.tokens&&(q=q.concat(x.walkTokens(ce.tokens,W)))}},Q=A(z),G;!(G=Q()).done;)H();return q},x.parseInline=function(z,W){if(typeof z>"u"||z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");W=d({},x.defaults,W||{}),w(W);try{var q=ie.lexInline(z,W);return W.walkTokens&&x.walkTokens(q,W.walkTokens),ne.parseInline(q,W)}catch(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,W.silent)return"<p>An error occurred:</p><pre>"+g(H.message+"",!0)+"</pre>";throw H}},x.Parser=ne,x.parser=ne.parse,x.Renderer=V,x.TextRenderer=J,x.Lexer=ie,x.lexer=ie.lex,x.Tokenizer=he,x.Slugger=U,x.parse=x;var re=x.options,Y=x.setOptions,ee=x.use,j=x.walkTokens,P=x.parseInline,M=x,K=ne.parse,te=ie.lex;le.Lexer=ie,le.Parser=ne,le.Renderer=V,le.Slugger=U,le.TextRenderer=J,le.Tokenizer=he,le.getDefaults=k,le.lexer=te,le.marked=x,le.options=re,le.parse=M,le.parseInline=P,le.parser=K,le.setOptions=Y,le.use=ee,le.walkTokens=j,Object.defineProperty(le,"__esModule",{value:!0})}),define(pe[95],be([1,0,27]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new S.LRUCache(1e4);function o(m){return b(m,"NFC",L)}e.normalizeNFC=o;const A=new S.LRUCache(1e4);function k(m){return b(m,"NFD",A)}e.normalizeNFD=k;const R=/[^\u0000-\u0080]/;function b(m,T,y){if(!m)return m;const v=y.get(m);if(v)return v;let h;return R.test(m)?h=m.normalize(T):h=m,y.set(m,h),h}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(T){return k(T).replace(m,"")}}()}),define(pe[142],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function S(R,b,m){return Math.min(Math.max(R,b),m)}e.clamp=S;function L(R,b){return(b+R%b)%b}e.rot=L;class o{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=o;class A{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class k{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const m=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=k}),function(){function le(o){const A=[];typeof o=="number"&&A.push("code/timeOrigin",o);function k(b){A.push(b,Date.now())}function R(){const b=[];for(let m=0;m<A.length;m+=2)b.push({name:A[m],startTime:A[m+1]});return b}return{mark:k,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(o){performance.mark(o)},getMarks(){let o=performance.timeOrigin;typeof o!="number"&&(o=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(o)}];for(const k of performance.getEntriesByType("mark"))A.push({name:k.name,startTime:Math.round(o+k.startTime)});return A}};if(typeof process=="object"){const o=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(o)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function S(o){return o.MonacoPerformanceMarks||(o.MonacoPerformanceMarks=e()),o.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=S(L))}(),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var L in S)(typeof exports=="object"?exports:le)[L]=S[L]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function S(L){if(e[L])return e[L].exports;var o=e[L]={i:L,l:!1,exports:{}};return le[L].call(o.exports,o,o.exports,S),o.l=!0,o.exports}return S.m=le,S.c=e,S.d=function(L,o,A){S.o(L,o)||Object.defineProperty(L,o,{enumerable:!0,get:A})},S.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},S.t=function(L,o){if(1&o&&(L=S(L)),8&o||4&o&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(S.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&o&&typeof L!="string")for(var k in L)S.d(A,k,function(R){return L[R]}.bind(null,k));return A},S.n=function(L){var o=L&&L.__esModule?function(){return L.default}:function(){return L};return S.d(o,"a",o),o},S.o=function(L,o){return Object.prototype.hasOwnProperty.call(L,o)},S.p="",S(S.s=0)}([function(le,e,S){(function(L){var o;e=le.exports=ee,o=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],b=e.src=[],m=0,T=m++;b[T]="0|[1-9]\\d*";var y=m++;b[y]="[0-9]+";var v=m++;b[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=m++;b[h]="("+b[T]+")\\.("+b[T]+")\\.("+b[T]+")";var g=m++;b[g]="("+b[y]+")\\.("+b[y]+")\\.("+b[y]+")";var p=m++;b[p]="(?:"+b[T]+"|"+b[v]+")";var r=m++;b[r]="(?:"+b[y]+"|"+b[v]+")";var f=m++;b[f]="(?:-("+b[p]+"(?:\\."+b[p]+")*))";var c=m++;b[c]="(?:-?("+b[r]+"(?:\\."+b[r]+")*))";var u=m++;b[u]="[0-9A-Za-z-]+";var D=m++;b[D]="(?:\\+("+b[u]+"(?:\\."+b[u]+")*))";var O=m++,t="v?"+b[h]+b[f]+"?"+b[D]+"?";b[O]="^"+t+"$";var n="[v=\\s]*"+b[g]+b[c]+"?"+b[D]+"?",s=m++;b[s]="^"+n+"$";var i=m++;b[i]="((?:<|>)?=?)";var a=m++;b[a]=b[y]+"|x|X|\\*";var l=m++;b[l]=b[T]+"|x|X|\\*";var d=m++;b[d]="[v=\\s]*("+b[l]+")(?:\\.("+b[l]+")(?:\\.("+b[l]+")(?:"+b[f]+")?"+b[D]+"?)?)?";var I=m++;b[I]="[v=\\s]*("+b[a]+")(?:\\.("+b[a]+")(?:\\.("+b[a]+")(?:"+b[c]+")?"+b[D]+"?)?)?";var C=m++;b[C]="^"+b[i]+"\\s*"+b[d]+"$";var E=m++;b[E]="^"+b[i]+"\\s*"+b[I]+"$";var w=m++;b[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=m++;b[N]="(?:~>?)";var $=m++;b[$]="(\\s*)"+b[N]+"\\s+",R[$]=new RegExp(b[$],"g");var se=m++;b[se]="^"+b[N]+b[d]+"$";var he=m++;b[he]="^"+b[N]+b[I]+"$";var ae=m++;b[ae]="(?:\\^)";var ue=m++;b[ue]="(\\s*)"+b[ae]+"\\s+",R[ue]=new RegExp(b[ue],"g");var ge=m++;b[ge]="^"+b[ae]+b[d]+"$";var _=m++;b[_]="^"+b[ae]+b[I]+"$";var ie=m++;b[ie]="^"+b[i]+"\\s*("+n+")$|^$";var V=m++;b[V]="^"+b[i]+"\\s*("+t+")$|^$";var J=m++;b[J]="(\\s*)"+b[i]+"\\s*("+n+"|"+b[d]+")",R[J]=new RegExp(b[J],"g");var U=m++;b[U]="^\\s*("+b[d]+")\\s+-\\s+("+b[d]+")\\s*$";var ne=m++;b[ne]="^\\s*("+b[I]+")\\s+-\\s+("+b[I]+")\\s*$";var x=m++;b[x]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)o(re,b[re]),R[re]||(R[re]=new RegExp(b[re]));function Y(me,Se){if(me instanceof ee)return me;if(typeof me!="string"||me.length>A||!(Se?R[s]:R[O]).test(me))return null;try{return new ee(me,Se)}catch{return null}}function ee(me,Se){if(me instanceof ee){if(me.loose===Se)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof ee))return new ee(me,Se);o("SemVer",me,Se),this.loose=Se;var we=me.trim().match(Se?R[s]:R[O]);if(!we)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+we[1],this.minor=+we[2],this.patch=+we[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");we[4]?this.prerelease=we[4].split(".").map(function(Ue){if(/^[0-9]+$/.test(Ue)){var Be=+Ue;if(Be>=0&&Be<k)return Be}return Ue}):this.prerelease=[],this.build=we[5]?we[5].split("."):[],this.format()}e.parse=Y,e.valid=function(me,Se){var we=Y(me,Se);return we?we.version:null},e.clean=function(me,Se){var we=Y(me.trim().replace(/^[=v]+/,""),Se);return we?we.version:null},e.SemVer=ee,ee.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ee.prototype.toString=function(){return this.version},ee.prototype.compare=function(me){return o("SemVer.compare",this.version,this.loose,me),me instanceof ee||(me=new ee(me,this.loose)),this.compareMain(me)||this.comparePre(me)},ee.prototype.compareMain=function(me){return me instanceof ee||(me=new ee(me,this.loose)),P(this.major,me.major)||P(this.minor,me.minor)||P(this.patch,me.patch)},ee.prototype.comparePre=function(me){if(me instanceof ee||(me=new ee(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var Se=0;do{var we=this.prerelease[Se],Ue=me.prerelease[Se];if(o("prerelease compare",Se,we,Ue),we===void 0&&Ue===void 0)return 0;if(Ue===void 0)return 1;if(we===void 0)return-1;if(we!==Ue)return P(we,Ue)}while(++Se)},ee.prototype.inc=function(me,Se){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var we=this.prerelease.length;--we>=0;)typeof this.prerelease[we]=="number"&&(this.prerelease[we]++,we=-2);we===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,Se,we,Ue){typeof we=="string"&&(Ue=we,we=void 0);try{return new ee(me,we).inc(Se,Ue).version}catch{return null}},e.diff=function(me,Se){if(z(me,Se))return null;var we=Y(me),Ue=Y(Se);if(we.prerelease.length||Ue.prerelease.length){for(var Be in we)if((Be==="major"||Be==="minor"||Be==="patch")&&we[Be]!==Ue[Be])return"pre"+Be;return"prerelease"}for(var Be in we)if((Be==="major"||Be==="minor"||Be==="patch")&&we[Be]!==Ue[Be])return Be},e.compareIdentifiers=P;var j=/^[0-9]+$/;function P(me,Se){var we=j.test(me),Ue=j.test(Se);return we&&Ue&&(me=+me,Se=+Se),we&&!Ue?-1:Ue&&!we?1:me<Se?-1:me>Se?1:0}function M(me,Se,we){return new ee(me,we).compare(new ee(Se,we))}function K(me,Se,we){return M(me,Se,we)>0}function te(me,Se,we){return M(me,Se,we)<0}function z(me,Se,we){return M(me,Se,we)===0}function W(me,Se,we){return M(me,Se,we)!==0}function q(me,Se,we){return M(me,Se,we)>=0}function H(me,Se,we){return M(me,Se,we)<=0}function Q(me,Se,we,Ue){var Be;switch(Se){case"===":typeof me=="object"&&(me=me.version),typeof we=="object"&&(we=we.version),Be=me===we;break;case"!==":typeof me=="object"&&(me=me.version),typeof we=="object"&&(we=we.version),Be=me!==we;break;case"":case"=":case"==":Be=z(me,we,Ue);break;case"!=":Be=W(me,we,Ue);break;case">":Be=K(me,we,Ue);break;case">=":Be=q(me,we,Ue);break;case"<":Be=te(me,we,Ue);break;case"<=":Be=H(me,we,Ue);break;default:throw new TypeError("Invalid operator: "+Se)}return Be}function G(me,Se){if(me instanceof G){if(me.loose===Se)return me;me=me.value}if(!(this instanceof G))return new G(me,Se);o("comparator",me,Se),this.loose=Se,this.parse(me),this.semver===Z?this.value="":this.value=this.operator+this.semver.version,o("comp",this)}e.rcompareIdentifiers=function(me,Se){return P(Se,me)},e.major=function(me,Se){return new ee(me,Se).major},e.minor=function(me,Se){return new ee(me,Se).minor},e.patch=function(me,Se){return new ee(me,Se).patch},e.compare=M,e.compareLoose=function(me,Se){return M(me,Se,!0)},e.rcompare=function(me,Se,we){return M(Se,me,we)},e.sort=function(me,Se){return me.sort(function(we,Ue){return e.compare(we,Ue,Se)})},e.rsort=function(me,Se){return me.sort(function(we,Ue){return e.rcompare(we,Ue,Se)})},e.gt=K,e.lt=te,e.eq=z,e.neq=W,e.gte=q,e.lte=H,e.cmp=Q,e.Comparator=G;var Z={};function ce(me,Se){if(me instanceof ce)return me.loose===Se?me:new ce(me.raw,Se);if(me instanceof G)return new ce(me.value,Se);if(!(this instanceof ce))return new ce(me,Se);if(this.loose=Se,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(we){return this.parseRange(we.trim())},this).filter(function(we){return we.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function Ee(me){return!me||me.toLowerCase()==="x"||me==="*"}function De(me,Se,we,Ue,Be,et,He,Ve,Ze,it,Ke,Xe,fe){return((Se=Ee(we)?"":Ee(Ue)?">="+we+".0.0":Ee(Be)?">="+we+"."+Ue+".0":">="+Se)+" "+(Ve=Ee(Ze)?"":Ee(it)?"<"+(+Ze+1)+".0.0":Ee(Ke)?"<"+Ze+"."+(+it+1)+".0":Xe?"<="+Ze+"."+it+"."+Ke+"-"+Xe:"<="+Ve)).trim()}function ke(me,Se){for(var we=0;we<me.length;we++)if(!me[we].test(Se))return!1;if(Se.prerelease.length){for(we=0;we<me.length;we++)if(o(me[we].semver),me[we].semver!==Z&&me[we].semver.prerelease.length>0){var Ue=me[we].semver;if(Ue.major===Se.major&&Ue.minor===Se.minor&&Ue.patch===Se.patch)return!0}return!1}return!0}function Fe(me,Se,we){try{Se=new ce(Se,we)}catch{return!1}return Se.test(me)}function ze(me,Se,we,Ue){var Be,et,He,Ve,Ze;switch(me=new ee(me,Ue),Se=new ce(Se,Ue),we){case">":Be=K,et=H,He=te,Ve=">",Ze=">=";break;case"<":Be=te,et=q,He=K,Ve="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(me,Se,Ue))return!1;for(var it=0;it<Se.set.length;++it){var Ke=Se.set[it],Xe=null,fe=null;if(Ke.forEach(function(Ce){Ce.semver===Z&&(Ce=new G(">=0.0.0")),Xe=Xe||Ce,fe=fe||Ce,Be(Ce.semver,Xe.semver,Ue)?Xe=Ce:He(Ce.semver,fe.semver,Ue)&&(fe=Ce)}),Xe.operator===Ve||Xe.operator===Ze||(!fe.operator||fe.operator===Ve)&&et(me,fe.semver)||fe.operator===Ze&&He(me,fe.semver))return!1}return!0}G.prototype.parse=function(me){var Se=this.loose?R[ie]:R[V],we=me.match(Se);if(!we)throw new TypeError("Invalid comparator: "+me);this.operator=we[1],this.operator==="="&&(this.operator=""),we[2]?this.semver=new ee(we[2],this.loose):this.semver=Z},G.prototype.toString=function(){return this.value},G.prototype.test=function(me){return o("Comparator.test",me,this.loose),this.semver===Z||(typeof me=="string"&&(me=new ee(me,this.loose)),Q(me,this.operator,this.semver,this.loose))},G.prototype.intersects=function(me,Se){if(!(me instanceof G))throw new TypeError("a Comparator is required");var we;if(this.operator==="")return we=new ce(me.value,Se),Fe(this.value,we,Se);if(me.operator==="")return we=new ce(this.value,Se),Fe(me.semver,we,Se);var Ue=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),et=this.semver.version===me.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),Ve=Q(this.semver,"<",me.semver,Se)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),Ze=Q(this.semver,">",me.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return Ue||Be||et&&He||Ve||Ze},e.Range=ce,ce.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},ce.prototype.toString=function(){return this.range},ce.prototype.parseRange=function(me){var Se=this.loose;me=me.trim(),o("range",me,Se);var we=Se?R[ne]:R[U];me=me.replace(we,De),o("hyphen replace",me),me=me.replace(R[J],"$1$2$3"),o("comparator trim",me,R[J]),me=(me=(me=me.replace(R[$],"$1~")).replace(R[ue],"$1^")).split(/\s+/).join(" ");var Ue=Se?R[ie]:R[V],Be=me.split(" ").map(function(et){return function(He,Ve){return o("comp",He),He=function(Ze,it){return Ze.trim().split(/\s+/).map(function(Ke){return function(Xe,fe){o("caret",Xe,fe);var Ce=fe?R[_]:R[ge];return Xe.replace(Ce,function(Te,Re,Oe,$e,Ge){var qe;return o("caret",Xe,Te,Re,Oe,$e,Ge),Ee(Re)?qe="":Ee(Oe)?qe=">="+Re+".0.0 <"+(+Re+1)+".0.0":Ee($e)?qe=Re==="0"?">="+Re+"."+Oe+".0 <"+Re+"."+(+Oe+1)+".0":">="+Re+"."+Oe+".0 <"+(+Re+1)+".0.0":Ge?(o("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),qe=Re==="0"?Oe==="0"?">="+Re+"."+Oe+"."+$e+Ge+" <"+Re+"."+Oe+"."+(+$e+1):">="+Re+"."+Oe+"."+$e+Ge+" <"+Re+"."+(+Oe+1)+".0":">="+Re+"."+Oe+"."+$e+Ge+" <"+(+Re+1)+".0.0"):(o("no pr"),qe=Re==="0"?Oe==="0"?">="+Re+"."+Oe+"."+$e+" <"+Re+"."+Oe+"."+(+$e+1):">="+Re+"."+Oe+"."+$e+" <"+Re+"."+(+Oe+1)+".0":">="+Re+"."+Oe+"."+$e+" <"+(+Re+1)+".0.0"),o("caret return",qe),qe})}(Ke,it)}).join(" ")}(He,Ve),o("caret",He),He=function(Ze,it){return Ze.trim().split(/\s+/).map(function(Ke){return function(Xe,fe){var Ce=fe?R[he]:R[se];return Xe.replace(Ce,function(Te,Re,Oe,$e,Ge){var qe;return o("tilde",Xe,Te,Re,Oe,$e,Ge),Ee(Re)?qe="":Ee(Oe)?qe=">="+Re+".0.0 <"+(+Re+1)+".0.0":Ee($e)?qe=">="+Re+"."+Oe+".0 <"+Re+"."+(+Oe+1)+".0":Ge?(o("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),qe=">="+Re+"."+Oe+"."+$e+Ge+" <"+Re+"."+(+Oe+1)+".0"):qe=">="+Re+"."+Oe+"."+$e+" <"+Re+"."+(+Oe+1)+".0",o("tilde return",qe),qe})}(Ke,it)}).join(" ")}(He,Ve),o("tildes",He),He=function(Ze,it){return o("replaceXRanges",Ze,it),Ze.split(/\s+/).map(function(Ke){return function(Xe,fe){Xe=Xe.trim();var Ce=fe?R[E]:R[C];return Xe.replace(Ce,function(Te,Re,Oe,$e,Ge,qe){o("xRange",Xe,Te,Re,Oe,$e,Ge,qe);var tt=Ee(Oe),Je=tt||Ee($e),Ye=Je||Ee(Ge);return Re==="="&&Ye&&(Re=""),tt?Te=Re===">"||Re==="<"?"<0.0.0":"*":Re&&Ye?(Je&&($e=0),Ye&&(Ge=0),Re===">"?(Re=">=",Je?(Oe=+Oe+1,$e=0,Ge=0):Ye&&($e=+$e+1,Ge=0)):Re==="<="&&(Re="<",Je?Oe=+Oe+1:$e=+$e+1),Te=Re+Oe+"."+$e+"."+Ge):Je?Te=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":Ye&&(Te=">="+Oe+"."+$e+".0 <"+Oe+"."+(+$e+1)+".0"),o("xRange return",Te),Te})}(Ke,it)}).join(" ")}(He,Ve),o("xrange",He),He=function(Ze,it){return o("replaceStars",Ze,it),Ze.trim().replace(R[x],"")}(He,Ve),o("stars",He),He}(et,Se)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(et){return!!et.match(Ue)})),Be=Be.map(function(et){return new G(et,Se)})},ce.prototype.intersects=function(me,Se){if(!(me instanceof ce))throw new TypeError("a Range is required");return this.set.some(function(we){return we.every(function(Ue){return me.set.some(function(Be){return Be.every(function(et){return Ue.intersects(et,Se)})})})})},e.toComparators=function(me,Se){return new ce(me,Se).set.map(function(we){return we.map(function(Ue){return Ue.value}).join(" ").trim().split(" ")})},ce.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new ee(me,this.loose));for(var Se=0;Se<this.set.length;Se++)if(ke(this.set[Se],me))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(me,Se,we){var Ue=null,Be=null;try{var et=new ce(Se,we)}catch{return null}return me.forEach(function(He){et.test(He)&&(Ue&&Be.compare(He)!==-1||(Be=new ee(Ue=He,we)))}),Ue},e.minSatisfying=function(me,Se,we){var Ue=null,Be=null;try{var et=new ce(Se,we)}catch{return null}return me.forEach(function(He){et.test(He)&&(Ue&&Be.compare(He)!==1||(Be=new ee(Ue=He,we)))}),Ue},e.validRange=function(me,Se){try{return new ce(me,Se).range||"*"}catch{return null}},e.ltr=function(me,Se,we){return ze(me,Se,"<",we)},e.gtr=function(me,Se,we){return ze(me,Se,">",we)},e.outside=ze,e.prerelease=function(me,Se){var we=Y(me,Se);return we&&we.prerelease.length?we.prerelease:null},e.intersects=function(me,Se,we){return me=new ce(me,we),Se=new ce(Se,we),me.intersects(Se)},e.coerce=function(me){if(me instanceof ee)return me;if(typeof me!="string")return null;var Se=me.match(R[w]);return Se==null?null:Y((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,S(1))},function(le,e){var S,L,o=le.exports={};function A(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function R(r){if(S===setTimeout)return setTimeout(r,0);if((S===A||!S)&&setTimeout)return S=setTimeout,setTimeout(r,0);try{return S(r,0)}catch{try{return S.call(null,r,0)}catch{return S.call(this,r,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:A}catch{S=A}try{L=typeof clearTimeout=="function"?clearTimeout:k}catch{L=k}})();var b,m=[],T=!1,y=-1;function v(){T&&b&&(T=!1,b.length?m=b.concat(m):y=-1,m.length&&h())}function h(){if(!T){var r=R(v);T=!0;for(var f=m.length;f;){for(b=m,m=[];++y<f;)b&&b[y].run();y=-1,f=m.length}b=null,T=!1,function(c){if(L===clearTimeout)return clearTimeout(c);if((L===k||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(c);try{L(c)}catch{try{return L.call(null,c)}catch{return L.call(this,c)}}}(r)}}function g(r,f){this.fun=r,this.array=f}function p(){}o.nextTick=function(r){var f=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)f[c-1]=arguments[c];m.push(new g(r,f)),m.length!==1||T||R(h)},g.prototype.run=function(){this.fun.apply(null,this.array)},o.title="browser",o.browser=!0,o.env={},o.argv=[],o.version="",o.versions={},o.on=p,o.addListener=p,o.once=p,o.off=p,o.removeListener=p,o.removeAllListeners=p,o.emit=p,o.prependListener=p,o.prependOnceListener=p,o.listeners=function(r){return[]},o.binding=function(r){throw new Error("process.binding is not supported")},o.cwd=function(){return"/"},o.chdir=function(r){throw new Error("process.chdir is not supported")},o.umask=function(){return 0}}])}),define(pe[143],be([1,0]),function(le,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(R,b,m){this.level=R,this.key=b,this.value=m,this.forward=[]}}const o=void 0;class A{constructor(R,b=2**16){this.comparator=R,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(b)|0),this.e=new L(this.c,o,o)}get size(){return this.f}clear(){this.e=new L(this.c,o,o)}has(R){return!!A.g(this,R,this.comparator)}get(R){return A.g(this,R,this.comparator)?.value}set(R,b){return A.h(this,R,b,this.comparator)&&(this.f+=1),this}delete(R){const b=A.k(this,R,this.comparator);return b&&(this.f-=1),b}forEach(R,b){let m=this.e.forward[0];for(;m;)R.call(b,m.value,m.key,this),m=m.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",b=this.e.forward[0];for(;b;)R+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return R}static g(R,b,m){let T=R.e;for(let y=R.d-1;y>=0;y--)for(;T.forward[y]&&m(T.forward[y].key,b)<0;)T=T.forward[y];if(T=T.forward[0],T&&m(T.key,b)===0)return T}static h(R,b,m,T){const y=[];let v=R.e;for(let h=R.d-1;h>=0;h--){for(;v.forward[h]&&T(v.forward[h].key,b)<0;)v=v.forward[h];y[h]=v}if(v=v.forward[0],v&&T(v.key,b)===0)return v.value=m,!1;{const h=A.j(R);if(h>R.d){for(let g=R.d;g<h;g++)y[g]=R.e;R.d=h}v=new L(h,b,m);for(let g=0;g<h;g++)v.forward[g]=y[g].forward[g],y[g].forward[g]=v;return!0}}static j(R,b=.5){let m=1;for(;Math.random()<b&&m<R.c;)m+=1;return m}static k(R,b,m){const T=[];let y=R.e;for(let v=R.d-1;v>=0;v--){for(;y.forward[v]&&m(y.forward[v].key,b)<0;)y=y.forward[v];T[v]=y}if(y=y.forward[0],!y||m(y.key,b)!==0)return!1;for(let v=0;v<R.d&&T[v].forward[v]===y;v++)T[v].forward[v]=y.forward[v];for(;R.d>0&&R.e.forward[R.d-1]===o;)R.d-=1;return!0}}e.SkipList=A}),define(pe[47],be([1,0,11,2]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function o(D){const O=D;return O?typeof O.read=="function":!1}e.isReadable=o;function A(D){const O=D;return O?[O.on,O.pause,O.resume,O.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function k(D){const O=D;return O?A(O.stream)&&Array.isArray(O.buffer)&&typeof O.ended=="boolean":!1}e.isReadableBufferedStream=k;function R(D,O){return new b(D,O)}e.newWriteableStream=R;class b{constructor(O,t){this.e=O,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(O){if(!this.a.destroyed){if(this.a.flowing)this.g(O);else if(this.b.data.push(O),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(O){this.a.destroyed||(this.a.flowing?this.h(O):this.b.error.push(O))}end(O){this.a.destroyed||(typeof O<"u"&&this.write(O),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(O){this.c.data.slice(0).forEach(t=>t(O))}h(O){this.c.error.length===0?(0,S.onUnexpectedError)(O):this.c.error.slice(0).forEach(t=>t(O))}i(){this.c.end.slice(0).forEach(O=>O())}on(O,t){if(!this.a.destroyed)switch(O){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(O,t){if(this.a.destroyed)return;let n;switch(O){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const s=n.indexOf(t);s>=0&&n.splice(s,1)}}j(){if(this.b.data.length>0){const O=this.e(this.b.data);this.g(O),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const O of this.b.error)this.h(O);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(D,O){const t=[];let n;for(;(n=D.read())!==null;)t.push(n);return O(t)}e.consumeReadable=m;function T(D,O,t){const n=[];let s;for(;(s=D.read())!==null&&n.length<t;)n.push(s);return s===null&&n.length>0?O(n):{read:()=>{if(n.length>0)return n.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return D.read()}}}e.peekReadable=T;function y(D,O){return new Promise((t,n)=>{const s=[];v(D,{onData:i=>{O&&s.push(i)},onError:i=>{O?n(i):t(void 0)},onEnd:()=>{t(O?O(s):void 0)}})})}e.consumeStream=y;function v(D,O){let t=!1;return D.on("error",n=>{t||O.onError(n)}),D.on("end",()=>{t||O.onEnd()}),D.on("data",n=>{t||O.onData(n)}),(0,L.toDisposable)(()=>t=!0)}e.listenStream=v;function h(D,O){return new Promise((t,n)=>{const s=new L.DisposableStore,i=[],a=I=>{if(i.push(I),i.length>O)return s.dispose(),D.pause(),t({stream:D,buffer:i,ended:!1})},l=I=>n(I),d=()=>t({stream:D,buffer:i,ended:!0});s.add((0,L.toDisposable)(()=>D.removeListener("error",l))),D.on("error",l),s.add((0,L.toDisposable)(()=>D.removeListener("end",d))),D.on("end",d),s.add((0,L.toDisposable)(()=>D.removeListener("data",a))),D.on("data",a)})}e.peekStream=h;function g(D,O){const t=R(O);return t.end(D),t}e.toStream=g;function p(){const D=R(()=>{throw new Error("not supported")});return D.end(),D}e.emptyStream=p;function r(D){let O=!1;return{read:()=>O?null:(O=!0,D)}}e.toReadable=r;function f(D,O,t){const n=R(t);return v(D,{onData:s=>n.write(O.data(s)),onError:s=>n.error(O.error?O.error(s):s),onEnd:()=>n.end()}),n}e.transform=f;function c(D,O,t){let n=!1;return{read:()=>{const s=O.read();return n?s:(n=!0,s!==null?t([D,s]):D)}}}e.prefixedReadable=c;function u(D,O,t){let n=!1;const s=R(t);return v(O,{onData:i=>n?s.write(i):(n=!0,s.write(t([D,i]))),onError:i=>s.error(i),onEnd:()=>{n||(n=!0,s.write(D)),s.end()}}),s}e.prefixedStream=u}),define(pe[15],be([1,0,93,47]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const o=typeof Buffer<"u",A=new S.Lazy(()=>new Uint8Array(256));let k,R;class b{static alloc(E){return o?new b(Buffer.allocUnsafe(E)):new b(new Uint8Array(E))}static wrap(E){return o&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new b(E)}static fromString(E,w){return!(w?.dontUseNodeBuffer||!1)&&o?new b(Buffer.from(E)):(k||(k=new TextEncoder),new b(k.encode(E)))}static fromByteArray(E){const w=b.alloc(E.length);for(let N=0,$=E.length;N<$;N++)w.buffer[N]=E[N];return w}static concat(E,w){if(typeof w>"u"){w=0;for(let se=0,he=E.length;se<he;se++)w+=E[se].byteLength}const N=b.alloc(w);let $=0;for(let se=0,he=E.length;se<he;se++){const ae=E[se];N.set(ae,$),$+=ae.byteLength}return N}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=b.alloc(this.byteLength);return E.set(this),E}toString(){return o?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(E,w){return new b(this.buffer.subarray(E,w))}set(E,w){if(E instanceof b)this.buffer.set(E.buffer,w);else if(E instanceof Uint8Array)this.buffer.set(E,w);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),w);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return y(this.buffer,E)}writeUInt32BE(E,w){v(this.buffer,E,w)}readUInt32LE(E){return h(this.buffer,E)}writeUInt32LE(E,w){g(this.buffer,E,w)}readUInt8(E){return p(this.buffer,E)}writeUInt8(E,w){r(this.buffer,E,w)}indexOf(E){const w=E instanceof b?E.buffer:E,N=w.byteLength,$=this.buffer,se=$.byteLength;if(N===0)return 0;if(N===1)return $.indexOf(w[0]);if(N>se)return-1;const he=A.value;he.fill(w.length);for(let _=0;_<w.length;_++)he[w[_]]=w.length-_-1;let ae=w.length-1,ue=ae,ge=-1;for(;ae<se;)if($[ae]===w[ue]){if(ue===0){ge=ae;break}ae--,ue--}else ae+=Math.max(w.length-ue,he[$[ae]]),ue=w.length-1;return ge}}e.VSBuffer=b;function m(C,E){return C[E+0]<<0>>>0|C[E+1]<<8>>>0}e.readUInt16LE=m;function T(C,E,w){C[w+0]=E&255,E=E>>>8,C[w+1]=E&255}e.writeUInt16LE=T;function y(C,E){return C[E]*2**24+C[E+1]*2**16+C[E+2]*2**8+C[E+3]}e.readUInt32BE=y;function v(C,E,w){C[w+3]=E,E=E>>>8,C[w+2]=E,E=E>>>8,C[w+1]=E,E=E>>>8,C[w]=E}e.writeUInt32BE=v;function h(C,E){return C[E+0]<<0>>>0|C[E+1]<<8>>>0|C[E+2]<<16>>>0|C[E+3]<<24>>>0}e.readUInt32LE=h;function g(C,E,w){C[w+0]=E&255,E=E>>>8,C[w+1]=E&255,E=E>>>8,C[w+2]=E&255,E=E>>>8,C[w+3]=E&255}e.writeUInt32LE=g;function p(C,E){return C[E]}e.readUInt8=p;function r(C,E,w){C[w]=E}e.writeUInt8=r;function f(C){return L.consumeReadable(C,E=>b.concat(E))}e.readableToBuffer=f;function c(C){return L.toReadable(C)}e.bufferToReadable=c;function u(C){return L.consumeStream(C,E=>b.concat(E))}e.streamToBuffer=u;async function D(C){return C.ended?b.concat(C.buffer):b.concat([...C.buffer,await u(C.stream)])}e.bufferedStreamToBuffer=D;function O(C){return L.toStream(C,E=>b.concat(E))}e.bufferToStream=O;function t(C){return L.transform(C,{data:E=>typeof E=="string"?b.fromString(E):b.wrap(E)},E=>b.concat(E))}e.streamToBufferReadableStream=t;function n(C){return L.newWriteableStream(E=>b.concat(E),C)}e.newWriteableBufferStream=n;function s(C,E){return L.prefixedReadable(C,E,w=>b.concat(w))}e.prefixedBufferReadable=s;function i(C,E){return L.prefixedStream(C,E,w=>b.concat(w))}e.prefixedBufferStream=i;function a(C){let E=0,w=0,N=0;const $=new Uint8Array(Math.floor(C.length/4*3)),se=ae=>{switch(w){case 3:$[N++]=E|ae,w=0;break;case 2:$[N++]=E|ae>>>2,E=ae<<6,w=3;break;case 1:$[N++]=E|ae>>>4,E=ae<<4,w=2;break;default:E=ae<<2,w=1}};for(let ae=0;ae<C.length;ae++){const ue=C.charCodeAt(ae);if(ue>=65&&ue<=90)se(ue-65);else if(ue>=97&&ue<=122)se(ue-97+26);else if(ue>=48&&ue<=57)se(ue-48+52);else if(ue===43||ue===45)se(62);else if(ue===47||ue===95)se(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${C[ae]}`)}}const he=N;for(;w>0;)se(0);return b.wrap($).slice(0,he)}e.decodeBase64=a;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:C},E=!0,w=!1){const N=w?d:l;let $="";const se=C.byteLength%3;let he=0;for(;he<C.byteLength-se;he+=3){const ae=C[he+0],ue=C[he+1],ge=C[he+2];$+=N[ae>>>2],$+=N[(ae<<4|ue>>>4)&63],$+=N[(ue<<2|ge>>>6)&63],$+=N[ge&63]}if(se===1){const ae=C[he+0];$+=N[ae>>>2],$+=N[ae<<4&63],E&&($+="==")}else if(se===2){const ae=C[he+0],ue=C[he+1];$+=N[ae>>>2],$+=N[(ae<<4|ue>>>4)&63],$+=N[ue<<2&63],E&&($+="=")}return $}e.encodeBase64=I}),define(pe[144],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(pe[8],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function S(n){return typeof n=="string"}e.isString=S;function L(n){return Array.isArray(n)&&n.every(s=>S(s))}e.isStringArray=L;function o(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}e.isObject=o;function A(n){const s=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof s}e.isTypedArray=A;function k(n){return typeof n=="number"&&!isNaN(n)}e.isNumber=k;function R(n){return!!n&&typeof n[Symbol.iterator]=="function"}e.isIterable=R;function b(n){return n===!0||n===!1}e.isBoolean=b;function m(n){return typeof n>"u"}e.isUndefined=m;function T(n){return!y(n)}e.isDefined=T;function y(n){return m(n)||n===null}e.isUndefinedOrNull=y;function v(n,s){if(!n)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=v;function h(n){if(y(n))throw new Error("Assertion Failed: argument is undefined or null");return n}e.assertIsDefined=h;function g(...n){const s=[];for(let i=0;i<n.length;i++){const a=n[i];if(y(a))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);s.push(a)}return s}e.assertAllDefined=g;const p=Object.prototype.hasOwnProperty;function r(n){if(!o(n))return!1;for(const s in n)if(p.call(n,s))return!1;return!0}e.isEmptyObject=r;function f(n){return typeof n=="function"}e.isFunction=f;function c(...n){return n.length>0&&n.every(f)}e.areFunctions=c;function u(n,s){const i=Math.min(n.length,s.length);for(let a=0;a<i;a++)D(n[a],s[a])}e.validateConstraints=u;function D(n,s){if(S(s)){if(typeof n!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(f(s)){try{if(n instanceof s)return}catch{}if(!y(n)&&n.constructor===s||s.length===1&&s.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=D;function O(n){return n===null?void 0:n}e.withNullAsUndefined=O;function t(n){return typeof n>"u"?null:n}e.withUndefinedAsNull=t}),define(pe[48],be([1,0,8]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function o(R,b){if((0,S.isString)(b)){const m=L[b];if(m===void 0)throw new Error(`${R} references an unknown codicon: ${b}`);b=m}return L[R]=b,{id:R}}function A(){return L}e.getCodiconFontCharacters=A;function k(){return Object.values(e.Codicon)}e.getAllCodicons=k,e.Codicon={add:o("add",6e4),plus:o("plus",6e4),gistNew:o("gist-new",6e4),repoCreate:o("repo-create",6e4),lightbulb:o("lightbulb",60001),lightBulb:o("light-bulb",60001),repo:o("repo",60002),repoDelete:o("repo-delete",60002),gistFork:o("gist-fork",60003),repoForked:o("repo-forked",60003),gitPullRequest:o("git-pull-request",60004),gitPullRequestAbandoned:o("git-pull-request-abandoned",60004),recordKeys:o("record-keys",60005),keyboard:o("keyboard",60005),tag:o("tag",60006),tagAdd:o("tag-add",60006),tagRemove:o("tag-remove",60006),person:o("person",60007),personFollow:o("person-follow",60007),personOutline:o("person-outline",60007),personFilled:o("person-filled",60007),gitBranch:o("git-branch",60008),gitBranchCreate:o("git-branch-create",60008),gitBranchDelete:o("git-branch-delete",60008),sourceControl:o("source-control",60008),mirror:o("mirror",60009),mirrorPublic:o("mirror-public",60009),star:o("star",60010),starAdd:o("star-add",60010),starDelete:o("star-delete",60010),starEmpty:o("star-empty",60010),comment:o("comment",60011),commentAdd:o("comment-add",60011),alert:o("alert",60012),warning:o("warning",60012),search:o("search",60013),searchSave:o("search-save",60013),logOut:o("log-out",60014),signOut:o("sign-out",60014),logIn:o("log-in",60015),signIn:o("sign-in",60015),eye:o("eye",60016),eyeUnwatch:o("eye-unwatch",60016),eyeWatch:o("eye-watch",60016),circleFilled:o("circle-filled",60017),primitiveDot:o("primitive-dot",60017),closeDirty:o("close-dirty",60017),debugBreakpoint:o("debug-breakpoint",60017),debugBreakpointDisabled:o("debug-breakpoint-disabled",60017),debugHint:o("debug-hint",60017),primitiveSquare:o("primitive-square",60018),edit:o("edit",60019),pencil:o("pencil",60019),info:o("info",60020),issueOpened:o("issue-opened",60020),gistPrivate:o("gist-private",60021),gitForkPrivate:o("git-fork-private",60021),lock:o("lock",60021),mirrorPrivate:o("mirror-private",60021),close:o("close",60022),removeClose:o("remove-close",60022),x:o("x",60022),repoSync:o("repo-sync",60023),sync:o("sync",60023),clone:o("clone",60024),desktopDownload:o("desktop-download",60024),beaker:o("beaker",60025),microscope:o("microscope",60025),vm:o("vm",60026),deviceDesktop:o("device-desktop",60026),file:o("file",60027),fileText:o("file-text",60027),more:o("more",60028),ellipsis:o("ellipsis",60028),kebabHorizontal:o("kebab-horizontal",60028),mailReply:o("mail-reply",60029),reply:o("reply",60029),organization:o("organization",60030),organizationFilled:o("organization-filled",60030),organizationOutline:o("organization-outline",60030),newFile:o("new-file",60031),fileAdd:o("file-add",60031),newFolder:o("new-folder",60032),fileDirectoryCreate:o("file-directory-create",60032),trash:o("trash",60033),trashcan:o("trashcan",60033),history:o("history",60034),clock:o("clock",60034),folder:o("folder",60035),fileDirectory:o("file-directory",60035),symbolFolder:o("symbol-folder",60035),logoGithub:o("logo-github",60036),markGithub:o("mark-github",60036),github:o("github",60036),terminal:o("terminal",60037),console:o("console",60037),repl:o("repl",60037),zap:o("zap",60038),symbolEvent:o("symbol-event",60038),error:o("error",60039),stop:o("stop",60039),variable:o("variable",60040),symbolVariable:o("symbol-variable",60040),array:o("array",60042),symbolArray:o("symbol-array",60042),symbolModule:o("symbol-module",60043),symbolPackage:o("symbol-package",60043),symbolNamespace:o("symbol-namespace",60043),symbolObject:o("symbol-object",60043),symbolMethod:o("symbol-method",60044),symbolFunction:o("symbol-function",60044),symbolConstructor:o("symbol-constructor",60044),symbolBoolean:o("symbol-boolean",60047),symbolNull:o("symbol-null",60047),symbolNumeric:o("symbol-numeric",60048),symbolNumber:o("symbol-number",60048),symbolStructure:o("symbol-structure",60049),symbolStruct:o("symbol-struct",60049),symbolParameter:o("symbol-parameter",60050),symbolTypeParameter:o("symbol-type-parameter",60050),symbolKey:o("symbol-key",60051),symbolText:o("symbol-text",60051),symbolReference:o("symbol-reference",60052),goToFile:o("go-to-file",60052),symbolEnum:o("symbol-enum",60053),symbolValue:o("symbol-value",60053),symbolRuler:o("symbol-ruler",60054),symbolUnit:o("symbol-unit",60054),activateBreakpoints:o("activate-breakpoints",60055),archive:o("archive",60056),arrowBoth:o("arrow-both",60057),arrowDown:o("arrow-down",60058),arrowLeft:o("arrow-left",60059),arrowRight:o("arrow-right",60060),arrowSmallDown:o("arrow-small-down",60061),arrowSmallLeft:o("arrow-small-left",60062),arrowSmallRight:o("arrow-small-right",60063),arrowSmallUp:o("arrow-small-up",60064),arrowUp:o("arrow-up",60065),bell:o("bell",60066),bold:o("bold",60067),book:o("book",60068),bookmark:o("bookmark",60069),debugBreakpointConditionalUnverified:o("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:o("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:o("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:o("debug-breakpoint-data-unverified",60072),debugBreakpointData:o("debug-breakpoint-data",60073),debugBreakpointDataDisabled:o("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:o("debug-breakpoint-log-unverified",60074),debugBreakpointLog:o("debug-breakpoint-log",60075),debugBreakpointLogDisabled:o("debug-breakpoint-log-disabled",60075),briefcase:o("briefcase",60076),broadcast:o("broadcast",60077),browser:o("browser",60078),bug:o("bug",60079),calendar:o("calendar",60080),caseSensitive:o("case-sensitive",60081),check:o("check",60082),checklist:o("checklist",60083),chevronDown:o("chevron-down",60084),dropDownButton:o("drop-down-button",60084),chevronLeft:o("chevron-left",60085),chevronRight:o("chevron-right",60086),chevronUp:o("chevron-up",60087),chromeClose:o("chrome-close",60088),chromeMaximize:o("chrome-maximize",60089),chromeMinimize:o("chrome-minimize",60090),chromeRestore:o("chrome-restore",60091),circle:o("circle",60092),circleOutline:o("circle-outline",60092),debugBreakpointUnverified:o("debug-breakpoint-unverified",60092),circleSlash:o("circle-slash",60093),circuitBoard:o("circuit-board",60094),clearAll:o("clear-all",60095),clippy:o("clippy",60096),closeAll:o("close-all",60097),cloudDownload:o("cloud-download",60098),cloudUpload:o("cloud-upload",60099),code:o("code",60100),collapseAll:o("collapse-all",60101),colorMode:o("color-mode",60102),commentDiscussion:o("comment-discussion",60103),compareChanges:o("compare-changes",60157),creditCard:o("credit-card",60105),dash:o("dash",60108),dashboard:o("dashboard",60109),database:o("database",60110),debugContinue:o("debug-continue",60111),debugDisconnect:o("debug-disconnect",60112),debugPause:o("debug-pause",60113),debugRestart:o("debug-restart",60114),debugStart:o("debug-start",60115),debugStepInto:o("debug-step-into",60116),debugStepOut:o("debug-step-out",60117),debugStepOver:o("debug-step-over",60118),debugStop:o("debug-stop",60119),debug:o("debug",60120),deviceCameraVideo:o("device-camera-video",60121),deviceCamera:o("device-camera",60122),deviceMobile:o("device-mobile",60123),diffAdded:o("diff-added",60124),diffIgnored:o("diff-ignored",60125),diffModified:o("diff-modified",60126),diffRemoved:o("diff-removed",60127),diffRenamed:o("diff-renamed",60128),diff:o("diff",60129),discard:o("discard",60130),editorLayout:o("editor-layout",60131),emptyWindow:o("empty-window",60132),exclude:o("exclude",60133),extensions:o("extensions",60134),eyeClosed:o("eye-closed",60135),fileBinary:o("file-binary",60136),fileCode:o("file-code",60137),fileMedia:o("file-media",60138),filePdf:o("file-pdf",60139),fileSubmodule:o("file-submodule",60140),fileSymlinkDirectory:o("file-symlink-directory",60141),fileSymlinkFile:o("file-symlink-file",60142),fileZip:o("file-zip",60143),files:o("files",60144),filter:o("filter",60145),flame:o("flame",60146),foldDown:o("fold-down",60147),foldUp:o("fold-up",60148),fold:o("fold",60149),folderActive:o("folder-active",60150),folderOpened:o("folder-opened",60151),gear:o("gear",60152),gift:o("gift",60153),gistSecret:o("gist-secret",60154),gist:o("gist",60155),gitCommit:o("git-commit",60156),gitCompare:o("git-compare",60157),gitMerge:o("git-merge",60158),githubAction:o("github-action",60159),githubAlt:o("github-alt",60160),globe:o("globe",60161),grabber:o("grabber",60162),graph:o("graph",60163),gripper:o("gripper",60164),heart:o("heart",60165),home:o("home",60166),horizontalRule:o("horizontal-rule",60167),hubot:o("hubot",60168),inbox:o("inbox",60169),issueClosed:o("issue-closed",60324),issueReopened:o("issue-reopened",60171),issues:o("issues",60172),italic:o("italic",60173),jersey:o("jersey",60174),json:o("json",60175),bracket:o("bracket",60175),kebabVertical:o("kebab-vertical",60176),key:o("key",60177),law:o("law",60178),lightbulbAutofix:o("lightbulb-autofix",60179),linkExternal:o("link-external",60180),link:o("link",60181),listOrdered:o("list-ordered",60182),listUnordered:o("list-unordered",60183),liveShare:o("live-share",60184),loading:o("loading",60185),location:o("location",60186),mailRead:o("mail-read",60187),mail:o("mail",60188),markdown:o("markdown",60189),megaphone:o("megaphone",60190),mention:o("mention",60191),milestone:o("milestone",60192),mortarBoard:o("mortar-board",60193),move:o("move",60194),multipleWindows:o("multiple-windows",60195),mute:o("mute",60196),noNewline:o("no-newline",60197),note:o("note",60198),octoface:o("octoface",60199),openPreview:o("open-preview",60200),package_:o("package",60201),paintcan:o("paintcan",60202),pin:o("pin",60203),play:o("play",60204),run:o("run",60204),plug:o("plug",60205),preserveCase:o("preserve-case",60206),preview:o("preview",60207),project:o("project",60208),pulse:o("pulse",60209),question:o("question",60210),quote:o("quote",60211),radioTower:o("radio-tower",60212),reactions:o("reactions",60213),references:o("references",60214),refresh:o("refresh",60215),regex:o("regex",60216),remoteExplorer:o("remote-explorer",60217),remote:o("remote",60218),remove:o("remove",60219),replaceAll:o("replace-all",60220),replace:o("replace",60221),repoClone:o("repo-clone",60222),repoForcePush:o("repo-force-push",60223),repoPull:o("repo-pull",60224),repoPush:o("repo-push",60225),report:o("report",60226),requestChanges:o("request-changes",60227),rocket:o("rocket",60228),rootFolderOpened:o("root-folder-opened",60229),rootFolder:o("root-folder",60230),rss:o("rss",60231),ruby:o("ruby",60232),saveAll:o("save-all",60233),saveAs:o("save-as",60234),save:o("save",60235),screenFull:o("screen-full",60236),screenNormal:o("screen-normal",60237),searchStop:o("search-stop",60238),server:o("server",60240),settingsGear:o("settings-gear",60241),settings:o("settings",60242),shield:o("shield",60243),smiley:o("smiley",60244),sortPrecedence:o("sort-precedence",60245),splitHorizontal:o("split-horizontal",60246),splitVertical:o("split-vertical",60247),squirrel:o("squirrel",60248),starFull:o("star-full",60249),starHalf:o("star-half",60250),symbolClass:o("symbol-class",60251),symbolColor:o("symbol-color",60252),symbolCustomColor:o("symbol-customcolor",60252),symbolConstant:o("symbol-constant",60253),symbolEnumMember:o("symbol-enum-member",60254),symbolField:o("symbol-field",60255),symbolFile:o("symbol-file",60256),symbolInterface:o("symbol-interface",60257),symbolKeyword:o("symbol-keyword",60258),symbolMisc:o("symbol-misc",60259),symbolOperator:o("symbol-operator",60260),symbolProperty:o("symbol-property",60261),wrench:o("wrench",60261),wrenchSubaction:o("wrench-subaction",60261),symbolSnippet:o("symbol-snippet",60262),tasklist:o("tasklist",60263),telescope:o("telescope",60264),textSize:o("text-size",60265),threeBars:o("three-bars",60266),thumbsdown:o("thumbsdown",60267),thumbsup:o("thumbsup",60268),tools:o("tools",60269),triangleDown:o("triangle-down",60270),triangleLeft:o("triangle-left",60271),triangleRight:o("triangle-right",60272),triangleUp:o("triangle-up",60273),twitter:o("twitter",60274),unfold:o("unfold",60275),unlock:o("unlock",60276),unmute:o("unmute",60277),unverified:o("unverified",60278),verified:o("verified",60279),versions:o("versions",60280),vmActive:o("vm-active",60281),vmOutline:o("vm-outline",60282),vmRunning:o("vm-running",60283),watch:o("watch",60284),whitespace:o("whitespace",60285),wholeWord:o("whole-word",60286),window:o("window",60287),wordWrap:o("word-wrap",60288),zoomIn:o("zoom-in",60289),zoomOut:o("zoom-out",60290),listFilter:o("list-filter",60291),listFlat:o("list-flat",60292),listSelection:o("list-selection",60293),selection:o("selection",60293),listTree:o("list-tree",60294),debugBreakpointFunctionUnverified:o("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:o("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:o("debug-breakpoint-function-disabled",60296),debugStackframeActive:o("debug-stackframe-active",60297),circleSmallFilled:o("circle-small-filled",60298),debugStackframeDot:o("debug-stackframe-dot",60298),debugStackframe:o("debug-stackframe",60299),debugStackframeFocused:o("debug-stackframe-focused",60299),debugBreakpointUnsupported:o("debug-breakpoint-unsupported",60300),symbolString:o("symbol-string",60301),debugReverseContinue:o("debug-reverse-continue",60302),debugStepBack:o("debug-step-back",60303),debugRestartFrame:o("debug-restart-frame",60304),callIncoming:o("call-incoming",60306),callOutgoing:o("call-outgoing",60307),menu:o("menu",60308),expandAll:o("expand-all",60309),feedback:o("feedback",60310),groupByRefType:o("group-by-ref-type",60311),ungroupByRefType:o("ungroup-by-ref-type",60312),account:o("account",60313),bellDot:o("bell-dot",60314),debugConsole:o("debug-console",60315),library:o("library",60316),output:o("output",60317),runAll:o("run-all",60318),syncIgnored:o("sync-ignored",60319),pinned:o("pinned",60320),githubInverted:o("github-inverted",60321),debugAlt:o("debug-alt",60305),serverProcess:o("server-process",60322),serverEnvironment:o("server-environment",60323),pass:o("pass",60324),stopCircle:o("stop-circle",60325),playCircle:o("play-circle",60326),record:o("record",60327),debugAltSmall:o("debug-alt-small",60328),vmConnect:o("vm-connect",60329),cloud:o("cloud",60330),merge:o("merge",60331),exportIcon:o("export",60332),graphLeft:o("graph-left",60333),magnet:o("magnet",60334),notebook:o("notebook",60335),redo:o("redo",60336),checkAll:o("check-all",60337),pinnedDirty:o("pinned-dirty",60338),passFilled:o("pass-filled",60339),circleLargeFilled:o("circle-large-filled",60340),circleLarge:o("circle-large",60341),circleLargeOutline:o("circle-large-outline",60341),combine:o("combine",60342),gather:o("gather",60342),table:o("table",60343),variableGroup:o("variable-group",60344),typeHierarchy:o("type-hierarchy",60345),typeHierarchySub:o("type-hierarchy-sub",60346),typeHierarchySuper:o("type-hierarchy-super",60347),gitPullRequestCreate:o("git-pull-request-create",60348),runAbove:o("run-above",60349),runBelow:o("run-below",60350),notebookTemplate:o("notebook-template",60351),debugRerun:o("debug-rerun",60352),workspaceTrusted:o("workspace-trusted",60353),workspaceUntrusted:o("workspace-untrusted",60354),workspaceUnspecified:o("workspace-unspecified",60355),terminalCmd:o("terminal-cmd",60356),terminalDebian:o("terminal-debian",60357),terminalLinux:o("terminal-linux",60358),terminalPowershell:o("terminal-powershell",60359),terminalTmux:o("terminal-tmux",60360),terminalUbuntu:o("terminal-ubuntu",60361),terminalBash:o("terminal-bash",60362),arrowSwap:o("arrow-swap",60363),copy:o("copy",60364),personAdd:o("person-add",60365),filterFilled:o("filter-filled",60366),wand:o("wand",60367),debugLineByLine:o("debug-line-by-line",60368),inspect:o("inspect",60369),layers:o("layers",60370),layersDot:o("layers-dot",60371),layersActive:o("layers-active",60372),compass:o("compass",60373),compassDot:o("compass-dot",60374),compassActive:o("compass-active",60375),azure:o("azure",60376),issueDraft:o("issue-draft",60377),gitPullRequestClosed:o("git-pull-request-closed",60378),gitPullRequestDraft:o("git-pull-request-draft",60379),debugAll:o("debug-all",60380),debugCoverage:o("debug-coverage",60381),runErrors:o("run-errors",60382),folderLibrary:o("folder-library",60383),debugContinueSmall:o("debug-continue-small",60384),beakerStop:o("beaker-stop",60385),graphLine:o("graph-line",60386),graphScatter:o("graph-scatter",60387),pieChart:o("pie-chart",60388),bracketDot:o("bracket-dot",60389),bracketError:o("bracket-error",60390),lockSmall:o("lock-small",60391),azureDevops:o("azure-devops",60392),verifiedFilled:o("verified-filled",60393),newLine:o("newline",60394),layout:o("layout",60395),layoutActivitybarLeft:o("layout-activitybar-left",60396),layoutActivitybarRight:o("layout-activitybar-right",60397),layoutPanelLeft:o("layout-panel-left",60398),layoutPanelCenter:o("layout-panel-center",60399),layoutPanelJustify:o("layout-panel-justify",60400),layoutPanelRight:o("layout-panel-right",60401),layoutPanel:o("layout-panel",60402),layoutSidebarLeft:o("layout-sidebar-left",60403),layoutSidebarRight:o("layout-sidebar-right",60404),layoutStatusbar:o("layout-statusbar",60405),layoutMenubar:o("layout-menubar",60406),layoutCentered:o("layout-centered",60407),layoutSidebarRightOff:o("layout-sidebar-right-off",60416),layoutPanelOff:o("layout-panel-off",60417),layoutSidebarLeftOff:o("layout-sidebar-left-off",60418),target:o("target",60408),indent:o("indent",60409),recordSmall:o("record-small",60410),errorSmall:o("error-small",60411),arrowCircleDown:o("arrow-circle-down",60412),arrowCircleLeft:o("arrow-circle-left",60413),arrowCircleRight:o("arrow-circle-right",60414),arrowCircleUp:o("arrow-circle-up",60415),heartFilled:o("heart-filled",60420),map:o("map",60421),mapFilled:o("map-filled",60422),circleSmall:o("circle-small",60423),bellSlash:o("bell-slash",60424),bellSlashDot:o("bell-slash-dot",60425),commentUnresolved:o("comment-unresolved",60426),gitPullRequestGoToChanges:o("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:o("git-pull-request-new-changes",60428),searchFuzzy:o("search-fuzzy",60429),commentDraft:o("comment-draft",60430),send:o("send",60431),sparkle:o("sparkle",60432),insert:o("insert",60433),dialogError:o("dialog-error","error"),dialogWarning:o("dialog-warning","warning"),dialogInfo:o("dialog-info","info"),dialogClose:o("dialog-close","close"),treeItemExpanded:o("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:o("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:o("tree-filter-on-type-off","list-selection"),treeFilterClear:o("tree-filter-clear","close"),treeItemLoading:o("tree-item-loading","loading"),menuSelection:o("menu-selection","check"),menuSubmenu:o("menu-submenu","chevron-right"),menuBarMore:o("menubar-more","more"),scrollbarButtonLeft:o("scrollbar-button-left","triangle-left"),scrollbarButtonRight:o("scrollbar-button-right","triangle-right"),scrollbarButtonUp:o("scrollbar-button-up","triangle-up"),scrollbarButtonDown:o("scrollbar-button-down","triangle-down"),toolBarMore:o("toolbar-more","more"),quickInputBack:o("quick-input-back","arrow-left")}}),define(pe[21],be([1,0,8]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const c=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([u,D])=>{c[u]=D&&typeof D=="object"?L(D):D}),c}e.deepClone=L;function o(f){if(!f||typeof f!="object")return f;const c=[f];for(;c.length>0;){const u=c.shift();Object.freeze(u);for(const D in u)if(A.call(u,D)){const O=u[D];typeof O=="object"&&!Object.isFrozen(O)&&!(0,S.isTypedArray)(O)&&c.push(O)}}return f}e.deepFreeze=o;const A=Object.prototype.hasOwnProperty;function k(f,c){return R(f,c,new Set)}e.cloneAndChange=k;function R(f,c,u){if((0,S.isUndefinedOrNull)(f))return f;const D=c(f);if(typeof D<"u")return D;if(Array.isArray(f)){const O=[];for(const t of f)O.push(R(t,c,u));return O}if((0,S.isObject)(f)){if(u.has(f))throw new Error("Cannot clone recursive data-structure");u.add(f);const O={};for(const t in f)A.call(f,t)&&(O[t]=R(f[t],c,u));return u.delete(f),O}return f}function b(f,c,u=!0){return(0,S.isObject)(f)?((0,S.isObject)(c)&&Object.keys(c).forEach(D=>{D in f?u&&((0,S.isObject)(f[D])&&(0,S.isObject)(c[D])?b(f[D],c[D],u):f[D]=c[D]):f[D]=c[D]}),f):c}e.mixin=b;function m(f,c){if(f===c)return!0;if(f==null||c===null||c===void 0||typeof f!=typeof c||typeof f!="object"||Array.isArray(f)!==Array.isArray(c))return!1;let u,D;if(Array.isArray(f)){if(f.length!==c.length)return!1;for(u=0;u<f.length;u++)if(!m(f[u],c[u]))return!1}else{const O=[];for(D in f)O.push(D);O.sort();const t=[];for(D in c)t.push(D);if(t.sort(),!m(O,t))return!1;for(u=0;u<O.length;u++)if(!m(f[O[u]],c[O[u]]))return!1}return!0}e.equals=m;function T(f){const c=new Set;return JSON.stringify(f,(u,D)=>{if((0,S.isObject)(D)||Array.isArray(D)){if(c.has(D))return"[Circular]";c.add(D)}return D})}e.safeStringify=T;function y(f,c){const u=Object.create(null);return!f||!c||Object.keys(c).forEach(O=>{const t=f[O],n=c[O];m(t,n)||(u[O]=n)}),u}e.distinct=y;function v(f,c){const u=c.toLowerCase(),D=Object.keys(f).find(O=>O.toLowerCase()===u);return D?f[D]:f[c]}e.getCaseInsensitive=v;function h(f,c){const u=Object.create(null);for(const[D,O]of Object.entries(f))c(D,O)&&(u[D]=O);return u}e.filter=h;function g(f){let c=[],u=Object.getPrototypeOf(f);for(;Object.prototype!==u;)c=c.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return c}e.getAllPropertyNames=g;function p(f){const c=[];for(const u of g(f))typeof f[u]=="function"&&c.push(u);return c}e.getAllMethodNames=p;function r(f,c){const u=O=>function(){const t=Array.prototype.slice.call(arguments,0);return c(O,t)},D={};for(const O of f)D[O]=u(O);return D}e.createProxyObject=r}),define(pe[96],be([1,0,48]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(k){function R(b){return b&&typeof b=="object"&&typeof b.id=="string"}k.isThemeColor=R})(L||(e.ThemeColor=L={}));function o(k){return{id:k}}e.themeColorFromId=o;var A;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function b(c){const u=R.exec(c.id);if(!u)return b(S.Codicon.error);const[,D,O]=u,t=["codicon","codicon-"+D];return O&&t.push("codicon-modifier-"+O.substring(1)),t}k.asClassNameArray=b;function m(c){return b(c).join(" ")}k.asClassName=m;function T(c){return"."+b(c).join(".")}k.asCSSSelector=T;function y(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||L.isThemeColor(c.color))}k.isThemeIcon=y;const v=new RegExp(`^\\$\\((${k.iconNameExpression}(?:${k.iconModifierExpression})?)\\)$`);function h(c){const u=v.exec(c);if(!u)return;const[,D]=u;return{id:D}}k.fromString=h;function g(c){return{id:c}}k.fromId=g;function p(c,u){let D=c.id;const O=D.lastIndexOf("~");return O!==-1&&(D=D.substring(0,O)),u&&(D=`${D}~${u}`),{id:D}}k.modify=p;function r(c){const u=c.id.lastIndexOf("~");if(u!==-1)return c.id.substring(u+1)}k.getModifier=r;function f(c,u){return c.id===u.id&&c.color?.id===u.color?.id}k.isEqual=f})(A||(e.ThemeIcon=A={}))}),define(pe[22],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(o){return S.test(o)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let o;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?o=crypto.getRandomValues.bind(crypto):o=function(R){for(let b=0;b<R.length;b++)R[b]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),k=[];for(let R=0;R<256;R++)k.push(R.toString(16).padStart(2,"0"));return function(){o(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let b=0,m="";return m+=k[A[b++]],m+=k[A[b++]],m+=k[A[b++]],m+=k[A[b++]],m+="-",m+=k[A[b++]],m+=k[A[b++]],m+="-",m+=k[A[b++]],m+=k[A[b++]],m+="-",m+=k[A[b++]],m+=k[A[b++]],m+="-",m+=k[A[b++]],m+=k[A[b++]],m+=k[A[b++]],m+=k[A[b++]],m+=k[A[b++]],m+=k[A[b++]],m}}()}),define(pe[145],be([1,0,18,46,22]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function A(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}e.createStringDataTransferItem=A;function k(y,v,h){const g={id:(0,o.generateUuid)(),name:y,uri:v,data:h};return{asString:async()=>"",asFile:()=>g,value:void 0}}e.createFileDataTransferItem=k;class R{constructor(){this.a=new Map}get size(){let v=0;for(const h of this.a)v++;return v}has(v){return this.a.has(this.b(v))}matches(v){const h=[...this.a.keys()];return L.Iterable.some(this,([g,p])=>p.asFile())&&h.push("files"),T(b(v),h)}get(v){return this.a.get(this.b(v))?.[0]}append(v,h){const g=this.a.get(v);g?g.push(h):this.a.set(this.b(v),[h])}replace(v,h){this.a.set(this.b(v),[h])}delete(v){this.a.delete(this.b(v))}*[Symbol.iterator](){for(const[v,h]of this.a)for(const g of h)yield[v,g]}b(v){return b(v)}}e.VSDataTransfer=R;function b(y){return y.toLowerCase()}function m(y,v){return T(b(y),v.map(b))}e.matchesMimeType=m;function T(y,v){if(y==="*/*")return v.length>0;if(v.includes(y))return!0;const h=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!h)return!1;const[g,p,r]=h;return r==="*"?v.some(f=>f.startsWith(p+"/")):!1}e.UriList=Object.freeze({create:y=>(0,S.distinct)(y.map(v=>v.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.UriList.split(y).filter(v=>!v.startsWith("#"))})}),function(){"use strict";function le(e,S,L){function o(h){return new Promise(g=>S.exists(h,g))}function A(h){return new Promise((g,p)=>{const r=new Date;S.utimes(h,r,r,f=>f?p(f):g())})}function k(h){return new Promise((g,p)=>S.mkdir(h,{recursive:!0},r=>r&&r.code!=="EEXIST"?p(r):g(h)))}function R(h){return new Promise((g,p)=>S.rm(h,{recursive:!0,force:!0,maxRetries:3},r=>r?p(r):g()))}function b(h){return new Promise((g,p)=>S.readFile(h,"utf8",(r,f)=>r?p(r):g(f)))}function m(h,g){return new Promise((p,r)=>S.writeFile(h,g,"utf8",f=>f?r(f):p()))}async function T(h){const g=e.join(h,"languagepacks.json");try{return JSON.parse(await b(g))}catch{}}function y(h,g){try{for(;g;){if(h[g])return g;{const p=g.lastIndexOf("-");if(p>0)g=g.substring(0,p);else return}}}catch(p){console.error("Resolving language pack configuration failed.",p)}}function v(h,g,p,r,f){const c=function(D){return L.mark("code/didGenerateNls"),Promise.resolve({locale:D,osLocale:f,availableLanguages:{}})};if(L.mark("code/willGenerateNls"),r==="pseudo")return Promise.resolve({locale:r,osLocale:f,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:r,osLocale:f,availableLanguages:{}});if(r&&(r==="en"||r==="en-us"))return Promise.resolve({locale:r,osLocale:f,availableLanguages:{}});const u=r;try{return h?T(g).then(D=>{if(!D)return c(u);const O=y(D,r);if(!O)return c(u);r=O;const t=D[r];let n;return!t||typeof t.hash!="string"||!t.translations||typeof(n=t.translations.vscode)!="string"?c(u):o(n).then(s=>{if(!s)return c(u);const i=t.hash+"."+r,a=e.join(g,"clp",i),l=e.join(a,h),d=e.join(a,"tcf.json"),I=e.join(a,"corrupted.info"),C={locale:u,osLocale:f,availableLanguages:{"*":r},_languagePackId:i,_translationsConfigFile:d,_cacheRoot:a,_resolvedLanguagePackCoreLocation:l,_corruptedFile:I};return o(I).then(E=>{let w;return E?w=R(a):w=Promise.resolve(void 0),w.then(()=>o(l).then(N=>N?(A(l).catch(()=>{}),L.mark("code/didGenerateNls"),C):k(l).then(()=>Promise.all([b(p),b(n)])).then($=>{const se=JSON.parse($[0]),he=JSON.parse($[1]).contents,ae=Object.keys(se.bundles),ue=[];for(const ge of ae){const _=se.bundles[ge],ie=Object.create(null);for(const V of _){const J=se.keys[V],U=se.messages[V],ne=he[V];let x;if(ne){x=[];for(let re=0;re<J.length;re++){const Y=J[re],ee=typeof Y=="string"?Y:Y.key;let j=ne[ee];j===void 0&&(j=U[re]),x.push(j)}}else x=U;ie[V]=x}ue.push(m(e.join(l,ge.replace(/\//g,"!")+".nls.json"),JSON.stringify(ie)))}return ue.push(m(d,JSON.stringify(t.translations))),Promise.all(ue)}).then(()=>(L.mark("code/didGenerateNls"),C)).catch($=>(console.error("Generating translation files failed.",$),c(r)))))})})}):c(u)}catch(D){return console.error("Generating translation files failed.",D),c(r)}}return{getNLSConfiguration:v}}if(typeof define=="function")define(pe[146],be([73,33,41]),function(e,S,L){return le(e,S,L)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("fs"),L=require("../common/performance");module.exports=le(e,S,L)}else throw new Error("Unknown context")}(),define(pe[147],be([1,0,28]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function o(k){const R=k.replace(/\-/g,":").toLowerCase();return!L.has(R)}function A(){const k=(0,S.networkInterfaces)();for(const R in k){const b=k[R];if(b){for(const{mac:m}of b)if(o(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(pe[148],be([1,0,74]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(R,b,m,T=1){let y=!1;return new Promise(v=>{const h=setTimeout(()=>{if(!y)return y=!0,v(0)},m);o(R,b,T,g=>{if(!y)return y=!0,clearTimeout(h),v(g)})})}e.findFreePort=L;function o(R,b,m,T){if(b===0)return T(0);const y=new S.Socket;y.once("connect",()=>(k(y),o(R+m,b-1,m,T))),y.once("data",()=>{}),y.once("error",v=>(k(y),v.code!=="ECONNREFUSED"?o(R+m,b-1,m,T):T(R))),y.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,b,m,T="127.0.0.1"){let y=!1,v,h=1;const g=S.createServer({pauseOnConnect:!0});function p(r,f){y||(y=!0,g.removeAllListeners(),g.close(),v&&clearTimeout(v),f(r))}return new Promise(r=>{v=setTimeout(()=>{p(0,r)},m),g.on("listening",()=>{p(R,r)}),g.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&h<b?(R++,h++,g.listen(R,T)):p(0,r)}),g.on("close",()=>{p(0,r)}),g.listen(R,T)})}e.findFreePortFaster=A;function k(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(b){console.error(b)}}}),function(){function le(){function e(){return process.uncHostAllowlist}function S(R){const b=new Set;if(Array.isArray(R))for(const m of R)typeof m=="string"&&b.add(m);return Array.from(b)}function L(){const R=e();return R?Array.from(R):[]}function o(R){if(process.platform!=="win32")return;const b=e();if(b)if(typeof R=="string")b.add(R.toLowerCase());else for(const m of S(R))o(m)}function A(R){if(typeof R!="string")return;const b=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const T of b){if(R.indexOf(T)!==0)continue;const v=R.indexOf("\\",T.length);if(v===-1)continue;const h=R.substring(T.length,v);if(h){m=h;break}}return m}function k(){process.platform==="win32"&&(process.enableUNCAccessChecks=!1)}return{getUNCHostAllowlist:L,addUNCHostToAllowlist:o,getUNCHost:A,disableUNCAccessRestrictions:k}}typeof define=="function"?define("vs/base/node/unc",[],function(){return le()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=le():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(pe[97],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class S{constructor(o,A){this.lineNumber=o,this.column=A}with(o=this.lineNumber,A=this.column){return o===this.lineNumber&&A===this.column?this:new S(o,A)}delta(o=0,A=0){return this.with(this.lineNumber+o,this.column+A)}equals(o){return S.equals(this,o)}static equals(o,A){return!o&&!A?!0:!!o&&!!A&&o.lineNumber===A.lineNumber&&o.column===A.column}isBefore(o){return S.isBefore(this,o)}static isBefore(o,A){return o.lineNumber<A.lineNumber?!0:A.lineNumber<o.lineNumber?!1:o.column<A.column}isBeforeOrEqual(o){return S.isBeforeOrEqual(this,o)}static isBeforeOrEqual(o,A){return o.lineNumber<A.lineNumber?!0:A.lineNumber<o.lineNumber?!1:o.column<=A.column}static compare(o,A){const k=o.lineNumber|0,R=A.lineNumber|0;if(k===R){const b=o.column|0,m=A.column|0;return b-m}return k-R}clone(){return new S(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(o){return new S(o.lineNumber,o.column)}static isIPosition(o){return o&&typeof o.lineNumber=="number"&&typeof o.column=="number"}}e.Position=S}),define(pe[49],be([1,0,97]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(A,k,R,b){A>R||A===R&&k>b?(this.startLineNumber=R,this.startColumn=b,this.endLineNumber=A,this.endColumn=k):(this.startLineNumber=A,this.startColumn=k,this.endLineNumber=R,this.endColumn=b)}isEmpty(){return L.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return L.containsPosition(this,A)}static containsPosition(A,k){return!(k.lineNumber<A.startLineNumber||k.lineNumber>A.endLineNumber||k.lineNumber===A.startLineNumber&&k.column<A.startColumn||k.lineNumber===A.endLineNumber&&k.column>A.endColumn)}static strictContainsPosition(A,k){return!(k.lineNumber<A.startLineNumber||k.lineNumber>A.endLineNumber||k.lineNumber===A.startLineNumber&&k.column<=A.startColumn||k.lineNumber===A.endLineNumber&&k.column>=A.endColumn)}containsRange(A){return L.containsRange(this,A)}static containsRange(A,k){return!(k.startLineNumber<A.startLineNumber||k.endLineNumber<A.startLineNumber||k.startLineNumber>A.endLineNumber||k.endLineNumber>A.endLineNumber||k.startLineNumber===A.startLineNumber&&k.startColumn<A.startColumn||k.endLineNumber===A.endLineNumber&&k.endColumn>A.endColumn)}strictContainsRange(A){return L.strictContainsRange(this,A)}static strictContainsRange(A,k){return!(k.startLineNumber<A.startLineNumber||k.endLineNumber<A.startLineNumber||k.startLineNumber>A.endLineNumber||k.endLineNumber>A.endLineNumber||k.startLineNumber===A.startLineNumber&&k.startColumn<=A.startColumn||k.endLineNumber===A.endLineNumber&&k.endColumn>=A.endColumn)}plusRange(A){return L.plusRange(this,A)}static plusRange(A,k){let R,b,m,T;return k.startLineNumber<A.startLineNumber?(R=k.startLineNumber,b=k.startColumn):k.startLineNumber===A.startLineNumber?(R=k.startLineNumber,b=Math.min(k.startColumn,A.startColumn)):(R=A.startLineNumber,b=A.startColumn),k.endLineNumber>A.endLineNumber?(m=k.endLineNumber,T=k.endColumn):k.endLineNumber===A.endLineNumber?(m=k.endLineNumber,T=Math.max(k.endColumn,A.endColumn)):(m=A.endLineNumber,T=A.endColumn),new L(R,b,m,T)}intersectRanges(A){return L.intersectRanges(this,A)}static intersectRanges(A,k){let R=A.startLineNumber,b=A.startColumn,m=A.endLineNumber,T=A.endColumn;const y=k.startLineNumber,v=k.startColumn,h=k.endLineNumber,g=k.endColumn;return R<y?(R=y,b=v):R===y&&(b=Math.max(b,v)),m>h?(m=h,T=g):m===h&&(T=Math.min(T,g)),R>m||R===m&&b>T?null:new L(R,b,m,T)}equalsRange(A){return L.equalsRange(this,A)}static equalsRange(A,k){return!A&&!k?!0:!!A&&!!k&&A.startLineNumber===k.startLineNumber&&A.startColumn===k.startColumn&&A.endLineNumber===k.endLineNumber&&A.endColumn===k.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(A){return new S.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(A){return new S.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,k){return new L(this.startLineNumber,this.startColumn,A,k)}setStartPosition(A,k){return new L(A,k,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(A){return new L(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return L.collapseToEnd(this)}static collapseToEnd(A){return new L(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new L(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,k=A){return new L(A.lineNumber,A.column,k.lineNumber,k.column)}static lift(A){return A?new L(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,k){return!(A.endLineNumber<k.startLineNumber||A.endLineNumber===k.startLineNumber&&A.endColumn<k.startColumn||k.endLineNumber<A.startLineNumber||k.endLineNumber===A.startLineNumber&&k.endColumn<A.startColumn)}static areIntersecting(A,k){return!(A.endLineNumber<k.startLineNumber||A.endLineNumber===k.startLineNumber&&A.endColumn<=k.startColumn||k.endLineNumber<A.startLineNumber||k.endLineNumber===A.startLineNumber&&k.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,k){if(A&&k){const m=A.startLineNumber|0,T=k.startLineNumber|0;if(m===T){const y=A.startColumn|0,v=k.startColumn|0;if(y===v){const h=A.endLineNumber|0,g=k.endLineNumber|0;if(h===g){const p=A.endColumn|0,r=k.endColumn|0;return p-r}return h-g}return y-v}return m-T}return(A?1:0)-(k?1:0)}static compareRangesUsingEnds(A,k){return A.endLineNumber===k.endLineNumber?A.endColumn===k.endColumn?A.startLineNumber===k.startLineNumber?A.startColumn-k.startColumn:A.startLineNumber-k.startLineNumber:A.endColumn-k.endColumn:A.endLineNumber-k.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=L}),define(pe[149],be([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(pe[150],be([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(pe[151],be([1,0,150]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,o=L*60,A=o*24,k=A*7,R=A*30,b=A*365;function m(y,v,h,g){typeof y!="number"&&(y=y.getTime());const p=Math.round((new Date().getTime()-y)/1e3);if(p<-30)return(0,S.localize)(0,null,m(new Date().getTime()+p*1e3,!1));if(!g&&p<30)return(0,S.localize)(1,null);let r;return p<L?(r=p,v?r===1?h?(0,S.localize)(2,null,r):(0,S.localize)(3,null,r):h?(0,S.localize)(4,null,r):(0,S.localize)(5,null,r):r===1?h?(0,S.localize)(6,null,r):(0,S.localize)(7,null,r):h?(0,S.localize)(8,null,r):(0,S.localize)(9,null,r)):p<o?(r=Math.floor(p/L),v?r===1?h?(0,S.localize)(10,null,r):(0,S.localize)(11,null,r):h?(0,S.localize)(12,null,r):(0,S.localize)(13,null,r):r===1?h?(0,S.localize)(14,null,r):(0,S.localize)(15,null,r):h?(0,S.localize)(16,null,r):(0,S.localize)(17,null,r)):p<A?(r=Math.floor(p/o),v?r===1?h?(0,S.localize)(18,null,r):(0,S.localize)(19,null,r):h?(0,S.localize)(20,null,r):(0,S.localize)(21,null,r):r===1?h?(0,S.localize)(22,null,r):(0,S.localize)(23,null,r):h?(0,S.localize)(24,null,r):(0,S.localize)(25,null,r)):p<k?(r=Math.floor(p/A),v?r===1?(0,S.localize)(26,null,r):(0,S.localize)(27,null,r):r===1?(0,S.localize)(28,null,r):(0,S.localize)(29,null,r)):p<R?(r=Math.floor(p/k),v?r===1?h?(0,S.localize)(30,null,r):(0,S.localize)(31,null,r):h?(0,S.localize)(32,null,r):(0,S.localize)(33,null,r):r===1?h?(0,S.localize)(34,null,r):(0,S.localize)(35,null,r):h?(0,S.localize)(36,null,r):(0,S.localize)(37,null,r)):p<b?(r=Math.floor(p/R),v?r===1?h?(0,S.localize)(38,null,r):(0,S.localize)(39,null,r):h?(0,S.localize)(40,null,r):(0,S.localize)(41,null,r):r===1?h?(0,S.localize)(42,null,r):(0,S.localize)(43,null,r):h?(0,S.localize)(44,null,r):(0,S.localize)(45,null,r)):(r=Math.floor(p/b),v?r===1?h?(0,S.localize)(46,null,r):(0,S.localize)(47,null,r):h?(0,S.localize)(48,null,r):(0,S.localize)(49,null,r):r===1?h?(0,S.localize)(50,null,r):(0,S.localize)(51,null,r):h?(0,S.localize)(52,null,r):(0,S.localize)(53,null,r))}e.fromNow=m;function T(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(pe[152],be([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(pe[38],be([1,0,18,8,152]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(y,v){return v&&(y.stack||y.stacktrace)?o.localize(0,null,R(y),k(y.stack)||k(y.stacktrace)):R(y)}function k(y){return Array.isArray(y)?y.join(`
`):y}function R(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?o.localize(1,null,y.message):y.message||o.localize(2,null)}function b(y=null,v=!1){if(!y)return o.localize(3,null);if(Array.isArray(y)){const h=S.coalesce(y),g=b(h[0],v);return h.length>1?o.localize(4,null,g,h.length):g}if(L.isString(y))return y;if(y.detail){const h=y.detail;if(h.error)return A(h.error,v);if(h.exception)return A(h.exception,v)}return y.stack?A(y,v):y.message?y.message:o.localize(5,null)}e.toErrorMessage=b;function m(y){const v=y;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=m;function T(y,v){let h;return typeof y=="string"?h=new Error(y):h=y,h.actions=v,h}e.createErrorWithActions=T}),define(pe[153],be([9,10]),function(le,e){return le.create("vs/base/common/jsonErrorMessages",e)}),define(pe[154],be([1,0,153]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(o){switch(o){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(pe[155],be([9,10]),function(le,e){return le.create("vs/base/common/platform",e)}),define(pe[3],be([1,0,155]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,o=!1,A=!1,k=!1,R=!1,b=!1,m=!1,T=!1,y=!1,v=!1,h,g=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT,r,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?c=e.globals.vscode.process:typeof process<"u"&&(c=process);const u=typeof c?.versions?.electron=="string",D=u&&c?.type==="renderer";if(typeof navigator=="object"&&!D)f=navigator.userAgent,L=f.indexOf("Windows")>=0,o=f.indexOf("Macintosh")>=0,T=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=f.indexOf("Linux")>=0,v=f?.indexOf("Mobi")>=0,b=!0,h=S.getConfiguredDefaultLocale(S.localize(0,null))||e.LANGUAGE_DEFAULT,g=h,p=navigator.language;else if(typeof c=="object"){L=c.platform==="win32",o=c.platform==="darwin",A=c.platform==="linux",k=A&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,m=u,y=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.LANGUAGE_DEFAULT,g=e.LANGUAGE_DEFAULT;const I=c.env.VSCODE_NLS_CONFIG;if(I)try{const C=JSON.parse(I),E=C.availableLanguages["*"];h=C.locale,p=C.osLocale,g=E||e.LANGUAGE_DEFAULT,r=C._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var O;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(O||(e.Platform=O={}));function t(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let n=0;o?n=1:L?n=3:A&&(n=2),e.isWindows=L,e.isMacintosh=o,e.isLinux=A,e.isLinuxSnap=k,e.isNative=R,e.isElectron=m,e.isWeb=b,e.isWebWorker=b&&typeof e.globals.importScripts=="function",e.isIOS=T,e.isMobile=v,e.isCI=y,e.platform=n,e.userAgent=f,e.language=g;var s;(function(I){function C(){return e.language}I.value=C;function E(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}I.isDefaultVariant=E;function w(){return e.language==="en"}I.isDefault=w})(s||(e.Language=s={})),e.locale=h,e.platformLocale=p,e.translationsConfigFile=r,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const I=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let w=0,N=I.length;w<N;w++){const $=I[w];if($.id===E.data.vscodeScheduleAsyncWork){I.splice(w,1),$.callback();return}}});let C=0;return E=>{const w=++C;I.push({id:w,callback:E}),e.globals.postMessage({vscodeScheduleAsyncWork:w},"*")}}return I=>setTimeout(I)})();var i;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=o||T?2:L?1:3;let a=!0,l=!1;function d(){if(!l){l=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,a=new Uint16Array(I.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=d,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(pe[29],be([1,0,3]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof S.globals.vscode<"u"&&typeof S.globals.vscode.process<"u"){const o=S.globals.vscode.process;L={get platform(){return o.platform},get arch(){return o.arch},get env(){return o.env},cwd(){return o.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(pe[7],be([1,0,29]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,o=97,A=90,k=122,R=46,b=47,m=92,T=58,y=63;class v extends Error{constructor(n,s,i){let a;typeof s=="string"&&s.indexOf("not ")===0?(a="must not be",s=s.replace(/^not /,"")):a="must be";const l=n.indexOf(".")!==-1?"property":"argument";let d=`The "${n}" ${l} ${a} of type ${s}`;d+=`. Received type ${typeof i}`,super(d),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,n){if(t===null||typeof t!="object")throw new v(n,"Object",t)}function g(t,n){if(typeof t!="string")throw new v(n,"string",t)}const p=S.platform==="win32";function r(t){return t===b||t===m}function f(t){return t===b}function c(t){return t>=L&&t<=A||t>=o&&t<=k}function u(t,n,s,i){let a="",l=0,d=-1,I=0,C=0;for(let E=0;E<=t.length;++E){if(E<t.length)C=t.charCodeAt(E);else{if(i(C))break;C=b}if(i(C)){if(!(d===E-1||I===1))if(I===2){if(a.length<2||l!==2||a.charCodeAt(a.length-1)!==R||a.charCodeAt(a.length-2)!==R){if(a.length>2){const w=a.lastIndexOf(s);w===-1?(a="",l=0):(a=a.slice(0,w),l=a.length-1-a.lastIndexOf(s)),d=E,I=0;continue}else if(a.length!==0){a="",l=0,d=E,I=0;continue}}n&&(a+=a.length>0?`${s}..`:"..",l=2)}else a.length>0?a+=`${s}${t.slice(d+1,E)}`:a=t.slice(d+1,E),l=E-d-1;d=E,I=0}else C===R&&I!==-1?++I:I=-1}return a}function D(t,n){h(n,"pathObject");const s=n.dir||n.root,i=n.base||`${n.name||""}${n.ext||""}`;return s?s===n.root?`${s}${i}`:`${s}${t}${i}`:i}e.win32={resolve(...t){let n="",s="",i=!1;for(let a=t.length-1;a>=-1;a--){let l;if(a>=0){if(l=t[a],g(l,"path"),l.length===0)continue}else n.length===0?l=S.cwd():(l=S.env[`=${n}`]||S.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==n.toLowerCase()&&l.charCodeAt(2)===m)&&(l=`${n}\\`));const d=l.length;let I=0,C="",E=!1;const w=l.charCodeAt(0);if(d===1)r(w)&&(I=1,E=!0);else if(r(w))if(E=!0,r(l.charCodeAt(1))){let N=2,$=N;for(;N<d&&!r(l.charCodeAt(N));)N++;if(N<d&&N!==$){const se=l.slice($,N);for($=N;N<d&&r(l.charCodeAt(N));)N++;if(N<d&&N!==$){for($=N;N<d&&!r(l.charCodeAt(N));)N++;(N===d||N!==$)&&(C=`\\\\${se}\\${l.slice($,N)}`,I=N)}}}else I=1;else c(w)&&l.charCodeAt(1)===T&&(C=l.slice(0,2),I=2,d>2&&r(l.charCodeAt(2))&&(E=!0,I=3));if(C.length>0)if(n.length>0){if(C.toLowerCase()!==n.toLowerCase())continue}else n=C;if(i){if(n.length>0)break}else if(s=`${l.slice(I)}\\${s}`,i=E,E&&n.length>0)break}return s=u(s,!i,"\\",r),i?`${n}\\${s}`:`${n}${s}`||"."},normalize(t){g(t,"path");const n=t.length;if(n===0)return".";let s=0,i,a=!1;const l=t.charCodeAt(0);if(n===1)return f(l)?"\\":t;if(r(l))if(a=!0,r(t.charCodeAt(1))){let I=2,C=I;for(;I<n&&!r(t.charCodeAt(I));)I++;if(I<n&&I!==C){const E=t.slice(C,I);for(C=I;I<n&&r(t.charCodeAt(I));)I++;if(I<n&&I!==C){for(C=I;I<n&&!r(t.charCodeAt(I));)I++;if(I===n)return`\\\\${E}\\${t.slice(C)}\\`;I!==C&&(i=`\\\\${E}\\${t.slice(C,I)}`,s=I)}}}else s=1;else c(l)&&t.charCodeAt(1)===T&&(i=t.slice(0,2),s=2,n>2&&r(t.charCodeAt(2))&&(a=!0,s=3));let d=s<n?u(t.slice(s),!a,"\\",r):"";return d.length===0&&!a&&(d="."),d.length>0&&r(t.charCodeAt(n-1))&&(d+="\\"),i===void 0?a?`\\${d}`:d:a?`${i}\\${d}`:`${i}${d}`},isAbsolute(t){g(t,"path");const n=t.length;if(n===0)return!1;const s=t.charCodeAt(0);return r(s)||n>2&&c(s)&&t.charCodeAt(1)===T&&r(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,s;for(let l=0;l<t.length;++l){const d=t[l];g(d,"path"),d.length>0&&(n===void 0?n=s=d:n+=`\\${d}`)}if(n===void 0)return".";let i=!0,a=0;if(typeof s=="string"&&r(s.charCodeAt(0))){++a;const l=s.length;l>1&&r(s.charCodeAt(1))&&(++a,l>2&&(r(s.charCodeAt(2))?++a:i=!1))}if(i){for(;a<n.length&&r(n.charCodeAt(a));)a++;a>=2&&(n=`\\${n.slice(a)}`)}return e.win32.normalize(n)},relative(t,n){if(g(t,"from"),g(n,"to"),t===n)return"";const s=e.win32.resolve(t),i=e.win32.resolve(n);if(s===i||(t=s.toLowerCase(),n=i.toLowerCase(),t===n))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===m;)a++;let l=t.length;for(;l-1>a&&t.charCodeAt(l-1)===m;)l--;const d=l-a;let I=0;for(;I<n.length&&n.charCodeAt(I)===m;)I++;let C=n.length;for(;C-1>I&&n.charCodeAt(C-1)===m;)C--;const E=C-I,w=d<E?d:E;let N=-1,$=0;for(;$<w;$++){const he=t.charCodeAt(a+$);if(he!==n.charCodeAt(I+$))break;he===m&&(N=$)}if($!==w){if(N===-1)return i}else{if(E>w){if(n.charCodeAt(I+$)===m)return i.slice(I+$+1);if($===2)return i.slice(I+$)}d>w&&(t.charCodeAt(a+$)===m?N=$:$===2&&(N=3)),N===-1&&(N=0)}let se="";for($=a+N+1;$<=l;++$)($===l||t.charCodeAt($)===m)&&(se+=se.length===0?"..":"\\..");return I+=N,se.length>0?`${se}${i.slice(I,C)}`:(i.charCodeAt(I)===m&&++I,i.slice(I,C))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.win32.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===m){if(n.charCodeAt(1)===m){const s=n.charCodeAt(2);if(s!==y&&s!==R)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(c(n.charCodeAt(0))&&n.charCodeAt(1)===T&&n.charCodeAt(2)===m)return`\\\\?\\${n}`;return t},dirname(t){g(t,"path");const n=t.length;if(n===0)return".";let s=-1,i=0;const a=t.charCodeAt(0);if(n===1)return r(a)?t:".";if(r(a)){if(s=i=1,r(t.charCodeAt(1))){let I=2,C=I;for(;I<n&&!r(t.charCodeAt(I));)I++;if(I<n&&I!==C){for(C=I;I<n&&r(t.charCodeAt(I));)I++;if(I<n&&I!==C){for(C=I;I<n&&!r(t.charCodeAt(I));)I++;if(I===n)return t;I!==C&&(s=i=I+1)}}}}else c(a)&&t.charCodeAt(1)===T&&(s=n>2&&r(t.charCodeAt(2))?3:2,i=s);let l=-1,d=!0;for(let I=n-1;I>=i;--I)if(r(t.charCodeAt(I))){if(!d){l=I;break}}else d=!1;if(l===-1){if(s===-1)return".";l=s}return t.slice(0,l)},basename(t,n){n!==void 0&&g(n,"ext"),g(t,"path");let s=0,i=-1,a=!0,l;if(t.length>=2&&c(t.charCodeAt(0))&&t.charCodeAt(1)===T&&(s=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let d=n.length-1,I=-1;for(l=t.length-1;l>=s;--l){const C=t.charCodeAt(l);if(r(C)){if(!a){s=l+1;break}}else I===-1&&(a=!1,I=l+1),d>=0&&(C===n.charCodeAt(d)?--d===-1&&(i=l):(d=-1,i=I))}return s===i?i=I:i===-1&&(i=t.length),t.slice(s,i)}for(l=t.length-1;l>=s;--l)if(r(t.charCodeAt(l))){if(!a){s=l+1;break}}else i===-1&&(a=!1,i=l+1);return i===-1?"":t.slice(s,i)},extname(t){g(t,"path");let n=0,s=-1,i=0,a=-1,l=!0,d=0;t.length>=2&&t.charCodeAt(1)===T&&c(t.charCodeAt(0))&&(n=i=2);for(let I=t.length-1;I>=n;--I){const C=t.charCodeAt(I);if(r(C)){if(!l){i=I+1;break}continue}a===-1&&(l=!1,a=I+1),C===R?s===-1?s=I:d!==1&&(d=1):s!==-1&&(d=-1)}return s===-1||a===-1||d===0||d===1&&s===a-1&&s===i+1?"":t.slice(s,a)},format:D.bind(null,"\\"),parse(t){g(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const s=t.length;let i=0,a=t.charCodeAt(0);if(s===1)return r(a)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(r(a)){if(i=1,r(t.charCodeAt(1))){let N=2,$=N;for(;N<s&&!r(t.charCodeAt(N));)N++;if(N<s&&N!==$){for($=N;N<s&&r(t.charCodeAt(N));)N++;if(N<s&&N!==$){for($=N;N<s&&!r(t.charCodeAt(N));)N++;N===s?i=N:N!==$&&(i=N+1)}}}}else if(c(a)&&t.charCodeAt(1)===T){if(s<=2)return n.root=n.dir=t,n;if(i=2,r(t.charCodeAt(2))){if(s===3)return n.root=n.dir=t,n;i=3}}i>0&&(n.root=t.slice(0,i));let l=-1,d=i,I=-1,C=!0,E=t.length-1,w=0;for(;E>=i;--E){if(a=t.charCodeAt(E),r(a)){if(!C){d=E+1;break}continue}I===-1&&(C=!1,I=E+1),a===R?l===-1?l=E:w!==1&&(w=1):l!==-1&&(w=-1)}return I!==-1&&(l===-1||w===0||w===1&&l===I-1&&l===d+1?n.base=n.name=t.slice(d,I):(n.name=t.slice(d,l),n.base=t.slice(d,I),n.ext=t.slice(l,I))),d>0&&d!==i?n.dir=t.slice(0,d-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const O=(()=>{if(p){const t=/\\/g;return()=>{const n=S.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>S.cwd()})();e.posix={resolve(...t){let n="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const a=i>=0?t[i]:O();g(a,"path"),a.length!==0&&(n=`${a}/${n}`,s=a.charCodeAt(0)===b)}return n=u(n,!s,"/",f),s?`/${n}`:n.length>0?n:"."},normalize(t){if(g(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===b,s=t.charCodeAt(t.length-1)===b;return t=u(t,!n,"/",f),t.length===0?n?"/":s?"./":".":(s&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return g(t,"path"),t.length>0&&t.charCodeAt(0)===b},join(...t){if(t.length===0)return".";let n;for(let s=0;s<t.length;++s){const i=t[s];g(i,"path"),i.length>0&&(n===void 0?n=i:n+=`/${i}`)}return n===void 0?".":e.posix.normalize(n)},relative(t,n){if(g(t,"from"),g(n,"to"),t===n||(t=e.posix.resolve(t),n=e.posix.resolve(n),t===n))return"";const s=1,i=t.length,a=i-s,l=1,d=n.length-l,I=a<d?a:d;let C=-1,E=0;for(;E<I;E++){const N=t.charCodeAt(s+E);if(N!==n.charCodeAt(l+E))break;N===b&&(C=E)}if(E===I)if(d>I){if(n.charCodeAt(l+E)===b)return n.slice(l+E+1);if(E===0)return n.slice(l+E)}else a>I&&(t.charCodeAt(s+E)===b?C=E:E===0&&(C=0));let w="";for(E=s+C+1;E<=i;++E)(E===i||t.charCodeAt(E)===b)&&(w+=w.length===0?"..":"/..");return`${w}${n.slice(l+C)}`},toNamespacedPath(t){return t},dirname(t){if(g(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===b;let s=-1,i=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===b){if(!i){s=a;break}}else i=!1;return s===-1?n?"/":".":n&&s===1?"//":t.slice(0,s)},basename(t,n){n!==void 0&&g(n,"ext"),g(t,"path");let s=0,i=-1,a=!0,l;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let d=n.length-1,I=-1;for(l=t.length-1;l>=0;--l){const C=t.charCodeAt(l);if(C===b){if(!a){s=l+1;break}}else I===-1&&(a=!1,I=l+1),d>=0&&(C===n.charCodeAt(d)?--d===-1&&(i=l):(d=-1,i=I))}return s===i?i=I:i===-1&&(i=t.length),t.slice(s,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===b){if(!a){s=l+1;break}}else i===-1&&(a=!1,i=l+1);return i===-1?"":t.slice(s,i)},extname(t){g(t,"path");let n=-1,s=0,i=-1,a=!0,l=0;for(let d=t.length-1;d>=0;--d){const I=t.charCodeAt(d);if(I===b){if(!a){s=d+1;break}continue}i===-1&&(a=!1,i=d+1),I===R?n===-1?n=d:l!==1&&(l=1):n!==-1&&(l=-1)}return n===-1||i===-1||l===0||l===1&&n===i-1&&n===s+1?"":t.slice(n,i)},format:D.bind(null,"/"),parse(t){g(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const s=t.charCodeAt(0)===b;let i;s?(n.root="/",i=1):i=0;let a=-1,l=0,d=-1,I=!0,C=t.length-1,E=0;for(;C>=i;--C){const w=t.charCodeAt(C);if(w===b){if(!I){l=C+1;break}continue}d===-1&&(I=!1,d=C+1),w===R?a===-1?a=C:E!==1&&(E=1):a!==-1&&(E=-1)}if(d!==-1){const w=l===0&&s?1:l;a===-1||E===0||E===1&&a===d-1&&a===l+1?n.base=n.name=t.slice(w,d):(n.name=t.slice(w,a),n.base=t.slice(w,d),n.ext=t.slice(a,d))}return l>0?n.dir=t.slice(0,l-1):s&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(pe[58],be([1,0,7]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(T){const y=(0,S.extname)(T),v=L[y.toLowerCase()];return v!==void 0?v:k(T)}e.getMediaOrTextMime=A;function k(T){const y=(0,S.extname)(T);return o[y.toLowerCase()]}e.getMediaMime=k;function R(T){for(const y in o)if(o[y]===T)return y}e.getExtensionForMimeType=R;const b=/^(.+)\/(.+?)(;.+)?$/;function m(T,y){const v=b.exec(T);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:y?void 0:T}e.normalizeMimeType=m}),define(pe[59],be([1,0,3]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(L||(e.Source=L={}));var o;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(o||(e.TerminateResponseCode=o={}));function A(R,...b){const m=b.reduce((v,h)=>(v[h]=!0,v),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(v=>!m[v]).forEach(v=>{for(let h=0;h<T.length;h++)if(v.search(T[h])!==-1){delete R[v];break}})}e.sanitizeProcessEnvironment=A;function k(R){R&&(delete R.DEBUG,S.isMacintosh&&delete R.DYLD_LIBRARY_PATH,S.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),define(pe[98],be([1,0,3]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=S.globals.performance&&typeof S.globals.performance.now=="function";class o{static create(k=!0){return new o(k)}constructor(k){this.a=L&&k,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?S.globals.performance.now():Date.now()}}e.StopWatch=o}),define(pe[6],be([1,0,11,71,2,94,98]),function(le,e,S,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,b=!1;var m;(function(l){l.None=()=>o.Disposable.None;function d(K){if(b){const{onDidAddListener:te}=K,z=g.create();let W=0;K.onDidAddListener=()=>{++W===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),z.print()),te?.()}}}function I(K,te){return ue(K,()=>{},0,void 0,!0,void 0,te)}l.defer=I;function C(K){return(te,z=null,W)=>{let q=!1,H;return H=K(Q=>{if(!q)return H?H.dispose():q=!0,te.call(z,Q)},null,W),q&&H.dispose(),H}}l.once=C;function E(K,te,z){return ae((W,q=null,H)=>K(Q=>W.call(q,te(Q)),null,H),z)}l.map=E;function w(K,te,z){return ae((W,q=null,H)=>K(Q=>{te(Q),W.call(q,Q)},null,H),z)}l.forEach=w;function N(K,te,z){return ae((W,q=null,H)=>K(Q=>te(Q)&&W.call(q,Q),null,H),z)}l.filter=N;function $(K){return K}l.signal=$;function se(...K){return(te,z=null,W)=>(0,o.combinedDisposable)(...K.map(q=>q(H=>te.call(z,H),null,W)))}l.any=se;function he(K,te,z,W){let q=z;return E(K,H=>(q=te(q,H),q),W)}l.reduce=he;function ae(K,te){let z;const W={onWillAddFirstListener(){z=K(q.fire,q)},onDidRemoveLastListener(){z?.dispose()}};te||d(W);const q=new r(W);return te?.add(q),q.event}function ue(K,te,z=100,W=!1,q=!1,H,Q){let G,Z,ce,Ee=0,De;const ke={leakWarningThreshold:H,onWillAddFirstListener(){G=K(ze=>{Ee++,Z=te(Z,ze),W&&!ce&&(Fe.fire(Z),Z=void 0),De=()=>{const me=Z;Z=void 0,ce=void 0,(!W||Ee>1)&&Fe.fire(me),Ee=0},typeof z=="number"?(clearTimeout(ce),ce=setTimeout(De,z)):ce===void 0&&(ce=0,queueMicrotask(De))})},onWillRemoveListener(){q&&Ee>0&&De?.()},onDidRemoveLastListener(){De=void 0,G.dispose()}};Q||d(ke);const Fe=new r(ke);return Q?.add(Fe),Fe.event}l.debounce=ue;function ge(K,te=0,z){return l.debounce(K,(W,q)=>W?(W.push(q),W):[q],te,void 0,!0,void 0,z)}l.accumulate=ge;function _(K,te=(W,q)=>W===q,z){let W=!0,q;return N(K,H=>{const Q=W||!te(H,q);return W=!1,q=H,Q},z)}l.latch=_;function ie(K,te,z){return[l.filter(K,te,z),l.filter(K,W=>!te(W),z)]}l.split=ie;function V(K,te=!1,z=[]){let W=z.slice(),q=K(G=>{W?W.push(G):Q.fire(G)});const H=()=>{W?.forEach(G=>Q.fire(G)),W=null},Q=new r({onWillAddFirstListener(){q||(q=K(G=>Q.fire(G)))},onDidAddFirstListener(){W&&(te?setTimeout(H):H())},onDidRemoveLastListener(){q&&q.dispose(),q=null}});return Q.event}l.buffer=V;class J{constructor(te){this.event=te,this.c=new o.DisposableStore}map(te){return new J(E(this.event,te,this.c))}forEach(te){return new J(w(this.event,te,this.c))}filter(te){return new J(N(this.event,te,this.c))}reduce(te,z){return new J(he(this.event,te,z,this.c))}latch(){return new J(_(this.event,void 0,this.c))}debounce(te,z=100,W=!1,q=!1,H){return new J(ue(this.event,te,z,W,q,H,this.c))}on(te,z,W){return this.event(te,z,W)}once(te,z,W){return C(this.event)(te,z,W)}dispose(){this.c.dispose()}}function U(K){return new J(K)}l.chain=U;function ne(K,te,z=W=>W){const W=(...G)=>Q.fire(z(...G)),q=()=>K.on(te,W),H=()=>K.removeListener(te,W),Q=new r({onWillAddFirstListener:q,onDidRemoveLastListener:H});return Q.event}l.fromNodeEventEmitter=ne;function x(K,te,z=W=>W){const W=(...G)=>Q.fire(z(...G)),q=()=>K.addEventListener(te,W),H=()=>K.removeEventListener(te,W),Q=new r({onWillAddFirstListener:q,onDidRemoveLastListener:H});return Q.event}l.fromDOMEventEmitter=x;function re(K){return new Promise(te=>C(K)(te))}l.toPromise=re;function Y(K,te){return te(void 0),K(z=>te(z))}l.runAndSubscribe=Y;function ee(K,te){let z=null;function W(H){z?.dispose(),z=new o.DisposableStore,te(H,z)}W(void 0);const q=K(H=>W(H));return(0,o.toDisposable)(()=>{q.dispose(),z?.dispose()})}l.runAndSubscribeWithStore=ee;class j{constructor(te,z){this._observable=te,this.c=0,this.d=!1;const W={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};z||d(W),this.emitter=new r(W),z&&z.add(this.emitter)}beginUpdate(te){this.c++}handlePossibleChange(te){}handleChange(te,z){this.d=!0}endUpdate(te){this.c--,this.c===0&&(this._observable.reportChanges(),this.d&&(this.d=!1,this.emitter.fire(this._observable.get())))}}function P(K,te){return new j(K,te).emitter.event}l.fromObservable=P;function M(K){return te=>{let z=0,W=!1;const q={beginUpdate(){z++},endUpdate(){z--,z===0&&(K.reportChanges(),W&&(W=!1,te()))},handlePossibleChange(){},handleChange(){W=!0}};return K.addObserver(q),{dispose(){K.removeObserver(q)}}}}l.fromObservableLight=M})(m||(e.Event=m={}));class T{constructor(d){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${d}_${T.c++}`,T.all.add(this)}start(d){this.d=new k.StopWatch(!0),this.listenerCount=d}stop(){if(this.d){const d=this.d.elapsed();this.durations.push(d),this.elapsedOverall+=d,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=T,T.all=new Set,T.c=0;let y=-1;function v(l){const d=y;return y=l,{dispose(){y=d}}}e.setGlobalLeakWarningThreshold=v;class h{constructor(d,I=Math.random().toString(18).slice(2,5)){this.threshold=d,this.name=I,this.d=0}dispose(){this.c?.clear()}check(d,I){const C=this.threshold;if(C<=0||I<C)return;this.c||(this.c=new Map);const E=this.c.get(d.value)||0;if(this.c.set(d.value,E+1),this.d-=1,this.d<=0){this.d=C*.5;let w,N=0;for(const[$,se]of this.c)(!w||N<se)&&(w=$,N=se);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${N}):`),console.warn(w)}return()=>{const w=this.c.get(d.value)||0;this.c.set(d.value,w-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(d){this.value=d}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(d,I,C){this.callback=d,this.callbackThis=I,this.stack=C,this.subscription=new o.SafeDisposable}invoke(d){this.callback.call(this.callbackThis,d)}}class r{constructor(d){this.j=!1,this.d=d,this.f=y>0||this.d?.leakWarningThreshold?new h(this.d?.leakWarningThreshold??y):void 0,this.g=this.d?._profName?new T(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(R){const d=Array.from(this.q);queueMicrotask(()=>{for(const I of d)I.subscription.isset()&&(I.subscription.unset(),I.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(d,I,C)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),o.Disposable.None;const E=this.q.isEmpty();E&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let w,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=g.create(),w=this.f.check(N,this.q.size+1)),R&&(N=N??g.create());const $=new p(d,I,N),se=this.q.push($);E&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,d,I);const he=$.subscription.set(()=>{w?.(),this.j||(this.d?.onWillRemoveListener?.(this),se(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return C instanceof o.DisposableStore?C.add(he):Array.isArray(C)&&C.push(he),he}),this.l}fire(d){if(this.q){this.m||(this.m=new c(this.d?.onListenerError));for(const I of this.q)this.m.push(this,I,d);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=r;class f{constructor(d=S.onUnexpectedError){this.d=d,this.c=new A.LinkedList}get size(){return this.c.size}push(d,I,C){this.c.push(new u(d,I,C))}clear(d){const I=new A.LinkedList;for(const C of this.c)C.emitter!==d&&I.push(C);this.c=I}deliver(){for(;this.c.size>0;){const d=this.c.shift();try{d.listener.invoke(d.event)}catch(I){this.d(I)}}}}e.EventDeliveryQueue=f;class c extends f{clear(d){this.c.clear()}}class u{constructor(d,I,C){this.emitter=d,this.listener=I,this.event=C}}class D extends r{async fireAsync(d,I,C){if(this.q){this.c||(this.c=new A.LinkedList);for(const E of this.q)this.c.push([E,d]);for(;this.c.size>0&&!I.isCancellationRequested;){const[E,w]=this.c.shift(),N=[],$={...w,token:I,waitUntil:se=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");C&&(se=C(se,E.callback)),N.push(se)}};try{E.invoke($)}catch(se){(0,S.onUnexpectedError)(se);continue}Object.freeze(N),await Promise.allSettled(N).then(se=>{for(const he of se)he.status==="rejected"&&(0,S.onUnexpectedError)(he.reason)})}}}}e.AsyncEmitter=D;class O extends r{get isPaused(){return this.h!==0}constructor(d){super(d),this.h=0,this.s=new A.LinkedList,this.t=d?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const d=Array.from(this.s);this.s.clear(),super.fire(this.t(d))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(d){this.q&&(this.h!==0?this.s.push(d):super.fire(d))}}e.PauseableEmitter=O;class t extends O{constructor(d){super(d),this.c=d.delay??100}fire(d){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(d)}}e.DebounceEmitter=t;class n extends r{constructor(d){super(d),this.c=[],this.h=d?.merge}fire(d){this.hasListeners()&&(this.c.push(d),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(I=>super.fire(I)),this.c=[]}))}}e.MicrotaskEmitter=n;class s{constructor(){this.d=!1,this.f=[],this.c=new r({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(d){const I={event:d,listener:null};this.f.push(I),this.d&&this.j(I);const C=()=>{this.d&&this.k(I);const E=this.f.indexOf(I);this.f.splice(E,1)};return(0,o.toDisposable)((0,L.once)(C))}g(){this.d=!0,this.f.forEach(d=>this.j(d))}h(){this.d=!1,this.f.forEach(d=>this.k(d))}j(d){d.listener=d.event(I=>this.c.fire(I))}k(d){d.listener&&d.listener.dispose(),d.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=s;class i{constructor(){this.c=[]}wrapEvent(d){return(I,C,E)=>d(w=>{const N=this.c[this.c.length-1];N?N.push(()=>I.call(C,w)):I.call(C,w)},void 0,E)}bufferEvents(d){const I=[];this.c.push(I);const C=d();return this.c.pop(),I.forEach(E=>E()),C}}e.EventBufferer=i;class a{constructor(){this.c=!1,this.d=m.None,this.f=o.Disposable.None,this.g=new r({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(d){this.d=d,this.c&&(this.f.dispose(),this.f=d(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=a}),define(pe[156],be([1,0,6,2,149]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class A extends L.Disposable{constructor(v,h="",g="",p=!0,r){super(),this.h=this.B(new S.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=h,this.u=g,this.w=p,this.C=r}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,h){this.C&&await this.C(v)}}e.Action=A;class k extends L.Disposable{constructor(){super(...arguments),this.f=this.B(new S.Emitter),this.onWillRun=this.f.event,this.h=this.B(new S.Emitter),this.onDidRun=this.h.event}async run(v,h){if(!v.enabled)return;this.f.fire({action:v});let g;try{await this.k(v,h)}catch(p){g=p}this.h.fire({action:v,error:g})}async k(v,h){await v.run(h)}}e.ActionRunner=k;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let h=[];for(const g of v)g.length&&(h.length?h=[...h,new R,...g]:h=g);return h}async run(){}}e.Separator=R,R.ID="vs.actions.separator";class b{get actions(){return this.a}constructor(v,h,g,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=h,this.class=p,this.a=g}async run(){}}e.SubmenuAction=b;class m extends A{constructor(){super(m.ID,o.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=m,m.ID="vs.actions.empty";function T(y){return{id:y.id,label:y.label,class:void 0,enabled:y.enabled??!0,checked:y.checked??!1,run:async()=>y.run(),tooltip:y.label}}e.toAction=T}),define(pe[20],be([1,0,6]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(R,b){const m=setTimeout(R.bind(b),0);return{dispose(){clearTimeout(m)}}});var o;(function(R){function b(m){return m===R.None||m===R.Cancelled||m instanceof A?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}R.isCancellationToken=b,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(o||(e.CancellationToken=o={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new S.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class k{constructor(b){this.a=void 0,this.b=void 0,this.b=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=o.Cancelled}dispose(b=!1){b&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=o.None}}e.CancellationTokenSource=k}),define(pe[157],be([1,0,20]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new S.CancellationTokenSource,b=this.b(R.token);return this.a={promise:b,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.Cache=L;class o{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const b=JSON.stringify(R);return this.b!==b&&(this.b=b,this.a=this.c(R)),this.a}}e.LRUCachedFunction=o;class A{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const b=this.b(R);return this.a.set(R,b),b}}e.CachedFunction=A}),define(pe[17],be([1,0,157,93]),function(le,e,S,L){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(fe){return!fe||typeof fe!="string"?!0:fe.trim().length===0}e.isFalsyOrWhitespace=A;const k=/{(\d+)}/g;function R(fe,...Ce){return Ce.length===0?fe:fe.replace(k,function(Te,Re){const Oe=parseInt(Re,10);return isNaN(Oe)||Oe<0||Oe>=Ce.length?Te:Ce[Oe]})}e.format=R;const b=/{([^}]+)}/g;function m(fe,Ce){return fe.replace(b,(Te,Re)=>Ce[Re]??Te)}e.format2=m;function T(fe){return fe.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=T;function y(fe){return fe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function v(fe,Ce){let Te=0;const Re=Ce.charCodeAt(0);for(let Oe=fe.length-1;Oe>=0;Oe--)fe.charCodeAt(Oe)===Re&&Te++;return Te}e.count=v;function h(fe,Ce,Te="\u2026"){return fe.length<=Ce?fe:`${fe.substr(0,Ce)}${Te}`}e.truncate=h;function g(fe,Ce=" "){const Te=p(fe,Ce);return r(Te,Ce)}e.trim=g;function p(fe,Ce){if(!fe||!Ce)return fe;const Te=Ce.length;if(Te===0||fe.length===0)return fe;let Re=0;for(;fe.indexOf(Ce,Re)===Re;)Re=Re+Te;return fe.substring(Re)}e.ltrim=p;function r(fe,Ce){if(!fe||!Ce)return fe;const Te=Ce.length,Re=fe.length;if(Te===0||Re===0)return fe;let Oe=Re,$e=-1;for(;$e=fe.lastIndexOf(Ce,Oe-1),!($e===-1||$e+Te!==Oe);){if($e===0)return"";Oe=$e}return fe.substring(0,Oe)}e.rtrim=r;function f(fe){return fe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function c(fe){return fe.replace(/\*/g,"")}e.stripWildcards=c;function u(fe,Ce,Te={}){if(!fe)throw new Error("Cannot create regex from empty string");Ce||(fe=y(fe)),Te.wholeWord&&(/\B/.test(fe.charAt(0))||(fe="\\b"+fe),/\B/.test(fe.charAt(fe.length-1))||(fe=fe+"\\b"));let Re="";return Te.global&&(Re+="g"),Te.matchCase||(Re+="i"),Te.multiline&&(Re+="m"),Te.unicode&&(Re+="u"),new RegExp(fe,Re)}e.createRegExp=u;function D(fe){return fe.source==="^"||fe.source==="^$"||fe.source==="$"||fe.source==="^\\s*$"?!1:!!(fe.exec("")&&fe.lastIndex===0)}e.regExpLeadsToEndlessLoop=D;function O(fe){return!!fe.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=O;function t(fe){return(fe.global?"g":"")+(fe.ignoreCase?"i":"")+(fe.multiline?"m":"")+(fe.unicode?"u":"")}e.regExpFlags=t;function n(fe){return fe.split(/\r\n|\r|\n/)}e.splitLines=n;function s(fe){for(let Ce=0,Te=fe.length;Ce<Te;Ce++){const Re=fe.charCodeAt(Ce);if(Re!==32&&Re!==9)return Ce}return-1}e.firstNonWhitespaceIndex=s;function i(fe,Ce=0,Te=fe.length){for(let Re=Ce;Re<Te;Re++){const Oe=fe.charCodeAt(Re);if(Oe!==32&&Oe!==9)return fe.substring(Ce,Re)}return fe.substring(Ce,Te)}e.getLeadingWhitespace=i;function a(fe,Ce=fe.length-1){for(let Te=Ce;Te>=0;Te--){const Re=fe.charCodeAt(Te);if(Re!==32&&Re!==9)return Te}return-1}e.lastNonWhitespaceIndex=a;function l(fe,Ce,Te){const Re=[];let Oe=0;for(const $e of fe.matchAll(Ce)){if(Re.push(fe.slice(Oe,$e.index)),$e.index===void 0)throw new Error("match.index should be defined");Oe=$e.index+$e[0].length,Re.push(Te($e[0],...$e.slice(1),$e.index,fe,$e.groups))}return Re.push(fe.slice(Oe)),Promise.all(Re).then($e=>$e.join(""))}e.replaceAsync=l;function d(fe,Ce){return fe<Ce?-1:fe>Ce?1:0}e.compare=d;function I(fe,Ce,Te=0,Re=fe.length,Oe=0,$e=Ce.length){for(;Te<Re&&Oe<$e;Te++,Oe++){const tt=fe.charCodeAt(Te),Je=Ce.charCodeAt(Oe);if(tt<Je)return-1;if(tt>Je)return 1}const Ge=Re-Te,qe=$e-Oe;return Ge<qe?-1:Ge>qe?1:0}e.compareSubstring=I;function C(fe,Ce){return E(fe,Ce,0,fe.length,0,Ce.length)}e.compareIgnoreCase=C;function E(fe,Ce,Te=0,Re=fe.length,Oe=0,$e=Ce.length){for(;Te<Re&&Oe<$e;Te++,Oe++){let tt=fe.charCodeAt(Te),Je=Ce.charCodeAt(Oe);if(tt===Je)continue;if(tt>=128||Je>=128)return I(fe.toLowerCase(),Ce.toLowerCase(),Te,Re,Oe,$e);N(tt)&&(tt-=32),N(Je)&&(Je-=32);const Ye=tt-Je;if(Ye!==0)return Ye}const Ge=Re-Te,qe=$e-Oe;return Ge<qe?-1:Ge>qe?1:0}e.compareSubstringIgnoreCase=E;function w(fe){return fe>=48&&fe<=57}e.isAsciiDigit=w;function N(fe){return fe>=97&&fe<=122}e.isLowerAsciiLetter=N;function $(fe){return fe>=65&&fe<=90}e.isUpperAsciiLetter=$;function se(fe,Ce){return fe.length===Ce.length&&E(fe,Ce)===0}e.equalsIgnoreCase=se;function he(fe,Ce){const Te=Ce.length;return Ce.length>fe.length?!1:E(fe,Ce,0,Te)===0}e.startsWithIgnoreCase=he;function ae(fe,Ce){const Te=Math.min(fe.length,Ce.length);let Re;for(Re=0;Re<Te;Re++)if(fe.charCodeAt(Re)!==Ce.charCodeAt(Re))return Re;return Te}e.commonPrefixLength=ae;function ue(fe,Ce){const Te=Math.min(fe.length,Ce.length);let Re;const Oe=fe.length-1,$e=Ce.length-1;for(Re=0;Re<Te;Re++)if(fe.charCodeAt(Oe-Re)!==Ce.charCodeAt($e-Re))return Re;return Te}e.commonSuffixLength=ue;function ge(fe){return 55296<=fe&&fe<=56319}e.isHighSurrogate=ge;function _(fe){return 56320<=fe&&fe<=57343}e.isLowSurrogate=_;function ie(fe,Ce){return(fe-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=ie;function V(fe,Ce,Te){const Re=fe.charCodeAt(Te);if(ge(Re)&&Te+1<Ce){const Oe=fe.charCodeAt(Te+1);if(_(Oe))return ie(Re,Oe)}return Re}e.getNextCodePoint=V;function J(fe,Ce){const Te=fe.charCodeAt(Ce-1);if(_(Te)&&Ce>1){const Re=fe.charCodeAt(Ce-2);if(ge(Re))return ie(Re,Te)}return Te}class U{get offset(){return this.e}constructor(Ce,Te=0){this.c=Ce,this.d=Ce.length,this.e=Te}setOffset(Ce){this.e=Ce}prevCodePoint(){const Ce=J(this.c,this.e);return this.e-=Ce>=65536?2:1,Ce}nextCodePoint(){const Ce=V(this.c,this.d,this.e);return this.e+=Ce>=65536?2:1,Ce}eol(){return this.e>=this.d}}e.CodePointIterator=U;class ne{get offset(){return this.c.offset}constructor(Ce,Te=0){this.c=new U(Ce,Te)}nextGraphemeLength(){const Ce=Be.getInstance(),Te=this.c,Re=Te.offset;let Oe=Ce.getGraphemeBreakType(Te.nextCodePoint());for(;!Te.eol();){const $e=Te.offset,Ge=Ce.getGraphemeBreakType(Te.nextCodePoint());if(we(Oe,Ge)){Te.setOffset($e);break}Oe=Ge}return Te.offset-Re}prevGraphemeLength(){const Ce=Be.getInstance(),Te=this.c,Re=Te.offset;let Oe=Ce.getGraphemeBreakType(Te.prevCodePoint());for(;Te.offset>0;){const $e=Te.offset,Ge=Ce.getGraphemeBreakType(Te.prevCodePoint());if(we(Ge,Oe)){Te.setOffset($e);break}Oe=Ge}return Re-Te.offset}eol(){return this.c.eol()}}e.GraphemeIterator=ne;function x(fe,Ce){return new ne(fe,Ce).nextGraphemeLength()}e.nextCharLength=x;function re(fe,Ce){return new ne(fe,Ce).prevGraphemeLength()}e.prevCharLength=re;function Y(fe,Ce){Ce>0&&_(fe.charCodeAt(Ce))&&Ce--;const Te=Ce+x(fe,Ce);return[Te-re(fe,Te),Te]}e.getCharContainingOffset=Y;function ee(fe){const Ce=new ne(fe);let Te=0;for(;!Ce.eol();)Te++,Ce.nextGraphemeLength();return Te}e.charCount=ee;let j;function P(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function M(fe){return j||(j=P()),j.test(fe)}e.containsRTL=M;const K=/^[\t\n\r\x20-\x7E]*$/;function te(fe){return K.test(fe)}e.isBasicASCII=te,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(fe){return e.UNUSUAL_LINE_TERMINATORS.test(fe)}e.containsUnusualLineTerminators=z;function W(fe){return fe>=11904&&fe<=55215||fe>=63744&&fe<=64255||fe>=65281&&fe<=65374}e.isFullWidthCharacter=W;function q(fe){return fe>=127462&&fe<=127487||fe===8986||fe===8987||fe===9200||fe===9203||fe>=9728&&fe<=10175||fe===11088||fe===11093||fe>=127744&&fe<=128591||fe>=128640&&fe<=128764||fe>=128992&&fe<=129008||fe>=129280&&fe<=129535||fe>=129648&&fe<=129782}e.isEmojiImprecise=q;function H(fe,Ce){if(fe.length<Ce)return fe;const Te=/\b/g;let Re=0;for(;Te.test(fe)&&!(fe.length-Te.lastIndex<Ce);)Re=Te.lastIndex,Te.lastIndex+=1;return fe.substring(Re).replace(/^\s/,"")}e.lcut=H;const Q=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,G=/\x1b\].*?\x07/g;function Z(fe){return fe&&(fe=fe.replace(Q,"").replace(G,"")),fe}e.removeAnsiEscapeCodes=Z,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(fe){return!!(fe&&fe.length>0&&fe.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function Ee(fe){return ce(fe)?fe.substr(1):fe}e.stripUTF8BOM=Ee;function De(fe,Ce){if(!fe||!Ce||fe.length<Ce.length)return!1;const Te=Ce.length,Re=fe.toLowerCase();let Oe=0,$e=-1;for(;Oe<Te;){const Ge=Re.indexOf(Ce[Oe],$e+1);if(Ge<0)return!1;$e=Ge,Oe++}return!0}e.fuzzyContains=De;function ke(fe,Ce=!1){return fe?(Ce&&(fe=fe.replace(/\\./g,"")),fe.toLowerCase()!==fe):!1}e.containsUppercaseCharacter=ke;function Fe(fe){return fe.charAt(0).toUpperCase()+fe.slice(1)}e.uppercaseFirstLetter=Fe;function ze(fe,Ce=1){if(Ce===0)return"";let Te=-1;do Te=fe.indexOf(`
`,Te+1),Ce--;while(Ce>0&&Te>=0);return Te===-1?fe:(fe[Te-1]==="\r"&&Te--,fe.substr(0,Te))}e.getNLines=ze;function me(fe){return fe=fe%(2*26),fe<26?String.fromCharCode(97+fe):String.fromCharCode(65+fe-26)}e.singleLetterHash=me;function Se(fe){return Be.getInstance().getGraphemeBreakType(fe)}e.getGraphemeBreakType=Se;function we(fe,Ce){return fe===0?Ce!==5&&Ce!==7:fe===2&&Ce===3?!1:fe===4||fe===2||fe===3||Ce===4||Ce===2||Ce===3?!0:!(fe===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(fe===11||fe===9)&&(Ce===9||Ce===10)||(fe===12||fe===10)&&Ce===10||Ce===5||Ce===13||Ce===7||fe===1||fe===13&&Ce===14||fe===6&&Ce===6)}var Ue;(function(fe){fe[fe.Other=0]="Other",fe[fe.Prepend=1]="Prepend",fe[fe.CR=2]="CR",fe[fe.LF=3]="LF",fe[fe.Control=4]="Control",fe[fe.Extend=5]="Extend",fe[fe.Regional_Indicator=6]="Regional_Indicator",fe[fe.SpacingMark=7]="SpacingMark",fe[fe.L=8]="L",fe[fe.V=9]="V",fe[fe.T=10]="T",fe[fe.LV=11]="LV",fe[fe.LVT=12]="LVT",fe[fe.ZWJ=13]="ZWJ",fe[fe.Extended_Pictographic=14]="Extended_Pictographic"})(Ue||(e.GraphemeBreakType=Ue={}));class Be{static getInstance(){return Be.c||(Be.c=new Be),Be.c}constructor(){this.d=et()}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const Te=this.d,Re=Te.length/3;let Oe=1;for(;Oe<=Re;)if(Ce<Te[3*Oe])Oe=2*Oe;else if(Ce>Te[3*Oe+1])Oe=2*Oe+1;else return Te[3*Oe+2];return 0}}Be.c=null;function et(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(fe,Ce){if(fe===0)return 0;const Te=Ve(fe,Ce);if(Te!==void 0)return Te;const Re=new U(Ce,fe);return Re.prevCodePoint(),Re.offset}e.getLeftDeleteOffset=He;function Ve(fe,Ce){const Te=new U(Ce,fe);let Re=Te.prevCodePoint();for(;Ze(Re)||Re===65039||Re===8419;){if(Te.offset===0)return;Re=Te.prevCodePoint()}if(!q(Re))return;let Oe=Te.offset;return Oe>0&&Te.prevCodePoint()===8205&&(Oe=Te.offset),Oe}function Ze(fe){return 127995<=fe&&fe<=127999}var it;(function(fe){fe[fe.zwj=8205]="zwj",fe[fe.emojiVariantSelector=65039]="emojiVariantSelector",fe[fe.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),e.noBreakWhitespace="\xA0";class Ke{static getInstance(Ce){return Ke.d.get(Array.from(Ce))}static getLocales(){return Ke.e.value}constructor(Ce){this.f=Ce}isAmbiguous(Ce){return this.f.has(Ce)}getPrimaryConfusable(Ce){return this.f.get(Ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=Ke,o=Ke,Ke.c=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ke.d=new S.LRUCachedFunction(fe=>{function Ce(Je){const Ye=new Map;for(let at=0;at<Je.length;at+=2)Ye.set(Je[at],Je[at+1]);return Ye}function Te(Je,Ye){const at=new Map(Je);for(const[gt,st]of Ye)at.set(gt,st);return at}function Re(Je,Ye){if(!Je)return Ye;const at=new Map;for(const[gt,st]of Je)Ye.has(gt)&&at.set(gt,st);return at}const Oe=o.c.value;let $e=fe.filter(Je=>!Je.startsWith("_")&&Je in Oe);$e.length===0&&($e=["_default"]);let Ge;for(const Je of $e){const Ye=Ce(Oe[Je]);Ge=Re(Ge,Ye)}const qe=Ce(Oe._common),tt=Te(qe,Ge);return new Ke(tt)}),Ke.e=new L.Lazy(()=>Object.keys(Ke.c.value).filter(fe=>!fe.startsWith("_")));class Xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Xe.c())),this.d}static isInvisibleCharacter(Ce){return Xe.e().has(Ce)}static get codePoints(){return Xe.e()}}e.InvisibleCharacters=Xe,Xe.d=void 0}),define(pe[39],be([1,0,7,3,17,8]),function(le,e,S,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(l){return l===47||l===92}e.isPathSeparator=k;function R(l){return l.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=R;function b(l){return l.indexOf("/")===-1&&(l=R(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=b;function m(l,d=S.posix.sep){if(!l)return"";const I=l.length,C=l.charCodeAt(0);if(k(C)){if(k(l.charCodeAt(1))&&!k(l.charCodeAt(2))){let w=3;const N=w;for(;w<I&&!k(l.charCodeAt(w));w++);if(N!==w&&!k(l.charCodeAt(w+1))){for(w+=1;w<I;w++)if(k(l.charCodeAt(w)))return l.slice(0,w+1).replace(/[\\/]/g,d)}}return d}else if(f(C)&&l.charCodeAt(1)===58)return k(l.charCodeAt(2))?l.slice(0,2)+d:l.slice(0,2);let E=l.indexOf("://");if(E!==-1){for(E+=3;E<I;E++)if(k(l.charCodeAt(E)))return l.slice(0,E+1)}return""}e.getRoot=m;function T(l){if(!L.isWindows||!l||l.length<5)return!1;let d=l.charCodeAt(0);if(d!==92||(d=l.charCodeAt(1),d!==92))return!1;let I=2;const C=I;for(;I<l.length&&(d=l.charCodeAt(I),d!==92);I++);return!(C===I||(d=l.charCodeAt(I+1),isNaN(d)||d===92))}e.isUNC=T;const y=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(l,d=L.isWindows){const I=d?y:v;return!(!l||l.length===0||/^\s+$/.test(l)||(I.lastIndex=0,I.test(l))||d&&h.test(l)||l==="."||l===".."||d&&l[l.length-1]==="."||d&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=g;function p(l,d,I){const C=l===d;return!I||C?C:!l||!d?!1:(0,o.equalsIgnoreCase)(l,d)}e.isEqual=p;function r(l,d,I,C=S.sep){if(l===d)return!0;if(!l||!d||d.length>l.length)return!1;if(I){if(!(0,o.startsWithIgnoreCase)(l,d))return!1;if(d.length===l.length)return!0;let w=d.length;return d.charAt(d.length-1)===C&&w--,l.charAt(w)===C}return d.charAt(d.length-1)!==C&&(d+=C),l.indexOf(d)===0}e.isEqualOrParent=r;function f(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=f;function c(l,d){return L.isWindows&&l.endsWith(":")&&(l+=S.sep),(0,S.isAbsolute)(l)||(l=(0,S.join)(d,l)),l=(0,S.normalize)(l),L.isWindows?(l=(0,o.rtrim)(l,S.sep),l.endsWith(":")&&(l+=S.sep)):(l=(0,o.rtrim)(l,S.sep),l||(l=S.sep)),l}e.sanitizeFilePath=c;function u(l){const d=(0,S.normalize)(l);return L.isWindows?l.length>3?!1:D(d)&&(l.length===2||d.charCodeAt(2)===92):d===S.posix.sep}e.isRootOrDriveLetter=u;function D(l,d=L.isWindows){return d?f(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=D;function O(l,d=L.isWindows){return D(l,d)?l[0]:void 0}e.getDriveLetter=O;function t(l,d,I){return d.length>l.length?-1:l===d?0:(I&&(l=l.toLowerCase(),d=d.toLowerCase()),l.indexOf(d))}e.indexOfPath=t;function n(l){const d=l.split(":");let I,C,E;for(const w of d){const N=Number(w);(0,A.isNumber)(N)?C===void 0?C=N:E===void 0&&(E=N):I=I?[I,w].join(":"):w}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:C!==void 0?C:void 0,column:E!==void 0?E:C!==void 0?1:void 0}}e.parseLineAndColumnAware=n;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(l,d,I=8){let C="";for(let w=0;w<I;w++){let N;w===0&&L.isWindows&&!d&&(I===3||I===4)?N=i:N=s,C+=N.charAt(Math.floor(Math.random()*N.length))}let E;return d?E=`${d}-${C}`:E=C,l?(0,S.join)(l,E):E}e.randomPath=a}),define(pe[158],be([1,0,27,17]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function o(...G){return function(Z,ce){for(let Ee=0,De=G.length;Ee<De;Ee++){const ke=G[Ee](Z,ce);if(ke)return ke}return null}}e.or=o,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(G,Z,ce){if(!ce||ce.length<Z.length)return null;let Ee;return G?Ee=L.startsWithIgnoreCase(ce,Z):Ee=ce.indexOf(Z)===0,Ee?Z.length>0?[{start:0,end:Z.length}]:[]:null}function k(G,Z){const ce=Z.toLowerCase().indexOf(G.toLowerCase());return ce===-1?null:[{start:ce,end:ce+G.length}]}e.matchesContiguousSubString=k;function R(G,Z){return b(G.toLowerCase(),Z.toLowerCase(),0,0)}e.matchesSubString=R;function b(G,Z,ce,Ee){if(ce===G.length)return[];if(Ee===Z.length)return null;if(G[ce]===Z[Ee]){let De=null;return(De=b(G,Z,ce+1,Ee+1))?f({start:Ee,end:Ee+1},De):null}return b(G,Z,ce,Ee+1)}function m(G){return 97<=G&&G<=122}function T(G){return 65<=G&&G<=90}e.isUpper=T;function y(G){return 48<=G&&G<=57}function v(G){return G===32||G===9||G===10||G===13}const h=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>h.add(G.charCodeAt(0)));function g(G){return v(G)||h.has(G)}function p(G,Z){return G===Z||g(G)&&g(Z)}function r(G){return m(G)||T(G)||y(G)}function f(G,Z){return Z.length===0?Z=[G]:G.end===Z[0].start?Z[0].start=G.start:Z.unshift(G),Z}function c(G,Z){for(let ce=Z;ce<G.length;ce++){const Ee=G.charCodeAt(ce);if(T(Ee)||y(Ee)||ce>0&&!r(G.charCodeAt(ce-1)))return ce}return G.length}function u(G,Z,ce,Ee){if(ce===G.length)return[];if(Ee===Z.length)return null;if(G[ce]!==Z[Ee].toLowerCase())return null;{let De=null,ke=Ee+1;for(De=u(G,Z,ce+1,Ee+1);!De&&(ke=c(Z,ke))<Z.length;)De=u(G,Z,ce+1,ke),ke++;return De===null?null:f({start:Ee,end:Ee+1},De)}}function D(G){let Z=0,ce=0,Ee=0,De=0,ke=0;for(let we=0;we<G.length;we++)ke=G.charCodeAt(we),T(ke)&&Z++,m(ke)&&ce++,r(ke)&&Ee++,y(ke)&&De++;const Fe=Z/G.length,ze=ce/G.length,me=Ee/G.length,Se=De/G.length;return{upperPercent:Fe,lowerPercent:ze,alphaPercent:me,numericPercent:Se}}function O(G){const{upperPercent:Z,lowerPercent:ce}=G;return ce===0&&Z>.6}function t(G){const{upperPercent:Z,lowerPercent:ce,alphaPercent:Ee,numericPercent:De}=G;return ce>.2&&Z<.8&&Ee>.6&&De<.2}function n(G){let Z=0,ce=0,Ee=0,De=0;for(let ke=0;ke<G.length;ke++)Ee=G.charCodeAt(ke),T(Ee)&&Z++,m(Ee)&&ce++,v(Ee)&&De++;return(Z===0||ce===0)&&De===0?G.length<=30:Z<=5}function s(G,Z){if(!Z||(Z=Z.trim(),Z.length===0)||!n(G)||Z.length>60)return null;const ce=D(Z);if(!t(ce)){if(!O(ce))return null;Z=Z.toLowerCase()}let Ee=null,De=0;for(G=G.toLowerCase();De<Z.length&&(Ee=u(G,Z,0,De))===null;)De=c(Z,De+1);return Ee}e.matchesCamelCase=s;function i(G,Z,ce=!1){if(!Z||Z.length===0)return null;let Ee=null,De=0;for(G=G.toLowerCase(),Z=Z.toLowerCase();De<Z.length&&(Ee=a(G,Z,0,De,ce))===null;)De=l(Z,De+1);return Ee}e.matchesWords=i;function a(G,Z,ce,Ee,De){if(ce===G.length)return[];if(Ee===Z.length)return null;if(p(G.charCodeAt(ce),Z.charCodeAt(Ee))){let ke=null,Fe=Ee+1;if(ke=a(G,Z,ce+1,Ee+1,De),!De)for(;!ke&&(Fe=l(Z,Fe))<Z.length;)ke=a(G,Z,ce+1,Fe,De),Fe++;return ke?G.charCodeAt(ce)!==Z.charCodeAt(Ee)?ke:f({start:Ee,end:Ee+1},ke):null}else return null}function l(G,Z){for(let ce=Z;ce<G.length;ce++)if(g(G.charCodeAt(ce))||ce>0&&g(G.charCodeAt(ce-1)))return ce;return G.length}const d=o(e.matchesPrefix,s,k),I=o(e.matchesPrefix,s,R),C=new S.LRUCache(1e4);function E(G,Z,ce=!1){if(typeof G!="string"||typeof Z!="string")return null;let Ee=C.get(G);Ee||(Ee=new RegExp(L.convertSimple2RegExpPattern(G),"i"),C.set(G,Ee));const De=Ee.exec(Z);return De?[{start:De.index,end:De.index+De[0].length}]:ce?I(G,Z):d(G,Z)}e.matchesFuzzy=E;function w(G,Z){const ce=K(G,G.toLowerCase(),0,Z,Z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ce?$(ce):null}e.matchesFuzzy2=w;function N(G,Z,ce,Ee,De,ke){const Fe=Math.min(13,G.length);for(;ce<Fe;ce++){const ze=K(G,Z,ce,Ee,De,ke,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ze)return ze}return[0,ke]}e.anyScore=N;function $(G){if(typeof G>"u")return[];const Z=[],ce=G[1];for(let Ee=G.length-1;Ee>1;Ee--){const De=G[Ee]+ce,ke=Z[Z.length-1];ke&&ke.end===De?ke.end=De+1:Z.push({start:De,end:De+1})}return Z}e.createMatches=$;const se=128;function he(){const G=[],Z=[];for(let ce=0;ce<=se;ce++)Z[ce]=0;for(let ce=0;ce<=se;ce++)G.push(Z.slice(0));return G}function ae(G){const Z=[];for(let ce=0;ce<=G;ce++)Z[ce]=0;return Z}const ue=ae(2*se),ge=ae(2*se),_=he(),ie=he(),V=he(),J=!1;function U(G,Z,ce,Ee,De){function ke(ze,me,Se=" "){for(;ze.length<me;)ze=Se+ze;return ze}let Fe=` |   |${Ee.split("").map(ze=>ke(ze,3)).join("|")}
`;for(let ze=0;ze<=ce;ze++)ze===0?Fe+=" |":Fe+=`${Z[ze-1]}|`,Fe+=G[ze].slice(0,De+1).map(me=>ke(me.toString(),3)).join("|")+`
`;return Fe}function ne(G,Z,ce,Ee){G=G.substr(Z),ce=ce.substr(Ee),console.log(U(ie,G,G.length,ce,ce.length)),console.log(U(V,G,G.length,ce,ce.length)),console.log(U(_,G,G.length,ce,ce.length))}function x(G,Z){if(Z<0||Z>=G.length)return!1;const ce=G.codePointAt(Z);switch(ce){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(ce)}}function re(G,Z){if(Z<0||Z>=G.length)return!1;switch(G.charCodeAt(Z)){case 32:case 9:return!0;default:return!1}}function Y(G,Z,ce){return Z[G]!==ce[G]}function ee(G,Z,ce,Ee,De,ke,Fe=!1){for(;Z<ce&&De<ke;)G[Z]===Ee[De]&&(Fe&&(ue[Z]=De),Z+=1),De+=1;return Z===ce}e.isPatternInWord=ee;var j;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(j||(j={}));var P;(function(G){G.Default=[-100,0];function Z(ce){return!ce||ce.length===2&&ce[0]===-100&&ce[1]===0}G.isDefault=Z})(P||(e.FuzzyScore=P={}));class M{constructor(Z,ce){this.firstMatchCanBeWeak=Z,this.boostFullMatch=ce}}e.FuzzyScoreOptions=M,M.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function K(G,Z,ce,Ee,De,ke,Fe=M.default){const ze=G.length>se?se:G.length,me=Ee.length>se?se:Ee.length;if(ce>=ze||ke>=me||ze-ce>me-ke||!ee(Z,ce,ze,De,ke,me,!0))return;te(ze,me,ce,ke,Z,De);let Se=1,we=1,Ue=ce,Be=ke;const et=[!1];for(Se=1,Ue=ce;Ue<ze;Se++,Ue++){const Ke=ue[Ue],Xe=ge[Ue],fe=Ue+1<ze?ge[Ue+1]:me;for(we=Ke-ke+1,Be=Ke;Be<fe;we++,Be++){let Ce=Number.MIN_SAFE_INTEGER,Te=!1;Be<=Xe&&(Ce=z(G,Z,Ue,ce,Ee,De,Be,me,ke,_[Se-1][we-1]===0,et));let Re=0;Ce!==Number.MAX_SAFE_INTEGER&&(Te=!0,Re=Ce+ie[Se-1][we-1]);const Oe=Be>Ke,$e=Oe?ie[Se][we-1]+(_[Se][we-1]>0?-5:0):0,Ge=Be>Ke+1&&_[Se][we-1]>0,qe=Ge?ie[Se][we-2]+(_[Se][we-2]>0?-5:0):0;if(Ge&&(!Oe||qe>=$e)&&(!Te||qe>=Re))ie[Se][we]=qe,V[Se][we]=3,_[Se][we]=0;else if(Oe&&(!Te||$e>=Re))ie[Se][we]=$e,V[Se][we]=2,_[Se][we]=0;else if(Te)ie[Se][we]=Re,V[Se][we]=1,_[Se][we]=_[Se-1][we-1]+1;else throw new Error("not possible")}}if(J&&ne(G,ce,Ee,ke),!et[0]&&!Fe.firstMatchCanBeWeak)return;Se--,we--;const He=[ie[Se][we],ke];let Ve=0,Ze=0;for(;Se>=1;){let Ke=we;do{const Xe=V[Se][Ke];if(Xe===3)Ke=Ke-2;else if(Xe===2)Ke=Ke-1;else break}while(Ke>=1);Ve>1&&Z[ce+Se-1]===De[ke+we-1]&&!Y(Ke+ke-1,Ee,De)&&Ve+1>_[Se][Ke]&&(Ke=we),Ke===we?Ve++:Ve=1,Ze||(Ze=Ke),Se--,we=Ke-1,He.push(we)}me===ze&&Fe.boostFullMatch&&(He[0]+=2);const it=Ze-ze;return He[0]-=it,He}e.fuzzyScore=K;function te(G,Z,ce,Ee,De,ke){let Fe=G-1,ze=Z-1;for(;Fe>=ce&&ze>=Ee;)De[Fe]===ke[ze]&&(ge[Fe]=ze,Fe--),ze--}function z(G,Z,ce,Ee,De,ke,Fe,ze,me,Se,we){if(Z[ce]!==ke[Fe])return Number.MIN_SAFE_INTEGER;let Ue=1,Be=!1;return Fe===ce-Ee?Ue=G[ce]===De[Fe]?7:5:Y(Fe,De,ke)&&(Fe===0||!Y(Fe-1,De,ke))?(Ue=G[ce]===De[Fe]?7:5,Be=!0):x(ke,Fe)&&(Fe===0||!x(ke,Fe-1))?Ue=5:(x(ke,Fe-1)||re(ke,Fe-1))&&(Ue=5,Be=!0),Ue>1&&ce===Ee&&(we[0]=!0),Be||(Be=Y(Fe,De,ke)||x(ke,Fe-1)||re(ke,Fe-1)),ce===Ee?Fe>me&&(Ue-=Be?3:5):Se?Ue+=Be?2:0:Ue+=Be?0:1,Fe+1===ze&&(Ue-=Be?3:5),Ue}function W(G,Z,ce,Ee,De,ke,Fe){return H(G,Z,ce,Ee,De,ke,!0,Fe)}e.fuzzyScoreGracefulAggressive=W;function q(G,Z,ce,Ee,De,ke,Fe){return H(G,Z,ce,Ee,De,ke,!1,Fe)}e.fuzzyScoreGraceful=q;function H(G,Z,ce,Ee,De,ke,Fe,ze){let me=K(G,Z,ce,Ee,De,ke,ze);if(me&&!Fe)return me;if(G.length>=3){const Se=Math.min(7,G.length-1);for(let we=ce+1;we<Se;we++){const Ue=Q(G,we);if(Ue){const Be=K(Ue,Ue.toLowerCase(),ce,Ee,De,ke,ze);Be&&(Be[0]-=3,(!me||Be[0]>me[0])&&(me=Be))}}}return me}function Q(G,Z){if(Z+1>=G.length)return;const ce=G[Z],Ee=G[Z+1];if(ce!==Ee)return G.slice(0,Z)+Ee+ce+G.slice(Z+2)}}),define(pe[75],be([1,0,17]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(f){return o(f,0)}e.hash=L;function o(f,c){switch(typeof f){case"object":return f===null?A(349,c):Array.isArray(f)?b(f,c):m(f,c);case"string":return R(f,c);case"boolean":return k(f,c);case"number":return A(f,c);case"undefined":return A(937,c);default:return A(617,c)}}e.doHash=o;function A(f,c){return(c<<5)-c+f|0}e.numberHash=A;function k(f,c){return A(f?433:863,c)}function R(f,c){c=A(149417,c);for(let u=0,D=f.length;u<D;u++)c=A(f.charCodeAt(u),c);return c}e.stringHash=R;function b(f,c){return c=A(104579,c),f.reduce((u,D)=>o(D,u),c)}function m(f,c){return c=A(181387,c),Object.keys(f).sort().reduce((u,D)=>(u=R(D,u),o(f[D],u)),c)}class T{constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=o(c,this.g),this.g}}e.Hasher=T;var y;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function v(f,c,u=32){const D=u-c,O=~((1<<D)-1);return(f<<c|(O&f)>>>D)>>>0}function h(f,c=0,u=f.byteLength,D=0){for(let O=0;O<u;O++)f[c+O]=D}function g(f,c,u="0"){for(;f.length<c;)f=u+f;return f}function p(f,c=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(u=>u.toString(16).padStart(2,"0")).join(""):g((f>>>0).toString(16),c/4)}e.toHexString=p;class r{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const u=c.length;if(u===0)return;const D=this.p;let O=this.r,t=this.u,n,s;for(t!==0?(n=t,s=-1,t=0):(n=c.charCodeAt(0),s=0);;){let i=n;if(S.isHighSurrogate(n))if(s+1<u){const a=c.charCodeAt(s+1);S.isLowSurrogate(a)?(s++,i=S.computeCodePoint(n,a)):i=65533}else{t=n;break}else S.isLowSurrogate(n)&&(i=65533);if(O=this.w(D,O,i),s++,s<u)n=c.charCodeAt(s);else break}this.r=O,this.u=t}w(c,u,D){return D<128?c[u++]=D:D<2048?(c[u++]=192|(D&1984)>>>6,c[u++]=128|(D&63)>>>0):D<65536?(c[u++]=224|(D&61440)>>>12,c[u++]=128|(D&4032)>>>6,c[u++]=128|(D&63)>>>0):(c[u++]=240|(D&1835008)>>>18,c[u++]=128|(D&258048)>>>12,c[u++]=128|(D&4032)>>>6,c[u++]=128|(D&63)>>>0),u>=64&&(this.y(),u-=64,this.t+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),u}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=r.g,u=this.q;for(let d=0;d<64;d+=4)c.setUint32(d,u.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)c.setUint32(d,v(c.getUint32(d-12,!1)^c.getUint32(d-32,!1)^c.getUint32(d-56,!1)^c.getUint32(d-64,!1),1),!1);let D=this.h,O=this.l,t=this.m,n=this.n,s=this.o,i,a,l;for(let d=0;d<80;d++)d<20?(i=O&t|~O&n,a=1518500249):d<40?(i=O^t^n,a=1859775393):d<60?(i=O&t|O&n|t&n,a=2400959708):(i=O^t^n,a=3395469782),l=v(D,5)+i+s+a+c.getUint32(d*4,!1)&4294967295,s=n,n=t,t=v(O,30),O=D,D=l;this.h=this.h+D&4294967295,this.l=this.l+O&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+s&4294967295}}e.StringSHA1=r,r.g=new DataView(new ArrayBuffer(320))}),define(pe[159],be([1,0,158,17,96]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const A="$(",k=new RegExp(`\\$\\(${o.ThemeIcon.iconNameExpression}(?:${o.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${k.source}`,"g");function b(f){return f.replace(R,(c,u)=>u?c:`\\${c}`)}e.escapeIcons=b;const m=new RegExp(`\\\\${k.source}`,"g");function T(f){return f.replace(m,c=>`\\${c}`)}e.markdownEscapeEscapedIcons=T;const y=new RegExp(`(\\s)?(\\\\)?${k.source}(\\s)?`,"g");function v(f){return f.indexOf(A)===-1?f:f.replace(y,(c,u,D,O)=>D?c:u||O||"")}e.stripIcons=v;function h(f){return f?f.replace(/\$\((.*?)\)/g,(c,u)=>` ${u} `).trim():""}e.getCodiconAriaLabel=h;const g=new RegExp(`\\$\\(${o.ThemeIcon.iconNameCharacter}+\\)`,"g");function p(f){g.lastIndex=0;let c="";const u=[];let D=0;for(;;){const O=g.lastIndex,t=g.exec(f),n=f.substring(O,t?.index);if(n.length>0){c+=n;for(let s=0;s<n.length;s++)u.push(D)}if(!t)break;D+=t[0].length}return{text:c,iconOffsets:u}}e.parseLabelWithIcons=p;function r(f,c,u=!1){const{text:D,iconOffsets:O}=c;if(!O||O.length===0)return(0,S.matchesFuzzy)(f,D,u);const t=(0,L.ltrim)(D," "),n=D.length-t.length,s=(0,S.matchesFuzzy)(f,t,u);if(s)for(const i of s){const a=O[i.start+n]+n;i.start+=a,i.end+=a}return s}e.matchesFuzzyIconAware=r}),define(pe[60],be([1,0,17]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(o){o[o.Ignore=0]="Ignore",o[o.Info=1]="Info",o[o.Warning=2]="Warning",o[o.Error=3]="Error"})(L||(L={})),function(o){const A="error",k="warning",R="warn",b="info",m="ignore";function T(v){return v?S.equalsIgnoreCase(A,v)?o.Error:S.equalsIgnoreCase(k,v)||S.equalsIgnoreCase(R,v)?o.Warning:S.equalsIgnoreCase(b,v)?o.Info:o.Ignore:o.Ignore}o.fromValue=T;function y(v){switch(v){case o.Error:return A;case o.Warning:return k;case o.Info:return b;default:return m}}o.toString=y}(L||(L={})),e.default=L}),define(pe[61],be([1,0,18,17]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class o{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const g=h.charCodeAt(0),p=this.b.charCodeAt(this.c);return g-p}value(){return this.b[this.c]}}e.StringIterator=o;class A{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,L.compareSubstring)(h,this.b,0,h.length,this.c,this.d):(0,L.compareSubstringIgnoreCase)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class k{constructor(h=!0,g=!0){this.f=h,this.g=g}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let g=h.length-1;g>=0;g--,this.c--){const p=this.b.charCodeAt(g);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,L.compareSubstring)(h,this.b,0,h.length,this.d,this.e):(0,L.compareSubstringIgnoreCase)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=k;var R;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(R||(R={}));class b{constructor(h,g){this.f=h,this.g=g,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new k(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,L.compareIgnoreCase)(h,this.c.scheme);if(this.d[this.e]===2)return(0,L.compareIgnoreCase)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,L.compare)(h,this.c.query);if(this.d[this.e]===5)return(0,L.compare)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=b;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(T||(T={}));class y{static forUris(h=()=>!1,g=()=>!1){return new y(new b(h,g))}static forPaths(h=!1){return new y(new k(void 0,!h))}static forStrings(){return new y(new o)}static forConfigKeys(){return new y(new A)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,g){if(g){const p=g.slice(0);(0,S.shuffle)(p);for(const r of p)this.set(r,h)}else{const p=h.slice(0);(0,S.shuffle)(p);for(const r of p)this.set(r[0],r[1])}}set(h,g){const p=this.b.reset(h);let r;this.c||(this.c=new m,this.c.segment=p.value());const f=[];for(r=this.c;;){const u=p.cmp(r.segment);if(u>0)r.left||(r.left=new m,r.left.segment=p.value()),f.push([-1,r]),r=r.left;else if(u<0)r.right||(r.right=new m,r.right.segment=p.value()),f.push([1,r]),r=r.right;else if(p.hasNext())p.next(),r.mid||(r.mid=new m,r.mid.segment=p.value()),f.push([0,r]),r=r.mid;else break}const c=r.value;r.value=g,r.key=h;for(let u=f.length-1;u>=0;u--){const D=f[u][1];D.updateHeight();const O=D.balanceFactor();if(O<-1||O>1){const t=f[u][0],n=f[u+1][0];if(t===1&&n===1)f[u][1]=D.rotateLeft();else if(t===-1&&n===-1)f[u][1]=D.rotateRight();else if(t===1&&n===-1)D.right=f[u+1][1]=f[u+1][1].rotateRight(),f[u][1]=D.rotateLeft();else if(t===-1&&n===1)D.left=f[u+1][1]=f[u+1][1].rotateLeft(),f[u][1]=D.rotateRight();else throw new Error;if(u>0)switch(f[u-1][0]){case-1:f[u-1][1].left=f[u][1];break;case 1:f[u-1][1].right=f[u][1];break;case 0:f[u-1][1].mid=f[u][1];break}else this.c=f[0][1]}}return c}get(h){return this.d(h)?.value}d(h){const g=this.b.reset(h);let p=this.c;for(;p;){const r=g.cmp(p.segment);if(r>0)p=p.left;else if(r<0)p=p.right;else if(g.hasNext())g.next(),p=p.mid;else break}return p}has(h){const g=this.d(h);return!(g?.value===void 0&&g?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,g){const p=this.b.reset(h),r=[];let f=this.c;for(;f;){const c=p.cmp(f.segment);if(c>0)r.push([-1,f]),f=f.left;else if(c<0)r.push([1,f]),f=f.right;else if(p.hasNext())p.next(),r.push([0,f]),f=f.mid;else break}if(f){if(g?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const c=this.f(f.right);if(c.key){const{key:u,value:D,segment:O}=c;this.e(c.key,!1),f.key=u,f.value=D,f.segment=O}}else{const c=f.left??f.right;if(r.length>0){const[u,D]=r[r.length-1];switch(u){case-1:D.left=c;break;case 0:D.mid=c;break;case 1:D.right=c;break}}else this.c=c}for(let c=r.length-1;c>=0;c--){const u=r[c][1];u.updateHeight();const D=u.balanceFactor();if(D>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),r[c][1]=u.rotateLeft()):D<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),r[c][1]=u.rotateRight()),c>0)switch(r[c-1][0]){case-1:r[c-1][1].left=r[c][1];break;case 1:r[c-1][1].right=r[c][1];break;case 0:r[c-1][1].mid=r[c][1];break}else this.c=r[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const g=this.b.reset(h);let p=this.c,r;for(;p;){const f=g.cmp(p.segment);if(f>0)p=p.left;else if(f<0)p=p.right;else if(g.hasNext())g.next(),r=p.value||r,p=p.mid;else break}return p&&p.value||r}findSuperstr(h){return this.g(h,!1)}g(h,g){const p=this.b.reset(h);let r=this.c;for(;r;){const f=p.cmp(r.segment);if(f>0)r=r.left;else if(f<0)r=r.right;else if(p.hasNext())p.next(),r=r.mid;else return r.mid?this.h(r.mid):g?r.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[g,p]of this)h(p,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const g=[];return this.j(h,g),g[Symbol.iterator]()}j(h,g){h&&(h.left&&this.j(h.left,g),h.value&&g.push([h.key,h.value]),h.mid&&this.j(h.mid,g),h.right&&this.j(h.right,g))}_isBalanced(){const h=g=>{if(!g)return!0;const p=g.balanceFactor();return p<-1||p>1?!1:h(g.left)&&h(g.right)};return h(this.c)}}e.TernarySearchTree=y}),define(pe[4],be([1,0,7,3]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const o=/^\w[\w\d+.-]*$/,A=/^\//,k=/^\/\//;function R(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!o.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(i,a){return!i&&!a?"file":i}function m(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==y&&(a=y+a):a=y;break}return a}const T="",y="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(a){return a instanceof h?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,l,d,I,C,E=!1){typeof a=="object"?(this.scheme=a.scheme||T,this.authority=a.authority||T,this.path=a.path||T,this.query=a.query||T,this.fragment=a.fragment||T):(this.scheme=b(a,E),this.authority=l||T,this.path=m(this.scheme,d||T),this.query=I||T,this.fragment=C||T,R(this,E))}get fsPath(){return D(this,!1)}with(a){if(!a)return this;let{scheme:l,authority:d,path:I,query:C,fragment:E}=a;return l===void 0?l=this.scheme:l===null&&(l=T),d===void 0?d=this.authority:d===null&&(d=T),I===void 0?I=this.path:I===null&&(I=T),C===void 0?C=this.query:C===null&&(C=T),E===void 0?E=this.fragment:E===null&&(E=T),l===this.scheme&&d===this.authority&&I===this.path&&C===this.query&&E===this.fragment?this:new r(l,d,I,C,E)}static parse(a,l=!1){const d=v.exec(a);return d?new r(d[2]||T,s(d[4]||T),s(d[5]||T),s(d[7]||T),s(d[9]||T),l):new r(T,T,T,T,T)}static file(a){let l=T;if(L.isWindows&&(a=a.replace(/\\/g,y)),a[0]===y&&a[1]===y){const d=a.indexOf(y,2);d===-1?(l=a.substring(2),a=y):(l=a.substring(2,d),a=a.substring(d)||y)}return new r("file",l,a,T,T)}static from(a,l){return new r(a.scheme,a.authority,a.path,a.query,a.fragment,l)}static joinPath(a,...l){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return L.isWindows&&a.scheme==="file"?d=h.file(S.win32.join(D(a,!0),...l)).path:d=S.posix.join(a.path,...l),a.with({path:d})}toString(a=!1){return O(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof h)return a;{const l=new r(a);return l._formatted=a.external??null,l._fsPath=a._sep===p?a.fsPath??null:null,l}}else return a}}e.URI=h;function g(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=g;const p=L.isWindows?1:void 0;class r extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=D(this,!1)),this._fsPath}toString(a=!1){return a?O(this,!0):(this._formatted||(this._formatted=O(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=p),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function c(i,a,l){let d,I=-1;for(let C=0;C<i.length;C++){const E=i.charCodeAt(C);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||a&&E===47||l&&E===91||l&&E===93||l&&E===58)I!==-1&&(d+=encodeURIComponent(i.substring(I,C)),I=-1),d!==void 0&&(d+=i.charAt(C));else{d===void 0&&(d=i.substr(0,C));const w=f[E];w!==void 0?(I!==-1&&(d+=encodeURIComponent(i.substring(I,C)),I=-1),d+=w):I===-1&&(I=C)}}return I!==-1&&(d+=encodeURIComponent(i.substring(I))),d!==void 0?d:i}function u(i){let a;for(let l=0;l<i.length;l++){const d=i.charCodeAt(l);d===35||d===63?(a===void 0&&(a=i.substr(0,l)),a+=f[d]):a!==void 0&&(a+=i[l])}return a!==void 0?a:i}function D(i,a){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=D;function O(i,a){const l=a?u:c;let d="",{scheme:I,authority:C,path:E,query:w,fragment:N}=i;if(I&&(d+=I,d+=":"),(C||I==="file")&&(d+=y,d+=y),C){let $=C.indexOf("@");if($!==-1){const se=C.substr(0,$);C=C.substr($+1),$=se.lastIndexOf(":"),$===-1?d+=l(se,!1,!1):(d+=l(se.substr(0,$),!1,!1),d+=":",d+=l(se.substr($+1),!1,!0)),d+="@"}C=C.toLowerCase(),$=C.lastIndexOf(":"),$===-1?d+=l(C,!1,!0):(d+=l(C.substr(0,$),!1,!0),d+=C.substr($))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const $=E.charCodeAt(1);$>=65&&$<=90&&(E=`/${String.fromCharCode($+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const $=E.charCodeAt(0);$>=65&&$<=90&&(E=`${String.fromCharCode($+32)}:${E.substr(2)}`)}d+=l(E,!0,!1)}return w&&(d+="?",d+=l(w,!1,!1)),N&&(d+="#",d+=a?N:c(N,!1,!1)),d}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(n)?i.replace(n,a=>t(a)):i}}),define(pe[160],be([1,0,4]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(m){const T=m;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=L;function o(m){const T=[];let y;try{const v=JSON.parse(m.arguments),h=v[v.length-1];h&&h.__$stack&&(v.pop(),y=h.__$stack),T.push(...v)}catch{T.push("Unable to log remote console arguments",m.arguments)}return{args:T,stack:y}}e.parse=o;function A(m){if(typeof m!="string")return A(o(m).stack);const T=m;if(T){const y=k(T),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(v&&v.length===4)return{uri:S.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=A;function k(m){if(!m)return m;const T=m.indexOf(`
`);return T===-1?m:m.substring(0,T)}function R(m,T){const{args:y,stack:v}=o(m),h=typeof y[0]=="string"&&y.length===1;let g=k(v);g&&(g=`(${g.trim()})`);let p=[];if(typeof y[0]=="string"?g&&h?p=[`%c[${T}] %c${y[0]} %c${g}`,b("blue"),b(""),b("grey")]:p=[`%c[${T}] %c${y[0]}`,b("blue"),b(""),...y.slice(1)]:p=[`%c[${T}]%`,b("blue"),...y],g&&!h&&p.push(g),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,p)}e.log=R;function b(m){return`color: ${m}`}}),define(pe[50],be([1,0,15,17,4]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(m){return JSON.stringify(m,R)}e.stringify=A;function k(m){let T=JSON.parse(m);return T=b(T),T}e.parse=k;function R(m,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,L.regExpFlags)(T)}:T}function b(m,T=0){if(!m||T>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return o.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof S.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let y=0;y<m.length;++y)m[y]=b(m[y],T+1);else for(const y in m)Object.hasOwnProperty.call(m,y)&&(m[y]=b(m[y],T+1))}return m}e.revive=b}),define(pe[13],be([1,0,11,3,4]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractive="vscode-interactive",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(T){this.d=T}setDelegate(T){this.e=T}setServerRootPath(T){this.f=`${T}/${A.vscodeRemoteResource}`}set(T,y,v){this.a[T]=y,this.b[T]=v}setConnectionToken(T,y){this.c[T]=y}getPreferredWebSchema(){return this.d}rewrite(T){if(this.e)try{return this.e(T)}catch(r){return S.onUnexpectedError(r),T}const y=T.authority;let v=this.a[y];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const h=this.b[y],g=this.c[y];let p=`path=${encodeURIComponent(T.path)}`;return typeof g=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),o.URI.from({scheme:L.isWeb?this.d:A.vscodeRemoteResource,authority:`${v}:${h}`,path:this.f,query:p})}}e.RemoteAuthorities=new k,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(T){const y=this.b(T,le);return this.uriToBrowserUri(y)}uriToBrowserUri(T){return T.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===A.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${A.vscodeFileResource}://${R.a}`)?T.with({scheme:A.vscodeFileResource,authority:T.authority||R.a,query:null,fragment:null}):T}asFileUri(T){const y=this.b(T,le);return this.uriToFileUri(y)}uriToFileUri(T){return T.scheme===A.vscodeFileResource?T.with({scheme:A.file,authority:T.authority!==R.a?T.authority:null,query:null,fragment:null}):T}b(T,y){return o.URI.isUri(T)?T:o.URI.parse(y.toUrl(T))}}R.a="vscode-app",e.FileAccess=new R;var b;(function(m){const T=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(T.get("3"));const y="vscode-coi";function v(g){let p;typeof g=="string"?p=new URL(g).searchParams:g instanceof URL?p=g.searchParams:o.URI.isUri(g)&&(p=new URL(g.toString(!0)).searchParams);const r=p?.get(y);if(r)return T.get(r)}m.getHeadersFromQuery=v;function h(g,p,r){if(!globalThis.crossOriginIsolated)return;const f=p&&r?"3":r?"2":"1";g instanceof URLSearchParams?g.set(y,f):g[y]=f}m.addSearchParam=h})(b||(e.COI=b={}))}),define(pe[19],be([1,0,39,13,7,3,17,4]),function(le,e,S,L,o,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(h){return(0,R.uriToFsPath)(h,!0)}e.originalFSPath=b;class m{constructor(g){this.a=g}compare(g,p,r=!1){return g===p?0:(0,k.compare)(this.getComparisonKey(g,r),this.getComparisonKey(p,r))}isEqual(g,p,r=!1){return g===p?!0:!g||!p?!1:this.getComparisonKey(g,r)===this.getComparisonKey(p,r)}getComparisonKey(g,p=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,p,r=!1){if(g.scheme===p.scheme){if(g.scheme===L.Schemas.file)return S.isEqualOrParent(b(g),b(p),this.a(g))&&g.query===p.query&&(r||g.fragment===p.fragment);if((0,e.isEqualAuthority)(g.authority,p.authority))return S.isEqualOrParent(g.path,p.path,this.a(g),"/")&&g.query===p.query&&(r||g.fragment===p.fragment)}return!1}joinPath(g,...p){return R.URI.joinPath(g,...p)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return o.posix.basename(g.path)}extname(g){return o.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let p;return g.scheme===L.Schemas.file?p=R.URI.file(o.dirname(b(g))).path:(p=o.posix.dirname(g.path),g.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),p="/")),g.with({path:p})}normalizePath(g){if(!g.path.length)return g;let p;return g.scheme===L.Schemas.file?p=R.URI.file(o.normalize(b(g))).path:p=o.posix.normalize(g.path),g.with({path:p})}relativePath(g,p){if(g.scheme!==p.scheme||!(0,e.isEqualAuthority)(g.authority,p.authority))return;if(g.scheme===L.Schemas.file){const c=o.relative(b(g),b(p));return A.isWindows?S.toSlashes(c):c}let r=g.path||"/";const f=p.path||"/";if(this.a(g)){let c=0;for(const u=Math.min(r.length,f.length);c<u&&!(r.charCodeAt(c)!==f.charCodeAt(c)&&r.charAt(c).toLowerCase()!==f.charAt(c).toLowerCase());c++);r=f.substr(0,c)+r.substr(c)}return o.posix.relative(r,f)}resolvePath(g,p){if(g.scheme===L.Schemas.file){const r=R.URI.file(o.resolve(b(g),p));return g.with({authority:r.authority,path:r.path})}return p=S.toPosixPath(p),g.with({path:o.posix.resolve(g.path,p)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,p){return g===p||g!==void 0&&p!==void 0&&(0,k.equalsIgnoreCase)(g,p)}hasTrailingPathSeparator(g,p=o.sep){if(g.scheme===L.Schemas.file){const r=b(g);return r.length>S.getRoot(r).length&&r[r.length-1]===p}else{const r=g.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,p=o.sep){return(0,e.hasTrailingPathSeparator)(g,p)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,p=o.sep){let r=!1;if(g.scheme===L.Schemas.file){const f=b(g);r=f!==void 0&&f.length===S.getRoot(f).length&&f[f.length-1]===p}else{p="/";const f=g.path;r=f.length===1&&f.charCodeAt(f.length-1)===47}return!r&&!(0,e.hasTrailingPathSeparator)(g,p)?g.with({path:g.path+"/"}):g}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(h=>h.scheme===L.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new m(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(h,g){const p=[];for(let r=0;r<h.length;r++){const f=g(h[r]);h.some((c,u)=>u===r?!1:(0,e.isEqualOrParent)(f,g(c)))||p.push(h[r])}return p}e.distinctParents=T;var y;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function g(p){const r=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(u=>{const[D,O]=u.split(":");D&&O&&r.set(D,O)});const c=p.path.substring(0,p.path.indexOf(";"));return c&&r.set(h.META_DATA_MIME,c),r}h.parseMetaData=g})(y||(e.DataUri=y={}));function v(h,g,p){if(g){let r=h.path;return r&&r[0]!==o.posix.sep&&(r=o.posix.sep+r),h.with({scheme:p,authority:g,path:r})}return h.with({scheme:p})}e.toLocalResource=v}),define(pe[14],be([1,0,20,11,6,2,19,3,144]),function(le,e,S,L,o,A,k,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(j){return!!j&&typeof j.then=="function"}e.isThenable=m;function T(j){const P=new S.CancellationTokenSource,M=j(P.token),K=new Promise((te,z)=>{const W=P.token.onCancellationRequested(()=>{W.dispose(),P.dispose(),z(new L.CancellationError)});Promise.resolve(M).then(q=>{W.dispose(),P.dispose(),te(q)},q=>{W.dispose(),P.dispose(),z(q)})});return new class{cancel(){P.cancel()}then(te,z){return K.then(te,z)}catch(te){return this.then(void 0,te)}finally(te){return K.finally(te)}}}e.createCancelablePromise=T;function y(j,P,M){return new Promise((K,te)=>{const z=P.onCancellationRequested(()=>{z.dispose(),K(M)});j.then(K,te).finally(()=>z.dispose())})}e.raceCancellation=y;function v(j,P){return new Promise((M,K)=>{const te=P.onCancellationRequested(()=>{te.dispose(),K(new L.CancellationError)});j.then(M,K).finally(()=>te.dispose())})}e.raceCancellationError=v;async function h(j){let P=-1;const M=j.map((K,te)=>K.then(z=>(P=te,z)));try{return await Promise.race(M)}finally{j.forEach((K,te)=>{te!==P&&K.cancel()})}}e.raceCancellablePromises=h;function g(j,P,M){let K;const te=setTimeout(()=>{K?.(void 0),M?.()},P);return Promise.race([j.finally(()=>clearTimeout(te)),new Promise(z=>K=z)])}e.raceTimeout=g;function p(j){return new Promise((P,M)=>{const K=j();m(K)?K.then(P,M):P(K)})}e.asPromise=p;class r{constructor(){this.a=null,this.b=null,this.d=null}queue(P){if(this.a){if(this.d=P,!this.b){const M=()=>{this.b=null;const K=this.queue(this.d);return this.d=null,K};this.b=new Promise(K=>{this.a.then(M,M).then(K)})}return new Promise((M,K)=>{this.b.then(M,K)})}return this.a=P(),new Promise((M,K)=>{this.a.then(te=>{this.a=null,M(te)},te=>{this.a=null,K(te)})})}}e.Throttler=r;class f{constructor(){this.a=Promise.resolve(null)}queue(P){return this.a=this.a.then(()=>P(),()=>P())}}e.Sequencer=f;class c{constructor(){this.a=new Map}queue(P,M){const te=(this.a.get(P)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.a.get(P)===te&&this.a.delete(P)});return this.a.set(P,te),te}}e.SequencerByKey=c;const u=(j,P)=>{let M=!0;const K=setTimeout(()=>{M=!1,P()},j);return{isTriggered:()=>M,dispose:()=>{clearTimeout(K),M=!1}}},D=j=>{let P=!0;return queueMicrotask(()=>{P&&(P=!1,j())}),{isTriggered:()=>P,dispose:()=>{P=!1}}};class O{constructor(P){this.defaultDelay=P,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(P,M=this.defaultDelay){this.g=P,this.h(),this.b||(this.b=new Promise((te,z)=>{this.d=te,this.f=z}).then(()=>{if(this.b=null,this.d=null,this.g){const te=this.g;return this.g=null,te()}}));const K=()=>{this.a=null,this.d?.(null)};return this.a=M===b.MicrotaskDelay?D(K):u(M,K),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=O;class t{constructor(P){this.a=new O(P),this.b=new r}trigger(P,M){return this.a.trigger(()=>this.b.queue(P),M)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class n{constructor(){this.a=!1,this.b=new Promise((P,M)=>{this.d=P})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class s extends n{constructor(P){super(),this.f=setTimeout(()=>this.open(),P)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function i(j,P){return P?new Promise((M,K)=>{const te=setTimeout(()=>{z.dispose(),M()},j),z=P.onCancellationRequested(()=>{clearTimeout(te),z.dispose(),K(new L.CancellationError)})}):T(M=>i(j,M))}e.timeout=i;function a(j,P=0){const M=setTimeout(j,P);return(0,A.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=a;function l(j){const P=[];let M=0;const K=j.length;function te(){return M<K?j[M++]():null}function z(W){W!=null&&P.push(W);const q=te();return q?q.then(z):Promise.resolve(P)}return Promise.resolve(null).then(z)}e.sequence=l;function d(j,P=K=>!!K,M=null){let K=0;const te=j.length,z=()=>{if(K>=te)return Promise.resolve(M);const W=j[K++];return Promise.resolve(W()).then(H=>P(H)?Promise.resolve(H):z())};return z()}e.first=d;function I(j,P=K=>!!K,M=null){if(j.length===0)return Promise.resolve(M);let K=j.length;const te=()=>{K=-1;for(const z of j)z.cancel?.()};return new Promise((z,W)=>{for(const q of j)q.then(H=>{--K>=0&&P(H)?(te(),z(H)):K===0&&z(M)}).catch(H=>{--K>=0&&(te(),W(H))})})}e.firstParallel=I;class C{constructor(P){this.a=0,this.d=P,this.f=[],this.b=0,this.g=new o.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(P){return this.a++,new Promise((M,K)=>{this.f.push({factory:P,c:M,e:K}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const P=this.f.shift();this.b++;const M=P.factory();M.then(P.c,P.e),M.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=C;class E extends C{constructor(){super(1)}}e.Queue=E;class w{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const P=new U;return this.b.add(P),P.p}d(){for(const[,P]of this.a)if(P.size>0)return!1;return!0}queueFor(P,M=k.extUri){const K=M.getComparisonKey(P);let te=this.a.get(K);return te||(te=new E,o.Event.once(te.onDrained)(()=>{te?.dispose(),this.a.delete(K),this.f()}),this.a.set(K,te)),te}f(){this.d()&&this.g()}g(){for(const P of this.b)P.complete();this.b.clear()}dispose(){for(const[,P]of this.a)P.dispose();this.a.clear(),this.g()}}e.ResourceQueue=w;class N{constructor(P,M){this.a=-1,typeof P=="function"&&typeof M=="number"&&this.setIfNotSet(P,M)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(P,M){this.cancel(),this.a=setTimeout(()=>{this.a=-1,P()},M)}setIfNotSet(P,M){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,P()},M))}}e.TimeoutTimer=N;class ${constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(P,M){this.cancel(),this.a=setInterval(()=>{P()},M)}}e.IntervalTimer=$;class se{constructor(P,M){this.b=-1,this.a=P,this.d=M,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(P=this.d){this.cancel(),this.b=setTimeout(this.f,P)}get delay(){return this.d}set delay(P){this.d=P}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=se;class he{constructor(P,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.a=P,this.b=M,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(P=this.b){P%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${P}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(P/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=he;class ae extends se{constructor(P,M){super(P,M),this.j=[]}work(P){this.j.push(P),this.isScheduled()||this.schedule()}h(){const P=this.j;this.j=[],this.a?.(P)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=ae;class ue extends A.Disposable{constructor(P,M){super(),this.g=P,this.h=M,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(P){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+P.length>this.g.maxBufferedWork)return!1}else if(this.pending+P.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const M of P)this.a.push(M);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new se(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=ue,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=j=>{(0,R.setTimeout0)(()=>{if(P)return;const M=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let P=!1;return{dispose(){P||(P=!0)}}}:e.runWhenIdle=(j,P)=>{const M=requestIdleCallback(j,typeof P=="number"?{timeout:P}:void 0);let K=!1;return{dispose(){K||(K=!0,cancelIdleCallback(M))}}}}();class ge{constructor(P){this.d=!1,this.a=()=>{try{this.f=P()}catch(M){this.g=M}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ge;async function _(j,P,M){let K;for(let te=0;te<M;te++)try{return await j()}catch(z){K=z,await i(P)}throw K}e.retry=_;class ie{hasPending(P){return this.a?typeof P=="number"?this.a.taskId===P:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(P,M,K){return this.a={taskId:P,cancel:()=>K?.(),promise:M},M.then(()=>this.d(P),()=>this.d(P)),M}d(P){this.a&&P===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const P=this.b;this.b=void 0,P.run().then(P.promiseResolve,P.promiseReject)}}setNext(P){if(this.b)this.b.run=P;else{let M,K;const te=new Promise((z,W)=>{M=z,K=W});this.b={run:P,promise:te,promiseResolve:M,promiseReject:K}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=ie;class V{constructor(P,M=()=>Date.now()){this.d=P,this.f=M,this.a=0,this.b=0}increment(){const P=this.f();return P-this.a>this.d&&(this.a=P,this.b=0),this.b++,this.b}}e.IntervalCounter=V;var J;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(J||(J={}));class U{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((P,M)=>{this.a=P,this.b=M})}complete(P){return new Promise(M=>{this.a(P),this.d={outcome:0,value:P},M()})}error(P){return new Promise(M=>{this.b(P),this.d={outcome:1,value:P},M()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=U;var ne;(function(j){async function P(K){let te;const z=await Promise.all(K.map(W=>W.then(q=>q,q=>{te||(te=q)})));if(typeof te<"u")throw te;return z}j.settled=P;function M(K){return new Promise(async(te,z)=>{try{await K(te,z)}catch(W){z(W)}})}j.withAsyncBody=M})(ne||(e.Promises=ne={}));var x;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(x||(x={}));class re{static fromArray(P){return new re(M=>{M.emitMany(P)})}static fromPromise(P){return new re(async M=>{M.emitMany(await P)})}static fromPromises(P){return new re(async M=>{await Promise.all(P.map(async K=>M.emitOne(await K)))})}static merge(P){return new re(async M=>{await Promise.all(P.map(async K=>{for await(const te of K)M.emitOne(te)}))})}constructor(P){this.a=0,this.b=[],this.d=null,this.f=new o.Emitter,queueMicrotask(async()=>{const M={emitOne:K=>this.g(K),emitMany:K=>this.h(K),reject:K=>this.k(K)};try{await Promise.resolve(P(M)),this.j()}catch(K){this.k(K)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let P=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(P<this.b.length)return{done:!1,value:this.b[P++]};if(this.a===1)return{done:!0,value:void 0};await o.Event.toPromise(this.f.event)}while(!0)}}}static map(P,M){return new re(async K=>{for await(const te of P)K.emitOne(M(te))})}map(P){return re.map(this,P)}static filter(P,M){return new re(async K=>{for await(const te of P)M(te)&&K.emitOne(te)})}filter(P){return re.filter(this,P)}static coalesce(P){return re.filter(P,M=>!!M)}coalesce(){return re.coalesce(this)}static async toPromise(P){const M=[];for await(const K of P)M.push(K);return M}toPromise(){return re.toPromise(this)}g(P){this.a===0&&(this.b.push(P),this.f.fire())}h(P){this.a===0&&(this.b=this.b.concat(P),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(P){this.a===0&&(this.a=2,this.d=P,this.f.fire())}}e.AsyncIterableObject=re,re.EMPTY=re.fromArray([]);class Y extends re{constructor(P,M){super(M),this.l=P}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Y;function ee(j){const P=new S.CancellationTokenSource,M=j(P.token);return new Y(P,async K=>{const te=P.token.onCancellationRequested(()=>{te.dispose(),P.dispose(),K.reject(new L.CancellationError)});try{for await(const z of M){if(P.token.isCancellationRequested)return;K.emitOne(z)}te.dispose(),P.dispose()}catch(z){te.dispose(),P.dispose(),K.reject(z)}})}e.createCancelableAsyncIterable=ee}),define(pe[76],be([1,0,18,14,39,27,7,3,17]),function(le,e,S,L,o,A,k,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",y="[^/\\\\]",v=/\//g;function h(V,J){switch(V){case 0:return"";case 1:return`${y}*?`;default:return`(?:${T}|${y}+${T}${J?`|${T}${y}+`:""})*?`}}function g(V,J){if(!V)return[];const U=[];let ne=!1,x=!1,re="";for(const Y of V){switch(Y){case J:if(!ne&&!x){U.push(re),re="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":x=!0;break;case"]":x=!1;break}re+=Y}return re&&U.push(re),U}e.splitGlobAware=g;function p(V){if(!V)return"";let J="";const U=g(V,e.GLOB_SPLIT);if(U.every(ne=>ne===e.GLOBSTAR))J=".*";else{let ne=!1;U.forEach((x,re)=>{if(x===e.GLOBSTAR){if(ne)return;J+=h(2,re===U.length-1)}else{let Y=!1,ee="",j=!1,P="";for(const M of x){if(M!=="}"&&Y){ee+=M;continue}if(j&&(M!=="]"||!P)){let K;M==="-"?K=M:(M==="^"||M==="!")&&!P?K="^":M===e.GLOB_SPLIT?K="":K=(0,b.escapeRegExpCharacters)(M),P+=K;continue}switch(M){case"{":Y=!0;continue;case"[":j=!0;continue;case"}":{const te=`(?:${g(ee,",").map(z=>p(z)).join("|")})`;J+=te,Y=!1,ee="";break}case"]":{J+="["+P+"]",j=!1,P="";break}case"?":J+=y;continue;case"*":J+=h(1);continue;default:J+=(0,b.escapeRegExpCharacters)(M)}}re<U.length-1&&(U[re+1]!==e.GLOBSTAR||re+2<U.length)&&(J+=T)}ne=x===e.GLOBSTAR})}return J}const r=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,O=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),n=function(){return!1},s=function(){return null};function i(V,J){if(!V)return s;let U;typeof V!="string"?U=V.pattern:U=V,U=U.trim();const ne=`${U}_${!!J.trimForExclusions}`;let x=t.get(ne);if(x)return a(x,V);let re;return r.test(U)?x=d(U.substr(4),U):(re=f.exec(l(U,J)))?x=I(re[1],U):(J.trimForExclusions?u:c).test(U)?x=C(U,J):(re=D.exec(l(U,J)))?x=E(re[1].substr(1),U,!0):(re=O.exec(l(U,J)))?x=E(re[1],U,!1):x=w(U),t.set(ne,x),a(x,V)}function a(V,J){if(typeof J=="string")return V;const U=function(ne,x){return(0,o.isEqualOrParent)(ne,J.base,!R.isLinux)?V((0,b.ltrim)(ne.substr(J.base.length),k.sep),x):null};return U.allBasenames=V.allBasenames,U.allPaths=V.allPaths,U.basenames=V.basenames,U.patterns=V.patterns,U}function l(V,J){return J.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function d(V,J){return function(U,ne){return typeof U=="string"&&U.endsWith(V)?J:null}}function I(V,J){const U=`/${V}`,ne=`\\${V}`,x=function(Y,ee){return typeof Y!="string"?null:ee?ee===V?J:null:Y===V||Y.endsWith(U)||Y.endsWith(ne)?J:null},re=[V];return x.basenames=re,x.patterns=[J],x.allBasenames=re,x}function C(V,J){const U=_(V.slice(1,-1).split(",").map(ee=>i(ee,J)).filter(ee=>ee!==s),V),ne=U.length;if(!ne)return s;if(ne===1)return U[0];const x=function(ee,j){for(let P=0,M=U.length;P<M;P++)if(U[P](ee,j))return V;return null},re=U.find(ee=>!!ee.allBasenames);re&&(x.allBasenames=re.allBasenames);const Y=U.reduce((ee,j)=>j.allPaths?ee.concat(j.allPaths):ee,[]);return Y.length&&(x.allPaths=Y),x}function E(V,J,U){const ne=k.sep===k.posix.sep,x=ne?V:V.replace(v,k.sep),re=k.sep+x,Y=k.posix.sep+V;let ee;return U?ee=function(j,P){return typeof j=="string"&&(j===x||j.endsWith(re)||!ne&&(j===V||j.endsWith(Y)))?J:null}:ee=function(j,P){return typeof j=="string"&&(j===x||!ne&&j===V)?J:null},ee.allPaths=[(U?"*/":"./")+V],ee}function w(V){try{const J=new RegExp(`^${p(V)}$`);return function(U){return J.lastIndex=0,typeof U=="string"&&J.test(U)?V:null}}catch{return s}}function N(V,J,U){return!V||typeof J!="string"?!1:$(V)(J,void 0,U)}e.match=N;function $(V,J={}){if(!V)return n;if(typeof V=="string"||se(V)){const U=i(V,J);if(U===s)return n;const ne=function(x,re){return!!U(x,re)};return U.allBasenames&&(ne.allBasenames=U.allBasenames),U.allPaths&&(ne.allPaths=U.allPaths),ne}return ue(V,J)}e.parse=$;function se(V){const J=V;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.isRelativePattern=se;function he(V){return V.allBasenames||[]}e.getBasenameTerms=he;function ae(V){return V.allPaths||[]}e.getPathTerms=ae;function ue(V,J){const U=_(Object.getOwnPropertyNames(V).map(ee=>ge(ee,V[ee],J)).filter(ee=>ee!==s)),ne=U.length;if(!ne)return s;if(!U.some(ee=>!!ee.requiresSiblings)){if(ne===1)return U[0];const ee=function(M,K){let te;for(let z=0,W=U.length;z<W;z++){const q=U[z](M,K);if(typeof q=="string")return q;(0,L.isThenable)(q)&&(te||(te=[]),te.push(q))}return te?(async()=>{for(const z of te){const W=await z;if(typeof W=="string")return W}return null})():null},j=U.find(M=>!!M.allBasenames);j&&(ee.allBasenames=j.allBasenames);const P=U.reduce((M,K)=>K.allPaths?M.concat(K.allPaths):M,[]);return P.length&&(ee.allPaths=P),ee}const x=function(ee,j,P){let M,K;for(let te=0,z=U.length;te<z;te++){const W=U[te];W.requiresSiblings&&P&&(j||(j=(0,k.basename)(ee)),M||(M=j.substr(0,j.length-(0,k.extname)(ee).length)));const q=W(ee,j,M,P);if(typeof q=="string")return q;(0,L.isThenable)(q)&&(K||(K=[]),K.push(q))}return K?(async()=>{for(const te of K){const z=await te;if(typeof z=="string")return z}return null})():null},re=U.find(ee=>!!ee.allBasenames);re&&(x.allBasenames=re.allBasenames);const Y=U.reduce((ee,j)=>j.allPaths?ee.concat(j.allPaths):ee,[]);return Y.length&&(x.allPaths=Y),x}function ge(V,J,U){if(J===!1)return s;const ne=i(V,U);if(ne===s)return s;if(typeof J=="boolean")return ne;if(J){const x=J.when;if(typeof x=="string"){const re=(Y,ee,j,P)=>{if(!P||!ne(Y,ee))return null;const M=x.replace("$(basename)",()=>j),K=P(M);return(0,L.isThenable)(K)?K.then(te=>te?V:null):K?V:null};return re.requiresSiblings=!0,re}}return ne}function _(V,J){const U=V.filter(ee=>!!ee.basenames);if(U.length<2)return V;const ne=U.reduce((ee,j)=>{const P=j.basenames;return P?ee.concat(P):ee},[]);let x;if(J){x=[];for(let ee=0,j=ne.length;ee<j;ee++)x.push(J)}else x=U.reduce((ee,j)=>{const P=j.patterns;return P?ee.concat(P):ee},[]);const re=function(ee,j){if(typeof ee!="string")return null;if(!j){let M;for(M=ee.length;M>0;M--){const K=ee.charCodeAt(M-1);if(K===47||K===92)break}j=ee.substr(M)}const P=ne.indexOf(j);return P!==-1?x[P]:null};re.basenames=ne,re.patterns=x,re.allBasenames=ne;const Y=V.filter(ee=>!ee.basenames);return Y.push(re),Y}function ie(V,J){return(0,S.equals)(V,J,(U,ne)=>typeof U=="string"&&typeof ne=="string"?U===ne:typeof U!="string"&&typeof ne!="string"?U.base===ne.base&&U.pattern===ne.pattern:!1)}e.patternsEquals=ie}),define(pe[99],be([1,0,11,159,19,17,4]),function(le,e,S,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var R;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(R||(e.MarkdownStringTextNewlineStyle=R={}));class b{constructor(f="",c=!1){if(this.value=f,typeof this.value!="string")throw(0,S.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(f,c=0){return this.value+=v(this.supportThemeIcons?(0,L.escapeIcons)(f):f).replace(/([ \t]+)/g,(u,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,c){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(f,c,u){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(f),")"),u&&(this.value+=` "${this.c(this.c(u,'"'),")")}"`),this.value+=")",this}c(f,c){const u=new RegExp((0,A.escapeRegExpCharacters)(c),"g");return f.replace(u,(D,O)=>f.charAt(O-1)!=="\\"?`\\${D}`:D)}}e.MarkdownString=b;function m(r){return T(r)?!r.value:Array.isArray(r)?r.every(m):!0}e.isEmptyMarkdownString=m;function T(r){return r instanceof b?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function y(r,f){return r===f?!0:!r||!f?!1:r.value===f.value&&r.isTrusted===f.isTrusted&&r.supportThemeIcons===f.supportThemeIcons&&r.supportHtml===f.supportHtml&&(r.baseUri===f.baseUri||!!r.baseUri&&!!f.baseUri&&(0,o.isEqual)(k.URI.from(r.baseUri),k.URI.from(f.baseUri)))}e.markdownStringEqual=y;function v(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function h(r){return r.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=h;function g(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=g;function p(r){const f=[],c=r.split("|").map(D=>D.trim());r=c[0];const u=c[1];if(u){const D=/height=(\d+)/.exec(u),O=/width=(\d+)/.exec(u),t=D?D[1]:"",n=O?O[1]:"",s=isFinite(parseInt(n)),i=isFinite(parseInt(t));s&&f.push(`width="${n}"`),i&&f.push(`height="${t}"`)}return{href:r,dimensions:f}}e.parseHrefAndDimensions=p}),define(pe[161],be([1,0,18,39,7,3,19,17]),function(le,e,S,L,o,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function b(i,a){const{os:l,tildify:d,relative:I}=a;if(I){const w=m(i,I,l);if(typeof w=="string")return w}let C=i.fsPath;if(l===1&&!A.isWindows?C=C.replace(/\//g,"\\"):l!==1&&A.isWindows&&(C=C.replace(/\\/g,"/")),l!==1&&d?.userHome){const w=d.userHome.fsPath;let N;i.scheme!==d.userHome.scheme&&i.path.startsWith(o.posix.sep)?N=d.userHome.with({path:i.path}).fsPath:N=i.fsPath,C=v(N,w,l)}return(l===1?o.win32:o.posix).normalize(T(C,l===1))}e.getPathLabel=b;function m(i,a,l){const d=l===1?o.win32:o.posix,I=l===3?k.extUri:k.extUriIgnorePathCase,C=a.getWorkspace(),E=(0,S.firstOrDefault)(C.folders);if(!E)return;i.scheme!==E.uri.scheme&&i.path.startsWith(o.posix.sep)&&(i=E.uri.with({path:i.path}));const w=a.getWorkspaceFolder(i);if(!w)return;let N;if(I.isEqual(w.uri,i)?N="":N=I.relativePath(w.uri,i)??"",N&&(N=d.normalize(N)),C.folders.length>1&&!a.noPrefix){const $=w.name?w.name:I.basenameOrAuthority(w.uri);N=N?`${$} \u2022 ${N}`:$}return N}function T(i,a=A.isWindows){return(0,L.hasDriveLetter)(i,a)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=T;let y=Object.create(null);function v(i,a,l=A.OS){if(l===1||!i||!a)return i;let d=y.original===a?y.normalized:void 0;d||(d=a,A.isWindows&&(d=(0,L.toSlashes)(d)),d=`${(0,R.rtrim)(d,o.posix.sep)}${o.posix.sep}`,y={original:a,normalized:d});let I=i;return A.isWindows&&(I=(0,L.toSlashes)(I)),(l===3?I.startsWith(d):(0,R.startsWithIgnoreCase)(I,d))?`~/${I.substr(d.length)}`:i}e.tildify=v;function h(i,a){return i.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=h;const g="\u2026",p="\\\\",r="~";function f(i,a=o.sep){const l=new Array(i.length);let d=!1;for(let I=0;I<i.length;I++){const C=i[I];if(C===""){l[I]=`.${a}`;continue}if(!C){l[I]=C;continue}d=!0;let E="",w=C;w.indexOf(p)===0?(E=w.substr(0,w.indexOf(p)+p.length),w=w.substr(w.indexOf(p)+p.length)):w.indexOf(a)===0?(E=w.substr(0,w.indexOf(a)+a.length),w=w.substr(w.indexOf(a)+a.length)):w.indexOf(r)===0&&(E=w.substr(0,w.indexOf(r)+r.length),w=w.substr(w.indexOf(r)+r.length));const N=w.split(a);for(let $=1;d&&$<=N.length;$++)for(let se=N.length-$;d&&se>=0;se--){d=!1;let he=N.slice(se,se+$).join(a);for(let ae=0;!d&&ae<i.length;ae++)if(ae!==I&&i[ae]&&i[ae].indexOf(he)>-1){const ue=se+$===N.length,ge=se>0&&i[ae].indexOf(a)>-1?a+he:he,_=i[ae].endsWith(ge);d=!ue||_}if(!d){let ae="";(N[0].endsWith(":")||E!=="")&&(se===1&&(se=0,$++,he=N[0]+a+he),se>0&&(ae=N[0]+a),ae=E+ae),se>0&&(ae=ae+g+a),ae=ae+he,se+$<N.length&&(ae=ae+a+g),l[I]=ae}}d&&(l[I]=C)}return l}e.shorten=f;var c;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function u(i,a=Object.create(null)){const l=[];let d=!1,I="";for(const C of i)if(C==="$"||d&&C==="{")I&&l.push({value:I,type:c.TEXT}),I="",d=!0;else if(C==="}"&&d){const E=a[I];if(typeof E=="string")E.length&&l.push({value:E,type:c.VARIABLE});else if(E){const w=l[l.length-1];(!w||w.type!==c.SEPARATOR)&&l.push({value:E.label,type:c.SEPARATOR})}I="",d=!1}else I+=C;return I&&!d&&l.push({value:I,type:c.TEXT}),l.filter((C,E)=>{if(C.type===c.SEPARATOR){const w=l[E-1],N=l[E+1];return[w,N].every($=>$&&($.type===c.VARIABLE||$.type===c.TEXT)&&$.value.length>0)}return!0}).map(C=>C.value).join("")}e.template=u;function D(i,a){return A.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function O(i,a){return A.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=O;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function n(i){if(i.endsWith("]")){const a=i.lastIndexOf(" [",i.length-2);if(a!==-1){const l=s(i.substring(0,a));return{name:l.name,parentPath:l.parentPath+i.substring(a)}}}return s(i)}e.splitRecentLabel=n;function s(i){const a=i.indexOf("/")!==-1?o.posix:o.win32,l=a.basename(i),d=a.dirname(i);return l.length?{name:l,parentPath:d}:{name:d,parentPath:""}}}),define(pe[51],be([1,0,15,4]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function o(y){return y.toJSON()}class A{constructor(v){this.a=v}transformIncoming(v){const h=this.a.transformIncoming(v);return h===v?v:o(L.URI.from(h))}transformOutgoing(v){const h=this.a.transformOutgoing(v);return h===v?v:o(L.URI.from(h))}transformOutgoingURI(v){const h=this.a.transformOutgoing(v);return h===v?v:L.URI.from(h)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function k(y,v,h){if(!y||h>200)return null;if(typeof y=="object"){if(y instanceof L.URI)return v.transformOutgoing(y);for(const g in y)if(Object.hasOwnProperty.call(y,g)){const p=k(y[g],v,h+1);p!==null&&(y[g]=p)}}return null}function R(y,v){const h=k(y,v,0);return h===null?y:h}e.transformOutgoingURIs=R;function b(y,v,h,g){if(!y||g>200)return null;if(typeof y=="object"){if(y.$mid===1)return h?L.URI.revive(v.transformIncoming(y)):v.transformIncoming(y);if(y instanceof S.VSBuffer)return null;for(const p in y)if(Object.hasOwnProperty.call(y,p)){const r=b(y[p],v,h,g+1);r!==null&&(y[p]=r)}}return null}function m(y,v){const h=b(y,v,!1,0);return h===null?y:h}e.transformIncomingURIs=m;function T(y,v){const h=b(y,v,!0,0);return h===null?y:h}e.transformAndReviveIncomingURIs=T}),define(pe[100],be([1,0,28,61,22,147]),function(le,e,S,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(m){return this.a||(this.a=L.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,T=0;const y=(0,S.networkInterfaces)();for(const v in y){const h=y[v];if(h)for(const{mac:g,internal:p}of h)p||(T+=1,this.c(g.toUpperCase())&&(m+=1))}this.b=T>0?m/T:0}return this.b}};let k;async function R(m){return k||(k=(async()=>await b(m)||o.generateUuid())()),k}e.getMachineId=R;async function b(m){try{const T=await new Promise((v,h)=>{le(["crypto"],v,h)}),y=(0,A.getMac)();return T.createHash("sha256").update(y,"utf8").digest("hex")}catch(T){m(T);return}}}),define(pe[23],be([1,0,33,28,293,14,39,95,7,3,19,4]),function(le,e,S,L,o,A,k,R,b,m,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(ue){ue[ue.UNLINK=0]="UNLINK",ue[ue.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function h(ue,ge=v.UNLINK,_){if((0,k.isRootOrDriveLetter)(ue))throw new Error("rimraf - will refuse to recursively delete root");return ge===v.UNLINK?p(ue):g(ue,_)}async function g(ue,ge=(0,k.randomPath)((0,L.tmpdir)())){try{try{await S.promises.rename(ue,ge)}catch(_){return _.code==="ENOENT"?void 0:p(ue)}p(ge).catch(_=>{})}catch(_){if(_.code!=="ENOENT")throw _}}async function p(ue){return(0,o.promisify)(S.rm)(ue,{recursive:!0,force:!0,maxRetries:3})}function r(ue){if((0,k.isRootOrDriveLetter)(ue))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(ue,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=r;async function f(ue,ge){return D(await(ge?c(ue):(0,o.promisify)(S.readdir)(ue)))}async function c(ue){try{return await(0,o.promisify)(S.readdir)(ue,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const ge=[],_=await f(ue);for(const ie of _){let V=!1,J=!1,U=!1;try{const ne=await e.Promises.lstat((0,b.join)(ue,ie));V=ne.isFile(),J=ne.isDirectory(),U=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}ge.push({name:ie,isFile:()=>V,isDirectory:()=>J,isSymbolicLink:()=>U})}return ge}function u(ue){return D(S.readdirSync(ue))}e.readdirSync=u;function D(ue){return ue.map(ge=>typeof ge=="string"?m.isMacintosh?(0,R.normalizeNFC)(ge):ge:(ge.name=m.isMacintosh?(0,R.normalizeNFC)(ge.name):ge.name,ge))}async function O(ue){const ge=await f(ue),_=[];for(const ie of ge)await n.existsDirectory((0,b.join)(ue,ie))&&_.push(ie);return _}function t(ue,ge=1e3){return new Promise(_=>{let ie=!1;const V=setInterval(()=>{ie||(ie=!0,S.access(ue,J=>{ie=!1,J&&(clearInterval(V),_(void 0))}))},ge)})}e.whenDeleted=t;var n;(function(ue){async function ge(V){let J;try{if(J=await e.Promises.lstat(V),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(m.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw ne}throw U}}ue.stat=ge;async function _(V){try{const{stat:J,symbolicLink:U}=await ue.stat(V);return J.isFile()&&U?.dangling!==!0}catch{}return!1}ue.existsFile=_;async function ie(V){try{const{stat:J,symbolicLink:U}=await ue.stat(V);return J.isDirectory()&&U?.dangling!==!0}catch{}return!1}ue.existsDirectory=ie})(n||(e.SymlinkSupport=n={}));const s=new A.ResourceQueue;function i(ue,ge,_){return s.queueFor(y.URI.file(ue),T.extUriBiasedIgnorePathCase).queue(()=>{const ie=C(_);return new Promise((V,J)=>d(ue,ge,ie,U=>U?J(U):V()))})}let a=!0;function l(ue){a=ue}e.configureFlushOnWrite=l;function d(ue,ge,_,ie){if(!a)return S.writeFile(ue,ge,{mode:_.mode,flag:_.flag},ie);S.open(ue,_.flag,_.mode,(V,J)=>{if(V)return ie(V);S.writeFile(J,ge,U=>{if(U)return S.close(J,()=>ie(U));S.fdatasync(J,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),l(!1)),S.close(J,x=>ie(x))))})})}function I(ue,ge,_){const ie=C(_);if(!a)return S.writeFileSync(ue,ge,{mode:ie.mode,flag:ie.flag});const V=S.openSync(ue,ie.flag,ie.mode);try{S.writeFileSync(V,ge);try{S.fdatasyncSync(V)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),l(!1)}}finally{S.closeSync(V)}}e.writeFileSync=I;function C(ue){return ue?{mode:typeof ue.mode=="number"?ue.mode:438,flag:typeof ue.flag=="string"?ue.flag:"w"}:{mode:438,flag:"w"}}async function E(ue,ge){if(ue!==ge)try{await e.Promises.rename(ue,ge)}catch(_){if(ue.toLowerCase()!==ge.toLowerCase()&&_.code==="EXDEV"||ue.endsWith("."))await w(ue,ge,{preserveSymlinks:!1}),await h(ue,v.MOVE);else throw _}}async function w(ue,ge,_){return $(ue,ge,{root:{source:ue,target:ge},options:_,handledSourcePaths:new Set})}const N=511;async function $(ue,ge,_){if(_.handledSourcePaths.has(ue))return;_.handledSourcePaths.add(ue);const{stat:ie,symbolicLink:V}=await n.stat(ue);if(V){if(_.options.preserveSymlinks)try{return await ae(ue,ge,_)}catch(J){console.warn("[node.js fs] copy of symlink failed: ",J)}if(V.dangling)return}return ie.isDirectory()?se(ue,ge,ie.mode&N,_):he(ue,ge,ie.mode&N)}async function se(ue,ge,_,ie){await e.Promises.mkdir(ge,{recursive:!0,mode:_});const V=await f(ue);for(const J of V)await $((0,b.join)(ue,J),(0,b.join)(ge,J),ie)}async function he(ue,ge,_){await e.Promises.copyFile(ue,ge),await e.Promises.chmod(ge,_)}async function ae(ue,ge,_){let ie=await e.Promises.readlink(ue);(0,k.isEqualOrParent)(ie,_.root.source,!m.isLinux)&&(ie=(0,b.join)(_.root.target,ie.substr(_.root.source.length+1))),await e.Promises.symlink(ie,ge)}e.Promises=new class{get access(){return(0,o.promisify)(S.access)}get stat(){return(0,o.promisify)(S.stat)}get lstat(){return(0,o.promisify)(S.lstat)}get utimes(){return(0,o.promisify)(S.utimes)}get read(){return(ue,ge,_,ie,V)=>new Promise((J,U)=>{S.read(ue,ge,_,ie,V,(ne,x,re)=>ne?U(ne):J({bytesRead:x,buffer:re}))})}get readFile(){return(0,o.promisify)(S.readFile)}get write(){return(ue,ge,_,ie,V)=>new Promise((J,U)=>{S.write(ue,ge,_,ie,V,(ne,x,re)=>ne?U(ne):J({bytesWritten:x,buffer:re}))})}get appendFile(){return(0,o.promisify)(S.appendFile)}get fdatasync(){return(0,o.promisify)(S.fdatasync)}get truncate(){return(0,o.promisify)(S.truncate)}get rename(){return(0,o.promisify)(S.rename)}get copyFile(){return(0,o.promisify)(S.copyFile)}get open(){return(0,o.promisify)(S.open)}get close(){return(0,o.promisify)(S.close)}get symlink(){return(0,o.promisify)(S.symlink)}get readlink(){return(0,o.promisify)(S.readlink)}get chmod(){return(0,o.promisify)(S.chmod)}get mkdir(){return(0,o.promisify)(S.mkdir)}get unlink(){return(0,o.promisify)(S.unlink)}get rmdir(){return(0,o.promisify)(S.rmdir)}get realpath(){return(0,o.promisify)(S.realpath)}async exists(ue){try{return await e.Promises.access(ue),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return O}get writeFile(){return i}get rm(){return h}get move(){return E}get copy(){return w}}}),define(pe[162],be([1,0,33,7,3,17,23]),function(le,e,S,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(v){if(o.isLinux)return v;const h=(0,L.dirname)(v);if(v===h)return v;const g=((0,L.basename)(v)||v).toLowerCase();try{const r=(0,k.readdirSync)(h).filter(f=>f.toLowerCase()===g);if(r.length===1){const f=R(h);if(f)return(0,L.join)(f,r[0])}else if(r.length>1){const f=r.indexOf(g);if(f>=0){const c=R(h);if(c)return(0,L.join)(c,r[f])}}}catch{}return null}e.realcaseSync=R;async function b(v){if(o.isLinux)return v;const h=(0,L.dirname)(v);if(v===h)return v;const g=((0,L.basename)(v)||v).toLowerCase();try{const r=(await k.Promises.readdir(h)).filter(f=>f.toLowerCase()===g);if(r.length===1){const f=await b(h);if(f)return(0,L.join)(f,r[0])}else if(r.length>1){const f=r.indexOf(g);if(f>=0){const c=await b(h);if(c)return(0,L.join)(c,r[f])}}}catch{}return null}e.realcase=b;async function m(v){try{return await k.Promises.realpath(v)}catch{const g=y(v);return await k.Promises.access(g,S.constants.R_OK),g}}e.realpath=m;function T(v){try{return S.realpathSync(v)}catch{const g=y(v);return S.accessSync(g,S.constants.R_OK),g}}e.realpathSync=T;function y(v){return(0,A.rtrim)((0,L.normalize)(v),L.sep)}}),define(pe[101],be([1,0,28,7,23]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,k=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var b;(function(D){D[D.x64=0]="x64",D[D.x86=1]="x86",D[D.ARM=2]="ARM"})(b||(b={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class y{constructor(O,t,n){this.exePath=O,this.displayName=t,this.a=n}async exists(){return this.a===void 0&&(this.a=await o.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:D=!1}={}){return D?m===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:D=!1,findPreview:O=!1}={}){const t=v({useAlternateBitness:D});if(!t)return null;const n=L.join(t,"PowerShell");if(!await o.SymlinkSupport.existsDirectory(n))return null;let s=-1,i=null;for(const d of await o.Promises.readdir(n)){let I=-1;if(O){const E=d.indexOf("-");if(E<0)continue;const w=d.substring(0,E);if(!A.test(w)||d.substring(E+1)!=="preview")continue;I=parseInt(w,10)}else{if(!A.test(d))continue;I=parseInt(d,10)}if(I<=s)continue;const C=L.join(n,d,"pwsh.exe");await o.SymlinkSupport.existsFile(C)&&(i=C,s=I)}if(!i)return null;const a=t.includes("x86")?" (x86)":"",l=O?" Preview":"";return new y(i,`PowerShell${l}${a}`,!0)}async function g({findPreview:D}={}){if(!process.env.LOCALAPPDATA)return null;const O=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await o.SymlinkSupport.existsDirectory(O))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=D?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const s of await o.Promises.readdir(O))if(t.test(s)){const i=L.join(O,s,"pwsh.exe");return new y(i,n)}return null}function p(){const D=L.join(S.homedir(),".dotnet","tools","pwsh.exe");return new y(D,".NET Core PowerShell Global Tool")}function r(){const D=L.join(process.env.windir,m===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(D,"Windows PowerShell",!0)}async function*f(){let D=await h();D&&(yield D),D=await h({useAlternateBitness:!0}),D&&(yield D),D=await g(),D&&(yield D),D=p(),D&&(yield D),D=await h({findPreview:!0}),D&&(yield D),D=await g({findPreview:!0}),D&&(yield D),D=await h({useAlternateBitness:!0,findPreview:!0}),D&&(yield D),D=r(),D&&(yield D)}async function*c(){for await(const D of f())await D.exists()&&(yield D)}e.enumeratePowerShellInstallations=c;async function u(){for await(const D of c())return D;return null}e.getFirstAvailablePowerShellInstallation=u}),define(pe[102],be([1,0,7,3,29,59,8,23]),function(le,e,S,L,o,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function b(y=o.env){return y.comspec||"cmd.exe"}e.getWindowsShell=b;function m(y){let v=[],h=!1;const g=function(p){if(h){v.push(p);return}(!y.send(p,f=>{if(f&&console.error(f),h=!1,v.length>0){const c=v.slice(0);v=[],c.forEach(u=>g(u))}})||L.isWindows)&&(h=!0)};return{send:g}}e.createQueuedSender=m;var T;(function(y){async function v(h,g,p){if(S.isAbsolute(h))return h;if(g===void 0&&(g=o.cwd()),S.dirname(h)!=="."||(p===void 0&&k.isString(o.env.PATH)&&(p=o.env.PATH.split(S.delimiter)),p===void 0||p.length===0))return S.join(g,h);async function f(c){if(await R.Promises.exists(c)){let u;try{u=await R.Promises.stat(c)}catch(D){D.message.startsWith("EACCES")&&(u=await R.Promises.lstat(c))}return u?!u.isDirectory():!1}return!1}for(const c of p){let u;if(S.isAbsolute(c)?u=S.join(c,h):u=S.join(g,c,h),await f(u))return u;let D=u+".com";if(await f(D)||(D=u+".exe",await f(D)))return D}return S.join(g,h)}y.findExecutable=v})(T||(e.win32=T={}))}),define(pe[103],be([1,0,52,13]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function o(k){return new Promise((R,b)=>{let m;const T=new Map;function y(h,g,p,r,f){const c=T.get(g);if(h===k||c){const u={name:v(p),cmd:p,pid:h,ppid:g,load:r,mem:f};T.set(h,u),h===k&&(m=u),c&&(c.children||(c.children=[]),c.children.push(u),c.children.length>1&&(c.children=c.children.sort((D,O)=>D.pid-O.pid)))}}function v(h){const g=/--utility-sub-type=network/i,p=/--ms-enable-electron-run-as-node/i,r=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,c=/conhost\.exe/i,u=/--type=([a-zA-Z-]+)/;if(r.exec(h))return"electron-crash-reporter";if(f.exec(h))return"winpty-process";if(c.exec(h))return"console-window-host (Windows internal process)";let D=u.exec(h);if(D&&D.length===2)return D[1]==="renderer"?"window":D[1]==="utility"?g.exec(h)?"utility-network-service":"utility-process":D[1]==="extensionHost"?"extension-host":D[1];const O=/[a-zA-Z-]+\.js/g;let t="";do D=O.exec(h),D&&(t+=D+" ");while(D);return t&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${t})`:p.exec(h)?`electron-nodejs (${h})`:h}if(process.platform==="win32"){const h=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substr(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substr(5):g;new Promise((g,p)=>{le(["@vscode/windows-process-tree"],g,p)}).then(g=>{g.getProcessList(k,p=>{if(!p){b(new Error(`Root process ${k} not found`));return}g.getProcessCpuUsage(p,r=>{const f=new Map;r.forEach(c=>{const u=h(c.commandLine||"");f.set(c.pid,{name:v(u),cmd:u,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),m=f.get(k),m?(f.forEach(c=>{const u=f.get(c.ppid);u&&(u.children||(u.children=[]),u.children.push(c))}),f.forEach(c=>{c.children&&(c.children=c.children.sort((u,D)=>u.pid-D.pid))}),R(m)):b(new Error(`Root process ${k} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let h=function(){let g=[m];const p=[];for(;g.length;){const f=g.shift();f&&(p.push(f.pid),f.children&&(g=g.concat(f.children)))}let r=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);r+=" "+p.join(" "),(0,S.exec)(r,{},(f,c,u)=>{if(f||u)b(f||new Error(u.toString()));else{const D=c.toString().split(`
`);for(let O=0;O<p.length;O++){const t=T.get(p[O]);t.load=parseFloat(D[O])}if(!m){b(new Error(`Root process ${k} not found`));return}R(m)}})};(0,S.exec)("which ps",{},(g,p,r)=>{if(g||r)if(process.platform!=="linux")b(g||new Error(r.toString()));else{const f=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)(f,{},(c,u,D)=>{c||D?b(c||new Error(D.toString())):(A(u,y),h())})}else{const f=p.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${f} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,D,O)=>{u||O&&!O.includes("screen size is bogus")?b(u||new Error(O.toString())):(A(D,y),process.platform==="linux"?h():m?R(m):b(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=o;function A(k,R){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=k.toString().split(`
`);for(const T of m){const y=b.exec(T.trim());y&&y.length===6&&R(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(pe[163],be([1,0,28,3,101,102]),function(le,e,S,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function k(y,v){return y===1?L.isWindows?T():A.getWindowsShell(v):b(y,v)}e.getSystemShell=k;let R=null;function b(y,v){if(L.isLinux&&y===2||L.isMacintosh&&y===3)return"/bin/bash";if(!R){let h;if(L.isWindows)h="/bin/bash";else{if(h=v.SHELL,!h)try{h=(0,S.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}R=h}return R}let m=null;async function T(){return m||(m=(await(0,o.getFirstAvailablePowerShellInstallation)()).exePath),m}});var Le=this&&this.__decorate||function(le,e,S,L){var o=arguments.length,A=o<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,S):L,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(le,e,S,L);else for(var R=le.length-1;R>=0;R--)(k=le[R])&&(A=(o<3?k(A):o>3?k(e,S,A):k(e,S))||A);return o>3&&A&&Object.defineProperty(e,S,A),A};define(pe[42],be([1,0,18,14,15,20,91,11,6,2,50,17,8]),function(le,e,S,L,o,A,k,R,b,m,T,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var h;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(h||(h={}));function g(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(p||(p={}));function r(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(f||(f={}));function c(J){let U=0;for(let ne=0;;ne+=7){const x=J.read(1);if(U|=(x.buffer[0]&127)<<ne,!(x.buffer[0]&128))return U}}const u=s(0);function D(J,U){if(U===0){J.write(u);return}let ne=0;for(let re=U;re!==0;re=re>>>7)ne++;const x=o.VSBuffer.alloc(ne);for(let re=0;U!==0;re++)x.buffer[re]=U&127,U=U>>>7,U>0&&(x.buffer[re]|=128);J.write(x)}class O{constructor(U){this.b=U,this.a=0}read(U){const ne=this.b.slice(this.a,this.a+U);return this.a+=ne.byteLength,ne}}e.BufferReader=O;class t{constructor(){this.a=[]}get buffer(){return o.VSBuffer.concat(this.a)}write(U){this.a.push(U)}}e.BufferWriter=t;var n;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(n||(n={}));function s(J){const U=o.VSBuffer.alloc(1);return U.writeUInt8(J,0),U}const i={Undefined:s(n.Undefined),String:s(n.String),Buffer:s(n.Buffer),VSBuffer:s(n.VSBuffer),Array:s(n.Array),Object:s(n.Object),Uint:s(n.Int)},a=typeof Buffer<"u";function l(J,U){if(typeof U>"u")J.write(i.Undefined);else if(typeof U=="string"){const ne=o.VSBuffer.fromString(U);J.write(i.String),D(J,ne.byteLength),J.write(ne)}else if(a&&Buffer.isBuffer(U)){const ne=o.VSBuffer.wrap(U);J.write(i.Buffer),D(J,ne.byteLength),J.write(ne)}else if(U instanceof o.VSBuffer)J.write(i.VSBuffer),D(J,U.byteLength),J.write(U);else if(Array.isArray(U)){J.write(i.Array),D(J,U.length);for(const ne of U)l(J,ne)}else if(typeof U=="number"&&(U|0)===U)J.write(i.Uint),D(J,U);else{const ne=o.VSBuffer.fromString(JSON.stringify(U));J.write(i.Object),D(J,ne.byteLength),J.write(ne)}}e.serialize=l;function d(J){switch(J.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return J.read(c(J)).toString();case n.Buffer:return J.read(c(J)).buffer;case n.VSBuffer:return J.read(c(J));case n.Array:{const ne=c(J),x=[];for(let re=0;re<ne;re++)x.push(d(J));return x}case n.Object:return JSON.parse(J.read(c(J)).toString());case n.Int:return c(J)}}e.deserialize=d;class I{constructor(U,ne,x=null,re=1e3){this.h=U,this.j=ne,this.k=x,this.l=re,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Y=>this.q(Y)),this.m({type:200})}registerChannel(U,ne){this.b.set(U,ne),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const ne=this.o([U.type]);this.k?.logOutgoing(ne,0,1,r(U.type));return}case 201:case 202:case 204:case 203:{const ne=this.o([U.type,U.id],U.data);this.k?.logOutgoing(ne,U.id,1,r(U.type),U.data);return}}}o(U,ne=void 0){const x=new t;return l(x,U),l(x,ne),this.p(x.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const ne=new O(U),x=d(ne),re=d(ne),Y=x[0];switch(Y){case 100:return this.k?.logIncoming(U.byteLength,x[1],1,`${g(Y)}: ${x[2]}.${x[3]}`,re),this.s({type:Y,id:x[1],channelName:x[2],name:x[3],arg:re});case 102:return this.k?.logIncoming(U.byteLength,x[1],1,`${g(Y)}: ${x[2]}.${x[3]}`,re),this.t({type:Y,id:x[1],channelName:x[2],name:x[3],arg:re});case 101:return this.k?.logIncoming(U.byteLength,x[1],1,`${g(Y)}`),this.u({type:Y,id:x[1]});case 103:return this.k?.logIncoming(U.byteLength,x[1],1,`${g(Y)}`),this.u({type:Y,id:x[1]})}}s(U){const ne=this.b.get(U.channelName);if(!ne){this.v(U);return}const x=new A.CancellationTokenSource;let re;try{re=ne.call(this.j,U.name,U.arg,x.token)}catch(j){re=Promise.reject(j)}const Y=U.id;re.then(j=>{this.m({id:Y,data:j,type:201}),this.d.delete(U.id)},j=>{j instanceof Error?this.m({id:Y,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.m({id:Y,data:j,type:203}),this.d.delete(U.id)});const ee=(0,m.toDisposable)(()=>x.cancel());this.d.set(U.id,ee)}t(U){const ne=this.b.get(U.channelName);if(!ne){this.v(U);return}const x=U.id,Y=ne.listen(this.j,U.name,U.arg)(ee=>this.m({id:x,data:ee,type:204}));this.d.set(U.id,Y)}u(U){const ne=this.d.get(U.id);ne&&(ne.dispose(),this.d.delete(U.id))}v(U){let ne=this.g.get(U.channelName);ne||(ne=[],this.g.set(U.channelName,ne));const x=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ne.push({request:U,timeoutTimer:x})}w(U){const ne=this.g.get(U);if(ne){for(const x of ne)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.s(x.request);break;case 102:this.t(x.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=I;var C;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));class E{constructor(U,ne=null){this.l=U,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(x=>this.s(x)),this.j=ne}getChannel(U){const ne=this;return{call(x,re,Y){return ne.a?Promise.reject(new R.CancellationError):ne.m(U,x,re,Y)},listen(x,re){return ne.a?b.Event.None:ne.o(U,x,re)}}}m(U,ne,x,re=A.CancellationToken.None){const Y=this.g++,j={id:Y,type:100,channelName:U,name:ne,arg:x};if(re.isCancellationRequested)return Promise.reject(new R.CancellationError);let P;return new Promise((K,te)=>{if(re.isCancellationRequested)return te(new R.CancellationError);const z=()=>{const Q=G=>{switch(G.type){case 201:this.f.delete(Y),K(G.data);break;case 202:{this.f.delete(Y);const Z=new Error(G.data.message);Z.stack=Array.isArray(G.data.stack)?G.data.stack.join(`
`):G.data.stack,Z.name=G.data.name,te(Z);break}case 203:this.f.delete(Y),te(G.data);break}};this.f.set(Y,Q),this.p(j)};let W=null;this.b===f.Idle?z():(W=(0,L.createCancelablePromise)(Q=>this.u()),W.then(()=>{W=null,z()}));const q=()=>{W?(W.cancel(),W=null):this.p({id:Y,type:101}),te(new R.CancellationError)},H=re.onCancellationRequested(q);P=(0,m.combinedDisposable)((0,m.toDisposable)(q),H),this.d.add(P)}).finally(()=>{this.d.delete(P)})}o(U,ne,x){const re=this.g++,ee={id:re,type:102,channelName:U,name:ne,arg:x};let j=null;const P=new b.Emitter({onWillAddFirstListener:()=>{j=(0,L.createCancelablePromise)(K=>this.u()),j.then(()=>{j=null,this.d.add(P),this.p(ee)})},onDidRemoveLastListener:()=>{j?(j.cancel(),j=null):(this.d.delete(P),this.p({id:re,type:103}))}}),M=K=>P.fire(K.data);return this.f.set(re,M),P.event}p(U){switch(U.type){case 100:case 102:{const ne=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(ne,U.id,0,`${g(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const ne=this.q([U.type,U.id]);this.j?.logOutgoing(ne,U.id,0,g(U.type));return}}}q(U,ne=void 0){const x=new t;return l(x,U),l(x,ne),this.r(x.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const ne=new O(U),x=d(ne),re=d(ne),Y=x[0];switch(Y){case 200:return this.j?.logIncoming(U.byteLength,0,0,r(Y)),this.t({type:x[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,x[1],0,r(Y),re),this.t({type:x[0],id:x[1],data:re})}}t(U){if(U.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.dispose)(this.d.values()),this.d.clear()}}e.ChannelClient=E,Le([k.memoize],E.prototype,"onDidInitializePromise",null);class w{get connections(){const U=[];return this.f.forEach(ne=>U.push(ne)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new b.Emitter,this.onDidAddConnection=this.g.event,this.h=new b.Emitter,this.onDidRemoveConnection=this.h.event,U(({protocol:ne,onDidClientDisconnect:x})=>{b.Event.once(ne.onMessage)(Y=>{const ee=new O(Y),j=d(ee),P=new I(ne,j),M=new E(ne);this.a.forEach((te,z)=>P.registerChannel(z,te));const K={channelServer:P,channelClient:M,ctx:j};this.f.add(K),this.g.fire(K),x(()=>{P.dispose(),M.dispose(),this.f.delete(K),this.h.fire(K)})})})}getChannel(U,ne){const x=this;return{call(re,Y,ee){let j;if((0,v.isFunction)(ne)){const M=(0,S.getRandomElement)(x.connections.filter(ne));j=M?Promise.resolve(M):b.Event.toPromise(b.Event.filter(x.onDidAddConnection,ne))}else j=ne.routeCall(x,re,Y);const P=j.then(M=>M.channelClient.getChannel(U));return $(P).call(re,Y,ee)},listen(re,Y){if((0,v.isFunction)(ne))return x.j(U,ne,re,Y);const ee=ne.routeEvent(x,re,Y).then(j=>j.channelClient.getChannel(U));return $(ee).listen(re,Y)}}}j(U,ne,x,re){const Y=this;let ee=new m.DisposableStore;const j=new b.Emitter({onWillAddFirstListener:()=>{ee=new m.DisposableStore;const P=new b.EventMultiplexer,M=new Map,K=z=>{const q=z.channelClient.getChannel(U).listen(x,re),H=P.add(q);M.set(z,H)},te=z=>{const W=M.get(z);W&&(W.dispose(),M.delete(z))};Y.connections.filter(ne).forEach(K),b.Event.filter(Y.onDidAddConnection,ne)(K,void 0,ee),Y.onDidRemoveConnection(te,void 0,ee),P.event(j.fire,j,ee),ee.add(P)},onDidRemoveLastListener:()=>{ee.dispose()}});return j.event}registerChannel(U,ne){this.a.set(U,ne),this.f.forEach(x=>{x.channelServer.registerChannel(U,ne)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=w;class N{constructor(U,ne,x=null){const re=new t;l(re,ne),U.send(re.buffer),this.a=new E(U,x),this.d=new I(U,ne,x)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,ne){this.d.registerChannel(U,ne)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function $(J){return{call(U,ne,x){return J.then(re=>re.call(U,ne,x))},listen(U,ne){const x=new b.Relay;return J.then(re=>x.input=re.listen(U,ne)),x.event}}}e.getDelayedChannel=$;function se(J){let U=!1;return{call(ne,x,re){return U?J.call(ne,x,re):(0,L.timeout)(0).then(()=>U=!0).then(()=>J.call(ne,x,re))},listen(ne,x){if(U)return J.listen(ne,x);const re=new b.Relay;return(0,L.timeout)(0).then(()=>U=!0).then(()=>re.input=J.listen(ne,x)),re.event}}}e.getNextTickChannel=se;class he{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const ne of U.connections)if(await Promise.resolve(this.a(ne.ctx)))return Promise.resolve(ne);return await b.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.StaticRouter=he;var ae;(function(J){function U(Y,ee){const j=Y,P=ee&&ee.disableMarshalling,M=new Map;for(const K in j)x(K)&&M.set(K,b.Event.buffer(j[K],!0));return new class{listen(K,te,z){const W=M.get(te);if(W)return W;if(re(te)){const q=j[te];if(typeof q=="function")return q.call(j,z)}throw new Error(`Event not found: ${te}`)}call(K,te,z){const W=j[te];if(typeof W=="function"){if(!P&&Array.isArray(z))for(let q=0;q<z.length;q++)z[q]=(0,T.revive)(z[q]);return W.apply(j,z)}throw new Error(`Method not found: ${te}`)}}}J.fromService=U;function ne(Y,ee){const j=ee&&ee.disableMarshalling;return new Proxy({},{get(P,M){if(typeof M=="string")return ee?.properties?.has(M)?ee.properties.get(M):re(M)?function(K){return Y.listen(M,K)}:x(M)?Y.listen(M):async function(...K){let te;ee&&!(0,v.isUndefinedOrNull)(ee.context)?te=[ee.context,...K]:te=K;const z=await Y.call(M,te);return j?z:(0,T.revive)(z)};throw new Error(`Property not found: ${String(M)}`)}})}J.toService=ne;function x(Y){return Y[0]==="o"&&Y[1]==="n"&&y.isUpperAsciiLetter(Y.charCodeAt(2))}function re(Y){return/^onDynamic/.test(Y)&&y.isUpperAsciiLetter(Y.charCodeAt(9))}})(ae||(e.ProxyChannel=ae={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const U=J.toString();if(U!=="[object Object]")return U}return J}function _(J){return Array.isArray(J)?J.map(ge):ge(J)}function ie(J,U,ne,x,re,Y,ee){ee=_(ee);const j=ue[re],P=j[x%j.length];let M=[`%c[${J}]%c[${String(U).padStart(7," ")}]%c[len: ${String(ne).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(Y)?(M=M.concat(ee),M.push(")")):M.push(ee),console.log.apply(console,M)}class V{constructor(U,ne){this.d=U,this.f=ne,this.a=0,this.b=0}logOutgoing(U,ne,x,re,Y){this.b+=U,ie(this.d,this.b,U,ne,x,re,Y)}logIncoming(U,ne,x,re,Y){this.a+=U,ie(this.f,this.a,U,ne,x,re,Y)}}e.IPCLogger=V}),define(pe[104],be([1,0,14,15,6,2,42]),function(le,e,S,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var b;(function(E){E.enableDiagnostics=!1,E.records=[];const w=new WeakMap;let N=0;function $(he,ae){if(!w.has(he)){const ue=String(++N);w.set(he,ue)}return w.get(he)}function se(he,ae,ue,ge){if(!E.enableDiagnostics)return;const _=$(he,ae);if(ge instanceof L.VSBuffer||ge instanceof Uint8Array||ge instanceof ArrayBuffer||ArrayBuffer.isView(ge)){const ie=L.VSBuffer.alloc(ge.byteLength);ie.set(ge),E.records.push({timestamp:Date.now(),id:_,label:ae,type:ue,buff:ie})}else E.records.push({timestamp:Date.now(),id:_,label:ae,type:ue,data:ge})}E.traceSocketEvent=se})(b||(e.SocketDiagnostics=b={}));var m;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m||(e.SocketCloseEventType=m={}));let T=null;function y(){return T||(T=L.VSBuffer.alloc(0)),T}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(w){this.a.push(w),this.b+=w.byteLength}read(w){return this.c(w,!0)}peek(w){return this.c(w,!1)}c(w,N){if(w===0)return y();if(w>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===w){const ae=this.a[0];return N&&(this.a.shift(),this.b-=w),ae}if(this.a[0].byteLength>w){const ae=this.a[0].slice(0,w);return N&&(this.a[0]=this.a[0].slice(w),this.b-=w),ae}const $=L.VSBuffer.alloc(w);let se=0,he=0;for(;w>0;){const ae=this.a[he];if(ae.byteLength>w){const ue=ae.slice(0,w);$.set(ue,se),se+=w,N&&(this.a[he]=ae.slice(w),this.b-=w),w-=w}else $.set(ae,se),se+=ae.byteLength,N?(this.a.shift(),this.b-=ae.byteLength):he++,w-=ae.byteLength}return $}}e.ChunkStream=v;var h;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(h||(h={}));function g(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var p;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(p||(e.ProtocolConstants=p={}));class r{constructor(w,N,$,se){this.type=w,this.id=N,this.ack=$,this.data=se,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends A.Disposable{constructor(w){super(),this.f=this.B(new o.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=w,this.b=!1,this.c=new v,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(w){if(!(!w||w.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(w);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:g(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const $=this.g.messageType,se=this.g.id,he=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new r($,se,he,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(w){this.k=null,this.a=!1,this.b=!1,this.c=w,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(w){if(this.a)return;w.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=L.VSBuffer.alloc(13);N.writeUInt8(w.type,0),N.writeUInt32BE(w.id,1),N.writeUInt32BE(w.ack,5),N.writeUInt32BE(w.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:g(w.type),id:w.id,ack:w.ack,messageSize:w.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",w.data),this.j(N,w.data)}g(w,N){const $=this.f===0;return this.d.push(w,N),this.f+=w.byteLength+N.byteLength,$}h(){const w=L.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,w}j(w,N){this.g(w,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const w=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:w.byteLength}),this.c.write(w)}}class u extends A.Disposable{constructor(w){super(),this.f=new o.Emitter,this.onMessage=this.f.event,this.g=new o.Emitter,this.onDidDispose=this.g.event,this.a=w,this.b=this.B(new c(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(w){this.b.write(new r(1,0,0,w))}}e.Protocol=u;class D extends k.IPCClient{static fromSocket(w,N){return new D(new u(w),N)}get onDidDispose(){return this.b.onDidDispose}constructor(w,N,$=null){super(w,N,$),this.b=w}dispose(){super.dispose();const w=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),w.end()}}e.Client=D;class O{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new o.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(w){this.b?this.d.length>0?this.d.push(w):this.a.fire(w):this.d.push(w)}flushBuffer(){this.d=[]}}e.BufferedEmitter=O;class t{constructor(w){this.data=w,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let w=0,N=this.a;for(;N;)N=N.next,w++;return w}peek(){return this.a?this.a.data:null}toArray(){const w=[];let N=0,$=this.a;for(;$;)w[N++]=$.data,$=$.next;return w}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(w){const N=new t(w);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class s{static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const w=Date.now();for(let N=0;N<s.a;N++)this.c[N]=w-1e3*N;setInterval(()=>{for(let N=s.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const w=Date.now(),N=(1+s.a)*1e3;let $=0;for(let se=0;se<s.a;se++)w-this.c[se]<=N&&$++;return 1-$/s.a}hasHighLoad(){return this.d()>=.5}}s.a=10,s.b=null;var i;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(i||(e.ConnectionHealth=i={}));function a(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=a;class l{constructor(w){this.connectionHealth=w}}e.ConnectionHealthChangedEvent=l;class d{constructor(w,N){this.roundTripTime=w,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=d;class I{get unacknowledgedCount(){return this.c-this.d}constructor(w){this.x=new O,this.onControlMessage=this.x.event,this.y=new O,this.onMessage=this.y.event,this.z=new O,this.onDidDispose=this.z.event,this.A=new O,this.onSocketClose=this.A.event,this.B=new O,this.onSocketTimeout=this.B.event,this.C=new O,this.onHighRoundTripTime=this.C.event,this.D=new O,this.onDidChangeConnectionHealth=this.D.event,this.u=w.loadEstimator??s.getInstance(),this.v=w.measureRoundTripTime??!1,this.w=w.sendKeepAlive??!0,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new A.DisposableStore,this.o=w.socket,this.p=this.t.add(new c(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new C),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),w.initialChunk&&this.q.acceptChunk(w.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const w=new r(5,0,0,y());this.p.write(w),this.p.flush()}sendPause(){const w=new r(7,0,0,y());this.p.write(w)}sendResume(){const w=new r(8,0,0,y());this.p.write(w)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(w,N){this.a=!0,this.t.dispose(),this.t=new A.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=w,this.p=this.t.add(new c(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage($=>this.E($))),this.t.add(this.o.onClose($=>this.A.fire($))),this.r=this.t.add(new C),this.t.add(this.r.onSendLatencyRequest($=>this.J($))),this.t.add(this.r.onHighRoundTripTime($=>this.C.fire($))),this.t.add(this.r.onDidChangeConnectionHealth($=>this.D.fire($))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const w=new r(3,0,this.h,y());this.p.write(w);const N=this.b.toArray();for(let $=0,se=N.length;$<se;$++)this.p.write(N[$]);this.G()}acceptDisconnect(){this.z.fire()}E(w){if(w.ack>this.d){this.d=w.ack;do{const N=this.b.peek();if(N&&N.id<=w.ack)this.b.pop();else break}while(!0)}switch(w.type){case 0:break;case 1:{if(w.id>this.g)if(w.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new r(6,0,0,y())))}else this.g=w.id,this.j=Date.now(),this.F(),this.y.fire(w.data);break}case 2:{this.x.fire(w.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let $=0,se=N.length;$<se;$++)this.p.write(N[$]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(w.data);break}case 11:{this.r.handleResponse(w.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(w){const N=++this.c;this.h=this.g;const $=new r(1,N,this.h,w);this.b.push($),this.a||(this.p.write($),this.G())}sendControl(w){const N=new r(2,0,0,w);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const w=Date.now()-this.j;if(w>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-w+5)}G(){if(this.c<=this.d||this.f||this.a)return;const w=this.b.peek(),N=Date.now()-w.writtenTime,$=Date.now()-this.q.lastReadTime,se=Date.now()-this.n;if(N>=2e4&&$>=2e4&&se>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:$});return}const he=Math.max(2e4-N,2e4-$,2e4-se,500);this.f=setTimeout(()=>{this.f=null,this.G()},he)}H(){if(this.g<=this.h)return;this.h=this.g;const w=new r(3,0,this.h,y());this.p.write(w)}I(){this.h=this.g;const w=new r(9,0,this.h,y());this.p.write(w)}J(w){this.h=this.g;const N=new r(10,0,this.h,w);this.p.write(N)}K(w){this.h=this.g;const N=new r(11,0,this.h,w);this.p.write(N)}}e.PersistentProtocol=I;class C extends A.Disposable{constructor(){super(),this.a=this.B(new o.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new o.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new o.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new S.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},w=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const w=++this.h,N=L.VSBuffer.alloc(4);N.writeUInt32BE(w,0),this.a.fire(N)},6e4)}handleResponse(w){if(w.byteLength!==4)return;const N=w.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const $=Date.now()-this.g,se=this.k++;this.j[se%this.j.length]=$;const he=this.l,ae=this.j.filter(ue=>ue>=1e3).length;this.l=ae>=3?1:0,$>1e3&&this.b.fire(new d($,ae)),he!==this.l&&this.c.fire(this.l)}}}),define(pe[105],be([1,0,52,14,15,20,160,11,6,2,21,102,59,42]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends h.ChannelServer{constructor(f){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",c=>o.VSBuffer.wrap(Buffer.from(c,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=g;class p{constructor(f,c){this.i=f,this.j=c,this.c=new Set,this.g=new Map,this.h=new b.Emitter,this.onDidProcessExit=this.h.event;const u=c&&c.timeout?c.timeout:6e4;this.b=new L.Delayer(u),this.d=null,this.f=null}getChannel(f){const c=this;return{call(u,D,O){return c.k(f,u,D,O)},listen(u,D){return c.l(f,u,D)}}}k(f,c,u,D=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(D.isCancellationRequested)return Promise.reject(R.canceled());this.b.cancel();const O=this.n(f),t=(0,L.createCancelablePromise)(i=>O.call(c,u,i)),n=D.onCancellationRequested(()=>t.cancel()),s=(0,m.toDisposable)(()=>t.cancel());return this.c.add(s),t.finally(()=>{n.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,c,u){if(!this.b)return b.Event.None;this.b.cancel();let D;const O=new b.Emitter({onWillAddFirstListener:()=>{D=this.n(f).listen(c,u)(O.fire,O),this.c.add(D)},onDidRemoveLastListener:()=>{this.c.delete(D),D.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return O.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],c=Object.create(null);c.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(c.env={...c.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(c.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,v.removeDangerousEnvVariables)(c.env),this.d=(0,S.fork)(this.i,f,c);const u=new b.Emitter;b.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,k.isRemoteConsoleLog)(a)){(0,k.log)(a,`IPC Library: ${this.j.serverName}`);return}u.fire(o.VSBuffer.wrap(Buffer.from(a,"base64")))});const O=this.j.useQueue?(0,y.createQueuedSender)(this.d):this.d,t=a=>this.d&&this.d.connected&&O.send(a.buffer.toString("base64")),n=u.event,s={send:t,onMessage:n};this.f=new h.ChannelClient(s);const i=()=>this.o();process.once("exit",i),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,l)=>{process.removeListener("exit",i),this.c.forEach(d=>(0,m.dispose)(d)),this.c.clear(),a!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:l})})}return this.f}n(f){let c=this.g.get(f);return c||(c=this.m.getChannel(f),this.g.set(f,c)),c}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=p}),define(pe[164],be([1,0,14,6,2,50,8]),function(le,e,S,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var R;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function b(v){const h=v;return h?.changed instanceof Map||h?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var m;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(m||(e.StorageState=m={}));class T extends o.Disposable{constructor(h,g=Object.create(null)){super(),this.m=h,this.n=g,this.b=this.B(new L.Emitter),this.onDidChangeStorage=this.b.event,this.c=m.None,this.f=new Map,this.g=new S.ThrottledDelayer(T.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(h=>this.r(h)))}r(h){h.changed?.forEach((g,p)=>this.s(p,g)),h.deleted?.forEach(g=>this.s(g,void 0))}s(h,g){if(this.c===m.Closed)return;let p=!1;(0,k.isUndefinedOrNull)(g)?p=this.f.delete(h):this.f.get(h)!==g&&(this.f.set(h,g),p=!0),p&&this.b.fire(h)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===m.None&&(this.c=m.Initialized,this.n.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(h,g){const p=this.f.get(h);return(0,k.isUndefinedOrNull)(p)?g:p}getBoolean(h,g){const p=this.get(h);return(0,k.isUndefinedOrNull)(p)?g:p==="true"}getNumber(h,g){const p=this.get(h);return(0,k.isUndefinedOrNull)(p)?g:parseInt(p,10)}getObject(h,g){const p=this.get(h);return(0,k.isUndefinedOrNull)(p)?g:(0,A.parse)(p)}async set(h,g){if(this.c===m.Closed)return;if((0,k.isUndefinedOrNull)(g))return this.delete(h);const p=(0,k.isObject)(g)||Array.isArray(g)?(0,A.stringify)(g):String(g);if(this.f.get(h)!==p)return this.f.set(h,p),this.j.set(h,p),this.h.delete(h),this.b.fire(h),this.w()}async delete(h){if(!(this.c===m.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire(h),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=m.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(h).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(h){if(this.u)return this.w(h)}async w(h){return this.g.trigger(()=>this.v(),h)}async whenFlushed(){if(this.u)return new Promise(h=>this.l.push(h))}isInMemory(){return this.n.hint===R.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=T,T.a=100;class y{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((g,p)=>this.a.set(p,g)),h.delete?.forEach(g=>this.a.delete(g))}async close(){}}e.InMemoryStorageDatabase=y}),define(pe[165],be([1,0,6,2]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class o{constructor(){this.a=new Map,this.b=new Map,this.c=new S.Emitter,this.onDidChange=this.c.event,this.d=null}handleChange(R){this.c.fire({changedLanguages:R,changedColorMap:!1})}register(R,b){return this.a.set(R,b),this.handleChange([R]),(0,L.toDisposable)(()=>{this.a.get(R)===b&&(this.a.delete(R),this.handleChange([R]))})}get(R){return this.a.get(R)||null}registerFactory(R,b){this.b.get(R)?.dispose();const m=new A(this,R,b);return this.b.set(R,m),(0,L.toDisposable)(()=>{const T=this.b.get(R);!T||T!==m||(this.b.delete(R),T.dispose())})}async getOrCreate(R){const b=this.get(R);if(b)return b;const m=this.b.get(R);return!m||m.isResolved?null:(await m.resolve(),this.get(R))}isResolved(R){if(this.get(R))return!0;const m=this.b.get(R);return!!(!m||m.isResolved)}setColorMap(R){this.d=R,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=o;class A extends L.Disposable{get isResolved(){return this.c}constructor(R,b,m){super(),this.f=R,this.g=b,this.h=m,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const R=await this.h.tokenizationSupport;this.c=!0,R&&!this.a&&this.B(this.f.register(this.g,R))}}}),define(pe[166],be([1,0,48,4,49,165]),function(le,e,S,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class k{constructor(N,$,se){this.offset=N,this.type=$,this.language=se,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=k;class R{constructor(N,$){this.tokens=N,this.endState=$,this._tokenizationResultBrand=void 0}}e.TokenizationResult=R;class b{constructor(N,$){this.tokens=N,this.endState=$,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=b;var m;(function(w){w[w.Method=0]="Method",w[w.Function=1]="Function",w[w.Constructor=2]="Constructor",w[w.Field=3]="Field",w[w.Variable=4]="Variable",w[w.Class=5]="Class",w[w.Struct=6]="Struct",w[w.Interface=7]="Interface",w[w.Module=8]="Module",w[w.Property=9]="Property",w[w.Event=10]="Event",w[w.Operator=11]="Operator",w[w.Unit=12]="Unit",w[w.Value=13]="Value",w[w.Constant=14]="Constant",w[w.Enum=15]="Enum",w[w.EnumMember=16]="EnumMember",w[w.Keyword=17]="Keyword",w[w.Text=18]="Text",w[w.Color=19]="Color",w[w.File=20]="File",w[w.Reference=21]="Reference",w[w.Customcolor=22]="Customcolor",w[w.Folder=23]="Folder",w[w.TypeParameter=24]="TypeParameter",w[w.User=25]="User",w[w.Issue=26]="Issue",w[w.Snippet=27]="Snippet"})(m||(e.CompletionItemKind=m={}));var T;(function(w){const N=new Map;N.set(0,S.Codicon.symbolMethod),N.set(1,S.Codicon.symbolFunction),N.set(2,S.Codicon.symbolConstructor),N.set(3,S.Codicon.symbolField),N.set(4,S.Codicon.symbolVariable),N.set(5,S.Codicon.symbolClass),N.set(6,S.Codicon.symbolStruct),N.set(7,S.Codicon.symbolInterface),N.set(8,S.Codicon.symbolModule),N.set(9,S.Codicon.symbolProperty),N.set(10,S.Codicon.symbolEvent),N.set(11,S.Codicon.symbolOperator),N.set(12,S.Codicon.symbolUnit),N.set(13,S.Codicon.symbolValue),N.set(15,S.Codicon.symbolEnum),N.set(14,S.Codicon.symbolConstant),N.set(15,S.Codicon.symbolEnum),N.set(16,S.Codicon.symbolEnumMember),N.set(17,S.Codicon.symbolKeyword),N.set(27,S.Codicon.symbolSnippet),N.set(18,S.Codicon.symbolText),N.set(19,S.Codicon.symbolColor),N.set(20,S.Codicon.symbolFile),N.set(21,S.Codicon.symbolReference),N.set(22,S.Codicon.symbolCustomColor),N.set(23,S.Codicon.symbolFolder),N.set(24,S.Codicon.symbolTypeParameter),N.set(25,S.Codicon.account),N.set(26,S.Codicon.issues);function $(ae){let ue=N.get(ae);return ue||(console.info("No codicon found for CompletionItemKind "+ae),ue=S.Codicon.symbolProperty),ue}w.toIcon=$;const se=new Map;se.set("method",0),se.set("function",1),se.set("constructor",2),se.set("field",3),se.set("variable",4),se.set("class",5),se.set("struct",6),se.set("interface",7),se.set("module",8),se.set("property",9),se.set("event",10),se.set("operator",11),se.set("unit",12),se.set("value",13),se.set("constant",14),se.set("enum",15),se.set("enum-member",16),se.set("enumMember",16),se.set("keyword",17),se.set("snippet",27),se.set("text",18),se.set("color",19),se.set("file",20),se.set("reference",21),se.set("customcolor",22),se.set("folder",23),se.set("type-parameter",24),se.set("typeParameter",24),se.set("account",25),se.set("issue",26);function he(ae,ue){let ge=se.get(ae);return typeof ge>"u"&&!ue&&(ge=9),ge}w.fromString=he})(T||(e.CompletionItemKinds=T={}));var y;(function(w){w[w.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var v;(function(w){w[w.None=0]="None",w[w.KeepWhitespace=1]="KeepWhitespace",w[w.InsertAsSnippet=4]="InsertAsSnippet"})(v||(e.CompletionItemInsertTextRule=v={}));var h;(function(w){w[w.Invoke=0]="Invoke",w[w.TriggerCharacter=1]="TriggerCharacter",w[w.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(e.CompletionTriggerKind=h={}));var g;(function(w){w[w.Automatic=0]="Automatic",w[w.Explicit=1]="Explicit"})(g||(e.InlineCompletionTriggerKind=g={}));class p{constructor(N,$,se,he){this.range=N,this.text=$,this.completionKind=se,this.isSnippetText=he}equals(N){return o.Range.lift(this.range).equalsRange(N.range)&&this.text===N.text&&this.completionKind===N.completionKind&&this.isSnippetText===N.isSnippetText}}e.SelectedSuggestionInfo=p;var r;(function(w){w[w.Invoke=1]="Invoke",w[w.Auto=2]="Auto"})(r||(e.CodeActionTriggerType=r={}));var f;(function(w){w[w.Invoke=1]="Invoke",w[w.TriggerCharacter=2]="TriggerCharacter",w[w.ContentChange=3]="ContentChange"})(f||(e.SignatureHelpTriggerKind=f={}));var c;(function(w){w[w.Text=0]="Text",w[w.Read=1]="Read",w[w.Write=2]="Write"})(c||(e.DocumentHighlightKind=c={}));function u(w){return w&&L.URI.isUri(w.uri)&&o.Range.isIRange(w.range)&&(o.Range.isIRange(w.originSelectionRange)||o.Range.isIRange(w.targetSelectionRange))}e.isLocationLink=u;var D;(function(w){w[w.File=0]="File",w[w.Module=1]="Module",w[w.Namespace=2]="Namespace",w[w.Package=3]="Package",w[w.Class=4]="Class",w[w.Method=5]="Method",w[w.Property=6]="Property",w[w.Field=7]="Field",w[w.Constructor=8]="Constructor",w[w.Enum=9]="Enum",w[w.Interface=10]="Interface",w[w.Function=11]="Function",w[w.Variable=12]="Variable",w[w.Constant=13]="Constant",w[w.String=14]="String",w[w.Number=15]="Number",w[w.Boolean=16]="Boolean",w[w.Array=17]="Array",w[w.Object=18]="Object",w[w.Key=19]="Key",w[w.Null=20]="Null",w[w.EnumMember=21]="EnumMember",w[w.Struct=22]="Struct",w[w.Event=23]="Event",w[w.Operator=24]="Operator",w[w.TypeParameter=25]="TypeParameter"})(D||(e.SymbolKind=D={}));var O;(function(w){w[w.Deprecated=1]="Deprecated"})(O||(e.SymbolTag=O={}));var t;(function(w){const N=new Map;N.set(0,S.Codicon.symbolFile),N.set(1,S.Codicon.symbolModule),N.set(2,S.Codicon.symbolNamespace),N.set(3,S.Codicon.symbolPackage),N.set(4,S.Codicon.symbolClass),N.set(5,S.Codicon.symbolMethod),N.set(6,S.Codicon.symbolProperty),N.set(7,S.Codicon.symbolField),N.set(8,S.Codicon.symbolConstructor),N.set(9,S.Codicon.symbolEnum),N.set(10,S.Codicon.symbolInterface),N.set(11,S.Codicon.symbolFunction),N.set(12,S.Codicon.symbolVariable),N.set(13,S.Codicon.symbolConstant),N.set(14,S.Codicon.symbolString),N.set(15,S.Codicon.symbolNumber),N.set(16,S.Codicon.symbolBoolean),N.set(17,S.Codicon.symbolArray),N.set(18,S.Codicon.symbolObject),N.set(19,S.Codicon.symbolKey),N.set(20,S.Codicon.symbolNull),N.set(21,S.Codicon.symbolEnumMember),N.set(22,S.Codicon.symbolStruct),N.set(23,S.Codicon.symbolEvent),N.set(24,S.Codicon.symbolOperator),N.set(25,S.Codicon.symbolTypeParameter);function $(se){let he=N.get(se);return he||(console.info("No codicon found for SymbolKind "+se),he=S.Codicon.symbolProperty),he}w.toIcon=$})(t||(e.SymbolKinds=t={}));class n{static fromValue(N){switch(N){case"comment":return n.Comment;case"imports":return n.Imports;case"region":return n.Region}return new n(N)}constructor(N){this.value=N}}e.FoldingRangeKind=n,n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region");var s;(function(w){function N($){return!$||typeof $!="object"?!1:typeof $.id=="string"&&typeof $.title=="string"}w.is=N})(s||(e.Command=s={}));var i;(function(w){w[w.Collapsed=0]="Collapsed",w[w.Expanded=1]="Expanded"})(i||(e.CommentThreadCollapsibleState=i={}));var a;(function(w){w[w.Unresolved=0]="Unresolved",w[w.Resolved=1]="Resolved"})(a||(e.CommentThreadState=a={}));var l;(function(w){w[w.Editing=0]="Editing",w[w.Preview=1]="Preview"})(l||(e.CommentMode=l={}));var d;(function(w){w[w.Published=0]="Published",w[w.Draft=1]="Draft"})(d||(e.CommentState=d={}));var I;(function(w){w[w.Type=1]="Type",w[w.Parameter=2]="Parameter"})(I||(e.InlayHintKind=I={}));class C{constructor(N){this.b=N,this.a=null}dispose(){this.a&&this.a.then(N=>{N&&N.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.LazyTokenizationSupport=C,e.TokenizationRegistry=new A.TokenizationRegistry;var E;(function(w){w[w.None=0]="None",w[w.Option=1]="Option",w[w.Default=2]="Default",w[w.Preferred=3]="Preferred"})(E||(e.ExternalUriOpenerPriority=E={}))}),define(pe[167],be([9,10]),function(le,e){return le.create("vs/base/node/zip",e)}),define(pe[168],be([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[169],be([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(pe[170],be([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(pe[171],be([9,10]),function(le,e){return le.create("vs/platform/environment/node/argv",e)}),define(pe[172],be([9,10]),function(le,e){return le.create("vs/platform/environment/node/argvHelper",e)}),define(pe[173],be([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(pe[174],be([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[175],be([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(pe[176],be([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(pe[177],be([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(pe[178],be([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(pe[179],be([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(pe[180],be([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[181],be([9,10]),function(le,e){return le.create("vs/platform/files/common/fileService",e)}),define(pe[182],be([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(pe[183],be([9,10]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(pe[184],be([9,10]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(pe[185],be([9,10]),function(le,e){return le.create("vs/platform/languagePacks/common/languagePacks",e)}),define(pe[186],be([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(pe[187],be([9,10]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(pe[188],be([9,10]),function(le,e){return le.create("vs/platform/shell/node/shellEnv",e)}),define(pe[189],be([9,10]),function(le,e){return le.create("vs/platform/telemetry/common/telemetryService",e)}),define(pe[190],be([9,10]),function(le,e){return le.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(pe[191],be([9,10]),function(le,e){return le.create("vs/platform/terminal/common/terminalProfiles",e)}),define(pe[192],be([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(pe[193],be([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(pe[194],be([9,10]),function(le,e){return le.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(pe[195],be([9,10]),function(le,e){return le.create("vs/server/node/serverEnvironmentService",e)}),define(pe[196],be([9,10]),function(le,e){return le.create("vs/server/node/serverServices",e)}),define(pe[197],be([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(pe[198],be([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(pe[199],be([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[200],be([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(pe[201],be([1,0,11,170]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var o;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(o||(e.TokenType=o={}));function A(...m){switch(m.length){case 1:return(0,L.localize)(0,null,m[0]);case 2:return(0,L.localize)(1,null,m[0],m[1]);case 3:return(0,L.localize)(2,null,m[0],m[1],m[2]);default:return}}const k=(0,L.localize)(3,null),R=(0,L.localize)(4,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,S.illegalState)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const y=this.d,v=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:v};this.g.push({offset:y,lexeme:v,additionalInfo:T}),this.f.push(h)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const y=this.c.substring(this.d,this.e),v=b.b.get(y);v?this.k(v):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(k);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,y=!1,v=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(R);return}const g=this.c.charCodeAt(T);if(y)y=!1;else if(g===47&&!v){T++;break}else g===91?v=!0:g===92?y=!0:g===93&&(v=!1);T++}for(;T<this.c.length&&b.a.has(this.c.charCodeAt(T));)T++;this.e=T;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.Scanner=b,b.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0))),b.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(pe[202],be([1,0,6,2]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class o{constructor(){this.a=new S.Emitter,this.b=new S.Emitter,this.c=new S.Emitter,this.d=new S.Emitter}call(R,b,m){switch(b){case"close":return Promise.resolve(this.a.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(R,b,m){switch(b){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=o,o.ChannelName="extensionhostdebugservice";class A extends L.Disposable{constructor(R){super(),this.b=R}reload(R){this.b.call("reload",[R])}get onReload(){return this.b.listen("reload")}close(R){this.b.call("close",[R])}get onClose(){return this.b.listen("close")}attachSession(R,b,m){this.b.call("attach",[R,b,m])}get onAttachSession(){return this.b.listen("attach")}terminateSession(R,b){this.b.call("terminate",[R,b])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(R,b){return this.b.call("openExtensionDevelopmentHostWindow",[R,b])}}e.ExtensionHostDebugChannelClient=A}),define(pe[203],be([1,0,4]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class L{constructor(k){this.a=k}listen(k,R,b){throw new Error("Invalid listen")}call(k,R,b){switch(R){case"download":return this.a.download(S.URI.revive(b[0]),S.URI.revive(b[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=L;class o{constructor(k,R){this.a=k,this.b=R}async download(k,R){const b=this.b();b&&(k=b.transformOutgoingURI(k),R=b.transformOutgoingURI(R)),await this.a.call("download",[k,R])}}e.DownloadServiceChannelClient=o}),define(pe[204],be([1,0,151,91,13,7,29,19,4]),function(le,e,S,L,o,A,k,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class m{get appRoot(){return(0,A.dirname)(o.FileAccess.asFileUri("").fsPath)}get userHome(){return b.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return b.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.b.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",h)}return b.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(b.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=k.env.VSCODE_PORTABLE;return h?b.URI.file((0,A.join)(h,"argv.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,A.resolve)(h):(0,A.normalize)((0,A.join)(o.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?b.URI.file((0,A.resolve)(h)):b.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,A.resolve)(h);const g=k.env.VSCODE_EXTENSIONS;if(g)return g;const p=k.env.VSCODE_PORTABLE;return p?(0,A.join)(p,"extensions"):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(g=>/^[^:/?#]+?:\/\//.test(g)?b.URI.parse(g):b.URI.file((0,A.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?b.URI.parse(h):b.URI.file((0,A.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return T(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const g of this.args.log||[]){const p=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(g);p&&p[1]&&p[2]&&h.push([p[1],p[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=k.env.VSCODE_PORTABLE;return h?b.URI.file((0,A.join)(h,"policy.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,g,p){this.a=h,this.b=g,this.c=p,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=m,Le([L.memoize],m.prototype,"appRoot",null),Le([L.memoize],m.prototype,"userHome",null),Le([L.memoize],m.prototype,"userDataPath",null),Le([L.memoize],m.prototype,"appSettingsHome",null),Le([L.memoize],m.prototype,"tmpDir",null),Le([L.memoize],m.prototype,"cacheHome",null),Le([L.memoize],m.prototype,"stateResource",null),Le([L.memoize],m.prototype,"userRoamingDataHome",null),Le([L.memoize],m.prototype,"userDataSyncHome",null),Le([L.memoize],m.prototype,"sync",null),Le([L.memoize],m.prototype,"machineSettingsResource",null),Le([L.memoize],m.prototype,"workspaceStorageHome",null),Le([L.memoize],m.prototype,"localHistoryHome",null),Le([L.memoize],m.prototype,"keyboardLayoutResource",null),Le([L.memoize],m.prototype,"argvResource",null),Le([L.memoize],m.prototype,"isExtensionDevelopment",null),Le([L.memoize],m.prototype,"untitledWorkspacesHome",null),Le([L.memoize],m.prototype,"builtinExtensionsPath",null),Le([L.memoize],m.prototype,"extensionsPath",null),Le([L.memoize],m.prototype,"extensionDevelopmentLocationURI",null),Le([L.memoize],m.prototype,"extensionDevelopmentKind",null),Le([L.memoize],m.prototype,"extensionTestsLocationURI",null),Le([L.memoize],m.prototype,"debugExtensionHost",null),Le([L.memoize],m.prototype,"logLevel",null),Le([L.memoize],m.prototype,"extensionLogLevel",null),Le([L.memoize],m.prototype,"serviceMachineIdResource",null),Le([L.memoize],m.prototype,"disableTelemetry",null),Le([L.memoize],m.prototype,"disableWorkspaceTrust",null),Le([L.memoize],m.prototype,"policyFile",null);function T(v,h){return y(v["inspect-extensions"],v["inspect-brk-extensions"],5870,h,v.debugId,v.extensionEnvironment)}e.parseExtensionHostDebugPort=T;function y(v,h,g,p,r,f){const u=Number(h||v)||(p?null:g),D=u?!!h:!1;let O;if(f)try{O=JSON.parse(f)}catch{}return{port:u,break:D,debugId:r,env:O}}e.parseDebugParams=y}),define(pe[62],be([1,0,294,3,171]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,o.localize)(0,null),e:(0,o.localize)(1,null),t:(0,o.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,o.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,o.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,o.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,o.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,o.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,o.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,o.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,o.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,o.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,o.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,o.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,o.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,o.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,o.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,o.localize)(17,null)},category:{type:"string",cat:"e",description:(0,o.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,o.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,o.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,o.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,o.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,o.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,o.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,o.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,o.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,o.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,o.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,o.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,o.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,o.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,o.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,o.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,o.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(p,r,f=k){const c=p.find(l=>l.length>0&&l[0]!=="-"),u={},D=["_"],O=[],t={};let n;for(const l in r){const d=r[l];d.type==="subcommand"?l===c&&(n=d):(d.alias&&(u[l]=d.alias),d.type==="string"||d.type==="string[]"?(D.push(l),d.deprecates&&D.push(...d.deprecates)):d.type==="boolean"&&(O.push(l),d.deprecates&&O.push(...d.deprecates)),d.global&&(t[l]=d))}if(n&&c){const l=t;for(const E in n.options)l[E]=n.options[E];const d=p.filter(E=>E!==c),I=f.getSubcommandReporter?f.getSubcommandReporter(c):void 0,C=R(d,l,I);return{[c]:C,_:[]}}const s=S(p,{string:D,boolean:O,alias:u}),i={},a=s;i._=s._.map(l=>String(l)).filter(l=>l.length>0),delete a._;for(const l in r){const d=r[l];if(d.type==="subcommand")continue;d.alias&&delete a[d.alias];let I=a[l];if(d.deprecates)for(const C of d.deprecates)a.hasOwnProperty(C)&&(I||(I=a[C],I&&f.onDeprecatedOption(C,d.deprecationMessage||(0,o.localize)(35,null,l))),delete a[C]);if(typeof I<"u"){if(d.type==="string[]"){if(Array.isArray(I)||(I=[I]),!d.allowEmptyValue){const C=I.filter(E=>E.length>0);C.length!==I.length&&(f.onEmptyValue(l),I=C.length>0?C:void 0)}}else d.type==="string"&&(Array.isArray(I)?(I=I.pop(),f.onMultipleValues(l,I)):!I&&!d.allowEmptyValue&&(f.onEmptyValue(l),I=void 0));i[l]=I,d.deprecationMessage&&f.onDeprecatedOption(l,d.deprecationMessage)}delete a[l]}for(const l in a)f.onUnknownOption(l);return i}e.parseArgs=R;function b(p,r){let f="";return r.args&&(Array.isArray(r.args)?f=` <${r.args.join("> <")}>`:f=` <${r.args}>`),r.alias?`-${r.alias} --${p}${f}`:`--${p}${f}`}function m(p,r){const f=[];for(const c in p){const u=p[c],D=b(c,u);f.push([D,u.description])}return T(f,r)}e.formatOptions=m;function T(p,r){const c=p.reduce((O,t)=>Math.max(O,t[0].length),12)+2+1;if(r-c<25)return p.reduce((O,t)=>O.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const u=r-c-1,D=[];for(const O of p){const t=O[0],n=v(O[1],u),s=y(c-t.length-2);D.push("  "+t+s+n[0]);for(let i=1;i<n.length;i++)D.push(y(c)+n[i])}return D}function y(p){return" ".repeat(p)}function v(p,r){const f=[];for(;p.length;){const c=p.length<r?p.length:p.lastIndexOf(" ",r),u=p.slice(0,c).trim();p=p.slice(c),f.push(u)}return f}function h(p,r,f,c,u){const D=process.stdout.isTTY&&process.stdout.columns||80,O=u?.noInputFiles!==!0?`[${(0,o.localize)(36,null)}...]`:"",t=[`${p} ${f}`];t.push(""),t.push(`${(0,o.localize)(37,null)}: ${r} [${(0,o.localize)(38,null)}]${O}`),t.push(""),u?.noPipe!==!0&&(L.isWindows?t.push((0,o.localize)(39,null,r)):t.push((0,o.localize)(40,null,r)),t.push(""));const n={},s=[];for(const i in c){const a=c[i];if(a.type==="subcommand")a.description&&s.push({command:i,description:a.description});else if(a.description&&a.cat){let l=n[a.cat];l||(n[a.cat]=l={}),l[i]=a}}for(const i in n){const a=i,l=n[a];l&&(t.push(A[a]),t.push(...m(l,D)),t.push(""))}return s.length&&(t.push((0,o.localize)(41,null)),t.push(...T(s.map(i=>[i.command,i.description]),D)),t.push("")),t.join(`
`)}e.buildHelpMessage=h;function g(p,r){return`${p||(0,o.localize)(42,null)}
${r||(0,o.localize)(43,null)}
${process.arch}`}e.buildVersionMessage=g}),define(pe[205],be([1,0,295,172,62]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(y,v){const h=(u,D)=>{console.warn((0,L.localize)(0,null,u,D))},g=u=>{console.warn((0,L.localize)(1,null,u))},p=(u,D)=>{console.warn((0,L.localize)(2,null,u,D))},r=u=>({onUnknownOption:D=>{u!=="tunnel"&&console.warn((0,L.localize)(3,null,D,u))},onMultipleValues:h,onEmptyValue:g,onDeprecatedOption:p,getSubcommandReporter:u!=="tunnel"?r:void 0}),f={onUnknownOption:u=>{console.warn((0,L.localize)(4,null,u))},onMultipleValues:h,onEmptyValue:g,onDeprecatedOption:p,getSubcommandReporter:r},c=(0,o.parseArgs)(y,o.OPTIONS,v?f:void 0);return c.goto&&c._.forEach(u=>S(/^(\w:)?[^:]+(:\d*){0,2}$/.test(u),(0,L.localize)(5,null))),c}function k(y){const v=y.findIndex(h=>!/^-/.test(h));if(v>-1)return[...y.slice(0,v),...y.slice(v+1)]}function R(y){let[,...v]=y;process.env.VSCODE_DEV&&(v=k(v)||[]);const h=!T(process.env);return A(v,h)}e.parseMainProcessArgv=R;function b(y){let[,,...v]=y;return process.env.VSCODE_DEV&&(v=k(v)||[]),A(v,!0)}e.parseCLIProcessArgv=b;function m(y,...v){const h=y.indexOf("--");return h===-1?y.push(...v):y.splice(h,0,...v),y}e.addArg=m;function T(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=T}),function(){"use strict";function le(e,S,L){function o(k,R){const b=A(k,R),m=[b];return e.isAbsolute(b)||m.unshift(L),e.resolve(...m)}function A(k,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,R);const T=k["user-data-dir"];if(T)return T;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(y,"AppData","Roaming")}break;case"darwin":m=e.join(S.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,R)}return{getUserDataPath:o}}if(typeof define=="function")define(pe[206],be([73,28,29]),function(e,S,L){return le(e,S,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=le(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(pe[106],be([1,0,28,204,206]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends L.AbstractNativeEnvironmentService{constructor(m,T){super(m,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,o.getUserDataPath)(m,T.nameShort)},T)}}e.NativeEnvironmentService=A;function k(b,m){return(0,L.parseDebugParams)(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,m,b.extensionEnvironment)}e.parsePtyHostDebugPort=k;function R(b,m){return(0,L.parseDebugParams)(b["inspect-sharedprocess"],b["inspect-brk-sharedprocess"],5879,m,b.extensionEnvironment)}e.parseSharedProcessDebugPort=R}),define(pe[207],be([1,0,8,176]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function o(k,R,b){try{A(k,R,b)}catch(m){console.error(m?.message??m)}return k}e.localizeManifest=o;function A(k,R,b){const m=(T,y,v)=>{const h=T[y];if((0,S.isString)(h)){const g=h,p=g.length;if(p>1&&g[0]==="%"&&g[p-1]==="%"){const r=g.substr(1,p-2);let f=R[r];f===void 0&&b&&(f=b[r]);const c=typeof f=="string"?f:f?.message,u=b?.[r],D=typeof u=="string"?u:u?.message;if(!c){D||console.warn(`[${k.name}]: ${(0,L.localize)(0,null,r)}`);return}if(v&&(y==="title"||y==="category")&&D&&D!==c){const O={value:c,original:D};T[y]=O}else T[y]=c}}else if((0,S.isObject)(h))for(const g in h)h.hasOwnProperty(g)&&(g==="commands"?m(h,g,!0):m(h,g,v));else if(Array.isArray(h))for(let g=0;g<h.length;g++)m(h,g,v)};for(const T in k)k.hasOwnProperty(T)&&m(k,T)}}),define(pe[77],be([1,0,19,60,180,53]),function(le,e,S,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function b(f){return f=f.trim(),f==="*"||k.test(f)}e.isValidVersionStr=b;function m(f){if(!b(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=f.match(k);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.parseVersion=m;function T(f){if(!f)return null;const c=f.majorBase,u=f.majorMustEqual,D=f.minorBase;let O=f.minorMustEqual;const t=f.patchBase;let n=f.patchMustEqual;f.hasCaret&&(c===0||(O=!1),n=!1);let s=0;if(f.preRelease){const i=R.exec(f.preRelease);if(i){const[,a,l,d]=i;s=Date.UTC(Number(a),Number(l)-1,Number(d))}}return{majorBase:c,majorMustEqual:u,minorBase:D,minorMustEqual:O,patchBase:t,patchMustEqual:n,isMinimum:f.hasGreaterEquals,notBefore:s}}e.normalizeVersion=T;function y(f,c,u){let D;typeof f=="string"?D=T(m(f)):D=f;let O;c instanceof Date?O=c.getTime():typeof c=="string"&&(O=new Date(c).getTime());let t;if(typeof u=="string"?t=T(m(u)):t=u,!D||!t)return!1;const n=D.majorBase,s=D.minorBase,i=D.patchBase;let a=t.majorBase,l=t.minorBase,d=t.patchBase;const I=t.notBefore;let C=t.majorMustEqual,E=t.minorMustEqual,w=t.patchMustEqual;return t.isMinimum?n>a?!0:n<a?!1:s>l?!0:s<l||O&&O<I?!1:i>=d:(n===1&&a===0&&(!C||!E||!w)&&(a=1,l=0,d=0,C=!0,E=!1,w=!1),n<a?!1:n>a?!C:s<l?!1:s>l?!E:i<d?!1:i>d?!w:!(O&&O<I))}e.isValidVersion=y;function v(f,c,u,D,O){const t=[];if(typeof D.publisher<"u"&&typeof D.publisher!="string")return t.push([L.default.Error,o.localize(0,null)]),t;if(typeof D.name!="string")return t.push([L.default.Error,o.localize(1,null,"name")]),t;if(typeof D.version!="string")return t.push([L.default.Error,o.localize(2,null,"version")]),t;if(!D.engines)return t.push([L.default.Error,o.localize(3,null,"engines")]),t;if(typeof D.engines.vscode!="string")return t.push([L.default.Error,o.localize(4,null,"engines.vscode")]),t;if(typeof D.extensionDependencies<"u"&&!r(D.extensionDependencies))return t.push([L.default.Error,o.localize(5,null,"extensionDependencies")]),t;if(typeof D.activationEvents<"u"){if(!r(D.activationEvents))return t.push([L.default.Error,o.localize(6,null,"activationEvents")]),t;if(typeof D.main>"u"&&typeof D.browser>"u")return t.push([L.default.Error,o.localize(7,null,"activationEvents","main","browser")]),t}if(typeof D.extensionKind<"u"&&typeof D.main>"u"&&t.push([L.default.Warning,o.localize(8,null,"extensionKind")]),typeof D.main<"u"){if(typeof D.main!="string")return t.push([L.default.Error,o.localize(9,null,"main")]),t;{const i=(0,S.joinPath)(u,D.main);(0,S.isEqualOrParent)(i,u)||t.push([L.default.Warning,o.localize(10,null,i.path,u.path)])}}if(typeof D.browser<"u"){if(typeof D.browser!="string")return t.push([L.default.Error,o.localize(11,null,"browser")]),t;{const i=(0,S.joinPath)(u,D.browser);(0,S.isEqualOrParent)(i,u)||t.push([L.default.Warning,o.localize(12,null,i.path,u.path)])}}if(!A.valid(D.version))return t.push([L.default.Error,o.localize(13,null)]),t;const n=[];if(!h(f,c,D,O,n))for(const i of n)t.push([L.default.Error,i]);return t}e.validateExtensionManifest=v;function h(f,c,u,D,O){return D||typeof u.main>"u"&&typeof u.browser>"u"?!0:p(f,c,u.engines.vscode,O)}e.isValidExtensionVersion=h;function g(f,c,u){return f==="*"||p(c,u,f)}e.isEngineValid=g;function p(f,c,u,D=[]){const O=T(m(u));if(!O)return D.push(o.localize(14,null,u)),!1;if(O.majorBase===0){if(!O.majorMustEqual||!O.minorMustEqual)return D.push(o.localize(15,null,u)),!1}else if(!O.majorMustEqual)return D.push(o.localize(16,null,u)),!1;return y(f,c,O)?!0:(D.push(o.localize(17,null,f,u)),!1)}function r(f){if(!Array.isArray(f))return!1;for(let c=0,u=f.length;c<u;c++)if(typeof f[c]!="string")return!1;return!0}}),define(pe[208],be([1,0,15,22]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function o(A,k,R){let b=R&&R.get("storage.serviceMachineId",-1)||null;if(b)return b;try{const T=(await k.readFile(A.serviceMachineIdResource)).value.toString();b=(0,L.isUUID)(T)?T:null}catch{b=null}if(!b){b=(0,L.generateUuid)();try{await k.writeFile(A.serviceMachineIdResource,S.VSBuffer.fromString(b))}catch{}}return R?.store("storage.serviceMachineId",b,-1,1),b}e.getServiceMachineId=o}),define(pe[63],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(o,A=[],k=!1){this.ctor=o,this.staticArguments=A,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=S}),define(pe[209],be([1,0,63]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var o;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(o||(e.InstantiationType=o={}));function A(R,b,m){b instanceof S.SyncDescriptor||(b=new S.SyncDescriptor(b,[],!!m)),L.push([R,b])}e.registerSingleton=A;function k(){return L}e.getSingletonServiceDescriptors=k}),define(pe[210],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(A,k){this.key=A,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=S;class L{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const k of this.a.values())k.outgoing.size===0&&A.push(k);return A}insertEdge(A,k){const R=this.lookupOrInsertNode(A),b=this.lookupOrInsertNode(k);R.outgoing.set(b.key,b),b.incoming.set(R.key,R)}removeNode(A){const k=this.b(A);this.a.delete(k);for(const R of this.a.values())R.outgoing.delete(k),R.incoming.delete(k)}lookupOrInsertNode(A){const k=this.b(A);let R=this.a.get(k);return R||(R=new S(k,A),this.a.set(k,R)),R}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[k,R]of this.a)A.push(`${k}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,k]of this.a){const R=new Set([A]),b=this.c(k,R);if(b)return b}}c(A,k){for(const[R,b]of A.outgoing){if(k.has(R))return[...k,R].join(" -> ");k.add(R);const m=this.c(b,k);if(m)return m;k.delete(R)}}}e.Graph=L}),define(pe[5],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function R(b){return b[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=R})(S||(e._util=S={})),e.IInstantiationService=o("instantiationService");function L(k,R,b){R[S.DI_TARGET]===R?R[S.DI_DEPENDENCIES].push({id:k,index:b}):(R[S.DI_DEPENDENCIES]=[{id:k,index:b}],R[S.DI_TARGET]=R)}function o(k){if(S.serviceIds.has(k))return S.serviceIds.get(k);const R=function(b,m,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(R,b,T)};return R.toString=()=>k,S.serviceIds.set(k,R),R}e.createDecorator=o;function A(k){return k}e.refineServiceDecorator=A}),define(pe[24],be([1,0,8,4,5]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,o.createDecorator)("configurationService");function A(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=A;function k(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=k;var R;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function b(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=b;function m(r,f){const c=Object.create(null);for(const u in r)T(c,u,r[u],f);return c}e.toValuesTree=m;function T(r,f,c,u){const D=f.split("."),O=D.pop();let t=r;for(let n=0;n<D.length;n++){const s=D[n];let i=t[s];switch(typeof i){case"undefined":i=t[s]=Object.create(null);break;case"object":break;default:u(`Ignoring ${f} as ${D.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}t=i}if(typeof t=="object"&&t!==null)try{t[O]=c}catch{u(`Ignoring ${f} as ${D.join(".")} is ${JSON.stringify(t)}`)}else u(`Ignoring ${f} as ${D.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=T;function y(r,f){const c=f.split(".");v(r,c)}e.removeFromValueTree=y;function v(r,f){const c=f.shift();if(f.length===0){delete r[c];return}if(Object.keys(r).indexOf(c)!==-1){const u=r[c];typeof u=="object"&&!Array.isArray(u)&&(v(u,f),Object.keys(u).length===0&&delete r[c])}}function h(r,f,c){function u(t,n){let s=t;for(const i of n){if(typeof s!="object"||s===null)return;s=s[i]}return s}const D=f.split("."),O=u(r,D);return typeof O>"u"?c:O}e.getConfigurationValue=h;function g(r,f,c){Object.keys(f).forEach(u=>{u!=="__proto__"&&(u in r?S.isObject(r[u])&&S.isObject(f[u])?g(r[u],f[u],c):c&&(r[u]=f[u]):r[u]=f[u])})}e.merge=g;function p(r){return r.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(pe[64],be([1,0,3,17,201,5,169,11]),function(le,e,S,L,o,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",S.isMacintosh),b.set("isLinux",S.isLinux),b.set("isWindows",S.isWindows),b.set("isWeb",S.isWeb),b.set("isMacNative",S.isMacintosh&&!S.isWeb),b.set("isEdge",S.isEdge),b.set("isFirefox",S.isFirefox),b.set("isChrome",S.isChrome),b.set("isSafari",S.isSafari);function m(j,P){if(b.get(j)!==void 0)throw(0,R.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(j,P)}e.setConstant=m;const T=Object.prototype.hasOwnProperty;var y;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const v={regexParsingWithErrorRecovery:!0},h=(0,k.localize)(0,null),g=(0,k.localize)(1,null),p=(0,k.localize)(2,null),r=(0,k.localize)(3,null),f=(0,k.localize)(4,null),c=(0,k.localize)(5,null),u=(0,k.localize)(6,null),D=(0,k.localize)(7,null);class O{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(P=v){this.k=P,this.d=new o.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(P){if(P===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(P).scan(),this.g=0,this.h=[];try{const M=this.l();if(!this.E()){const K=this.D(),te=K.type===17?c:void 0;throw this.h.push({message:f,offset:K.offset,lexeme:o.Scanner.getLexeme(K),additionalInfo:te}),O.c}return M}catch(M){if(M!==O.c)throw M;return}}l(){return this.m()}m(){const P=[this.o()];for(;this.y(16);){const M=this.o();P.push(M)}return P.length===1?P[0]:t.or(...P)}o(){const P=[this.s()];for(;this.y(15);){const M=this.s();P.push(M)}return P.length===1?P[0]:t.and(...P)}s(){if(this.y(2)){const P=this.D();switch(P.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const M=this.l();return this.A(1,r),M?.negate()}case 17:return this.z(),N.create(P.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",P)}}return this.t()}t(){const P=this.D();switch(P.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const M=this.l();return this.A(1,r),M}case 17:{const M=P.lexeme;if(this.z(),this.y(9)){const te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),te.type!==10)throw this.B("REGEX",te);const z=te.lexeme,W=z.lastIndexOf("/"),q=W===z.length-1?void 0:this.w(z.substring(W+1));let H;try{H=new RegExp(z.substring(1,W),q)}catch{throw this.B("REGEX",te)}return ge.create(M,H)}switch(te.type){case 10:case 19:{const z=[te.lexeme];this.z();let W=this.D(),q=0;for(let ce=0;ce<te.lexeme.length;ce++)te.lexeme.charCodeAt(ce)===40?q++:te.lexeme.charCodeAt(ce)===41&&q--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:q++;break;case 1:q--;break;case 10:case 18:for(let ce=0;ce<W.lexeme.length;ce++)W.lexeme.charCodeAt(ce)===40?q++:te.lexeme.charCodeAt(ce)===41&&q--}if(q<0)break;z.push(o.Scanner.getLexeme(W)),this.z(),W=this.D()}const H=z.join(""),Q=H.lastIndexOf("/"),G=Q===H.length-1?void 0:this.w(H.substring(Q+1));let Z;try{Z=new RegExp(H.substring(1,Q),G)}catch{throw this.B("REGEX",te)}return t.regex(M,Z)}case 18:{const z=te.lexeme;this.z();let W=null;if(!(0,L.isFalsyOrWhitespace)(z)){const q=z.indexOf("/"),H=z.lastIndexOf("/");if(q!==H&&q>=0){const Q=z.slice(q+1,H),G=z[H+1]==="i"?"i":"";try{W=new RegExp(Q,G)}catch{throw this.B("REGEX",te)}}}if(W===null)throw this.B("REGEX",te);return ge.create(M,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const te=this.u();return t.notIn(M,te)}switch(this.D().type){case 3:{this.z();const te=this.u();if(this.x().type===18)return t.equals(M,te);switch(te){case"true":return t.has(M);case"false":return t.not(M);default:return t.equals(M,te)}}case 4:{this.z();const te=this.u();if(this.x().type===18)return t.notEquals(M,te);switch(te){case"true":return t.not(M);case"false":return t.has(M);default:return t.notEquals(M,te)}}case 5:return this.z(),ae.create(M,this.u());case 6:return this.z(),ue.create(M,this.u());case 7:return this.z(),se.create(M,this.u());case 8:return this.z(),he.create(M,this.u());case 13:return this.z(),t.in(M,this.u());default:return t.has(M)}}case 20:throw this.h.push({message:u,offset:P.offset,lexeme:"",additionalInfo:D}),O.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const P=this.D();switch(P.type){case 17:case 18:return this.z(),P.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(P){return P.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(P){return this.C(P)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(P,M){if(this.C(P))return this.z();throw this.B(M,this.D())}B(P,M,K){const te=(0,k.localize)(8,null,P,o.Scanner.getLexeme(M)),z=M.offset,W=o.Scanner.getLexeme(M);return this.h.push({message:te,offset:z,lexeme:W,additionalInfo:K}),O.c}C(P){return this.D().type===P}D(){return this.f[this.g]}E(){return this.D().type===20}}e.Parser=O,O.c=new Error;class t{static false(){return a.INSTANCE}static true(){return l.INSTANCE}static has(P){return d.create(P)}static equals(P,M){return I.create(P,M)}static notEquals(P,M){return w.create(P,M)}static regex(P,M){return ge.create(P,M)}static in(P,M){return C.create(P,M)}static notIn(P,M){return E.create(P,M)}static not(P){return N.create(P)}static and(...P){return V.create(P,null,!0)}static or(...P){return J.create(P,null,!0)}static greater(P,M){return se.create(P,M)}static greaterEquals(P,M){return he.create(P,M)}static smaller(P,M){return ae.create(P,M)}static smallerEquals(P,M){return ue.create(P,M)}static deserialize(P){return P==null?void 0:this.c.parse(P)}}e.ContextKeyExpr=t,t.c=new O({regexParsingWithErrorRecovery:!1});function n(j){const P=new O({regexParsingWithErrorRecovery:!1});return j.map(M=>(P.parse(M),P.lexingErrors.length>0?P.lexingErrors.map(K=>({errorMessage:K.additionalInfo?(0,k.localize)(9,null,K.additionalInfo):(0,k.localize)(10,null),offset:K.offset,length:K.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(K=>({errorMessage:K.additionalInfo?`${K.message}. ${K.additionalInfo}`:K.message,offset:K.offset,length:K.lexeme.length})):[]))}e.validateWhenClauses=n;function s(j,P){const M=j?j.substituteConstants():void 0,K=P?P.substituteConstants():void 0;return!M&&!K?!0:!M||!K?!1:M.equals(K)}e.expressionsAreEqualWithConstantSubstitution=s;function i(j,P){return j.cmp(P)}class a{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=a,a.INSTANCE=new a;class l{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return a.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class d{static create(P,M=null){const K=b.get(P);return typeof K=="boolean"?K?l.INSTANCE:a.INSTANCE:new d(P,M)}constructor(P,M){this.key=P,this.c=M,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=b.get(this.key);return typeof P=="boolean"?P?l.INSTANCE:a.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=d;class I{static create(P,M,K=null){if(typeof M=="boolean")return M?d.create(P,K):N.create(P,K);const te=b.get(P);return typeof te=="boolean"?M===(te?"true":"false")?l.INSTANCE:a.INSTANCE:new I(P,M,K)}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:x(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=b.get(this.c);if(typeof P=="boolean"){const M=P?"true":"false";return this.d===M?l.INSTANCE:a.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=I;class C{static create(P,M){return new C(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:x(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.f),K=P.getValue(this.d);return Array.isArray(M)?M.includes(K):typeof K=="string"&&typeof M=="object"&&M!==null?T.call(M,K):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=C;class E{static create(P,M){return new E(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=11,this.c=C.create(P,M)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=E;class w{static create(P,M,K=null){if(typeof M=="boolean")return M?N.create(P,K):d.create(P,K);const te=b.get(P);return typeof te=="boolean"?M===(te?"true":"false")?a.INSTANCE:l.INSTANCE:new w(P,M,K)}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:x(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=b.get(this.c);if(typeof P=="boolean"){const M=P?"true":"false";return this.d===M?a.INSTANCE:l.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=w;class N{static create(P,M=null){const K=b.get(P);return typeof K=="boolean"?K?a.INSTANCE:l.INSTANCE:new N(P,M)}constructor(P,M){this.c=P,this.d=M,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=b.get(this.c);return typeof P=="boolean"?P?a.INSTANCE:l.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=d.create(this.c,this)),this.d}}e.ContextKeyNotExpr=N;function $(j,P){if(typeof j=="string"){const M=parseFloat(j);isNaN(M)||(j=M)}return typeof j=="string"||typeof j=="number"?P(j):a.INSTANCE}class se{static create(P,M,K=null){return $(M,te=>new se(P,te,K))}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:x(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=se;class he{static create(P,M,K=null){return $(M,te=>new he(P,te,K))}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:x(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=he;class ae{static create(P,M,K=null){return $(M,te=>new ae(P,te,K))}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:x(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=ae;class ue{static create(P,M,K=null){return $(M,te=>new ue(P,te,K))}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:x(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=ue;class ge{static create(P,M){return new ge(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const M=this.f?this.f.source:"",K=P.f?P.f.source:"";return M<K?-1:M>K?1:0}equals(P){if(P.type===this.type){const M=this.f?this.f.source:"",K=P.f?P.f.source:"";return this.d===P.d&&M===K}return!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=_.create(this)),this.c}}e.ContextKeyRegexExpr=ge;class _{static create(P){return new _(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(P){return new _(this.c.map(P))}negate(){return this.c}}e.ContextKeyNotRegexExpr=_;function ie(j){let P=null;for(let M=0,K=j.length;M<K;M++){const te=j[M].substituteConstants();if(j[M]!==te&&P===null){P=[];for(let z=0;z<M;z++)P[z]=j[z]}P!==null&&(P[M]=te)}return P===null?j:P}class V{static create(P,M,K){return V.d(P,M,K)}constructor(P,M){this.expr=P,this.c=M,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,K=this.expr.length;M<K;M++){const te=i(this.expr[M],P.expr[M]);if(te!==0)return te}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,K=this.expr.length;M<K;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=ie(this.expr);return P===this.expr?this:V.create(P,this.c,!1)}evaluate(P){for(let M=0,K=this.expr.length;M<K;M++)if(!this.expr[M].evaluate(P))return!1;return!0}static d(P,M,K){const te=[];let z=!1;for(const W of P)if(W){if(W.type===1){z=!0;continue}if(W.type===0)return a.INSTANCE;if(W.type===6){te.push(...W.expr);continue}te.push(W)}if(te.length===0&&z)return l.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(i);for(let W=1;W<te.length;W++)te[W-1].equals(te[W])&&(te.splice(W,1),W--);if(te.length===1)return te[0];for(;te.length>1;){const W=te[te.length-1];if(W.type!==9)break;te.pop();const q=te.pop(),H=te.length===0,Q=J.create(W.expr.map(G=>V.create([G,q],null,K)),null,H);Q&&(te.push(Q),te.sort(i))}if(te.length===1)return te[0];if(K){for(let W=0;W<te.length;W++)for(let q=W+1;q<te.length;q++)if(te[W].negate().equals(te[q]))return a.INSTANCE;if(te.length===1)return te[0]}return new V(te,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new V(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.c){const P=[];for(const M of this.expr)P.push(M.negate());this.c=J.create(P,this,!0)}return this.c}}e.ContextKeyAndExpr=V;class J{static create(P,M,K){return J.d(P,M,K)}constructor(P,M){this.expr=P,this.c=M,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,K=this.expr.length;M<K;M++){const te=i(this.expr[M],P.expr[M]);if(te!==0)return te}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,K=this.expr.length;M<K;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=ie(this.expr);return P===this.expr?this:J.create(P,this.c,!1)}evaluate(P){for(let M=0,K=this.expr.length;M<K;M++)if(this.expr[M].evaluate(P))return!0;return!1}static d(P,M,K){let te=[],z=!1;if(P){for(let W=0,q=P.length;W<q;W++){const H=P[W];if(H){if(H.type===0){z=!0;continue}if(H.type===1)return l.INSTANCE;if(H.type===9){te=te.concat(H.expr);continue}te.push(H)}}if(te.length===0&&z)return a.INSTANCE;te.sort(i)}if(te.length!==0){if(te.length===1)return te[0];for(let W=1;W<te.length;W++)te[W-1].equals(te[W])&&(te.splice(W,1),W--);if(te.length===1)return te[0];if(K){for(let W=0;W<te.length;W++)for(let q=W+1;q<te.length;q++)if(te[W].negate().equals(te[q]))return l.INSTANCE;if(te.length===1)return te[0]}return new J(te,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new J(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.c){const P=[];for(const M of this.expr)P.push(M.negate());for(;P.length>1;){const M=P.shift(),K=P.shift(),te=[];for(const z of ee(M))for(const W of ee(K))te.push(V.create([z,W],null,!1));P.unshift(J.create(te,null,!1))}this.c=J.create(P,this,!0)}return this.c}}e.ContextKeyOrExpr=J;class U extends d{static all(){return U.d.values()}constructor(P,M,K){super(P,null),this.f=M,typeof K=="object"?U.d.push({...K,key:P}):K!==!0&&U.d.push({key:P,description:K,type:M!=null?typeof M:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return I.create(this.key,P)}notEqualsTo(P){return w.create(this.key,P)}}e.RawContextKey=U,U.d=[],e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function ne(j,P){return j<P?-1:j>P?1:0}function x(j,P,M,K){return j<M?-1:j>M?1:P<K?-1:P>K?1:0}function re(j,P){if(j.type===0||P.type===1)return!0;if(j.type===9)return P.type===9?Y(j.expr,P.expr):!1;if(P.type===9){for(const M of P.expr)if(re(j,M))return!0;return!1}if(j.type===6){if(P.type===6)return Y(P.expr,j.expr);for(const M of j.expr)if(re(M,P))return!0;return!1}return j.equals(P)}e.implies=re;function Y(j,P){let M=0,K=0;for(;M<j.length&&K<P.length;){const te=j[M].cmp(P[K]);if(te<0)return!1;te===0&&M++,K++}return M===j.length}function ee(j){return j.type===9?j.expr:[j]}}),define(pe[78],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,S.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,S.createDecorator)("credentialsMainService");class L{constructor(){this.a={}}async getPassword(A,k){return this.a[A]?.[k]??null}async setPassword(A,k,R){this.a[A]=this.a[A]??{},this.a[A][k]=R}async deletePassword(A,k){return this.a[A]?.[k]?(delete this.a[A][k],Object.keys(this.a[A]).length===0&&delete this.a[A],!0):!1}async findPassword(A){return JSON.stringify(this.a[A])??null}async findCredentials(A){const k=[];for(const R of Object.keys(this.a[A]||{}))k.push({account:R,password:this.a[A][R]});return k}async clear(){this.a={}}}e.InMemoryCredentialsProvider=L}),define(pe[211],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function L(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=L;class o{async getPerformanceInfo(k,R){return{}}async getSystemInfo(k,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,R){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=o}),define(pe[79],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,S.createDecorator)("downloadService")}),define(pe[212],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,S.createDecorator)("encryptionMainService")}),define(pe[25],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(pe[30],be([1,0,174,5]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function o(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=o;function A(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function k(c,u){switch(c){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function R(c,u){return u==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function b(c,u,D){return R(u,D)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===D?!0:m(D).includes(c)}e.isTargetPlatformCompatible=b;function m(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function T(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=T;var y;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var v;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var h;(function(c){c.Install="install",c.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var g;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var p;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var r;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class f extends Error{constructor(u,D){super(u),this.code=D,this.name=D}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,S.localize)(1,null),original:"Preferences"}}),define(pe[213],be([1,0,6,2,21,4,51,30]),function(le,e,S,L,o,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(r,f){return r?A.URI.revive(f?f.transformIncoming(r):r):void 0}function m(r,f){return f?f.transformOutgoingURI(r):r}function T(r,f){f=f||k.DefaultURITransformer;const c=r.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...r,manifest:void 0},f),manifest:c}}function y(r,f){return r?.profileLocation?(0,k.transformAndReviveIncomingURIs)(r,f??k.DefaultURITransformer):r}function v(r,f){return f?(0,o.cloneAndChange)(r,c=>c instanceof A.URI?f.transformOutgoingURI(c):void 0):r}class h{constructor(f,c){this.a=f,this.b=c,this.onInstallExtension=S.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=S.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=S.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=S.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=S.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,c){const u=this.b(f);switch(c){case"onInstallExtension":return S.Event.map(this.onInstallExtension,D=>({...D,profileLocation:D.profileLocation?m(D.profileLocation,u):D.profileLocation}));case"onDidInstallExtensions":return S.Event.map(this.onDidInstallExtensions,D=>D.map(O=>({...O,local:O.local?v(O.local,u):O.local,profileLocation:O.profileLocation?m(O.profileLocation,u):O.profileLocation})));case"onUninstallExtension":return S.Event.map(this.onUninstallExtension,D=>({...D,profileLocation:D.profileLocation?m(D.profileLocation,u):D.profileLocation}));case"onDidUninstallExtension":return S.Event.map(this.onDidUninstallExtension,D=>({...D,profileLocation:D.profileLocation?m(D.profileLocation,u):D.profileLocation}));case"onDidUpdateExtensionMetadata":return S.Event.map(this.onDidUpdateExtensionMetadata,D=>v(D,u))}throw new Error("Invalid listen")}async call(f,c,u){const D=this.b(f);switch(c){case"zip":{const O=T(u[0],D),t=await this.a.zip(O);return m(t,D)}case"unzip":return this.a.unzip(b(u[0],D));case"install":return this.a.install(b(u[0],D),y(u[1],D));case"installFromLocation":return this.a.installFromLocation(b(u[0],D),b(u[1],D));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(u[0],b(u[1],D),b(u[2],D));case"getManifest":return this.a.getManifest(b(u[0],D));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(u[0]);case"installFromGallery":return this.a.installFromGallery(u[0],y(u[1],D));case"uninstall":return this.a.uninstall(T(u[0],D),y(u[1],D));case"reinstallFromGallery":return this.a.reinstallFromGallery(T(u[0],D));case"getInstalled":return(await this.a.getInstalled(u[0],b(u[1],D))).map(t=>v(t,D));case"copyExtensions":return this.a.copyExtensions(b(u[0],D),b(u[1],D));case"updateMetadata":{const O=await this.a.updateMetadata(T(u[0],D),u[1],b(u[2],D));return v(O,D)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(u[0],u[1],u[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=h;class g extends L.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.k=f,this.c=this.B(new S.Emitter),this.f=this.B(new S.Emitter),this.g=this.B(new S.Emitter),this.h=this.B(new S.Emitter),this.j=this.B(new S.Emitter),this.B(this.k.listen("onInstallExtension")(c=>this.l(this.c,{...c,source:this.m(c.source)?A.URI.revive(c.source):c.source,profileLocation:A.URI.revive(c.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(c=>this.l(this.f,c.map(u=>({...u,local:u.local?T(u.local,null):u.local,source:this.m(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(c=>this.l(this.g,{...c,profileLocation:A.URI.revive(c.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(c=>this.l(this.h,{...c,profileLocation:A.URI.revive(c.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(c=>this.j.fire(T(c,null))))}l(f,c){f.fire(c)}m(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(f){const c=await this.getTargetPlatform();return f.allTargetPlatforms.some(u=>(0,R.isTargetPlatformCompatible)(u,f.allTargetPlatforms,c))}zip(f){return Promise.resolve(this.k.call("zip",[f]).then(c=>A.URI.revive(c)))}unzip(f){return Promise.resolve(this.k.call("unzip",[f]))}install(f,c){return Promise.resolve(this.k.call("install",[f,c])).then(u=>T(u,null))}installFromLocation(f,c){return Promise.resolve(this.k.call("installFromLocation",[f,c])).then(u=>T(u,null))}async installExtensionsFromProfile(f,c,u){return(await this.k.call("installExtensionsFromProfile",[f,c,u])).map(O=>T(O,null))}getManifest(f){return Promise.resolve(this.k.call("getManifest",[f]))}installFromGallery(f,c){return Promise.resolve(this.k.call("installFromGallery",[f,c])).then(u=>T(u,null))}uninstall(f,c){return Promise.resolve(this.k.call("uninstall",[f,c]))}reinstallFromGallery(f){return Promise.resolve(this.k.call("reinstallFromGallery",[f])).then(c=>T(c,null))}getInstalled(f=null,c){return Promise.resolve(this.k.call("getInstalled",[f,c])).then(u=>u.map(D=>T(D,null)))}updateMetadata(f,c,u){return Promise.resolve(this.k.call("updateMetadata",[f,c,u])).then(D=>T(D,null))}copyExtensions(f,c){return this.k.call("copyExtensions",[f,c])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(f,c,u){const D=await this.k.call("download",[f,c,u]);return A.URI.revive(D)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=g;class p{constructor(f){this.a=f}listen(f,c){throw new Error("Invalid listen")}call(f,c,u){switch(c){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=p}),define(pe[80],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,S.createDecorator)("IExtensionSignatureVerificationService");class L{b(){return this.a||(this.a=new Promise((A,k)=>le(["node-vsce-sign"],async R=>A(R),k))),this.a}async verify(A,k,R){let b;try{b=await this.b()}catch{return!1}return b.verify(A,k,R)}}e.ExtensionSignatureVerificationService=L}),define(pe[16],be([1,0,61,7,17,8,4,182,5,3,13]),function(le,e,S,L,o,A,k,R,b,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function y(U){return U.create===!0}e.isFileOpenForWriteOptions=y;var v;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var h;(function(U){U[U.Readonly=1]="Readonly",U[U.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var g;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileAtomicWrite=32768]="FileAtomicWrite",U[U.FileAtomicDelete=65536]="FileAtomicDelete",U[U.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function p(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=p;function r(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=r;function f(U){return!!(U.capabilities&131072)}e.hasFileCloneCapability=f;function c(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function u(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=u;function D(U){return p(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=D;function O(U){return p(U)?!!(U.capabilities&32768):!1}e.hasFileAtomicWriteCapability=O;function t(U){return!!(U.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;var n;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsStorageQuota="EntryExceedsStorageQuota",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class s extends Error{static create(ne,x){const re=new s(ne.toString(),x);return l(re,x),re}constructor(ne,x){super(ne),this.code=x}}e.FileSystemProviderError=s;function i(U,ne){return s.create(U,ne)}e.createFileSystemProviderError=i;function a(U){return U||i((0,R.localize)(0,null),n.Unknown)}e.ensureFileSystemProviderError=a;function l(U,ne){return U.name=ne?`${ne} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=l;function d(U){if(!U)return n.Unknown;if(U instanceof s)return U.code;const ne=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!ne)return n.Unknown;switch(ne[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.toFileSystemProviderErrorCode=d;function I(U){if(U instanceof se)return U.fileOperationResult;switch(d(U)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=I;var C;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class E{constructor(ne,x,re){this.resource=ne,this.operation=x,this.target=re}isOperation(ne){return this.operation===ne}}e.FileOperationEvent=E;var w;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(w||(e.FileChangeType=w={}));class N{constructor(ne,x){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const re=new Map;for(const Y of ne){const ee=re.get(Y.type);switch(ee?ee.push([Y.resource,Y]):re.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,ee]of re)switch(Y){case 1:this.a=S.TernarySearchTree.forUris(()=>x),this.a.fill(ee);break;case 0:this.b=S.TernarySearchTree.forUris(()=>x),this.b.fill(ee);break;case 2:this.c=S.TernarySearchTree.forUris(()=>x),this.c.fill(ee);break}}contains(ne,...x){return this.d(ne,{includeChildren:!1},...x)}affects(ne,...x){return this.d(ne,{includeChildren:!0},...x)}d(ne,x,...re){if(!ne)return!1;const Y=re.length>0;return!!((!Y||re.includes(1))&&(this.a?.get(ne)||x.includeChildren&&this.a?.findSuperstr(ne))||(!Y||re.includes(0))&&(this.b?.get(ne)||x.includeChildren&&this.b?.findSuperstr(ne))||(!Y||re.includes(2))&&(this.c?.findSubstr(ne)||x.includeChildren&&this.c?.findSuperstr(ne)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=N;function $(U,ne,x){return!U||!ne||U===ne||ne.length>U.length?!1:(ne.charAt(ne.length-1)!==L.sep&&(ne+=L.sep),x?(0,o.startsWithIgnoreCase)(U,ne):U.indexOf(ne)===0)}e.isParent=$;class se extends Error{constructor(ne,x,re){super(ne),this.fileOperationResult=x,this.options=re}}e.FileOperationError=se;class he extends se{constructor(ne,x,re,Y){super(ne,x,Y),this.fileOperationResult=x,this.size=re}}e.TooLargeFileOperationError=he;class ae extends se{constructor(ne,x,re){super(ne,2,re),this.stat=x}}e.NotModifiedSinceFileOperationError=ae;var ue;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ue||(e.FileOperationResult=ue={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ge;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(ge||(e.FileKind=ge={})),e.ETAG_DISABLED="";function _(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=_;async function ie(U,ne){if(!ne.hasProvider(k.URI.from({scheme:U.scheme})))return new Promise(x=>{const re=ne.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===U.scheme&&Y.added&&(re.dispose(),x())})})}e.whenProviderRegistered=ie;class V{static formatSize(ne){return(0,A.isNumber)(ne)||(ne=0),ne<V.KB?(0,R.localize)(1,null,ne.toFixed(0)):ne<V.MB?(0,R.localize)(2,null,(ne/V.KB).toFixed(2)):ne<V.GB?(0,R.localize)(3,null,(ne/V.MB).toFixed(2)):ne<V.TB?(0,R.localize)(4,null,(ne/V.GB).toFixed(2)):(0,R.localize)(5,null,(ne/V.TB).toFixed(2))}}e.ByteSize=V,V.KB=1024,V.MB=V.KB*V.KB,V.GB=V.MB*V.KB,V.TB=V.GB*V.KB;function J(U){const ne=typeof U=="string"||U?.scheme===T.Schemas.vscodeRemote;return typeof U!="string"&&U?.scheme===T.Schemas.file?1024*V.MB:ne?10*V.MB:m.isWeb?50*V.MB:1024*V.MB}e.getLargeFileConfirmationLimit=J}),define(pe[214],be([1,0,15,38,11,6,2,47,4,22,16]),function(le,e,S,L,o,A,k,R,b,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class y extends k.Disposable{constructor(h,g){super(),this.a=h,this.b=g,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.h=(0,m.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,g){const{buffer:p}=await this.a.call("readFile",[h,g]);return p}readFileStream(h,g,p){const r=(0,R.newWriteableStream)(c=>S.VSBuffer.concat(c.map(u=>S.VSBuffer.wrap(u))).buffer),f=this.a.listen("readFileStream",[h,g])(c=>{if(c instanceof S.VSBuffer)r.write(c.buffer);else{if(c==="end")r.end();else{let u;if(c instanceof Error)u=c;else{const D=c;u=(0,T.createFileSystemProviderError)(D.message??(0,L.toErrorMessage)(D),D.code??T.FileSystemProviderErrorCode.Unknown)}r.error(u),r.end()}f.dispose()}});return p.onCancellationRequested(()=>{r.error((0,o.canceled)()),r.end(),f.dispose()}),r}writeFile(h,g,p){return this.a.call("writeFile",[h,S.VSBuffer.wrap(g),p])}open(h,g){return this.a.call("open",[h,g])}close(h){return this.a.call("close",[h])}async read(h,g,p,r,f){const[c,u]=await this.a.call("read",[h,g,f]);return p.set(c.buffer.slice(0,u),r),u}write(h,g,p,r,f){return this.a.call("write",[h,g,S.VSBuffer.wrap(p),r,f])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,g){return this.a.call("delete",[h,g])}rename(h,g,p){return this.a.call("rename",[h,g,p])}copy(h,g,p){return this.a.call("copy",[h,g,p])}cloneFile(h,g){return this.a.call("cloneFile",[h,g])}i(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const g=h;this.f.fire(g.map(p=>({resource:b.URI.revive(p.resource),type:p.type})))}else{const g=h;this.g.fire(g)}}))}watch(h,g){const p=(0,m.generateUuid)();return this.a.call("watch",[this.h,p,h,g]),(0,k.toDisposable)(()=>this.a.call("unwatch",[this.h,p]))}}e.DiskFileSystemProviderClient=y}),define(pe[107],be([1,0,15,11,183,16]),function(le,e,S,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(T,y,v,h,g,p){let r;try{await R(T,y,v,h,g,p)}catch(f){r=f}finally{r&&g.errorTransformer&&(r=g.errorTransformer(r)),typeof r<"u"&&v.error(r),v.end()}}e.readFileIntoStream=k;async function R(T,y,v,h,g,p){b(p);const r=await T.open(y,{create:!1});try{b(p);let f=0,c=0,u=g&&typeof g.length=="number"?g.length:void 0,D=S.VSBuffer.alloc(Math.min(g.bufferSize,typeof u=="number"?u:g.bufferSize)),O=g&&typeof g.position=="number"?g.position:0,t=0;do c=await T.read(r,O,D.buffer,t,D.byteLength-t),O+=c,t+=c,f+=c,typeof u=="number"&&(u-=c),t===D.byteLength&&(await v.write(h(D)),D=S.VSBuffer.alloc(Math.min(g.bufferSize,typeof u=="number"?u:g.bufferSize)),t=0);while(c>0&&(typeof u!="number"||u>0)&&b(p)&&m(f,g));if(t>0){let n=t;typeof u=="number"&&(n=Math.min(t,u)),v.write(h(D.slice(0,n)))}}catch(f){throw(0,A.ensureFileSystemProviderError)(f)}finally{await T.close(r)}}function b(T){if(T.isCancellationRequested)throw(0,L.canceled)();return!0}function m(T,y){if(typeof y?.limits?.size=="number"&&T>y.limits.size)throw(0,A.createFileSystemProviderError)((0,o.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(pe[65],be([1,0,76,2,7,3,4,16]),function(le,e,S,L,o,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function b(f){return f.recursive===!0}e.isRecursiveWatchRequest=b;class m extends L.Disposable{constructor(c,u,D,O){super(),this.h=c,this.i=u,this.j=D,this.k=O,this.c=this.B(new L.MutableDisposable),this.f=void 0,this.g=0}m(){const c=new L.DisposableStore;this.c.value=c,this.b=this.l(c),this.b.setVerboseLogging(this.j),c.add(this.b.onDidChangeFile(u=>this.h(u))),c.add(this.b.onDidLogMessage(u=>this.i(u))),c.add(this.b.onDidError(u=>this.n(u)))}n(c){this.k.restartOnError?this.g<m.a&&this.f?(this.r(`restarting watcher after error: ${c}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${c}`):this.r(c)}p(c){this.g++,this.m(),this.watch(c)}async watch(c){this.f=c,await this.b?.watch(c)}async setVerboseLogging(c){this.j=c,await this.b?.setVerboseLogging(c)}r(c){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${c}`})}s(c){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${c}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.a=5;class T extends m{constructor(c,u,D){super(c,u,D,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=T;class y extends m{constructor(c,u,D){super(c,u,D,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function v(f){return f.map(c=>({type:c.type,resource:k.URI.file(c.path)}))}e.toFileChanges=v;function h(f){const c=new r;for(const u of f)c.processEvent(u);return c.coalesce()}e.coalesceEvents=h;function g(f,c){return typeof c=="string"&&!c.startsWith(S.GLOBSTAR)&&!(0,o.isAbsolute)(c)?{base:f,pattern:c}:c}e.normalizeWatcherPattern=g;function p(f,c){const u=[];for(const D of c)u.push((0,S.parse)(g(f,D)));return u}e.parseWatcherPatterns=p;class r{constructor(){this.a=new Set,this.b=new Map}c(c){return A.isLinux?c.path:c.path.toLowerCase()}processEvent(c){const u=this.b.get(this.c(c));let D=!1;if(u){const O=u.type,t=c.type;u.path!==c.path&&(c.type===2||c.type===1)?D=!0:O===1&&t===2?(this.b.delete(this.c(c)),this.a.delete(u)):O===2&&t===1?u.type=0:O===1&&t===0||(u.type=t)}else D=!0;D&&(this.a.add(c),this.b.set(this.c(c),c))}coalesce(){const c=[],u=[];return Array.from(this.a).filter(D=>D.type!==2?(c.push(D),!1):!0).sort((D,O)=>D.path.length-O.path.length).filter(D=>u.some(O=>(0,R.isParent)(D.path,O,!A.isLinux))?!1:(u.push(D.path),!0)).concat(c)}}}),define(pe[215],be([1,0,33,14,20,39,2,95,7,3,162,23,65]),function(le,e,S,L,o,A,k,R,b,m,T,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends k.Disposable{constructor(r,f,c,u){super(),this.j=r,this.k=f,this.l=c,this.m=u,this.c=this.B(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},D=>this.k(D))),this.f=this.B(new L.RunOnceWorker(D=>this.u(D),h.b)),this.g=(0,v.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,v.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new o.CancellationTokenSource,this.ready=this.n()}async n(){try{const r=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const f=await y.Promises.stat(r);this.B(await this.s(r,f.isDirectory()))}catch(r){r.code!=="ENOENT"?this.w(r):this.z(r)}}async r(r){let f=r.path;try{f=await y.Promises.realpath(r.path),r.path===f&&(f=await(0,T.realcase)(r.path)??r.path),r.path!==f&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${f})`)}catch{}return f}async s(r,f){if(m.isMacintosh&&(0,A.isEqualOrParent)(r,"/Volumes/",!0))return this.w(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const c=new o.CancellationTokenSource(this.i.token),u=new k.DisposableStore;try{const D=(0,b.basename)(r),O=(0,S.watch)(r);u.add((0,k.toDisposable)(()=>{O.removeAllListeners(),O.close()})),this.z(`Started watching: '${r}'`);const t=new Set;if(f)try{for(const s of await y.Promises.readdir(r))t.add(s)}catch(s){this.w(s)}const n=new Map;u.add((0,k.toDisposable)(()=>{for(const[,s]of n)s.dispose();n.clear()})),O.on("error",(s,i)=>{this.w(`Failed to watch ${r} for changes using fs.watch() (${s}, ${i})`),this.dispose()}),O.on("change",(s,i)=>{if(c.token.isCancellationRequested)return;this.z(`[raw] ["${s}"] ${i}`);let a="";if(i&&(a=i.toString(),m.isMacintosh&&(a=(0,R.normalizeNFC)(a))),!(!a||s!=="change"&&s!=="rename"))if(f)if(s==="rename"){n.get(a)?.dispose();const l=setTimeout(async()=>{if(n.delete(a),a===D&&!await y.Promises.exists(r)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const d=await this.v((0,b.join)(r,a));if(c.token.isCancellationRequested)return;let I;d?t.has(a)?I=0:(I=1,t.add(a)):(t.delete(a),I=2),this.t({path:(0,b.join)(this.j.path,a),type:I})},h.a);n.set(a,(0,k.toDisposable)(()=>clearTimeout(l)))}else{let l;t.has(a)?l=0:(l=1,t.add(a)),this.t({path:(0,b.join)(this.j.path,a),type:l})}else if(s==="rename"||a!==D){const l=setTimeout(async()=>{const d=await y.Promises.exists(r);c.token.isCancellationRequested||(d?(this.t({path:this.j.path,type:0},!0),u.add(await this.s(r,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},h.a);u.clear(),u.add((0,k.toDisposable)(()=>clearTimeout(l)))}else this.t({path:this.j.path,type:0},!0)})}catch(D){await y.Promises.exists(r)&&!c.token.isCancellationRequested&&this.w(`Failed to watch ${r} for changes using fs.watch() (${D.toString()})`)}return(0,k.toDisposable)(()=>{c.dispose(!0),u.dispose()})}t(r,f=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`),!f&&this.g.some(c=>c(r.path))?this.m&&this.z(` >> ignored (excluded) ${r.path}`):!f&&this.h&&this.h.length>0&&!this.h.some(c=>c(r.path))?this.m&&this.z(` >> ignored (not included) ${r.path}`):this.f.work(r))}u(r){const f=(0,v.coalesceEvents)(r);if(f.length>0){if(this.m)for(const u of f)this.z(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);this.c.work(f)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(r){if(m.isLinux)return y.Promises.exists(r);try{const f=(0,b.basename)(r);return(await y.Promises.readdir((0,b.dirname)(r))).some(u=>u===f)}catch(f){return this.z(f),!1}}setVerboseLogging(r){this.m=r}w(r){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}y(r){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}z(r){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=h,h.a=100,h.b=75;async function g(p,r,f,c,u=512){const D=await y.Promises.open(p,"r"),O=Buffer.allocUnsafe(u),t=new o.CancellationTokenSource(c);let n,s=!1;const i={path:p,excludes:[],recursive:!1},a=new h(i,l=>{(async()=>{for(const{type:d}of l)if(d===0){if(s)return;s=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:I}=await y.Promises.read(D,O,0,u,null);if(!I||t.token.isCancellationRequested)break;r(O.slice(0,I))}}catch(I){n=new Error(I),t.dispose(!0)}finally{s=!1}}})()});return await a.ready,f(),new Promise((l,d)=>{t.token.onCancellationRequested(async()=>{a.dispose();try{await y.Promises.close(D)}catch(I){n=new Error(I)}n?d(n):l()})})}e.watchFileContents=g}),define(pe[216],be([1,0,6,76,2,3,215]),function(le,e,S,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends o.Disposable{constructor(){super(...arguments),this.a=this.B(new S.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new S.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(m){const T=this.i(m),y=T.filter(h=>{const g=this.c.get(h.path);return g?!(0,L.patternsEquals)(g.request.excludes,h.excludes)||!(0,L.patternsEquals)(g.request.includes,h.includes):!0}),v=Array.from(this.c.values()).filter(({request:h})=>!T.find(g=>g.path===h.path&&(0,L.patternsEquals)(g.excludes,h.excludes)&&(0,L.patternsEquals)(g.includes,h.includes))).map(({request:h})=>h.path);y.length&&this.j(`Request to start watching: ${y.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),v.length&&this.j(`Request to stop watching: ${v.join(",")}`);for(const h of v)this.h(h);for(const h of y)this.g(h)}g(m){const T=new k.NodeJSFileWatcherLibrary(m,v=>this.a.fire(v),v=>this.b.fire(v),this.f),y={request:m,instance:T};this.c.set(m.path,y)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const T=this.c.get(m);T&&(this.c.delete(m),T.instance.dispose())}i(m){const T=new Map;for(const y of m){const v=A.isLinux?y.path:y.path.toLowerCase();T.set(v,y)}return Array.from(T.values())}async setVerboseLogging(m){this.f=m;for(const[,T]of this.c)T.instance.setVerboseLogging(m)}j(m){this.f&&this.b.fire({type:"trace",message:this.k(m)})}k(m,T){return T?`[File Watcher (node.js)] ${m} (path: ${T.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=R}),define(pe[217],be([1,0,65,216]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class o extends S.AbstractNonRecursiveWatcherClient{constructor(k,R,b){super(k,R,b),this.m()}l(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=o}),define(pe[218],be([1,0,13,42,105,65]),function(le,e,S,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends A.AbstractUniversalWatcherClient{constructor(b,m,T){super(b,m,T),this.m()}l(b){const m=b.add(new o.Client(S.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(m.onDidProcessExit(({code:T,signal:y})=>this.n(`terminated by itself with code ${T}, signal: ${y}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(pe[81],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...o){this.a=new Map;for(const[A,k]of o)this.set(A,k)}set(o,A){const k=this.a.get(o);return this.a.set(o,A),k}has(o){return this.a.has(o)}get(o){return this.a.get(o)}}e.ServiceCollection=S}),define(pe[108],be([1,0,14,11,2,63,210,5,81,94]),function(le,e,S,L,o,A,k,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const T=!1;class y extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class v{constructor(r=new b.ServiceCollection,f=!1,c,u=T){this.f=r,this.g=f,this.h=c,this.i=u,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=u?c?._globalGraph??new k.Graph(D=>D):void 0}createChild(r){return new v(r,this.g,this,this.i)}invokeFunction(r,...f){const c=g.traceInvocation(this.i,r);let u=!1;try{return r({get:O=>{if(u)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(O,c);if(!t)throw new Error(`[invokeFunction] unknown service '${O}'`);return t}},...f)}finally{u=!0,c.stop()}}createInstance(r,...f){let c,u;return r instanceof A.SyncDescriptor?(c=g.traceCreation(this.i,r.ctor),u=this.j(r.ctor,r.staticArguments.concat(f),c)):(c=g.traceCreation(this.i,r),u=this.j(r,f,c)),c.stop(),u}j(r,f=[],c){const u=R._util.getServiceDependencies(r).sort((t,n)=>t.index-n.index),D=[];for(const t of u){const n=this.m(t.id,c);n||this.u(`[createInstance] ${r.name} depends on UNKNOWN service ${t.id}.`,!1),D.push(n)}const O=u.length>0?u[0].index:f.length;if(f.length!==O){console.trace(`[createInstance] First service dependency of ${r.name} at position ${O+1} conflicts with ${f.length} static arguments`);const t=O-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,O)}return Reflect.construct(r,f.concat(D))}k(r,f){if(this.f.get(r)instanceof A.SyncDescriptor)this.f.set(r,f);else if(this.h)this.h.k(r,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(r){const f=this.f.get(r);return!f&&this.h?this.h.l(r):f}m(r,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const c=this.l(r);return c instanceof A.SyncDescriptor?this.q(r,c,f.branch(r,!0)):(f.branch(r,!1),c)}q(r,f,c){if(this.o.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.o.add(r);try{return this.r(r,f,c)}finally{this.o.delete(r)}}r(r,f,c){const u=new k.Graph(t=>t.id.toString());let D=0;const O=[{id:r,desc:f,_trace:c}];for(;O.length;){const t=O.pop();if(u.lookupOrInsertNode(t),D++>1e3)throw new y(u);for(const n of R._util.getServiceDependencies(t.desc.ctor)){const s=this.l(n.id);if(s||this.u(`[createInstance] ${r} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),s instanceof A.SyncDescriptor){const i={id:n.id,desc:s,_trace:t._trace.branch(n.id,!0)};u.insertEdge(t,i),O.push(i)}}}for(;;){const t=u.roots();if(t.length===0){if(!u.isEmpty())throw new y(u);break}for(const{data:n}of t){if(this.l(n.id)instanceof A.SyncDescriptor){const i=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,i)}u.removeNode(n)}}return this.l(r)}s(r,f,c=[],u,D){if(this.f.get(r)instanceof A.SyncDescriptor)return this.t(r,f,c,u,D);if(this.h)return this.h.s(r,f,c,u,D);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(r,f,c=[],u,D){if(u){const O=new v(void 0,this.g,this,this.i);O.c=String(r);const t=new Map,n=new S.IdleValue(()=>{const s=O.j(f,c,D);for(const[i,a]of t){const l=s[i];if(typeof l=="function")for(const d of a)l.apply(s,d)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let d=t.get(i);return d||(d=new m.LinkedList,t.set(i,d)),(C,E,w)=>{const N=d.push([C,E,w]);return(0,o.toDisposable)(N)}}if(i in s)return s[i];const a=n.value;let l=a[i];return typeof l!="function"||(l=l.bind(a),s[i]=l),l},set(s,i,a){return n.value[i]=a,!0},getPrototypeOf(s){return f.prototype}})}else return this.j(f,c,D)}u(r,f){if(f&&console.warn(r),this.g)throw new Error(r)}}e.InstantiationService=v;var h;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(h||(h={}));class g{static traceInvocation(r,f){return r?new g(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(r,f){return r?new g(1,f.name):g.c}constructor(r,f){this.type=r,this.name=f,this.g=Date.now(),this.h=[]}branch(r,f){const c=new g(3,r.toString());return this.h.push([r,f,c]),c}stop(){const r=Date.now()-this.g;g.f+=r;let f=!1;function c(D,O){const t=[],n=new Array(D+1).join("	");for(const[s,i,a]of O.h)if(i&&a){f=!0,t.push(`${n}CREATES -> ${s}`);const l=c(D+1,a);l&&t.push(l)}else t.push(`${n}uses -> ${s}`);return t.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(r>2||f)&&g.all.add(u.join(`
`))}}e.Trace=g,g.all=new Set,g.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}},g.f=0}),define(pe[219],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.ILabelService=void 0,e.ILabelService=(0,S.createDecorator)("labelService");var L;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(L||(e.Verbosity=L={}))});var Ae=this&&this.__param||function(le,e){return function(S,L){e(S,L,le)}};define(pe[82],be([1,0,20,2,3,185,30,5]),function(le,e,S,L,o,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function b(T){return T.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=b,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let m=e.LanguagePackBaseService=class extends L.Disposable{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new S.CancellationTokenSource;setTimeout(()=>y.cancel(),1e3);let v;try{v=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const g=v.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(r=>r.startsWith("lp-"))).map(p=>{const r=p.properties.localizedLanguages?.[0],f=b(p);return{...this.f(f,r,p),extensionId:p.identifier.id,galleryExtension:p}});return g.push(this.f("en","English")),g}f(y,v,h){const g=v??y;let p;if(g!==y&&(p=`(${y})`),y.toLowerCase()===o.language.toLowerCase()&&(p??="",p+=(0,A.localize)(0,null)),h?.installCount){p??="";const r=h.installCount;let f;r>1e6?f=`${Math.floor(r/1e5)/10}M`:r>1e3?f=`${Math.floor(r/1e3)}K`:f=String(r),p+=` $(cloud-download) ${f}`}return{id:y,label:g,description:p}}};e.LanguagePackBaseService=m=Le([Ae(0,k.IExtensionGalleryService)],m)}),define(pe[12],be([1,0,38,6,75,2,27,3,19,8,4,64,5]),function(le,e,S,L,o,A,k,R,b,m,T,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function h(){return new Date().toISOString()}function g(C){return(0,m.isNumber)(C)}e.isLogLevel=g;var p;(function(C){C[C.Off=0]="Off",C[C.Trace=1]="Trace",C[C.Debug=2]="Debug",C[C.Info=3]="Info",C[C.Warning=4]="Warning",C[C.Error=5]="Error"})(p||(e.LogLevel=p={})),e.DEFAULT_LOG_LEVEL=p.Info;function r(C,E,w){switch(E){case p.Trace:C.trace(w);break;case p.Debug:C.debug(w);break;case p.Info:C.info(w);break;case p.Warning:C.warn(w);break;case p.Error:C.error(w);break;case p.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=r;function f(C,E=!1){let w="";for(let N=0;N<C.length;N++){let $=C[N];if($ instanceof Error&&($=(0,S.toErrorMessage)($,E)),typeof $=="object")try{$=JSON.stringify($)}catch{}w+=(N>0?" ":"")+$}return w}class c extends A.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new L.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==p.Off&&this.b<=E}}e.AbstractLogger=c;class u extends c{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...w){this.f(p.Trace)&&this.g(p.Trace,f([E,...w],!0))}debug(E,...w){this.f(p.Debug)&&this.g(p.Debug,f([E,...w]))}info(E,...w){this.f(p.Info)&&this.g(p.Info,f([E,...w]))}warn(E,...w){this.f(p.Warning)&&this.g(p.Warning,f([E,...w]))}error(E,...w){if(this.f(p.Error))if(E instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=E.stack,this.g(p.Error,f(N))}else this.g(p.Error,f([E,...w]))}flush(){}}e.AbstractMessageLogger=u;class D extends c{constructor(E=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(E),this.g=!R.isWindows}trace(E,...w){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,E,...w):console.log(`[main ${h()}]`,E,...w))}debug(E,...w){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,E,...w):console.log(`[main ${h()}]`,E,...w))}info(E,...w){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,E,...w):console.log(`[main ${h()}]`,E,...w))}warn(E,...w){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,E,...w):console.warn(`[main ${h()}]`,E,...w))}error(E,...w){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,E,...w):console.error(`[main ${h()}]`,E,...w))}dispose(){}flush(){}}e.ConsoleMainLogger=D;class O extends c{constructor(E=e.DEFAULT_LOG_LEVEL,w=!0){super(),this.g=w,this.setLevel(E)}trace(E,...w){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...w):console.log(E,...w))}debug(E,...w){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...w):console.log(E,...w))}info(E,...w){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...w):console.log(E,...w))}warn(E,...w){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...w):console.log(E,...w))}error(E,...w){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...w):console.error(E,...w))}dispose(){}flush(){}}e.ConsoleLogger=O;class t extends c{constructor(E,w=e.DEFAULT_LOG_LEVEL){super(),this.g=E,this.setLevel(w)}trace(E,...w){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(E),...w])}debug(E,...w){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(E),...w])}info(E,...w){this.f(p.Info)&&this.g.log(p.Info,[this.h(E),...w])}warn(E,...w){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(E),...w])}error(E,...w){this.f(p.Error)&&this.g.log(p.Error,[this.h(E),...w])}h(E){return typeof E=="string"?E:(0,S.toErrorMessage)(E,this.f(p.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class n extends c{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const w of this.g)w.setLevel(E);super.setLevel(E)}trace(E,...w){for(const N of this.g)N.trace(E,...w)}debug(E,...w){for(const N of this.g)N.debug(E,...w)}info(E,...w){for(const N of this.g)N.info(E,...w)}warn(E,...w){for(const N of this.g)N.warn(E,...w)}error(E,...w){for(const N of this.g)N.error(E,...w)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose()}}e.MultiplexLogger=n;class s extends A.Disposable{constructor(E,w,N){if(super(),this.h=E,this.j=w,this.b=new k.ResourceMap,this.c=this.B(new L.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeVisibility=this.g.event,N)for(const $ of N)this.b.set($.resource,{logger:void 0,info:$})}k(E){return(0,m.isString)(E)?[...this.b.values()].find(w=>w.info.id===E):this.b.get(E)}getLogger(E){return this.k(E)?.logger}createLogger(E,w){const N=this.l(E),$=(0,m.isString)(E)?E:w?.id??(0,o.hash)(N.toString()).toString(16);let se=this.b.get(N)?.logger;const he=w?.logLevel==="always"?p.Trace:w?.logLevel;se||(se=this.m(N,he??this.getLogLevel(N)??this.h,{...w,id:$}));const ae={logger:se,info:{resource:N,id:$,logLevel:he,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId,when:w?.when}};return this.registerLogger(ae.info),this.b.set(N,ae),se}l(E){return(0,m.isString)(E)?(0,b.joinPath)(this.j,`${E}.log`):E}setLogLevel(E,w){if(T.URI.isUri(E)){const N=E,$=w,se=this.b.get(N);se&&$!==se.info.logLevel&&(se.info.logLevel=$===this.h?void 0:$,se.logger?.setLevel($),this.b.set(se.info.resource,se),this.f.fire([N,$]))}else{this.h=E;for(const[N,$]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&$.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,w){const N=this.k(E);N&&w!==!N.info.hidden&&(N.info.hidden=!w,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,w]))}getLogLevel(E){let w;return E&&(w=this.b.get(E)?.info.logLevel),w??this.h}registerLogger(E){const w=this.b.get(E.resource);w?w.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const w=this.b.get(E);w&&(w.logger&&w.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[w.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=s;class i{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(E){}getLevel(){return p.Info}trace(E,...w){}debug(E,...w){}info(E,...w){}warn(E,...w){}error(E,...w){}critical(E,...w){}dispose(){}flush(){}}e.NullLogger=i;class a extends i{}e.NullLogService=a;function l(C){if(C.verbose)return p.Trace;if(typeof C.logLevel=="string"){const E=I(C.logLevel.toLowerCase());if(E!==void 0)return E}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function d(C){switch(C){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.LogLevelToString=d;function I(C){switch(C){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.parseLogLevel=I,e.CONTEXT_LOG_LEVEL=new y.RawContextKey("logLevel",d(p.Info))}),define(pe[220],be([1,0,78,6,2,12,3,14]),function(le,e,S,L,o,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let b=e.BaseCredentialsMainService=class Kt extends o.Disposable{constructor(T){super(),this.h=T,this.c=this.B(new L.Emitter),this.onDidChangePassword=this.c.event,this.g=new R.SequencerByKey}async getPassword(T,y){this.h.trace("Going to get password from keytar:",T,y);let v;try{v=await this.i()}catch{return null}return await this.g.queue(T+y,()=>this.k(v,T,y))}async k(T,y,v){this.h.trace("Doing get password from keytar:",y,v);const h=await(0,R.retry)(()=>T.getPassword(y,v),50,3);if(!h)return this.h.trace("Did not get a password from keytar for account:",v),h;let g,p;try{const r=JSON.parse(h);g=r.content,p=r.hasNextChunk}catch{}if(!g||!p)return this.h.trace("Got password from keytar for account:",v),h;try{let r=1;for(;p;){const f=await(0,R.retry)(()=>T.getPassword(y,`${v}-${r}`),50,3),c=JSON.parse(f);g+=c.content,p=c.hasNextChunk,r++}return this.h.trace(`Got ${r}-chunked password from keytar for account:`,v),g}catch(r){return this.h.error(r),h}}async setPassword(T,y,v){this.h.trace("Going to set password using keytar:",T,y);let h;try{h=await this.i()}catch(g){throw this.j?.(g),g}await this.g.queue(T+y,()=>this.l(h,T,y,v)),this.c.fire({service:T,account:y})}async l(T,y,v,h){if(this.h.trace("Doing set password from keytar:",y,v),!k.isWindows){await(0,R.retry)(()=>T.setPassword(y,v,h),50,3),this.h.trace("Set password from keytar for account:",v);return}if(await this.m(T,y,v),h.length<=Kt.b){await(0,R.retry)(()=>T.setPassword(y,v,h),50,3),this.h.trace("Set password from keytar for account:",v);return}let g=0,p=0,r=!0;for(;r;){const f=h.substring(g,g+Kt.b);g+=Kt.b,r=h.length-g>0;const c={content:f,hasNextChunk:r};await(0,R.retry)(()=>T.setPassword(y,p?`${v}-${p}`:v,JSON.stringify(c)),50,3),p++}this.h.trace(`Set${p?` ${p}-chunked`:""} password from keytar for account:`,v)}async deletePassword(T,y){this.h.trace("Going to delete password using keytar:",T,y);let v;try{v=await this.i()}catch(g){throw this.j?.(g),g}const h=await this.g.queue(T+y,()=>this.m(v,T,y));return h&&this.c.fire({service:T,account:y}),h}async m(T,y,v){this.h.trace("Doing delete password from keytar:",y,v);const h=await T.getPassword(y,v);if(!h)return this.h.trace("Did not get a password to delete from keytar for account:",v),!1;let g,p;try{const f=JSON.parse(h);g=f.content,p=f.hasNextChunk}catch{}let r=0;if(g&&p)try{for(r++;p;){const f=`${v}-${r}`,c=await T.getPassword(y,f);await T.deletePassword(y,f),p=JSON.parse(c).hasNextChunk,r++}}catch(f){this.h.error(f)}return await T.deletePassword(y,v)?(this.h.trace(`Deleted${r?` ${r}-chunked`:""} password from keytar for account:`,v),!0):(this.h.trace(`Keytar failed to delete${r?` ${r}-chunked`:""} password for account:`,v),!1)}async findPassword(T){let y;try{y=await this.i()}catch{return null}return await y.findPassword(T)}async findCredentials(T){let y;try{y=await this.i()}catch{return[]}return await y.findCredentials(T)}clear(){return this.f instanceof S.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};b.a=2500,b.b=b.a-100,e.BaseCredentialsMainService=b=Le([Ae(0,A.ILogService)],b)}),define(pe[221],be([1,0,12]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let L=e.EncryptionMainService=class{constructor(A,k){this.a=A,this.b=k}c(){return new Promise((A,k)=>le(["vscode-encrypt"],A,k))}async encrypt(A){let k;try{k=await this.c()}catch{return A}try{return k.encrypt(this.a,A)}catch(R){return this.b.error(R),A}}async decrypt(A){let k;try{k=await this.c()}catch{return A}try{return k.decrypt(this.a,A)}catch(R){return this.b.error(R),A}}};e.EncryptionMainService=L=Le([Ae(1,S.ILogService)],L)}),define(pe[222],be([1,0,18,14,11,6,2,7,65,12]),function(le,e,S,L,o,A,k,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends k.Disposable{constructor(v,h){super(),this.a=v,this.b=h,this.c=this.B(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new L.ThrottledDelayer(0)),this.s=[],this.t=this.B(new L.ThrottledDelayer(0))}watch(v,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(v,h):this.u(v,h)}l(v,h){const g={path:this.C(v),excludes:h.excludes,includes:h.includes,recursive:h.recursive},p=(0,S.insert)(this.j,g);return this.m(),(0,k.toDisposable)(()=>{p(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(v=>(0,o.onUnexpectedError)(v))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,b.toFileChanges)(h)),h=>this.z(h),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const h of this.j)(0,b.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const h of this.j)(0,b.isRecursiveWatchRequest)(h)&&v.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(v,h){const g={path:this.C(v),excludes:h.excludes,includes:h.includes,recursive:!1},p=(0,S.insert)(this.s,g);return this.v(),(0,k.toDisposable)(()=>{p(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(v=>(0,o.onUnexpectedError)(v))}w(){return this.r||(this.r=this.B(this.y(v=>this.c.fire((0,b.toFileChanges)(v)),v=>this.z(v),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.r.watch(this.s)}z(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}C(v){return(0,R.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(pe[109],be([1,0,18,14,15,20,6,75,46,2,61,13,41,19,47,181,16,107,12,11]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let D=e.FileService=class extends m.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new k.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new k.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new k.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new k.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new L.ResourceQueue)}registerProvider(t,n){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${t}`);const s=new m.DisposableStore;return this.h.set(t,n),this.c.fire({added:!0,scheme:t,provider:n}),s.add(n.onDidChangeFile(i=>this.R.fire(new r.FileChangesEvent(i,!this.O(n))))),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(i=>this.S.fire(new Error(i)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:t}))),(0,m.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:n}),this.h.delete(t),(0,m.dispose)(s)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const n=[];this.f.fire({scheme:t,join(s){n.push(s)}}),!this.h.has(t)&&await L.Promises.settled(n)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,n){const s=this.h.get(t.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return b.Iterable.map(this.h,([t,n])=>({scheme:t,capabilities:n.capabilities}))}async j(t){if(!(0,h.isAbsolutePath)(t))throw new r.FileOperationError((0,p.localize)(0,null,this.ob(t)),8);await this.activateProvider(t.scheme);const n=this.h.get(t.scheme);if(!n){const s=new u.ErrorNoTelemetry;throw s.message=(0,p.localize)(1,null,t.toString()),s}return n}async k(t){const n=await this.j(t);if((0,r.hasOpenReadWriteCloseCapability)(n)||(0,r.hasReadWriteCapability)(n)||(0,r.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const n=await this.j(t);if((0,r.hasOpenReadWriteCloseCapability)(n)||(0,r.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,n){try{return await this.n(t,n)}catch(s){throw(0,r.toFileSystemProviderErrorCode)(s)===r.FileSystemProviderErrorCode.FileNotFound?new r.FileOperationError((0,p.localize)(2,null,this.ob(t)),1):(0,r.ensureFileSystemProviderError)(s)}}async n(t,n){const s=await this.j(t),i=this.O(s),a=n?.resolveTo,l=n?.resolveSingleChildDescendants,d=n?.resolveMetadata,I=await s.stat(t);let C;return this.p(s,t,I,void 0,!!d,(E,w)=>(C||(C=T.TernarySearchTree.forUris(()=>!i),C.set(t,!0),a&&C.fill(!0,a)),C.get(E.resource)||C.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&l?w===1:!1))}async p(t,n,s,i,a,l){const{providerExtUri:d}=this.N(t),I={resource:n,name:d.basename(n),isFile:(s.type&r.FileType.File)!==0,isDirectory:(s.type&r.FileType.Directory)!==0,isSymbolicLink:(s.type&r.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&r.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((s.permissions??0)&r.FilePermission.Locked),etag:(0,r.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(I.isDirectory&&l(I,i)){try{const C=await t.readdir(n),E=await L.Promises.settled(C.map(async([w,N])=>{try{const $=d.joinPath(n,w),se=a?await t.stat($):{type:N};return await this.p(t,$,se,C.length,a,l)}catch($){return this.b.trace($),null}}));I.children=(0,S.coalesce)(E)}catch(C){this.b.trace(C),I.children=[]}return I}return I}async resolveAll(t){return L.Promises.settled(t.map(async n=>{try{return{stat:await this.n(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(t){const n=await this.j(t),s=await n.stat(t);return this.p(n,t,s,void 0,!0,()=>!1)}async exists(t){const n=await this.j(t);try{return!!await n.stat(t)}catch{return!1}}async canCreateFile(t,n){try{await this.r(t,n)}catch(s){return s}return!0}async r(t,n){if(!n?.overwrite&&await this.exists(t))throw new r.FileOperationError((0,p.localize)(3,null,this.ob(t)),3,n)}async createFile(t,n=o.VSBuffer.fromString(""),s){await this.r(t,s);const i=await this.writeFile(t,n);return this.m.fire(new r.FileOperationEvent(t,0,i)),i}async writeFile(t,n,s){const i=this.mb(await this.l(t),t),{providerExtUri:a}=this.N(i);try{await this.s(i,t,s)||await this.P(i,a.dirname(t));let d;if((0,r.hasReadWriteCapability)(i)&&!(n instanceof o.VSBuffer))if((0,g.isReadableStream)(n)){const I=await(0,g.peekStream)(n,3);I.ended?d=o.VSBuffer.concat(I.buffer):d=I}else d=(0,g.peekReadable)(n,I=>o.VSBuffer.concat(I),3);else d=n;if(!(0,r.hasOpenReadWriteCloseCapability)(i)||(0,r.hasReadWriteCapability)(i)&&d instanceof o.VSBuffer)await this.db(i,t,s,d);else{const I=d instanceof o.VSBuffer?(0,o.bufferToReadable)(d):d;s?.atomic!==!1&&s?.atomic?.postfix?await this.Y(i,t,(0,h.joinPath)((0,h.dirname)(t),`${(0,h.basename)(t)}${s.atomic.postfix}`),s,I):await this.Z(i,t,s,I)}this.m.fire(new r.FileOperationEvent(t,4))}catch(l){throw new r.FileOperationError((0,p.localize)(4,null,this.ob(t),(0,r.ensureFileSystemProviderError)(l).toString()),(0,r.toFileOperationResult)(l),s)}return this.resolve(t,{resolveMetadata:!0})}async s(t,n,s){const i=!!s?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,p.localize)(5,null,this.ob(n)));if(!!s?.atomic){if(!(t.capabilities&32768))throw new Error((0,p.localize)(6,null,this.ob(n)));if(i)throw new Error((0,p.localize)(7,null,this.ob(n)))}let l;try{l=await t.stat(n)}catch{return}if(l.type&r.FileType.Directory)throw new r.FileOperationError((0,p.localize)(8,null,this.ob(n)),0,s);if(this.nb(n,l),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==r.ETAG_DISABLED&&typeof l.mtime=="number"&&typeof l.size=="number"&&s.mtime<l.mtime&&s.etag!==(0,r.etag)({mtime:s.mtime,size:l.size}))throw new r.FileOperationError((0,p.localize)(9,null),3,s);return l}async readFile(t,n,s){const i=await this.k(t);return n?.atomic?this.t(i,t,n,s):this.u(i,t,n,s)}async t(t,n,s,i){return new Promise((a,l)=>{this.X.queueFor(n,this.N(t).providerExtUri).queue(async()=>{try{const d=await this.u(t,n,s,i);a(d)}catch(d){l(d)}})})}async u(t,n,s,i){const a=await this.v(t,n,{...s,preferUnbuffered:!0},i);return{...a,value:await(0,o.streamToBuffer)(a.value)}}async readFileStream(t,n,s){const i=await this.k(t);return this.v(i,t,n,s)}async v(t,n,s,i){const a=new A.CancellationTokenSource(i),l=this.F(n,s).then(I=>I,I=>{throw a.cancel(),I});let d;try{return typeof s?.etag=="string"&&s.etag!==r.ETAG_DISABLED&&await l,s?.atomic&&(0,r.hasFileAtomicReadCapability)(t)||!((0,r.hasOpenReadWriteCloseCapability)(t)||(0,r.hasFileReadStreamCapability)(t))||(0,r.hasReadWriteCapability)(t)&&s?.preferUnbuffered?d=this.D(t,n,s):(0,r.hasFileReadStreamCapability)(t)?d=this.z(t,n,a.token,s):d=this.C(t,n,a.token,s),{...await l,value:d}}catch(I){throw d&&await(0,g.consumeStream)(d),this.w(I,n,s)}}w(t,n,s){const i=(0,p.localize)(10,null,this.ob(n),(0,r.ensureFileSystemProviderError)(t).toString());return t instanceof r.NotModifiedSinceFileOperationError?new r.NotModifiedSinceFileOperationError(i,t.stat,s):t instanceof r.TooLargeFileOperationError?new r.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new r.FileOperationError(i,(0,r.toFileOperationResult)(t),s)}z(t,n,s,i=Object.create(null)){const a=t.readFileStream(n,i,s);return(0,g.transform)(a,{data:l=>l instanceof o.VSBuffer?l:o.VSBuffer.wrap(l),error:l=>this.w(l,n,i)},l=>o.VSBuffer.concat(l))}C(t,n,s,i=Object.create(null)){const a=(0,o.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,n,a,l=>l,{...i,bufferSize:this.a,errorTransformer:l=>this.w(l,n,i)},s),a}D(t,n,s){const i=(0,g.newWriteableStream)(a=>o.VSBuffer.concat(a));return(async()=>{try{let a;s?.atomic&&(0,r.hasFileAtomicReadCapability)(t)?a=await t.readFile(n,{atomic:!0}):a=await t.readFile(n),typeof s?.position=="number"&&(a=a.slice(s.position)),typeof s?.length=="number"&&(a=a.slice(0,s.length)),this.G(n,a.byteLength,s),i.end(o.VSBuffer.wrap(a))}catch(a){i.error(a),i.end()}})(),i}async F(t,n){const s=await this.resolve(t,{resolveMetadata:!0});if(s.isDirectory)throw new r.FileOperationError((0,p.localize)(11,null,this.ob(t)),0,n);if(typeof n?.etag=="string"&&n.etag!==r.ETAG_DISABLED&&n.etag===s.etag)throw new r.NotModifiedSinceFileOperationError((0,p.localize)(12,null),s,n);return this.G(t,s.size,n),s}G(t,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new r.TooLargeFileOperationError((0,p.localize)(13,null,this.ob(t)),7,n,s)}async canMove(t,n,s){return this.H(t,n,"move",s)}async canCopy(t,n,s){return this.H(t,n,"copy",s)}async H(t,n,s,i){if(t.toString()!==n.toString())try{const a=s==="move"?this.mb(await this.l(t),t):await this.k(t),l=this.mb(await this.l(n),n);await this.M(a,t,l,n,s,i)}catch(a){return a}return!0}async move(t,n,s){const i=this.mb(await this.l(t),t),a=this.mb(await this.l(n),n),l=await this.I(i,t,a,n,"move",!!s),d=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,l==="move"?2:3,d)),d}async copy(t,n,s){const i=await this.k(t),a=this.mb(await this.l(n),n),l=await this.I(i,t,a,n,"copy",!!s),d=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,l==="copy"?3:2,d)),d}async I(t,n,s,i,a,l){if(n.toString()===i.toString())return a;const{exists:d,isSameResourceWithDifferentPathCase:I}=await this.M(t,n,s,i,a,l);if(d&&!I&&l&&await this.del(i,{recursive:!0}),await this.P(s,this.N(s).providerExtUri.dirname(i)),a==="copy"){if(t===s&&(0,r.hasFileFolderCopyCapability)(t))await t.copy(n,i,{overwrite:l});else{const C=await this.resolve(n);C.isDirectory?await this.L(t,C,s,i):await this.J(t,n,s,i)}return a}else return t===s?(await t.rename(n,i,{overwrite:l}),a):(await this.I(t,n,s,i,"copy",l),await this.del(n,{recursive:!0}),"copy")}async J(t,n,s,i){if((0,r.hasOpenReadWriteCloseCapability)(t)&&(0,r.hasOpenReadWriteCloseCapability)(s))return this.fb(t,n,s,i);if((0,r.hasOpenReadWriteCloseCapability)(t)&&(0,r.hasReadWriteCapability)(s))return this.lb(t,n,s,i);if((0,r.hasReadWriteCapability)(t)&&(0,r.hasOpenReadWriteCloseCapability)(s))return this.jb(t,n,s,i);if((0,r.hasReadWriteCapability)(t)&&(0,r.hasReadWriteCapability)(s))return this.hb(t,n,s,i)}async L(t,n,s,i){await s.mkdir(i),Array.isArray(n.children)&&await L.Promises.settled(n.children.map(async a=>{const l=this.N(s).providerExtUri.joinPath(i,a.name);return a.isDirectory?this.L(t,await this.resolve(a.resource),s,l):this.J(t,a.resource,s,l)}))}async M(t,n,s,i,a,l){let d=!1;if(t===s){const{providerExtUri:C,isPathCaseSensitive:E}=this.N(t);if(E||(d=C.isEqual(n,i)),d&&a==="copy")throw new Error((0,p.localize)(14,null,this.ob(n),this.ob(i)));if(!d&&C.isEqualOrParent(i,n))throw new Error((0,p.localize)(15,null,this.ob(n),this.ob(i)))}const I=await this.exists(i);if(I&&!d){if(!l)throw new r.FileOperationError((0,p.localize)(16,null,this.ob(n),this.ob(i)),4);if(t===s){const{providerExtUri:C}=this.N(t);if(C.isEqualOrParent(n,i))throw new Error((0,p.localize)(17,null,this.ob(n),this.ob(i)))}}return{exists:I,isSameResourceWithDifferentPathCase:d}}N(t){const n=this.O(t);return{providerExtUri:n?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:n}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const n=this.mb(await this.j(t),t);await this.P(n,t);const s=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,0,s)),s}async P(t,n){const s=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(n,i.dirname(n));)try{if(!((await t.stat(n)).type&r.FileType.Directory))throw new Error((0,p.localize)(18,null,this.ob(n)));break}catch(a){if((0,r.toFileSystemProviderErrorCode)(a)!==r.FileSystemProviderErrorCode.FileNotFound)throw a;s.push(i.basename(n)),n=i.dirname(n)}for(let a=s.length-1;a>=0;a--){n=i.joinPath(n,s[a]);try{await t.mkdir(n)}catch(l){if((0,r.toFileSystemProviderErrorCode)(l)!==r.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(t,n){try{await this.Q(t,n)}catch(s){return s}return!0}async Q(t,n){const s=this.mb(await this.j(t),t),i=!!n?.useTrash;if(i&&!(s.capabilities&4096))throw new Error((0,p.localize)(19,null,this.ob(t)));const a=n?.atomic;if(a&&!(s.capabilities&65536))throw new Error((0,p.localize)(20,null,this.ob(t)));if(i&&a)throw new Error((0,p.localize)(21,null,this.ob(t)));let l;try{l=await s.stat(t)}catch{}if(l)this.nb(t,l);else throw new r.FileOperationError((0,p.localize)(22,null,this.ob(t)),1);if(!!!n?.recursive){const I=await this.resolve(t);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,p.localize)(23,null,this.ob(t)))}return s}async del(t,n){const s=await this.Q(t,n),i=!!n?.useTrash,a=!!n?.recursive,l=n?.atomic??!1;await s.delete(t,{recursive:a,useTrash:i,atomic:l}),this.m.fire(new r.FileOperationEvent(t,1))}async cloneFile(t,n){const s=await this.j(t),i=this.mb(await this.l(n),n);if(s===i&&this.N(s).providerExtUri.isEqual(t,n))return;if(s===i&&(0,r.hasFileCloneCapability)(s))return s.cloneFile(t,n);await this.P(i,this.N(i).providerExtUri.dirname(n));const a=this.X.queueFor(t,this.N(s).providerExtUri);return s===i&&(0,r.hasFileFolderCopyCapability)(s)?a.queue(()=>s.copy(t,n,{overwrite:!0})):a.queue(()=>this.J(s,t,i,n))}watch(t,n={recursive:!1,excludes:[]}){const s=new m.DisposableStore;let i=!1,a=()=>{i=!0};return s.add((0,m.toDisposable)(()=>a())),(async()=>{try{const l=await this.W(t,n);i?(0,m.dispose)(l):a=()=>(0,m.dispose)(l)}catch(l){this.b.error(l)}})(),s}async W(t,n){const s=await this.j(t),i=(0,R.hash)([this.N(s).providerExtUri.getComparisonKey(t),n]);let a=this.U.get(i);return a||(a={count:0,disposable:s.watch(t,n)},this.U.set(i,a)),a.count+=1,(0,m.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,m.dispose)(a.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,m.dispose)(t.disposable);this.U.clear()}async Y(t,n,s,i,a){await this.Z(t,s,i,a);try{await t.rename(s,n,{overwrite:!0})}catch(l){try{await t.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}async Z(t,n,s,i){return this.X.queueFor(n,this.N(t).providerExtUri).queue(async()=>{const a=await t.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,g.isReadableStream)(i)||(0,g.isReadableBufferedStream)(i)?await this.ab(t,a,i):await this.bb(t,a,i)}catch(l){throw(0,r.ensureFileSystemProviderError)(l)}finally{await t.close(a)}})}async ab(t,n,s){let i=0,a;if((0,g.isReadableBufferedStream)(s)){if(s.buffer.length>0){const l=o.VSBuffer.concat(s.buffer);await this.cb(t,n,l,l.byteLength,i,0),i+=l.byteLength}if(s.ended)return;a=s.stream}else a=s;return new Promise((l,d)=>{(0,g.listenStream)(a,{onData:async I=>{a.pause();try{await this.cb(t,n,I,I.byteLength,i,0)}catch(C){return d(C)}i+=I.byteLength,setTimeout(()=>a.resume())},onError:I=>d(I),onEnd:()=>l()})})}async bb(t,n,s){let i=0,a;for(;(a=s.read())!==null;)await this.cb(t,n,a,a.byteLength,i,0),i+=a.byteLength}async cb(t,n,s,i,a,l){let d=0;for(;d<i;){const I=await t.write(n,a+d,s.buffer,l+d,i-d);d+=I}}async db(t,n,s,i){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.eb(t,n,s,i))}async eb(t,n,s,i){let a;i instanceof o.VSBuffer?a=i:(0,g.isReadableStream)(i)?a=await(0,o.streamToBuffer)(i):(0,g.isReadableBufferedStream)(i)?a=await(0,o.bufferedStreamToBuffer)(i):a=(0,o.readableToBuffer)(i),await t.writeFile(n,a.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async fb(t,n,s,i){return this.X.queueFor(i,this.N(s).providerExtUri).queue(()=>this.gb(t,n,s,i))}async gb(t,n,s,i){let a,l;try{a=await t.open(n,{create:!1}),l=await s.open(i,{create:!0,unlock:!1});const d=o.VSBuffer.alloc(this.a);let I=0,C=0,E=0;do E=await t.read(a,I,d.buffer,C,d.byteLength-C),await this.cb(s,l,d,E,I,C),I+=E,C+=E,C===d.byteLength&&(C=0);while(E>0)}catch(d){throw(0,r.ensureFileSystemProviderError)(d)}finally{await L.Promises.settled([typeof a=="number"?t.close(a):Promise.resolve(),typeof l=="number"?s.close(l):Promise.resolve()])}}async hb(t,n,s,i){return this.X.queueFor(i,this.N(s).providerExtUri).queue(()=>this.ib(t,n,s,i))}async ib(t,n,s,i){return s.writeFile(i,await t.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async jb(t,n,s,i){return this.X.queueFor(i,this.N(s).providerExtUri).queue(()=>this.kb(t,n,s,i))}async kb(t,n,s,i){const a=await s.open(i,{create:!0,unlock:!1});try{const l=await t.readFile(n);await this.cb(s,a,o.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,r.ensureFileSystemProviderError)(l)}finally{await s.close(a)}}async lb(t,n,s,i){const a=await(0,o.streamToBuffer)(this.C(t,n,A.CancellationToken.None));await this.db(s,i,void 0,a)}mb(t,n){if(t.capabilities&2048)throw new r.FileOperationError((0,p.localize)(24,null,this.ob(n)),6);return t}nb(t,n){if((n.permissions??0)&r.FilePermission.Readonly)throw new r.FileOperationError((0,p.localize)(25,null,this.ob(t)),6)}ob(t){return t.scheme===y.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=D=Le([Ae(0,c.ILogService)],D)}),define(pe[66],be([1,0,33,296,14,27,15,6,39,2,7,3,19,47,23,184,16,107,222,38,218,217]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f,c,u,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(S)}catch(n){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(n)}`)}})();class t extends c.AbstractDiskFileSystemProvider{constructor(s,i){super(s,i),this.onDidChangeCapabilities=R.Event.None,this.I=new A.ResourceMap(a=>v.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,y.isLinux&&(this.F|=1024)),this.F}async stat(s){try{const{stat:i,symbolicLink:a}=await g.SymlinkSupport.stat(this.C(s));return{type:this.H(i,a),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:r.FilePermission.Locked}}catch(i){throw this.bb(i)}}async G(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await g.Promises.readdir(this.C(s),{withFileTypes:!0}),a=[];return await Promise.all(i.map(async l=>{try{let d;l.isSymbolicLink()?d=(await this.stat((0,v.joinPath)(s,l.name))).type:d=this.H(l),a.push([l.name,d])}catch(d){this.a.trace(d)}})),a}catch(i){throw this.bb(i)}}H(s,i){let a;return i?.dangling?a=r.FileType.Unknown:s.isFile()?a=r.FileType.File:s.isDirectory()?a=r.FileType.Directory:a=r.FileType.Unknown,i&&(a|=r.FileType.SymbolicLink),a}async J(s){const i=this.C(s);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let a;for(;a=this.I.get(s);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await a.wait();const l=new o.Barrier;return this.I.set(s,l),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,m.toDisposable)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.I.get(s)===l&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.I.delete(s)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(s,i){let a;try{i?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(s)})`),a=await this.J(s));const l=this.C(s);return await g.Promises.readFile(l)}catch(l){throw this.bb(l)}finally{a?.dispose()}}L(s){t.D&&this.a.trace(s)}readFileStream(s,i,a){const l=(0,h.newWriteableStream)(d=>k.VSBuffer.concat(d.map(I=>k.VSBuffer.wrap(I))).buffer);return(0,f.readFileIntoStream)(this,s,l,d=>d.buffer,{...i,bufferSize:256*1024},a),l}async writeFile(s,i,a){return a?.atomic!==!1&&a?.atomic?.postfix?this.M(s,(0,v.joinPath)((0,v.dirname)(s),`${(0,v.basename)(s)}${a.atomic.postfix}`),i,a):this.N(s,i,a)}async M(s,i,a,l){await this.N(i,a,l);try{await this.rename(i,s,{overwrite:!0})}catch(d){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw d}}async N(s,i,a){let l;try{const d=this.C(s);if(!a.create||!a.overwrite){if(await g.Promises.exists(d)){if(!a.overwrite)throw(0,r.createFileSystemProviderError)((0,p.localize)(0,null),r.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,r.createFileSystemProviderError)((0,p.localize)(1,null),r.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(s,{create:!0,unlock:a.unlock}),await this.write(l,0,i,0,i.byteLength)}catch(d){throw await this.cb(s,d)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(s){t.R=s}async open(s,i){const a=this.C(s);let l;(0,r.isFileOpenForWriteOptions)(i)&&(l=await this.J(s));let d;try{if((0,r.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:C}=await g.SymlinkSupport.stat(a);C.mode&128||await g.Promises.chmod(a,C.mode|128)}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}let I;if((0,r.isFileOpenForWriteOptions)(i)){if(y.isWindows)try{await g.Promises.truncate(a,0),I="r+"}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}I||(I="w")}else I="r";d=await g.Promises.open(a,I)}catch(I){throw l?.dispose(),(0,r.isFileOpenForWriteOptions)(i)?await this.cb(s,I):this.bb(I)}if(this.O.set(d,0),(0,r.isFileOpenForWriteOptions)(i)&&this.Q.set(d,s),l){const I=this.P.get(d);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${d} (${a})`),this.P.set(d,l),I&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${d} (${a})`),I.dispose())}return d}async close(s){const i=this.P.get(s);try{if(this.O.delete(s),this.Q.delete(s)&&t.R)try{await g.Promises.fdatasync(s)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await g.Promises.close(s)}catch(a){throw this.bb(a)}finally{i&&(this.P.get(s)===i&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.P.delete(s)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,a,l,d){const I=this.S(s,i);let C=null;try{C=(await g.Promises.read(s,a,l,d,I)).bytesRead}catch(E){throw this.bb(E)}finally{this.U(s,I,C)}return C}S(s,i){return i===this.O.get(s)?null:i}U(s,i,a){const l=this.O.get(s);typeof l=="number"&&(typeof i=="number"||(typeof a=="number"?this.O.set(s,l+a):this.O.delete(s)))}async write(s,i,a,l,d){return(0,o.retry)(()=>this.W(s,i,a,l,d),100,3)}async W(s,i,a,l,d){const I=this.S(s,i);let C=null;try{C=(await g.Promises.write(s,a,l,d,I)).bytesWritten}catch(E){throw await this.cb(this.Q.get(s),E)}finally{this.U(s,I,C)}return C}async mkdir(s){try{await g.Promises.mkdir(this.C(s))}catch(i){throw this.bb(i)}}async delete(s,i){try{const a=this.C(s);if(i.recursive){let l;i?.atomic!==!1&&i.atomic.postfix&&(l=(0,T.join)((0,T.dirname)(a),`${(0,T.basename)(a)}${i.atomic.postfix}`)),await g.Promises.rm(a,g.RimRafMode.MOVE,l)}else try{await g.Promises.unlink(a)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let d=!1;try{const{stat:I,symbolicLink:C}=await g.SymlinkSupport.stat(a);d=I.isDirectory()&&!C}catch{}if(d)await g.Promises.rmdir(a);else throw l}else throw l}}catch(a){throw this.bb(a)}}async rename(s,i,a){const l=this.C(s),d=this.C(i);if(l!==d)try{await this.X(s,i,"move",a.overwrite),await g.Promises.move(l,d)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,p.localize)(2,null,(0,T.basename)(l),(0,T.basename)((0,T.dirname)(d)),I.toString()))),this.bb(I)}}async copy(s,i,a){const l=this.C(s),d=this.C(i);if(l!==d)try{await this.X(s,i,"copy",a.overwrite),await g.Promises.copy(l,d,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,p.localize)(3,null,(0,T.basename)(l),(0,T.basename)((0,T.dirname)(d)),I.toString()))),this.bb(I)}}async X(s,i,a,l){const d=this.C(s),I=this.C(i);let C=!1;if(!!(this.capabilities&1024)||(C=(0,b.isEqual)(d,I,!0)),C){if(a==="copy")throw(0,r.createFileSystemProviderError)((0,p.localize)(4,null),r.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const w=await this.G(s);if(!w)throw(0,r.createFileSystemProviderError)((0,p.localize)(5,null),r.FileSystemProviderErrorCode.FileNotFound);const N=await this.G(i);if(N){if(!l)throw(0,r.createFileSystemProviderError)((0,p.localize)(6,null),r.FileSystemProviderErrorCode.FileExists);w.type&r.FileType.File&&N.type&r.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.Y(s,i,!1)}async Y(s,i,a){const l=this.C(s),d=this.C(i),I=!!(this.capabilities&1024);if((0,b.isEqual)(l,d,!I))return;const C=new m.DisposableStore;try{const[E,w]=await Promise.all([this.J(s),this.J(i)]);C.add(E),C.add(w),a&&await g.Promises.mkdir((0,T.dirname)(d),{recursive:!0}),await g.Promises.copyFile(l,d)}catch(E){if(E.code==="ENOENT"&&!a)return this.Y(s,i,!0);throw this.bb(E)}finally{C.dispose()}}p(s,i,a){return new D.UniversalWatcherClient(l=>s(l),l=>i(l),a)}y(s,i,a){return new O.NodeJSWatcherClient(l=>s(l),l=>i(l),a)}bb(s){if(s instanceof r.FileSystemProviderError)return s;let i=s,a;switch(s.code){case"ENOENT":a=r.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=r.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=r.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=r.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=r.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=r.FileSystemProviderErrorCode.Unknown;break;default:a=r.FileSystemProviderErrorCode.Unknown}return(0,r.createFileSystemProviderError)(i,a)}async cb(s,i){let a=this.bb(i);if(s&&a.code===r.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await g.SymlinkSupport.stat(this.C(s));l.mode&128||(a=(0,r.createFileSystemProviderError)(i,r.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return a}}e.DiskFileSystemProvider=t,t.D=!1,t.R=!0}),define(pe[223],be([1,0,6,66,2,15,47,20]),function(le,e,S,L,o,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class b extends o.Disposable{constructor(y,v){super(),this.a=y,this.b=v,this.w=new Map,this.y=new Map}call(y,v,h){const g=this.c(y);switch(v){case"stat":return this.g(g,h[0]);case"readdir":return this.h(g,h[0]);case"open":return this.l(g,h[0],h[1]);case"close":return this.m(h[0]);case"read":return this.n(h[0],h[1],h[2]);case"readFile":return this.i(g,h[0],h[1]);case"write":return this.p(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.k(g,h[0],h[1],h[2]);case"rename":return this.t(g,h[0],h[1],h[2]);case"copy":return this.u(g,h[0],h[1],h[2]);case"cloneFile":return this.v(g,h[0],h[1]);case"mkdir":return this.r(g,h[0]);case"delete":return this.s(g,h[0],h[1]);case"watch":return this.C(g,h[0],h[1],h[2],h[3]);case"unwatch":return this.D(h[0],h[1])}throw new Error(`IPC Command ${v} not found`)}listen(y,v,h){const g=this.c(y);switch(v){case"fileChange":return this.z(g,h[0]);case"readFileStream":return this.j(g,h[0],h[1])}throw new Error(`Unknown event ${v}`)}g(y,v){const h=this.f(y,v,!0);return this.a.stat(h)}h(y,v){const h=this.f(y,v);return this.a.readdir(h)}async i(y,v,h){const g=this.f(y,v,!0),p=await this.a.readFile(g,h);return A.VSBuffer.wrap(p)}j(y,v,h){const g=this.f(y,v,!0),p=new R.CancellationTokenSource,r=new S.Emitter({onDidRemoveLastListener:()=>{p.cancel()}}),f=this.a.readFileStream(g,h,p.token);return(0,k.listenStream)(f,{onData:c=>r.fire(A.VSBuffer.wrap(c)),onError:c=>r.fire(c),onEnd:()=>{r.fire("end"),r.dispose(),p.dispose()}}),r.event}k(y,v,h,g){const p=this.f(y,v);return this.a.writeFile(p,h.buffer,g)}l(y,v,h){const g=this.f(y,v,!0);return this.a.open(g,h)}m(y){return this.a.close(y)}async n(y,v,h){const g=A.VSBuffer.alloc(h),p=0,r=await this.a.read(y,v,g.buffer,p,h);return[g,r]}p(y,v,h,g,p){return this.a.write(y,v,h.buffer,g,p)}r(y,v){const h=this.f(y,v);return this.a.mkdir(h)}s(y,v,h){const g=this.f(y,v);return this.a.delete(g,h)}t(y,v,h,g){const p=this.f(y,v),r=this.f(y,h);return this.a.rename(p,r,g)}u(y,v,h,g){const p=this.f(y,v),r=this.f(y,h);return this.a.copy(p,r,g)}v(y,v,h){const g=this.f(y,v),p=this.f(y,h);return this.a.cloneFile(g,p)}z(y,v){const h=new S.Emitter({onWillAddFirstListener:()=>{this.w.set(v,this.F(y,h))},onDidRemoveLastListener:()=>{(0,o.dispose)(this.w.get(v)),this.w.delete(v)}});return h.event}async C(y,v,h,g,p){const r=this.w.get(v);if(r){const f=this.f(y,g),c=r.watch(h,f,p);this.y.set(v+h,c)}}async D(y,v){const h=y+v,g=this.y.get(h);g&&((0,o.dispose)(g),this.y.delete(h))}dispose(){super.dispose();for(const[,y]of this.y)y.dispose();this.y.clear();for(const[,y]of this.w)y.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=b;class m extends o.Disposable{constructor(y,v,h,g){super(),this.c=y,this.f=h,this.g=g,this.a=new Map,this.b=this.B(new L.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(v)}h(y){const v=this.B(new S.Emitter);this.B(v.event(h=>{y.fire(h.map(g=>({resource:this.c.transformOutgoingURI(g.resource),type:g.type})))})),this.B(this.b.onDidChangeFile(h=>v.fire(h))),this.B(this.b.onDidWatchError(h=>y.fire(h)))}i(y){}j(y){}watch(y,v,h){const g=this.j(this.g);return Array.isArray(g)&&(h.excludes=[...h.excludes,...g]),this.a.set(y,this.b.watch(v,h)),(0,o.toDisposable)(()=>{(0,o.dispose)(this.a.get(y)),this.a.delete(y)})}dispose(){super.dispose();for(const[,y]of this.a)y.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=m}),define(pe[110],be([1,0,4,6,12,2]),function(le,e,S,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class k extends o.AbstractLoggerService{constructor(y,v,h,g,p){super(v,h,g),this.n=y,this.p=p,this.B(p.listen("onDidChangeLogLevel",y)(r=>{(0,o.isLogLevel)(r)?super.setLogLevel(r):super.setLogLevel(S.URI.revive(r[0]),r[1])})),this.B(p.listen("onDidChangeVisibility",y)(([r,f])=>super.setVisibility(S.URI.revive(r),f))),this.B(p.listen("onDidChangeLoggers",y)(({added:r,removed:f})=>{for(const c of r)super.registerLogger({...c,resource:S.URI.revive(c.resource)});for(const c of f)super.deregisterLogger(c.resource)}))}createConsoleMainLogger(){return new o.AdapterLogger({log:(y,v)=>{this.p.call("consoleLog",[y,v])}})}registerLogger(y){super.registerLogger(y),this.p.call("registerLogger",[y,this.n])}deregisterLogger(y){super.deregisterLogger(y),this.p.call("deregisterLogger",[y,this.n])}setLogLevel(y,v){super.setLogLevel(y,v),this.p.call("setLogLevel",[y,v])}setVisibility(y,v){super.setVisibility(y,v),this.p.call("setVisibility",[this.l(y),v])}m(y,v,h){return new R(this.p,y,v,h,this.n)}static setLogLevel(y,v,h){return y.call("setLogLevel",[v,h])}}e.LoggerChannelClient=k;class R extends o.AbstractMessageLogger{constructor(y,v,h,g,p){super(g?.logLevel==="always"),this.m=y,this.n=v,this.k=!1,this.l=[],this.setLevel(h),this.m.call("createLogger",[v,g,p]).then(()=>{this.r(this.l),this.k=!0})}g(y,v){const h=[[y,v]];this.k?this.r(h):this.l.push(...h)}r(y){this.m.call("log",[this.n,y])}}class b{constructor(y,v){this.a=y,this.b=v}listen(y,v){const h=this.b(y);switch(v){case"onDidChangeLoggers":return L.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(p=>this.c(p,h)),removed:[...g.removed].map(p=>this.c(p,h))}));case"onDidChangeVisibility":return L.Event.map(this.a.onDidChangeVisibility,g=>[h.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return L.Event.map(this.a.onDidChangeLogLevel,g=>(0,o.isLogLevel)(g)?g:[h.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${v}`)}async call(y,v,h){const g=this.b(y);switch(v){case"setLogLevel":return(0,o.isLogLevel)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(S.URI.revive(g.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,g)))}throw new Error(`Call not found: ${v}`)}c(y,v){return{...y,resource:v.transformOutgoingURI(y.resource)}}}e.LoggerChannel=b;class m extends A.Disposable{constructor(y,v){super(),v.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(h=>v.call("setLogLevel",[h]))),v.call("getRegisteredLoggers").then(h=>{for(const g of h)y.registerLogger({...g,resource:S.URI.revive(g.resource)})}),this.B(v.listen("onDidChangeVisibility")(([h,g])=>y.setVisibility(S.URI.revive(h),g))),this.B(v.listen("onDidChangeLoggers")(({added:h,removed:g})=>{for(const p of h)y.registerLogger({...p,resource:S.URI.revive(p.resource)});for(const p of g)y.deregisterLogger(p.resource)}))}}e.RemoteLoggerChannelClient=m}),define(pe[111],be([1,0,2,12]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class o extends S.Disposable{constructor(k,R=[]){super(),this.a=new L.MultiplexLogger([k,...R]),this.B(k.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(k){this.a.setLevel(k)}getLevel(){return this.a.getLevel()}trace(k,...R){this.a.trace(k,...R)}debug(k,...R){this.a.debug(k,...R)}info(k,...R){this.a.info(k,...R)}warn(k,...R){this.a.warn(k,...R)}error(k,...R){this.a.error(k,...R)}flush(){this.a.flush()}}e.LogService=o}),define(pe[224],be([1,0,16,12]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var o;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(o||(o={}));async function A(m,T,y,v,h){try{const g=await new Promise((r,f)=>{le(["@vscode/spdlog"],r,f)});g.setFlushOn(o.Trace);const p=await g.createAsyncRotatingLogger(m,T,y,v);return h?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(g){console.error(g)}return null}function k(m,T,y){switch(T){case L.LogLevel.Trace:m.trace(y);break;case L.LogLevel.Debug:m.debug(y);break;case L.LogLevel.Info:m.info(y);break;case L.LogLevel.Warning:m.warn(y);break;case L.LogLevel.Error:m.error(y);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${T}`)}}function R(m,T){switch(T){case L.LogLevel.Trace:m.setLevel(o.Trace);break;case L.LogLevel.Debug:m.setLevel(o.Debug);break;case L.LogLevel.Info:m.setLevel(o.Info);break;case L.LogLevel.Warning:m.setLevel(o.Warning);break;case L.LogLevel.Error:m.setLevel(o.Error);break;case L.LogLevel.Off:m.setLevel(o.Off);break;default:throw new Error(`Invalid log level ${T}`)}}class b extends L.AbstractMessageLogger{constructor(T,y,v,h,g){super(),this.k=[],this.setLevel(g),this.l=this.n(T,y,v,h),this.B(this.onDidChangeLogLevel(p=>{this.m&&R(this.m,p)}))}async n(T,y,v,h){const g=v?6:1,p=30/g*S.ByteSize.MB,r=await A(T,y,p,g,h);if(r){this.m=r,R(this.m,this.getLevel());for(const{level:f,message:c}of this.k)k(this.m,f,c);this.k=[]}}g(T,y){this.m?k(this.m,T,y):this.getLevel()<=T&&this.k.push({level:T,message:y})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=b}),define(pe[112],be([1,0,22,12,224]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends L.AbstractLoggerService{m(R,b,m){return new o.SpdLogLogger((0,S.generateUuid)(),R.fsPath,!m?.donotRotate,!!m?.donotUseFormatters,b)}}e.LoggerService=A}),define(pe[225],be([1,0,60,186,5]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var k;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(k||(e.MarkerSeverity=k={})),function(b){function m(g,p){return p-g}b.compare=m;const T=Object.create(null);T[b.Error]=(0,L.localize)(0,null),T[b.Warning]=(0,L.localize)(1,null),T[b.Info]=(0,L.localize)(2,null);function y(g){return T[g]||""}b.toString=y;function v(g){switch(g){case S.default.Error:return b.Error;case S.default.Warning:return b.Warning;case S.default.Info:return b.Info;case S.default.Ignore:return b.Hint}}b.fromSeverity=v;function h(g){switch(g){case b.Error:return S.default.Error;case b.Warning:return S.default.Warning;case b.Info:return S.default.Info;case b.Hint:return S.default.Ignore}}b.toSeverity=h}(k||(e.MarkerSeverity=k={}));var R;(function(b){const m="";function T(v){return y(v,!0)}b.makeKey=T;function y(v,h){const g=[m];return v.source?g.push(v.source.replace("\xA6","\\\xA6")):g.push(m),v.code?typeof v.code=="string"?g.push(v.code.replace("\xA6","\\\xA6")):g.push(v.code.value.replace("\xA6","\\\xA6")):g.push(m),v.severity!==void 0&&v.severity!==null?g.push(k.toString(v.severity)):g.push(m),v.message&&h?g.push(v.message.replace("\xA6","\\\xA6")):g.push(m),v.startLineNumber!==void 0&&v.startLineNumber!==null?g.push(v.startLineNumber.toString()):g.push(m),v.startColumn!==void 0&&v.startColumn!==null?g.push(v.startColumn.toString()):g.push(m),v.endLineNumber!==void 0&&v.endLineNumber!==null?g.push(v.endLineNumber.toString()):g.push(m),v.endColumn!==void 0&&v.endColumn!==null?g.push(v.endColumn.toString()):g.push(m),g.push(m),g.join("\xA6")}b.makeKeyOptionalMessage=y})(R||(e.IMarkerData=R={})),e.IMarkerService=(0,o.createDecorator)("markerService")}),define(pe[67],be([1,0,6,46,2,5]),function(le,e,S,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class k extends o.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(m){const T=Object.keys(this.f).length;return this.f={...m,...this.f},T!==Object.keys(this.f).length&&await this.i(m),L.Iterable.reduce(this.g.entries(),(y,[v,h])=>({...y,[v]:h}),{})}getPolicyValue(m){return this.g.get(m)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(m,[T,y])=>({...m,[T]:{definition:y,value:this.g.get(T)}}),{})}}e.AbstractPolicyService=k;class R{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(pe[54],be([1,0,3,29]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let o;if(typeof S.globals.vscode<"u"&&typeof S.globals.vscode.context<"u"){const A=S.globals.vscode.context.configuration();if(A)o=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(o=globalThis._VSCODE_PRODUCT_JSON,L.env.VSCODE_DEV&&Object.assign(o,{nameShort:`${o.nameShort} Dev`,nameLong:`${o.nameLong} Dev`,dataFolderName:`${o.dataFolderName}-dev`,serverDataFolderName:o.serverDataFolderName?`${o.serverDataFolderName}-dev`:void 0}),!o.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(o,{version:A.version})}}else o={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csharp":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"ms-vscode.vscode-typescript-tslint-plugin":{onFileOpen:[{pathGlob:"{**/tslint.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"felipecaputo.git-project-manager":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"GoogleCloudTools.cloudcode":{onFileOpen:[{pathGlob:"{**/skaffold.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"Pivotal.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}]},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"python-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*\\])|("black\\s*["[(<=>!~;@])'}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","testObserver","envShellEvent","quickPickItemTooltip","terminalDataWriteEvent","envCollectionWorkspace","saveEditor","envCollectionOptions"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmActionButton","scmSelectedProvider","scmValidation","shareProvider","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["contribCommentThreadAdditionalMenu","tokenInformation","contribShareMenu","fileComments","contribCommentPeekContext","treeItemCheckbox","codiconDecoration","diffCommand","contribCommentEditorActionsMenu","shareProvider","quickDiffProvider"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["handleIssueUri","interactive","interactiveUserActions","semanticSimilarity","terminalDataWriteEvent"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io"],trustedExtensionAuthAccess:["vscode.git","vscode.github","ms-vscode.remote-repositories","github.remotehub","ms-vscode.azure-repos","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","ms-vsliveshare.vsliveshare","github.copilot","github.copilot-chat"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]}}},win32TunnelServiceMutex:"vscode-tunnelservice",win32TunnelMutex:"vscode-tunnel",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.78.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.19",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],walkthroughMetadata:[{id:"Setup",steps:[{id:"copilotInstall",title:"Supercharge your coding with AI-based suggestions",description:`Throw that rubber duck away! Code more efficiently with AI at your fingertips. Try [GitHub Copilot](command:extension.open?"github.copilot") free for 60 days.
[Install Copilot](command:workbench.extensions.installExtension?%22github.copilot%22)`,media:{type:"image",altText:"Copilot Statistics",path:"copilotStep.png"}}]}],featuredExtensions:[{id:"github.copilot",title:"GitHub Copilot",description:"Supercharge your coding experience for as little as $10/month with cutting edge AI code generation."}],version:"1.79.0",commit:"b380da4ef1ee00e224a15c1d4d9793e27c2b6302",date:"2023-06-07T14:11:36.563Z"},Object.keys(o).length===0&&Object.assign(o,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=o}),define(pe[26],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(pe[226],be([1,0,78,12,25,26,220]),function(le,e,S,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let R=e.CredentialsWebMainService=class extends k.BaseCredentialsMainService{constructor(m,T,y){super(m),this.p=T,this.r=y}async getSecretStoragePrefix(){return Promise.resolve(`${this.r.urlProtocol}-server`)}async i(){if(this.f)return this.f;if(this.p.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new S.InMemoryCredentialsProvider,this.f;try{this.f=await new Promise((m,T)=>{le(["keytar"],m,T)}),await this.f.findCredentials("test-keytar-loads")}catch(m){this.h.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${m.message??m}`),this.f=new S.InMemoryCredentialsProvider}return this.f}};e.CredentialsWebMainService=R=Le([Ae(0,L.ILogService),Ae(1,o.INativeEnvironmentService),Ae(2,A.IProductService)],R)}),define(pe[40],be([1,0,92,8]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class o{constructor(){this.a=new Map}add(k,R){S.ok(L.isString(k)),S.ok(L.isObject(R)),S.ok(!this.a.has(k),"There is already an extension with this id"),this.a.set(k,R)}knows(k){return this.a.has(k)}as(k){return this.a.get(k)||null}}e.Registry=new o}),define(pe[227],be([1,0,6,40]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function o(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this.b=new S.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,m){this.a[o(b)]=m,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const k=new A;L.Registry.add(e.Extensions.JSONContribution,k)}),define(pe[55],be([1,0,18,6,8,168,24,227,40]),function(le,e,S,L,o,A,k,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(O){O.Multiline="multilineText",O.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(O){O[O.APPLICATION=1]="APPLICATION",O[O.MACHINE=2]="MACHINE",O[O.WINDOW=3]="WINDOW",O[O.RESOURCE=4]="RESOURCE",O[O.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",O[O.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=b.Registry.as(R.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new L.Emitter,this.onDidSchemaChange=this.i.event,this.j=new L.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const s=new Set;this.n(t,n,s),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const n=new Set;this.o(t,n),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const s=new Set;this.o(n,s),this.n(t,!1,s),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const n=new Set;this.k(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(t,n){const s=[];for(const{overrides:i,source:a}of t)for(const l in i)if(n.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const d=this.a.get(l),I=d?.valuesSources??new Map;if(a)for(const N of Object.keys(i[l]))I.set(N,a);const C={...d?.value||{},...i[l]};this.a.set(l,{source:a,value:C,valuesSources:I});const E=(0,k.getLanguageTagSettingPlainKey)(l),w={type:"object",default:C,description:A.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:C,source:o.isString(a)?void 0:a,defaultValueSource:a};s.push(...p(l)),this.d[l]=w,this.b.properties[l]=w}else{this.a.set(l,{value:i[l],source:a});const d=this.d[l];d&&(this.w(l,d),this.r(l,d))}this.m(s)}deregisterDefaultConfigurations(t){const n=new Set;this.l(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(t,n){for(const{overrides:s,source:i}of t)for(const a in s){const l=this.a.get(a),d=o.isString(i)?i:i?.id,I=o.isString(l?.source)?l?.source:l?.source?.id;if(d===I)if(n.add(a),this.a.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.d[a],delete this.b.properties[a];else{const C=this.d[a];C&&(this.w(a,C),this.r(a,C))}}this.u()}deltaConfiguration(t){let n=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),n=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),n=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const n of t)this.h.add(n);this.u()}n(t,n,s){t.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,s),this.c.push(i),this.q(i)})}o(t,n){const s=i=>{if(i.properties)for(const a in i.properties){n.add(a);const l=this.d[a];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[a],this.s(a,i.properties[a])}i.allOf?.forEach(a=>s(a))};for(const i of t){s(i);const a=this.c.indexOf(i);a!==-1&&this.c.splice(a,1)}}p(t,n=!0,s,i,a=3,l){a=o.isUndefinedOrNull(t.scope)?a:t.scope;const d=t.properties;if(d)for(const C in d){const E=d[C];if(n&&u(C,E)){delete d[C];continue}if(E.source=s,E.defaultDefaultValue=d[C].default,this.w(C,E),e.OVERRIDE_PROPERTY_REGEX.test(C)?E.scope=void 0:(E.scope=o.isUndefinedOrNull(E.scope)?a:E.scope,E.restricted=o.isUndefinedOrNull(E.restricted)?!!i?.includes(C):E.restricted),d[C].hasOwnProperty("included")&&!d[C].included){this.f[C]=d[C],delete d[C];continue}else this.d[C]=d[C],d[C].policy?.name&&this.e.set(d[C].policy.name,C);!d[C].deprecationMessage&&d[C].markdownDeprecationMessage&&(d[C].deprecationMessage=d[C].markdownDeprecationMessage),l.add(C)}const I=t.allOf;if(I)for(const C of I)this.p(C,n,s,i,a,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const n=s=>{const i=s.properties;if(i)for(const l in i)this.r(l,i[l]);s.allOf?.forEach(n)};n(t)}r(t,n){switch(e.allSettings.properties[t]=n,n.scope){case 1:e.applicationSettings.properties[t]=n;break;case 2:e.machineSettings.properties[t]=n;break;case 6:e.machineOverridableSettings.properties[t]=n;break;case 3:e.windowSettings.properties[t]=n;break;case 4:e.resourceSettings.properties[t]=n;break;case 5:e.resourceSettings.properties[t]=n,this.g.properties[t]=n;break}}s(t,n){switch(delete e.allSettings.properties[t],n.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const n=`[${t}]`,s={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(n,s),e.allSettings.properties[n]=s,e.applicationSettings.properties[n]=s,e.machineSettings.properties[n]=s,e.machineOverridableSettings.properties[n]=s,e.windowSettings.properties[n]=s,e.resourceSettings.properties[n]=s}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,n){const s=this.a.get(t);let i=s?.value,a=s?.source;o.isUndefined(i)&&(i=n.defaultDefaultValue,a=void 0),o.isUndefined(i)&&(i=f(n.type)),n.default=i,n.defaultValueSource=a}}const h="\\[([^\\]]+)\\]",g=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(O){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(O)){let n=g.exec(O);for(;n?.length;){const s=n[1].trim();s&&t.push(s),n=g.exec(O)}}return(0,S.distinct)(t)}e.overrideIdentifiersFromKey=p;function r(O){return O.reduce((t,n)=>`${t}[${n}]`,"")}e.keyFromOverrideIdentifiers=r;function f(O){switch(Array.isArray(O)?O[0]:O){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const c=new v;b.Registry.add(e.Extensions.Configuration,c);function u(O,t){return O.trim()?e.OVERRIDE_PROPERTY_REGEX.test(O)?A.localize(7,null,O):c.getConfigurationProperties()[O]!==void 0?A.localize(8,null,O):t.policy?.name&&c.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,O,t.policy?.name,c.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=u;function D(){const O=[],t=c.getConfigurationProperties();for(const n of Object.keys(t))O.push([n,t[n].scope]);return O.push(["launch",4]),O.push(["task",4]),O}e.getScopes=D}),define(pe[113],be([1,0,18,6,72,2,27,21,8,4,24,55,40]),function(le,e,S,L,o,A,k,R,b,m,T,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function h(n){return Object.isFrozen(n)?n:R.deepFreeze(n)}class g{constructor(s={},i=[],a=[],l){this.b=s,this.c=i,this.d=a,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof g)return i;const a=new p("");return a.parseRaw(i),a.configurationModel});this.f=s.reduce((i,a)=>a===i?a:i.merge(a),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,T.getConfigurationValue)(this.contents,s):this.contents}inspect(s,i){const a=this.rawConfiguration.getValue(s),l=i?this.rawConfiguration.getOverrideValue(s,i):void 0,d=i?this.rawConfiguration.override(i).getValue(s):a;return{value:a,override:l,merged:d}}getOverrideValue(s,i){const a=this.i(i);return a?s?(0,T.getConfigurationValue)(a,s):a:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const a of this.overrides)a.identifiers.includes(s)&&i.push(...a.keys);return S.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return S.distinct(s)}override(s){let i=this.a.get(s);return i||(i=this.g(s),this.a.set(s,i)),i}merge(...s){const i=R.deepClone(this.contents),a=R.deepClone(this.overrides),l=[...this.keys],d=this.raw?.length?[...this.raw]:[this];for(const I of s)if(d.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(i,I.contents);for(const C of I.overrides){const[E]=a.filter(w=>S.equals(w.identifiers,C.identifiers));E?(this.h(E.contents,C.contents),E.keys.push(...C.keys),E.keys=S.distinct(E.keys)):a.push(R.deepClone(C))}for(const C of I.keys)l.indexOf(C)===-1&&l.push(C)}return new g(i,l,a,d.every(I=>I instanceof g)?void 0:d)}g(s){const i=this.i(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const a={};for(const l of S.distinct([...Object.keys(this.contents),...Object.keys(i)])){let d=this.contents[l];const I=i[l];I&&(typeof d=="object"&&typeof I=="object"?(d=R.deepClone(d),this.h(d,I)):d=I),a[l]=d}return new g(a,this.keys,this.overrides)}h(s,i){for(const a of Object.keys(i)){if(a in s&&b.isObject(s[a])&&b.isObject(i[a])){this.h(s[a],i[a]);continue}s[a]=R.deepClone(i[a])}}i(s){let i=null,a=null;const l=d=>{d&&(a?this.h(a,d):a=R.deepClone(d))};for(const d of this.overrides)S.equals(d.identifiers,[s])?i=d.contents:d.identifiers.includes(s)&&l(d.contents);return l(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.j(s,i,!0)}setValue(s,i){this.j(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,T.removeFromValueTree)(this.contents,s),y.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(a=>S.equals(a.identifiers,(0,y.overrideIdentifiersFromKey)(s))),1))}j(s,i,a){(0,T.addToValueTree)(this.contents,s,i,l=>console.error(l)),a=a||this.keys.indexOf(s)===-1,a&&this.keys.push(s),y.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,y.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,T.toValuesTree)(this.contents[s],l=>console.error(l))})}}e.ConfigurationModel=g;class p{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,i){if(!b.isUndefinedOrNull(s)){const a=this.g(s);this.parseRaw(a,i)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,i){this.a=s;const{contents:a,keys:l,overrides:d,restricted:I,hasExcludedProperties:C}=this.h(s,i);this.b=new g(a,l,d,C?[s]:void 0),this.c=I||[]}g(s){let i={},a=null,l=[];const d=[],I=[];function C(w){Array.isArray(l)?l.push(w):a!==null&&(l[a]=w)}const E={onObjectBegin:()=>{const w={};C(w),d.push(l),l=w,a=null},onObjectProperty:w=>{a=w},onObjectEnd:()=>{l=d.pop()},onArrayBegin:()=>{const w=[];C(w),d.push(l),l=w,a=null},onArrayEnd:()=>{l=d.pop()},onLiteralValue:C,onError:(w,N,$)=>{I.push({error:w,offset:N,length:$})}};if(s)try{o.visit(s,E),i=l[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return i}h(s,i){const a=v.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),l=this.i(s,a,!0,i);s=l.raw;const d=(0,T.toValuesTree)(s,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),I=Object.keys(s),C=this.j(s,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:d,keys:I,overrides:C,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(s,i,a,l){let d=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:d};const I={},C=[];for(const E in s)if(y.OVERRIDE_PROPERTY_REGEX.test(E)&&a){const w=this.i(s[E],i,!1,l);I[E]=w.raw,d=d||w.hasExcludedProperties,C.push(...w.restricted)}else{const w=i[E],N=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&C.push(E),(N===void 0||l.scopes===void 0||l.scopes.includes(N))&&!(l.skipRestricted&&w?.restricted)?I[E]=s[E]:d=!0}return{raw:I,restricted:C,hasExcludedProperties:d}}j(s,i){const a=[];for(const l of Object.keys(s))if(y.OVERRIDE_PROPERTY_REGEX.test(l)){const d={};for(const I in s[l])d[I]=s[l][I];a.push({identifiers:(0,y.overrideIdentifiersFromKey)(l),keys:Object.keys(d),contents:(0,T.toValuesTree)(d,i)})}return a}}e.ConfigurationModelParser=p;class r extends A.Disposable{constructor(s,i,a,l){super(),this.f=s,this.g=i,this.h=l,this.c=this.B(new L.Emitter),this.onDidChange=this.c.event,this.a=new p(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(a.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(L.Event.any(L.Event.filter(this.h.onDidFilesChange,d=>d.contains(this.f)),L.Event.filter(this.h.onDidRunOperation,d=>(d.isOperation(0)||d.isOperation(3)||d.isOperation(1)||d.isOperation(4))&&a.isEqual(d.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new g}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=r;class f{constructor(s,i,a,l,d,I,C,E,w,N,$,se,he){this.a=s,this.b=i,this.c=a,this.overrideIdentifiers=l,this.d=d,this.f=I,this.g=C,this.h=E,this.i=w,this.j=N,this.k=$,this.l=se,this.m=he}get value(){return h(this.c)}n(s,i,a){const l=s.inspect(i,a);return{get value(){return h(l.value)},get override(){return h(l.override)},get merged(){return h(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(s,i,a,l,d=new g,I=new g,C=new k.ResourceMap,E=new g,w=new k.ResourceMap){this.c=s,this.d=i,this.f=a,this.g=l,this.h=d,this.i=I,this.j=C,this.l=E,this.m=w,this.a=null,this.b=new k.ResourceMap,this.n=null}getValue(s,i,a){return this.q(s,i,a).getValue(s)}updateValue(s,i,a={}){let l;a.resource?(l=this.m.get(a.resource),l||(l=new g,this.m.set(a.resource,l))):l=this.l,i===void 0?l.removeValue(s):l.setValue(s,i),a.resource||(this.a=null)}inspect(s,i,a){const l=this.q(s,i,a),d=this.u(i.resource,a),I=i.resource?this.m.get(i.resource)||this.l:this.l,C=new Set;for(const E of l.overrides)for(const w of E.identifiers)l.getOverrideValue(s,w)!==void 0&&C.add(w);return new f(s,i,l.getValue(s),C.size?[...C]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,d||void 0,I)}keys(s){const i=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,i){this.j.set(s,i),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const a=[];if(!i){const{added:l,updated:d,removed:I}=O(this.c,s);i=[...l,...d,...I]}for(const l of i)for(const d of(0,y.overrideIdentifiersFromKey)(l)){const I=this.c.getKeysForOverrideIdentifier(d),C=s.getKeysForOverrideIdentifier(d),E=[...C.filter(w=>I.indexOf(w)===-1),...I.filter(w=>C.indexOf(w)===-1),...I.filter(w=>!R.equals(this.c.override(d).getValue(w),s.override(d).getValue(w)))];a.push([d,E])}return this.updateDefaultConfiguration(s),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:a,removed:l}=O(this.d,s),d=[...i,...a,...l];return d.length&&this.updatePolicyConfiguration(s),{keys:d,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:a,removed:l,overrides:d}=O(this.applicationConfiguration,s),I=[...i,...a,...l];return I.length&&this.updateApplicationConfiguration(s),{keys:I,overrides:d}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:a,removed:l,overrides:d}=O(this.localUserConfiguration,s),I=[...i,...a,...l];return I.length&&this.updateLocalUserConfiguration(s),{keys:I,overrides:d}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:a,removed:l,overrides:d}=O(this.remoteUserConfiguration,s),I=[...i,...a,...l];return I.length&&this.updateRemoteUserConfiguration(s),{keys:I,overrides:d}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:a,removed:l,overrides:d}=O(this.workspaceConfiguration,s),I=[...i,...a,...l];return I.length&&this.updateWorkspaceConfiguration(s),{keys:I,overrides:d}}compareAndUpdateFolderConfiguration(s,i){const a=this.p.get(s),{added:l,updated:d,removed:I,overrides:C}=O(a,i),E=[...l,...d,...I];return(E.length||!a)&&this.updateFolderConfiguration(s,i),{keys:E,overrides:C}}compareAndDeleteFolderConfiguration(s){const i=this.p.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:a,updated:l,removed:d,overrides:I}=O(i,void 0);return{keys:[...a,...l,...d],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,i,a){let l=this.r(i,a);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(l=l.merge(this.d)),l}r({resource:s},i){let a=this.s();if(i&&s){const l=i.getFolder(s);l&&(a=this.t(l.uri)||a);const d=this.m.get(s);d&&(a=a.merge(d))}return a}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let i=this.b.get(s);if(!i){const a=this.s(),l=this.j.get(s);l?(i=a.merge(l),this.b.set(s,i)):i=a}return i}u(s,i){if(i&&s){const a=i.getFolder(s);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,i)=>{const{contents:a,overrides:l,keys:d}=this.j.get(i);return s.push([i,{contents:a,overrides:l,keys:d}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this.i.keys.forEach(i=>s.add(i)),this.j.forEach(i=>i.keys.forEach(a=>s.add(a))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(a=>s.add(a))),[...s.values()]}w(s){const i=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a)),this.i.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(s).forEach(l=>i.add(l))),[...i.values()]}static parse(s){const i=this.x(s.defaults),a=this.x(s.policy),l=this.x(s.application),d=this.x(s.user),I=this.x(s.workspace),C=s.folders.reduce((E,w)=>(E.set(m.URI.revive(w[0]),this.x(w[1])),E),new k.ResourceMap);return new c(i,a,l,d,new g,I,C,new g,new k.ResourceMap)}static x(s){return new g(s.contents,s.keys,s.overrides)}}e.Configuration=c;function u(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const s=new Set,i=new Map;for(const l of n)l.keys.forEach(d=>s.add(d)),l.overrides.forEach(([d,I])=>{const C=(0,k.getOrSet)(i,d,new Set);I.forEach(E=>C.add(E))});const a=[];return i.forEach((l,d)=>a.push([d,[...l.values()]])),{keys:[...s.values()],overrides:a}}e.mergeChanges=u;class D{constructor(s,i,a,l){this.change=s,this.f=i,this.g=a,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const d of s.keys)this.affectedKeys.add(d);for(const[,d]of s.overrides)for(const I of d)this.affectedKeys.add(I);this.d=this.a;for(const d of this.affectedKeys)this.d+=d+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(s,i){const a=this.a+s,l=this.d.indexOf(a);if(l<0)return!1;const d=l+a.length;if(d>=this.d.length)return!1;const I=this.d.charCodeAt(d);if(I!==this.b&&I!==this.c)return!1;if(i){const C=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.f?.workspace):void 0,E=this.g.getValue(s,i,this.h);return!R.equals(C,E)}return!0}}e.ConfigurationChangeEvent=D;function O(n,s){const{added:i,removed:a,updated:l}=t(s?.rawConfiguration,n?.rawConfiguration),d=[],I=n?.getAllOverrideIdentifiers()||[],C=s?.getAllOverrideIdentifiers()||[];if(s){const E=C.filter(w=>!I.includes(w));for(const w of E)d.push([w,s.getKeysForOverrideIdentifier(w)])}if(n){const E=I.filter(w=>!C.includes(w));for(const w of E)d.push([w,n.getKeysForOverrideIdentifier(w)])}if(s&&n){for(const E of I)if(C.includes(E)){const w=t({contents:n.getOverrideValue(void 0,E)||{},keys:n.getKeysForOverrideIdentifier(E)},{contents:s.getOverrideValue(void 0,E)||{},keys:s.getKeysForOverrideIdentifier(E)});d.push([E,[...w.added,...w.removed,...w.updated]])}}return{added:i,removed:a,updated:l,overrides:d}}function t(n,s){const i=n?s?n.keys.filter(d=>s.keys.indexOf(d)===-1):[...n.keys]:[],a=s?n?s.keys.filter(d=>n.keys.indexOf(d)===-1):[...s.keys]:[],l=[];if(n&&s){for(const d of s.keys)if(n.keys.indexOf(d)!==-1){const I=(0,T.getConfigurationValue)(s.contents,d),C=(0,T.getConfigurationValue)(n.contents,d);R.equals(I,C)||l.push(d)}}return{added:i,removed:a,updated:l}}}),define(pe[228],be([1,0,18,6,2,21,8,113,55,12,67,40]),function(le,e,S,L,o,A,k,R,b,m,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class v extends o.Disposable{constructor(){super(...arguments),this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new R.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(y.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:r,defaultsOverrides:f})=>this.c(Array.from(r),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(r,f){this.h(r,y.Registry.as(b.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:r})}f(){return{}}g(){this.b=new R.ConfigurationModel;const r=y.Registry.as(b.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(r),r)}h(r,f){const c=this.f();for(const u of r){const D=c[u],O=f[u];D!==void 0?this.b.addValue(u,D):O?this.b.addValue(u,O.default):this.b.removeValue(u)}}}e.DefaultConfiguration=v;class h{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new R.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=h;let g=e.PolicyConfiguration=class extends o.Disposable{get configurationModel(){return this.b}constructor(r,f,c){super(),this.c=r,this.f=f,this.g=c,this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new R.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(r=>this.i(r))),this.B(this.c.onDidChangeConfiguration(async({properties:r})=>this.j(await this.h(r),!0))),this.b}async h(r){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",r);const f={},c=[],u=y.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(const D of r){const O=u[D];if(!O){c.push(D);continue}if(O.policy){if(O.type!=="string"&&O.type!=="number"){this.g.warn(`Policy ${O.policy.name} has unsupported type ${O.type}`);continue}c.push(D),f[O.policy.name]={type:O.type}}}return(0,k.isEmptyObject)(f)||await this.f.updatePolicyDefinitions(f),c}i(r){this.g.trace("PolicyConfiguration#onDidChangePolicies",r);const f=y.Registry.as(b.Extensions.Configuration).getPolicyConfigurations(),c=(0,S.coalesce)(r.map(u=>f.get(u)));this.j(c,!0)}j(r,f){this.g.trace("PolicyConfiguration#update",r);const c=y.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),u=[],D=this.b.isEmpty();for(const O of r){const t=c[O]?.policy?.name;if(t){const n=this.f.getPolicyValue(t);(D?n!==void 0:!(0,A.equals)(this.b.getValue(O),n))&&u.push([O,n])}else this.b.getValue(O)!==void 0&&u.push([O,void 0])}if(u.length){this.g.trace("PolicyConfiguration#changed",u);const O=this.b;this.b=new R.ConfigurationModel;for(const t of O.keys)this.b.setValue(t,O.getValue(t));for(const[t,n]of u)n===void 0?this.b.removeValue(t):this.b.setValue(t,n);f&&this.a.fire(this.b)}}};e.PolicyConfiguration=g=Le([Ae(1,T.IPolicyService),Ae(2,m.ILogService)],g)}),define(pe[114],be([1,0,14,6,2,19,24,113,228,67]),function(le,e,S,L,o,A,k,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class T extends o.Disposable{constructor(v,h,g,p){super(),this.i=v,this.h=this.B(new L.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.DefaultConfiguration),this.c=g instanceof m.NullPolicyService?new b.NullPolicyConfiguration:this.B(new b.PolicyConfiguration(this.b,g,p)),this.f=this.B(new R.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,h)),this.a=new R.Configuration(this.b.configurationModel,this.c.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.g=this.B(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:f})=>this.k(r,f))),this.B(this.c.onDidChangeConfiguration(r=>this.l(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[v,h,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.Configuration(v,h,new R.ConfigurationModel,g)}getConfigurationData(){return this.a.toData()}getValue(v,h){const g=typeof v=="string"?v:void 0,p=(0,k.isConfigurationOverrides)(v)?v:(0,k.isConfigurationOverrides)(h)?h:{};return this.a.getValue(g,p,void 0)}updateValue(v,h,g,p){return Promise.reject(new Error("not supported"))}inspect(v){return this.a.inspect(v,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const v=await this.f.loadConfiguration();this.j(v)}j(v){const h=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration(v);this.m(g,h,2)}k(v,h){const g=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(v,h);this.m(p,g,7)}l(v){const h=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration(v);this.m(g,h,7)}m(v,h,g){const p=new R.ConfigurationChangeEvent(v,{data:h},this.a);p.source=g,p.sourceConfig=this.n(g),this.h.fire(p)}n(v){switch(v){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=T}),define(pe[115],be([1,0,11,5]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var o;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(o||(e.RemoteConnectionType=o={}));class A{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=A;class k{constructor(y,v){this.host=y,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=k;var R;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class b extends S.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof b&&y._code===R.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof b&&y._code===R.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof b&&y._code===R.NoResolverFound}static isHandled(y){return y instanceof b&&y.isHandled}constructor(y,v=R.Unknown,h){super(y),this._message=y,this._code=v,this._detail=h,this.isHandled=v===R.NotAvailable&&h===!0,Object.setPrototypeOf(this,b.prototype)}}e.RemoteAuthorityResolverError=b;function m(T){const y=T.indexOf("+");return y===-1?T:T.substring(0,y)}e.getRemoteAuthorityPrefix=m}),define(pe[229],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteExtensionsScannerChannelName=e.IRemoteExtensionsScannerService=void 0,e.IRemoteExtensionsScannerService=(0,S.createDecorator)("IRemoteExtensionsScannerService"),e.RemoteExtensionsScannerChannelName="remoteExtensionsScanner"}),define(pe[56],be([1,0,13]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(m){return m.scheme===S.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=L;function o(m){if(!m)return;const T=m.indexOf("+");return T<0?m:m.substr(0,T)}e.getRemoteName=o;function A(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=A;function k(m){const{host:T,port:y}=b(m);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:T,port:y}}e.parseAuthorityWithPort=k;function R(m,T){let{host:y,port:v}=b(m);return typeof v>"u"&&(v=T),{host:y,port:v}}e.parseAuthorityWithOptionalPort=R;function b(m){const T=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(T)return{host:T[1],port:parseInt(T[2],10)};const y=m.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const v=m.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:m,port:void 0}}}),define(pe[34],be([1,0,17,5,56]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(k||(e.ExtensionType=k={}));var R;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class b{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,f){if(typeof r>"u"||r===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof r=="string"||typeof f=="string"){const c=typeof r=="string"?r:r.value,u=typeof f=="string"?f:f.value;return S.equalsIgnoreCase(c,u)}return r._lower===f._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.ExtensionIdentifier=b;class m{get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const f of r)this.add(f)}add(r){this.c.add(b.toKey(r))}delete(r){return this.c.delete(b.toKey(r))}has(r){return this.c.has(b.toKey(r))}}e.ExtensionIdentifierSet=m;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(b.toKey(r))}get(r){return this.c.get(b.toKey(r))}has(r){return this.c.has(b.toKey(r))}set(r,f){this.c.set(b.toKey(r),f)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=T;function y(p){return v(p)}e.isApplicationScopedExtension=y;function v(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function h(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=h;function g(p,r){if(r){const f=`onResolveRemoteAuthority:${(0,o.getRemoteName)(r)}`;return!!p.activationEvents?.includes(f)}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(pe[230],be([1,0,11,34]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class o{constructor(){this.a=new Map,this.b=new WeakMap}register(k,R){this.a.set(k,R)}readActivationEvents(k){return this.b.has(k)||this.b.set(k,this.c(k)),this.b.get(k)}createActivationEventsMap(k){const R=Object.create(null);for(const b of k){const m=this.readActivationEvents(b);m.length>0&&(R[L.ExtensionIdentifier.toKey(b.identifier)]=m)}return R}c(k){if(typeof k.main>"u"&&typeof k.browser>"u")return[];const R=Array.isArray(k.activationEvents)?k.activationEvents.slice(0):[];if(!k.contributes)return R;for(const b in k.contributes){const m=this.a.get(b);if(!m)continue;const T=k.contributes[b],y=Array.isArray(T)?T:[T];try{m(y,R)}catch(v){(0,S.onUnexpectedError)(v)}}return R}}e.ImplicitActivationEventsImpl=o,e.ImplicitActivationEvents=new o}),define(pe[231],be([1,0,2,34,16]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends S.Disposable{constructor(R,b,m,T,y){super(),this.a=R,this.b=b,this.c=m,this.f=y,this.B(T.onDidInstallExtensions(v=>this.g(v))),this.B(T.onDidUninstallExtension(v=>this.h(v)))}g(R){for(const b of R)b.local&&this.invalidate(b.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const b of this.a.profiles)this.c.extUri.isEqual(b.extensionsResource,R)&&await this.i(b);else await this.i(this.a.defaultProfile)}async i(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,L.USER_MANIFEST_CACHE_FILE))}catch(b){(0,o.toFileOperationResult)(b)!==1&&this.f.error(b)}}}e.ExtensionsManifestCache=A}),define(pe[43],be([1,0,15,11,2,187,55,5,12,40]),function(le,e,S,L,o,A,k,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");class T{constructor(O){this.b=O}toJSON(){if(!this.a){const O=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?O[t]="*****":O[t]=this.b[t];this.a=O}return this.a}}class y extends o.Disposable{constructor(O){super(),this.b=0,this.a=O.createLogger("network",{name:(0,A.localize)(0,null),when:b.CONTEXT_LOG_LEVEL.isEqualTo((0,b.LogLevelToString)(b.LogLevel.Trace)).serialize()})}async c(O,t,n){const s=`${O} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new T(t.headers??{}));try{const i=await n();return this.a.trace(`${s} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${s} - error`,t.type,(0,L.getErrorMessage)(i)),i}}}e.AbstractRequestService=y;function v(D){return D.res.statusCode&&D.res.statusCode>=200&&D.res.statusCode<300||D.res.statusCode===1223}e.isSuccess=v;function h(D){return D.res.statusCode===204}async function g(D){return h(D)?null:(await(0,S.streamToBuffer)(D.stream)).toString()}e.asText=g;async function p(D){if(!v(D))throw new Error("Server returned "+D.res.statusCode);return g(D)}e.asTextOrError=p;async function r(D){if(!v(D))throw new Error("Server returned "+D.res.statusCode);if(h(D))return null;const t=(await(0,S.streamToBuffer)(D.stream)).toString();try{return JSON.parse(t)}catch(n){throw n.message+=`:
`+t,n}}e.asJson=r;function f(D){u(D)}e.updateProxyConfigurationsScope=f;let c;function u(D){const O=m.Registry.as(k.Extensions.Configuration),t=c;c={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:D,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(5,null),(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null)],default:"override",description:(0,A.localize)(9,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(10,null),restricted:!0}}},O.updateConfigurations({add:[c],remove:t?[t]:[]})}u(1)}),define(pe[232],be([1,0,20,13,16,43]),function(le,e,S,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=e.DownloadService=class{constructor(b,m){this.a=b,this.b=m}async download(b,m,T=S.CancellationToken.None){if(b.scheme===L.Schemas.file||b.scheme===L.Schemas.vscodeRemote){await this.b.copy(b,m);return}const y={type:"GET",url:b.toString(!0)},v=await this.a.request(y,T);if(v.res.statusCode===200)await this.b.writeFile(m,v.stream);else{const h=await(0,A.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${h}`)}}};e.DownloadService=k=Le([Ae(0,A.IRequestService),Ae(1,o.IFileService)],k)}),define(pe[233],be([1,0,15,20]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class o{constructor(R){this.a=R}listen(R,b){throw new Error("Invalid listen")}call(R,b,m,T=L.CancellationToken.None){switch(b){case"request":return this.a.request(m[0],T).then(async({res:y,stream:v})=>{const h=await(0,S.streamToBuffer)(v);return[{statusCode:y.statusCode,headers:y.headers},h]});case"resolveProxy":return this.a.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=o;class A{constructor(R){this.a=R}async request(R,b){const[m,T]=await this.a.call("request",[R],b);return{res:m,stream:(0,S.bufferToStream)(T)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.RequestChannelClient=A}),define(pe[234],be([1,0,83,8]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function o(k,R){return k.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:k.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function A(k,R,b={}){const m=(0,S.parse)(k),T=b.proxyUrl||o(m,R);if(!T)return null;const y=(0,S.parse)(T);if(!/^https?:$/.test(y.protocol||""))return null;const v={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,L.isBoolean)(b.strictSSL)?b.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((h,g)=>{le(["http-proxy-agent"],h,g)}))(v):new(await new Promise((h,g)=>{le(["https-proxy-agent"],h,g)}))(v)}e.getProxyAgent=A}),define(pe[84],be([1,0,52,7,188,20,38,11,3,22,163,205,14,142]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let g;async function p(f,c,u,D){return u["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(D)&&!u["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(D)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=v.Promises.withAsyncBody(async(O,t)=>{const n=new A.CancellationTokenSource;let s=1e4;const i=f.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(s=(0,h.clamp)(i,1,120)*1e3);const a=setTimeout(()=>{n.dispose(!0),t(new Error((0,o.localize)(0,null)))},s);try{O(await r(c,n.token))}catch(l){!(0,R.isCancellationError)(l)&&!n.token.isCancellationRequested?t(new Error((0,o.localize)(1,null,(0,k.toErrorMessage)(l)))):O({})}finally{clearTimeout(a),n.dispose()}})),g)}e.getResolvedShellEnv=p;async function r(f,c){const u=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",u);const D=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",D);const O=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(O+"({.*})"+O),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",n);const s=await(0,T.getSystemShell)(b.OS,n);return f.trace("getUnixShellEnvironment#shell",s),new Promise((i,a)=>{if(c.isCancellationRequested)return a(new R.CancellationError);const l=(0,L.basename)(s);let d,I;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(d=`& '${process.execPath}' ${C} -p '''${O}'' + JSON.stringify(process.env) + ''${O}'''`,I=["-Login","-Command"]):l==="nu"?(d=`^'${process.execPath}' ${C} -p '"${O}" + JSON.stringify(process.env) + "${O}"'`,I=["-i","-l","-c"]):(d=`'${process.execPath}' ${C} -p '"${O}" + JSON.stringify(process.env) + "${O}"'`,l==="tcsh"||l==="csh"?I=["-ic"]:I=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),d);const E=(0,S.spawn)(s,[...I,d],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});c.onCancellationRequested(()=>(E.kill(),a(new R.CancellationError))),E.on("error",$=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)($)),a($)});const w=[];E.stdout.on("data",$=>w.push($));const N=[];E.stderr.on("data",$=>N.push($)),E.on("close",($,se)=>{const he=Buffer.concat(w).toString("utf8");f.trace("getUnixShellEnvironment#raw",he);const ae=Buffer.concat(N).toString("utf8");if(ae.trim()&&f.trace("getUnixShellEnvironment#stderr",ae),$||se)return a(new Error((0,o.localize)(2,null,$,se)));const ue=t.exec(he),ge=ue?ue[1]:"{}";try{const _=JSON.parse(ge);u?_.ELECTRON_RUN_AS_NODE=u:delete _.ELECTRON_RUN_AS_NODE,D?_.ELECTRON_NO_ATTACH_CONSOLE=D:delete _.ELECTRON_NO_ATTACH_CONSOLE,delete _.VSCODE_RESOLVING_ENVIRONMENT,delete _.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",_),i(_)}catch(_){f.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(_)),a(_)}})})}}),define(pe[235],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,S.createDecorator)("stateReadService"),e.IStateService=(0,S.createDecorator)("stateService")}),define(pe[236],be([1,0,14,15,8,25,16,12]),function(le,e,S,L,o,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var b;(function(v){v[v.IMMEDIATE=0]="IMMEDIATE",v[v.DELAYED=1]="DELAYED"})(b||(e.SaveStrategy=b={}));class m{constructor(h,g,p,r){this.f=h,this.g=p,this.h=r,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=g===0?void 0:new S.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(h){h.fileOperationResult!==1&&this.g.error(h)}}getItem(h,g){const p=this.a[h];return(0,o.isUndefinedOrNull)(p)?g:p}setItem(h,g){this.setItems([{key:h,data:g}])}setItems(h){let g=!1;for(const{key:p,data:r}of h)this.a[p]!==r&&((0,o.isUndefinedOrNull)(r)?(0,o.isUndefined)(this.a[p])||(this.a[p]=void 0,g=!0):(this.a[p]=r,g=!0));g&&this.j()}removeItem(h){(0,o.isUndefined)(this.a[h])||(this.a[h]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const h=JSON.stringify(this.a,null,4);if(h!==this.b)try{await this.h.writeFile(this.f,L.VSBuffer.fromString(h),{atomic:{postfix:".vsctmp"}}),this.b=h}catch(g){this.g.error(g)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=m;let T=e.StateReadonlyService=class{constructor(h,g,p,r){this.a=new m(g.stateResource,h,p,r)}async init(){await this.a.init()}getItem(h,g){return this.a.getItem(h,g)}};e.StateReadonlyService=T=Le([Ae(1,A.IEnvironmentService),Ae(2,R.ILogService),Ae(3,k.IFileService)],T);class y extends T{setItem(h,g){this.a.setItem(h,g)}setItems(h){this.a.setItems(h)}removeItem(h){this.a.removeItem(h)}close(){return this.a.close()}}e.StateService=y}),define(pe[116],be([1,0,3,29,22]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(b){if(S.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}function k(b,m,T,y,v,h,g,p){const r=Object.create(null);r["common.machineId"]=h,r.sessionID=(0,o.generateUuid)()+Date.now(),r.commitHash=y,r.version=v,r["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,S.PlatformToString)(S.platform),r["common.nodePlatform"]=L.platform,r["common.nodeArch"]=T,r["common.product"]=p||"desktop",g&&(r["common.msftInternal"]=g);let f=0;const c=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),S.isLinuxSnap&&(r["common.snap"]="true");const u=A(m);return u&&(r["common.platformDetail"]=u),r}e.resolveCommonProperties=k;function R(b){const m=L.env.USERDNSDOMAIN;if(!m)return!1;const T=m.toLowerCase();return b.some(y=>T===y)}e.verifyMicrosoftInternalDomain=R}),define(pe[237],be([1,0,18,11,2,21,16]),function(le,e,S,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var R;(function(m){function T(y,v){return y.callstack<v.callstack?-1:y.callstack>v.callstack?1:0}m.compare=T})(R||(e.ErrorEvent=R={}));class b{constructor(T,y=b.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new o.DisposableStore,this.c=T,this.d=y;const v=L.errorHandler.addListener(h=>this.j(h));this.h.add((0,o.toDisposable)(v)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(T){if(!T||(T.detail&&T.detail.stack&&(T=T.detail),L.ErrorNoTelemetry.isErrorNoTelemetry(T)||T instanceof k.FileOperationError||T?.message?.includes("Unable to read file")))return;const y=Array.isArray(T.stack)?T.stack.join(`
`):T.stack,v=T.message?T.message:(0,A.safeStringify)(T);y&&this.k({msg:v,callstack:y})}k(T){const y=(0,S.binarySearch)(this.g,T,R.compare);y<0?(T.count=1,this.g.splice(~y,0,T)):(this.g[y].count||(this.g[y].count=0),this.g[y].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const T of this.g)this.c.publicLogError2("UnhandledError",T);this.g.length=0}}b.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=b}),define(pe[238],be([1,0,2]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class L extends S.Disposable{constructor(A,k){super(),this.a=A,this.b=k}async call(A,k,R){switch(k){case"updateTelemetryLevel":{const{telemetryLevel:b}=R;return this.a.updateInjectedTelemetryLevel(b)}case"logTelemetry":{const{eventName:b,data:m}=R;return this.b?this.b.log(b,m):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${k} not found`)}listen(A,k,R){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=L}),define(pe[31],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var o;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(o||(e.TelemetryConfiguration=o={}))}),define(pe[239],be([1,0,28,14,72,13,7,3,4,100,23,103,211,16,26,31]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const r=new Map;async function f(t,n){const s=`${t}::${n.join(":")}`,i=r.get(s);if(i)return i;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,d=new Map,I=2e4;function C(w,N,$,se){const he=N.substring(w.length+1);return L.Promises.withAsyncBody(async ae=>{let ue;try{ue=await T.Promises.readdir(N,{withFileTypes:!0})}catch{ae();return}if(se.count>=I){se.count+=ue.length,se.maxReached=!0,ae();return}let ge=ue.length;if(ge===0){ae();return}let _=ue;se.count+ue.length>I&&(se.maxReached=!0,ge=I-se.count,_=ue.slice(0,ge)),se.count+=ue.length;for(const ie of _)if(ie.isDirectory()){if($.includes(ie.name)||await C(w,(0,k.join)(N,ie.name),$,se),--ge===0){ae();return}}else{const V=ie.name.lastIndexOf(".");if(V>=0){const J=ie.name.substring(V+1);J&&l.set(J,(l.get(J)??0)+1)}for(const J of a)J.relativePathPattern?.test(he)!==!1&&J.filePattern.test(ie.name)&&d.set(J.tag,(d.get(J.tag)??0)+1);if(--ge===0){ae();return}}})}const E=L.Promises.withAsyncBody(async w=>{const N={count:0,maxReached:!1};await C(t,t,n,N);const $=await D(t);w({configFiles:c(d),fileTypes:c(l),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:$})});return r.set(s,E),E}e.collectWorkspaceStats=f;function c(t){return Array.from(t.entries(),([n,s])=>({name:n,count:s})).sort((n,s)=>s.count-n.count)}function u(){const t={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},n=S.cpus();return n&&n.length>0&&(t.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),t}e.getMachineInfo=u;async function D(t){try{const n=new Map,s=(0,k.join)(t,".vscode","launch.json"),i=await T.Promises.readFile(s),a=[],l=(0,o.parse)(i.toString(),a);if(a.length)return console.log(`Unable to parse ${s}`),[];if((0,o.getNodeType)(l)==="object"&&l.configurations)for(const d of l.configurations){const I=d.type;I&&(n.has(I)?n.set(I,n.get(I)+1):n.set(I,1))}return c(n)}catch{return[]}}e.collectLaunchConfigs=D;let O=e.DiagnosticsService=class{constructor(n,s){this.c=n,this.d=s}f(n){const s=[];return s.push(`OS Version:       ${n.os}`),s.push(`CPUs:             ${n.cpus}`),s.push(`Memory (System):  ${n.memory}`),s.push(`VM:               ${n.vmHint}`),s.join(`
`)}g(n){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const i=S.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(S.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||s.push(`Load (avg):       ${S.loadavg().map(a=>Math.round(a)).join(", ")}`),s.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${n.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(n.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(n,s){return Promise.all([(0,y.listProcesses)(n.mainPID),this.k(n)]).then(async i=>{let[a,l]=i,d=this.m(n,a);return s.forEach(I=>{if((0,v.isRemoteDiagnosticError)(I))d+=`
${I.errorMessage}`,l+=`
${I.errorMessage}`;else if(d+=`

Remote: ${I.hostName}`,I.processes&&(d+=`
${this.m(n,I.processes)}`),I.workspaceMetadata){l+=`
|  Remote: ${I.hostName}`;for(const C of Object.keys(I.workspaceMetadata)){const E=I.workspaceMetadata[C];let w=`${E.fileCount} files`;E.maxFilesReached&&(w=`more than ${w}`),l+=`|    Folder (${C}): ${w}`,l+=this.h(E)}}}),{processInfo:d,workspaceInfo:l}})}async getSystemInfo(n,s){const{memory:i,vmHint:a,os:l,cpus:d}=u(),I={os:l,memory:i,cpus:d,vmHint:a,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:s};return R.isWindows||(I.load=`${S.loadavg().map(C=>Math.round(C)).join(", ")}`),R.isLinux&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(n,s){const i=[];return(0,y.listProcesses)(n.mainPID).then(async a=>(i.push(""),i.push(this.g(n)),i.push(""),i.push(this.m(n,a)),n.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(n))),s.forEach(l=>{if((0,v.isRemoteDiagnosticError)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.f(l.machineInfo)),l.processes&&i.push(this.m(n,l.processes)),l.workspaceMetadata)for(const d of Object.keys(l.workspaceMetadata)){const I=l.workspaceMetadata[d];let C=`${I.fileCount} files`;I.maxFilesReached&&(C=`more than ${C}`),i.push(`Folder (${d}): ${C}`),i.push(this.h(I))}}),i.push(""),i.push(""),i.join(`
`)))}h(n){const s=[];let a=0;const l=(E,w)=>{const N=` ${E}(${w})`;a+N.length>60?(s.push(d),d="|                 ",a=d.length):a+=N.length,d+=N};let d="|      File types:";const I=10,C=n.fileTypes.length>I?I:n.fileTypes.length;for(let E=0;E<C;E++){const w=n.fileTypes[E];l(w.name,w.count)}if(s.push(d),n.configFiles.length>=0&&(d="|      Conf files:",a=0,n.configFiles.forEach(E=>{l(E.name,E.count)}),s.push(d)),n.launchConfigFiles.length>0){let E="|      Launch Configs:";n.launchConfigFiles.forEach(w=>{const N=w.count>1?` ${w.name}(${w.count})`:` ${w.name}`;E+=N}),s.push(E)}return s.join(`
`)}j(n){const s=Math.max(...Object.keys(n).map(i=>i.length));return Object.keys(n).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${n[i]}`).join(`
                  `)}k(n){const s=[],i=[];return n.windows.forEach(a=>{a.folderURIs.length===0||a.remoteAuthority||(s.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const d=b.URI.revive(l);if(d.scheme===A.Schemas.file){const I=d.fsPath;i.push(f(I,["node_modules",".git"]).then(C=>{let E=`${C.fileCount} files`;C.maxFilesReached&&(E=`more than ${E}`),s.push(`|    Folder (${(0,k.basename)(I)}): ${E}`),s.push(this.h(C))}).catch(C=>{s.push(`|      Error: Unable to collect workspace stats for folder ${I} (${C.toString()})`)}))}else s.push(`|    Folder (${d.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(a=>s.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}m(n,s){const i=new Map;n.windows.forEach(l=>i.set(l.pid,`window [${l.id}] (${l.title})`)),n.pidToNames.forEach(({pid:l,name:d})=>i.set(l,d));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),s&&this.n(n.mainPID,i,a,s,0),a.join(`
`)}n(n,s,i,a,l){const d=l===0;let I;d?I=a.pid===n?`${this.d.applicationName} main`:"remote agent":s.has(a.pid)?I=s.get(a.pid):I=`${"  ".repeat(l)} ${a.name}`;const C=process.platform==="win32"?a.mem:S.totalmem()*(a.mem/100);i.push(`${a.load.toFixed(0).padStart(5," ")}	${(C/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(a.children)&&a.children.forEach(E=>this.n(n,s,i,E,l+1))}async getWorkspaceFileExtensions(n){const s=new Set;for(const{uri:i}of n.folders){const a=b.URI.revive(i);if(a.scheme!==A.Schemas.file)continue;const l=a.fsPath;try{(await f(l,["node_modules",".git"])).fileTypes.forEach(I=>s.add(I.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(n){for(const{uri:s}of n.folders){const i=b.URI.revive(s);if(i.scheme!==A.Schemas.file)continue;const a=i.fsPath;try{const l=await f(a,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),l.fileTypes.forEach(d=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:d.name,count:d.count})}),l.launchConfigFiles.forEach(d=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:d.name,count:d.count})}),l.configFiles.forEach(d=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:d.name,count:d.count})})}catch{}}}};e.DiagnosticsService=O=Le([Ae(0,p.ITelemetryService),Ae(1,g.IProductService)],O)}),define(pe[37],be([1,0,21,8,6,24,56,116,31]),function(le,e,S,L,o,A,k,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=m;class T{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class y{async publicLog(a,l,d){}async publicLogError(a,l,d){}}e.NullEndpointTelemetryService=y,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,a){return o.Event.debounce(a.onDidChangeConfiguration,(d,I)=>{const C=d?new Set([...d.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:C}},1e3,!0)(d=>{d.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(d.source),configurationKeys:Array.from(d.affectedKeys)})})}e.configurationTelemetry=v;function h(i,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!i.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=h;function g(i,a){return!(a.isBuilt||a.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=g;function p(i){const a=i.getValue(b.TELEMETRY_SETTING_ID),l=i.getValue(b.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(b.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function r(i){const a={},l={},d={};u(i,d);for(let I in d){I=I.length>150?I.substr(I.length-149):I;const C=d[I];typeof C=="number"?l[I]=C:typeof C=="boolean"?l[I]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${C.length}`),a[I]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(a[I]=C)}return{properties:a,measurements:l}}e.validateTelemetryData=r;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(i){if(!i)return"none";const a=(0,k.getRemoteName)(i);return f.has(a)?a:"other"}e.cleanRemoteAuthority=c;function u(i,a,l=0,d){if(i)for(const I of Object.getOwnPropertyNames(i)){const C=i[I],E=d?d+I:I;Array.isArray(C)?a[E]=(0,S.safeStringify)(C):C instanceof Date?a[E]=C.toISOString():(0,L.isObject)(C)?l<2?u(C,a,l+1,E+"."):a[E]=(0,S.safeStringify)(C):a[E]=C}}function D(i,a){const l=i.msftInternalDomains||[],d=a.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(l)||d}e.isInternalTelemetry=D;function O(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=O;function t(i,a){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let l=i;const d=[];for(const w of a)for(;;){const N=w.exec(i);if(!N)break;d.push([N.index,w.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(l="";;){const w=C.exec(i);if(!w)break;const N=d.some(([$,se])=>w.index<se&&$<C.lastIndex);!I.test(w[0])&&!N&&(l+=i.substring(E,w.index)+"<REDACTED: user-file-path>",E=C.lastIndex)}return E<i.length&&(l+=i.substr(E)),l}function n(i){if(!i)return i;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of a)if(l.regex.test(i))return`<REDACTED: ${l.label}>`;return i}function s(i,a){return(0,S.cloneAndChange)(i,l=>{if(l instanceof m||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let d=l.replaceAll("%20"," ");d=t(d,a);for(const I of a)d=d.replace(I,"");return d=n(d),d}})}e.cleanData=s}),define(pe[35],be([1,0,17,30,34,3,4,11,29,37]),function(le,e,S,L,o,A,k,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function T(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,S.compareIgnoreCase)(s.id,i.id)===0}e.areSameExtensions=T;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const a=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,a,l)}static parse(i){const a=y.exec(i);return a&&a[1]&&a[2]?new v({id:a[1]},a[2],a[4]||void 0):null}constructor(i,a,l="undefined"){this.version=a,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?T(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=v;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(s){const i=h.exec(s);return i&&i[1]?[r(i[1]),i[2]]:[r(s),void 0]}e.getIdAndVersion=g;function p(s,i){return`${s}.${i}`}e.getExtensionId=p;function r(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=r;function f(s,i){return r(p(s??o.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=f;function c(s,i){const a=[],l=d=>{for(const I of a)if(I.some(C=>T(i(C),i(d))))return I;return null};for(const d of s){const I=l(d);I?I.push(d):a.push([d])}return a}e.groupByExtension=c;function u(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=u;function D(s){return{id:new m.TelemetryTrustedValue(s.identifier.id),name:new m.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=D,e.BetterMergeId=new o.ExtensionIdentifier("pprice.better-merge");function O(s,i){const a=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const d=l.shift();if(d&&a.every(I=>!T(I.identifier,{id:d}))){const I=s.filter(C=>T(C.identifier,{id:d}));I.length===1&&(a.push(I[0]),l.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=O;async function t(s,i){if(!A.isLinux)return!1;let a;try{a=(await s.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await s.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){i.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(d))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(s,i){const a=await t(s,i),l=(0,L.getTargetPlatform)(a?"alpine":A.platform,b.arch);return i.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=n}),define(pe[117],be([1,0,20,11,13,19,53,4,175,30,35,34]),function(le,e,S,L,o,A,k,R,b,m,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const v=r=>(0,b.localize)(0,null,r),h=(0,b.localize)(1,null,"ms-dotnettools.csharp");function g(r,f){return f?`${r.publisher}.${r.name}@${r.version}`:`${r.publisher}.${r.name}`}let p=e.ExtensionManagementCLI=class{constructor(f,c,u){this.a=f,this.b=c,this.d=u}get f(){}async listExtensions(f,c,u){let D=await this.b.getInstalled(1,u);const O=y.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(c&&c!==""){if(O.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}D=D.filter(n=>n.manifest.categories?n.manifest.categories.map(i=>i.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),O.forEach(n=>{this.a.info(n)});return}this.f&&this.a.info((0,b.localize)(2,null,this.f)),D=D.sort((n,s)=>n.identifier.id.localeCompare(s.identifier.id));let t;for(const n of D)t!==n.identifier.id&&(t=n.identifier.id,this.a.info(g(n.manifest,f)))}async installExtensions(f,c,u,D){const O=[];try{const t=[];f.length&&this.a.info(this.f?(0,b.localize)(3,null,this.f):(0,b.localize)(4,null));const n=[];let s=[];const i=(l,d,I)=>{s.push({id:l,version:d!=="prerelease"?d:void 0,installOptions:{...u,isBuiltin:I,installPreReleaseVersion:d==="prerelease"||u.installPreReleaseVersion}})};for(const l of f)if(l instanceof R.URI)n.push({vsix:l,installOptions:u});else{const[d,I]=(0,T.getIdAndVersion)(l);i(d,I,!1)}for(const l of c)if(l instanceof R.URI)n.push({vsix:l,installOptions:{...u,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[d,I]=(0,T.getIdAndVersion)(l);i(d,I,!0)}const a=await this.b.getInstalled(1,u.profileLocation);if(n.length&&await Promise.all(n.map(async({vsix:l,installOptions:d})=>{try{const I=await this.g(l,d,D,a);I&&t.push(I)}catch(I){this.a.error(I),O.push(l.toString())}})),s.length&&(s=s.filter(({id:l,version:d})=>{const I=a.find(C=>(0,T.areSameExtensions)(C.identifier,{id:l}));if(I){if(!D&&(!d||d==="prerelease"&&I.preRelease))return this.a.info((0,b.localize)(5,null,l,I.manifest.version,l)),!1;if(d&&I.manifest.version===d)return this.a.info((0,b.localize)(6,null,`${l}@${d}`)),!1}return!0}),s.length)){const l=await this.h(s);await Promise.all(s.map(async d=>{const I=l.get(d.id.toLowerCase());if(I)try{const C=await this.j(d,I,a);C&&t.push(C)}catch(C){this.a.error(C.message||C.stack||C),O.push(d.id)}else this.a.error(`${v(d.version?`${d.id}@${d.version}`:d.id)}
${h}`),O.push(d.id)}))}}catch(t){throw this.a.error((0,b.localize)(7,null,(0,L.getErrorMessage)(t))),t}if(O.length)throw new Error((0,b.localize)(8,null,O.join(", ")))}async g(f,c,u,D){const O=await this.b.getManifest(f);if(!O)throw new Error("Invalid vsix");if(await this.l(O,u,c.profileLocation,D))try{return await this.b.install(f,c),this.a.info((0,b.localize)(9,null,(0,A.basename)(f))),O}catch(n){if((0,L.isCancellationError)(n))return this.a.info((0,b.localize)(10,null,(0,A.basename)(f))),null;throw n}return null}async h(f){const c=new Map,u=f.some(t=>t.installOptions.installPreReleaseVersion),D=await this.b.getTargetPlatform(),O=[];for(const t of f)m.EXTENSION_IDENTIFIER_REGEX.test(t.id)&&O.push({...t,preRelease:u});if(O.length){const t=await this.d.getExtensions(O,{targetPlatform:D},S.CancellationToken.None);for(const n of t)c.set(n.identifier.id.toLowerCase(),n)}return c}async j({id:f,version:c,installOptions:u},D,O){const t=await this.d.getManifest(D,S.CancellationToken.None);if(t&&!this.k(t))return null;const n=O.find(s=>(0,T.areSameExtensions)(s.identifier,D.identifier));if(n){if(D.version===n.manifest.version)return this.a.info((0,b.localize)(11,null,c?`${f}@${c}`:f)),null;this.a.info((0,b.localize)(12,null,f,D.version))}try{u.isBuiltin?this.a.info(c?(0,b.localize)(13,null,f,c):(0,b.localize)(14,null,f)):this.a.info(c?(0,b.localize)(15,null,f,c):(0,b.localize)(16,null,f));const s=await this.b.installFromGallery(D,{...u,installGivenVersion:!!c});return this.a.info((0,b.localize)(17,null,f,s.manifest.version)),t}catch(s){if((0,L.isCancellationError)(s))return this.a.info((0,b.localize)(18,null,f)),null;throw s}}k(f){return!0}async l(f,c,u,D){if(!c){const O={id:(0,T.getGalleryExtensionId)(f.publisher,f.name)},t=D.find(n=>(0,T.areSameExtensions)(O,n.identifier)&&(0,k.gt)(n.manifest.version,f.version));if(t)return this.a.info((0,b.localize)(19,null,t.identifier.id,t.manifest.version,f.version)),!1}return this.k(f)}async uninstallExtensions(f,c,u){const D=async t=>{if(t instanceof R.URI){const n=await this.b.getManifest(t);return g(n)}return t},O=[];for(const t of f){const n=await D(t),i=(await this.b.getInstalled(void 0,u)).filter(a=>(0,T.areSameExtensions)(a.identifier,{id:n}));if(!i.length)throw new Error(`${this.m(n)}
${h}`);if(i.some(a=>a.type===0)){this.a.info((0,b.localize)(20,null,n));return}if(!c&&i.some(a=>a.isBuiltin)){this.a.info((0,b.localize)(21,null,n));return}this.a.info((0,b.localize)(22,null,n));for(const a of i)await this.b.uninstall(a,{profileLocation:u}),O.push(a);this.f?this.a.info((0,b.localize)(23,null,n,this.f)):this.a.info((0,b.localize)(24,null,n))}}async locateExtension(f){const c=await this.b.getInstalled();f.forEach(u=>{c.forEach(D=>{if(D.identifier.id===u&&D.location.scheme===o.Schemas.file){this.a.info(D.location.fsPath);return}})})}m(f){return this.f?(0,b.localize)(25,null,f,this.f):(0,b.localize)(26,null,f)}};e.ExtensionManagementCLI=p=Le([Ae(1,m.IExtensionManagementService),Ae(2,m.IExtensionGalleryService)],p)}),define(pe[240],be([1,0,6,2,27,35,34]),function(le,e,S,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends L.Disposable{constructor(m,T,y,v,h,g,p){super(),this.f=m,this.g=T,this.h=y,this.i=v,this.j=h,this.k=g,this.l=p,this.a=this.B(new S.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new L.DisposableMap),this.m().then(null,r=>p.error(r))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(m=>this.p(m.added,m.removed))),this.B(this.i.onAddExtensions(m=>this.r(m))),this.B(this.i.onDidAddExtensions(m=>this.s(m))),this.B(this.i.onRemoveExtensions(m=>this.t(m))),this.B(this.i.onDidRemoveExtensions(m=>this.u(m))),this.B(this.k.onDidFilesChange(m=>this.v(m)))}async p(m,T){try{await Promise.all(T.map(y=>(this.c.deleteAndDispose(y.id),this.z(y.extensionsResource)))),m.length&&await Promise.all(m.map(y=>(this.c.set(y.id,(0,L.combinedDisposable)(this.k.watch(this.j.extUri.dirname(y.extensionsResource)),this.k.watch(y.extensionsResource))),this.y(y.extensionsResource))))}catch(y){throw this.l.error(y),y}}async r(m){for(const T of m.extensions)this.D(this.G(T.identifier,T.version),m.profileLocation)}async s(m){for(const T of m.extensions){const y=this.G(T.identifier,T.version);m.error?this.F(y,m.profileLocation):this.D(y,m.profileLocation)}}async t(m){for(const T of m.extensions)this.F(this.G(T.identifier,T.version),m.profileLocation)}async u(m){const T=[],y=[];for(const v of m.extensions){const h=this.G(v.identifier,v.version);m.error?this.D(h,m.profileLocation):(this.F(h,m.profileLocation),this.b.has(h)||(this.l.debug("Extension is removed from all profiles",v.identifier.id,v.version),y.push(this.f.scanInstalledExtensionAtLocation(v.location).then(g=>{g?T.push(g):this.l.info("Extension not found at the location",v.location.toString())},g=>this.l.error(g)))))}try{await Promise.all(y),T.length&&await this.C(T)}catch(v){this.l.error(v)}}v(m){for(const T of this.h.profiles)m.contains(T.extensionsResource,0,1)&&this.w(T.extensionsResource)}async w(m){const T=[],y=[],v=await this.i.scanProfileExtensions(m),h=new Set,g=new Set;for(const[p,r]of this.b)r.has(m)&&g.add(p);for(const p of v){const r=this.G(p.identifier,p.version);h.add(r),g.has(r)||(T.push(p.identifier),this.D(r,m))}for(const p of g)if(!h.has(p)){const r=this.H(p);r&&(y.push(r.identifier),this.F(p,m))}(T.length||y.length)&&this.a.fire({added:T.length?{extensions:T,profileLocation:m}:void 0,removed:y.length?{extensions:y,profileLocation:m}:void 0})}async y(m){const T=await this.i.scanProfileExtensions(m);for(const y of T)this.D(this.G(y.identifier,y.version),m)}async z(m){for(const T of[...this.b.keys()])this.F(T,m);await this.C()}async C(m){m||(m=(await this.f.scanAllUserInstalledExtensions()).filter(y=>!this.b.has(this.G(y.identifier,y.manifest.version)))),m.length&&await this.f.markAsUninstalled(...m)}D(m,T){let y=this.b.get(m);y||this.b.set(m,y=new o.ResourceSet(v=>this.j.extUri.getComparisonKey(v))),y.add(T)}F(m,T){const y=this.b.get(m);y&&y.delete(T),y?.size||this.b.delete(m)}G(m,T){return`${k.ExtensionIdentifier.toKey(m.id)}@${T}`}H(m){const[T,y]=(0,A.getIdAndVersion)(m);return y?{identifier:{id:T},version:y}:void 0}}e.ExtensionsWatcher=R}),define(pe[241],be([1,0,208,37]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function o(A,k,R,b,m,T,y){const v={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${k.nameShort})`};if((0,L.supportsTelemetry)(k,R)&&(0,L.getTelemetryLevel)(b)===3){const h=await(0,S.getServiceMachineId)(R,m,T);v["X-Market-User-Id"]=h,v["VSCode-SessionId"]=y.machineId||h}return v}e.resolveMarketplaceHeaders=o}),define(pe[118],be([1,0,85,18,14,2,13,7,23,25,30,35,12,82,4]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let p=e.NativeLanguagePackService=class extends h.LanguagePackBaseService{constructor(u,D,O,t){super(O),this.h=u,this.i=t,this.g=this.B(new r(D,t)),this.h.registerParticipant({postInstall:async n=>this.j(n),postUninstall:async n=>this.k(n)})}async getBuiltInExtensionTranslationsUri(u,D){const t=(await this.g.getLanguagePacks())[D];if(!t){this.i.warn(`No language pack found for ${D}`);return}const n=t.translations[u];return n?g.URI.file(n):void 0}async getInstalledLanguages(){const u=await this.g.getLanguagePacks(),D=Object.keys(u).map(O=>{const t=u[O];return{...this.f(O,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return D.push(this.f("en","English")),D.sort((O,t)=>O.label.localeCompare(t.label)),D}async j(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",u.identifier.id),await this.update())}async k(u){const D=await this.g.getLanguagePacks();Object.keys(D).some(O=>D[O]&&D[O].extensions.some(t=>(0,y.areSameExtensions)(t.extensionIdentifier,u.identifier)))&&(this.i.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,D]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),O=await this.g.update(D);return!(0,L.equals)(Object.keys(u),Object.keys(O))}};e.NativeLanguagePackService=p=Le([Ae(0,T.IExtensionManagementService),Ae(1,m.INativeEnvironmentService),Ae(2,T.IExtensionGalleryService),Ae(3,v.ILogService)],p);let r=class extends A.Disposable{constructor(u,D){super(),this.i=D,this.c={},this.f=(0,R.join)(u.userDataPath,"languagepacks.json"),this.g=new o.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(u){return this.m(D=>{Object.keys(D).forEach(O=>delete D[O]),this.j(D,...u)}).then(()=>this.c)}j(u,...D){for(const O of D)O&&O.manifest&&O.manifest.contributes&&O.manifest.contributes.localizations&&O.manifest.contributes.localizations.length&&this.k(u,O);Object.keys(u).forEach(O=>this.l(u[O]))}k(u,D){const O=D.identifier,t=D.manifest.contributes&&D.manifest.contributes.localizations?D.manifest.contributes.localizations:[];for(const n of t)if(D.location.scheme===k.Schemas.file&&f(n)){let s=u[n.languageId];s||(s={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},u[n.languageId]=s);const i=s.extensions.filter(a=>(0,y.areSameExtensions)(a.extensionIdentifier,O))[0];i?i.version=D.manifest.version:s.extensions.push({extensionIdentifier:O,version:D.manifest.version});for(const a of n.translations)s.translations[a.id]=(0,R.join)(D.location.fsPath,a.path)}}l(u){if(u){const D=(0,S.createHash)("md5");for(const O of u.extensions)D.update(O.extensionIdentifier.uuid||O.extensionIdentifier.id).update(O.version);u.hash=D.digest("hex")}}m(u=()=>null){return this.g.queue(()=>{let D=null;return b.Promises.readFile(this.f,"utf8").then(void 0,O=>O.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(O)).then(O=>{try{return JSON.parse(O)}catch{return{}}}).then(O=>(D=u(O),O)).then(O=>{for(const n of Object.keys(O))O[n]||delete O[n];this.c=O,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),b.Promises.writeFile(this.f,t)}).then(()=>D,O=>this.i.error(O))})}};r=Le([Ae(0,m.INativeEnvironmentService),Ae(1,v.ILogService)],r);function f(c){if(typeof c.languageId!="string"||!Array.isArray(c.translations)||c.translations.length===0)return!1;for(const u of c.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(c.languageName&&typeof c.languageName!="string"||c.localizedLanguageName&&typeof c.localizedLanguageName!="string")}}),define(pe[242],be([1,0,11,21,37]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function R(m,T,y){const v=await new Promise((f,c)=>{le(["@microsoft/1ds-core-js"],f,c)}),h=await new Promise((f,c)=>{le(["@microsoft/1ds-post-js"],f,c)}),g=new v.AppInsightsCore,p=new h.PostChannel,r={instrumentationKey:m,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(y){r.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:y};r.extensionConfig[p.identifier]=f}return g.initialize(r,[]),g.addTelemetryInitializer(f=>{T&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),g}class b{constructor(T,y,v,h,g){this.e=T,this.f=y,this.g=v,this.h=g,this.c=A,this.d=k,this.g||(this.g={}),typeof h=="function"?this.a=h():this.a=h,this.b=null}i(T){if(this.a){if(typeof this.a!="string"){T(this.a);return}this.b||(this.b=R(this.a,this.e,this.h)),this.b.then(y=>{T(y)},y=>{(0,S.onUnexpectedError)(y),console.error(y)})}}log(T,y){if(!this.a)return;y=(0,L.mixin)(y,this.g),y=(0,o.validateTelemetryData)(y);const v=this.f+"/"+T;try{this.i(h=>{h.pluginVersionString=y?.properties.version??"Unknown",h.track({name:v,baseData:{name:v,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(T=>{this.i(y=>{y.unload(!0,()=>{this.a=void 0,T(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=b}),define(pe[243],be([1,0,2,21,3,17,189,24,55,54,26,40,31,37]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=e.TelemetryService=class{constructor(f,c,u){this.k=c,this.l=u,this.d={},this.i=new S.DisposableStore,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const D of this.f)this.j.push(new RegExp((0,A.escapeRegExpCharacters)(D),"gi")),D.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.escapeRegExpCharacters)(D.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(D=>{(D.affectsConfiguration(v.TELEMETRY_SETTING_ID)||D.affectsConfiguration(v.TELEMETRY_OLD_SETTING_ID)||D.affectsConfiguration(v.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(f,c){this.d[f]=c}m(){let f=(0,h.getTelemetryLevel)(this.k);const c=this.l.enabledTelemetryLevels;if(c){this.h=this.sendErrorTelemetry?c.error:!1;const u=c.usage?3:c.error?2:0;f=Math.min(f,u)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,c,u){this.g<c||(u=(0,L.mixin)(u,this.d),u=(0,h.cleanData)(u,this.j),u=(0,L.mixin)(u,this.c),this.b.forEach(D=>D.log(f,u)))}publicLog(f,c){this.n(f,3,c)}publicLog2(f,c){this.publicLog(f,c)}publicLogError(f,c){this.h&&this.n(f,2,c)}publicLogError2(f,c){this.publicLogError(f,c)}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=g=Le([Ae(1,R.IConfigurationService),Ae(2,T.IProductService)],g);function p(){const r=(0,k.localize)(0,null,m.default.nameLong),f=m.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=o.isWeb?"":(0,k.localize)(3,null),u=(0,k.localize)(4,null),D=(0,k.localize)(5,null),O=(0,k.localize)(6,null),t=(0,k.localize)(7,null),n=`
|       | ${u} | ${D} | ${O} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,k.localize)(8,null);return`
${r} ${f} ${c}

&nbsp;

${t}
${n}

&nbsp;

${s}
`}y.Registry.as(b.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,k.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(b.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,k.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,k.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(pe[244],be([1,0,24,5,26,31,243,37]),function(le,e,S,L,o,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let b=e.ServerTelemetryService=class extends k.TelemetryService{constructor(T,y,v,h){super(T,v,h),this.o=y}publicLog(T,y){if(!(this.o<3))return super.publicLog(T,y)}publicLog2(T,y){return this.publicLog(T,y)}publicLogError(T,y){return this.o<2?Promise.resolve(void 0):super.publicLogError(T,y)}publicLogError2(T,y){return this.publicLogError(T,y)}async updateInjectedTelemetryLevel(T){if(T===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,T):T,this.o===0&&this.dispose()}};e.ServerTelemetryService=b=Le([Ae(2,S.IConfigurationService),Ae(3,o.IProductService)],b),e.ServerNullTelemetryService=new class extends R.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,L.refineServiceDecorator)(A.ITelemetryService)}),define(pe[245],be([1,0,297,242]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class o extends L.AbstractOneDataSystemAppender{constructor(k,R,b,m){const T={sendPOST:(y,v)=>{const h={method:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data)}};try{const g=S.request(y.urlString,h,p=>{p.on("data",function(r){v(p.statusCode??200,p.headers,r.toString())}),p.on("error",function(r){v(0,{})})});g.write(y.data),g.end()}catch{v(0,{})}}};super(k,R,b,m,T)}}e.OneDataSystemAppender=o}),define(pe[246],be([1,0,11,237]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class o extends L.default{i(){(0,S.setUnexpectedErrorHandler)(R=>console.error(R));const k=[];process.on("unhandledRejection",(R,b)=>{k.push(b),setTimeout(()=>{const m=k.indexOf(b);m>=0&&b.catch(T=>{k.splice(m,1),(0,S.isCancellationError)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T.stack&&console.warn(`stack trace: ${T.stack}`),R&&(0,S.onUnexpectedError)(R))})},1e3)}),process.on("rejectionHandled",R=>{const b=k.indexOf(R);b>=0&&k.splice(b,1)}),process.on("uncaughtException",R=>{(0,S.isSigPipeError)(R)||(0,S.onUnexpectedError)(R)})}}e.default=o}),define(pe[119],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var S;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(S||(e.EnvironmentVariableMutatorType=S={}))}),define(pe[120],be([1,0,3,119]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const o=new Map([[L.EnvironmentVariableMutatorType.Append,"APPEND"],[L.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[L.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class A{constructor(T){this.collections=T,this.a=new Map,this.b=new Map,T.forEach((y,v)=>{this.d(y,v);const h=y.map.entries();let g=h.next();for(;!g.done;){const p=g.value[1],r=g.value[0];let f=this.a.get(r);if(f||(f=[],this.a.set(r,f)),f.length>0&&f[0].type===L.EnvironmentVariableMutatorType.Replace){g=h.next();continue}const c={extensionIdentifier:v,value:p.value,type:p.type,scope:p.scope,variable:p.variable,options:p.options};c.scope||delete c.scope,f.unshift(c),g=h.next()}})}async applyToProcessEnvironment(T,y,v){let h;S.isWindows&&(h={},Object.keys(T).forEach(g=>h[g.toLowerCase()]=g));for(const[g,p]of this.getVariableMap(y)){const r=S.isWindows&&h[g.toLowerCase()]||g;for(const f of p){const c=v?await v(f.value):f.value;if(f.options?.applyAtProcessCreation??!0)switch(f.type){case L.EnvironmentVariableMutatorType.Append:T[r]=(T[r]||"")+c;break;case L.EnvironmentVariableMutatorType.Prepend:T[r]=c+(T[r]||"");break;case L.EnvironmentVariableMutatorType.Replace:T[r]=c;break}if(f.options?.applyAtShellIntegration??!1){const u=`VSCODE_ENV_${o.get(f.type)}`;T[u]=(T[u]?T[u]+":":"")+g+"="+this.c(c)}}}}c(T){return T.replaceAll(":","\\x3a")}diff(T,y){const v=new Map,h=new Map,g=new Map;if(T.getVariableMap(y).forEach((p,r)=>{const f=this.getVariableMap(y).get(r),c=R(p,f);c&&v.set(r,c)}),this.getVariableMap(y).forEach((p,r)=>{const f=T.getVariableMap(y).get(r),c=R(p,f);c&&g.set(r,c)}),this.getVariableMap(y).forEach((p,r)=>{const f=T.getVariableMap(y).get(r),c=b(p,f);c&&h.set(r,c)}),!(v.size===0&&h.size===0&&g.size===0))return{added:v,changed:h,removed:g}}getVariableMap(T){const y=new Map;return this.a.forEach((v,h)=>{const g=v.filter(p=>k(p,T));g.length>0&&y.set(g[0].variable,g)}),y}getDescriptionMap(T){const y=new Map;return this.b.forEach((v,h)=>{const g=v.filter(p=>k(p,T,!0));g.length>0&&y.set(g[0].extensionIdentifier,g[0].description)}),y}d(T,y){if(!T.descriptionMap)return;const v=T.descriptionMap.entries();let h=v.next();for(;!h.done;){const g=h.value[1],p=h.value[0];let r=this.b.get(p);r||(r=[],this.b.set(p,r));const f={extensionIdentifier:y,scope:g.scope,description:g.description};f.scope||delete f.scope,r.push(f),h=v.next()}}}e.MergedEnvironmentVariableCollection=A;function k(m,T,y=!1){return m.scope?!!(m.scope.workspaceFolder&&T?.workspaceFolder&&m.scope.workspaceFolder.index===T.workspaceFolder.index):y?T===m.scope:!0}function R(m,T){if(!T)return m;const y=new Set;T.forEach(h=>y.add(h.extensionIdentifier));const v=[];return m.forEach(h=>{y.has(h.extensionIdentifier)||v.push(h)}),v.length===0?void 0:v}function b(m,T){if(!T)return;const y=new Map;T.forEach(h=>y.set(h.extensionIdentifier,h));const v=[];return m.forEach(h=>{const g=y.get(h.extensionIdentifier);g&&(h.type!==g.type||h.value!==g.value||h.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index)&&v.push(g)}),v.length===0?void 0:v}}),define(pe[86],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function S(b){return[...b.entries()]}e.serializeEnvironmentVariableCollection=S;function L(b){return b?[...b.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function o(b){return new Map(b)}e.deserializeEnvironmentVariableCollection=o;function A(b){return new Map(b??[])}e.deserializeEnvironmentDescriptionMap=A;function k(b){return Array.from(b.entries()).map(m=>[m[0],S(m[1].map),L(m[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=k;function R(b){return new Map(b.map(m=>[m[0],{map:o(m[1]),descriptionMap:A(m[2])}]))}e.deserializeEnvironmentVariableCollections=R}),define(pe[247],be([1,0,14,20,6,2,12]),function(le,e,S,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=e.RequestStore=class extends A.Disposable{constructor(m,T){super(),this.h=T,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new o.Emitter),this.onCreateRequest=this.g.event,this.b=m===void 0?15e3:m}createRequest(m){return new Promise((T,y)=>{const v=++this.a;this.c.set(v,T),this.g.fire({requestId:v,...m});const h=new L.CancellationTokenSource;(0,S.timeout)(this.b,h.token).then(()=>y(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,A.toDisposable)(()=>h.cancel())])})}acceptReply(m,T){const y=this.c.get(m);y?(this.c.delete(m),(0,A.dispose)(this.f.get(m)||[]),this.f.delete(m),y(T)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${m}`)}};e.RequestStore=R=Le([Ae(1,k.ILogService)],R)}),define(pe[121],be([1,0,5,64]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusContextKey=void 0,e.terminalTabFocusContextKey=new L.RawContextKey("terminalTabFocusMode",!1,!0);var o;(function(u){u.Shell="terminal.integrated.shell.",u.ShellArgs="terminal.integrated.shellArgs.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(o||(e.TerminalSettingPrefix=o={}));var A;(function(u){u.ShellLinux="terminal.integrated.shell.linux",u.ShellMacOs="terminal.integrated.shell.osx",u.ShellWindows="terminal.integrated.shell.windows",u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationShellLinux="terminal.integrated.automationShell.linux",u.AutomationShellMacOs="terminal.integrated.automationShell.osx",u.AutomationShellWindows="terminal.integrated.automationShell.windows",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ShellArgsLinux="terminal.integrated.shellArgs.linux",u.ShellArgsMacOs="terminal.integrated.shellArgs.osx",u.ShellArgsWindows="terminal.integrated.shellArgs.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.TabStopWidth="terminal.integrated.tabStopWidth",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.TabFocusMode="terminal.integrated.tabFocusMode",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",u.ExperimentalImageSupport="terminal.integrated.experimentalImageSupport",u.SmoothScrolling="terminal.integrated.smoothScrolling"})(A||(e.TerminalSettingId=A={}));var k;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(k||(e.PosixShellType=k={}));var R;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(R||(e.WindowsShellType=R={}));var b;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(b||(e.TitleEventSource=b={}));var m;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.PtyHostWindow="ptyHostWindow",u.Logger="logger",u.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={})),e.IPtyService=(0,S.createDecorator)("ptyService");var T;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(T||(e.ProcessPropertyType=T={}));var y;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var v;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(v||(e.TerminalLocation=v={}));var h;(function(u){u.TerminalView="view",u.Editor="editor"})(h||(e.TerminalLocationString=h={}));var g;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(g||(e.LocalReconnectConstants=g={}));var p;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var r;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(r||(e.ProfileSource=r={}));var f;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var c;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(c||(e.TerminalExitReason=c={})),e.ILocalPtyService=(0,S.createDecorator)("localPtyService")}),define(pe[248],be([1,0,3]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeCwd=e.collapseTildePath=e.escapeNonWindowsPath=void 0;function L(k){let R=k;R.includes("\\")&&(R=R.replace(/\\/g,"\\\\"));const b=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return R=R.replace(b,""),`'${R}'`}e.escapeNonWindowsPath=L;function o(k,R,b){if(!k)return"";if(!R)return k;R.match(/[\/\\]$/)&&(R=R.slice(0,R.length-1));const m=k.replace(/\\/g,"/").toLowerCase(),T=R.replace(/\\/g,"/").toLowerCase();return m.includes(T)?`~${b}${k.slice(R.length+1)}`:k}e.collapseTildePath=o;function A(k){return k.match(/^['"].*['"]$/)&&(k=k.substring(1,k.length-1)),S.OS===1&&k&&k[1]===":"?k[0].toUpperCase()+k.substring(1):k}e.sanitizeCwd=A}),define(pe[249],be([1,0,48,4,191,96]),function(le,e,S,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function k(v,h){const g=[{name:null,description:(0,o.localize)(0,null)}];return g.push(...v.map(p=>({name:p.profileName,description:R(p)}))),h&&g.push(...h.map(p=>({name:p.title,description:b(p)}))),{values:g.map(p=>p.name),markdownDescriptions:g.map(p=>p.description)}}e.createProfileSchemaEnums=k;function R(v){let h=`$(${A.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:S.Codicon.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?h+=`
- args: "${v.args}"`:h+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(h+=`
- overrideName: ${v.overrideName}`),v.color&&(h+=`
- color: ${v.color}`),v.env&&(h+=`
- env: ${JSON.stringify(v.env)}`),h}function b(v){return`$(${A.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:S.Codicon.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function m(v,h){if(!v&&!h)return!0;if(typeof v=="string"&&typeof h=="string")return v===h;if(Array.isArray(v)&&Array.isArray(h)){if(v.length!==h.length)return!1;for(let g=0;g<v.length;g++)if(v[g]!==h[g])return!1;return!0}return!1}e.terminalProfileArgsMatch=m;function T(v,h){if(!v&&!h)return!0;if(!v||!h)return!1;if(A.ThemeIcon.isThemeIcon(v)&&A.ThemeIcon.isThemeIcon(h))return v.id===h.id&&v.color===h.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof h=="object"&&"light"in h&&"dark"in h){const g=v,p=h;if((L.URI.isUri(g.light)||y(g.light))&&(L.URI.isUri(g.dark)||y(g.dark))&&(L.URI.isUri(p.light)||y(p.light))&&(L.URI.isUri(p.dark)||y(p.dark)))return g.light.path===p.light.path&&g.dark.path===p.dark.path}if(L.URI.isUri(v)&&L.URI.isUri(h)||y(v)||y(h)){const g=v,p=h;return g.path===p.path&&g.scheme===p.scheme}return!1}e.terminalIconsEqual=T;function y(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.isUriComponents=y}),define(pe[250],be([1,0,48,3,190,55,40,249]),function(le,e,S,L,o,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,S.getAllCodicons)(),t=>t.id),markdownEnumDescriptions:Array.from((0,S.getAllCodicons)(),t=>`$(${t.id})`)};const b={args:{description:(0,o.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,o.localize)(1,null),type:"boolean"},icon:{description:(0,o.localize)(2,null),...e.terminalIconSchema},color:{description:(0,o.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,o.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,o.localize)(5,null),type:["string","array"],items:{type:"string"}},...b}},T={type:"object",required:["path"],properties:{path:{description:(0,o.localize)(6,null),type:["string"],items:{type:"string"}},...b}};function y(t){const n=t===2?"linux":t===1?"osx":"windows";return(0,o.localize)(7,null,(0,L.PlatformToString)(t),'```json\n"terminal.integrated.profile.'+n+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v=(0,o.localize)(8,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),h=(0,o.localize)(9,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),g=(0,o.localize)(10,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,o.localize)(11,null,"`#terminal.integrated.automationProfile.linux#`"),r=(0,o.localize)(12,null,"`#terminal.integrated.automationProfile.osx#`"),f=(0,o.localize)(13,null,"`#terminal.integrated.automationProfile.windows#`"),c={id:"terminal",order:100,title:(0,o.localize)(14,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,o.localize)(15,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,o.localize)(16,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:r},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,o.localize)(17,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,o.localize)(18,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},T],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,o.localize)(19,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},T],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,o.localize)(20,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},T],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,o.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,o.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,o.localize)(23,null),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,o.localize)(24,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:v},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,o.localize)(25,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:h},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,o.localize)(26,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,o.localize)(27,null)}},{type:"string",markdownDescription:(0,o.localize)(28,null)}],default:[],markdownDeprecationMessage:g},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:y(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,o.localize)(29,null),enum:["PowerShell","Git Bash"]},...b}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,o.localize)(30,null),type:"string"},id:{description:(0,o.localize)(31,null),type:"string"},title:{description:(0,o.localize)(32,null),type:"string"},...b}},{type:"null"},m]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:y(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,o.localize)(33,null),type:"string"},id:{description:(0,o.localize)(34,null),type:"string"},title:{description:(0,o.localize)(35,null),type:"string"},...b}},{type:"null"},m]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:y(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,o.localize)(36,null),type:"string"},id:{description:(0,o.localize)(37,null),type:"string"},title:{description:(0,o.localize)(38,null),type:"string"},...b}},{type:"null"},m]}},["terminal.integrated.useWslProfiles"]:{description:(0,o.localize)(39,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,o.localize)(40,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,o.localize)(41,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,o.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,o.localize)(43,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){k.Registry.as(A.Extensions.Configuration).registerConfiguration(c),O()}e.registerTerminalPlatformConfiguration=u;let D;function O(t,n){const s=k.Registry.as(A.Extensions.Configuration);let i;t&&(i=(0,R.createProfileSchemaEnums)(t?.profiles,n));const a=D;D={id:"terminal",order:100,title:(0,o.localize)(44,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,o.localize)(45,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:t?.os===3?i?.values:void 0,markdownEnumDescriptions:t?.os===3?i?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,o.localize)(46,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:t?.os===2?i?.values:void 0,markdownEnumDescriptions:t?.os===2?i?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,o.localize)(47,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:t?.os===1?i?.values:void 0,markdownEnumDescriptions:t?.os===1?i?.markdownDescriptions:void 0}}},s.updateConfigurations({add:[D],remove:a?[a]:[]})}e.registerTerminalDefaultProfileConfiguration=O}),define(pe[251],be([1,0,2,13,105,25,106]),function(le,e,S,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodePtyHostStarter=void 0;let R=e.NodePtyHostStarter=class{constructor(m,T){this.a=m,this.b=T}start(m){const T={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.fsPath],env:{VSCODE_LAST_PTY_ID:m,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},y=(0,k.parsePtyHostDebugPort)(this.b.args,this.b.isBuilt);y&&(y.break&&y.port?T.debugBrk=y.port:!y.break&&y.port&&(T.debug=y.port));const v=new o.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,T),h=new S.DisposableStore;return h.add(v),{client:v,store:h,onDidProcessExit:v.onDidProcessExit}}};e.NodePtyHostStarter=R=Le([Ae(1,A.IEnvironmentService)],R)}),define(pe[252],be([1,0,28,13,21,7,3,29,17,8,23,119,86,120]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function g(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let a=0;return i&&i.length===4&&(a=parseInt(i[3])),a}e.getWindowsBuildNumber=g;async function p(i,a,l,d=R.env,I=T.Promises.exists){if(A.isAbsolute(i))return await I(i)?i:void 0;if(a===void 0&&(a=R.cwd()),A.dirname(i)!=="."){const N=A.join(a,i);return await I(N)?N:void 0}const E=(0,o.getCaseInsensitive)(d,"PATH");if(l===void 0&&(0,m.isString)(E)&&(l=E.split(A.delimiter)),l===void 0||l.length===0){const N=A.join(a,i);return await I(N)?N:void 0}for(const N of l){let $;if(A.isAbsolute(N)?$=A.join(N,i):$=A.join(a,N,i),await I($))return $;if(k.isWindows){let se=$+".com";if(await I(se)||(se=$+".exe",await I(se)))return se}}const w=A.join(a,i);return await I(w)?w:void 0}e.findExecutable=p;function r(i,a,l,d,I){const C=k.isWindows&&(!a.windowsEnableConpty||g()<18309);if(!a.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||C)return;const E=i.args,w=R.platform==="win32"?A.basename(i.executable).toLowerCase():A.basename(i.executable),N=A.dirname(L.FileAccess.asFileUri("").fsPath);let $;const se={VSCODE_INJECTION:"1"};if(a.shellIntegration.nonce&&(se.VSCODE_NONCE=a.shellIntegration.nonce),k.isWindows){if(w==="pwsh.exe"||w==="powershell.exe")return!E||n(E)?$=u.get(c.WindowsPwsh):t(E)&&($=u.get(c.WindowsPwshLogin)),$?($=[...$],$[$.length-1]=(0,b.format)($[$.length-1],N,""),{newArgs:$,envMixin:se}):void 0;d.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(w){case"bash":return!E||E.length===0?$=u.get(c.Bash):s(E)&&(se.VSCODE_SHELL_LOGIN="1",f(a,se),$=u.get(c.Bash)),$?($=[...$],$[$.length-1]=(0,b.format)($[$.length-1],N),{newArgs:$,envMixin:se}):void 0;case"fish":return;case"pwsh":return!E||n(E)?$=u.get(c.Pwsh):t(E)&&($=u.get(c.PwshLogin)),$?($=[...$],$[$.length-1]=(0,b.format)($[$.length-1],N,""),{newArgs:$,envMixin:se}):void 0;case"zsh":{if(!E||E.length===0?$=u.get(c.Zsh):s(E)?($=u.get(c.ZshLogin),f(a,se)):(E===u.get(c.Zsh)||E===u.get(c.ZshLogin))&&($=E),!$)return;$=[...$],$[$.length-1]=(0,b.format)($[$.length-1],N);let he;try{he=S.userInfo().username}catch{he="unknown"}const ae=A.join(S.tmpdir(),`${he}-${I.applicationName}-zsh`);se.ZDOTDIR=ae;const ue=l?.ZDOTDIR??S.homedir()??"~";se.USER_ZDOTDIR=ue;const ge=[];return ge.push({source:A.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(ae,".zshrc")}),ge.push({source:A.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(ae,".zprofile")}),ge.push({source:A.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(ae,".zshenv")}),ge.push({source:A.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(ae,".zlogin")}),{newArgs:$,envMixin:se,filesToCopy:ge}}}d.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=r;function f(i,a){if(k.isMacintosh&&i.environmentVariableCollections){const l=(0,v.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),I=new h.MergedEnvironmentVariableCollection(l).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),C=[];if(I)for(const E of I)E.type===y.EnvironmentVariableMutatorType.Prepend&&C.push(E.value);C.length>0&&(a.VSCODE_PATH_PREFIX=C.join(""))}}var c;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(c||(c={}));const u=new Map;u.set(c.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),u.set(c.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),u.set(c.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),u.set(c.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),u.set(c.Zsh,["-i"]),u.set(c.ZshLogin,["-il"]),u.set(c.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const D=["-login","-l"],O=["-nol","-nologo"];function t(i){return typeof i=="string"?D.includes(i.toLowerCase()):i.length===1&&D.includes(i[0].toLowerCase())||i.length===2&&(D.includes(i[0].toLowerCase())||D.includes(i[1].toLowerCase()))&&(O.includes(i[0].toLowerCase())||O.includes(i[1].toLowerCase()))}function n(i){return typeof i=="string"?O.includes(i.toLowerCase()):i.length===0||i?.length===1&&O.includes(i[0].toLowerCase())}function s(i){return i==="string"&&D.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&D.includes(i[0].toLowerCase())}}),define(pe[253],be([1,0,52,48,7,3,8,23,101,252,73]),function(le,e,S,L,o,A,k,R,b,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let y,v=!0;function h(i,a,l,d,I=process.env,C,E,w,N){return C=C||{existsFile:R.SymlinkSupport.existsFile,readFile:R.Promises.readFile},A.isWindows?g(l,C,I,E,d.getValue("terminal.integrated.useWslProfiles")!==!1,i&&typeof i=="object"?{...i}:d.getValue("terminal.integrated.profiles.windows"),typeof a=="string"?a:d.getValue("terminal.integrated.defaultProfile.windows"),N,w):t(C,E,l,i&&typeof i=="object"?{...i}:d.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof a=="string"?a:d.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),N,w,I)}e.detectAvailableProfiles=h;async function g(i,a,l,d,I,C,E,w,N){const $=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),se=`${process.env.windir}\\${$?"Sysnative":"System32"}`;let he=!1;(0,m.getWindowsBuildNumber)()>=16299&&(he=!0),await f(w);const ae=new Map;if(i){ae.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),ae.set("Windows PowerShell",{path:`${se}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),ae.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ae.set("Command Prompt",{path:`${se}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0}),ae.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ae.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:L.Codicon.terminalBash,isAutoDetected:!0});const ge=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ae.set("Cmder",{path:`${se}\\cmd.exe`,args:["/K",ge],requiresPath:process.env.CMDER_ROOT?ge:{path:ge,isUnsafe:!0},isAutoDetected:!0})}n(C,ae);const ue=await p(ae.entries(),E,a,l,d,N);if(i||I)try{const ge=await D(`${se}\\${he?"wsl":"bash"}.exe`,E);for(const _ of ge)(!C||!(_.profileName in C))&&ue.push(_)}catch{v&&(d?.info("WSL is not installed, so could not detect WSL profiles"),v=!1)}return ue}async function p(i,a,l,d=process.env,I,C){const E=[];for(const[w,N]of i){if(N===null)continue;let $,se,he;if("source"in N&&!("path"in N)){const _=y?.get(N.source);if(!_)continue;$=_.paths,se=N.args||_.args,N.icon?he=r(N.icon):_.icon&&(he=_.icon)}else $=Array.isArray(N.path)?N.path:[N.path],se=A.isWindows||Array.isArray(N.args)?N.args:void 0,he=r(N.icon);let ae;if(C){const _=$.map(V=>typeof V=="string"?V:V.path),ie=await C(_);ae=new Array($.length);for(let V=0;V<$.length;V++)typeof $[V]=="string"?ae[V]=ie[V]:ae[V]={path:ie[V],isUnsafe:!0}}else ae=$.slice();let ue;if(N.requiresPath){let _;if((0,k.isString)(N.requiresPath)?_=N.requiresPath:(_=N.requiresPath.path,N.requiresPath.isUnsafe&&(ue=_)),!await l.existsFile(_))continue}const ge=await s(w,a,ae,l,d,se,N.env,N.overrideName,N.isAutoDetected,ue);ge?(ge.isAutoDetected=N.isAutoDetected,ge.icon=he,ge.color=N.color,E.push(ge)):I?.debug("Terminal profile not validated",w,$)}return I?.debug("Validated terminal profiles",E),E}function r(i){return typeof i=="string"?{id:i}:i}async function f(i){if(y&&!i)return;const[a,l]=await Promise.all([c(),i||u()]);y=new Map,y.set("Git Bash",{profileName:"Git Bash",paths:a,args:["--login","-i"]}),y.set("PowerShell",{profileName:"PowerShell",paths:l,icon:L.Codicon.terminalPowershell})}async function c(){const i=new Set,a=await(0,m.findExecutable)("git.exe");if(a){const I=(0,T.dirname)(a);i.add((0,T.resolve)(I,"../.."))}function l(I,C){C&&I.add(C)}l(i,process.env.ProgramW6432),l(i,process.env.ProgramFiles),l(i,process.env["ProgramFiles(X86)"]),l(i,`${process.env.LocalAppData}\\Program`);const d=[];for(const I of i)d.push(`${I}\\Git\\bin\\bash.exe`,`${I}\\Git\\usr\\bin\\bash.exe`,`${I}\\usr\\bin\\bash.exe`);return d.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),d}async function u(){const i=[];for await(const a of(0,b.enumeratePowerShellInstallations)())i.push(a.exePath);return i}async function D(i,a){const l=[],d=await new Promise((E,w)=>{S.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(N,$)=>{if(N)return w("Problem occurred when getting wsl distros");E($)})});if(!d)return[];const I=new RegExp(/[\r?\n]/),C=d.split(I).filter(E=>E.trim().length>0&&E!=="");for(const E of C){if(E===""||E.startsWith("docker-desktop"))continue;const w=`${E} (WSL)`,N={profileName:w,path:i,args:["-d",`${E}`],isDefault:w===a,icon:O(E),isAutoDetected:!1};l.push(N)}return l}function O(i){return i.includes("Ubuntu")?L.Codicon.terminalUbuntu:i.includes("Debian")?L.Codicon.terminalDebian:L.Codicon.terminalLinux}async function t(i,a,l,d,I,C,E,w){const N=new Map;if(l){const $=(await i.readFile("/etc/shells")).toString(),se=C||$.split(`
`).filter(ae=>ae.trim().includes("#")&&ae.trim().length>0),he=new Map;for(const ae of se){let ue=(0,o.basename)(ae),ge=he.get(ue)||0;ge++,ge>1&&(ue=`${ue} (${ge})`),he.set(ue,ge),N.set(ue,{path:ae,isAutoDetected:!0})}}return n(d,N),await p(N.entries(),I,i,w,a,E)}function n(i,a){if(i)for(const[l,d]of Object.entries(i))d===null||typeof d!="object"||!("path"in d)&&!("source"in d)?a.delete(l):(d.icon=d.icon||a.get(l)?.icon,a.set(l,d))}async function s(i,a,l,d,I,C,E,w,N,$){if(l.length===0)return Promise.resolve(void 0);const se=l.shift();if(se==="")return s(i,a,l,d,I,C,E,w,N);const he=typeof se!="string"&&se.isUnsafe,ae=typeof se=="string"?se:se.path,ue={profileName:i,path:ae,args:C,env:E,overrideName:w,isAutoDetected:N,isDefault:i===a,isUnsafePath:he,requiresUnsafePath:$};if((0,o.basename)(ae)===ae){const _=I.PATH?I.PATH.split(o.delimiter):void 0,ie=await(0,m.findExecutable)(ae,void 0,_,void 0,d.existsFile);return ie?(ue.path=ie,ue.isFromPath=!0,ue):s(i,a,l,d,I,C)}return await d.existsFile((0,o.normalize)(ae))?ue:s(i,a,l,d,I,C,E,w,N)}}),define(pe[254],be([1,0,6,2,3,42,24,12,110,84,247,121,250,253]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let p=0,r=e.PtyHostService=class extends L.Disposable{get c(){return this.g(),this.a}get f(){return this.g(),this.b}g(){this.a||([this.a,this.b]=this.O())}constructor(c,u,D,O){super(),this.G=c,this.H=u,this.I=D,this.J=O,this.i=!1,this.j=0,this.k=!0,this.l=!1,this.p=this.B(new S.Emitter),this.onPtyHostExit=this.p.event,this.r=this.B(new S.Emitter),this.onPtyHostStart=this.r.event,this.s=this.B(new S.Emitter),this.onPtyHostUnresponsive=this.s.event,this.t=this.B(new S.Emitter),this.onPtyHostResponsive=this.t.event,this.u=this.B(new S.Emitter),this.onPtyHostRequestResolveVariables=this.u.event,this.v=this.B(new S.Emitter),this.onProcessData=this.v.event,this.w=this.B(new S.Emitter),this.onProcessReady=this.w.event,this.y=this.B(new S.Emitter),this.onProcessReplay=this.y.event,this.z=this.B(new S.Emitter),this.onProcessOrphanQuestion=this.z.event,this.C=this.B(new S.Emitter),this.onDidRequestDetach=this.C.event,this.D=this.B(new S.Emitter),this.onDidChangeProperty=this.D.event,this.F=this.B(new S.Emitter),this.onProcessExit=this.F.event,(0,v.registerTerminalPlatformConfiguration)(),this.B((0,L.toDisposable)(()=>this.P())),this.h=this.B(new T.RequestStore(void 0,this.I)),this.h.onCreateRequest(this.u.fire,this.u),this.G.onBeforeWindowConnection?S.Event.once(this.G.onBeforeWindowConnection)(()=>this.g()):this.g(),this.G.onWillShutdown?.(()=>this.i=!0)}get L(){return this.H.getValue("terminal.integrated.ignoreProcessNames")}async M(){return this.f.refreshIgnoreProcessNames?.(this.L)}async N(){if(o.isWindows)return process.env;try{return await(0,m.getResolvedShellEnv)(this.H,this.I,{_:[]},process.env)}catch(c){return this.I.error("ptyHost was unable to resolve shell environment",c),{}}}O(){const c=this.G.start(p),u=c.client;this.r.fire(),A.ProxyChannel.toService(u.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.Q()),this.Q(),this.B(c.onDidProcessExit(t=>{this.p.fire(t.code),!this.i&&!this.l&&(this.j<=g.MaxRestarts?(this.I.error(`ptyHost terminated unexpectedly with code ${t.code}`),this.j++,this.restartPtyHost()):this.I.error(`ptyHost terminated unexpectedly with code ${t.code}, giving up`))}));const O=A.ProxyChannel.toService(u.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(O.onProcessData(t=>this.v.fire(t))),this.B(O.onProcessReady(t=>this.w.fire(t))),this.B(O.onProcessExit(t=>this.F.fire(t))),this.B(O.onDidChangeProperty(t=>this.D.fire(t))),this.B(O.onProcessReplay(t=>this.y.fire(t))),this.B(O.onProcessOrphanQuestion(t=>this.z.fire(t))),this.B(O.onDidRequestDetach(t=>this.C.fire(t))),S.Event.once(S.Event.any(O.onProcessReady,O.onProcessReplay))(()=>{this.B(new b.RemoteLoggerChannelClient(this.J,u.getChannel(y.TerminalIpcChannels.Logger)))}),this.a=c,this.b=O,this.B(this.H.onDidChangeConfiguration(async t=>{t.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.M()})),this.M(),[c,O]}dispose(){this.l=!0,super.dispose()}async createProcess(c,u,D,O,t,n,s,i,a,l,d){const I=setTimeout(()=>this.U(),y.HeartbeatConstants.CreateProcessTimeout),C=await this.f.createProcess(c,u,D,O,t,n,s,i,a,l,d);return clearTimeout(I),p=Math.max(p,C),C}updateTitle(c,u,D){return this.f.updateTitle(c,u,D)}updateIcon(c,u,D,O){return this.f.updateIcon(c,u,D,O)}attachToProcess(c){return this.f.attachToProcess(c)}detachFromProcess(c,u){return this.f.detachFromProcess(c,u)}listProcesses(){return this.f.listProcesses()}reduceConnectionGraceTime(){return this.f.reduceConnectionGraceTime()}start(c){return this.f.start(c)}shutdown(c,u){return this.f.shutdown(c,u)}input(c,u){return this.f.input(c,u)}processBinary(c,u){return this.f.processBinary(c,u)}resize(c,u,D){return this.f.resize(c,u,D)}acknowledgeDataEvent(c,u){return this.f.acknowledgeDataEvent(c,u)}setUnicodeVersion(c,u){return this.f.setUnicodeVersion(c,u)}getInitialCwd(c){return this.f.getInitialCwd(c)}getCwd(c){return this.f.getCwd(c)}getLatency(c){return this.f.getLatency(c)}orphanQuestionReply(c){return this.f.orphanQuestionReply(c)}installAutoReply(c,u){return this.f.installAutoReply(c,u)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(c){return this.f.uninstallAutoReply(c)}getDefaultSystemShell(c){return this.f.getDefaultSystemShell(c)}async getProfiles(c,u,D,O=!1){const t=await this.N();return(0,h.detectAvailableProfiles)(u,D,O,this.H,t,void 0,this.I,this.X.bind(this,c))}getEnvironment(){return this.f.getEnvironment()}getWslPath(c,u){return this.f.getWslPath(c,u)}getRevivedPtyNewId(c){return this.f.getRevivedPtyNewId(c)}setTerminalLayoutInfo(c){return this.f.setTerminalLayoutInfo(c)}async getTerminalLayoutInfo(c){return await this.f.getTerminalLayoutInfo(c)}async requestDetachInstance(c,u){return this.f.requestDetachInstance(c,u)}async acceptDetachInstanceReply(c,u){return this.f.acceptDetachInstanceReply(c,u)}async freePortKillProcess(c){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(c)}async serializeTerminalState(c){return this.f.serializeTerminalState(c)}async reviveTerminalProcesses(c,u){return this.f.reviveTerminalProcesses(c,u)}async refreshProperty(c,u){return this.f.refreshProperty(c,u)}async updateProperty(c,u,D){return this.f.updateProperty(c,u,D)}async restartPtyHost(){this.P(),this.k=!0,this.O()}P(){this.f.shutdownAll?.(),this.c.store.dispose()}Q(){this.W(),this.m=setTimeout(()=>this.R(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.k||(this.k=!0,this.t.fire())}R(){this.I.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.m=void 0,this.n=setTimeout(()=>this.S(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}S(){this.I.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.n=void 0,this.k&&(this.k=!1,this.s.fire())}U(){this.W(),this.I.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.k&&(this.k=!1,this.s.fire())}W(){this.m&&(clearTimeout(this.m),this.m=void 0),this.n&&(clearTimeout(this.n),this.n=void 0)}X(c,u){return this.h.createRequest({workspaceId:c,originalText:u})}async acceptPtyHostResolvedVariables(c,u){this.h.acceptReply(c,u)}};e.PtyHostService=r=Le([Ae(1,k.IConfigurationService),Ae(2,R.ILogService),Ae(3,R.ILoggerService)],r)}),define(pe[36],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,S.createDecorator)("IUriIdentityService")}),define(pe[122],be([1,0,36,209,16,19,143,6,2]),function(le,e,S,L,o,A,k,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(v){this.uri=v,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let T=e.UriIdentityService=class{constructor(v){this.g=v,this.c=new b.DisposableStore,this.f=2**16;const h=new Map,g=p=>{let r=h.get(p.scheme);return r===void 0&&(r=v.hasProvider(p)&&!this.g.hasCapability(p,1024),h.set(p.scheme,r)),r};this.c.add(R.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(p=>{h.delete(p.scheme)})),this.extUri=new A.ExtUri(g),this.d=new k.SkipList((p,r)=>this.extUri.compare(p,r,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,A.normalizePath)(v));const h=this.d.get(v);return h?h.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new m(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((g,p)=>g[1].time<p[1].time?1:g[1].time>p[1].time?-1:0);m._clock=0,this.d.clear();const h=this.f*.5;for(let g=0;g<h;g++)this.d.set(v[g][0],v[g][1].touch())}};e.UriIdentityService=T=Le([Ae(0,o.IFileService)],T),(0,L.registerSingleton)(S.IUriIdentityService,T,1)}),define(pe[87],be([1,0,193,7,61,19,4,5,13]),function(le,e,S,L,o,A,k,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function m(i){const a=i;return typeof a?.id=="string"&&k.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=m;function T(i){return typeof i?.id=="string"&&!m(i)&&!v(i)}e.isEmptyWorkspaceIdentifier=T,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(i,a){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.basename)(i)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.toWorkspaceIdentifier=y;function v(i){const a=i;return typeof a?.id=="string"&&k.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=v;function h(i){const a=i;if(a?.uri)return{id:a.id,uri:k.URI.revive(a.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:k.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=h;var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function p(i){const a=i;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=p;function r(i){const a=i;return!!(a&&typeof a=="object"&&k.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=r;class f{constructor(a,l,d,I,C){this.h=a,this.j=d,this.k=I,this.l=C,this.c=o.TernarySearchTree.forUris(this.l,()=>!0),this.folders=l}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=o.TernarySearchTree.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class c{constructor(a,l){this.raw=l,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,A.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=c;function u(i){return new c({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=u,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(i,a){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,a.untitledWorkspacesHome)}e.isUntitledWorkspace=D;function O(i){let a;return k.URI.isUri(i)?a=i:a=i.configuration,a?.scheme===b.Schemas.tmp}e.isTemporaryWorkspace=O,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function n(i,a){return!D(i,a)&&!O(i)}e.isSavedWorkspace=n;function s(i){return(typeof i=="string"?(0,L.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(pe[32],be([1,0,75,6,2,19,4,192,25,16,5,12,87,27,36,14,22,17,8]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function u(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&k.URI.isUri(i.location)&&k.URI.isUri(i.globalStorageHome)&&k.URI.isUri(i.settingsResource)&&k.URI.isUri(i.keybindingsResource)&&k.URI.isUri(i.tasksResource)&&k.URI.isUri(i.snippetsHome)&&k.URI.isUri(i.extensionsResource))}e.isUserDataProfile=u,e.IUserDataProfilesService=(0,T.createDecorator)("IUserDataProfilesService");function D(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,location:k.URI.revive(s.location).with({scheme:i}),globalStorageHome:k.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:k.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:k.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:k.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:k.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:k.URI.revive(s.extensionsResource).with({scheme:i}),cacheHome:k.URI.revive(s.cacheHome).with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.reviveProfile=D;function O(s,i,a,l,d){return{id:s,name:i,location:a,isDefault:!1,shortName:d?.shortName,globalStorageHome:(0,A.joinPath)(a,"globalStorage"),settingsResource:(0,A.joinPath)(a,"settings.json"),keybindingsResource:(0,A.joinPath)(a,"keybindings.json"),tasksResource:(0,A.joinPath)(a,"tasks.json"),snippetsHome:(0,A.joinPath)(a,"snippets"),extensionsResource:(0,A.joinPath)(a,"extensions.json"),cacheHome:(0,A.joinPath)(l,s),useDefaultFlags:d?.useDefaultFlags,isTransient:d?.transient}}e.toUserDataProfile=O;let t=e.UserDataProfilesService=class extends o.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,a,l,d){super(),this.n=i,this.r=a,this.s=l,this.t=d,this.f=!0,this.h=this.B(new L.Emitter),this.onDidChangeProfiles=this.h.event,this.i=this.B(new L.Emitter),this.onWillCreateProfile=this.i.event,this.j=this.B(new L.Emitter),this.onWillRemoveProfile=this.j.event,this.k=this.B(new L.Emitter),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new h.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.n.userRoamingDataHome,"profiles"),this.g=(0,A.joinPath)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=[];if(this.f)try{for(const I of this.J()){if(!I.name||!(0,c.isString)(I.name)||!I.location){this.t.warn("Skipping the invalid stored profile",I.location||I.name);continue}i.push(O((0,A.basename)(I.location),I.name,I.location,this.g,{shortName:I.shortName,useDefaultFlags:I.useDefaultFlags}))}}catch(I){this.t.error(I)}const a=new h.ResourceMap,l=new Map,d=this.w();if(i.unshift({...d,extensionsResource:this.O()??d.extensionsResource,isDefault:!0}),i.length)try{const I=this.M();if(I.workspaces)for(const[C,E]of Object.entries(I.workspaces)){const w=k.URI.parse(C),N=i.find($=>$.id===E);N&&a.set(w,N)}if(I.emptyWindows)for(const[C,E]of Object.entries(I.emptyWindows)){const w=i.find(N=>N.id===E);w&&l.set(C,w)}}catch(I){this.t.error(I)}this.u={profiles:i,workspaces:a,emptyWindows:l}}return this.u}w(){return O("__default__profile__",(0,R.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(i){const a="Temp",l=new RegExp(`${(0,f.escapeRegExpCharacters)(a)}\\s(\\d+)`);let d=0;for(const C of this.profiles){const E=l.exec(C.name),w=E?parseInt(E[1]):0;d=w>d?w:d}const I=`${a} ${d+1}`;return this.createProfile((0,S.hash)((0,r.generateUuid)()).toString(16),I,{transient:!0},i)}async createNamedProfile(i,a,l){return this.createProfile((0,S.hash)((0,r.generateUuid)()).toString(16),i,a,l)}async createProfile(i,a,l,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.y(i,a,l);return d&&await this.setProfileForWorkspace(d,I),I}async y(i,a,l){if(!(0,c.isString)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let d=this.l.get(a);return d||(d=(async()=>{try{const I=this.profiles.find(w=>w.name===a||w.id===i);if(I)return I;const C=O(i,a,(0,A.joinPath)(this.profilesHome,i),this.g,l);await this.r.createFolder(C.location);const E=[];return this.i.fire({profile:C,join(w){E.push(w)}}),await p.Promises.settled(E),this.D([C],[],[]),C}finally{this.l.delete(a)}})(),this.l.set(a,d)),d}async updateProfile(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(d=>d.id===i.id);if(!l)throw new Error(`Profile '${i.name}' does not exist`);return l=O(l.id,a.name??l.name,l.location,this.g,{shortName:a.shortName??l.shortName,transient:a.transient??l.isTransient,useDefaultFlags:a.useDefaultFlags??l.useDefaultFlags}),this.D([],[],[l]),l}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(d=>d.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);const l=[];this.j.fire({profile:a,join(d){l.push(d)}});try{await Promise.allSettled(l)}catch(d){this.t.error(d)}for(const d of[...this.v.emptyWindows.keys()])a.id===this.v.emptyWindows.get(d)?.id&&this.v.emptyWindows.delete(d);for(const d of[...this.v.workspaces.keys()])a.id===this.v.workspaces.get(d)?.id&&this.v.workspaces.delete(d);this.H(),this.D([],[a],[]);try{await this.r.del(a.cacheHome,{recursive:!0})}catch(d){(0,m.toFileOperationResult)(d)!==1&&this.t.error(d)}try{this.profiles.length===1?await this.r.del(this.profilesHome,{recursive:!0}):await this.r.del(a.location,{recursive:!0})}catch(d){this.t.error(d)}}async setProfileForWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(d=>d.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);this.G(i,l)}unsetWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,a)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(a=>a.isDirectory&&this.profiles.every(l=>!this.s.extUri.isEqual(l.location,a.resource))).map(a=>this.r.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(a=>!this.C(a));await Promise.allSettled(i.map(a=>this.removeProfile(a)))}getProfileForWorkspace(i){const a=this.z(i);return k.URI.isUri(a)?this.m.workspaces.get(a)??this.v.workspaces.get(a):this.m.emptyWindows.get(a)??this.v.emptyWindows.get(a)}z(i){return(0,v.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,v.isWorkspaceIdentifier)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.m.workspaces.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.v.emptyWindows.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.v.workspaces.values()].some(a=>this.s.extUri.isEqual(a.location,i.location)))}D(i,a,l){const d=[...this.profiles,...i],I=[];this.m.profiles=[];for(let C of d)C.isDefault||a.some(E=>C.id===E.id)||(C=l.find(E=>C.id===E.id)??C,C.isTransient?this.m.profiles.push(C):I.push({location:C.location,name:C.name,shortName:C.shortName,useDefaultFlags:C.useDefaultFlags}));this.L(I),this.u=void 0,this.F(i,a,l)}F(i,a,l){this.h.fire({added:i,removed:a,updated:l,all:this.profiles})}G(i,a,l){l=a?.isTransient?!0:l,l||this.G(i,void 0,!0);const d=this.z(i),I=l?this.m:this.v;k.URI.isUri(d)?(I.workspaces.delete(d),a&&I.workspaces.set(d,a)):(I.emptyWindows.delete(d),a&&I.emptyWindows.set(d,a)),l||this.H()}H(){const i={};for(const[l,d]of this.v.workspaces.entries())i[l.toString()]=d.id;const a={};for(const[l,d]of this.v.emptyWindows.entries())a[l.toString()]=d.id;this.N({workspaces:i,emptyWindows:a}),this.u=void 0}I(i){const a={},l=this.w();if(i.workspaces)for(const[I,C]of Object.entries(i.workspaces)){const E=k.URI.parse(C);a[I]=this.s.extUri.isEqual(E,l.location)?l.id:this.s.extUri.basename(E)}const d={};if(i.emptyWindows)for(const[I,C]of Object.entries(i.emptyWindows)){const E=k.URI.parse(C);d[I]=this.s.extUri.isEqual(E,l.location)?l.id:this.s.extUri.basename(E)}return{workspaces:a,emptyWindows:d}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};t.b="userDataProfiles",t.c="profileAssociations",e.UserDataProfilesService=t=Le([Ae(0,b.IEnvironmentService),Ae(1,m.IFileService),Ae(2,g.IUriIdentityService),Ae(3,y.ILogService)],t);class n extends t{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.InMemoryUserDataProfilesService=n}),define(pe[255],be([1,0,18,14,20,11,6,2,3,8,4,173,30,35,34,12,26,31,32]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=void 0;let u=e.AbstractExtensionManagementService=class extends R.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,a,l,d,I){super(),this.t=i,this.u=a,this.v=l,this.w=d,this.y=I,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new k.Emitter),this.m=this.B(new k.Emitter),this.n=this.B(new k.Emitter),this.p=this.B(new k.Emitter),this.s=[],this.B((0,R.toDisposable)(()=>{this.j.forEach(({task:C})=>C.cancel()),this.k.forEach(C=>C.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const a=await this.getTargetPlatform();return i.allTargetPlatforms.some(l=>(0,v.isTargetPlatformCompatible)(l,i.allTargetPlatforms,a))}async installFromGallery(i,a={}){try{if(!this.t.isEnabled())throw new v.ExtensionManagementError(y.localize(0,null),v.ExtensionManagementErrorCode.Internal);const l=await this.G(i,!!a.installGivenVersion,!!a.installPreReleaseVersion);return await this.z(l.manifest,l.extension,a)}catch(l){throw t(this.u,"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(i),error:l}),this.v.error("Failed to install extension.",i.identifier.id),this.v.error(l),O(l)}}async uninstall(i,a={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,a)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i,a,l){const d=l.isApplicationScoped||l.isBuiltin||(0,g.isApplicationScopedExtension)(i),I={...l,installOnlyNewlyAddedFromExtensionPack:T.URI.isUri(a)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:d,profileLocation:d?this.y.defaultProfile.extensionsResource:l.profileLocation??this.P()},C=he=>`${h.ExtensionKey.create(he).toString()}${I.profileLocation?`-${I.profileLocation.toString()}`:""}`;if(!T.URI.isUri(a)){const he=this.j.get(C(a));if(he)return this.v.info("Extensions is already requested to install",a.identifier.id),he.task.waitUntilTaskIsFinished()}const E=[],w=[],N=[],$=this.Q(i,a,I);T.URI.isUri(a)||this.j.set(C(a),{task:$,waitingTasks:[]}),this.l.fire({identifier:$.identifier,source:a,profileLocation:I.profileLocation}),this.v.info("Installing extension:",$.identifier.id),E.push({task:$,manifest:i});let se=!1;try{if(I.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",$.identifier.id);else try{const ae=await this.F($.identifier,i,!!I.installOnlyNewlyAddedFromExtensionPack,!!I.installPreReleaseVersion,I.profileLocation),ue=await this.getInstalled(void 0,I.profileLocation);for(const{gallery:ge,manifest:_}of(0,S.distinct)(ae,({gallery:ie})=>ie.identifier.id)){se=se||!!_.extensionDependencies?.some(J=>(0,h.areSameExtensions)({id:J},$.identifier));const ie=C(ge),V=this.j.get(ie);if(V){if(this.C($,V.task)){const J=V.task.identifier;this.v.info("Waiting for already requested installing extension",J.id,$.identifier.id),V.waitingTasks.push($),w.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,U=>U.some(ne=>(0,h.areSameExtensions)(ne.identifier,J)))).then(U=>{if(this.v.info("Finished waiting for already requested installing extension",J.id,$.identifier.id),!U.find(x=>(0,h.areSameExtensions)(x.identifier,J))?.local)throw new Error(`Extension ${J.id} is not installed`)}))}}else if(!ue.some(({identifier:J})=>(0,h.areSameExtensions)(J,ge.identifier))){const J=this.Q(_,ge,{...I,donotIncludePackAndDependencies:!0});this.j.set(ie,{task:J,waitingTasks:[$]}),this.l.fire({identifier:J.identifier,source:ge,profileLocation:I.profileLocation}),this.v.info("Installing extension:",J.identifier.id,$.identifier.id),E.push({task:J,manifest:_})}}}catch(ae){if(T.URI.isUri($.source))(0,S.isNonEmptyArray)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",$.identifier.id,ae.message),(0,S.isNonEmptyArray)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",$.identifier.id,ae.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",$.identifier.id),ae}const he=E.reduce((ae,{task:ue,manifest:ge})=>(ae.set(ue.identifier.id.toLowerCase(),{task:ue,manifest:ge}),ae),new Map);for(;he.size;){let ae;const ue=[...he.values()].filter(({manifest:ge})=>!ge.extensionDependencies?.some(_=>he.has(_.toLowerCase())));ue.length?ae=he.size===1?ue:ue.filter(({task:ge})=>!(ge===$&&!se)):(this.v.info("Found extensions with circular dependencies",ue.map(({task:ge})=>ge.identifier.id)),ae=[...he.values()]),await this.D(ae.map(async({task:ge})=>{const _=new Date().getTime();try{const ie=await ge.run();if(await this.D(this.s.map(V=>V.postInstall(ie,ge.source,I,o.CancellationToken.None))),!T.URI.isUri(ge.source)){const V=ge.operation===3,J=V?void 0:(new Date().getTime()-ge.source.lastUpdated)/1e3;if(t(this.u,V?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(ge.source),verificationStatus:ge.verificationStatus,duration:new Date().getTime()-_,durationSinceUpdate:J}),b.isWeb&&ge.operation!==3)try{await this.t.reportStatistic(ie.manifest.publisher,ie.manifest.name,ie.manifest.version,"install")}catch{}}N.push({local:ie,identifier:ge.identifier,operation:ge.operation,source:ge.source,context:I.context,profileLocation:ge.profileLocation,applicationScoped:ie.isApplicationScoped})}catch(ie){throw T.URI.isUri(ge.source)||t(this.u,ge.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(ge.source),verificationStatus:ge.verificationStatus,duration:new Date().getTime()-_,error:ie}),this.v.error("Error while installing the extension:",ge.identifier.id),ie}finally{he.delete(ge.identifier.id.toLowerCase())}}))}return w.length&&await this.D(w),N.forEach(({identifier:ae})=>this.v.info("Extension installed successfully:",ae.id)),this.m.fire(N),N.filter(({identifier:ae})=>(0,h.areSameExtensions)(ae,$.identifier))[0].local}catch(he){if(E.forEach(({task:ae})=>ae.cancel()),N.length)try{const ae=await Promise.allSettled(N.map(({local:ue})=>this.R(ue,{versionOnly:!0,profileLocation:I.profileLocation}).run()));for(let ue=0;ue<ae.length;ue++){const ge=ae[ue],{identifier:_}=N[ue];ge.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",_.id):this.v.warn("Rollback: Error while uninstalling extension",_.id,(0,A.getErrorMessage)(ge.reason))}}catch(ae){this.v.warn("Error while rolling back extensions",(0,A.getErrorMessage)(ae),N.map(({identifier:ue})=>ue.id))}throw this.m.fire(E.map(({task:ae})=>({identifier:ae.identifier,operation:2,source:ae.source,context:I.context,profileLocation:I.profileLocation}))),he}finally{for(const{task:he}of E)he.source&&!T.URI.isUri(he.source)&&this.j.delete(C(he.source))}}C(i,a){for(const[,{task:l,waitingTasks:d}]of this.j.entries())if(l===i&&(d.includes(a)||d.some(I=>this.C(I,a)))||l===a&&d[0]&&!this.C(i,d[0]))return!1;return!0}async D(i){const a=[],l=[],d=await Promise.allSettled(i);for(const I of d)I.status==="fulfilled"?a.push(I.value):l.push(I.reason);if(l.length)throw D(l);return a}async F(i,a,l,d,I){if(!this.t.isEnabled())return[];const C=await this.getInstalled(void 0,I),E=[],w=[],N=async($,se)=>{E.push($);const he=se.extensionDependencies||[],ae=[...he];if(se.extensionPack){const ue=l?C.find(ge=>(0,h.areSameExtensions)(ge.identifier,$)):void 0;for(const ge of se.extensionPack)ue&&ue.manifest.extensionPack&&ue.manifest.extensionPack.some(_=>(0,h.areSameExtensions)({id:_},{id:ge}))||ae.every(_=>!(0,h.areSameExtensions)({id:_},{id:ge}))&&ae.push(ge)}if(ae.length){const ue=ae.filter(ge=>E.every(_=>!(0,h.areSameExtensions)(_,{id:ge})));if(ue.length){const ge=await this.t.getExtensions(ue.map(_=>({id:_,preRelease:d})),o.CancellationToken.None);for(const _ of ge){if(E.find(J=>(0,h.areSameExtensions)(J,_.identifier)))continue;const ie=he.some(J=>(0,h.areSameExtensions)({id:J},_.identifier));let V;try{V=await this.G(_,!1,d)}catch(J){if(J instanceof v.ExtensionManagementError&&J.code===v.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ie){this.v.info("Skipping the packed extension as it cannot be installed",_.identifier.id);continue}else throw J}w.push({gallery:V.extension,manifest:V.manifest}),await N(V.extension.identifier,V.manifest)}}}};return await N(i,a),w}async G(i,a,l){if((await this.getExtensionsControlManifest()).malicious.some(E=>(0,h.areSameExtensions)(i.identifier,E)))throw new v.ExtensionManagementError(y.localize(1,null,i.identifier.id),v.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const E=await this.getTargetPlatform();throw new v.ExtensionManagementError(y.localize(2,null,i.identifier.id,this.w.nameLong,(0,v.TargetPlatformToString)(E)),v.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const I=await this.H(i,a,l);if(I){if(l&&!a&&i.hasPreReleaseVersion&&!I.properties.isPreReleaseVersion)throw new v.ExtensionManagementError(y.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),v.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!l&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],o.CancellationToken.None))[0]?new v.ExtensionManagementError(y.localize(4,null,i.identifier.id),v.ExtensionManagementErrorCode.ReleaseVersionNotFound):new v.ExtensionManagementError(y.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),v.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",I.identifier.id);const C=await this.t.getManifest(I,o.CancellationToken.None);if(C===null)throw new v.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,v.ExtensionManagementErrorCode.Invalid);if(C.version!==I.version)throw new v.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,v.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:C}}async H(i,a,l){const d=await this.getTargetPlatform();let I=null;return!a&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==l&&(I=(await this.t.getExtensions([{...i.identifier,preRelease:l}],{targetPlatform:d,compatible:!0},o.CancellationToken.None))[0]||null),!I&&await this.t.isExtensionCompatible(i,l,d)&&(I=i),I||(a?I=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:d,compatible:!0},o.CancellationToken.None))[0]||null:I=await this.t.getCompatibleExtension(i,l,d)),I}async I(i,a){const l={...a,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},d=$=>`${$.id.toLowerCase()}${l.versionOnly?`-${i.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,I=this.k.get(d(i.identifier));if(I)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),I.waitUntilTaskIsFinished();const C=$=>{const se=this.R($,l);return this.k.set(d(se.extension.identifier),se),l.profileLocation?this.v.info("Uninstalling extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,l.profileLocation.toString()):this.v.info("Uninstalling extension:",`${$.identifier.id}@${$.manifest.version}`),this.n.fire({identifier:$.identifier,profileLocation:l.profileLocation,applicationScoped:$.isApplicationScoped}),se},E=($,se)=>{se?l.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,l.profileLocation.toString(),se.message):this.v.error("Failed to uninstall extension:",`${$.identifier.id}@${$.manifest.version}`,se.message):l.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${$.identifier.id}@${$.manifest.version}`,l.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${$.identifier.id}@${$.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,h.getLocalExtensionTelemetryData)($),error:se}),this.p.fire({identifier:$.identifier,error:se?.code,profileLocation:l.profileLocation,applicationScoped:$.isApplicationScoped})},w=[],N=[];try{w.push(C(i));const $=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const se=this.M(i,$);for(const he of se)this.k.has(d(he.identifier))?this.v.info("Extensions is already requested to uninstall",he.identifier.id):w.push(C(he))}l.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(w.map(se=>se.extension),$,i),await this.D(w.map(async se=>{try{if(await se.run(),await this.D(this.s.map(he=>he.postUninstall(se.extension,l,o.CancellationToken.None))),se.extension.identifier.uuid)try{await this.t.reportStatistic(se.extension.manifest.publisher,se.extension.manifest.name,se.extension.manifest.version,"uninstall")}catch{}E(se.extension)}catch(he){const ae=he instanceof v.ExtensionManagementError?he:new v.ExtensionManagementError((0,A.getErrorMessage)(he),v.ExtensionManagementErrorCode.Internal);throw E(se.extension,ae),ae}finally{N.push(se)}}))}catch($){const se=$ instanceof v.ExtensionManagementError?$:new v.ExtensionManagementError((0,A.getErrorMessage)($),v.ExtensionManagementErrorCode.Internal);for(const he of w){try{he.cancel()}catch{}N.includes(he)||E(he.extension,se)}throw se}finally{for(const $ of w)this.k.delete(d($.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",$.extension.identifier.id)}}J(i,a,l){for(const d of i){const I=this.N(d,a);if(I.length){const C=I.filter(E=>!i.some(w=>(0,h.areSameExtensions)(w.identifier,E.identifier)));if(C.length)throw new Error(this.L(d,C,l))}}}L(i,a,l){return l===i?a.length===1?y.localize(6,null,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?y.localize(7,null,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):y.localize(8,null,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?y.localize(9,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?y.localize(10,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):y.localize(11,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}M(i,a,l=[]){if(l.indexOf(i)!==-1)return[];l.push(i);const d=i.manifest.extensionPack?i.manifest.extensionPack:[];if(d.length){const I=a.filter(E=>!E.isBuiltin&&d.some(w=>(0,h.areSameExtensions)({id:w},E.identifier))),C=[];for(const E of I)C.push(...this.M(E,a,l));return[...I,...C]}return[]}N(i,a){return a.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(d=>(0,h.areSameExtensions)({id:d},i.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};e.AbstractExtensionManagementService=u=Le([Ae(0,v.IExtensionGalleryService),Ae(1,f.ITelemetryService),Ae(2,p.ILogService),Ae(3,r.IProductService),Ae(4,c.IUserDataProfilesService)],u);function D(s){const i=Array.isArray(s)?s:[s];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((a,l)=>new Error(`${a.message}${a.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.joinErrors=D;function O(s){if(s instanceof v.ExtensionManagementError)return s;const i=new v.ExtensionManagementError(s.message,v.ExtensionManagementErrorCode.Internal);return i.stack=s.stack,i}function t(s,i,{extensionData:a,verificationStatus:l,duration:d,error:I,durationSinceUpdate:C}){let E,w;(0,m.isDefined)(l)&&(l===!0?l="Verified":(l===!1||(E=v.ExtensionManagementErrorCode.Signature,w=l),l="Unverified")),I&&(I instanceof v.ExtensionManagementError?(E=I.code,I.code===v.ExtensionManagementErrorCode.Signature&&(w=I.message)):E=v.ExtensionManagementErrorCode.Internal),s.publicLog(i,{...a,verificationStatus:l,success:!I,duration:d,errorcode:E,errorcodeDetail:w,durationSinceUpdate:C})}class n{constructor(){this.d=new L.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,L.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,L.createCancelablePromise)(i=>new Promise((a,l)=>{const d=i.onCancellationRequested(()=>{d.dispose(),l(new A.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=n}),define(pe[44],be([1,0,14,15,2,6,27,4,30,35,16,5,12,32,36,8,11,31]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var c;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(c||(e.ExtensionsProfileScanningErrorCode=c={}));class u extends Error{constructor(s,i){super(s),this.code=i}}e.ExtensionsProfileScanningError=u,e.IExtensionsProfileScannerService=(0,y.createDecorator)("IExtensionsProfileScannerService");let D=e.AbstractExtensionsProfileScannerService=class extends o.Disposable{constructor(s,i,a,l,d,I){super(),this.i=s,this.j=i,this.k=a,this.l=l,this.m=d,this.n=I,this.b=this.B(new A.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new A.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new k.ResourceMap}scanProfileExtensions(s,i){return this.p(s,void 0,i)}async addExtensionsToProfile(s,i){const a=[],l=[];try{return await this.p(i,d=>{const I=[];for(const C of d)s.some(([E])=>(0,m.areSameExtensions)(E.identifier,C.identifier)&&E.manifest.version!==C.version)?a.push(C):I.push(C);for(const[C,E]of s)if(!I.some(w=>(0,m.areSameExtensions)(w.identifier,C.identifier)&&w.version===C.manifest.version)){const w={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:E};l.push(w),I.push(w)}return l.length&&this.b.fire({extensions:l,profileLocation:i}),a.length&&this.f.fire({extensions:a,profileLocation:i}),I}),l.length&&this.c.fire({extensions:l,profileLocation:i}),a.length&&this.g.fire({extensions:a,profileLocation:i}),l}catch(d){throw l.length&&this.c.fire({extensions:l,error:d,profileLocation:i}),a.length&&this.g.fire({extensions:a,error:d,profileLocation:i}),d}}async updateMetadata(s,i){const a=[];return await this.p(i,l=>{const d=[];for(const I of l){const C=s.find(([E])=>(0,m.areSameExtensions)(E.identifier,I.identifier)&&E.manifest.version===I.version);C&&(I.metadata={...I.metadata,...C[1]},a.push(I)),d.push(I)}return d}),a}async removeExtensionFromProfile(s,i){const a=[];this.f.fire({extensions:a,profileLocation:i});try{await this.p(i,l=>{const d=[];for(const I of l)(0,m.areSameExtensions)(I.identifier,s.identifier)?a.push(I):d.push(I);return a.length&&this.f.fire({extensions:a,profileLocation:i}),d}),a.length&&this.g.fire({extensions:a,profileLocation:i})}catch(l){throw a.length&&this.g.fire({extensions:a,error:l,profileLocation:i}),l}}async p(s,i,a){return this.w(s).queue(async()=>{let l=[],d;try{const I=await this.j.readFile(s);d=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,T.toFileOperationResult)(I)!==1)throw I;if(this.l.extUri.isEqual(s,this.k.defaultProfile.extensionsResource)&&(d=await this.v()),!d&&a?.bailOutWhenFileNotFound)throw new u((0,r.getErrorMessage)(I),"ERROR_PROFILE_NOT_FOUND")}if(d){Array.isArray(d)||this.r(s);let I=!1;for(const C of d){O(C)||this.r(s);let E;if((0,p.isString)(C.relativeLocation)&&C.relativeLocation)E=this.t(C.relativeLocation);else if((0,p.isString)(C.location))E=this.t(C.location),I=!0,C.relativeLocation=C.location,C.location=E.toJSON();else{E=R.URI.revive(C.location);const w=this.s(E);w&&(I=!0,C.relativeLocation=w)}l.push({identifier:C.identifier,location:E,version:C.version,metadata:C.metadata})}I&&await this.j.writeFile(s,L.VSBuffer.fromString(JSON.stringify(d)))}if(i){l=i(l);const I=l.map(C=>({identifier:C.identifier,version:C.version,location:C.location.toJSON(),relativeLocation:this.s(C.location),metadata:C.metadata}));await this.j.writeFile(s,L.VSBuffer.fromString(JSON.stringify(I)))}return l})}r(s){const i=new u(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(s){return this.l.extUri.isEqual(this.l.extUri.dirname(s),this.i)?this.l.extUri.basename(s):void 0}t(s){return this.l.extUri.joinPath(this.i,s)}async v(){return this.u||(this.u=(async()=>{const s=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let a;try{a=(await this.j.readFile(s)).value.toString()}catch(d){if((0,T.toFileOperationResult)(d)===1)return;throw d}this.n.info("Migrating extensions from old default profile location",s.toString());let l;try{const d=JSON.parse(a);Array.isArray(d)&&d.every(I=>O(I))?l=d:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",d)}catch(d){this.n.error(d)}if(l)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(l)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",s.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(d){if((0,T.toFileOperationResult)(d)===3)this.n.info("Migration from old default profile location to new location is done by another window",s.toString(),this.k.defaultProfile.extensionsResource.toString());else throw d}try{await this.j.del(s)}catch(d){(0,T.toFileOperationResult)(d)!==1&&this.n.error(d)}try{await this.j.del(i)}catch(d){(0,T.toFileOperationResult)(d)!==1&&this.n.error(d)}return l})()),this.u}w(s){let i=this.h.get(s);return i||(i=new S.Queue,this.h.set(s,i)),i}};e.AbstractExtensionsProfileScannerService=D=Le([Ae(1,T.IFileService),Ae(2,h.IUserDataProfilesService),Ae(3,g.IUriIdentityService),Ae(4,f.ITelemetryService),Ae(5,v.ILogService)],D);function O(n){return(0,p.isObject)(n)&&(0,b.isIExtensionIdentifier)(n.identifier)&&(t(n.location)||(0,p.isString)(n.location)&&n.location)&&((0,p.isUndefined)(n.relativeLocation)||(0,p.isString)(n.relativeLocation))&&n.version&&(0,p.isString)(n.version)}function t(n){return n?(0,p.isString)(n.path)&&(0,p.isString)(n.scheme):!1}}),define(pe[57],be([1,0,18,14,21,15,11,72,154,2,13,7,3,19,53,60,8,4,177,25,35,34,77,16,5,12,26,6,50,44,32,36,207]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f,c,u,D,O,t,n,s,i,a,l,d,I,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var N;(function(_){function ie(V,J){if(V===J)return!0;const U=Object.keys(V),ne=new Set;for(const x of Object.keys(J))ne.add(x);if(U.length!==ne.size)return!1;for(const x of U){if(V[x]!==J[x])return!1;ne.delete(x)}return ne.size===0}_.equals=ie})(N||(e.Translations=N={})),e.IExtensionsScannerService=(0,s.createDecorator)("IExtensionsScannerService");let $=e.AbstractExtensionsScannerService=class extends m.Disposable{constructor(ie,V,J,U,ne,x,re,Y,ee,j,P,M){super(),this.systemExtensionsLocation=ie,this.userExtensionsLocation=V,this.l=J,this.m=U,this.n=ne,this.r=x,this.s=re,this.t=Y,this.u=ee,this.v=j,this.w=P,this.y=M,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(ae,this.m,this.h)),this.j=this.B(this.y.createInstance(ae,this.m,this.h)),this.k=this.B(this.y.createInstance(he,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,D.computeTargetPlatform)(this.s,this.t)),this.z}async scanAllExtensions(ie,V,J){const[U,ne]=await Promise.all([this.scanSystemExtensions(ie),this.scanUserExtensions(V)]),x=J?await this.scanExtensionsUnderDevelopment(ie,[...U,...ne]):[];return this.G(U,ne,x,await this.getTargetPlatform(),!0)}async scanSystemExtensions(ie){const V=[];V.push(this.H(!!ie.useCache,ie.language)),V.push(this.I(ie.language,!!ie.checkControlFile));const[J,U]=await Promise.all(V);return this.F([...J,...U],0,ie,!1)}async scanUserExtensions(ie){const V=ie.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",V);const J=this.w.extUri.isEqual(ie.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.L(V,!!ie.profileLocation,1,!ie.includeUninstalled,ie.language,!0,J),ne=ie.useCache&&!U.devMode&&U.excludeObsolete?this.j:this.k;let x;try{x=await ne.scanExtensions(U)}catch(re){if(re instanceof I.ExtensionsProfileScanningError&&re.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),x=await ne.scanExtensions(U);else throw re}return x=await this.F(x,1,ie,!0),this.t.trace("Scanned user extensions:",x.length),x}async scanExtensionsUnderDevelopment(ie,V){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const J=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(U=>U.scheme===T.Schemas.file).map(async U=>{const ne=await this.L(U,!1,1,!0,ie.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(ne)).map(re=>(re.type=V.find(Y=>(0,D.areSameExtensions)(Y.identifier,re.identifier))?.type??re.type,this.k.validate(re,ne)))}))).flat();return this.F(J,"development",ie,!0)}return[]}async scanExistingExtension(ie,V,J){const U=await this.L(ie,!1,V,!0,J.language,!0,void 0),ne=await this.k.scanExtension(U);return!ne||!J.includeInvalid&&!ne.isValid?null:ne}async scanOneOrMultipleExtensions(ie,V,J){const U=await this.L(ie,!1,V,!0,J.language,!0,void 0),ne=await this.k.scanOneOrMultipleExtensions(U);return this.F(ne,V,J,!0)}async scanMetadata(ie){const V=(0,h.joinPath)(ie,"package.json"),J=(await this.s.readFile(V)).value.toString();return JSON.parse(J).__metadata}async updateMetadata(ie,V){const J=(0,h.joinPath)(ie,"package.json"),U=(await this.s.readFile(J)).value.toString(),ne=JSON.parse(U);V.isMachineScoped=V.isMachineScoped||void 0,V.isBuiltin=V.isBuiltin||void 0,ne.__metadata={...ne.__metadata,...V},await this.s.writeFile((0,h.joinPath)(ie,"package.json"),A.VSBuffer.fromString(JSON.stringify(ne,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(ie){if(ie instanceof I.ExtensionsProfileScanningError&&ie.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw ie}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const ie=await this.scanUserExtensions({includeInvalid:!0});if(ie.length)await this.r.addExtensionsToProfile(ie.map(V=>[V,V.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(V){(0,n.toFileOperationResult)(V)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(V))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(ie){this.t.error(ie)}finally{this.C=void 0}})()),this.C}async F(ie,V,J,U){return J.includeAllVersions||(ie=this.G(V===0?ie:void 0,V===1?ie:void 0,V==="development"?ie:void 0,await this.getTargetPlatform(),U)),J.includeInvalid||(ie=ie.filter(ne=>ne.isValid)),ie.sort((ne,x)=>{const re=y.basename(ne.location.fsPath),Y=y.basename(x.location.fsPath);return re<Y?-1:re>Y?1:0})}G(ie,V,J,U,ne){const x=(Y,ee,j)=>{if(Y.isValid&&!ee.isValid)return!1;if(Y.isValid===ee.isValid){if(ne&&g.gt(Y.manifest.version,ee.manifest.version))return this.t.debug(`Skipping extension ${ee.location.path} with lower version ${ee.manifest.version} in favour of ${Y.location.path} with version ${Y.manifest.version}`),!1;if(g.eq(Y.manifest.version,ee.manifest.version)){if(Y.type===0)return this.t.debug(`Skipping extension ${ee.location.path} in favour of system extension ${Y.location.path} with same version`),!1;if(Y.targetPlatform===U)return this.t.debug(`Skipping extension ${ee.location.path} from different target platform ${ee.targetPlatform}`),!1}}return j?this.t.warn(`Overwriting user extension ${Y.location.path} with ${ee.location.path}.`):this.t.debug(`Overwriting user extension ${Y.location.path} with ${ee.location.path}.`),!0},re=new O.ExtensionIdentifierMap;return ie?.forEach(Y=>{const ee=re.get(Y.identifier.id);(!ee||x(ee,Y,!1))&&re.set(Y.identifier.id,Y)}),V?.forEach(Y=>{const ee=re.get(Y.identifier.id);if(!ee&&ie&&Y.type===0){this.t.debug(`Skipping obsolete system extension ${Y.location.path}.`);return}(!ee||x(ee,Y,!1))&&re.set(Y.identifier.id,Y)}),J?.forEach(Y=>{const ee=re.get(Y.identifier.id);(!ee||x(ee,Y,!0))&&re.set(Y.identifier.id,Y),re.set(Y.identifier.id,Y)}),[...re.values()]}async H(ie,V){this.t.trace("Started scanning system extensions");const J=await this.L(this.systemExtensionsLocation,!1,0,!0,V,!0,void 0),ne=await(ie&&!J.devMode?this.i:this.k).scanExtensions(J);return this.t.trace("Scanned system extensions:",ne.length),ne}async I(ie,V){const J=this.u.isBuilt?[]:this.v.builtInExtensions;if(!J?.length)return[];this.t.trace("Started scanning dev system extensions");const U=V?await this.J():{},ne=[],x=f.URI.file(y.normalize(y.join(T.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Y of J){const ee=U[Y.name]||"marketplace";switch(ee){case"disabled":break;case"marketplace":ne.push((0,h.joinPath)(x,Y.name));break;default:ne.push(f.URI.file(ee));break}}const re=await Promise.all(ne.map(async Y=>this.k.scanExtension(await this.L(Y,!1,0,!0,ie,!0,void 0))));return this.t.trace("Scanned dev system extensions:",re.length),(0,S.coalesce)(re)}async J(){try{const ie=await this.s.readFile(this.l);return JSON.parse(ie.value.toString())}catch{return{}}}async L(ie,V,J,U,ne,x,re){const Y=await this.f(ne??v.language),ee=await this.M(ie),j=V&&!this.w.extUri.isEqual(ie,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,P=j?await this.M(j):void 0;return new se(ie,ee,j,P,V,re,J,U,x,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,ne,Y)}async M(ie){try{const V=await this.s.stat(ie);if(typeof V.mtime=="number")return V.mtime}catch{}}};e.AbstractExtensionsScannerService=$=Le([Ae(4,C.IUserDataProfilesService),Ae(5,I.IExtensionsProfileScannerService),Ae(6,n.IFileService),Ae(7,i.ILogService),Ae(8,u.IEnvironmentService),Ae(9,a.IProductService),Ae(10,E.IUriIdentityService),Ae(11,s.IInstantiationService)],$);class se{constructor(ie,V,J,U,ne,x,re,Y,ee,j,P,M,K,te,z){this.location=ie,this.mtime=V,this.applicationExtensionslocation=J,this.applicationExtensionslocationMtime=U,this.profile=ne,this.profileScanOptions=x,this.type=re,this.excludeObsolete=Y,this.validate=ee,this.productVersion=j,this.productDate=P,this.productCommit=M,this.devMode=K,this.language=te,this.translations=z}static createNlsConfiguration(ie){return{language:ie.language,pseudo:ie.language==="pseudo",devMode:ie.devMode,translations:ie.translations}}static equals(ie,V){return(0,h.isEqual)(ie.location,V.location)&&ie.mtime===V.mtime&&(0,h.isEqual)(ie.applicationExtensionslocation,V.applicationExtensionslocation)&&ie.applicationExtensionslocationMtime===V.applicationExtensionslocationMtime&&ie.profile===V.profile&&o.equals(ie.profileScanOptions,V.profileScanOptions)&&ie.type===V.type&&ie.excludeObsolete===V.excludeObsolete&&ie.validate===V.validate&&ie.productVersion===V.productVersion&&ie.productDate===V.productDate&&ie.productCommit===V.productCommit&&ie.devMode===V.devMode&&ie.language===V.language&&N.equals(ie.translations,V.translations)}}e.ExtensionScannerInput=se;let he=class extends m.Disposable{constructor(ie,V,J,U,ne){super(),this.f=ie,this.g=V,this.h=J,this.i=U,this.j=ne}async scanExtensions(ie){const V=ie.profile?await this.l(ie):await this.k(ie);let J={};if(ie.excludeObsolete&&ie.type===1)try{const U=(await this.i.readFile(this.f)).value.toString();J=JSON.parse(U)}catch{}return(0,r.isEmptyObject)(J)?V:V.filter(U=>!J[D.ExtensionKey.create(U).toString()])}async k(ie){const V=await this.i.resolve(ie.location);if(!V.children?.length)return[];const J=await Promise.all(V.children.map(async U=>{if(!U.isDirectory||ie.type===1&&(0,h.basename)(U.resource).indexOf(".")===0)return null;const ne=new se(U.resource,ie.mtime,ie.applicationExtensionslocation,ie.applicationExtensionslocationMtime,ie.profile,ie.profileScanOptions,ie.type,ie.excludeObsolete,ie.validate,ie.productVersion,ie.productDate,ie.productCommit,ie.devMode,ie.language,ie.translations);return this.scanExtension(ne)}));return(0,S.coalesce)(J).sort((U,ne)=>U.location.path<ne.location.path?-1:1)}async l(ie){let V=await this.m(ie.location,()=>!0,ie);if(ie.applicationExtensionslocation&&!this.h.extUri.isEqual(ie.location,ie.applicationExtensionslocation)){V=V.filter(U=>!U.metadata?.isApplicationScoped);const J=await this.m(ie.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,ie);V.push(...J)}return V}async m(ie,V,J){const U=await this.g.scanProfileExtensions(ie,J.profileScanOptions);if(!U.length)return[];const ne=await Promise.all(U.map(async x=>{if(V(x)){const re=new se(x.location,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(re,x.metadata)}return null}));return(0,S.coalesce)(ne)}async scanOneOrMultipleExtensions(ie){try{if(await this.i.exists((0,h.joinPath)(ie.location,"package.json"))){const V=await this.scanExtension(ie);return V?[V]:[]}else return await this.scanExtensions(ie)}catch(V){return this.j.error(`Error scanning extensions at ${ie.location.path}:`,(0,k.getErrorMessage)(V)),[]}}async scanExtension(ie,V){try{let J=await this.scanExtensionManifest(ie.location);if(J){J.publisher||(J.publisher=O.UNDEFINED_PUBLISHER),V=V??J.__metadata,delete J.__metadata;const U=(0,D.getGalleryExtensionId)(J.publisher,J.name),ne=V?.id?{id:U,uuid:V.id}:{id:U},x=V?.isSystem?0:ie.type,re=x===0||!!V?.isBuiltin;J=await this.n(ie.location,J,se.createNlsConfiguration(ie));const Y={type:x,identifier:ne,manifest:J,location:ie.location,isBuiltin:re,targetPlatform:V?.targetPlatform??"undefined",metadata:V,isValid:!0,validations:[]};return ie.validate?this.validate(Y,ie):Y}}catch(J){ie.type!==0&&this.j.error(J)}return null}validate(ie,V){let J=!0;const U=(0,t.validateExtensionManifest)(V.productVersion,V.productDate,V.location,ie.manifest,ie.isBuiltin);for(const[ne,x]of U)ne===p.default.Error&&(J=!1,this.j.error(this.u(V.location,x)));return ie.isValid=J,ie.validations=U,ie}async scanExtensionManifest(ie){const V=(0,h.joinPath)(ie,"package.json");let J;try{J=(await this.i.readFile(V)).value.toString()}catch(ne){return(0,n.toFileOperationResult)(ne)!==1&&this.j.error(this.u(ie,(0,c.localize)(0,null,V.path,ne.message))),null}let U;try{U=JSON.parse(J)}catch{const x=[];(0,R.parse)(J,x);for(const re of x)this.j.error(this.u(ie,(0,c.localize)(1,null,V.path,re.offset,re.length,(0,b.getParseErrorMessage)(re.error))));return null}return(0,R.getNodeType)(U)!=="object"?(this.j.error(this.u(ie,(0,c.localize)(2,null,V.path))),null):U}async n(ie,V,J){const U=await this.r(ie,V,J);if(U)try{const ne=[],x=await this.s(U.default,ne);if(ne.length>0)return ne.forEach(Y=>{this.j.error(this.u(ie,(0,c.localize)(3,null,U.default?.path,(0,b.getParseErrorMessage)(Y.error))))}),V;if((0,R.getNodeType)(U)!=="object")return this.j.error(this.u(ie,(0,c.localize)(4,null,U.default?.path))),V;const re=U.values||Object.create(null);return(0,w.localizeManifest)(V,re,x)}catch{}return V}async r(ie,V,J){const U=(0,h.joinPath)(ie,"package.nls.json"),ne=(ee,j)=>{j.forEach(P=>{this.j.error(this.u(ie,(0,c.localize)(5,null,ee?.path,(0,b.getParseErrorMessage)(P.error))))})},x=ee=>{this.j.error(this.u(ie,(0,c.localize)(6,null,ee?.path)))},re=`${V.publisher}.${V.name}`,Y=J.translations[re];if(Y)try{const ee=f.URI.file(Y),j=(await this.i.readFile(ee)).value.toString(),P=[],M=(0,R.parse)(j,P);return P.length>0?(ne(ee,P),{values:void 0,default:U}):(0,R.getNodeType)(M)!=="object"?(x(ee),{values:void 0,default:U}):{values:M.contents?M.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.i.exists(U))return;let j;try{j=await this.t(ie,J)}catch{return}if(!j.localized)return{values:void 0,default:j.original};try{const P=(await this.i.readFile(j.localized)).value.toString(),M=[],K=(0,R.parse)(P,M);return M.length>0?(ne(j.localized,M),{values:void 0,default:j.original}):(0,R.getNodeType)(K)!=="object"?(x(j.localized),{values:void 0,default:j.original}):{values:K,default:j.original}}catch{return{values:void 0,default:j.original}}}}async s(ie,V){if(ie)try{const J=(await this.i.readFile(ie)).value.toString();return(0,R.parse)(J,V)}catch{}}t(ie,V){return new Promise((J,U)=>{const ne=x=>{const re=(0,h.joinPath)(ie,`package.nls.${x}.json`);this.i.exists(re).then(Y=>{Y&&J({localized:re,original:(0,h.joinPath)(ie,"package.nls.json")});const ee=x.lastIndexOf("-");ee===-1?J({localized:(0,h.joinPath)(ie,"package.nls.json"),original:null}):(x=x.substring(0,ee),ne(x))})};if(V.devMode||V.pseudo||!V.language)return J({localized:(0,h.joinPath)(ie,"package.nls.json"),original:null});ne(V.language)})}u(ie,V){return`[${ie.path}]: ${V}`}};he=Le([Ae(1,I.IExtensionsProfileScannerService),Ae(2,E.IUriIdentityService),Ae(3,n.IFileService),Ae(4,i.ILogService)],he);let ae=class extends he{constructor(ie,V,J,U,ne,x,re){super(V,U,ne,x,re),this.z=ie,this.C=J,this.w=this.B(new L.ThrottledDelayer(3e3)),this.y=this.B(new l.Emitter),this.onDidChangeCache=this.y.event}async scanExtensions(ie){const V=this.H(ie),J=await this.D(V);if(this.v=ie,J&&J.input&&se.equals(J.input,this.v))return this.j.debug("Using cached extensions scan result",ie.location.toString()),this.w.trigger(()=>this.G()),J.result.map(ne=>(ne.location=f.URI.revive(ne.location),ne));const U=await super.scanExtensions(ie);return await this.F(V,{input:ie,result:U}),U}async D(ie){try{const V=await this.i.readFile(ie),J=JSON.parse(V.value.toString());return{result:J.result,input:(0,d.revive)(J.input)}}catch(V){this.j.debug("Error while reading the extension cache file:",ie.path,(0,k.getErrorMessage)(V))}return null}async F(ie,V){try{await this.i.writeFile(ie,A.VSBuffer.fromString(JSON.stringify(V)))}catch(J){this.j.debug("Error while writing the extension cache file:",ie.path,(0,k.getErrorMessage)(J))}}async G(){if(!this.v)return;const ie=this.H(this.v),V=await this.D(ie);if(!V)return;const J=V.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!o.equals(U,J))try{this.j.info("Invalidating Cache",J,U),await this.i.del(ie),this.y.fire()}catch(ne){this.j.error(ne)}}H(ie){const V=this.I(ie);return this.h.extUri.joinPath(V.cacheHome,ie.type===0?O.BUILTIN_MANIFEST_CACHE_FILE:O.USER_MANIFEST_CACHE_FILE)}I(ie){return ie.type===0?this.C.defaultProfile:ie.profile?this.h.extUri.isEqual(ie.location,this.z.extensionsResource)?this.z:this.C.profiles.find(V=>this.h.extUri.isEqual(ie.location,V.extensionsResource))??this.z:this.C.defaultProfile}};ae=Le([Ae(2,C.IUserDataProfilesService),Ae(3,I.IExtensionsProfileScannerService),Ae(4,E.IUriIdentityService),Ae(5,n.IFileService),Ae(6,i.ILogService)],ae);function ue(_,ie){const V=(0,D.getExtensionId)(_.manifest.publisher,_.manifest.name);return{id:V,identifier:new O.ExtensionIdentifier(V),isBuiltin:_.type===0,isUserBuiltin:_.type===1&&_.isBuiltin,isUnderDevelopment:ie,extensionLocation:_.location,uuid:_.identifier.uuid,targetPlatform:_.targetPlatform,..._.manifest}}e.toExtensionDescription=ue;class ge extends ${constructor(ie,V,J,U,ne,x,re,Y,ee,j,P,M){super(ie,V,(0,h.joinPath)(J,".vscode-oss-dev","extensions","control.json"),U,ne,x,re,Y,ee,j,P,M),this.N=(async()=>{if(v.translationsConfigFile)try{const K=await this.s.readFile(f.URI.file(v.translationsConfigFile));return JSON.parse(K.value.toString())}catch{}return Object.create(null)})()}f(ie){return this.N}}e.NativeExtensionsScannerService=ge}),define(pe[256],be([1,0,52,14,38,6,2,13,7,23,12,32]),function(le,e,S,L,o,A,k,R,b,m,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=e.ExtensionsLifecycle=class extends k.Disposable{constructor(g,p){super(),this.b=g,this.f=p,this.a=new L.Limiter(5)}async postUninstall(g){const p=this.g(g,"uninstall");p&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(r){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(r)}}));try{await m.Promises.rm(this.j(g))}catch(r){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(r)}}g(g,p){const r=`vscode:${p}`;if(g.location.scheme===R.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[r]=="string"){const f=g.manifest.scripts[r].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${r} should be a node script`),null):{script:(0,b.join)(g.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(g,p,r,f,c){return new Promise((u,D)=>{const O=this.i(g,p,r,c);let t;const n=s=>{t&&(clearTimeout(t),t=null),s?D(s):u(void 0)};O.on("error",s=>{n((0,o.toErrorMessage)(s)||"Unknown")}),O.on("exit",(s,i)=>{n(s?`post-${p} process exited with code ${s}`:void 0)}),f&&(t=setTimeout(()=>{t=null,O.kill(),D("timed out")},5e3))})}i(g,p,r,f){const c={silent:!0,execArgv:void 0},u=(0,S.fork)(g,[`--type=extension-post-${p}`,...r],c);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const D=A.Event.fromNodeEventEmitter(u.stdout,"data"),O=A.Event.fromNodeEventEmitter(u.stderr,"data");D(s=>this.f.info(f.identifier.id,f.manifest.version,`post-${p}`,s)),O(s=>this.f.error(f.identifier.id,f.manifest.version,`post-${p}`,s));const t=A.Event.any(A.Event.map(D,s=>({data:`%c${s}`,format:[""]})),A.Event.map(O,s=>({data:`%c${s}`,format:["color: red"]})));return A.Event.debounce(t,(s,i)=>s?{data:s.data+i.data,format:[...s.format,...i.format]}:{data:i.data,format:i.format},100)(s=>{console.group(f.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),u}j(g){return(0,b.join)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=v=Le([Ae(0,y.IUserDataProfilesService),Ae(1,T.ILogService)],v)}),define(pe[123],be([1,0,12,32,36,31,44,16,25,4]),function(le,e,S,L,o,A,k,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let T=e.ExtensionsProfileScannerService=class extends k.AbstractExtensionsProfileScannerService{constructor(v,h,g,p,r,f){super(m.URI.file(v.extensionsPath),h,g,p,r,f)}};e.ExtensionsProfileScannerService=T=Le([Ae(0,b.INativeEnvironmentService),Ae(1,R.IFileService),Ae(2,L.IUserDataProfilesService),Ae(3,o.IUriIdentityService),Ae(4,A.ITelemetryService),Ae(5,S.ILogService)],T)}),define(pe[257],be([1,0,14,6,2,41,8,164,5,32]),function(le,e,S,L,o,A,k,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,b.createDecorator)("storageService");var T;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(T||(e.WillSaveStateReason=T={}));var y;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var v;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function h(c){const u=c.get(e.TARGET_KEY);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}e.loadKeyTargets=h;class g extends o.Disposable{constructor(u={flushInterval:g.a}){super(),this.j=u,this.b=this.B(new L.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new L.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new S.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new o.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,S.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,o.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(u,D){if(D===e.TARGET_KEY){switch(u){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:u})}else this.b.fire({scope:u,key:D,target:this.F(u)[D]})}r(u){this.f.fire({reason:u})}get(u,D,O){return this.L(D)?.get(u,O)}getBoolean(u,D,O){return this.L(D)?.getBoolean(u,O)}getNumber(u,D,O){return this.L(D)?.getNumber(u,O)}getObject(u,D,O){return this.L(D)?.getObject(u,O)}store(u,D,O,t){if((0,k.isUndefinedOrNull)(D)){this.remove(u,O);return}this.t(()=>{this.u(u,O,t),this.L(O)?.set(u,D)})}remove(u,D){this.t(()=>{this.u(u,D,void 0),this.L(D)?.delete(u)})}t(u){this.b.pause(),this.c.pause();try{u()}finally{this.b.resume(),this.c.resume()}}keys(u,D){const O=[],t=this.F(u);for(const n of Object.keys(t))t[n]===D&&O.push(n);return O}u(u,D,O){const t=this.F(D);typeof O=="number"?t[u]!==O&&(t[u]=O,this.L(D)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[u]=="number"&&(delete t[u],this.L(D)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(u){switch(u){case-1:return this.D;case 0:return this.z;default:return this.w}}G(u){const D=this.L(u);return D?h(D):Object.create(null)}isNew(u){return this.getBoolean(e.IS_NEW_KEY,u)===!0}async flush(u=T.NONE){this.f.fire({reason:u});const D=this.L(-1),O=this.L(0),t=this.L(1);switch(u){case T.NONE:await S.Promises.settled([D?.whenFlushed()??Promise.resolve(),O?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await S.Promises.settled([D?.flush(0)??Promise.resolve(),O?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.L(-1)?.items??new Map,D=this.L(0)?.items??new Map,O=this.L(1)?.items??new Map;return f(u,D,O,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(u,D){return this.r(T.NONE),(0,m.isUserDataProfile)(u)?this.N(u,D):this.O(u,D)}H(u,D){return!(u.id===D.id||p(D)&&p(u))}I(u,D,O,t){this.t(()=>{if(t)for(const[n,s]of u)D.set(n,s);else{const n=new Set;for(const[s,i]of u)n.add(s),D.get(s)!==i&&this.n(O,s);for(const[s]of D.items)n.has(s)||this.n(O,s)}})}}e.AbstractStorageService=g,g.a=60*1e3;function p(c){return c.isDefault||!!c.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=p;class r extends g{constructor(){super(),this.p=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(u=>this.n(1,u))),this.B(this.P.onDidChangeStorage(u=>this.n(0,u))),this.B(this.p.onDidChangeStorage(u=>this.n(-1,u)))}L(u){switch(u){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(u){return!1}}e.InMemoryStorageService=r;async function f(c,u,D,O,t,n){const s=N=>{try{return JSON.parse(N)}catch{return N}},i=new Map,a=new Map;c.forEach((N,$)=>{i.set($,N),a.set($,s(N))});const l=new Map,d=new Map;u.forEach((N,$)=>{l.set($,N),d.set($,s(N))});const I=new Map,C=new Map;D.forEach((N,$)=>{I.set($,N),C.set($,s(N))}),console.group(O!==t?`Storage: Application (path: ${O})`:`Storage: Application & Profile (path: ${O}, default profile)`);const E=[];if(i.forEach((N,$)=>{E.push({key:$,value:N})}),console.table(E),console.groupEnd(),console.log(a),O!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const N=[];l.forEach(($,se)=>{N.push({key:se,value:$})}),console.table(N),console.groupEnd(),console.log(d)}console.group(`Storage: Workspace (path: ${n})`);const w=[];I.forEach((N,$)=>{w.push({key:$,value:N})}),console.table(w),console.groupEnd(),console.log(C)}e.logStorage=f}),define(pe[124],be([1,0,18,20,11,3,29,8,4,24,25,30,35,77,16,12,26,43,241,257,31]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f,c,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const O=A.isWeb?"web":(0,y.getTargetPlatform)(A.platform,k.arch),t="X-Market-Search-Activity-Id";var n;(function(j){j[j.None=0]="None",j[j.IncludeVersions=1]="IncludeVersions",j[j.IncludeFiles=2]="IncludeFiles",j[j.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",j[j.IncludeSharedAccounts=8]="IncludeSharedAccounts",j[j.IncludeVersionProperties=16]="IncludeVersionProperties",j[j.ExcludeNonValidated=32]="ExcludeNonValidated",j[j.IncludeInstallationTargets=64]="IncludeInstallationTargets",j[j.IncludeAssetUri=128]="IncludeAssetUri",j[j.IncludeStatistics=256]="IncludeStatistics",j[j.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",j[j.Unpublished=4096]="Unpublished",j[j.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...j){return String(j.reduce((P,M)=>P|M,0))}var i;(function(j){j[j.Tag=1]="Tag",j[j.ExtensionId=4]="ExtensionId",j[j.Category=5]="Category",j[j.ExtensionName=7]="ExtensionName",j[j.Target=8]="Target",j[j.Featured=9]="Featured",j[j.SearchText=10]="SearchText",j[j.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class C{constructor(P=I){this.d=P}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(P,M=this.d.pageSize){return new C({...this.d,pageNumber:P,pageSize:M})}withFilter(P,...M){const K=[...this.d.criteria,...M.length?M.map(te=>({filterType:P,value:te})):[{filterType:P}]];return new C({...this.d,criteria:K})}withSortBy(P){return new C({...this.d,sortBy:P})}withSortOrder(P){return new C({...this.d,sortOrder:P})}withFlags(...P){return new C({...this.d,flags:P.reduce((M,K)=>M|K,0)})}withAssetTypes(...P){return new C({...this.d,assetTypes:P})}withSource(P){return new C({...this.d,source:P})}get raw(){const{criteria:P,pageNumber:M,pageSize:K,sortBy:te,sortOrder:z,flags:W,assetTypes:q}=this.d;return{filters:[{criteria:P,pageNumber:M,pageSize:K,sortBy:te,sortOrder:z}],assetTypes:q,flags:W}}get searchText(){const P=this.d.criteria.filter(M=>M.filterType===i.SearchText)[0];return P&&P.value?P.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(P=>String(P.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function E(j,P){const M=(j||[]).filter(K=>K.statisticName===P)[0];return M?M.value:0}function w(j){const P="Microsoft.VisualStudio.Code.Translation.";return j.files.filter(K=>K.assetType.indexOf(P)===0).reduce((K,te)=>{const z=se(j,te.assetType);return z&&K.push([te.assetType.substring(P.length),z]),K},[])}function N(j){if(j.properties){const P=j.properties.filter(te=>te.key===a.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),K=P.filter(te=>M.test(te.value))[0];return K?{uri:K.value,fallbackUri:K.value}:null}return se(j,a.Repository)}function $(j){return{uri:`${j.fallbackAssetUri}/${a.VSIX}?redirect=true${j.targetPlatform?`&targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${a.VSIX}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}}function se(j,P){return j.files.filter(K=>K.assetType===P)[0]?{uri:`${j.assetUri}/${P}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${P}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}:null}function he(j,P){const M=j.properties?j.properties.filter(te=>te.key===P):[],K=M.length>0&&M[0].value;return K?K.split(",").map(te=>(0,v.adoptToGalleryExtensionId)(te)):[]}function ae(j){const P=j.properties?j.properties.filter(M=>M.key===l.Engine):[];return P.length>0&&P[0].value||""}function ue(j){const P=j.properties?j.properties.filter(M=>M.key===l.PreRelease):[];return P.length>0&&P[0].value==="true"}function ge(j){const P=j.properties?j.properties.filter(K=>K.key===l.LocalizedLanguages):[],M=P.length>0&&P[0].value||"";return M?M.split(","):[]}function _(j){return j.properties?.find(P=>P.key===l.SponsorLink)?.value}function ie(j){return j.indexOf("preview")!==-1}function V(j){return j.targetPlatform?(0,y.toTargetPlatform)(j.targetPlatform):"undefined"}function J(j){const P=(0,S.distinct)(j.versions.map(V)),M=!!j.tags?.includes(y.WEB_EXTENSION_TAG),K=P.indexOf("web");return M?K===-1&&P.push("web"):K!==-1&&P.splice(K,1),P}function U(j,P){const M=(0,y.getFallbackTargetPlarforms)(P);for(let K=0;K<j.length;K++){const te=j[K];if(te.version===j[K-1]?.version){let z=K;const W=V(te);if(W===P)for(;z>0&&j[z-1].version===te.version;)z--;else if(M.includes(W))for(;z>0&&j[z-1].version===te.version&&V(j[z-1])!==P;)z--;z!==K&&(j.splice(K,1),j.splice(z,0,te))}}return j}e.sortExtensionVersions=U;function ne(j,P,M){j.telemetryData={index:P,querySource:M,queryActivityId:j.queryContext?.[t]}}function x(j,P,M,K){const te=j.versions[0],z={manifest:se(P,a.Manifest),readme:se(P,a.Details),changelog:se(P,a.Changelog),license:se(P,a.License),repository:N(P),download:$(P),icon:se(P,a.Icon),signature:se(P,a.Signature),coreTranslations:w(P)};return{identifier:{id:(0,v.getGalleryExtensionId)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},name:j.extensionName,version:P.version,displayName:j.displayName,publisherId:j.publisher.publisherId,publisher:j.publisher.publisherName,publisherDisplayName:j.publisher.displayName,publisherDomain:j.publisher.domain?{link:j.publisher.domain,verified:!!j.publisher.isDomainVerified}:void 0,publisherSponsorLink:_(te),description:j.shortDescription||"",installCount:E(j.statistics,"install"),rating:E(j.statistics,"averagerating"),ratingCount:E(j.statistics,"ratingcount"),categories:j.categories||[],tags:j.tags||[],releaseDate:Date.parse(j.releaseDate),lastUpdated:Date.parse(j.lastUpdated),allTargetPlatforms:M,assets:z,properties:{dependencies:he(P,l.Dependency),extensionPack:he(P,l.ExtensionPack),engine:ae(P),localizedLanguages:ge(P),targetPlatform:V(P),isPreReleaseVersion:ue(P)},hasPreReleaseVersion:ue(te),hasReleaseVersion:!0,preview:ie(j.flags),isSigned:!!z.signature,queryContext:K}}let re=class{constructor(P,M,K,te,z,W,q,H){this.k=M,this.l=K,this.n=te,this.o=z,this.q=W,this.u=q,this.w=H;const Q=q.extensionsGallery,G=Q?.servicePPEUrl&&H.getValue("_extensionsGallery.enablePPE");this.d=G?Q.servicePPEUrl:Q?.serviceUrl,this.g=G?void 0:Q?.searchUrl,this.h=Q?.controlUrl,this.j=(0,c.resolveMarketplaceHeaders)(q.version,q,this.n,this.w,this.q,P,this.o)}x(P=""){return`${this.d}${P}`}isEnabled(){return!!this.d}async getExtensions(P,M,K){const te=L.CancellationToken.isCancellationToken(M)?{}:M,z=L.CancellationToken.isCancellationToken(M)?M:K,W=[],q=[],H=[],Q=[];let G=!0;for(const Ee of P){Ee.uuid?q.push(Ee.uuid):W.push(Ee.id);const De=!!(Ee.version||Ee.preRelease);H.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:De}),Ee.version&&Q.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),G=G&&!!Ee.hasPreRelease&&!De}if(!q.length&&!W.length)return[];let Z=new C().withPage(1,P.length);q.length&&(Z=Z.withFilter(i.ExtensionId,...q)),W.length&&(Z=Z.withFilter(i.ExtensionName,...W)),(te.queryAllVersions||G)&&(Z=Z.withFlags(Z.flags,n.IncludeVersions)),te.source&&(Z=Z.withSource(te.source));const{extensions:ce}=await this.z(Z,{targetPlatform:te.targetPlatform??O,includePreRelease:H,versions:Q,compatible:!!te.compatible},z);return te.source&&ce.forEach((Ee,De)=>ne(Ee,De,te.source)),ce}async getCompatibleExtension(P,M,K){if((0,y.isNotWebExtensionInWebTargetPlatform)(P.allTargetPlatforms,K))return null;if(await this.isExtensionCompatible(P,M,K))return P;const te=new C().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,P.identifier.uuid),{extensions:z}=await this.z(te,{targetPlatform:K,compatible:!0,includePreRelease:M},L.CancellationToken.None);return z[0]||null}async isExtensionCompatible(P,M,K){if(!(0,y.isTargetPlatformCompatible)(P.properties.targetPlatform,P.allTargetPlatforms,K)||!M&&P.properties.isPreReleaseVersion)return!1;let te=P.properties.engine;if(!te){const z=await this.getManifest(P,L.CancellationToken.None);if(!z)throw new Error("Manifest was not found");te=z.engines.vscode}return(0,h.isEngineValid)(te,this.u.version,this.u.date)}async y(P,M,K,te,z){if(!(0,y.isTargetPlatformCompatible)(V(P),te,z)||M!=="any"&&ue(P)!==(M==="prerelease"))return!1;if(K)try{const W=await this.E(P);if(!(0,h.isEngineValid)(W,this.u.version,this.u.date))return!1}catch(W){return this.l.error(`Error while getting the engine for the version ${P.version}.`,(0,o.getErrorMessage)(W)),!1}return!0}async query(P,M){let K=P.text||"";const te=P.pageSize??50;let z=new C().withPage(1,te);K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(G,Z,ce)=>(z=z.withFilter(i.Category,ce||Z),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(G,Z,ce)=>(z=z.withFilter(i.Tag,ce||Z),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(z=z.withFilter(i.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),z=z.withFilter(i.SearchText,K)),z=z.withSortBy(0)):P.ids?z=z.withFilter(i.ExtensionId,...P.ids):P.names?z=z.withFilter(i.ExtensionName,...P.names):z=z.withSortBy(4),typeof P.sortBy=="number"&&(z=z.withSortBy(P.sortBy)),typeof P.sortOrder=="number"&&(z=z.withSortOrder(P.sortOrder)),P.source&&(z=z.withSource(P.source));const W=async(G,Z)=>{const{extensions:ce,total:Ee}=await this.z(G,{targetPlatform:O,compatible:!1,includePreRelease:!!P.includePreRelease},Z);return ce.forEach((De,ke)=>ne(De,(G.pageNumber-1)*G.pageSize+ke,P.source)),{extensions:ce,total:Ee}},{extensions:q,total:H}=await W(z,M),Q=async(G,Z)=>{if(Z.isCancellationRequested)throw new o.CancellationError;const{extensions:ce}=await W(z.withPage(G+1),Z);return ce};return{firstPage:q,total:H,pageSize:z.pageSize,getPage:Q}}async z(P,M,K){const te=P.flags;P.flags&n.IncludeLatestVersionOnly&&P.flags&n.IncludeVersions&&(P=P.withFlags(P.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(P.flags&n.IncludeLatestVersionOnly)&&!(P.flags&n.IncludeVersions)&&(P=P.withFlags(P.flags,n.IncludeLatestVersionOnly)),M.versions?.length&&(P=P.withFlags(P.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),P=P.withFlags(P.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:z,total:W,context:q}=await this.B(P,K);if(!(P.flags&n.IncludeLatestVersionOnly)){const Z=[];for(const ce of z){const Ee=await this.A(ce,M,q);Ee&&Z.push(Ee)}return{extensions:Z,total:W}}const Q=[],G=new Map;for(let Z=0;Z<z.length;Z++){const ce=z[Z],Ee={id:(0,v.getGalleryExtensionId)(ce.publisher.publisherName,ce.extensionName),uuid:ce.extensionId},De=(0,R.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Fe=>(0,v.areSameExtensions)(Fe,Ee))?.includePreRelease;if(M.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(J(ce),M.targetPlatform))continue;const ke=await this.A(ce,M,q);!ke||ke.properties.isPreReleaseVersion&&(!De||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==M.targetPlatform&&ke.hasPreReleaseVersion?G.set(ce.extensionId,Z):Q.push([Z,ke])}if(G.size){const Z=new Date().getTime(),ce=new C().withFlags(te&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,G.size).withFilter(i.ExtensionId,...G.keys()),{extensions:Ee}=await this.z(ce,M,K);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-Z,count:G.size});for(const De of Ee){const ke=G.get(De.identifier.uuid);Q.push([ke,De])}}return{extensions:Q.sort((Z,ce)=>Z[0]-ce[0]).map(([,Z])=>Z),total:W}}async A(P,M,K){const te={id:(0,v.getGalleryExtensionId)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},z=M.versions?.find(Q=>(0,v.areSameExtensions)(Q,te))?.version,W=(0,R.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Q=>(0,v.areSameExtensions)(Q,te))?.includePreRelease,q=J(P),H=U(P.versions,M.targetPlatform);if(M.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(q,M.targetPlatform))return null;for(let Q=0;Q<H.length;Q++){const G=H[Q];if(!(z&&G.version!==z)){if(await this.y(G,W?"any":"release",M.compatible,q,M.targetPlatform))return x(P,G,q,K);if(z&&G.version===z)return null}}return z||M.compatible?null:x(P,P.versions[0],q)}async B(P,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");P=P.withFlags(P.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,s(n.Unpublished));const K=await this.j,te=JSON.stringify(P.raw),z={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(te.length)},W=new Date().getTime();let q,H,Q=0;try{if(q=await this.k.request({type:"POST",url:this.g&&P.criteria.some(Z=>Z.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:te,headers:z},M),q.res.statusCode&&q.res.statusCode>=400&&q.res.statusCode<500)return{galleryExtensions:[],total:Q};const G=await(0,f.asJson)(q);if(G){const Z=G.results[0],ce=Z.extensions,Ee=Z.resultMetadata&&Z.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return Q=Ee&&Ee.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:ce,total:Q,context:{[t]:q.res.headers.activityid}}}return{galleryExtensions:[],total:Q}}catch(G){throw H=G,G}finally{this.o.publicLog2("galleryService:query",{...P.telemetryData,requestBodySize:String(te.length),duration:new Date().getTime()-W,success:!!q&&(0,f.isSuccess)(q),responseBodySize:q?.res.headers["Content-Length"],statusCode:q?String(q.res.statusCode):void 0,errorCode:H?(0,o.isCancellationError)(H)?"canceled":(0,o.getErrorMessage)(H).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Q)})}}async reportStatistic(P,M,K,te){if(!this.isEnabled())return;const z=A.isWeb?this.x(`/itemName/${P}.${M}/version/${K}/statType/${te==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${P}/extensions/${M}/${K}/stats?statType=${te}`),W=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",H={...await this.j,Accept:W};try{await this.k.request({type:"POST",url:z,headers:H},L.CancellationToken.None)}catch{}}async download(P,M,K){this.l.trace("ExtensionGalleryService#download",P.identifier.id);const te=(0,v.getGalleryExtensionTelemetryData)(P),z=new Date().getTime(),W=Z=>this.o.publicLog("galleryService:downloadVSIX",{...te,duration:Z}),q=K===2?"install":K===3?"update":"",H=q?{uri:`${P.assets.download.uri}${b.URI.parse(P.assets.download.uri).query?"&":"?"}${q}=true`,fallbackUri:`${P.assets.download.fallbackUri}${b.URI.parse(P.assets.download.fallbackUri).query?"&":"?"}${q}=true`}:P.assets.download,Q=P.queryContext?.[t]?{[t]:P.queryContext[t]}:void 0,G=await this.D(H,Q?{headers:Q}:void 0);await this.q.writeFile(M,G.stream),W(new Date().getTime()-z)}async downloadSignatureArchive(P,M){if(!P.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",P.identifier.id);const K=await this.D(P.assets.signature);await this.q.writeFile(M,K.stream)}async getReadme(P,M){if(P.assets.readme){const K=await this.D(P.assets.readme,{},M);return await(0,f.asTextOrError)(K)||""}return""}async getManifest(P,M){if(P.assets.manifest){const K=await this.D(P.assets.manifest,{},M),te=await(0,f.asTextOrError)(K);return te?JSON.parse(te):null}return null}async C(P,M){const K=se(P,a.Manifest);if(!K)throw new Error("Manifest was not found");const te={"Accept-Encoding":"gzip"},z=await this.D(K,{headers:te});return await(0,f.asJson)(z)}async getCoreTranslation(P,M){const K=P.assets.coreTranslations.filter(te=>te[0]===M.toUpperCase())[0];if(K){const te=await this.D(K[1]),z=await(0,f.asTextOrError)(te);return z?JSON.parse(z):null}return null}async getChangelog(P,M){if(P.assets.changelog){const K=await this.D(P.assets.changelog,{},M);return await(0,f.asTextOrError)(K)||""}return""}async getAllCompatibleVersions(P,M,K){let te=new C().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);P.identifier.uuid?te=te.withFilter(i.ExtensionId,P.identifier.uuid):te=te.withFilter(i.ExtensionName,P.identifier.id);const{galleryExtensions:z}=await this.B(te,L.CancellationToken.None);if(!z.length)return[];const W=J(z[0]);if((0,y.isNotWebExtensionInWebTargetPlatform)(W,K))return[];const q=[];await Promise.all(z[0].versions.map(async G=>{try{await this.y(G,M?"any":"release",!0,W,K)&&q.push(G)}catch{}}));const H=[],Q=new Set;for(const G of U(q,K))Q.has(G.version)||(Q.add(G.version),H.push({version:G.version,date:G.lastUpdated,isPreReleaseVersion:ue(G)}));return H}async D(P,M={},K=L.CancellationToken.None){const te=await this.j,z={type:"GET"},W={...te,...M.headers||{}};M={...M,...z,headers:W};const q=P.uri,H=P.fallbackUri,Q={...M,url:q};try{const G=await this.k.request(Q,K);if(G.res.statusCode===200)return G;const Z=await(0,f.asTextOrError)(G);throw new Error(`Expected 200, got back ${G.res.statusCode} instead.

${Z}`)}catch(G){if((0,o.isCancellationError)(G))throw G;const Z=(0,o.getErrorMessage)(G);this.o.publicLog2("galleryService:cdnFallback",{url:q,message:Z});const ce={...M,url:H};return this.k.request(ce,K)}}async E(P){let M=ae(P);if(!M){const K=await this.C(P,L.CancellationToken.None);if(!K)throw new Error("Manifest was not found");M=K.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const P=await this.k.request({type:"GET",url:this.h},L.CancellationToken.None);if(P.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,f.asJson)(P),K=[],te={};if(M){for(const z of M.malicious)K.push({id:z});if(M.migrateToPreRelease)for(const[z,W]of Object.entries(M.migrateToPreRelease))(!W.engine||(0,h.isEngineValid)(W.engine,this.u.version,this.u.date))&&(te[z.toLowerCase()]={disallowInstall:!0,extension:{id:W.id,displayName:W.displayName,autoMigrate:{storage:!!W.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[z,W]of Object.entries(M.deprecated))W&&(te[z.toLowerCase()]=(0,R.isBoolean)(W)?{}:W)}return{malicious:K,deprecated:te}}};re=Le([Ae(1,f.IRequestService),Ae(2,p.ILogService),Ae(3,T.IEnvironmentService),Ae(4,D.ITelemetryService),Ae(5,g.IFileService),Ae(6,r.IProductService),Ae(7,m.IConfigurationService)],re);let Y=e.ExtensionGalleryService=class extends re{constructor(P,M,K,te,z,W,q,H){super(P,M,K,te,z,W,q,H)}};e.ExtensionGalleryService=Y=Le([Ae(0,u.IStorageService),Ae(1,f.IRequestService),Ae(2,p.ILogService),Ae(3,T.IEnvironmentService),Ae(4,D.ITelemetryService),Ae(5,g.IFileService),Ae(6,r.IProductService),Ae(7,m.IConfigurationService)],Y);let ee=e.ExtensionGalleryServiceWithNoStorageService=class extends re{constructor(P,M,K,te,z,W,q){super(void 0,P,M,K,te,z,W,q)}};e.ExtensionGalleryServiceWithNoStorageService=ee=Le([Ae(0,f.IRequestService),Ae(1,p.ILogService),Ae(2,T.IEnvironmentService),Ae(3,D.ITelemetryService),Ae(4,g.IFileService),Ae(5,r.IProductService),Ae(6,m.IConfigurationService)],ee)}),define(pe[258],be([1,0,6,2,32,51]),function(le,e,S,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class k{constructor(m,T){this.a=m,this.b=T}listen(m,T){const y=this.b(m);switch(T){case"onDidChangeProfiles":return S.Event.map(this.a.onDidChangeProfiles,v=>({all:v.all.map(h=>(0,A.transformOutgoingURIs)({...h},y)),added:v.added.map(h=>(0,A.transformOutgoingURIs)({...h},y)),removed:v.removed.map(h=>(0,A.transformOutgoingURIs)({...h},y)),updated:v.updated.map(h=>(0,A.transformOutgoingURIs)({...h},y))}))}throw new Error(`Invalid listen ${T}`)}async call(m,T,y){const v=this.b(m);switch(T){case"createProfile":{const h=await this.a.createProfile(y[0],y[1],y[2]);return(0,A.transformOutgoingURIs)({...h},v)}case"updateProfile":{let h=(0,o.reviveProfile)((0,A.transformIncomingURIs)(y[0],v),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,y[1]),(0,A.transformOutgoingURIs)({...h},v)}case"removeProfile":{const h=(0,o.reviveProfile)((0,A.transformIncomingURIs)(y[0],v),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${T}`)}}e.RemoteUserDataProfilesServiceChannel=k;class R extends L.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(m,T,y){super(),this.profilesHome=T,this.f=y,this.a=[],this.b=this.B(new S.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=m.map(v=>(0,o.reviveProfile)(v,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(v=>{const h=v.added.map(r=>(0,o.reviveProfile)(r,this.profilesHome.scheme)),g=v.removed.map(r=>(0,o.reviveProfile)(r,this.profilesHome.scheme)),p=v.updated.map(r=>(0,o.reviveProfile)(r,this.profilesHome.scheme));this.a=v.all.map(r=>(0,o.reviveProfile)(r,this.profilesHome.scheme)),this.b.fire({added:h,removed:g,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(m){this.c=m}isEnabled(){return this.c}async createNamedProfile(m,T,y){const v=await this.f.call("createNamedProfile",[m,T,y]);return(0,o.reviveProfile)(v,this.profilesHome.scheme)}async createProfile(m,T,y,v){const h=await this.f.call("createProfile",[m,T,y,v]);return(0,o.reviveProfile)(h,this.profilesHome.scheme)}async createTransientProfile(m){const T=await this.f.call("createTransientProfile",[m]);return(0,o.reviveProfile)(T,this.profilesHome.scheme)}async setProfileForWorkspace(m,T){await this.f.call("setProfileForWorkspace",[m,T])}removeProfile(m){return this.f.call("removeProfile",[m])}async updateProfile(m,T){const y=await this.f.call("updateProfile",[m,T]);return(0,o.reviveProfile)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=R}),define(pe[125],be([1,0,4,25,16,12,235,36,32,8,236]),function(le,e,S,L,o,A,k,R,b,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let y=e.UserDataProfilesReadonlyService=class Jt extends b.UserDataProfilesService{constructor(p,r,f,c,u){super(f,c,r,u),this.P=p,this.Q=f}J(){return this.P.getItem(Jt.b,[]).map(r=>({...r,location:(0,m.isString)(r.location)?this.s.extUri.joinPath(this.profilesHome,r.location):S.URI.revive(r.location)}))}M(){const p=this.P.getItem(Jt.c,{});return this.P.getItem(Jt.a,!1)?p:this.I(p)}O(){return this.s.extUri.joinPath(S.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};y.a="profileAssociationsMigration",e.UserDataProfilesReadonlyService=y=Le([Ae(0,k.IStateReadService),Ae(1,R.IUriIdentityService),Ae(2,L.INativeEnvironmentService),Ae(3,o.IFileService),Ae(4,A.ILogService)],y);let v=e.UserDataProfilesService=class Ot extends y{constructor(p,r,f,c,u){super(p,r,f,c,u),this.W=p}L(p){p.length?this.W.setItem(Ot.b,p.map(r=>({...r,location:this.s.extUri.basename(r.location)}))):this.W.removeItem(Ot.b)}J(){const p=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(p),this.W.setItem("userDataProfilesMigration",!0)),p}N(p){p.emptyWindows||p.workspaces?this.W.setItem(Ot.c,p):this.W.removeItem(Ot.c)}M(){const p="workspaceAndProfileInfo",r=this.W.getItem(p,void 0);if(r){this.W.removeItem(p);const c=r.reduce((u,{workspace:D,profile:O})=>(u[S.URI.revive(D).toString()]=S.URI.revive(O).toString(),u),{});this.W.setItem(Ot.c,{workspaces:c})}const f=super.M();return this.W.getItem(Ot.a,!1)||(this.N(f),this.W.setItem(Ot.a,!0)),f}};e.UserDataProfilesService=v=Le([Ae(0,k.IStateService),Ae(1,R.IUriIdentityService),Ae(2,L.INativeEnvironmentService),Ae(3,o.IFileService),Ae(4,A.ILogService)],v);let h=e.ServerUserDataProfilesService=class extends v{constructor(p,r,f,c){super(new T.StateService(0,r,c,f),p,r,f,c)}async init(){return await this.W.init(),super.init()}};e.ServerUserDataProfilesService=h=Le([Ae(0,R.IUriIdentityService),Ae(1,L.INativeEnvironmentService),Ae(2,o.IFileService),Ae(3,A.ILogService)],h)}),define(pe[126],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,S.createDecorator)("extensionHostStatusService");class L{constructor(){this.a=new Map}setExitInfo(A,k){this.a.set(A,k)}getExitInfo(A){return this.a.get(A)||null}}e.ExtensionHostStatusService=L}),define(pe[259],be([1,0,6,14]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=void 0;function o(k){let R=0,b=0,m=0;k>=1e3&&(m=Math.floor(k/1e3),k-=m*1e3),m>=60&&(b=Math.floor(m/60),m-=b*60),b>=60&&(R=Math.floor(b/60),b-=R*60);const T=R?`${R}h`:"",y=b?`${b}m`:"",v=m?`${m}s`:"",h=k?`${k}ms`:"";return`${T}${y}${v}${h}`}class A{constructor(R,b,m,T){this.i=R,this.j=b,this.a=new S.Emitter,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=m,this.protocol=T,this.e=!1,this.f=new L.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection grace time of ${o(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new L.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection short grace time of ${o(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${o(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(R){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${R}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${o(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const R=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),R.end(),this.a.fire(void 0)}acceptReconnection(R,b,m){this.d=R,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(b,m),this.protocol.endAcceptReconnection()}}e.ManagementConnection=A}),define(pe[127],be([1,0,33,13,7,146,54]),function(le,e,S,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const R=o.join(L.FileAccess.asFileUri("").fsPath,"nls.metadata.json"),b=new Map;function m(v){return new Promise(h=>S.exists(v,h))}function T(v,h){return m(R).then(g=>{if(!g||!k.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const p=`${v}||${h}`;let r=b.get(p);return r||(r=A.getNLSConfiguration(k.default.commit,h,R,v,v).then(f=>(y.is(f)&&(f._languagePackSupport=!0),f)),b.set(p,r)),r})}e.getNLSConfiguration=T;var y;(function(v){function h(g){const p=g;return p&&typeof p._languagePackId=="string"}v.is=h})(y||(e.InternalNLSConfiguration=y={}))}),define(pe[128],be([1,0,19,4,25,44,57,16,5,12,26,36,32,127]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=e.ExtensionsScannerService=class extends k.AbstractExtensionsScannerService{constructor(r,f,c,u,D,O,t,n){super(L.URI.file(D.builtinExtensionsPath),L.URI.file(D.extensionsPath),(0,S.joinPath)(D.userHome,".vscode-oss-dev","extensions","control.json"),r.defaultProfile,r,f,c,u,D,O,t,n),this.N=D}async f(r){const f=await(0,h.getNLSConfiguration)(r,this.N.userDataPath);if(h.InternalNLSConfiguration.is(f))try{const c=await this.s.readFile(L.URI.file(f._translationsConfigFile));return JSON.parse(c.value.toString())}catch{}return Object.create(null)}};e.ExtensionsScannerService=g=Le([Ae(0,v.IUserDataProfilesService),Ae(1,A.IExtensionsProfileScannerService),Ae(2,R.IFileService),Ae(3,m.ILogService),Ae(4,o.INativeEnvironmentService),Ae(5,T.IProductService),Ae(6,y.IUriIdentityService),Ae(7,b.IInstantiationService)],g)}),define(pe[260],be([1,0,261,33,7,22,13,23]),function(le,e,S,L,o,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const b=/^[0-9A-Za-z_-]+$/;var m;(function(r){r[r.None=0]="None",r[r.Optional=1]="Optional",r[r.Mandatory=2]="Mandatory"})(m||(e.ServerConnectionTokenType=m={}));class T{constructor(){this.type=0}validate(f){return!0}}e.NoneServerConnectionToken=T;class y{constructor(f){this.value=f,this.type=2}validate(f){return f===this.value}}e.MandatoryServerConnectionToken=y;class v{constructor(f){this.message=f}}e.ServerConnectionTokenParseError=v;async function h(r,f){const c=r["without-connection-token"],u=r["connection-token"],D=r["connection-token-file"];if(c)return typeof u<"u"||typeof D<"u"?new v("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new T;if(typeof D<"u"){if(typeof u<"u")return new v("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let O;try{O=L.readFileSync(D).toString().replace(/\r?\n$/,"")}catch{return new v(`Unable to read the connection token file at '${D}'.`)}return b.test(O)?new y(O):new v(`The connection token defined in '${D} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof u<"u"?b.test(u)?new y(u):new v(`The connection token '${u} does not adhere to the characters 0-9, a-z, A-Z or -.`):new y(await f())}e.parseServerConnectionToken=h;async function g(r){return h(r,async()=>{if(!r["user-data-dir"])return(0,A.generateUuid)();const c=o.join(r["user-data-dir"],"token");try{const O=(await R.Promises.readFile(c)).toString().replace(/\r?\n$/,"");if(b.test(O))return O}catch{}const u=(0,A.generateUuid)();try{await R.Promises.writeFile(c,u,{mode:384})}catch{}return u})}e.determineServerConnectionToken=g;function p(r,f,c){if(r.validate(c.query[k.connectionTokenQueryName]))return!0;const u=S.parse(f.headers.cookie||"");return r.validate(u[k.connectionTokenCookieName])}e.requestHasValidConnectionToken=p}),define(pe[45],be([1,0,195,106,62,5,25]),function(le,e,S,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={host:{type:"string",cat:"o",args:"ip-address",description:S.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:S.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:S.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:S.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:S.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:S.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:S.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:S.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:S.localize(8,null)},"user-data-dir":o.OPTIONS["user-data-dir"],"enable-smoke-test-driver":o.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":o.OPTIONS["disable-telemetry"],"disable-workspace-trust":o.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:o.OPTIONS.log,logsPath:o.OPTIONS.logsPath,"force-disable-user-env":o.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:S.localize(9,null)},"default-workspace":{type:"string",description:S.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":o.OPTIONS["extensions-dir"],"extensions-download-dir":o.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":o.OPTIONS["builtin-extensions-dir"],"install-extension":o.OPTIONS["install-extension"],"install-builtin-extension":o.OPTIONS["install-builtin-extension"],"uninstall-extension":o.OPTIONS["uninstall-extension"],"list-extensions":o.OPTIONS["list-extensions"],"locate-extension":o.OPTIONS["locate-extension"],"show-versions":o.OPTIONS["show-versions"],category:o.OPTIONS.category,force:o.OPTIONS.force,"do-not-sync":o.OPTIONS["do-not-sync"],"pre-release":o.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:S.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:o.OPTIONS.help,version:o.OPTIONS.version,"locate-shell-integration-path":o.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:o.OPTIONS._},e.IServerEnvironmentService=(0,A.refineServiceDecorator)(k.IEnvironmentService);class R extends L.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=R}),define(pe[262],be([1,0,33,73,83,261,85,39,58,3,12,45,7,13,22,26,43,20,4,15,8,56]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f,c,u,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const t={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function n(d,I,C,E){I.writeHead(C,{"Content-Type":"text/plain"}),I.end(E)}e.serveError=n;var s;(function(d){d[d.NO_CACHING=0]="NO_CACHING",d[d.ETAG=1]="ETAG",d[d.NO_EXPIRY=2]="NO_EXPIRY"})(s||(e.CacheControl=s={}));async function i(d,I,C,E,w,N){try{const $=await S.promises.stat(d);if(I===1){const se=`W/"${[$.ino,$.size,$.mtime.getTime()].join("-")}"`;if(E.headers["if-none-match"]===se)return w.writeHead(304),void w.end();N.Etag=se}else I===2?N["Cache-Control"]="public, max-age=31536000":I===0&&(N["Cache-Control"]="no-store");N["Content-Type"]=t[(0,v.extname)(d)]||(0,b.getMediaMime)(d)||"text/plain",w.writeHead(200,N),(0,S.createReadStream)(d).pipe(w)}catch($){return $.code!=="ENOENT"?(C.error($),console.error($.toString())):console.error(`File not found: ${d}`),w.writeHead(404,{"Content-Type":"text/plain"}),void w.end("Not found")}}e.serveFile=i;const a=(0,v.dirname)(h.FileAccess.asFileUri("").fsPath);let l=e.WebClientServer=class{constructor(I,C,E,w,N){this.f=I,this.g=C,this.h=E,this.i=w,this.j=N,this.a=this.j.extensionsGallery?.resourceUrlTemplate?c.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const $=(0,O.getRemoteServerRootPath)(N);this.b=`${$}/static`,this.c=`${$}/callback`,this.d=`${$}/web-extension-resource`}async handle(I,C,E){try{const w=E.pathname;return w.startsWith(this.b)&&w.charCodeAt(this.b.length)===47?this.k(I,C,E):w==="/"?this.n(I,C,E):w===this.c?this.p(C):w.startsWith(this.d)&&w.charCodeAt(this.d.length)===47?this.m(I,C,E):n(I,C,404,"Not found.")}catch(w){return this.h.error(w),console.error(w.toString()),n(I,C,500,"Internal Server Error.")}}async k(I,C,E){const w=Object.create(null),$=decodeURIComponent(E.pathname).substring(this.b.length+1),se=(0,v.join)(a,$);return(0,R.isEqualOrParent)(se,a,!m.isLinux)?i(se,this.g.isBuilt?2:1,this.h,I,C,w):n(I,C,400,"Bad request.")}l(I){const C=I.authority.indexOf(".");return C!==-1?I.authority.substring(C+1):void 0}async m(I,C,E){if(!this.a)return n(I,C,500,"No extension gallery service configured.");const w=decodeURIComponent(E.pathname),N=(0,v.normalize)(w.substring(this.d.length+1)),$=c.URI.parse(N).with({scheme:this.a.scheme,authority:N.substring(0,N.indexOf("/")),path:N.substring(N.indexOf("/")+1)});if(this.l(this.a)!==this.l($))return n(I,C,403,"Request Forbidden");const se={},he=V=>{const J=I.headers[V];J&&((0,D.isString)(J)||J[0])?se[V]=(0,D.isString)(J)?J:J[0]:V!==V.toLowerCase()&&he(V.toLowerCase())};he("X-Client-Name"),he("X-Client-Version"),he("X-Machine-Id"),he("X-Client-Commit");const ae=await this.i.request({type:"GET",url:$.toString(!0),headers:se},f.CancellationToken.None),ue=ae.res.statusCode||500;if(ue!==200){let V=null;try{V=await(0,r.asTextOrError)(ae)}catch{}return n(I,C,ue,V||`Request failed with status ${ue}`)}const ge=Object.create(null),_=V=>{const J=ae.res.headers[V];J?ge[V]=J:V!==V.toLowerCase()&&_(V.toLowerCase())};_("Cache-Control"),_("Content-Type"),C.writeHead(200,ge);const ie=await(0,u.streamToBuffer)(ae.stream);return void C.end(ie.buffer)}async n(I,C,E){const w=E.query[h.connectionTokenQueryName];if(typeof w=="string"){const re=Object.create(null);re["Set-Cookie"]=A.serialize(h.connectionTokenCookieName,w,{sameSite:"lax",maxAge:60*60*24*7});const Y=Object.create(null);for(const j in E.query)j!==h.connectionTokenQueryName&&(Y[j]=E.query[j]);const ee=o.format({pathname:"/",query:Y});return re.Location=ee,C.writeHead(302,re),void C.end()}const N=re=>{const Y=I.headers[re];return Array.isArray(Y)?Y[0]:Y},$=N("x-original-host")||N("x-forwarded-host")||I.headers.host;if(!$)return n(I,C,400,"Bad request.");function se(re){return JSON.stringify(re).replace(/"/g,"&quot;")}let he;this.g.args["enable-smoke-test-driver"]&&(he=!1);const ae=re=>re&&c.URI.file(L.resolve(re)).with({scheme:h.Schemas.vscodeRemote,authority:$}),ue=h.FileAccess.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,ge=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,g.generateUuid)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,_={embedderIdentifier:"server-distro",extensionsGallery:this.a?{...this.j.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:$,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0};if(!this.g.isBuilt)try{const re=JSON.parse((await S.promises.readFile((0,v.join)(a,"product.overrides.json"))).toString());Object.assign(_,re)}catch{}const ie={remoteAuthority:$,_wrapWebWorkerExtHostInIframe:he,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:ae(this.g.args["default-folder"]),workspaceUri:ae(this.g.args["default-workspace"]),productConfiguration:_,callbackRoute:this.c},V=this.j.extensionsGallery?.nlsBaseUrl,J={WORKBENCH_WEB_CONFIGURATION:se(ie),WORKBENCH_AUTH_SESSION:ge?se(ge):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_BASE_URL:V?`${V}${V.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""};let U;try{U=(await S.promises.readFile(ue)).toString().replace(/\{\{([^}]+)\}\}/g,(Y,ee)=>J[ee]??"undefined")}catch{return C.writeHead(404,{"Content-Type":"text/plain"}),void C.end("Not found")}const x={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(U).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' http://${$};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(x["Set-Cookie"]=A.serialize(h.connectionTokenCookieName,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),C.writeHead(200,x),void C.end(U)}o(I){const C=/<script>([\s\S]+?)<\/script>/img,E=[];let w;for(;w=C.exec(I);){const N=k.createHash("sha256"),$=w[1].replace(/\r\n/g,`
`),se=N.update(Buffer.from($)).digest().toString("base64");E.push(`'sha256-${se}'`)}return E}async p(I){const C=h.FileAccess.asFileUri("vs/code/browser/workbench/callback.html").fsPath,E=(await S.promises.readFile(C)).toString(),w=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(E).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return I.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":w}),void I.end(E)}};e.WebClientServer=l=Le([Ae(1,y.IServerEnvironmentService),Ae(2,T.ILogService),Ae(3,r.IRequestService),Ae(4,p.IProductService)],l)}),define(pe[263],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,S.createDecorator)("IExtHostInitDataService")}),define(pe[264],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,S.createDecorator)("IExtHostRpcService");class L{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=L}),define(pe[68],be([1,0,51]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function L(A){return{transformIncoming:k=>k.scheme==="vscode-remote"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="file"?{scheme:"vscode-local",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoing:k=>k.scheme==="file"?{scheme:"vscode-remote",authority:A,path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="vscode-local"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoingScheme:k=>k==="file"?"vscode-remote":k==="vscode-local"?"file":k}}function o(A){return new S.URITransformer(L(A))}e.createURITransformer=o}),define(pe[265],be([1,0,3,41,4,68,51,103,239,7,19]),function(le,e,S,L,o,A,k,R,b,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class y{constructor(h,g,p,r){this.b=h,this.c=g,this.d=p,this.e=r}async call(h,g,p){switch(g){case"getEnvironmentData":{const r=p,f=(0,A.createURITransformer)(r.remoteAuthority);let c=await this.f(r.profile);return c=(0,k.transformOutgoingURIs)(c,f),c}case"getExtensionHostExitInfo":{const r=p;return this.e.getExitInfo(r.reconnectionToken)}case"getDiagnosticInfo":{const r=p,f={machineInfo:(0,b.getMachineInfo)()},c=r.includeProcesses?(0,R.listProcesses)(process.pid):Promise.resolve();let u=[];const D={};if(r.folders){const O=(0,A.createURITransformer)("");u=r.folders.map(n=>o.URI.revive(O.transformIncoming(n))).filter(n=>n.scheme==="file").map(n=>(0,b.collectWorkspaceStats)(n.fsPath,["node_modules",".git"]).then(s=>{D[(0,m.basename)(n.fsPath)]=s}))}return Promise.all([c,...u]).then(([O,t])=>(f.processes=O||void 0,f.workspaceMetadata=r.folders?D:void 0,f))}}throw new Error(`IPC Command ${g} not found`)}listen(h,g,p){throw new Error("Not supported")}async f(h){return h&&!this.d.profiles.some(g=>g.id===h)&&await this.d.createProfile(h,h),{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:o.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,T.joinPath)(this.c.logsHome,`exthost${y.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:S.OS,arch:process.arch,marks:L.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(g=>({...g}))}}}}e.RemoteAgentEnvironmentChannel=y,y.a=1}),define(pe[266],be([1,0,4,68,66,7,223]),function(le,e,S,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class R extends k.AbstractDiskFileSystemProviderChannel{constructor(T,y){super(new o.DiskFileSystemProvider(T),T),this.H=y,this.G=new Map,this.B(this.a)}c(T){let y=this.G.get(T.remoteAuthority);return y||(y=(0,L.createURITransformer)(T.remoteAuthority),this.G.set(T.remoteAuthority,y)),y}f(T,y,v=!1){if(v&&y.path==="/vscode-resource"&&y.query){const h=JSON.parse(y.query).requestResourcePath;return S.URI.from({scheme:"file",path:h})}return S.URI.revive(T.transformIncoming(y))}F(T,y){return new b(T,y,this.b,this.H)}}e.RemoteAgentFileSystemProviderChannel=R;class b extends k.AbstractSessionFileWatcher{constructor(T,y,v,h){super(T,y,v,h)}i(T){const y=T.args["file-watcher-polling"];if(y){const v=y.split(A.delimiter),h=Number(v[0]);if(h>0)return{usePolling:v.length>1?v.slice(1):!0,pollingInterval:h}}}j(T){if(T.extensionsPath)return[A.posix.join(T.extensionsPath,"**")]}}}),define(pe[88],be([1,0,198,8,4,2,5,40,16,13,38,156,60]),function(le,e,S,L,o,A,k,R,b,m,T,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var h;(function(x){x[x.PROGRAMMATIC=1]="PROGRAMMATIC",x[x.USER=2]="USER",x[x.EDIT=3]="EDIT",x[x.NAVIGATION=4]="NAVIGATION",x[x.JUMP=5]="JUMP"})(h||(e.EditorPaneSelectionChangeReason=h={}));var g;(function(x){x[x.IDENTICAL=1]="IDENTICAL",x[x.SIMILAR=2]="SIMILAR",x[x.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function p(x){const re=x;return!!re&&typeof re.getSelection=="function"&&!!re.onDidChangeSelection}e.isEditorPaneWithSelection=p;function r(x,re,Y){for(const ee of Y.visibleEditorPanes)if(ee.group.id===re&&x.matches(ee.input))return ee.getViewState()}e.findViewStateForEditor=r;function f(x){if(l(x))return!1;const re=x;return o.URI.isUri(re?.resource)}e.isResourceEditorInput=f;function c(x){if(l(x))return!1;const re=x;return re?.original!==void 0&&re.modified!==void 0}e.isResourceDiffEditorInput=c;function u(x){if(l(x)||c(x))return!1;const re=x;return re?.primary!==void 0&&re.secondary!==void 0}e.isResourceSideBySideEditorInput=u;function D(x){if(l(x))return!1;const re=x;return re?re.resource===void 0||re.resource.scheme===m.Schemas.untitled||re.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=D;function O(x){if(l(x))return!1;const re=x;return o.URI.isUri(re?.base?.resource)&&o.URI.isUri(re?.input1?.resource)&&o.URI.isUri(re?.input2?.resource)&&o.URI.isUri(re?.result?.resource)}e.isResourceMergeEditorInput=O;var t;(function(x){x[x.SHORT=0]="SHORT",x[x.MEDIUM=1]="MEDIUM",x[x.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var n;(function(x){x[x.EXPLICIT=1]="EXPLICIT",x[x.AUTO=2]="AUTO",x[x.FOCUS_CHANGE=3]="FOCUS_CHANGE",x[x.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class s{constructor(){this.a=new Map}registerSource(re,Y){let ee=this.a.get(re);return ee||(ee={source:re,label:Y},this.a.set(re,ee)),ee.source}getSourceLabel(re){return this.a.get(re)?.label??re}}e.SaveSourceRegistry=new s;var i;(function(x){x[x.None=0]="None",x[x.Readonly=2]="Readonly",x[x.Untitled=4]="Untitled",x[x.Singleton=8]="Singleton",x[x.RequiresTrust=16]="RequiresTrust",x[x.CanSplitInGroup=32]="CanSplitInGroup",x[x.ForceDescription=64]="ForceDescription",x[x.CanDropIntoEditor=128]="CanDropIntoEditor",x[x.MultipleEditors=256]="MultipleEditors",x[x.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class a extends A.Disposable{}e.AbstractEditorInput=a;function l(x){return x instanceof a}e.isEditorInput=l;function d(x){const re=x;return o.URI.isUri(re?.preferredResource)}function I(x){const re=x;return l(re?.primary)&&l(re?.secondary)}e.isSideBySideEditorInput=I;function C(x){const re=x;return l(re?.modified)&&l(re?.original)}e.isDiffEditorInput=C;function E(x,re,Y,ee,j){return ne(ee,[(0,y.toAction)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const P={...Y,limits:{size:Number.MAX_VALUE}};x.openEditor(re,P)}}),(0,y.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>j.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=E;function w(x){return l(x?.editor)}e.isEditorInputWithOptions=w;function N(x){const re=x;return w(x)&&re?.group!==void 0}e.isEditorInputWithOptionsAndGroup=N;function $(x){const re=x;return typeof re?.groupId=="number"&&l(re.editor)}e.isEditorIdentifier=$;var se;(function(x){x[x.UNKNOWN=0]="UNKNOWN",x[x.REPLACE=1]="REPLACE",x[x.MOVE=2]="MOVE",x[x.UNPIN=3]="UNPIN"})(se||(e.EditorCloseContext=se={}));var he;(function(x){x[x.GROUP_ACTIVE=0]="GROUP_ACTIVE",x[x.GROUP_INDEX=1]="GROUP_INDEX",x[x.GROUP_LOCKED=2]="GROUP_LOCKED",x[x.EDITOR_OPEN=3]="EDITOR_OPEN",x[x.EDITOR_CLOSE=4]="EDITOR_CLOSE",x[x.EDITOR_MOVE=5]="EDITOR_MOVE",x[x.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",x[x.EDITOR_LABEL=7]="EDITOR_LABEL",x[x.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",x[x.EDITOR_PIN=9]="EDITOR_PIN",x[x.EDITOR_STICKY=10]="EDITOR_STICKY",x[x.EDITOR_DIRTY=11]="EDITOR_DIRTY",x[x.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(he||(e.GroupModelChangeKind=he={}));var ae;(function(x){x[x.PRIMARY=1]="PRIMARY",x[x.SECONDARY=2]="SECONDARY",x[x.BOTH=3]="BOTH",x[x.ANY=4]="ANY"})(ae||(e.SideBySideEditor=ae={}));class ue{getOriginalUri(re,Y){if(!re)return;if(O(re))return e.EditorResourceAccessor.getOriginalUri(re.result,Y);if(Y?.supportSideBySide){const{primary:j,secondary:P}=this.a(re);if(j&&P){if(Y?.supportSideBySide===ae.BOTH)return{primary:this.getOriginalUri(j,{filterByScheme:Y.filterByScheme}),secondary:this.getOriginalUri(P,{filterByScheme:Y.filterByScheme})};if(Y?.supportSideBySide===ae.ANY)return this.getOriginalUri(j,{filterByScheme:Y.filterByScheme})??this.getOriginalUri(P,{filterByScheme:Y.filterByScheme});re=Y.supportSideBySide===ae.PRIMARY?j:P}}if(c(re)||u(re)||O(re))return;const ee=d(re)?re.preferredResource:re.resource;return!ee||!Y||!Y.filterByScheme?ee:this.b(ee,Y.filterByScheme)}a(re){return I(re)||u(re)?{primary:re.primary,secondary:re.secondary}:C(re)||c(re)?{primary:re.modified,secondary:re.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(re,Y){if(!re)return;if(O(re))return e.EditorResourceAccessor.getCanonicalUri(re.result,Y);if(Y?.supportSideBySide){const{primary:j,secondary:P}=this.a(re);if(j&&P){if(Y?.supportSideBySide===ae.BOTH)return{primary:this.getCanonicalUri(j,{filterByScheme:Y.filterByScheme}),secondary:this.getCanonicalUri(P,{filterByScheme:Y.filterByScheme})};if(Y?.supportSideBySide===ae.ANY)return this.getCanonicalUri(j,{filterByScheme:Y.filterByScheme})??this.getCanonicalUri(P,{filterByScheme:Y.filterByScheme});re=Y.supportSideBySide===ae.PRIMARY?j:P}}if(c(re)||u(re)||O(re))return;const ee=re.resource;return!ee||!Y||!Y.filterByScheme?ee:this.b(ee,Y.filterByScheme)}b(re,Y){if(Array.isArray(Y)){if(Y.some(ee=>re.scheme===ee))return re}else if(Y===re.scheme)return re}}e.EditorResourceAccessor=new ue;var ge;(function(x){x[x.LEFT=0]="LEFT",x[x.RIGHT=1]="RIGHT"})(ge||(e.CloseDirection=ge={}));class _{constructor(){this.c=new Map,this.d=new Map}start(re){const Y=this.a=re.get(k.IInstantiationService);for(const[ee,j]of this.c)this.e(ee,j,Y);this.c.clear()}e(re,Y,ee){const j=ee.createInstance(Y);this.d.set(re,j)}registerFileEditorFactory(re){if(this.b)throw new Error("Can only register one file editor factory.");this.b=re}getFileEditorFactory(){return(0,L.assertIsDefined)(this.b)}registerEditorSerializer(re,Y){if(this.c.has(re)||this.d.has(re))throw new Error(`A editor serializer with type ID '${re}' was already registered.`);return this.a?this.e(re,Y,this.a):this.c.set(re,Y),(0,A.toDisposable)(()=>{this.c.delete(re),this.d.delete(re)})}getEditorSerializer(re){return this.d.get(typeof re=="string"?re:re.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new _);async function ie(x,re,Y){return!x||!x.length?[]:await Promise.all(x.map(async ee=>{const j=o.URI.revive(ee.fileUri);if(!j){Y.info("Cannot resolve the path because it is not valid.",ee);return}if(!await re.canHandleResource(j)){Y.info("Cannot resolve the path because it cannot be handled",ee);return}let M=ee.exists,K=ee.type;if(typeof M!="boolean"||typeof K!="number")try{K=(await re.stat(j)).isDirectory?b.FileType.Directory:b.FileType.Unknown,M=!0}catch(z){Y.error(z),M=!1}if(!M&&ee.openOnlyIfExists){Y.info("Cannot resolve the path because it does not exist",ee);return}if(K===b.FileType.Directory){Y.info("Cannot resolve the path because it is a directory",ee);return}const te={...ee.options,pinned:!0};return M?{resource:j,options:te}:{resource:j,options:te,forceUntitled:!0}}))}e.pathsToEditors=ie;var V;(function(x){x[x.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",x[x.SEQUENTIAL=1]="SEQUENTIAL"})(V||(e.EditorsOrder=V={}));function J(x){const re=x;if(!re)return!1;const Y=re;if(Y.modified)return J(Y.modified);const ee=re;return!!(ee.contributionsState&&ee.viewState&&Array.isArray(ee.cursorState))}e.isTextEditorViewState=J;function U(x){return(0,T.isErrorWithActions)(x)}e.isEditorOpenError=U;function ne(x,re,Y){const ee=(0,T.createErrorWithActions)(x,re);return ee.forceMessage=Y?.forceMessage,ee.forceSeverity=Y?.forceSeverity,ee.allowDialog=Y?.allowDialog,ee}e.createEditorOpenError=ne}),define(pe[129],be([1,0,15,76,46,58,13,7,3,64]),function(le,e,S,L,o,A,k,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var T;(function(_){_[_.Markup=1]="Markup",_[_.Code=2]="Code"})(T||(e.CellKind=T={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(_){_[_.Running=1]="Running",_[_.Idle=2]="Idle"})(y||(e.NotebookRunState=y={}));var v;(function(_){_[_.Unconfirmed=1]="Unconfirmed",_[_.Pending=2]="Pending",_[_.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var h;(function(_){_[_.Unconfirmed=1]="Unconfirmed",_[_.Pending=2]="Pending",_[_.Executing=3]="Executing"})(h||(e.NotebookExecutionState=h={}));var g;(function(_){_[_.WithHardKernelDependency=0]="WithHardKernelDependency",_[_.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",_[_.Pure=2]="Pure",_[_.Never=3]="Never"})(g||(e.NotebookRendererMatch=g={}));var p;(function(_){_.Always="always",_.Never="never",_.Optional="optional"})(p||(e.RendererMessagingSpec=p={}));var r;(function(_){_[_.ModelChange=1]="ModelChange",_[_.Move=2]="Move",_[_.ChangeCellLanguage=5]="ChangeCellLanguage",_[_.Initialize=6]="Initialize",_[_.ChangeCellMetadata=7]="ChangeCellMetadata",_[_.Output=8]="Output",_[_.OutputItem=9]="OutputItem",_[_.ChangeCellContent=10]="ChangeCellContent",_[_.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",_[_.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",_[_.ChangeCellMime=13]="ChangeCellMime",_[_.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var f;(function(_){_[_.Handle=0]="Handle",_[_.Index=1]="Index"})(f||(e.SelectionStateType=f={}));var c;(function(_){_[_.Replace=1]="Replace",_[_.Output=2]="Output",_[_.Metadata=3]="Metadata",_[_.CellLanguage=4]="CellLanguage",_[_.DocumentMetadata=5]="DocumentMetadata",_[_.Move=6]="Move",_[_.OutputItems=7]="OutputItems",_[_.PartialMetadata=8]="PartialMetadata",_[_.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var u;(function(_){_.scheme=k.Schemas.vscodeNotebookCell;const ie=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${ie.join("")}]+`),J=7;function U(j,P){const M=P.toString(J),te=`${M.length<ie.length?ie[M.length-1]:"z"}${M}s${(0,S.encodeBase64)(S.VSBuffer.fromString(j.scheme),!0,!0)}`;return j.with({scheme:_.scheme,fragment:te})}_.generate=U;function ne(j){if(j.scheme!==_.scheme)return;const P=j.fragment.indexOf("s");if(P<0)return;const M=parseInt(j.fragment.substring(0,P).replace(V,""),J),K=(0,S.decodeBase64)(j.fragment.substring(P+1)).toString();if(!isNaN(M))return{handle:M,notebook:j.with({scheme:K,fragment:null})}}_.parse=ne;function x(j,P){return j.with({scheme:k.Schemas.vscodeNotebookCellOutput,fragment:`op${P??""},${j.scheme!==k.Schemas.file?j.scheme:""}`})}_.generateCellOutputUri=x;function re(j){if(j.scheme!==k.Schemas.vscodeNotebookCellOutput)return;const P=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(j.fragment);if(!P)return;const M=P[1]&&P[1]!==""?P[1]:void 0,K=P[2];return{outputId:M,notebook:j.with({scheme:K||k.Schemas.file,fragment:null})}}_.parseCellOutputUri=re;function Y(j,P,M){return _.generate(j,P).with({scheme:M})}_.generateCellPropertyUri=Y;function ee(j,P){if(j.scheme===P)return _.parse(j.with({scheme:_.scheme}))}_.parseCellPropertyUri=ee})(u||(e.CellUri=u={}));const D=_=>b.isWindows?_.replace(/\//g,"\\"):_;class O{constructor(ie=[],V=e.NOTEBOOK_DISPLAY_ORDER){this.e=V,this.d=[...new Set(ie)].map(J=>({pattern:J,matches:L.parse(D(J))}))}sort(ie){const V=new Map(o.Iterable.map(ie,U=>[U,D(U)]));let J=[];for(const{matches:U}of this.d)for(const[ne,x]of V)if(U(x)){J.push(ne),V.delete(ne);break}return V.size&&(J=J.concat([...V.keys()].sort((U,ne)=>this.e.indexOf(U)-this.e.indexOf(ne)))),J}prioritize(ie,V){const J=this.f(ie);if(J===-1){this.d.unshift({pattern:ie,matches:L.parse(D(ie))});return}const U=new Set(V.map(x=>this.f(x,J)));U.delete(-1);const ne=Array.from(U).sort();this.d.splice(J+1,0,...ne.map(x=>this.d[x]));for(let x=ne.length-1;x>=0;x--)this.d.splice(ne[x],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,V=this.d.length){const J=D(ie);for(let U=0;U<V;U++)if(this.d[U].matches(J))return U;return-1}}e.MimeTypeDisplayOrder=O;function t(_,ie,V,J=(U,ne)=>U===ne){const U=[];function ne(Y,ee,j){if(ee===0&&j.length===0)return;const P=U[U.length-1];P&&P.start+P.deleteCount===Y?(P.deleteCount+=ee,P.toInsert.push(...j)):U.push({start:Y,deleteCount:ee,toInsert:j})}let x=0,re=0;for(;;){if(x===_.length){ne(x,0,ie.slice(re));break}if(re===ie.length){ne(x,_.length-x,[]);break}const Y=_[x],ee=ie[re];if(J(Y,ee)){x+=1,re+=1;continue}V(ee)?(ne(x,1,[]),x+=1):(ne(x,0,[ee]),re+=1)}return U}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new m.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(_){_.default="default",_.option="option"})(n||(e.NotebookEditorPriority=n={}));function s(_){const ie=_;return!!((typeof ie.include=="string"||L.isRelativePattern(ie.include))&&(typeof ie.exclude=="string"||L.isRelativePattern(ie.exclude)))}e.isDocumentExcludePattern=s;function i(_,ie,V){if(Array.isArray(_.viewType)&&_.viewType.indexOf(ie)>=0||_.viewType===ie)return!0;if(_.filenamePattern){const J=s(_.filenamePattern)?_.filenamePattern.include:_.filenamePattern,U=s(_.filenamePattern)?_.filenamePattern.exclude:void 0;if(L.match(J,(0,R.basename)(V.fsPath).toLowerCase()))return!(U&&L.match(U,(0,R.basename)(V.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var a;(function(_){_[_.Left=1]="Left",_[_.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class l{static create(ie){return`${l.d}${ie}`}static parse(ie){if(ie.startsWith(l.d))return ie.substring(l.d.length)}}e.NotebookWorkingCopyTypeIdentifier=l,l.d="notebook/";function d(_){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(_)}e.isTextStreamMime=d;const I=new TextDecoder;function C(_){const ie=[];let V=!1;for(const J of _)(ie.length===0||V)&&(ie.push(J),V=!0);return $(ie),ge(S.VSBuffer.concat(ie.map(J=>S.VSBuffer.wrap(J))))}e.compressOutputItemStreams=C;const E=`${String.fromCharCode(27)}[A`,w=E.split("").map(_=>_.charCodeAt(0)),N=10;function $(_){_.forEach((ie,V)=>{if(V===0||ie.length<E.length)return;const J=_[V-1],U=ie.subarray(0,E.length);if(U[0]===w[0]&&U[1]===w[1]&&U[2]===w[2]){const ne=J.lastIndexOf(N);if(ne===-1)return;_[V-1]=J.subarray(0,ne),_[V]=ie.subarray(E.length)}})}function se(_){let ie=_;do _=ie,ie=_.replace(/[^\n]\x08/gm,"");while(ie.length<_.length);return _}function he(_){for(_=_.replace(/\r+\n/gm,`
`);_.search(/\r[^$]/g)>-1;){const ie=_.match(/^(.*)\r+/m)[1];let V=_.match(/\r+(.*)$/m)[1];V=V+ie.slice(V.length,ie.length),_=_.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return _}const ae="\b".charCodeAt(0),ue="\r".charCodeAt(0);function ge(_){return!_.buffer.includes(ae)&&!_.buffer.includes(ue)?_:S.VSBuffer.fromString(he(se(I.decode(_.buffer))))}}),define(pe[267],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,S.createDecorator)("environmentVariableService")}),define(pe[268],be([1,0,7,4,59,3,248,8]),function(le,e,S,L,o,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWorkspaceForTerminal=e.preparePathForShell=e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function b(s,i){if(i)if(A.isWindows)for(const a in i){let l=a;for(const I in s)if(a.toLowerCase()===I.toLowerCase()){l=I;break}const d=i[a];d!==void 0&&m(s,l,d)}else Object.keys(i).forEach(a=>{const l=i[a];l!==void 0&&m(s,a,l)})}e.mergeEnvironments=b;function m(s,i,a){typeof a=="string"?s[i]=a:delete s[i]}function T(s,i,a,l){s.TERM_PROGRAM="vscode",i&&(s.TERM_PROGRAM_VERSION=i),h(s,l)&&(s.LANG=g(a)),s.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=T;function y(s,i){if(i)for(const a of Object.keys(i)){const l=i[a];l!=null&&(s[a]=l)}}async function v(s,i){return await Promise.all(Object.entries(i).map(async([a,l])=>{if(typeof l=="string")try{i[a]=await s(l)}catch{i[a]=l}})),i}function h(s,i){if(i==="on")return!0;if(i==="auto"){const a=s.LANG;return!a||a.search(/\.UTF\-8$/)===-1&&a.search(/\.utf8$/)===-1&&a.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=h;function g(s){const i=s?s.split("-"):[],a=i.length;if(a===0)return"en_US.UTF-8";if(a===1){const l={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};i[0]in l&&i.push(l[i[0]])}else i[1]=i[1].toUpperCase();return i.join("_")+".UTF-8"}e.getLangEnvVariable=g;async function p(s,i,a,l,d,I){if(s.cwd){const E=typeof s.cwd=="object"?s.cwd.fsPath:s.cwd,w=await r(E,a);return(0,k.sanitizeCwd)(w||E)}let C;return!s.ignoreConfigurationCwd&&d&&(a&&(d=await r(d,a,I)),d&&(S.isAbsolute(d)?C=d:l&&(C=S.join(l.fsPath,d)))),C||(C=l?l.fsPath:i||""),(0,k.sanitizeCwd)(C)}e.getCwd=p;async function r(s,i,a){if(i)try{return await i(s)}catch(l){a?.error("Could not resolve terminal cwd",l);return}return s}function f(s,i,a){if(a)return l=>a.resolveWithEnvironment(i,s,l)}e.createVariableResolver=f;async function c(s,i,a,l,d,I,C,E=A.platform){let w;C&&(w=D(s,"automationShell",E)),w||(w=D(s,"shell",E));let N=w||i;if(E===3&&!a&&l){const $=S.join(l,"Sysnative").replace(/\//g,"\\").toLowerCase();N&&N.toLowerCase().indexOf($)===0&&(N=S.join(l,"System32",N.substr($.length+1)))}if(N&&E===3&&(N=N.replace(/\//g,"\\")),d)try{N=await d(N)}catch($){I.error("Could not resolve shell",$)}return N}e.getDefaultShell=c;async function u(s,i,a,l,d=A.platform){if(i&&D(s,"automationShell",d))return[];const I=d===3?"windows":d===1?"osx":"linux";let C=s(`terminal.integrated.shellArgs.${I}`);if(!C)return[];if(typeof C=="string"&&d===3)return a?await a(C):C;if(a){const E=[];for(const w of C)try{E.push(await a(w))}catch(N){l.error(`Could not resolve terminal.integrated.shellArgs.${I}`,N),E.push(w)}C=E}return C}e.getDefaultShellArgs=u;function D(s,i,a=A.platform){return s(`terminal.integrated.${i}.${a===3?"windows":a===1?"osx":"linux"}`)}async function O(s,i,a,l,d,I){const C={};if(s.strictEnv)y(C,s.env);else{y(C,I);const E={...i};a&&(E&&await v(a,E),s.env&&await v(a,s.env)),(0,o.sanitizeProcessEnvironment)(C,"VSCODE_IPC_HOOK_CLI"),b(C,E),b(C,s.env),T(C,l,A.language,d)}return C}e.createTerminalEnvironment=O;async function t(s,i,a,l,d,I,C=A.isWindows){let E;if((0,R.isString)(s)?E=s:(E=s.fsPath,C&&I!==1?E=E.replace(/\\/g,"/"):!C&&I===1&&(E=E.replace(/\//g,"\\"))),!i)return E;const w=E.includes(" "),N=E.includes("(")||E.includes(")"),$=S.basename(i,".exe"),se=$==="pwsh"||a==="pwsh"||$==="powershell"||a==="powershell";if(se&&(w||E.includes("'")))return`& '${E.replace(/'/g,"''")}'`;if(N&&se)return`& '${E}'`;if(I===1){if(l!==void 0)return l==="gitbash"?(0,k.escapeNonWindowsPath)(E.replace(/\\/g,"/")):l==="wsl"?d?.getWslPath(E,"win-to-unix")||E:w?`"${E}"`:E;const he=i.toLowerCase();return he.includes("wsl")||he.includes("bash.exe")&&!he.toLowerCase().includes("git")?d?.getWslPath(E,"win-to-unix")||E:w?`"${E}"`:E}return(0,k.escapeNonWindowsPath)(E)}e.preparePathForShell=t;function n(s,i,a){const l=typeof s=="string"?L.URI.parse(s):s;let d=l?(0,R.withNullAsUndefined)(i.getWorkspaceFolder(l)):void 0;if(!d){const I=a.getLastActiveWorkspaceRoot();d=I?(0,R.withNullAsUndefined)(i.getWorkspaceFolder(I)):void 0}return d}e.getWorkspaceForTerminal=n}),define(pe[69],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(A){A.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var L;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class o{static fromExtHostTestItem(k,R,b=k.parent){if(k._isRoot)return new o([R]);const m=[k.id];for(let T=b;T&&T.id!==R;T=T.parent)m.push(T.id);return m.push(R),new o(m.reverse())}static isRoot(k){return!k.includes("\0")}static root(k){const R=k.indexOf("\0");return R===-1?k:k.slice(0,R)}static fromString(k){return new o(k.split("\0"))}static join(k,R){return new o([...k.path,R])}static joinToString(k,R){return k.toString()+"\0"+R}static parentId(k){const R=k.lastIndexOf("\0");return R===-1?void 0:k.slice(0,R)}static localId(k){const R=k.lastIndexOf("\0");return R===-1?k:k.slice(R+1)}static isChild(k,R){return R.startsWith(k)&&R[k.length]==="\0"}static compare(k,R){return k===R?0:o.isChild(k,R)?2:o.isChild(R,k)?3:1}constructor(k,R=k.length){if(this.path=k,this.d=R,k.length===0||R<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new o(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let k=1;k<=this.d;k++)yield new o(this.path,k)}*idsToRoot(){for(let k=this.d;k>0;k--)yield new o(this.path,k)}compare(k){if(typeof k=="string")return o.compare(this.toString(),k);for(let R=0;R<k.d&&R<this.d;R++)if(k.path[R]!==this.path[R])return 1;return k.d>this.d?2:k.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let k=1;k<this.d;k++)this.c+="\0",this.c+=this.path[k]}return this.c}}e.TestId=o}),define(pe[89],be([1,0,4,49,69]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var k;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(k||(e.ExtTestRunProfileKind=k={}));var R;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})(R||(e.TestRunProfileBitset=R={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const b=I=>"runId"in I;e.isStartControllerTests=b;var m;(function(I){I.serialize=C=>({range:C.range.toJSON(),uri:C.uri.toJSON()}),I.deserialize=C=>({range:L.Range.lift(C.range),uri:S.URI.revive(C.uri)})})(m||(e.IRichLocation=m={}));var T;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(T||(e.TestMessageType=T={}));var y;(function(I){I.serialize=C=>({message:C.message,type:0,expected:C.expected,actual:C.actual,location:C.location&&m.serialize(C.location)}),I.deserialize=C=>({message:C.message,type:0,expected:C.expected,actual:C.actual,location:C.location&&m.deserialize(C.location)})})(y||(e.ITestErrorMessage=y={}));const v=(I,C)=>`${C?"s":"e"}${I}`;e.getMarkId=v;var h;(function(I){I.serialize=C=>({message:C.message,type:1,offset:C.offset,length:C.length,location:C.location&&m.serialize(C.location)}),I.deserialize=C=>({message:C.message,type:1,offset:C.offset,length:C.length,location:C.location&&m.deserialize(C.location)})})(h||(e.ITestOutputMessage=h={}));var g;(function(I){I.serialize=C=>C.type===0?y.serialize(C):h.serialize(C),I.deserialize=C=>C.type===0?y.deserialize(C):h.deserialize(C)})(g||(e.ITestMessage=g={}));var p;(function(I){I.serializeWithoutMessages=C=>({state:C.state,duration:C.duration,messages:[]}),I.serialize=C=>({state:C.state,duration:C.duration,messages:C.messages.map(g.serialize)}),I.deserialize=C=>({state:C.state,duration:C.duration,messages:C.messages.map(g.deserialize)})})(p||(e.ITestTaskState=p={}));const r="\0",f=(I,C)=>I+r+C;e.namespaceTestTag=f;const c=I=>{const C=I.indexOf(r);return{ctrlId:I.slice(0,C),tagId:I.slice(C+1)}};e.denamespaceTestTag=c;var u;(function(I){I.serialize=C=>({extId:C.extId,label:C.label,tags:C.tags,busy:C.busy,children:void 0,uri:C.uri?.toJSON(),range:C.range?.toJSON()||null,description:C.description,error:C.error,sortText:C.sortText}),I.deserialize=C=>({extId:C.extId,label:C.label,tags:C.tags,busy:C.busy,children:void 0,uri:C.uri?S.URI.revive(C.uri):void 0,range:C.range?L.Range.lift(C.range):null,description:C.description,error:C.error,sortText:C.sortText})})(u||(e.ITestItem=u={}));var D;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(D||(e.TestItemExpandState=D={}));var O;(function(I){I.serialize=C=>({expand:C.expand,item:u.serialize(C.item)}),I.deserialize=C=>({controllerId:o.TestId.root(C.item.extId),expand:C.expand,item:u.deserialize(C.item)})})(O||(e.InternalTestItem=O={}));var t;(function(I){I.serialize=C=>{let E;return C.item&&(E={},C.item.label!==void 0&&(E.label=C.item.label),C.item.tags!==void 0&&(E.tags=C.item.tags),C.item.busy!==void 0&&(E.busy=C.item.busy),C.item.uri!==void 0&&(E.uri=C.item.uri?.toJSON()),C.item.range!==void 0&&(E.range=C.item.range?.toJSON()),C.item.description!==void 0&&(E.description=C.item.description),C.item.error!==void 0&&(E.error=C.item.error),C.item.sortText!==void 0&&(E.sortText=C.item.sortText)),{extId:C.extId,expand:C.expand,item:E}},I.deserialize=C=>{let E;return C.item&&(E={},C.item.label!==void 0&&(E.label=C.item.label),C.item.tags!==void 0&&(E.tags=C.item.tags),C.item.busy!==void 0&&(E.busy=C.item.busy),C.item.range!==void 0&&(E.range=C.item.range?L.Range.lift(C.item.range):null),C.item.description!==void 0&&(E.description=C.item.description),C.item.error!==void 0&&(E.error=C.item.error),C.item.sortText!==void 0&&(E.sortText=C.item.sortText)),{extId:C.extId,expand:C.expand,item:E}}})(t||(e.ITestItemUpdate=t={}));const n=(I,C)=>{C.expand!==void 0&&(I.expand=C.expand),C.item!==void 0&&(I.item=I.item?Object.assign(I.item,C.item):C.item)};e.applyTestItemUpdate=n;var s;(function(I){I.serializeWithoutMessages=C=>({...O.serialize(C),ownComputedState:C.ownComputedState,computedState:C.computedState,tasks:C.tasks.map(p.serializeWithoutMessages)}),I.serialize=C=>({...O.serialize(C),ownComputedState:C.ownComputedState,computedState:C.computedState,tasks:C.tasks.map(p.serialize)}),I.deserialize=C=>({...O.deserialize(C),ownComputedState:C.ownComputedState,computedState:C.computedState,tasks:C.tasks.map(p.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var i;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(i||(e.DetailType=i={}));var a;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(a||(e.TestDiffOpType=a={}));var l;(function(I){I.deserialize=C=>C.op===0?{op:C.op,item:O.deserialize(C.item)}:C.op===1?{op:C.op,item:t.deserialize(C.item)}:C.op===2?{op:C.op,uri:S.URI.revive(C.uri),docv:C.docv}:C,I.serialize=C=>C.op===0?{op:C.op,item:O.serialize(C.item)}:C.op===1?{op:C.op,item:t.serialize(C.item)}:C})(l||(e.TestsDiffOp=l={}));class d{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(C){const E=this.o();for(const w of C)switch(w.op){case 0:this.j(O.deserialize(w.item),E);break;case 1:this.k(t.deserialize(w.item),E);break;case 3:this.l(w.itemId,E);break;case 5:this.m(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.c.set(w.tag.id,w.tag);break;case 7:this.c.delete(w.id);break}E.complete?.()}j(C,E){const w=o.TestId.parentId(C.item.extId)?.toString();let N;if(!w)N=this.p(C),this.f.add(N),this.d.set(C.item.extId,N);else if(this.d.has(w)){const $=this.d.get(w);$.children.add(C.item.extId),N=this.p(C,$),this.d.set(C.item.extId,N)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(C)}`);return}return E.add?.(N),C.expand===2&&this.g++,N}k(C,E){const w=this.d.get(C.extId);if(w)return C.expand!==void 0&&(w.expand===2&&this.g--,C.expand===2&&this.g++),(0,e.applyTestItemUpdate)(w,C),E.update?.(w),w}l(C,E){const w=this.d.get(C);if(!w)return;const N=o.TestId.parentId(w.item.extId)?.toString();N?this.d.get(N).children.delete(w.item.extId):this.f.delete(w);const $=[[C]];for(;$.length;)for(const se of $.pop()){const he=this.d.get(se);he&&($.push(he.children),this.d.delete(se),E.remove?.(he,he!==w),he.expand===2&&this.g--)}}m(C){}updatePendingRoots(C){this.h+=C}o(){return{}}}e.AbstractIncrementalTestCollection=d}),define(pe[130],be([1,0,14,6,2,92,89,69]),function(le,e,S,L,o,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var b;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const m=(c,u)=>c===u,y=Object.entries({range:(c,u)=>c===u?!0:!c||!u?!1:c.equalsRange(u),busy:m,label:m,description:m,error:m,sortText:m,tags:(c,u)=>!(c.length!==u.length||c.some(D=>!u.includes(D)))}),v=(c,u)=>{let D;for(const[O,t]of y)t(c[O],u[O])||(D?D[O]=u[O]:D={[O]:u[O]});return D};class h extends o.Disposable{get root(){return this.m.root}constructor(u){super(),this.m=u,this.f=this.B(new S.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new L.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(u){this.h=u;for(const D of this.tree.values())this.G(D)}get resolveHandler(){return this.h}collectDiff(){const u=this.k;return this.k=[],u}pushDiff(u){switch(u.op){case 2:{for(const D of this.k)if(D.op===2&&D.uri===u.uri){D.docv=u.docv;return}break}case 1:{const D=this.k[this.k.length-1];if(D){if(D.op===1&&D.item.extId===u.item.extId){(0,k.applyTestItemUpdate)(D.item,u.item);return}if(D.op===0&&D.item.item.extId===u.item.extId){(0,k.applyTestItemUpdate)(D.item,u.item);return}}break}}this.k.push(u),this.f.isScheduled()||this.f.schedule()}expand(u,D){const O=this.tree.get(u);if(O){if((O.expandLevels===void 0||D>O.expandLevels)&&(O.expandLevels=D),O.expand===1){const t=this.I(O);return t.isOpen()?this.H(O,D-1):t.wait().then(()=>this.H(O,D-1))}else if(O.expand===3)return O.resolveBarrier?.isOpen()===!1?O.resolveBarrier.wait().then(()=>this.H(O,D-1)):this.H(O,D-1)}}dispose(){for(const u of this.tree.values())this.m.getApiFor(u.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(u,D){switch(D.op){case 3:this.L(R.TestId.joinToString(u.fullId,D.id));break;case 0:this.u(D.item,u);break;case 5:for(const O of D.ops)this.p(u,O);break;case 1:this.w(D.new,D.old,u.fullId.toString());break;case 2:this.G(u);break;case 4:this.pushDiff({op:1,item:{extId:u.fullId.toString(),item:D.update}});break;case 6:this.s(u.actual.uri);break;default:(0,A.assertNever)(D)}}s(u){u&&this.pushDiff({op:2,uri:u,docv:this.m.getDocumentVersion(u)})}u(u,D){const O=R.TestId.fromExtHostTestItem(u,this.root.id,D?.actual),t=this.m.getApiFor(u);t.parent&&t.parent!==D?.actual&&this.m.getChildren(t.parent).delete(u.id);let n=this.tree.get(O.toString());if(!n){n={fullId:O,actual:u,expandLevels:D?.expandLevels?D.expandLevels-1:void 0,expand:0},u.tags.forEach(this.y,this),this.tree.set(n.fullId.toString(),n),this.C(u,D),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:n.expand,item:this.m.toITestItem(u)}}),this.F(u,n,D);return}if(n.actual===u){this.D(u,n,D);return}if(n.actual.uri?.toString()!==u.uri?.toString())return this.L(O.toString()),this.u(u,D);const s=this.m.getChildren(n.actual),i=n.actual,a=v(this.m.toITestItem(i),this.m.toITestItem(u));this.m.getApiFor(i).listener=void 0,n.actual=u,n.expand=0,a&&(a.hasOwnProperty("tags")&&(this.w(u.tags,i.tags,O.toString()),delete a.tags),this.p(n,{op:4,update:a})),this.F(u,n,D);for(const[l,d]of s)this.m.getChildren(u).get(d.id)||this.L(R.TestId.joinToString(O,d.id));this.s(n.actual.uri)}w(u,D,O){const t=new Set(D.map(n=>n.id));for(const n of u)t.delete(n.id)||this.y(n);this.pushDiff({op:1,item:{extId:O,item:{tags:u.map(n=>(0,k.namespaceTestTag)(this.m.controllerId,n.id))}}}),t.forEach(this.z,this)}y(u){const D=this.j.get(u.id);D?D.refCount++:(this.j.set(u.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,k.namespaceTestTag)(this.m.controllerId,u.id)}}))}z(u){const D=this.j.get(u);D&&!--D.refCount&&(this.j.delete(u),this.pushDiff({op:7,id:(0,k.namespaceTestTag)(this.m.controllerId,u)}))}C(u,D){this.m.getApiFor(u).parent=D&&D.actual!==this.root?D.actual:void 0}D(u,D,O){this.C(u,O);const t=this.m.getApiFor(u);t.parent=O?.actual,t.listener=n=>this.p(D,n),this.G(D)}F(u,D,O){this.D(u,D,O);for(const[t,n]of this.m.getChildren(u))this.u(n,D)}G(u){let D;this.h?u.resolveBarrier?D=u.resolveBarrier.isOpen()?3:2:D=u.actual.canResolveChildren?1:0:D=0,D!==u.expand&&(u.expand=D,this.pushDiff({op:1,item:{extId:u.fullId.toString(),expand:D}}),D===1&&u.expandLevels!==void 0&&this.I(u))}H(u,D){if(D<0)return;const O=[];for(const[t,n]of this.m.getChildren(u.actual)){const s=this.expand(R.TestId.joinToString(u.fullId,n.id),D);(0,S.isThenable)(s)&&O.push(s)}if(O.length)return Promise.all(O).then(()=>{})}I(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this.h){const n=new S.Barrier;return n.open(),n}u.expand=2,this.J(u);const D=u.resolveBarrier=new S.Barrier,O=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,n)};let t;try{t=this.h(u.actual===this.root?void 0:u.actual)}catch(n){O(n)}return(0,S.isThenable)(t)?t.catch(O).then(()=>{D.open(),this.G(u)}):(D.open(),this.G(u)),u.resolveBarrier}J(u){this.pushDiff({op:1,item:{extId:u.fullId.toString(),expand:u.expand}})}L(u){const D=this.tree.get(u);if(!D)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:u});const O=[D];for(;O.length;){const t=O.pop();if(t){this.m.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.z(n.id);this.tree.delete(t.fullId.toString());for(const[n,s]of this.m.getChildren(t.actual))O.push(this.tree.get(R.TestId.joinToString(t.fullId,s.id)))}}}flushDiff(){const u=this.collectDiff();u.length&&this.g.fire(u)}}e.TestItemCollection=h;class g extends Error{constructor(u){super(`Attempted to insert a duplicate test item ID ${u}`)}}e.DuplicateTestItemError=g;class p extends Error{constructor(u){super(`TestItem with ID "${u}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class r extends Error{constructor(u,D,O){super(`TestItem with ID "${u}" is from controller "${D}" and cannot be added as a child of an item from controller "${O}".`)}}e.MixedTestItemController=r;const f=(c,u,D)=>{let O=new Map;return{get size(){return O.size},forEach(t,n){for(const s of O.values())t.call(n,s,this)},[Symbol.iterator](){return O.entries()},replace(t){const n=new Map,s=new Set(O.keys()),i={op:5,ops:[]};for(const a of t){if(!(a instanceof D))throw new p(a.id);const l=u(a).controllerId;if(l!==c.controllerId)throw new r(a.id,l,c.controllerId);if(n.has(a.id))throw new g(a.id);n.set(a.id,a),s.delete(a.id),i.ops.push({op:0,item:a})}for(const a of s.keys())i.ops.push({op:3,id:a});c.listener?.(i),O=n},add(t){if(!(t instanceof D))throw new p(t.id);O.set(t.id,t),c.listener?.({op:0,item:t})},delete(t){O.delete(t)&&c.listener?.({op:3,id:t})},get(t){return O.get(t)},toJSON(){return Array.from(O.values())}}};e.createTestItemChildren=f}),define(pe[131],be([1,0,130]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const L=new WeakMap,o=(k,R)=>{const b={controllerId:R};return L.set(k,b),b};e.createPrivateApiFor=o;const A=k=>{const R=L.get(k);if(!R)throw new S.InvalidTestItemError(k?.id||"<unknown>");return R};e.getPrivateApiFor=A}),define(pe[269],be([1,0,24,5]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5,6],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,L.refineServiceDecorator)(S.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(pe[132],be([1,0,5]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,S.createDecorator)("configurationResolverService");var L;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(L||(e.VariableKind=L={}));class o extends Error{constructor(k,R){super(R),this.variable=k}}e.VariableError=o}),define(pe[270],be([1,0,7,29,8,21,3,161,199,132,17]),function(le,e,S,L,o,A,k,R,b,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class y{constructor(h,g,p,r){this.h=new Map,this.a=h,this.b=g,this.g=p,r&&(this.c=r.then(f=>this.i(f)))}i(h){if(k.isWindows){const g=Object.create(null);return Object.keys(h).forEach(p=>{g[p.toLowerCase()]=h[p]}),g}return h}resolveWithEnvironment(h,g,p){return this.l({env:this.i(h),userHome:void 0},g?g.uri:void 0,p)}async resolveAsync(h,g){const p={env:await this.c,userHome:await this.g};return this.l(p,h?h.uri:void 0,g)}async j(h,g,p,r){const f=A.deepClone(g);k.isWindows&&f.windows?Object.keys(f.windows).forEach(u=>f[u]=f.windows[u]):k.isMacintosh&&f.osx?Object.keys(f.osx).forEach(u=>f[u]=f.osx[u]):k.isLinux&&f.linux&&Object.keys(f.linux).forEach(u=>f[u]=f.linux[u]),delete f.windows,delete f.osx,delete f.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,h?h.uri:void 0,f,p,r)}async resolveAnyAsync(h,g,p){return this.j(h,g,p)}async resolveAnyMap(h,g,p){const r=new Map;return{newConfig:await this.j(h,g,p,r),resolvedVariables:r}}resolveWithInteractionReplace(h,g,p,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(h,g,p,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(h,g){if(this.h.has(h))throw new Error("Variable "+h+" is contributed twice.");this.h.set(h,g)}async l(h,g,p,r,f){if(o.isString(p))return this.m(h,g,p,r,f);if(Array.isArray(p))return Promise.all(p.map(c=>this.l(h,g,c,r,f)));if(o.isObject(p)){const c=Object.create(null),u=await Promise.all(Object.keys(p).map(async D=>[await this.m(h,g,D,r,f),await this.l(h,g,p[D],r,f)]));for(const[D,O]of u)c[D]=O;return c}return p}m(h,g,p,r,f){return(0,T.replaceAsync)(p,y.VARIABLE_REGEXP,async(c,u)=>{if(u.includes(y.VARIABLE_LHS))return c;let D=await this.o(h,c,u,g,r);return f?.set(u,D),D!==c&&o.isString(D)&&D.match(y.VARIABLE_REGEXP)&&(D=await this.m(h,g,D,r,f)),D})}n(h){return this.b?this.b.getUriLabel(h,{noPrefix:!0}):h.fsPath}async o(h,g,p,r,f){let c;const u=p.split(":");u.length>1&&(p=u[0],c=u[1]);const D=n=>{const s=this.a.getFilePath();if(s)return(0,R.normalizeDriveLetter)(s);throw new m.VariableError(n,(0,b.localize)(0,null,g))},O=n=>{const s=D(n);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,R.normalizeDriveLetter)(i)}throw new m.VariableError(n,(0,b.localize)(1,null,g,S.basename(s)))},t=n=>{if(c){const s=this.a.getFolderUri(c);if(s)return s;throw new m.VariableError(n,(0,b.localize)(2,null,g,c))}if(r)return r;throw this.a.getWorkspaceFolderCount()>1?new m.VariableError(n,(0,b.localize)(3,null,g)):new m.VariableError(n,(0,b.localize)(4,null,g))};switch(p){case"env":if(c){if(h.env){const n=h.env[k.isWindows?c.toLowerCase():c];if(o.isString(n))return n}return""}throw new m.VariableError(m.VariableKind.Env,(0,b.localize)(5,null,g));case"config":if(c){const n=this.a.getConfigurationValue(r,c);if(o.isUndefinedOrNull(n))throw new m.VariableError(m.VariableKind.Config,(0,b.localize)(6,null,g,c));if(o.isObject(n))throw new m.VariableError(m.VariableKind.Config,(0,b.localize)(7,null,g,c));return n}throw new m.VariableError(m.VariableKind.Config,(0,b.localize)(8,null,g));case"command":return this.p(m.VariableKind.Command,g,c,f,"command");case"input":return this.p(m.VariableKind.Input,g,c,f,"input");case"extensionInstallFolder":if(c){const n=await this.a.getExtension(c);if(!n)throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,b.localize)(9,null,g,c));return this.n(n.extensionLocation)}throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,b.localize)(10,null,g));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.n(t(m.VariableKind.WorkspaceFolder)));case"cwd":return r||c?(0,R.normalizeDriveLetter)(this.n(t(m.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(S.basename(this.n(t(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(h.userHome)return h.userHome;throw new m.VariableError(m.VariableKind.UserHome,(0,b.localize)(11,null,g))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new m.VariableError(m.VariableKind.LineNumber,(0,b.localize)(12,null,g))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new m.VariableError(m.VariableKind.SelectedText,(0,b.localize)(13,null,g))}case"file":return D(m.VariableKind.File);case"fileWorkspaceFolder":return O(m.VariableKind.FileWorkspaceFolder);case"relativeFile":return r||c?S.relative(this.n(t(m.VariableKind.RelativeFile)),D(m.VariableKind.RelativeFile)):D(m.VariableKind.RelativeFile);case"relativeFileDirname":{const n=S.dirname(D(m.VariableKind.RelativeFileDirname));if(r||c){const s=S.relative(this.n(t(m.VariableKind.RelativeFileDirname)),n);return s.length===0?".":s}return n}case"fileDirname":return S.dirname(D(m.VariableKind.FileDirname));case"fileExtname":return S.extname(D(m.VariableKind.FileExtname));case"fileBasename":return S.basename(D(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=S.basename(D(m.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-S.extname(n).length)}case"fileDirnameBasename":return S.basename(S.dirname(D(m.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||g}case"execInstallFolder":{const n=this.a.getAppRoot();return n||g}case"pathSeparator":return S.sep;default:try{const n=c?`${p}:${c}`:p;return this.p(m.VariableKind.Unknown,g,n,f,void 0)}catch{return g}}}}p(h,g,p,r,f){if(p&&r){const c=f===void 0?r[p]:r[f+":"+p];if(typeof c=="string")return c;throw new m.VariableError(h,(0,b.localize)(14,null,g))}return g}}e.AbstractVariableResolverService=y,y.VARIABLE_LHS="${",y.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(pe[271],be([1,0,5,88]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,S.createDecorator)("editorGroupsService");var o;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(o||(e.GroupDirection=o={}));var A;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var k;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(k||(e.GroupLocation=k={}));var R;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(R||(e.GroupsArrangement=R={}));var b;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function m(g){const p=g;return(0,L.isEditorInput)(p?.editor)&&(0,L.isEditorInput)(p?.replacement)}e.isEditorReplacement=m;var T;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var y;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function v(g){const p=g;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=v;function h(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=h}),define(pe[133],be([1,0,5,271]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,S.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function o(A){const k=A;return typeof A=="number"||(0,L.isEditorGroup)(k)}e.isPreferredGroup=o}),define(pe[272],be([1,0,8,269,12,115,87,86,132,88,133,13,219,267]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let g=e.RemoteTerminalChannelClient=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(r,f,c,u,D,O,t,n,s,i){this.a=r,this.b=f,this.c=c,this.d=u,this.e=D,this.f=O,this.g=t,this.h=n,this.i=s,this.j=i}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(r,f,c,u,D,O,t,n){await this.c.whenRemoteConfigurationLoaded();const s=Object.create(null),i=c?(0,S.withNullAsUndefined)(this.d.getWorkspaceFolder(c)):void 0;let a;try{a=(await this.e.resolveAnyMap(i,{shellLaunchConfig:r,configuration:f})).resolvedVariables}catch(se){this.h.error(se)}if(a)for(const[se,he]of a.entries())(/^config:/.test(se)||se==="selectedText"||se==="lineNumber")&&(s[se]=he);const l=[];for(const[se,he]of this.f.collections.entries())l.push([se,(0,R.serializeEnvironmentVariableCollection)(he.map),(0,R.serializeEnvironmentDescriptionMap)(he.descriptionMap)]);const d=await this.g.resolveAuthority(this.a),I=d.options&&d.options.extensionHostEnv,C=this.d.getWorkspace(),E=C.folders,w=c?this.d.getWorkspaceFolder(c):null,N=m.EditorResourceAccessor.getOriginalUri(this.i.activeEditor,{supportSideBySide:m.SideBySideEditor.PRIMARY,filterByScheme:[y.Schemas.file,y.Schemas.vscodeUserData,y.Schemas.vscodeRemote]}),$={configuration:f,resolvedVariables:s,envVariableCollections:l,shellLaunchConfig:r,workspaceId:C.id,workspaceName:this.j.getWorkspaceLabel(C),workspaceFolders:E,activeWorkspaceFolder:w,activeFileResource:N,shouldPersistTerminal:D,options:u,cols:O,rows:t,unicodeVersion:n,resolverEnv:I};return await this.b.call("$createProcess",$)}requestDetachInstance(r,f){return this.b.call("$requestDetachInstance",[r,f])}acceptDetachInstanceReply(r,f){return this.b.call("$acceptDetachInstanceReply",[r,f])}attachToProcess(r){return this.b.call("$attachToProcess",[r])}detachFromProcess(r,f){return this.b.call("$detachFromProcess",[r,f])}listProcesses(){return this.b.call("$listProcesses")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(r,f){return this.b.call("$processBinary",[r,f])}start(r){return this.b.call("$start",[r])}input(r,f){return this.b.call("$input",[r,f])}acknowledgeDataEvent(r,f){return this.b.call("$acknowledgeDataEvent",[r,f])}setUnicodeVersion(r,f){return this.b.call("$setUnicodeVersion",[r,f])}shutdown(r,f){return this.b.call("$shutdown",[r,f])}resize(r,f,c){return this.b.call("$resize",[r,f,c])}getInitialCwd(r){return this.b.call("$getInitialCwd",[r])}getCwd(r){return this.b.call("$getCwd",[r])}orphanQuestionReply(r){return this.b.call("$orphanQuestionReply",[r])}sendCommandResult(r,f,c){return this.b.call("$sendCommandResult",[r,f,c])}freePortKillProcess(r){return this.b.call("$freePortKillProcess",[r])}installAutoReply(r,f){return this.b.call("$installAutoReply",[r,f])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(r){return this.b.call("$getDefaultSystemShell",[r])}getProfiles(r,f,c){return this.b.call("$getProfiles",[this.d.getWorkspace().id,r,f,c])}acceptPtyHostResolvedVariables(r,f){return this.b.call("$acceptPtyHostResolvedVariables",[r,f])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(r,f){return this.b.call("$getWslPath",[r,f])}setTerminalLayoutInfo(r){const c={workspaceId:this.d.getWorkspace().id,tabs:r?r.tabs:[]};return this.b.call("$setTerminalLayoutInfo",c)}updateTitle(r,f,c){return this.b.call("$updateTitle",[r,f,c])}updateIcon(r,f,c,u){return this.b.call("$updateIcon",[r,f,c,u])}refreshProperty(r,f){return this.b.call("$refreshProperty",[r,f])}updateProperty(r,f,c){return this.b.call("$updateProperty",[r,f,c])}getTerminalLayoutInfo(){const f={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",f)}reviveTerminalProcesses(r,f){return this.b.call("$reviveTerminalProcesses",[r,f])}getRevivedPtyNewId(r){return this.b.call("$getRevivedPtyNewId",[r])}serializeTerminalState(r){return this.b.call("$serializeTerminalState",[r])}};e.RemoteTerminalChannelClient=g=Le([Ae(2,L.IWorkbenchConfigurationService),Ae(3,k.IWorkspaceContextService),Ae(4,b.IConfigurationResolverService),Ae(5,h.IEnvironmentVariableService),Ae(6,A.IRemoteAuthorityResolverService),Ae(7,o.ILogService),Ae(8,T.IEditorService),Ae(9,v.ILabelService)],g)}),define(pe[273],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var S;(function(T){T[T.IPC=1]="IPC",T[T.Socket=2]="Socket",T[T.MessagePort=3]="MessagePort"})(S||(e.ExtHostConnectionType=S={}));class L{constructor(y){this.pipeName=y,this.type=1}serialize(y){y[L.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=L,L.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class o{constructor(){this.type=2}serialize(y){y[o.ENV_KEY]="1"}}e.SocketExtHostConnection=o,o.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class A{constructor(){this.type=3}serialize(y){y[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A,A.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function k(T){delete T[L.ENV_KEY],delete T[o.ENV_KEY],delete T[A.ENV_KEY]}function R(T,y){k(y),T.serialize(y)}e.writeExtHostConnection=R;function b(T){if(T[L.ENV_KEY])return m(T,new L(T[L.ENV_KEY]));if(T[o.ENV_KEY])return m(T,new o);if(T[A.ENV_KEY])return m(T,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=b;function m(T,y){return k(T),y}}),define(pe[274],be([1,0,15]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(L||(e.UIKind=L={}));var o;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(o||(e.ExtensionHostExitCode=o={}));var A;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function k(m){const T=S.VSBuffer.alloc(1);switch(m){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}e.createMessageOfType=k;function R(m,T){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}e.isMessageOfType=R;var b;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(pe[275],be([1,0,5,6,12,263,274,56,37,21,4,2,197]),function(le,e,S,L,o,A,k,R,b,m,T,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let h=e.ExtHostTelemetry=class extends y.Disposable{constructor(f,c){super(),this.n=f,this.p=c,this.a=this.B(new L.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=T.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=c.createLogger(this.j,{id:b.extensionTelemetryLogChannelId,name:(0,v.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(u=>{(0,o.isLogLevel)(u)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===o.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(f,c,u){const D=this.getTelemetryDetails(),O=new g(c,u,f,this.k,this.i,this.getBuiltInCommonProperties(f),{isUsageEnabled:D.isUsageEnabled,isErrorsEnabled:D.isErrorsEnabled}),t=this.m.get(f.identifier.value)??[];return this.m.set(f.identifier.value,[...t,O]),O.apiTelemetryLogger}$initializeTelemetryLevel(f,c,u){this.f=f,this.g=c,this.c=u??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(f){const c=Object.create(null);switch(c["common.extname"]=`${f.publisher}.${f.name}`,c["common.extversion"]=f.version,c["common.vscodemachineid"]=this.n.telemetryInfo.machineId,c["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,c["common.vscodeversion"]=this.n.version,c["common.isnewappinstall"]=p(this.n.telemetryInfo.firstSessionDate),c["common.product"]=this.n.environment.appHost,this.n.uiKind){case k.UIKind.Web:c["common.uikind"]="web";break;case k.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,R.getRemoteName)((0,b.cleanRemoteAuthority)(this.n.remote.authority)),c}$onDidChangeTelemetryLevel(f){this.h=this.getTelemetryConfiguration(),this.f=f;const c=this.getTelemetryDetails();this.m.forEach((u,D)=>{const O=u.filter(t=>!t.isDisposed);O.length===0?this.m.delete(D):this.m.set(D,O)}),this.m.forEach(u=>{for(const D of u)D.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(f,c){const D=this.m.get(f.value)?.filter(t=>!t.isDisposed);if(!D)return this.m.delete(f.value),!1;let O=!1;for(const t of D)t.ignoreUnhandledExtHostErrors||(t.logError(c),O=!0);return O}};e.ExtHostTelemetry=h=Le([Ae(0,A.IExtHostInitDataService),Ae(1,o.ILoggerService)],h);class g{static validateSender(f){if(typeof f!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof f.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof f.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof f.flush<"u"&&typeof f.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(f,c,u,D,O,t,n){this.g=u,this.h=D,this.i=O,this.j=t,this.a=new L.Emitter,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=f,this.d={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(f,c){this.e&&(this.d={isUsageEnabled:f,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(f){let c="properties"in f?f.properties??{}:f;return c=(0,b.cleanData)(c,[]),this.c&&(c=(0,m.mixin)(c,this.c)),this.b||(c=(0,m.mixin)(c,this.j)),"properties"in f?f.properties=c:f=c,f}k(f,c){this.f&&(this.g.publisher==="vscode"?f=this.g.name+"/"+f:f=this.g.identifier.value+"/"+f,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(f,c),this.h.trace(f,c))}logUsage(f,c){this.d.isUsageEnabled&&this.k(f,c)}logError(f,c){!this.d.isErrorsEnabled||!this.f||(typeof f=="string"?this.k(f,c):this.f.sendErrorData(f,c))}get apiTelemetryLogger(){if(!this.e){const f=this,c={logUsage:f.logUsage.bind(f),get isUsageEnabled(){return f.d.isUsageEnabled},get isErrorsEnabled(){return f.d.isErrorsEnabled},logError:f.logError.bind(f),dispose:f.dispose.bind(f),onDidChangeEnableStates:f.a.event.bind(f)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let f=this.f;this.f=void 0,Promise.resolve(f.flush()).then(f=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=g;function p(r){const f=Date.now()-new Date(r).getTime();return isNaN(f)?!1:f<1e3*60*60*24}e.isNewAppInstall=p,e.IExtHostTelemetry=(0,S.createDecorator)("IExtHostTelemetry")}),define(pe[276],be([1,0,6,4,35,230,34,5]),function(le,e,S,L,o,A,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new k.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,R.createDecorator)("extensionService");class b{constructor(O){this.dependency=O}}e.MissingExtensionDependency=b;var m;(function(D){D[D.EagerAutoStart=1]="EagerAutoStart",D[D.EagerManualStart=2]="EagerManualStart",D[D.Lazy=3]="Lazy"})(m||(e.ExtensionHostStartup=m={}));class T{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:A.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(O,t){const n=[],s=[],i=[],a=[],l=y(this.c),d=y(O),I=($,se)=>$.extensionLocation.toString()===se.extensionLocation.toString()||$.isBuiltin===se.isBuiltin||$.isUserBuiltin===se.isUserBuiltin||$.isUnderDevelopment===se.isUnderDevelopment;for(const $ of this.c){const se=d.get($.identifier);if(!se){n.push($.identifier),l.delete($.identifier);continue}if(!I($,se)){n.push($.identifier),l.delete($.identifier);continue}}for(const $ of O){const se=l.get($.identifier);if(!se){s.push($);continue}if(!I(se,$)){n.push(se.identifier),l.delete(se.identifier);continue}}const C=new k.ExtensionIdentifierSet(this.d),E=new k.ExtensionIdentifierSet(t);for(const $ of this.d)E.has($)||i.push($);for(const $ of t)C.has($)||a.push($);const w=A.ImplicitActivationEvents.createActivationEventsMap(s),N={toRemove:n,toAdd:s,addActivationEvents:w,myToRemove:i,myToAdd:a};return this.delta(N),N}delta(O){const{toRemove:t,toAdd:n,myToRemove:s,myToAdd:i}=O,a=new k.ExtensionIdentifierSet(t),l=new k.ExtensionIdentifierSet(s);for(let d=0;d<this.c.length;d++)a.has(this.c[d].identifier)&&(this.c.splice(d,1),d--);for(let d=0;d<this.d.length;d++)l.has(this.d[d])&&(this.d.splice(d,1),d--);for(const d of n)this.c.push(d);for(const d of i)this.d.push(d)}containsExtension(O){for(const t of this.d)if(k.ExtensionIdentifier.equals(t,O))return!0;return!1}}e.ExtensionHostExtensions=T;function y(D){const O=new k.ExtensionIdentifierMap;for(const t of D)O.set(t.identifier,t);return O}function v(D,O){return D.enabledApiProposals?D.enabledApiProposals.includes(O):!1}e.isProposedApiEnabled=v;function h(D,O){if(!v(D,O))throw new Error(`Extension '${D.identifier.value}' CANNOT use API proposal: ${O}.
Its package.json#enabledApiProposals-property declares: ${D.enabledApiProposals?.join(", ")??"[]"} but NOT ${O}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${D.identifier.value}`)}e.checkProposedApiEnabled=h;class g{constructor(O,t,n,s){this.codeLoadingTime=O,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=s}}e.ActivationTimes=g;class p{constructor(O,t){this.description=O,this.value=t}}e.ExtensionPointContribution=p;var r;(function(D){D[D.Normal=0]="Normal",D[D.Immediate=1]="Immediate"})(r||(e.ActivationKind=r={}));function f(D){return{type:D.isBuiltin?0:1,isBuiltin:D.isBuiltin||D.isUserBuiltin,identifier:{id:(0,o.getGalleryExtensionId)(D.publisher,D.name),uuid:D.uuid},manifest:D,location:D.extensionLocation,targetPlatform:D.targetPlatform,validations:[],isValid:!0}}e.toExtension=f;function c(D,O){return{identifier:new k.ExtensionIdentifier((0,o.getExtensionId)(D.manifest.publisher,D.manifest.name)),isBuiltin:D.type===0,isUserBuiltin:D.type===1&&D.isBuiltin,isUnderDevelopment:!!O,extensionLocation:D.location,...D.manifest,uuid:D.identifier.uuid,targetPlatform:D.targetPlatform}}e.toExtensionDescription=c;class u{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(O){return Promise.resolve(void 0)}activationEventIsDone(O){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(O){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(O,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(O){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=u});var kt=this&&this.__classPrivateFieldSet||function(le,e,S,L,o){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!o)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?le!==e||!o:!e.has(le))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?o.call(le,S):o?o.value=S:e.set(le,S),S},rt=this&&this.__classPrivateFieldGet||function(le,e,S,L){if(S==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?le!==e||!L:!e.has(le))throw new TypeError("Cannot read private member from an object whose class did not declare it");return S==="m"?L:S==="a"?L.call(le):L?L.value:e.get(le)};define(pe[134],be([1,0,18,11,99,27,58,17,8,4,22,34,16,115,129,276]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p){"use strict";var r,f,c,u,D,O,t,n,s,i,a,l,d,I,C,E,w,N,$,se,he,ae,ue,ge,_,ie;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.NotebookCodeActionKind=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function V(B){return Object.assign(B,{apply:function(){const oe=arguments.length===1?[]:arguments[1];return Reflect.construct(B,oe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(B,[]);{const[oe,...ve]=arguments;return Reflect.construct(B,ve,oe.constructor)}}})}var J;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(J||(e.TerminalOutputAnchor=J={}));var U;(function(B){B[B.Command=0]="Command",B[B.Opener=1]="Opener"})(U||(e.TerminalQuickFixType=U={}));let ne=e.Disposable=s=class{static from(...F){let oe=F;return new s(function(){if(oe){for(const ve of oe)ve&&typeof ve.dispose=="function"&&ve.dispose();oe=void 0}})}constructor(F){r.set(this,void 0),kt(this,r,F,"f")}dispose(){typeof rt(this,r,"f")=="function"&&(rt(this,r,"f").call(this),kt(this,r,void 0,"f"))}};r=new WeakMap,e.Disposable=ne=s=Le([V],ne);let x=e.Position=i=class{static Min(...F){if(F.length===0)throw new TypeError;let oe=F[0];for(let ve=1;ve<F.length;ve++){const Me=F[ve];Me.isBefore(oe)&&(oe=Me)}return oe}static Max(...F){if(F.length===0)throw new TypeError;let oe=F[0];for(let ve=1;ve<F.length;ve++){const Me=F[ve];Me.isAfter(oe)&&(oe=Me)}return oe}static isPosition(F){if(!F)return!1;if(F instanceof i)return!0;const{line:oe,character:ve}=F;return typeof oe=="number"&&typeof ve=="number"}static of(F){if(F instanceof i)return F;if(this.isPosition(F))return new i(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,oe){if(F<0)throw(0,L.illegalArgument)("line must be non-negative");if(oe<0)throw(0,L.illegalArgument)("character must be non-negative");this.c=F,this.e=oe}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,oe=0){if(F===null||oe===null)throw(0,L.illegalArgument)();let ve;return typeof F>"u"?ve=0:typeof F=="number"?ve=F:(ve=typeof F.lineDelta=="number"?F.lineDelta:0,oe=typeof F.characterDelta=="number"?F.characterDelta:0),ve===0&&oe===0?this:new i(this.line+ve,this.character+oe)}with(F,oe=this.character){if(F===null||oe===null)throw(0,L.illegalArgument)();let ve;return typeof F>"u"?ve=this.line:typeof F=="number"?ve=F:(ve=typeof F.line=="number"?F.line:this.line,oe=typeof F.character=="number"?F.character:this.character),ve===this.line&&oe===this.character?this:new i(ve,oe)}toJSON(){return{line:this.line,character:this.character}}};e.Position=x=i=Le([V],x);let re=e.Range=a=class{static isRange(F){return F instanceof a?!0:F?x.isPosition(F.start)&&x.isPosition(F.end):!1}static of(F){if(F instanceof a)return F;if(this.isRange(F))return new a(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,oe,ve,Me){let xe,_e;if(typeof F=="number"&&typeof oe=="number"&&typeof ve=="number"&&typeof Me=="number"?(xe=new x(F,oe),_e=new x(ve,Me)):x.isPosition(F)&&x.isPosition(oe)&&(xe=x.of(F),_e=x.of(oe)),!xe||!_e)throw new Error("Invalid arguments");xe.isBefore(_e)?(this.c=xe,this.e=_e):(this.c=_e,this.e=xe)}contains(F){return a.isRange(F)?this.contains(F.start)&&this.contains(F.end):x.isPosition(F)?!(x.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const oe=x.Max(F.start,this.c),ve=x.Min(F.end,this.e);if(!oe.isAfter(ve))return new a(oe,ve)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const oe=x.Min(F.start,this.c),ve=x.Max(F.end,this.end);return new a(oe,ve)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,oe=this.end){if(F===null||oe===null)throw(0,L.illegalArgument)();let ve;return F?x.isPosition(F)?ve=F:(ve=F.start||this.start,oe=F.end||this.end):ve=this.start,ve.isEqual(this.c)&&oe.isEqual(this.end)?this:new a(ve,oe)}toJSON(){return[this.start,this.end]}};e.Range=re=a=Le([V],re);let Y=e.Selection=l=class extends re{static isSelection(F){return F instanceof l?!0:F?re.isRange(F)&&x.isPosition(F.anchor)&&x.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,oe,ve,Me){let xe,_e;if(typeof F=="number"&&typeof oe=="number"&&typeof ve=="number"&&typeof Me=="number"?(xe=new x(F,oe),_e=new x(ve,Me)):x.isPosition(F)&&x.isPosition(oe)&&(xe=x.of(F),_e=x.of(oe)),!xe||!_e)throw new Error("Invalid arguments");super(xe,_e),this.f=xe,this.g=_e}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=Y=l=Le([V],Y);const ee=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,L.illegalArgument)("connectionToken")};class j{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,oe,ve){if(typeof F!="string"||F.length===0)throw(0,L.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,L.illegalArgument)("port");typeof ve<"u"&&ee(ve),this.host=F,this.port=Math.round(oe),this.connectionToken=ve}}e.ResolvedAuthority=j;class P{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,oe){this.makeConnection=F,this.connectionToken=oe,typeof oe<"u"&&ee(oe)}}e.ManagedResolvedAuthority=P;class M extends Error{static NotAvailable(F,oe){return new M(F,h.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(F){return new M(F,h.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,oe=h.RemoteAuthorityResolverErrorCode.Unknown,ve){super(F),this._message=F,this._code=oe,this._detail=ve,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M;var K;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(K||(e.EndOfLine=K={}));var te;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(te||(e.EnvironmentVariableMutatorType=te={}));let z=e.TextEdit=d=class{static isTextEdit(F){return F instanceof d?!0:F?re.isRange(F)&&typeof F.newText=="string":!1}static replace(F,oe){return new d(F,oe)}static insert(F,oe){return d.replace(new re(F,F),oe)}static delete(F){return d.replace(F,"")}static setEndOfLine(F){const oe=new d(new re(new x(0,0),new x(0,0)),"");return oe.newEol=F,oe}get range(){return this.c}set range(F){if(F&&!re.isRange(F))throw(0,L.illegalArgument)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,L.illegalArgument)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,L.illegalArgument)("newEol");this.f=F}constructor(F,oe){this.c=F,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.TextEdit=z=d=Le([V],z);let W=e.NotebookEdit=I=class{static isNotebookCellEdit(F){return F instanceof I?!0:F?Lt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,oe){return new I(F,oe)}static insertCells(F,oe){return new I(new Lt(F,F),oe)}static deleteCells(F){return new I(F,[])}static updateCellMetadata(F,oe){const ve=new I(new Lt(F,F),[]);return ve.newCellMetadata=oe,ve}static updateNotebookMetadata(F){const oe=new I(new Lt(0,0),[]);return oe.newNotebookMetadata=F,oe}constructor(F,oe){this.range=F,this.newCells=oe}};e.NotebookEdit=W=I=Le([V],W);class q{static isSnippetTextEdit(F){return F instanceof q?!0:F?re.isRange(F.range)&&G.isSnippetString(F.snippet):!1}static replace(F,oe){return new q(F,oe)}static insert(F,oe){return q.replace(new re(F,F),oe)}constructor(F,oe){this.range=F,this.snippet=oe}}e.SnippetTextEdit=q;var H;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(H||(e.FileEditType=H={}));let Q=e.WorkspaceEdit=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,oe,ve,Me){this.c.push({_type:1,from:F,to:oe,options:ve,metadata:Me})}createFile(F,oe,ve){this.c.push({_type:1,from:void 0,to:F,options:oe,metadata:ve})}deleteFile(F,oe,ve){this.c.push({_type:1,from:F,to:void 0,options:oe,metadata:ve})}e(F,oe,ve){this.c.push({_type:3,metadata:ve,uri:F,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(F,oe,ve,Me){const xe=oe.start,_e=oe.end;(xe!==_e||ve.length>0)&&this.c.push({_type:5,uri:F,index:xe,count:_e-xe,cells:ve,metadata:Me})}g(F,oe,ve,Me){this.c.push({_type:3,metadata:Me,uri:F,edit:{editType:8,index:oe,metadata:ve}})}replace(F,oe,ve,Me){this.c.push({_type:2,uri:F,edit:new z(oe,ve),metadata:Me})}insert(F,oe,ve,Me){this.replace(F,new re(oe,oe),ve,Me)}delete(F,oe,ve){this.replace(F,oe,"",ve)}has(F){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===F.toString())}set(F,oe){if(oe)for(const ve of oe){if(!ve)continue;let Me,xe;Array.isArray(ve)?(Me=ve[0],xe=ve[1]):Me=ve,W.isNotebookCellEdit(Me)?Me.newCellMetadata?this.g(F,Me.range.start,Me.newCellMetadata,xe):Me.newNotebookMetadata?this.e(F,Me.newNotebookMetadata,xe):this.f(F,Me.range,Me.newCells,xe):q.isSnippetTextEdit(Me)?this.c.push({_type:6,uri:F,range:Me.range,edit:Me.snippet,metadata:xe}):this.c.push({_type:2,uri:F,edit:Me,metadata:xe})}else{for(let ve=0;ve<this.c.length;ve++){const Me=this.c[ve];switch(Me._type){case 2:case 6:case 3:case 5:Me.uri.toString()===F.toString()&&(this.c[ve]=void 0);break}}(0,S.coalesceInPlace)(this.c)}}get(F){const oe=[];for(const ve of this.c)ve._type===2&&ve.uri.toString()===F.toString()&&oe.push(ve.edit);return oe}entries(){const F=new A.ResourceMap;for(const oe of this.c)if(oe._type===2){let ve=F.get(oe.uri);ve||(ve=[oe.uri,[]],F.set(oe.uri,ve)),ve[1].push(oe.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=Q=Le([V],Q);let G=e.SnippetString=C=class{static isSnippetString(F){return F instanceof C?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=C.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,oe=this.e++){if(typeof F=="function"){const ve=new C;ve.e=this.e,F(ve),this.e=ve.e,F=ve.value}else F=C.c(F);return this.value+="${",this.value+=oe,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,oe=this.e++){const ve=F.map(Me=>Me.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ve,this.value+="|}",this}appendVariable(F,oe){if(typeof oe=="function"){const ve=new C;ve.e=this.e,oe(ve),this.e=ve.e,oe=ve.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.SnippetString=G=C=Le([V],G);var Z;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(Z||(e.DiagnosticTag=Z={}));var ce;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ce||(e.DiagnosticSeverity=ce={}));let Ee=e.Location=E=class{static isLocation(F){return F instanceof E?!0:F?re.isRange(F.range)&&m.URI.isUri(F.uri):!1}constructor(F,oe){if(this.uri=F,oe)if(re.isRange(oe))this.range=re.of(oe);else if(x.isPosition(oe))this.range=new re(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=Ee=E=Le([V],Ee);let De=e.DiagnosticRelatedInformation=class{static is(F){return F?typeof F.message=="string"&&F.location&&re.isRange(F.location.range)&&m.URI.isUri(F.location.uri):!1}constructor(F,oe){this.location=F,this.message=oe}static isEqual(F,oe){return F===oe?!0:!F||!oe?!1:F.message===oe.message&&F.location.range.isEqual(oe.location.range)&&F.location.uri.toString()===oe.location.uri.toString()}};e.DiagnosticRelatedInformation=De=Le([V],De);let ke=e.Diagnostic=class{constructor(F,oe,ve=ce.Error){if(!re.isRange(F))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=F,this.message=oe,this.severity=ve}toJSON(){return{severity:ce[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,oe){return F===oe?!0:!F||!oe?!1:F.message===oe.message&&F.severity===oe.severity&&F.code===oe.code&&F.severity===oe.severity&&F.source===oe.source&&F.range.isEqual(oe.range)&&(0,S.equals)(F.tags,oe.tags)&&(0,S.equals)(F.relatedInformation,oe.relatedInformation,De.isEqual)}};e.Diagnostic=ke=Le([V],ke);let Fe=e.Hover=class{constructor(F,oe){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=oe}};e.Hover=Fe=Le([V],Fe);var ze;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(ze||(e.DocumentHighlightKind=ze={}));let me=e.DocumentHighlight=class{constructor(F,oe=ze.Text){this.range=F,this.kind=oe}toJSON(){return{range:this.range,kind:ze[this.kind]}}};e.DocumentHighlight=me=Le([V],me);var Se;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Se||(e.SymbolKind=Se={}));var we;(function(B){B[B.Deprecated=1]="Deprecated"})(we||(e.SymbolTag=we={}));let Ue=e.SymbolInformation=w=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,oe,ve,Me,xe){this.name=F,this.kind=oe,this.containerName=xe,typeof ve=="string"&&(this.containerName=ve),Me instanceof Ee?this.location=Me:ve instanceof re&&(this.location=new Ee(Me,ve)),w.validate(this)}toJSON(){return{name:this.name,kind:Se[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Ue=w=Le([V],Ue);let Be=e.DocumentSymbol=N=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(N.validate)}constructor(F,oe,ve,Me,xe){this.name=F,this.detail=oe,this.kind=ve,this.range=Me,this.selectionRange=xe,this.children=[],N.validate(this)}};e.DocumentSymbol=Be=N=Le([V],Be);var et;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(et||(e.CodeActionTriggerKind=et={}));let He=e.CodeAction=class{constructor(F,oe){this.title=F,this.kind=oe}};e.CodeAction=He=Le([V],He);let Ve=e.CodeActionKind=$=class{constructor(F){this.value=F}append(F){return new $(this.value?this.value+$.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+$.c)}};Ve.c=".",e.CodeActionKind=Ve=$=Le([V],Ve);class Ze extends Ve{constructor(F){super(F),this.value=F}}e.NotebookCodeActionKind=Ze,Ve.Empty=new Ve(""),Ve.QuickFix=Ve.Empty.append("quickfix"),Ve.Refactor=Ve.Empty.append("refactor"),Ve.RefactorExtract=Ve.Refactor.append("extract"),Ve.RefactorInline=Ve.Refactor.append("inline"),Ve.RefactorMove=Ve.Refactor.append("move"),Ve.RefactorRewrite=Ve.Refactor.append("rewrite"),Ve.Source=Ve.Empty.append("source"),Ve.SourceOrganizeImports=Ve.Source.append("organizeImports"),Ve.SourceFixAll=Ve.Source.append("fixAll"),Ve.Notebook=Ve.Empty.append("notebook");let it=e.SelectionRange=class{constructor(F,oe){if(this.range=F,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=it=Le([V],it);class Ke{constructor(F,oe,ve,Me,xe,_e){this.kind=F,this.name=oe,this.detail=ve,this.uri=Me,this.range=xe,this.selectionRange=_e}}e.CallHierarchyItem=Ke;class Xe{constructor(F,oe){this.fromRanges=oe,this.from=F}}e.CallHierarchyIncomingCall=Xe;class fe{constructor(F,oe){this.fromRanges=oe,this.to=F}}e.CallHierarchyOutgoingCall=fe;var Ce;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Ce||(e.LanguageStatusSeverity=Ce={}));let Te=e.CodeLens=class{constructor(F,oe){this.range=F,this.command=oe}get isResolved(){return!!this.command}};e.CodeLens=Te=Le([V],Te);let Re=e.MarkdownString=se=class{static isMarkdownString(F){return F instanceof se?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,oe=!1){f.set(this,void 0),kt(this,f,new o.MarkdownString(F,{supportThemeIcons:oe}),"f")}get value(){return rt(this,f,"f").value}set value(F){rt(this,f,"f").value=F}get isTrusted(){return rt(this,f,"f").isTrusted}set isTrusted(F){rt(this,f,"f").isTrusted=F}get supportThemeIcons(){return rt(this,f,"f").supportThemeIcons}set supportThemeIcons(F){rt(this,f,"f").supportThemeIcons=F}get supportHtml(){return rt(this,f,"f").supportHtml}set supportHtml(F){rt(this,f,"f").supportHtml=F}get baseUri(){return rt(this,f,"f").baseUri}set baseUri(F){rt(this,f,"f").baseUri=F}appendText(F){return rt(this,f,"f").appendText(F),this}appendMarkdown(F){return rt(this,f,"f").appendMarkdown(F),this}appendCodeblock(F,oe){return rt(this,f,"f").appendCodeblock(oe??"",F),this}};f=new WeakMap,e.MarkdownString=Re=se=Le([V],Re);let Oe=e.ParameterInformation=class{constructor(F,oe){this.label=F,this.documentation=oe}};e.ParameterInformation=Oe=Le([V],Oe);let $e=e.SignatureInformation=class{constructor(F,oe){this.label=F,this.documentation=oe,this.parameters=[]}};e.SignatureInformation=$e=Le([V],$e);let Ge=e.SignatureHelp=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=Ge=Le([V],Ge);var qe;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(qe||(e.SignatureHelpTriggerKind=qe={}));var tt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let Je=e.InlayHintLabelPart=class{constructor(F){this.value=F}};e.InlayHintLabelPart=Je=Le([V],Je);let Ye=e.InlayHint=class{constructor(F,oe,ve){this.position=F,this.label=oe,this.kind=ve}};e.InlayHint=Ye=Le([V],Ye);var at;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var gt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(gt||(e.CompletionItemKind=gt={}));var st;(function(B){B[B.Deprecated=1]="Deprecated"})(st||(e.CompletionItemTag=st={}));let Nt=e.CompletionItem=class{constructor(F,oe){this.label=F,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&gt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Nt=Le([V],Nt);let Et=e.CompletionList=class{constructor(F=[],oe=!1){this.items=F,this.isIncomplete=oe}};e.CompletionList=Et=Le([V],Et);let Ct=e.InlineSuggestion=class{constructor(F,oe,ve){this.insertText=F,this.range=oe,this.command=ve}};e.InlineSuggestion=Ct=Le([V],Ct);let dt=e.InlineSuggestionList=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.InlineSuggestionList=dt=Le([V],dt);var pt;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(pt||(e.ViewColumn=pt={}));var At;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(At||(e.StatusBarAlignment=At={}));function Ft(B,F){return`${y.ExtensionIdentifier.toKey(B)}.${F}`}e.asStatusBarItemIdentifier=Ft;var St;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(St||(e.TextEditorLineNumbersStyle=St={}));var Rt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Rt||(e.TextDocumentSaveReason=Rt={}));var Mt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Mt||(e.TextEditorRevealType=Mt={}));var ht;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(ht||(e.TextEditorSelectionChangeKind=ht={}));var Ut;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Dt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Dt||(e.DecorationRangeBehavior=Dt={})),function(B){function F(oe){switch(oe){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=F}(ht||(e.TextEditorSelectionChangeKind=ht={}));let ot=e.DocumentLink=class{constructor(F,oe){if(oe&&!m.URI.isUri(oe))throw(0,L.illegalArgument)("target");if(!re.isRange(F)||F.isEmpty)throw(0,L.illegalArgument)("range");this.range=F,this.target=oe}};e.DocumentLink=ot=Le([V],ot);let ye=e.Color=class{constructor(F,oe,ve,Me){this.red=F,this.green=oe,this.blue=ve,this.alpha=Me}};e.Color=ye=Le([V],ye);let Ie=e.ColorInformation=class{constructor(F,oe){if(oe&&!(oe instanceof ye))throw(0,L.illegalArgument)("color");if(!re.isRange(F)||F.isEmpty)throw(0,L.illegalArgument)("range");this.range=F,this.color=oe}};e.ColorInformation=Ie=Le([V],Ie);let de=e.ColorPresentation=class{constructor(F){if(!F||typeof F!="string")throw(0,L.illegalArgument)("label");this.label=F}};e.ColorPresentation=de=Le([V],de);var X;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(X||(e.ColorFormat=X={}));var Pe;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Pe||(e.SourceControlInputBoxValidationType=Pe={}));var Ne;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(Ne||(e.TerminalExitReason=Ne={}));class We{constructor(F,oe,ve){if(this.startIndex=F,this.length=oe,this.tooltip=ve,typeof F!="number"||F<0)throw(0,L.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,L.illegalArgument)("length");if(ve!==void 0&&typeof ve!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=We;class je{constructor(F){this.uri=F}}e.TerminalQuickFixOpener=je;class Qe{constructor(F){this.terminalCommand=F}}e.TerminalQuickFixCommand=Qe;var lt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(lt||(e.TerminalLocation=lt={}));class vt{constructor(F){if(this.options=F,typeof F!="object")throw(0,L.illegalArgument)("options")}}e.TerminalProfile=vt;var ft;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(ft||(e.TaskRevealKind=ft={}));var ct;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ct||(e.TaskPanelKind=ct={}));let ut=e.TaskGroup=he=class{static from(F){switch(F){case"clean":return he.Clean;case"build":return he.Build;case"rebuild":return he.Rebuild;case"test":return he.Test;default:return}}constructor(F,oe){if(this.label=oe,typeof F!="string"||typeof oe!="string")throw(0,L.illegalArgument)("name");this.c=F}get id(){return this.c}};ut.Clean=new he("clean","Clean"),ut.Build=new he("build","Build"),ut.Rebuild=new he("rebuild","Rebuild"),ut.Test=new he("test","Test"),e.TaskGroup=ut=he=Le([V],ut);function ni(B){let F="";for(let oe=0;oe<B.length;oe++)F+=B[oe].replace(/,/g,",,")+",";return F}let Yt=e.ProcessExecution=class{constructor(F,oe,ve){if(typeof F!="string")throw(0,L.illegalArgument)("process");this.e=[],this.c=F,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=ve):this.f=oe)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,L.illegalArgument)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)F.push(oe);return ni(F)}};e.ProcessExecution=Yt=Le([V],Yt);let Xt=e.ShellExecution=class{constructor(F,oe,ve){if(this.f=[],Array.isArray(oe)){if(!F)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,L.illegalArgument)("command");this.e=F,this.f=oe,this.g=ve}else{if(typeof F!="string")throw(0,L.illegalArgument)("commandLine");this.c=F,this.g=oe}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,L.illegalArgument)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,L.illegalArgument)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)F.push(typeof oe=="string"?oe:oe.value);return ni(F)}};e.ShellExecution=Xt=Le([V],Xt);var ri;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ri||(e.ShellQuoting=ri={}));var Ht;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Ht||(e.TaskScope=Ht={}));class si{constructor(F){this.c=F}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(F){this.c=F}get callback(){return this.c}}e.CustomExecution=si;let Bt=e.Task=ae=class{constructor(F,oe,ve,Me,xe,_e){this.j=!1,this.k=this.definition=F;let nt;typeof oe=="string"?(this.m=this.name=oe,this.t=this.source=ve,this.execution=Me,nt=xe,this.j=!0):oe===Ht.Global||oe===Ht.Workspace?(this.target=oe,this.m=this.name=ve,this.t=this.source=Me,this.execution=xe,nt=_e):(this.target=oe,this.m=this.name=ve,this.t=this.source=Me,this.execution=xe,nt=_e),typeof nt=="string"?(this.o=[nt],this.q=!0):Array.isArray(nt)?(this.o=nt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(F){this.h=F}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Yt?this.k={type:ae.e,id:this.n.computeId()}:this.n instanceof Xt?this.k={type:ae.f,id:this.n.computeId()}:this.n instanceof si?this.k={type:ae.c,id:this.n.computeId()}:this.k={type:ae.g,id:(0,T.generateUuid)()}}get definition(){return this.k}set definition(F){if(F==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=F}get scope(){return this.l}set target(F){this.y(),this.l=F}get name(){return this.m}set name(F){if(typeof F!="string")throw(0,L.illegalArgument)("name");this.y(),this.m=F}get execution(){return this.n}set execution(F){F===null&&(F=void 0),this.y(),this.n=F;const oe=this.k.type;(ae.g===oe||ae.e===oe||ae.f===oe||ae.c===oe)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(F){if(Array.isArray(F))this.y(),this.o=F,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.y(),this.r=F}get source(){return this.t}set source(F){if(typeof F!="string"||F.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.y(),this.t=F}get group(){return this.u}set group(F){F===null&&(F=void 0),this.y(),this.u=F}get detail(){return this.x}set detail(F){F===null&&(F=void 0),this.x=F}get presentationOptions(){return this.v}set presentationOptions(F){F==null&&(F=Object.create(null)),this.y(),this.v=F}get runOptions(){return this.w}set runOptions(F){F==null&&(F=Object.create(null)),this.y(),this.w=F}};Bt.c="customExecution",Bt.e="process",Bt.f="shell",Bt.g="$empty",e.Task=Bt=ae=Le([V],Bt);var oi;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(oi||(e.ProgressLocation=oi={}));var ai;(function(B){function F(oe){const ve=oe;return(0,b.isNumber)(ve.value)?ve.tooltip&&!(0,b.isString)(ve.tooltip)?(console.log("INVALID view badge, invalid tooltip",ve.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ve.value),!1)}B.isViewBadge=F})(ai||(e.ViewBadge=ai={}));let li=e.TreeItem=ue=class{static isTreeItem(F,oe){const ve=F;if(ve.checkboxState!==void 0){(0,p.checkProposedApiEnabled)(oe,"treeItemCheckbox");const Me=(0,b.isNumber)(ve.checkboxState)?ve.checkboxState:(0,b.isObject)(ve.checkboxState)&&(0,b.isNumber)(ve.checkboxState.state)?ve.checkboxState.state:void 0,xe=!(0,b.isNumber)(ve.checkboxState)&&(0,b.isObject)(ve.checkboxState)?ve.checkboxState.tooltip:void 0;if(Me===void 0||Me!==Vt.Checked&&Me!==Vt.Unchecked||xe!==void 0&&!(0,b.isString)(xe))return console.log("INVALID tree item, invalid checkboxState",ve.checkboxState),!1}if(F instanceof ue)return!0;if(ve.label!==void 0&&!(0,b.isString)(ve.label)&&!ve.label?.label)return console.log("INVALID tree item, invalid label",ve.label),!1;if(ve.id!==void 0&&!(0,b.isString)(ve.id))return console.log("INVALID tree item, invalid id",ve.id),!1;if(ve.iconPath!==void 0&&!(0,b.isString)(ve.iconPath)&&!m.URI.isUri(ve.iconPath)&&(!ve.iconPath||!(0,b.isString)(ve.iconPath.id))){const Me=ve.iconPath;if(!Me||!(0,b.isString)(Me.light)&&!m.URI.isUri(Me.light)&&!(0,b.isString)(Me.dark)&&!m.URI.isUri(Me.dark))return console.log("INVALID tree item, invalid iconPath",ve.iconPath),!1}return ve.description!==void 0&&!(0,b.isString)(ve.description)&&typeof ve.description!="boolean"?(console.log("INVALID tree item, invalid description",ve.description),!1):ve.resourceUri!==void 0&&!m.URI.isUri(ve.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ve.resourceUri),!1):ve.tooltip!==void 0&&!(0,b.isString)(ve.tooltip)&&!(ve.tooltip instanceof Re)?(console.log("INVALID tree item, invalid tooltip",ve.tooltip),!1):ve.command!==void 0&&!ve.command.command?(console.log("INVALID tree item, invalid command",ve.command),!1):ve.collapsibleState!==void 0&&ve.collapsibleState<jt.None&&ve.collapsibleState>jt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ve.collapsibleState),!1):ve.contextValue!==void 0&&!(0,b.isString)(ve.contextValue)?(console.log("INVALID tree item, invalid contextValue",ve.contextValue),!1):ve.accessibilityInformation!==void 0&&!ve.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ve.accessibilityInformation),!1):!0}constructor(F,oe=jt.None){this.collapsibleState=oe,m.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.TreeItem=li=ue=Le([V],li);var jt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(jt||(e.TreeItemCollapsibleState=jt={}));var Vt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Vt||(e.TreeItemCheckboxState=Vt={}));let Qt=e.DataTransferItem=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.DataTransferItem=Qt=Le([V],Qt);class ci extends Qt{}e.InternalDataTransferItem=ci;class En extends ci{constructor(F){super(""),c.set(this,void 0),kt(this,c,F,"f")}asFile(){return rt(this,c,"f")}}e.InternalFileDataTransferItem=En,c=new WeakMap;class wn{constructor(F,oe,ve,Me){this.name=F,this.uri=oe,this._itemId=ve,this.c=Me}data(){return this.c()}}e.DataTransferFile=wn;let ui=e.DataTransfer=class{constructor(F){u.add(this),D.set(this,new Map);for(const[oe,ve]of F??[]){const Me=rt(this,D,"f").get(rt(this,u,"m",O).call(this,oe));Me?Me.push(ve):rt(this,D,"f").set(rt(this,u,"m",O).call(this,oe),[ve])}}get(F){return rt(this,D,"f").get(rt(this,u,"m",O).call(this,F))?.[0]}set(F,oe){rt(this,D,"f").set(rt(this,u,"m",O).call(this,F),[oe])}forEach(F,oe){for(const[ve,Me]of rt(this,D,"f"))for(const xe of Me)F.call(oe,xe,ve,this)}*[(D=new WeakMap,u=new WeakSet,Symbol.iterator)](){for(const[F,oe]of rt(this,D,"f"))for(const ve of oe)yield[F,ve]}};O=function(F){return F.toLowerCase()},e.DataTransfer=ui=Le([V],ui);let hi=e.DocumentDropEdit=class{constructor(F){this.insertText=F}};e.DocumentDropEdit=hi=Le([V],hi);let fi=e.DocumentPasteEdit=class{constructor(F,oe,ve){this.id=oe,this.label=ve,this.insertText=F}};e.DocumentPasteEdit=fi=Le([V],fi);let Tt=e.ThemeIcon=class{constructor(F,oe){this.id=F,this.color=oe}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.ThemeIcon=Tt=Le([V],Tt),Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let di=e.ThemeColor=class{constructor(F){this.id=F}};e.ThemeColor=di=Le([V],di);var mi;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(mi||(e.ConfigurationTarget=mi={}));let gi=e.RelativePattern=class{get base(){return this.c}set base(F){this.c=F,this.e=m.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,oe){if(typeof F!="string"&&(!F||!m.URI.isUri(F)&&!m.URI.isUri(F.uri)))throw(0,L.illegalArgument)("base");if(typeof oe!="string")throw(0,L.illegalArgument)("pattern");typeof F=="string"?this.baseUri=m.URI.file(F):m.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=gi=Le([V],gi);const pi=new WeakMap;function yn(B,F){pi.set(B,F)}e.setBreakpointId=yn;let zt=e.Breakpoint=class{constructor(F,oe,ve,Me){this.enabled=typeof F=="boolean"?F:!0,typeof oe=="string"&&(this.condition=oe),typeof ve=="string"&&(this.hitCondition=ve),typeof Me=="string"&&(this.logMessage=Me)}get id(){return this.c||(this.c=pi.get(this)??(0,T.generateUuid)()),this.c}};e.Breakpoint=zt=Le([V],zt);let vi=e.SourceBreakpoint=class extends zt{constructor(F,oe,ve,Me,xe){if(super(oe,ve,Me,xe),F===null)throw(0,L.illegalArgument)("location");this.location=F}};e.SourceBreakpoint=vi=Le([V],vi);let bi=e.FunctionBreakpoint=class extends zt{constructor(F,oe,ve,Me,xe){super(oe,ve,Me,xe),this.functionName=F}};e.FunctionBreakpoint=bi=Le([V],bi);let Ei=e.DataBreakpoint=class extends zt{constructor(F,oe,ve,Me,xe,_e,nt){if(super(Me,xe,_e,nt),!oe)throw(0,L.illegalArgument)("dataId");this.label=F,this.dataId=oe,this.canPersist=ve}};e.DataBreakpoint=Ei=Le([V],Ei);let wi=e.DebugAdapterExecutable=class{constructor(F,oe,ve){this.command=F,this.args=oe||[],this.options=ve}};e.DebugAdapterExecutable=wi=Le([V],wi);let yi=e.DebugAdapterServer=class{constructor(F,oe){this.port=F,this.host=oe}};e.DebugAdapterServer=yi=Le([V],yi);let Si=e.DebugAdapterNamedPipeServer=class{constructor(F){this.path=F}};e.DebugAdapterNamedPipeServer=Si=Le([V],Si);let Ii=e.DebugAdapterInlineImplementation=class{constructor(F){this.implementation=F}};e.DebugAdapterInlineImplementation=Ii=Le([V],Ii);let Ci=e.StackFrameFocus=class{constructor(F,oe,ve){this.session=F,this.threadId=oe,this.frameId=ve}};e.StackFrameFocus=Ci=Le([V],Ci);let Di=e.ThreadFocus=class{constructor(F,oe){this.session=F,this.threadId=oe}};e.ThreadFocus=Di=Le([V],Di);let Pi=e.EvaluatableExpression=class{constructor(F,oe){this.range=F,this.expression=oe}};e.EvaluatableExpression=Pi=Le([V],Pi);var ki;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(ki||(e.InlineCompletionTriggerKind=ki={}));let Ai=e.InlineValueText=class{constructor(F,oe){this.range=F,this.text=oe}};e.InlineValueText=Ai=Le([V],Ai);let Ri=e.InlineValueVariableLookup=class{constructor(F,oe,ve=!0){this.range=F,this.variableName=oe,this.caseSensitiveLookup=ve}};e.InlineValueVariableLookup=Ri=Le([V],Ri);let Ti=e.InlineValueEvaluatableExpression=class{constructor(F,oe){this.range=F,this.expression=oe}};e.InlineValueEvaluatableExpression=Ti=Le([V],Ti);let Li=e.InlineValueContext=class{constructor(F,oe){this.frameId=F,this.stoppedLocation=oe}};e.InlineValueContext=Li=Le([V],Li);var Oi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Oi||(e.FileChangeType=Oi={}));let Ni=e.FileSystemError=ge=class extends Error{static FileExists(F){return new ge(F,v.FileSystemProviderErrorCode.FileExists,ge.FileExists)}static FileNotFound(F){return new ge(F,v.FileSystemProviderErrorCode.FileNotFound,ge.FileNotFound)}static FileNotADirectory(F){return new ge(F,v.FileSystemProviderErrorCode.FileNotADirectory,ge.FileNotADirectory)}static FileIsADirectory(F){return new ge(F,v.FileSystemProviderErrorCode.FileIsADirectory,ge.FileIsADirectory)}static NoPermissions(F){return new ge(F,v.FileSystemProviderErrorCode.NoPermissions,ge.NoPermissions)}static Unavailable(F){return new ge(F,v.FileSystemProviderErrorCode.Unavailable,ge.Unavailable)}constructor(F,oe=v.FileSystemProviderErrorCode.Unknown,ve){super(m.URI.isUri(F)?F.toString(!0):F),this.code=ve?.name??"Unknown",(0,v.markAsFileSystemProviderError)(this,oe),Object.setPrototypeOf(this,ge.prototype),typeof Error.captureStackTrace=="function"&&typeof ve=="function"&&Error.captureStackTrace(this,ve)}};e.FileSystemError=Ni=ge=Le([V],Ni);let Fi=e.FoldingRange=class{constructor(F,oe,ve){this.start=F,this.end=oe,this.kind=ve}};e.FoldingRange=Fi=Le([V],Fi);var Mi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Mi||(e.FoldingRangeKind=Mi={}));var Ui;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Ui||(e.CommentThreadCollapsibleState=Ui={}));var Bi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Bi||(e.CommentMode=Bi={}));var ji;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(ji||(e.CommentState=ji={}));var zi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(zi||(e.CommentThreadState=zi={}));class Sn{constructor(F,oe=[]){this.tokenTypes=F,this.tokenModifiers=oe}}e.SemanticTokensLegend=Sn;function In(B){return typeof B>"u"||(0,b.isStringArray)(B)}class Zt{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,F){this.l=!0;for(let oe=0,ve=F.tokenTypes.length;oe<ve;oe++)this.j.set(F.tokenTypes[oe],oe);for(let oe=0,ve=F.tokenModifiers.length;oe<ve;oe++)this.k.set(F.tokenModifiers[oe],oe)}}push(F,oe,ve,Me,xe){if(typeof F=="number"&&typeof oe=="number"&&typeof ve=="number"&&typeof Me=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.n(F,oe,ve,Me,xe);if(re.isRange(F)&&typeof oe=="string"&&In(ve))return this.m(F,oe,ve);throw(0,L.illegalArgument)()}m(F,oe,ve){if(!this.l)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(oe))throw new Error("`tokenType` is not in the provided legend");const Me=F.start.line,xe=F.start.character,_e=F.end.character-F.start.character,nt=this.j.get(oe);let mt=0;if(ve)for(const bt of ve){if(!this.k.has(bt))throw new Error("`tokenModifier` is not in the provided legend");const yt=this.k.get(bt);mt|=1<<yt>>>0}this.n(Me,xe,_e,nt,mt)}n(F,oe,ve,Me,xe){if(this.f&&(F<this.c||F===this.c&&oe<this.e)){this.f=!1;const mt=this.g.length/5|0;let bt=0,yt=0;for(let It=0;It<mt;It++){let Pt=this.g[5*It],Wt=this.g[5*It+1];Pt===0?(Pt=bt,Wt+=yt):Pt+=bt,this.g[5*It]=Pt,this.g[5*It+1]=Wt,bt=Pt,yt=Wt}}let _e=F,nt=oe;this.f&&this.h>0&&(_e-=this.c,_e===0&&(nt-=this.e)),this.g[this.h++]=_e,this.g[this.h++]=nt,this.g[this.h++]=ve,this.g[this.h++]=Me,this.g[this.h++]=xe,this.c=F,this.e=oe}static o(F){const oe=[],ve=F.length/5|0;for(let nt=0;nt<ve;nt++)oe[nt]=nt;oe.sort((nt,mt)=>{const bt=F[5*nt],yt=F[5*mt];if(bt===yt){const It=F[5*nt+1],Pt=F[5*mt+1];return It-Pt}return bt-yt});const Me=new Uint32Array(F.length);let xe=0,_e=0;for(let nt=0;nt<ve;nt++){const mt=5*oe[nt],bt=F[mt+0],yt=F[mt+1],It=F[mt+2],Pt=F[mt+3],Wt=F[mt+4],bn=bt-xe,Hn=bn===0?yt-_e:yt,xt=5*nt;Me[xt+0]=bn,Me[xt+1]=Hn,Me[xt+2]=It,Me[xt+3]=Pt,Me[xt+4]=Wt,xe=bt,_e=yt}return Me}build(F){return this.f?new _t(new Uint32Array(this.g),F):new _t(Zt.o(this.g),F)}}e.SemanticTokensBuilder=Zt;class _t{constructor(F,oe){this.resultId=oe,this.data=F}}e.SemanticTokens=_t;class Cn{constructor(F,oe,ve){this.start=F,this.deleteCount=oe,this.data=ve}}e.SemanticTokensEdit=Cn;class Dn{constructor(F,oe){this.resultId=oe,this.edits=F}}e.SemanticTokensEdits=Dn;var $i;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})($i||(e.DebugConsoleMode=$i={}));let ei=e.QuickInputButtons=class{constructor(){}};ei.Back={iconPath:new Tt("arrow-left")},e.QuickInputButtons=ei=Le([V],ei);var Wi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Wi||(e.QuickPickItemKind=Wi={}));var xi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(xi||(e.InputBoxValidationSeverity=xi={}));var Hi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Hi||(e.ExtensionKind=Hi={}));class Pn{static validate(F){if(typeof F.badge=="string"){let oe=(0,R.nextCharLength)(F.badge,0);if(oe<F.badge.length&&(oe+=(0,R.nextCharLength)(F.badge,oe)),F.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!Tt.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,oe,ve){this.badge=F,this.tooltip=oe,this.color=ve}}e.FileDecoration=Pn;let Vi=e.ColorTheme=class{constructor(F){this.kind=F}};e.ColorTheme=Vi=Le([V],Vi);var qi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(qi||(e.ColorThemeKind=qi={}));class Lt{static isNotebookRange(F){return F instanceof Lt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,oe){if(F<0)throw(0,L.illegalArgument)("start must be positive");if(oe<0)throw(0,L.illegalArgument)("end must be positive");F<=oe?(this.c=F,this.e=oe):(this.c=oe,this.e=F)}with(F){let oe=this.c,ve=this.e;return F.start!==void 0&&(oe=F.start),F.end!==void 0&&(ve=F.end),oe===this.c&&ve===this.e?this:new Lt(oe,ve)}}e.NotebookRange=Lt;class qt{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(oe=>qt.isNotebookCellData(oe))}static isNotebookCellData(F){return!0}constructor(F,oe,ve,Me,xe,_e,nt){this.kind=F,this.value=oe,this.languageId=ve,this.mime=Me,this.outputs=xe??[],this.metadata=_e,this.executionSummary=nt,qt.validate(this)}}e.NotebookCellData=qt;class kn{constructor(F){this.cells=F}}e.NotebookData=kn;class wt{static isNotebookCellOutputItem(F){return F instanceof wt?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const oe={name:F.name,message:F.message,stack:F.stack};return wt.json(oe,"application/vnd.code.notebook.error")}static stdout(F){return wt.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return wt.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,oe="application/octet-stream"){return new wt(F,oe)}static text(F,oe=k.Mimes.text){const ve=rt(wt,t,"f",n).encode(String(F));return new wt(ve,oe)}static json(F,oe="text/x-json"){const ve=JSON.stringify(F,void 0,"	");return wt.text(ve,oe)}constructor(F,oe){this.data=F,this.mime=oe;const ve=(0,k.normalizeMimeType)(oe,!0);if(!ve)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ve}}e.NotebookCellOutputItem=wt,t=wt,n={value:new TextEncoder};class Gt{static isNotebookCellOutput(F){return F instanceof Gt?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,oe=!1){const ve=new Set,Me=new Set;for(let xe=0;xe<F.length;xe++){const _e=F[xe],nt=(0,k.normalizeMimeType)(_e.mime);if(!ve.has(nt)||(0,g.isTextStreamMime)(nt)){ve.add(nt);continue}Me.add(xe),oe&&console.warn(`DUPLICATED mime type '${_e.mime}' will be dropped`)}return Me.size===0?F:F.filter((xe,_e)=>!Me.has(_e))}constructor(F,oe,ve){this.items=Gt.ensureUniqueMimeTypes(F,!0),typeof oe=="string"?(this.id=oe,this.metadata=ve):(this.id=(0,T.generateUuid)(),this.metadata=oe??ve)}}e.NotebookCellOutput=Gt;var Gi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Gi||(e.NotebookCellKind=Gi={}));var Ki;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Ki||(e.NotebookCellExecutionState=Ki={}));var Ji;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ji||(e.NotebookCellStatusBarAlignment=Ji={}));var Yi;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Yi||(e.NotebookEditorRevealType=Yi={}));class An{constructor(F,oe){this.text=F,this.alignment=oe}}e.NotebookCellStatusBarItem=An;var Xi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Xi||(e.NotebookControllerAffinity=Xi={}));var Qi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(Qi||(e.NotebookControllerAffinity2=Qi={}));class Rn{constructor(F,oe=[]){this.uri=F,this.provides=(0,S.asArray)(oe)}}e.NotebookRendererScript=Rn;class Tn{constructor(F){this.label=F}}e.NotebookKernelSourceAction=Tn;let Zi=e.TimelineItem=class{constructor(F,oe){this.label=F,this.timestamp=oe}};e.TimelineItem=Zi=Le([V],Zi);var _i;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(_i||(e.ExtensionMode=_i={}));var en;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(en||(e.ExtensionRuntime=en={}));var tn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(tn||(e.StandardTokenType=tn={}));class Ln{constructor(F,oe){this.ranges=F,this.wordPattern=oe}}e.LinkedEditingRanges=Ln;class On{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.PortAttributes=On;var nn;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(nn||(e.TestResultState=nn={}));var rn;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(rn||(e.TestRunProfileKind=rn={}));let ti=e.TestRunRequest=class{constructor(F=void 0,oe=void 0,ve=void 0,Me=!1){this.include=F,this.exclude=oe,this.profile=ve,this.continuous=Me}};e.TestRunRequest=ti=Le([V],ti);let sn=e.TestRunRequest2=class extends ti{};e.TestRunRequest2=sn=Le([V],sn);let on=e.TestMessage=_=class{static diff(F,oe,ve){const Me=new _(F);return Me.expectedOutput=oe,Me.actualOutput=ve,Me}constructor(F){this.message=F}};e.TestMessage=on=_=Le([V],on);let an=e.TestTag=class{constructor(F){this.id=F}};e.TestTag=an=Le([V],an);let $t=e.CoveredCount=class{constructor(F,oe){this.covered=F,this.total=oe}};e.CoveredCount=$t=Le([V],$t);let ln=e.FileCoverage=ie=class{static fromDetails(F,oe){const ve=new $t(0,0),Me=new $t(0,0),xe=new $t(0,0);for(const nt of oe)if("branches"in nt){ve.total+=1,ve.covered+=nt.executionCount>0?1:0;for(const mt of nt.branches)Me.total+=1,Me.covered+=mt.executionCount>0?1:0}else xe.total+=1,xe.covered+=nt.executionCount>0?1:0;const _e=new ie(F,ve,Me.total>0?Me:void 0,xe.total>0?xe:void 0);return _e.detailedCoverage=oe,_e}constructor(F,oe,ve,Me){this.uri=F,this.statementCoverage=oe,this.branchCoverage=ve,this.functionCoverage=Me}};e.FileCoverage=ln=ie=Le([V],ln);let cn=e.StatementCoverage=class{constructor(F,oe,ve=[]){this.executionCount=F,this.location=oe,this.branches=ve}};e.StatementCoverage=cn=Le([V],cn);let un=e.BranchCoverage=class{constructor(F,oe){this.executionCount=F,this.location=oe}};e.BranchCoverage=un=Le([V],un);let hn=e.FunctionCoverage=class{constructor(F,oe){this.executionCount=F,this.location=oe}};e.FunctionCoverage=hn=Le([V],hn);var fn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(fn||(e.ExternalUriOpenerPriority=fn={}));var dn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(dn||(e.WorkspaceTrustState=dn={}));var mn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(mn||(e.PortAutoForwardAction=mn={}));class Nn{constructor(F,oe,ve,Me,xe,_e){this.kind=F,this.name=oe,this.detail=ve,this.uri=Me,this.range=xe,this.selectionRange=_e}}e.TypeHierarchyItem=Nn;class Fn{constructor(F){this.uri=F}}e.TextTabInput=Fn;class Mn{constructor(F,oe){this.original=F,this.modified=oe}}e.TextDiffTabInput=Mn;class Un{constructor(F,oe,ve,Me){this.base=F,this.input1=oe,this.input2=ve,this.result=Me}}e.TextMergeTabInput=Un;class Bn{constructor(F,oe){this.uri=F,this.viewType=oe}}e.CustomEditorTabInput=Bn;class jn{constructor(F){this.viewType=F}}e.WebviewEditorTabInput=jn;class zn{constructor(F,oe){this.uri=F,this.notebookType=oe}}e.NotebookEditorTabInput=zn;class $n{constructor(F,oe,ve){this.original=F,this.modified=oe,this.notebookType=ve}}e.NotebookDiffEditorTabInput=$n;class Wn{constructor(){}}e.TerminalEditorTabInput=Wn;class xn{constructor(F,oe){this.uri=F,this.inputBoxUri=oe}}e.InteractiveWindowInput=xn;var gn;(function(B){B[B.Up=1]="Up",B[B.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var pn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var vn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone"})(vn||(e.InteractiveEditorResponseFeedbackKind=vn={}))}),define(pe[135],be([1,0,18,15,145,71,99,27,141,50,58,21,8,4,49,166,225,131,88,129,69,89,133,134]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f,c,u,D,O,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(ye){function Ie(X){const{selectionStartLineNumber:Pe,selectionStartColumn:Ne,positionLineNumber:We,positionColumn:je}=X,Qe=new n.Position(Pe-1,Ne-1),lt=new n.Position(We-1,je-1);return new n.Selection(Qe,lt)}ye.to=Ie;function de(X){const{anchor:Pe,active:Ne}=X;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Ne.line+1,positionColumn:Ne.character+1}}ye.from=de})(s||(e.Selection=s={}));var i;(function(ye){function Ie(X){if(!X)return;const{start:Pe,end:Ne}=X;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Ne.line+1,endColumn:Ne.character+1}}ye.from=Ie;function de(X){if(!X)return;const{startLineNumber:Pe,startColumn:Ne,endLineNumber:We,endColumn:je}=X;return new n.Range(Pe-1,Ne-1,We-1,je-1)}ye.to=de})(i||(e.Range=i={}));var a;(function(ye){function Ie(de){switch(de){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}ye.to=Ie})(a||(e.TokenType=a={}));var l;(function(ye){function Ie(X){return new n.Position(X.lineNumber-1,X.column-1)}ye.to=Ie;function de(X){return{lineNumber:X.line+1,column:X.character+1}}ye.from=de})(l||(e.Position=l={}));var d;(function(ye){function Ie(Pe,Ne,We){return(0,S.coalesce)((0,S.asArray)(Pe).map(je=>de(je,Ne,We)))}ye.from=Ie;function de(Pe,Ne,We){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:We?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:X(Pe.scheme,Ne),pattern:Ce.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:We?.isBuiltin}}function X(Pe,Ne){return Ne&&typeof Pe=="string"?Ne.transformOutgoingScheme(Pe):Pe}})(d||(e.DocumentSelector=d={}));var I;(function(ye){function Ie(X){switch(X){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}ye.from=Ie;function de(X){switch(X){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}ye.to=de})(I||(e.DiagnosticTag=I={}));var C;(function(ye){function Ie(X){let Pe;return X.code&&((0,v.isString)(X.code)||(0,v.isNumber)(X.code)?Pe=String(X.code):Pe={value:String(X.code.value),target:X.code.target}),{...i.from(X.range),message:X.message,source:X.source,code:Pe,severity:w.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(E.from),tags:Array.isArray(X.tags)?(0,S.coalesce)(X.tags.map(I.from)):void 0}}ye.from=Ie;function de(X){const Pe=new n.Diagnostic(i.to(X),X.message,w.to(X.severity));return Pe.source=X.source,Pe.code=(0,v.isString)(X.code)?X.code:X.code?.value,Pe.relatedInformation=X.relatedInformation&&X.relatedInformation.map(E.to),Pe.tags=X.tags&&(0,S.coalesce)(X.tags.map(I.to)),Pe}ye.to=de})(C||(e.Diagnostic=C={}));var E;(function(ye){function Ie(X){return{...i.from(X.location.range),message:X.message,resource:X.location.uri}}ye.from=Ie;function de(X){return new n.DiagnosticRelatedInformation(new n.Location(X.resource,i.to(X)),X.message)}ye.to=de})(E||(e.DiagnosticRelatedInformation=E={}));var w;(function(ye){function Ie(X){switch(X){case n.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}ye.from=Ie;function de(X){switch(X){case r.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}ye.to=de})(w||(e.DiagnosticSeverity=w={}));var N;(function(ye){function Ie(X){return typeof X=="number"&&X>=n.ViewColumn.One?X-1:X===n.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}ye.from=Ie;function de(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=de})(N||(e.ViewColumn=N={}));function $(ye){return typeof ye.range<"u"}function se(ye){return ye.length===0?!0:!!$(ye[0])}e.isDecorationOptionsArr=se;var he;(function(ye){function Ie(je){return je.map(ye.from)}ye.fromMany=Ie;function de(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function X(je){let Qe;if(de(je)){const{language:ct,value:ut}=je;Qe={value:"```"+ct+`
`+ut+"\n```\n"}}else n.MarkdownString.isMarkdownString(je)?Qe={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?Qe={value:je}:Qe={value:""};const lt=Object.create(null);Qe.uris=lt;const vt=ct=>{try{let ut=h.URI.parse(ct,!0);ut=ut.with({query:Pe(ut.query,lt)}),lt[ct]=ut}catch{}return""},ft=new b.marked.Renderer;return ft.link=vt,ft.image=ct=>typeof ct=="string"?vt(k.parseHrefAndDimensions(ct).href):"",(0,b.marked)(Qe.value,{renderer:ft}),Qe}ye.from=X;function Pe(je,Qe){if(!je)return je;let lt;try{lt=(0,m.parse)(je)}catch{}if(!lt)return je;let vt=!1;return lt=(0,y.cloneAndChange)(lt,ft=>{if(h.URI.isUri(ft)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return Qe[ct]=ft,vt=!0,ct}else return}),vt?JSON.stringify(lt):je}function Ne(je){const Qe=new n.MarkdownString(je.value,je.supportThemeIcons);return Qe.isTrusted=je.isTrusted,Qe.supportHtml=je.supportHtml,Qe.baseUri=je.baseUri?h.URI.from(je.baseUri):void 0,Qe}ye.to=Ne;function We(je){if(je)return typeof je=="string"?je:ye.from(je)}ye.fromStrict=We})(he||(e.MarkdownString=he={}));function ae(ye){return se(ye)?ye.map(Ie=>({range:i.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?he.fromMany(Ie.hoverMessage):Ie.hoverMessage?he.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):ye.map(Ie=>({range:i.from(Ie)}))}e.fromRangeOrRangeWithMessage=ae;function ue(ye){return typeof ye>"u"?ye:typeof ye=="string"?h.URI.file(ye):ye}e.pathOrURIToURI=ue;var ge;(function(ye){function Ie(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?ue(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}ye.from=Ie})(ge||(e.ThemableDecorationAttachmentRenderOptions=ge={}));var _;(function(ye){function Ie(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?ue(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?ge.from(de.before):void 0,after:de.after?ge.from(de.after):void 0}}ye.from=Ie})(_||(e.ThemableDecorationRenderOptions=_={}));var ie;(function(ye){function Ie(de){if(typeof de>"u")return de;switch(de){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Ie})(ie||(e.DecorationRangeBehavior=ie={}));var V;(function(ye){function Ie(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?ie.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?_.from(de.light):void 0,dark:de.dark?_.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?ue(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?ge.from(de.before):void 0,after:de.after?ge.from(de.after):void 0}}ye.from=Ie})(V||(e.DecorationRenderOptions=V={}));var J;(function(ye){function Ie(X){return{text:X.newText,eol:X.newEol&&Ze.from(X.newEol),range:i.from(X.range)}}ye.from=Ie;function de(X){const Pe=new n.TextEdit(i.to(X.range),X.text);return Pe.newEol=typeof X.eol>"u"?void 0:Ze.to(X.eol),Pe}ye.to=de})(J||(e.TextEdit=J={}));var U;(function(ye){function Ie(X,Pe){const Ne={edits:[]};if(X instanceof n.WorkspaceEdit){const We=new R.ResourceSet;for(const je of X._allEntries())je._type===1&&h.URI.isUri(je.to)&&je.from===void 0&&We.add(je.to);for(const je of X._allEntries())if(je._type===1){let Qe;je.options?.contents&&(ArrayBuffer.isView(je.options.contents)?Qe={type:"base64",value:(0,L.encodeBase64)(L.VSBuffer.wrap(je.options.contents))}:Qe={type:"dataTransferItem",id:je.options.contents._itemId}),Ne.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contents:Qe},metadata:je.metadata})}else je._type===2?Ne.edits.push({resource:je.uri,textEdit:J.from(je.edit),versionId:We.has(je.uri)?void 0:Pe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===6?Ne.edits.push({resource:je.uri,textEdit:{range:i.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:We.has(je.uri)?void 0:Pe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?Ne.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(je.uri)}):je._type===5&&Ne.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(tt.from)}})}return Ne}ye.from=Ie;function de(X){const Pe=new n.WorkspaceEdit,Ne=new R.ResourceMap;for(const We of X.edits)if(We.textEdit){const je=We,Qe=h.URI.revive(je.resource),lt=i.to(je.textEdit.range),vt=je.textEdit.text,ft=je.textEdit.insertAsSnippet;let ct;ft?ct=n.SnippetTextEdit.replace(lt,new n.SnippetString(vt)):ct=n.TextEdit.replace(lt,vt);const ut=Ne.get(Qe);ut?ut.push(ct):Ne.set(Qe,[ct])}else Pe.renameFile(h.URI.revive(We.oldResource),h.URI.revive(We.newResource),We.options);for(const[We,je]of Ne)Pe.set(We,je);return Pe}ye.to=de})(U||(e.WorkspaceEdit=U={}));var ne;(function(ye){const Ie=Object.create(null);Ie[n.SymbolKind.File]=0,Ie[n.SymbolKind.Module]=1,Ie[n.SymbolKind.Namespace]=2,Ie[n.SymbolKind.Package]=3,Ie[n.SymbolKind.Class]=4,Ie[n.SymbolKind.Method]=5,Ie[n.SymbolKind.Property]=6,Ie[n.SymbolKind.Field]=7,Ie[n.SymbolKind.Constructor]=8,Ie[n.SymbolKind.Enum]=9,Ie[n.SymbolKind.Interface]=10,Ie[n.SymbolKind.Function]=11,Ie[n.SymbolKind.Variable]=12,Ie[n.SymbolKind.Constant]=13,Ie[n.SymbolKind.String]=14,Ie[n.SymbolKind.Number]=15,Ie[n.SymbolKind.Boolean]=16,Ie[n.SymbolKind.Array]=17,Ie[n.SymbolKind.Object]=18,Ie[n.SymbolKind.Key]=19,Ie[n.SymbolKind.Null]=20,Ie[n.SymbolKind.EnumMember]=21,Ie[n.SymbolKind.Struct]=22,Ie[n.SymbolKind.Event]=23,Ie[n.SymbolKind.Operator]=24,Ie[n.SymbolKind.TypeParameter]=25;function de(Pe){return typeof Ie[Pe]=="number"?Ie[Pe]:6}ye.from=de;function X(Pe){for(const Ne in Ie)if(Ie[Ne]===Pe)return Number(Ne);return n.SymbolKind.Property}ye.to=X})(ne||(e.SymbolKind=ne={}));var x;(function(ye){function Ie(X){switch(X){case n.SymbolTag.Deprecated:return 1}}ye.from=Ie;function de(X){switch(X){case 1:return n.SymbolTag.Deprecated}}ye.to=de})(x||(e.SymbolTag=x={}));var re;(function(ye){function Ie(X){return{name:X.name,kind:ne.from(X.kind),tags:X.tags&&X.tags.map(x.from),containerName:X.containerName,location:M.from(X.location)}}ye.from=Ie;function de(X){const Pe=new n.SymbolInformation(X.name,ne.to(X.kind),X.containerName,M.to(X.location));return Pe.tags=X.tags&&X.tags.map(x.to),Pe}ye.to=de})(re||(e.WorkspaceSymbol=re={}));var Y;(function(ye){function Ie(X){const Pe={name:X.name||"!!MISSING: name!!",detail:X.detail,range:i.from(X.range),selectionRange:i.from(X.selectionRange),kind:ne.from(X.kind),tags:X.tags?.map(x.from)??[]};return X.children&&(Pe.children=X.children.map(Ie)),Pe}ye.from=Ie;function de(X){const Pe=new n.DocumentSymbol(X.name,X.detail,ne.to(X.kind),i.to(X.range),i.to(X.selectionRange));return(0,S.isNonEmptyArray)(X.tags)&&(Pe.tags=X.tags.map(x.to)),X.children&&(Pe.children=X.children.map(de)),Pe}ye.to=de})(Y||(e.DocumentSymbol=Y={}));var ee;(function(ye){function Ie(X){const Pe=new n.CallHierarchyItem(ne.to(X.kind),X.name,X.detail||"",h.URI.revive(X.uri),i.to(X.range),i.to(X.selectionRange));return Pe._sessionId=X._sessionId,Pe._itemId=X._itemId,Pe}ye.to=Ie;function de(X,Pe,Ne){if(Pe=Pe??X._sessionId,Ne=Ne??X._itemId,Pe===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ne,name:X.name,detail:X.detail,kind:ne.from(X.kind),uri:X.uri,range:i.from(X.range),selectionRange:i.from(X.selectionRange),tags:X.tags?.map(x.from)}}ye.from=de})(ee||(e.CallHierarchyItem=ee={}));var j;(function(ye){function Ie(de){return new n.CallHierarchyIncomingCall(ee.to(de.from),de.fromRanges.map(X=>i.to(X)))}ye.to=Ie})(j||(e.CallHierarchyIncomingCall=j={}));var P;(function(ye){function Ie(de){return new n.CallHierarchyOutgoingCall(ee.to(de.to),de.fromRanges.map(X=>i.to(X)))}ye.to=Ie})(P||(e.CallHierarchyOutgoingCall=P={}));var M;(function(ye){function Ie(X){return{range:X.range&&i.from(X.range),uri:X.uri}}ye.from=Ie;function de(X){return new n.Location(h.URI.revive(X.uri),i.to(X.range))}ye.to=de})(M||(e.location=M={}));var K;(function(ye){function Ie(X){const Pe=X,Ne=X;return{originSelectionRange:Pe.originSelectionRange?i.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Ne.uri,range:i.from(Pe.targetRange?Pe.targetRange:Ne.range),targetSelectionRange:Pe.targetSelectionRange?i.from(Pe.targetSelectionRange):void 0}}ye.from=Ie;function de(X){return{targetUri:h.URI.revive(X.uri),targetRange:i.to(X.range),targetSelectionRange:X.targetSelectionRange?i.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?i.to(X.originSelectionRange):void 0}}ye.to=de})(K||(e.DefinitionLink=K={}));var te;(function(ye){function Ie(X){return{range:i.from(X.range),contents:he.fromMany(X.contents)}}ye.from=Ie;function de(X){return new n.Hover(X.contents.map(he.to),i.to(X.range))}ye.to=de})(te||(e.Hover=te={}));var z;(function(ye){function Ie(X){return{range:i.from(X.range),expression:X.expression}}ye.from=Ie;function de(X){return new n.EvaluatableExpression(i.to(X.range),X.expression)}ye.to=de})(z||(e.EvaluatableExpression=z={}));var W;(function(ye){function Ie(X){if(X instanceof n.InlineValueText)return{type:"text",range:i.from(X.range),text:X.text};if(X instanceof n.InlineValueVariableLookup)return{type:"variable",range:i.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof n.InlineValueEvaluatableExpression)return{type:"expression",range:i.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Ie;function de(X){switch(X.type){case"text":return{range:i.to(X.range),text:X.text};case"variable":return{range:i.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:i.to(X.range),expression:X.expression}}}ye.to=de})(W||(e.InlineValue=W={}));var q;(function(ye){function Ie(X){return{frameId:X.frameId,stoppedLocation:i.from(X.stoppedLocation)}}ye.from=Ie;function de(X){return new n.InlineValueContext(X.frameId,i.to(X.stoppedLocation))}ye.to=de})(q||(e.InlineValueContext=q={}));var H;(function(ye){function Ie(X){return{range:i.from(X.range),kind:X.kind}}ye.from=Ie;function de(X){return new n.DocumentHighlight(i.to(X.range),X.kind)}ye.to=de})(H||(e.DocumentHighlight=H={}));var Q;(function(ye){function Ie(de){switch(de){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}ye.to=Ie})(Q||(e.CompletionTriggerKind=Q={}));var G;(function(ye){function Ie(de){return{triggerKind:Q.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}ye.to=Ie})(G||(e.CompletionContext=G={}));var Z;(function(ye){function Ie(X){switch(X){case n.CompletionItemTag.Deprecated:return 1}}ye.from=Ie;function de(X){switch(X){case 1:return n.CompletionItemTag.Deprecated}}ye.to=de})(Z||(e.CompletionItemTag=Z={}));var ce;(function(ye){const Ie=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function de(Ne){return Ie.get(Ne)??9}ye.from=de;const X=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Pe(Ne){return X.get(Ne)??n.CompletionItemKind.Property}ye.to=Pe})(ce||(e.CompletionItemKind=ce={}));var Ee;(function(ye){function Ie(de,X){const Pe=new n.CompletionItem(de.label);return Pe.insertText=de.insertText,Pe.kind=ce.to(de.kind),Pe.tags=de.tags?.map(Z.to),Pe.detail=de.detail,Pe.documentation=k.isMarkdownString(de.documentation)?he.to(de.documentation):de.documentation,Pe.sortText=de.sortText,Pe.filterText=de.filterText,Pe.preselect=de.preselect,Pe.commitCharacters=de.commitCharacters,g.Range.isIRange(de.range)?Pe.range=i.to(de.range):typeof de.range=="object"&&(Pe.range={inserting:i.to(de.range.insert),replacing:i.to(de.range.replace)}),Pe.keepWhitespace=typeof de.insertTextRules>"u"?!1:!!(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Pe.insertText=new n.SnippetString(de.insertText):(Pe.insertText=de.insertText,Pe.textEdit=Pe.range instanceof n.Range?new n.TextEdit(Pe.range,Pe.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Pe.additionalTextEdits=de.additionalTextEdits.map(Ne=>J.to(Ne))),Pe.command=X&&de.command?X.fromInternal(de.command):void 0,Pe}ye.to=Ie})(Ee||(e.CompletionItem=Ee={}));var De;(function(ye){function Ie(X){if(typeof X.label!="string"&&!Array.isArray(X.label))throw new TypeError("Invalid label");return{label:X.label,documentation:he.fromStrict(X.documentation)}}ye.from=Ie;function de(X){return{label:X.label,documentation:k.isMarkdownString(X.documentation)?he.to(X.documentation):X.documentation}}ye.to=de})(De||(e.ParameterInformation=De={}));var ke;(function(ye){function Ie(X){return{label:X.label,documentation:he.fromStrict(X.documentation),parameters:Array.isArray(X.parameters)?X.parameters.map(De.from):[],activeParameter:X.activeParameter}}ye.from=Ie;function de(X){return{label:X.label,documentation:k.isMarkdownString(X.documentation)?he.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(De.to):[],activeParameter:X.activeParameter}}ye.to=de})(ke||(e.SignatureInformation=ke={}));var Fe;(function(ye){function Ie(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(ke.from):[]}}ye.from=Ie;function de(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(ke.to):[]}}ye.to=de})(Fe||(e.SignatureHelp=Fe={}));var ze;(function(ye){function Ie(de,X){const Pe=new n.InlayHint(l.to(X.position),typeof X.label=="string"?X.label:X.label.map(me.to.bind(void 0,de)),X.kind&&Se.to(X.kind));return Pe.textEdits=X.textEdits&&X.textEdits.map(J.to),Pe.tooltip=k.isMarkdownString(X.tooltip)?he.to(X.tooltip):X.tooltip,Pe.paddingLeft=X.paddingLeft,Pe.paddingRight=X.paddingRight,Pe}ye.to=Ie})(ze||(e.InlayHint=ze={}));var me;(function(ye){function Ie(de,X){const Pe=new n.InlayHintLabelPart(X.label);return Pe.tooltip=k.isMarkdownString(X.tooltip)?he.to(X.tooltip):X.tooltip,p.Command.is(X.command)&&(Pe.command=de.fromInternal(X.command)),X.location&&(Pe.location=M.to(X.location)),Pe}ye.to=Ie})(me||(e.InlayHintLabelPart=me={}));var Se;(function(ye){function Ie(X){return X}ye.from=Ie;function de(X){return X}ye.to=de})(Se||(e.InlayHintKind=Se={}));var we;(function(ye){function Ie(X){return{range:i.from(X.range),url:X.target,tooltip:X.tooltip}}ye.from=Ie;function de(X){let Pe;if(X.url)try{Pe=typeof X.url=="string"?h.URI.parse(X.url,!0):h.URI.revive(X.url)}catch{}return new n.DocumentLink(i.to(X.range),Pe)}ye.to=de})(we||(e.DocumentLink=we={}));var Ue;(function(ye){function Ie(X){const Pe=new n.ColorPresentation(X.label);return X.textEdit&&(Pe.textEdit=J.to(X.textEdit)),X.additionalTextEdits&&(Pe.additionalTextEdits=X.additionalTextEdits.map(Ne=>J.to(Ne))),Pe}ye.to=Ie;function de(X){return{label:X.label,textEdit:X.textEdit?J.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(Pe=>J.from(Pe)):void 0}}ye.from=de})(Ue||(e.ColorPresentation=Ue={}));var Be;(function(ye){function Ie(X){return new n.Color(X[0],X[1],X[2],X[3])}ye.to=Ie;function de(X){return[X.red,X.green,X.blue,X.alpha]}ye.from=de})(Be||(e.Color=Be={}));var et;(function(ye){function Ie(X){return{range:i.from(X.range)}}ye.from=Ie;function de(X){return new n.SelectionRange(i.to(X.range))}ye.to=de})(et||(e.SelectionRange=et={}));var He;(function(ye){function Ie(de){switch(de){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}ye.to=Ie})(He||(e.TextDocumentSaveReason=He={}));var Ve;(function(ye){function Ie(X){switch(X){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Ie;function de(X){switch(X){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}ye.to=de})(Ve||(e.TextEditorLineNumbersStyle=Ve={}));var Ze;(function(ye){function Ie(X){if(X===n.EndOfLine.CRLF)return 1;if(X===n.EndOfLine.LF)return 0}ye.from=Ie;function de(X){if(X===1)return n.EndOfLine.CRLF;if(X===0)return n.EndOfLine.LF}ye.to=de})(Ze||(e.EndOfLine=Ze={}));var it;(function(ye){function Ie(de){if(typeof de=="object")return de.viewId;switch(de){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Ie})(it||(e.ProgressLocation=it={}));var Ke;(function(ye){function Ie(X){const Pe={start:X.start+1,end:X.end+1};return X.kind&&(Pe.kind=Xe.from(X.kind)),Pe}ye.from=Ie;function de(X){const Pe={start:X.start-1,end:X.end-1};return X.kind&&(Pe.kind=Xe.to(X.kind)),Pe}ye.to=de})(Ke||(e.FoldingRange=Ke={}));var Xe;(function(ye){function Ie(X){if(X)switch(X){case n.FoldingRangeKind.Comment:return p.FoldingRangeKind.Comment;case n.FoldingRangeKind.Imports:return p.FoldingRangeKind.Imports;case n.FoldingRangeKind.Region:return p.FoldingRangeKind.Region}}ye.from=Ie;function de(X){if(X)switch(X.value){case p.FoldingRangeKind.Comment.value:return n.FoldingRangeKind.Comment;case p.FoldingRangeKind.Imports.value:return n.FoldingRangeKind.Imports;case p.FoldingRangeKind.Region.value:return n.FoldingRangeKind.Region}}ye.to=de})(Xe||(e.FoldingRangeKind=Xe={}));var fe;(function(ye){function Ie(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?i.from(de.selection):void 0,override:typeof de.override=="boolean"?c.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ye.from=Ie})(fe||(e.TextEditorOpenOptions=fe={}));var Ce;(function(ye){function Ie(Ne){return Ne instanceof n.RelativePattern?Ne.toJSON():typeof Ne=="string"?Ne:de(Ne)||X(Ne)?new n.RelativePattern(Ne.baseUri??Ne.base,Ne.pattern).toJSON():Ne}ye.from=Ie;function de(Ne){const We=Ne;return We?h.URI.isUri(We.baseUri)&&typeof We.pattern=="string":!1}function X(Ne){const We=Ne;return We?typeof We.base=="string"&&typeof We.pattern=="string":!1}function Pe(Ne){return typeof Ne=="string"?Ne:new n.RelativePattern(h.URI.revive(Ne.baseUri),Ne.pattern)}ye.to=Pe})(Ce||(e.GlobPattern=Ce={}));var Te;(function(ye){function Ie(de){if(de){if(Array.isArray(de))return de.map(Ie);if(typeof de=="string")return de;{const X=de;return{language:X.language,scheme:X.scheme,pattern:Ce.from(X.pattern),exclusive:X.exclusive,notebookType:X.notebookType}}}else return}ye.from=Ie})(Te||(e.LanguageSelector=Te={}));var Re;(function(ye){function Ie(X){return{start:X.start,end:X.end}}ye.from=Ie;function de(X){return new n.NotebookRange(X.start,X.end)}ye.to=de})(Re||(e.NotebookRange=Re={}));var Oe;(function(ye){function Ie(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}ye.to=Ie;function de(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}ye.from=de})(Oe||(e.NotebookCellExecutionSummary=Oe={}));var $e;(function(ye){function Ie(de){if(de===u.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(de===u.NotebookCellExecutionState.Pending)return;if(de===u.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}ye.to=Ie})($e||(e.NotebookCellExecutionState=$e={}));var Ge;(function(ye){function Ie(X){switch(X){case n.NotebookCellKind.Markup:return u.CellKind.Markup;case n.NotebookCellKind.Code:default:return u.CellKind.Code}}ye.from=Ie;function de(X){switch(X){case u.CellKind.Markup:return n.NotebookCellKind.Markup;case u.CellKind.Code:default:return n.NotebookCellKind.Code}}ye.to=de})(Ge||(e.NotebookCellKind=Ge={}));var qe;(function(ye){function Ie(X){const Pe={metadata:X.metadata??Object.create(null),cells:[]};for(const Ne of X.cells)n.NotebookCellData.validate(Ne),Pe.cells.push(tt.from(Ne));return Pe}ye.from=Ie;function de(X){const Pe=new n.NotebookData(X.cells.map(tt.to));return(0,v.isEmptyObject)(X.metadata)||(Pe.metadata=X.metadata),Pe}ye.to=de})(qe||(e.NotebookData=qe={}));var tt;(function(ye){function Ie(X){return{cellKind:Ge.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:Oe.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(Ye.from):[]}}ye.from=Ie;function de(X){return new n.NotebookCellData(Ge.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(Ye.to):void 0,X.metadata,X.internalMetadata?Oe.to(X.internalMetadata):void 0)}ye.to=de})(tt||(e.NotebookCellData=tt={}));var Je;(function(ye){function Ie(X){return{mime:X.mime,valueBytes:L.VSBuffer.wrap(X.data)}}ye.from=Ie;function de(X){return new n.NotebookCellOutputItem(X.valueBytes.buffer,X.mime)}ye.to=de})(Je||(e.NotebookCellOutputItem=Je={}));var Ye;(function(ye){function Ie(X){return{outputId:X.id,items:X.items.map(Je.from),metadata:X.metadata}}ye.from=Ie;function de(X){const Pe=X.items.map(Je.to);return new n.NotebookCellOutput(Pe,X.outputId,X.metadata)}ye.to=de})(Ye||(e.NotebookCellOutput=Ye={}));var at;(function(ye){function Ie(Pe){return X(Pe)?{include:(0,v.withNullAsUndefined)(Ce.from(Pe.include)),exclude:(0,v.withNullAsUndefined)(Ce.from(Pe.exclude))}:(0,v.withNullAsUndefined)(Ce.from(Pe))}ye.from=Ie;function de(Pe){return X(Pe)?{include:Ce.to(Pe.include),exclude:Ce.to(Pe.exclude)}:Ce.to(Pe)}ye.to=de;function X(Pe){const Ne=Pe;return Ne?!(0,v.isUndefinedOrNull)(Ne.include)&&!(0,v.isUndefinedOrNull)(Ne.exclude):!1}})(at||(e.NotebookExclusiveDocumentPattern=at={}));var gt;(function(ye){function Ie(de,X,Pe){const Ne=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Ne,Pe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}ye.from=Ie})(gt||(e.NotebookStatusBarItem=gt={}));var st;(function(ye){function Ie(de,X,Pe){const Ne=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:X.toInternal(Ne,Pe),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}ye.from=Ie})(st||(e.NotebookKernelSourceAction=st={}));var Nt;(function(ye){function Ie(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}ye.from=Ie})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Et;(function(ye){function Ie(X){return{uri:X.uri,provides:X.provides}}ye.from=Ie;function de(X){return new n.NotebookRendererScript(h.URI.revive(X.uri),X.provides)}ye.to=de})(Et||(e.NotebookRendererScript=Et={}));var Ct;(function(ye){function Ie(X){return{message:he.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location&&{range:i.from(X.location.range),uri:X.location.uri}}}ye.from=Ie;function de(X){const Pe=new n.TestMessage(typeof X.message=="string"?X.message:he.to(X.message));return Pe.actualOutput=X.actual,Pe.expectedOutput=X.expected,Pe.location=X.location?M.to(X.location):void 0,Pe}ye.to=de})(Ct||(e.TestMessage=Ct={}));var dt;(function(ye){ye.namespace=O.namespaceTestTag,ye.denamespace=O.denamespaceTestTag})(dt||(e.TestTag=dt={}));var pt;(function(ye){function Ie(X){const Pe=(0,f.getPrivateApiFor)(X).controllerId;return{extId:D.TestId.fromExtHostTestItem(X,Pe).toString(),label:X.label,uri:h.URI.revive(X.uri),busy:X.busy,tags:X.tags.map(Ne=>dt.namespace(Pe,Ne.id)),range:g.Range.lift(i.from(X.range)),description:X.description||null,sortText:X.sortText||null,error:X.error&&he.fromStrict(X.error)||null}}ye.from=Ie;function de(X){return{parent:void 0,error:void 0,id:D.TestId.fromString(X.extId).localId,label:X.label,uri:h.URI.revive(X.uri),tags:(X.tags||[]).map(Pe=>{const{tagId:Ne}=dt.denamespace(Pe);return new n.TestTag(Ne)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(X.range||void 0),canResolveChildren:!1,busy:X.busy,description:X.description||void 0,sortText:X.sortText||void 0}}ye.toPlain=de})(pt||(e.TestItem=pt={})),function(ye){function Ie(X){return{id:X.id}}ye.from=Ie;function de(X){return new n.TestTag(X.id)}ye.to=de}(dt||(e.TestTag=dt={}));var At;(function(ye){const Ie=(X,Pe)=>{const Ne=[];for(const[je,Qe]of Pe)D.TestId.compare(Qe.item.extId,je)===2&&(Pe.delete(je),Ne.push(Qe));const We={...pt.toPlain(X.item),parent:void 0,taskStates:X.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(Qe=>Qe.type===0).map(Ct.to)})),children:Ne.map(je=>Ie(je,Pe))};for(const je of We.children)je.parent=We;return We};function de(X){const Pe=[],Ne=new Map;for(const We of X.items){Ne.set(We.item.extId,We);const je=D.TestId.root(We.item.extId);X.request.targets.some(Qe=>Qe.controllerId===je&&Qe.testIds.includes(We.item.extId))&&Pe.push(We)}return{completedAt:X.completedAt,results:Pe.map(We=>Ie(We,Ne))}}ye.to=de})(At||(e.TestResults=At={}));var Ft;(function(ye){function Ie(Ne){return{covered:Ne.covered,total:Ne.covered}}function de(Ne){return"line"in Ne?l.from(Ne):i.from(Ne)}function X(Ne){return"branches"in Ne?{count:Ne.executionCount,location:de(Ne.location),type:1,branches:Ne.branches.length?Ne.branches.map(We=>({count:We.executionCount,location:We.location&&de(We.location)})):void 0}:{type:0,count:Ne.executionCount,location:de(Ne.location)}}ye.fromDetailed=X;function Pe(Ne){return{uri:Ne.uri,statement:Ie(Ne.statementCoverage),branch:Ne.branchCoverage&&Ie(Ne.branchCoverage),function:Ne.functionCoverage&&Ie(Ne.functionCoverage),details:Ne.detailedCoverage?.map(X)}}ye.fromFile=Pe})(Ft||(e.TestCoverage=Ft={}));var St;(function(ye){function Ie(de){switch(de){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}ye.to=Ie})(St||(e.CodeActionTriggerKind=St={}));var Rt;(function(ye){function Ie(X){const Pe=new n.TypeHierarchyItem(ne.to(X.kind),X.name,X.detail||"",h.URI.revive(X.uri),i.to(X.range),i.to(X.selectionRange));return Pe._sessionId=X._sessionId,Pe._itemId=X._itemId,Pe}ye.to=Ie;function de(X,Pe,Ne){if(Pe=Pe??X._sessionId,Ne=Ne??X._itemId,Pe===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ne,kind:ne.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:i.from(X.range),selectionRange:i.from(X.selectionRange),tags:X.tags?.map(x.from)}}ye.from=de})(Rt||(e.TypeHierarchyItem=Rt={}));var Mt;(function(ye){function Ie(de){if(de)return{value:de.value,tooltip:de.tooltip}}ye.from=Ie})(Mt||(e.ViewBadge=Mt={}));var ht;(function(ye){function Ie(Ne,We,je){const Qe=We.fileData;return Qe?new n.InternalFileDataTransferItem(new n.DataTransferFile(Qe.name,h.URI.revive(Qe.uri),Qe.id,(0,A.once)(()=>je(Qe.id)))):Ne===T.Mimes.uriList&&We.uriListData?new n.InternalDataTransferItem(Pe(We.uriListData)):new n.InternalDataTransferItem(We.asString)}ye.to=Ie;async function de(Ne,We){const je=await We.asString();if(Ne===T.Mimes.uriList)return{asString:je,fileData:void 0,uriListData:X(je)};const Qe=We.asFile();return{asString:je,fileData:Qe?{name:Qe.name,uri:Qe.uri,id:Qe._itemId??Qe.id}:void 0}}ye.from=de;function X(Ne){return o.UriList.split(Ne).map(We=>{if(We.startsWith("#"))return We;try{return h.URI.parse(We)}catch{}return We})}function Pe(Ne){return o.UriList.create(Ne.map(We=>typeof We=="string"?We:h.URI.revive(We)))}})(ht||(e.DataTransferItem=ht={}));var Ut;(function(ye){function Ie(X,Pe){const Ne=X.items.map(([We,je])=>[We,ht.to(We,je,Pe)]);return new n.DataTransfer(Ne)}ye.toDataTransfer=Ie;async function de(X){const Pe={items:[]},Ne=[];for(const[We,je]of X)Ne.push((async()=>{Pe.items.push([We,await ht.from(We,je)])})());return await Promise.all(Ne),Pe}ye.from=de})(Ut||(e.DataTransfer=Ut={}));var Dt;(function(ye){function Ie(X){return{message:X.message,metadata:X.metadata,title:X.title,tooltip:X.tooltip}}ye.to=Ie;function de(X){return{kind:"reply",message:X.message,metadata:X.metadata,title:X.title,tooltip:X.tooltip}}ye.from=de})(Dt||(e.ChatReplyFollowup=Dt={}));var ot;(function(ye){function Ie(de){return typeof de=="string"?{title:de,message:de,kind:"reply"}:"commandId"in de?{kind:"command",title:de.title??"",commandId:de.commandId??"",args:de.args}:Dt.from(de)}ye.from=Ie})(ot||(e.ChatFollowup=ot={}))}),define(pe[277],be([1,0,49,131,69,130,89,135,4]),function(le,e,S,L,o,A,k,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const m=(u,D,O,t)=>{let n=D;return{enumerable:!0,configurable:!1,get(){return n},set(s){if(!O(n,s)){const i=n;n=s,u.listener?.(t(s,i))}}}},T=(u,D)=>u===D,y={range:(u,D)=>u===D?!0:!u||!D?!1:u.isEqual(D),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(u,D)=>!(u.length!==D.length||u.some(O=>!D.find(t=>O.id===t.id)))},v=u=>D=>({op:4,update:u(D)}),h=(u,D)=>({range:(()=>{let O;const t=v(n=>({range:S.Range.lift(R.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return O},set(n){u.listener?.({op:6}),y.range(O,n)||(O=n,u.listener?.(t(n)))}}})(),label:m(u,D,y.label,v(O=>({label:O}))),description:m(u,void 0,y.description,v(O=>({description:O}))),sortText:m(u,void 0,y.sortText,v(O=>({sortText:O}))),canResolveChildren:m(u,!1,y.canResolveChildren,O=>({op:2,state:O})),busy:m(u,!1,y.busy,v(O=>({busy:O}))),error:m(u,void 0,y.error,v(O=>({error:R.MarkdownString.fromStrict(O)||null}))),tags:m(u,[],y.tags,(O,t)=>({op:1,new:O.map(R.TestTag.from),old:t.map(R.TestTag.from)}))}),g=u=>{const D=o.TestId.fromString(u.extId),O=new r(D.controllerId,D.localId,u.label,b.URI.revive(u.uri)||void 0);return O.range=R.Range.to(u.range||void 0),O.description=u.description||void 0,O.sortText=u.sortText||void 0,O.tags=u.tags.map(t=>R.TestTag.to({id:(0,k.denamespaceTestTag)(t).tagId})),O},p=u=>{let D;for(const O of u.tests){const t=g(O.item);(0,L.getPrivateApiFor)(t).parent=D,D=t}return D};e.toItemFromContext=p;class r{constructor(D,O,t,n){if(O.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(O)} symbol`);const s=(0,L.createPrivateApiFor)(this,D);Object.defineProperties(this,{id:{value:O,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof f?void 0:s.parent}},children:{value:(0,A.createTestItemChildren)(s,L.getPrivateApiFor,r),enumerable:!0,writable:!1},...h(s,t)})}}e.TestItemImpl=r;class f extends r{constructor(D,O){super(D,D,O,void 0),this._isRoot=!0}}e.TestItemRootImpl=f;class c extends A.TestItemCollection{constructor(D,O,t){super({controllerId:D,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:L.getPrivateApiFor,getChildren:n=>n.children,root:new f(D,O),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=c}),define(pe[278],be([1,0,34,200,53]),function(le,e,S,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function A(k,R,b,m){const T=new S.ExtensionIdentifierMap;return k.forEach(y=>{const v=T.get(y.identifier);v&&m.warn((0,L.localize)(0,null,v.extensionLocation.fsPath,y.extensionLocation.fsPath)),T.set(y.identifier,y)}),R.forEach(y=>{const v=T.get(y.identifier);if(v)if(v.isBuiltin){if(o.gte(v.version,y.version)){m.warn(`Skipping extension ${y.extensionLocation.path} in favour of the builtin extension ${v.extensionLocation.path}.`);return}y.isBuiltin=!0}else m.warn((0,L.localize)(1,null,v.extensionLocation.fsPath,y.extensionLocation.fsPath));else if(y.isBuiltin){m.warn(`Skipping obsolete builtin extension ${y.extensionLocation.path}`);return}T.set(y.identifier,y)}),b.forEach(y=>{m.info((0,L.localize)(2,null,y.extensionLocation.fsPath));const v=T.get(y.identifier);v&&v.isBuiltin&&(y.isBuiltin=!0),T.set(y.identifier,y)}),Array.from(T.values())}e.dedupExtensions=A}),define(pe[279],be([1,0,7,3,29,4,41,51,64,57,278,13]),function(le,e,S,L,o,A,k,R,b,m,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteExtensionsScannerChannel=e.RemoteExtensionsScannerService=void 0;class v{constructor(p,r,f,c,u,D,O){this.b=p,this.c=f,this.d=c,this.f=u,this.g=D,this.h=O;const t=r.args["install-builtin-extension"];if(t){u.trace("Installing builtin extensions passed via args...");const s={isMachineScoped:!!r.args["do-not-sync"],installPreReleaseVersion:!!r.args["pre-release"]};k.mark("code/server/willInstallBuiltinExtensions"),this.a=p.installExtensions([],this.i(t),s,!!r.args.force).then(()=>{k.mark("code/server/didInstallBuiltinExtensions"),u.trace("Finished installing builtin extensions")},i=>{u.error(i)})}else this.a=Promise.resolve();const n=r.args["install-extension"];n&&(u.trace("Installing extensions passed via args..."),this.a.then(()=>p.installExtensions(this.i(n),[],{isMachineScoped:!!r.args["do-not-sync"],installPreReleaseVersion:!!r.args["pre-release"],isApplicationScoped:!0},!!r.args.force)).then(()=>{u.trace("Finished installing extensions")},s=>{u.error(s)}))}i(p){return p.map(r=>/\.vsix$/i.test(r)?A.URI.file((0,S.isAbsolute)(r)?r:(0,S.join)((0,o.cwd)(),r)):r)}whenExtensionsReady(){return this.a}async scanExtensions(p,r,f,c){k.mark("code/server/willScanExtensions"),this.f.trace(`Scanning extensions using UI language: ${p}`),await this.whenExtensionsReady();const u=f?f.filter(O=>O.scheme===y.Schemas.file).map(O=>O.fsPath):void 0;r=r??this.c.defaultProfile.extensionsResource;const D=await this.j(r,p??L.language,u,c);return this.f.trace("Scanned Extensions",D),this.q(D),k.mark("code/server/didScanExtensions"),D}async scanSingleExtension(p,r,f){await this.whenExtensionsReady();const c=p.scheme===y.Schemas.file?p.fsPath:null;if(!c)return null;const u=await this.n(c,r,f??L.language);return u?(this.q([u]),u):null}async j(p,r,f,c){await this.o(r,c);const[u,D,O]=await Promise.all([this.l(r),this.m(p,r),this.k(r,f)]);return(0,T.dedupExtensions)(u,D,O,this.f)}async k(p,r){return r?(await Promise.all(r.map(f=>this.d.scanOneOrMultipleExtensions(A.URI.file((0,S.resolve)(f)),1,{language:p})))).flat().map(f=>(0,m.toExtensionDescription)(f,!0)):[]}async l(p){return(await this.d.scanSystemExtensions({language:p,useCache:!0})).map(f=>(0,m.toExtensionDescription)(f,!1))}async m(p,r){return(await this.d.scanUserExtensions({profileLocation:p,language:r,useCache:!0})).map(c=>(0,m.toExtensionDescription)(c,!1))}async n(p,r,f){const c=A.URI.file((0,S.resolve)(p)),u=r?0:1,D=await this.d.scanExistingExtension(c,u,{language:f});return D?(0,m.toExtensionDescription)(D,!1):null}async o(p,r){if(!(p===L.LANGUAGE_DEFAULT||!this.g.isEnabled())){try{if((await this.h.getInstalledLanguages()).find(c=>c.id===p)){this.f.trace(`Language Pack ${p} is already installed. Skipping language pack installation.`);return}}catch(f){this.f.error(f)}if(!r){this.f.trace(`No language pack id provided for language ${p}. Skipping language pack installation.`);return}this.f.trace(`Language Pack ${r} for language ${p} is not installed. It will be installed now.`);try{await this.b.installExtensions([r],[],{isMachineScoped:!0},!0)}catch(f){this.f.error(f)}}}q(p){const r=(t,n)=>t.replace(/file/g,"vscode-remote"),f=t=>{let n="";return n+=t.global?"g":"",n+=t.ignoreCase?"i":"",n+=t.multiline?"m":"",new RegExp(r(t.source,!0),n)},c=new class{mapDefined(t){return b.ContextKeyDefinedExpr.create(t)}mapNot(t){return b.ContextKeyNotExpr.create(t)}mapEquals(t,n){return t==="resourceScheme"&&typeof n=="string"?b.ContextKeyEqualsExpr.create(t,r(n,!1)):b.ContextKeyEqualsExpr.create(t,n)}mapNotEquals(t,n){return t==="resourceScheme"&&typeof n=="string"?b.ContextKeyNotEqualsExpr.create(t,r(n,!1)):b.ContextKeyNotEqualsExpr.create(t,n)}mapGreater(t,n){return b.ContextKeyGreaterExpr.create(t,n)}mapGreaterEquals(t,n){return b.ContextKeyGreaterEqualsExpr.create(t,n)}mapSmaller(t,n){return b.ContextKeySmallerExpr.create(t,n)}mapSmallerEquals(t,n){return b.ContextKeySmallerEqualsExpr.create(t,n)}mapRegex(t,n){return t==="resourceScheme"&&n?b.ContextKeyRegexExpr.create(t,f(n)):b.ContextKeyRegexExpr.create(t,n)}mapIn(t,n){return b.ContextKeyInExpr.create(t,n)}mapNotIn(t,n){return b.ContextKeyNotInExpr.create(t,n)}},u=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const n=b.ContextKeyExpr.deserialize(t.when);if(!n)return;const s=n.map(c);t.when=s.serialize()},D=t=>{if(Array.isArray(t))for(const n of t)u(n);else u(t)},O=t=>{for(const n in t)D(t[n])};p.forEach(t=>{t.contributes&&(t.contributes.menus&&O(t.contributes.menus),t.contributes.keybindings&&D(t.contributes.keybindings),t.contributes.views&&O(t.contributes.views))})}}e.RemoteExtensionsScannerService=v;class h{constructor(p,r){this.a=p,this.b=r}listen(p,r){throw new Error("Invalid listen")}async call(p,r,f){const c=this.b(p);switch(r){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const u=f[0],D=f[1]?A.URI.revive(c.transformIncoming(f[1])):void 0,O=Array.isArray(f[2])?f[2].map(s=>A.URI.revive(c.transformIncoming(s))):void 0,t=f[3];return(await this.a.scanExtensions(u,D,O,t)).map(s=>(0,R.transformOutgoingURIs)(s,c))}case"scanSingleExtension":{const u=await this.a.scanSingleExtension(A.URI.revive(c.transformIncoming(f[0])),f[1],f[2]);return u?(0,R.transformOutgoingURIs)(u,c):null}}throw new Error("Invalid call")}}e.RemoteExtensionsScannerChannel=h}),define(pe[136],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class S{constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++S.count}}e.ProxyIdentifier=S,S.count=0;const L=[];function o(R){const b=new S(R);return L[b.nid]=b,b}e.createProxyIdentifier=o;function A(R){return L[R].sid}e.getStringIdentifierForProxy=A;class k{constructor(b){this.value=b}}e.SerializableObjectWithBuffers=k}),define(pe[280],be([1,0,136]),function(le,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var o;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(o||(e.TabInputKind=o={}));var A;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var k;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(k||(e.WebviewEditorCapabilities=k={}));var R;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(R||(e.WebviewMessageArrayBufferViewType=R={}));var b;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var m;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(m||(e.NotebookEditorRevealType=m={}));var T;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(T||(e.CandidatePortSource=T={}));class y{static mixin(r){return r._id=y.a++,r}}e.IdObject=y,y.a=0;var v;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.kindModifier="m",p.commandIdent="n",p.commandId="o",p.commandArguments="p"})(v||(e.ISuggestDataDtoField=v={}));var h;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(h||(e.ISuggestResultDtoField=h={}));var g;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.MainContext={MainThreadAuthentication:(0,S.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,S.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,S.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,S.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,S.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,S.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,S.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,S.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,S.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,S.createProxyIdentifier)("MainThreadChat"),MainThreadInteractiveEditor:(0,S.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,S.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,S.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,S.createProxyIdentifier)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,S.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,S.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,S.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,S.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,S.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostChat:(0,S.createProxyIdentifier)("ExtHostChat"),ExtHostSemanticSimilarity:(0,S.createProxyIdentifier)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,S.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,S.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,S.createProxyIdentifier)("ExtHostIssueReporter")}});var kt=this&&this.__classPrivateFieldSet||function(le,e,S,L,o){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!o)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?le!==e||!o:!e.has(le))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?o.call(le,S):o?o.value=S:e.set(le,S),S},rt=this&&this.__classPrivateFieldGet||function(le,e,S,L){if(S==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?le!==e||!L:!e.has(le))throw new TypeError("Cannot read private member from an object whose class did not declare it");return S==="m"?L:S==="a"?L.call(le):L?L.value:e.get(le)};define(pe[281],be([1,0,8,134,135,21,280,18,12,50,49,97,4,2,5,264,277,15,136,38,98,37,275]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f,c,u,D,O,t){"use strict";var n,s,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=e.ExtHostCommands=class{constructor(w,N,$){n.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),i.set(this,void 0),kt(this,n,w.getProxy(k.MainContext.MainThreadCommands),"f"),this.d=N,kt(this,i,$,"f"),kt(this,s,w.getProxy(k.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,se=>{const he=this.c.get(se);return he?.result===I.Void?he:void 0},N),this.f=[{processArgument(se){return(0,m.revive)(se)}},{processArgument(se){return(0,A.cloneAndChange)(se,function(he){if(T.Range.isIRange(he))return o.Range.to(he);if(y.Position.isIPosition(he))return o.Position.to(he);if(T.Range.isIRange(he.range)&&v.URI.isUri(he.uri))return o.location.to(he);if(he instanceof f.VSBuffer)return he.buffer.buffer;if(!Array.isArray(he))return he})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const N=this.registerCommand(!1,w.id,async(...$)=>{const se=w.args.map((ae,ue)=>{if(!ae.validate($[ue]))throw new Error(`Invalid argument '${ae.name}' when running '${w.id}', received: ${$[ue]}`);return ae.convert($[ue])}),he=await this.executeCommand(w.internalId,...se);return w.result.convert(he,$,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new L.Disposable(()=>{N.dispose(),this.c.delete(w.id)})}registerCommand(w,N,$,se,he,ae){if(this.d.trace("ExtHostCommands#registerCommand",N),!N.trim().length)throw new Error("invalid id");if(this.b.has(N))throw new Error(`command '${N}' already exists`);return this.b.set(N,{callback:$,thisArg:se,description:he,extension:ae}),w&&rt(this,n,"f").$registerCommand(N),new L.Disposable(()=>{this.b.delete(N)&&w&&rt(this,n,"f").$unregisterCommand(N)})}executeCommand(w,...N){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,N,!0)}async g(w,N,$){if(this.b.has(w))return rt(this,n,"f").$fireCommandActivationEvent(w),this.h(w,N,!1);{let se=!1;const he=(0,A.cloneAndChange)(N,function(ae){if(ae instanceof L.Position)return o.Position.from(ae);if(ae instanceof L.Range)return o.Range.from(ae);if(ae instanceof L.Location)return o.location.from(ae);if(L.NotebookRange.isNotebookRange(ae))return o.NotebookRange.from(ae);if(ae instanceof ArrayBuffer)return se=!0,f.VSBuffer.wrap(new Uint8Array(ae));if(ae instanceof Uint8Array)return se=!0,f.VSBuffer.wrap(ae);if(ae instanceof f.VSBuffer)return se=!0,ae;if(!Array.isArray(ae))return ae});try{const ae=await rt(this,n,"f").$executeCommand(w,se?new c.SerializableObjectWithBuffers(he):he,$);return(0,m.revive)(ae)}catch(ae){if(ae instanceof Error&&ae.message==="$executeCommand:retry")return this.g(w,N,!1);throw ae}}}async h(w,N,$){const se=this.b.get(w);if(!se)throw new Error("Unknown command");const{callback:he,thisArg:ae,description:ue}=se;if(ue)for(let _=0;_<ue.args.length;_++)try{(0,S.validateConstraint)(N[_],ue.args[_].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${ue.args[_].name}' - ${ue.args[_].description}`)}const ge=D.StopWatch.create();try{return await he.apply(ae,N)}catch(_){if(w===this.converter.delegatingCommandId){const ie=this.converter.getActualCommand(...N);ie&&(w=ie.command)}if(this.d.error(_,w,se.extension?.identifier),!$)throw _;if(se.extension?.identifier){const ie=rt(this,i,"f").onExtensionError(se.extension.identifier,_);this.d.trace("forwarded error to extension?",ie,se.extension?.identifier)}throw new class extends Error{constructor(){super((0,u.toErrorMessage)(_)),this.id=w,this.source=se.extension?.displayName??se.extension?.name}}}finally{this.j(se,w,ge.elapsed())}}j(w,N,$){w.extension&&rt(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new O.TelemetryTrustedValue(N),duration:$})}$executeContributedCommand(w,...N){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const $=this.b.get(w);return $?(N=N.map(se=>this.f.reduce((he,ae)=>ae.processArgument(he,$.extension?.identifier),se)),this.h(w,N,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),rt(this,n,"f").$getCommands().then(N=>(w&&(N=N.filter($=>$[0]!=="_")),N))}$getContributedCommandHandlerDescriptions(){const w=Object.create(null);for(const[N,$]of this.b){const{description:se}=$;se&&(w[N]=se)}return Promise.resolve(w)}};n=new WeakMap,s=new WeakMap,i=new WeakMap,e.ExtHostCommands=a=Le([Ae(0,p.IExtHostRpcService),Ae(1,b.ILogService),Ae(2,t.IExtHostTelemetry)],a),e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class l{constructor(w,N,$){this.d=w,this.f=N,this.g=$,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,N){if(!w)return;const $={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return $;const se=this.f(w.command);if(se)$.id=se.internalId,$.arguments=se.args.map((he,ae)=>he.convert(w.arguments&&w.arguments[ae]));else if((0,R.isNonEmptyArray)(w.arguments)){const he=`${w.command}/${++this.c}`;this.b.set(he,w),N.add((0,h.toDisposable)(()=>{this.b.delete(he),this.g.trace("CommandsConverter#DISPOSE",he)})),$.$ident=he,$.id=this.delegatingCommandId,$.arguments=[he],this.g.trace("CommandsConverter#CREATE",w.command,he)}return $}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const N=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],N?N.command:"MISSING"),N?this.d.executeCommand(N.command,...N.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.CommandsConverter=l;class d{constructor(w,N,$,se){this.name=w,this.description=N,this.validate=$,this.convert=se}optional(){return new d(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,N){return new d(w??this.name,N??this.description,this.validate,this.convert)}}e.ApiCommandArgument=d,d.Uri=new d("uri","Uri of a text document",E=>v.URI.isUri(E),E=>E),d.Position=new d("position","A position in a text document",E=>L.Position.isPosition(E),o.Position.from),d.Range=new d("range","A range in a text document",E=>L.Range.isRange(E),o.Range.from),d.Selection=new d("selection","A selection in a text document",E=>L.Selection.isSelection(E),o.Selection.from),d.Number=new d("number","",E=>typeof E=="number",E=>E),d.String=new d("string","",E=>typeof E=="string",E=>E),d.CallHierarchyItem=new d("item","A call hierarchy item",E=>E instanceof L.CallHierarchyItem,o.CallHierarchyItem.from),d.TypeHierarchyItem=new d("item","A type hierarchy item",E=>E instanceof L.TypeHierarchyItem,o.TypeHierarchyItem.from),d.TestItem=new d("testItem","A VS Code TestItem",E=>E instanceof r.TestItemImpl,o.TestItem.from);class I{constructor(w,N){this.description=w,this.convert=N}}e.ApiCommandResult=I,I.Void=new I("no result",E=>E);class C{constructor(w,N,$,se,he){this.id=w,this.internalId=N,this.description=$,this.args=se,this.result=he}}e.ApiCommand=C}),define(pe[282],be([1,0,11,2,13,214]),function(le,e,S,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class k extends A.DiskFileSystemProviderClient{static register(b,m,T){const y=b.getConnection();if(!y)return L.Disposable.None;const v=new L.DisposableStore,h=(async()=>{try{const g=await b.getRawEnvironment();g?m.registerProvider(o.Schemas.vscodeRemote,v.add(new k(g,y))):T.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(g){T.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,S.getErrorMessage)(g))}})();return v.add(m.onWillActivateFileSystemProvider(g=>{g.scheme===o.Schemas.vscodeRemote&&g.join(h)})),v}constructor(b,m){super(m.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:b.os===3})}}e.RemoteFileSystemProviderClient=k}),define(pe[90],be([1,0,33,14,7,8,23,167,298,299]),function(le,e,S,L,o,A,k,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const T=new RegExp(e.CorruptZipMessage);class y extends Error{constructor(n,s){let i=s.message;switch(n){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=n,this.cause=s}}e.ExtractError=y;function v(t){const n=t.externalFileAttributes>>16||33188;return[448,56,7].map(s=>n&s).reduce((s,i)=>s+i,n&61440)}function h(t){if(t instanceof y)return t;let n;return T.test(t.message)&&(n="CorruptZip"),new y(n,t)}function g(t,n,s,i,a,l){const d=o.dirname(n),I=o.join(i,d);if(!I.startsWith(i))return Promise.reject(new Error(R.localize(0,null,n)));const C=o.join(i,n);let E;return l.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(k.Promises.mkdir(I,{recursive:!0})).then(()=>new Promise((w,N)=>{if(!l.isCancellationRequested)try{E=(0,S.createWriteStream)(C,{mode:s}),E.once("close",()=>w()),E.once("error",N),t.once("error",N),t.pipe(E)}catch($){N($)}}))}function p(t,n,s,i){let a=(0,L.createCancelablePromise)(()=>Promise.resolve()),l=0;return i.onCancellationRequested(()=>{a.cancel(),t.close()}),new Promise((d,I)=>{const C=new L.Sequencer,E=w=>{w.isCancellationRequested||(l++,t.readEntry())};t.once("error",I),t.once("close",()=>a.then(()=>{i.isCancellationRequested||t.entryCount===l?d():I(new y("Incomplete",new Error(R.localize(1,null,l,t.entryCount))))},I)),t.readEntry(),t.on("entry",w=>{if(i.isCancellationRequested)return;if(!s.sourcePathRegex.test(w.fileName)){E(i);return}const N=w.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(N)){const he=o.join(n,N);a=(0,L.createCancelablePromise)(ae=>k.Promises.mkdir(he,{recursive:!0}).then(()=>E(ae)).then(void 0,I));return}const $=f(t,w),se=v(w);a=(0,L.createCancelablePromise)(he=>C.queue(()=>$.then(ae=>g(ae,N,se,n,s,he).then(()=>E(he)))).then(null,I))})})}function r(t,n=!1){return new Promise((s,i)=>{(0,b.open)(t,n?{lazyEntries:!0}:void 0,(a,l)=>{a?i(h(a)):s((0,A.assertIsDefined)(l))})})}function f(t,n){return new Promise((s,i)=>{t.openReadStream(n,(a,l)=>{a?i(h(a)):s((0,A.assertIsDefined)(l))})})}function c(t,n){return new Promise((s,i)=>{const a=new m.ZipFile;n.forEach(d=>{d.contents?a.addBuffer(typeof d.contents=="string"?Buffer.from(d.contents,"utf8"):d.contents,d.path):d.localPath&&a.addFile(d.localPath,d.path)}),a.end();const l=(0,S.createWriteStream)(t);a.outputStream.pipe(l),a.outputStream.once("error",i),l.once("error",i),l.once("finish",()=>s(t))})}e.zip=c;function u(t,n,s={},i){const a=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let l=r(t,!0);return s.overwrite&&(l=l.then(d=>k.Promises.rm(n).then(()=>d))),l.then(d=>p(d,n,{sourcePathRegex:a},i))}e.extract=u;function D(t,n){return r(t).then(s=>new Promise((i,a)=>{s.on("entry",l=>{l.fileName===n&&f(s,l).then(d=>i(d),d=>a(d))}),s.once("close",()=>a(new Error(R.localize(2,null,n))))}))}function O(t,n){return D(t,n).then(s=>new Promise((i,a)=>{const l=[];s.once("error",a),s.on("data",d=>l.push(d)),s.on("end",()=>i(Buffer.concat(l)))}))}e.buffer=O}),define(pe[283],be([1,0,14,11,2,13,3,19,53,8,22,23,90,24,25,30,35,80,16,12]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let D=e.ExtensionsDownloader=class ii extends o.Disposable{constructor(t,n,s,i,a,l){super(),this.h=n,this.i=s,this.j=i,this.k=a,this.l=l,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(t,n,s){await this.g;const i=(0,R.joinPath)(this.extensionsDownloadDir,this.v(t));try{await this.r(t,i,l=>this.i.download(t,l,n))}catch(l){throw new p.ExtensionManagementError(l.message,p.ExtensionManagementErrorCode.Download)}let a=!1;if(s&&this.m(t)){const l=await this.n(t);try{a=await this.k.verify(i.fsPath,l.fsPath,this.l.getLevel()===u.LogLevel.Trace)}catch(d){const I=d;if(a=I.code,I.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${I.output}`),a===p.ExtensionSignaturetErrorCode.PackageIsInvalidZip||a===p.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new p.ExtensionManagementError(v.CorruptZipMessage,p.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(l)}catch(d){this.l.error(d)}}}return a===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):a===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${a}': ${t.identifier.id}`),{location:i,verificationStatus:a}}m(t){if(!t.isSigned)return!1;const n=this.j.getValue("extensions.verifySignature");return(0,m.isBoolean)(n)?n:!0}async n(t){await this.g;const n=(0,R.joinPath)(this.extensionsDownloadDir,`${this.v(t)}${ii.c}`);return await this.r(t,n,s=>this.i.downloadSignatureArchive(t,s)),n}async r(t,n,s){if(await this.h.exists(n))return;if(n.scheme!==A.Schemas.file){await s(n);return}const i=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,T.generateUuid)()}`);await this.h.exists(i)||await s(i);try{await this.t(i,n,Date.now()+2*60*1e3)}catch(a){try{await this.h.del(i)}catch{}if(a.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,n.path);else throw this.l.info(`Rename failed because of ${(0,L.getErrorMessage)(a)}. Deleted the file from downloaded location`,i.path),a}}async delete(t){await this.g,await this.h.del(t)}async t(t,n,s){try{await y.Promises.rename(t.fsPath,n.fsPath)}catch(i){if(k.isWindows&&i&&i.code==="EPERM"&&Date.now()<s)return this.l.info(`Failed renaming ${t} to ${n} with 'EPERM' error. Trying again...`),this.t(t,n,s);throw i}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const n=[],s=[],i=[];for(const d of t.children)if(d.name.endsWith(ii.c))i.push(d.resource);else{const I=r.ExtensionKey.parse(d.name);I&&s.push([I,d])}const a=(0,r.groupByExtension)(s,([d])=>d),l=[];for(const d of a)d.sort((I,C)=>b.rcompare(I[0].version,C[0].version)),n.push(...d.slice(1).map(I=>I[1].resource)),l.push(d[0][1]);l.sort((d,I)=>d.mtime-I.mtime),n.push(...l.slice(0,Math.max(0,l.length-this.f)).map(d=>d.resource)),n.push(...i),await S.Promises.settled(n.map(d=>(this.l.trace("Deleting from cache",d.path),this.h.del(d))))}}catch(t){this.l.error(t)}}v(t){return this.f?r.ExtensionKey.create(t).toString().toLowerCase():(0,T.generateUuid)()}};D.c=".sigzip",e.ExtensionsDownloader=D=Le([Ae(0,g.INativeEnvironmentService),Ae(1,c.IFileService),Ae(2,p.IExtensionGalleryService),Ae(3,h.IConfigurationService),Ae(4,f.IExtensionSignatureVerificationService),Ae(5,u.ILogService)],D)}),define(pe[284],be([1,0,90,179]),function(le,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function o(A){return(0,S.buffer)(A,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,L.localize)(0,null))}})}e.getManifest=o}),define(pe[137],be([1,0,14,15,20,38,11,6,2,27,13,7,3,19,53,8,4,22,23,90,178,79,25,255,30,35,44,57,283,256,284,231,240,77,16,5,12,26,31,36,32]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f,c,u,D,O,t,n,s,i,a,l,d,I,C,E,w,N,$,se,he,ae,ue,ge,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,se.refineServiceDecorator)(s.IExtensionManagementService);let ie=e.ExtensionManagementService=class extends n.AbstractExtensionManagementService{constructor(Y,ee,j,P,M,K,te,z,W,q,H,Q){super(Y,ee,j,q,Q),this.Z=M,this.ab=K,this.bb=te,this.cb=W,this.db=H,this.X=this.B(new R.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new m.ResourceSet;const G=this.B(z.createInstance(I.ExtensionsLifecycle));this.S=this.B(z.createInstance(V,ce=>G.postUninstall(ce))),this.U=this.B(new E.ExtensionsManifestCache(Q,W,H,this,this.v)),this.W=this.B(z.createInstance(d.ExtensionsDownloader));const Z=this.B(new w.ExtensionsWatcher(this,this.Z,Q,K,H,W,j));this.B(Z.onDidChangeExtensionsByAnotherSource(ce=>this.kb(ce))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(Y){this.v.trace("ExtensionManagementService#zip",Y.identifier.id);const ee=await this.jb(Y),j=await(0,u.zip)((0,h.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,ee);return r.URI.file(j)}async unzip(Y){return this.v.trace("ExtensionManagementService#unzip",Y.toString()),(await this.install(Y)).identifier}async getManifest(Y){const{location:ee,cleanup:j}=await this.fb(Y),P=y.resolve(ee.fsPath);try{return await(0,C.getManifest)(P)}finally{await j()}}getInstalled(Y,ee=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(Y??null,ee)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Y){return this.S.scanUserExtensionAtLocation(Y)}async install(Y,ee={}){this.v.trace("ExtensionManagementService#install",Y.toString());const{location:j,cleanup:P}=await this.fb(Y);try{const M=await(0,C.getManifest)(y.resolve(j.fsPath));if(M.engines&&M.engines.vscode&&!(0,N.isEngineValid)(M.engines.vscode,this.w.version,this.w.date))throw new Error(D.localize(0,null,(0,i.getGalleryExtensionId)(M.publisher,M.name),this.w.version));return await this.z(M,j,ee)}finally{await P()}}async installFromLocation(Y,ee){this.v.trace("ExtensionManagementService#installFromLocation",Y.toString());const j=await this.S.scanUserExtensionAtLocation(Y);if(!j)throw new Error(`Cannot find a valid extension from the location ${Y.toString()}`);return await this.ob([[j,void 0]],ee),this.v.info("Successfully installed extension",j.identifier.id,ee.toString()),j}async installExtensionsFromProfile(Y,ee,j){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",Y,ee.toString(),j.toString());const P=(await this.S.scanExtensions(1,ee)).filter(M=>Y.some(K=>(0,i.areSameExtensions)(K,M.identifier)));if(P.length){const M=await Promise.all(P.map(K=>this.S.scanMetadata(K,ee)));await this.ob(P.map((K,te)=>[K,M[te]]),j),this.v.info("Successfully installed extensions",P.map(K=>K.identifier.id),j.toString())}return P}async updateMetadata(Y,ee,j=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",Y.identifier.id),ee.isPreReleaseVersion&&(ee.preRelease=!0),ee.isMachineScoped=ee.isMachineScoped||void 0,ee.isBuiltin=ee.isBuiltin||void 0,ee.pinned=ee.pinned||void 0,Y=await this.S.updateMetadata(Y,ee,j),this.U.invalidate(j),this.X.fire(Y),Y}async reinstallFromGallery(Y){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",Y.identifier.id),!this.t.isEnabled())throw new Error(D.localize(1,null));const ee=await this.getTargetPlatform(),[j]=await this.t.getExtensions([{...Y.identifier,preRelease:Y.preRelease}],{targetPlatform:ee,compatible:!0},o.CancellationToken.None);if(!j)throw new Error(D.localize(2,null));await this.S.setUninstalled(Y);try{await this.S.removeUninstalledExtension(Y)}catch(P){throw new Error(D.localize(3,null,(0,A.toErrorMessage)(P)))}return this.installFromGallery(j)}copyExtensions(Y,ee){return this.S.copyExtensions(Y,ee)}markAsUninstalled(...Y){return this.S.setUninstalled(...Y)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(Y){this.v.error(Y)}}async download(Y,ee,j){const{location:P}=await this.W.download(Y,ee,!j);return P}async fb(Y){if(Y.scheme===T.Schemas.file)return{location:Y,async cleanup(){}};this.v.trace("Downloading extension from",Y.toString());const ee=(0,h.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)());return await this.bb.download(Y,ee),this.v.info("Downloaded extension to",ee.toString()),{location:ee,cleanup:async()=>{try{await this.cb.del(ee)}catch(P){this.v.error(P)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(Y,ee,j){if(r.URI.isUri(ee))return new ne(Y,ee,j,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const P=i.ExtensionKey.create(ee).toString();let M=this.Y.get(P);return M||(this.Y.set(P,M=new U(Y,ee,j,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),M.waitUntilTaskIsFinished().finally(()=>this.Y.delete(P))),M}R(Y,ee){return new x(Y,ee.profileLocation,this.ab)}async jb(Y){const ee=async P=>{let M=await c.Promises.readdir(P);M=M.map(z=>y.join(P,z));const K=await Promise.all(M.map(z=>c.Promises.stat(z)));let te=Promise.resolve([]);return K.forEach((z,W)=>{const q=M[W];z.isFile()&&(te=te.then(H=>[...H,q])),z.isDirectory()&&(te=te.then(H=>ee(q).then(Q=>[...H,...Q])))}),te};return(await ee(Y.location.fsPath)).map(P=>({path:`extension/${y.relative(Y.location.fsPath,P)}`,localPath:P}))}async kb({added:Y,removed:ee}){if(ee)for(const j of ee.extensions)this.v.info("Extensions removed from another source",j.id,ee.profileLocation.toString()),this.p.fire({identifier:j,profileLocation:ee.profileLocation});if(Y){const P=(await this.S.scanExtensions(1,Y.profileLocation)).filter(M=>Y.extensions.some(K=>(0,i.areSameExtensions)(K,M.identifier)));this.m.fire(P.map(M=>(this.v.info("Extensions added from another source",M.identifier.id,Y.profileLocation.toString()),{identifier:M.identifier,local:M,profileLocation:Y.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(ee=>this.lb.add(ee)));const Y=await this.cb.resolve(this.Z.userExtensionsLocation);for(const ee of Y.children??[])ee.isDirectory&&this.lb.add(ee.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(ee=>this.nb(ee)))}async nb(Y){if(!Y.affects(this.Z.userExtensionsLocation,1))return;const ee=[];for(const j of Y.rawAdded){if(this.lb.has(j)||!this.db.extUri.isEqual(this.db.extUri.dirname(j),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(j,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(j).startsWith(".")||!(await this.cb.stat(j)).isDirectory)continue;const P=await this.S.scanUserExtensionAtLocation(j);P&&P.installedTimestamp===void 0&&(this.lb.add(j),ee.push(P))}ee.length&&(await this.ob(ee.map(j=>[j,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",ee.map(j=>j.identifier.id)))}async ob(Y,ee){const j=Y.map(P=>P[0]);await this.pb(j),await this.ab.addExtensionsToProfile(Y,ee),this.m.fire(j.map(P=>({local:P,identifier:P.identifier,operation:1,profileLocation:ee})))}async pb(Y){const ee=await this.S.getUninstalledExtensions();for(const j of Y){const P=i.ExtensionKey.create(j);ee[P.toString()]&&(this.v.trace("Removing the extension from uninstalled list:",P.id),await this.S.setInstalled(P),this.v.info("Removed the extension from uninstalled list:",P.id))}}};e.ExtensionManagementService=ie=Le([Ae(0,s.IExtensionGalleryService),Ae(1,ue.ITelemetryService),Ae(2,he.ILogService),Ae(3,t.INativeEnvironmentService),Ae(4,l.IExtensionsScannerService),Ae(5,a.IExtensionsProfileScannerService),Ae(6,O.IDownloadService),Ae(7,se.IInstantiationService),Ae(8,$.IFileService),Ae(9,ae.IProductService),Ae(10,ge.IUriIdentityService),Ae(11,_.IUserDataProfilesService)],ie);let V=e.ExtensionsScanner=class extends b.Disposable{constructor(Y,ee,j,P,M,K){super(),this.k=Y,this.l=ee,this.m=j,this.n=P,this.p=M,this.s=K,this.h=this.B(new R.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,h.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new S.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(Y,ee){const j={includeInvalid:!0,profileLocation:ee};let P=[];return Y===null||Y===0?P.push(...await this.m.scanAllExtensions({includeInvalid:!0},j,!1)):Y===1&&P.push(...await this.m.scanUserExtensions(j)),P=Y!==null?P.filter(M=>M.type===Y):P,Promise.all(P.map(M=>this.y(M)))}async scanAllUserExtensions(Y){const ee=await this.m.scanUserExtensions({includeAllVersions:!Y,includeInvalid:!0});return Promise.all(ee.map(j=>this.y(j)))}async scanUserExtensionAtLocation(Y){try{const ee=await this.m.scanExistingExtension(Y,1,{includeInvalid:!0});if(ee)return await this.y(ee)}catch(ee){this.s.error(ee)}return null}async extractUserExtension(Y,ee,j,P){await this.j.catch(()=>{});const M=Y.toString(),K=y.join(this.m.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`),te=y.join(this.m.userExtensionsLocation.fsPath,M);try{await c.Promises.rm(te)}catch{throw new s.ExtensionManagementError(D.localize(4,null,te,Y.id),s.ExtensionManagementErrorCode.Delete)}await this.u(Y,ee,K,P),await this.m.updateMetadata(r.URI.file(K),j);try{this.h.fire(r.URI.file(te)),await this.v(Y,K,te,Date.now()+2*60*1e3),this.s.info("Renamed to",te)}catch(z){try{await c.Promises.rm(K)}catch{}if(z.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",Y.id);else throw this.s.info(`Rename failed because of ${(0,k.getErrorMessage)(z)}. Deleted from extracted location`,K),z}return this.w(r.URI.file(te),1)}async scanMetadata(Y,ee){return ee?(await this.n.scanProfileExtensions(ee)).find(P=>(0,i.areSameExtensions)(P.identifier,Y.identifier))?.metadata:this.m.scanMetadata(Y.location)}async updateMetadata(Y,ee,j){return j?await this.n.updateMetadata([[Y,ee]],j):await this.m.updateMetadata(Y.location,ee),this.w(Y.location,Y.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...Y){const ee=Y.map(j=>i.ExtensionKey.create(j));await this.t(j=>ee.forEach(P=>{j[P.toString()]=!0,this.s.info("Marked extension as uninstalled",P.toString())}))}async setInstalled(Y){await this.t(ee=>delete ee[Y.toString()])}async removeExtension(Y,ee){this.s.trace(`Deleting ${ee} extension from disk`,Y.identifier.id,Y.location.fsPath);const j=this.p.extUri.joinPath(this.p.extUri.dirname(Y.location),`._${(0,f.generateUuid)()}`);await this.v(Y.identifier,Y.location.fsPath,j.fsPath,Date.now()+2*60*1e3),await this.l.del(j,{recursive:!0}),this.s.info("Deleted from disk",Y.identifier.id,Y.location.fsPath)}async removeUninstalledExtension(Y){await this.removeExtension(Y,"uninstalled"),await this.t(ee=>delete ee[i.ExtensionKey.create(Y).toString()])}async copyExtensions(Y,ee){const j=await this.scanExtensions(1,Y),P=await Promise.all(j.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,Y)]));await this.n.addExtensionsToProfile(P,ee)}async t(Y){return this.g.queue(async()=>{let ee;try{ee=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(P){if((0,$.toFileOperationResult)(P)!==1)throw P}let j={};if(ee)try{j=JSON.parse(ee)}catch{}return Y&&(Y(j),Object.keys(j).length?await this.l.writeFile(this.c,L.VSBuffer.fromString(JSON.stringify(j))):await this.l.del(this.c)),j})}async u(Y,ee,j,P){this.s.trace(`Started extracting the extension from ${ee} to ${j}`);try{await c.Promises.rm(j)}catch(M){throw new s.ExtensionManagementError(this.D(M).message,s.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(ee,j,{sourcePath:"extension",overwrite:!0},P),this.s.info(`Extracted extension to ${j}:`,Y.id)}catch(M){try{await c.Promises.rm(j)}catch{}let K=s.ExtensionManagementErrorCode.Extract;throw M instanceof u.ExtractError&&(M.type==="CorruptZip"?K=s.ExtensionManagementErrorCode.CorruptZip:M.type==="Incomplete"&&(K=s.ExtensionManagementErrorCode.IncompleteZip)),new s.ExtensionManagementError(M.message,K)}}async v(Y,ee,j,P){try{await c.Promises.rename(ee,j)}catch(M){if(v.isWindows&&M&&M.code==="EPERM"&&Date.now()<P)return this.s.info(`Failed renaming ${ee} to ${j} with 'EPERM' error. Trying again...`,Y.id),this.v(Y,ee,j,P);throw new s.ExtensionManagementError(M.message||D.localize(5,null,ee,j),M.code||s.ExtensionManagementErrorCode.Rename)}}async w(Y,ee){const j=await this.m.scanExistingExtension(Y,ee,{includeInvalid:!0});if(j)return this.y(j);throw new Error(D.localize(6,null,Y.path))}async y(Y){const ee=await this.l.resolve(Y.location);let j,P;return ee.children&&(j=ee.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,P=ee.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:Y.identifier,type:Y.type,isBuiltin:Y.isBuiltin||!!Y.metadata?.isBuiltin,location:Y.location,manifest:Y.manifest,targetPlatform:Y.targetPlatform,validations:Y.validations,isValid:Y.isValid,readmeUrl:j,changelogUrl:P,publisherDisplayName:Y.metadata?.publisherDisplayName||null,publisherId:Y.metadata?.publisherId||null,isApplicationScoped:!!Y.metadata?.isApplicationScoped,isMachineScoped:!!Y.metadata?.isMachineScoped,isPreReleaseVersion:!!Y.metadata?.isPreReleaseVersion,preRelease:!!Y.metadata?.preRelease,installedTimestamp:Y.metadata?.installedTimestamp,updated:!!Y.metadata?.updated,pinned:!!Y.metadata?.pinned}}async z(){const Y=await this.getUninstalledExtensions();if(Object.keys(Y).length===0){this.s.debug("No uninstalled extensions found.");return}this.s.debug("Removing uninstalled extensions:",Object.keys(Y));const ee=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),j=new Set;for(const M of ee)Y[i.ExtensionKey.create(M).toString()]||j.add(M.identifier.id.toLowerCase());try{const M=(0,i.groupByExtension)(ee,K=>K.identifier);await S.Promises.settled(M.map(async K=>{const te=K.sort((z,W)=>g.rcompare(z.manifest.version,W.manifest.version))[0];j.has(te.identifier.id.toLowerCase())||await this.k(await this.y(te))}))}catch(M){this.s.error(M)}const P=ee.filter(M=>M.metadata&&Y[i.ExtensionKey.create(M).toString()]);await Promise.allSettled(P.map(M=>this.removeUninstalledExtension(M)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const Y=[];let ee;try{ee=await this.l.resolve(this.m.userExtensionsLocation)}catch(j){(0,$.toFileOperationResult)(j)!==1&&this.s.error(j)}for(const j of ee?.children??[])j.isDirectory&&j.name.startsWith("._")&&(0,f.isUUID)(j.name.substring(2))&&Y.push((async()=>{this.s.trace("Deleting the generated extension folder",j.resource.toString());try{await this.l.del(j.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",j.resource.toString())}catch(P){this.s.error(P)}})());await Promise.allSettled(Y)}D(Y){const ee=Array.isArray(Y)?Y:[Y];return ee.length===1?ee[0]instanceof Error?ee[0]:new Error(ee[0]):ee.reduce((j,P)=>new Error(`${j.message}${j.message?",":""}${P instanceof Error?P.message:P}`),new Error(""))}};e.ExtensionsScanner=V=Le([Ae(1,$.IFileService),Ae(2,l.IExtensionsScannerService),Ae(3,a.IExtensionsProfileScannerService),Ae(4,ge.IUriIdentityService),Ae(5,he.ILogService)],V);class J extends n.AbstractExtensionTask{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.isUndefined)(this.m.operation)?this.l:this.m.operation}constructor(Y,ee,j,P,M,K,te,z,W){super(),this.identifier=Y,this.source=ee,this.m=j,this.n=P,this.o=M,this.p=K,this.q=te,this.s=z,this.t=W,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h(Y){const[ee,j]=await this.y(Y);return this.j=ee.isBuiltin||ee.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[ee,j]],this.j),ee}async v({zipPath:Y,key:ee,metadata:j},P){let M=await this.w(ee);return M||(this.t.trace("Extracting extension...",ee.id),M=await this.n.extractUserExtension(ee,Y,j,P),this.t.info("Extracting extension completed.",ee.id)),M}async w(Y){return await this.x(Y)?(this.t.trace("Removing the extension from uninstalled list:",Y.id),await this.n.setInstalled(Y),this.t.info("Removed the extension from uninstalled list:",Y.id),(await this.n.scanAllUserExtensions(!0)).find(P=>i.ExtensionKey.create(P).equals(Y))):void 0}async x(Y){return!!(await this.n.getUninstalledExtensions())[Y.toString()]}}class U extends J{constructor(Y,ee,j,P,M,K,te,z,W,q){super(ee.identifier,ee,j,M,K,te,z,W,q),this.z=ee,this.A=P}async y(Y){const j=(await this.n.scanExtensions(null,this.m.profileLocation)).find(te=>(0,i.areSameExtensions)(te.identifier,this.z.identifier));j&&(this.l=3);const P={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||j?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||j?.isMachineScoped,isBuiltin:this.m.isBuiltin||j?.isBuiltin,isSystem:j?.type===0?!0:void 0,updated:!!j,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,p.isBoolean)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:j?.preRelease)};if(j?.manifest.version===this.z.version)return[await this.n.updateMetadata(j,P),P];const{location:M,verificationStatus:K}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=K,this.C(M.fsPath),[await this.v({zipPath:M.fsPath,key:i.ExtensionKey.create(this.z),metadata:P},Y),P]}catch(te){try{await this.A.delete(M)}catch(z){this.t.warn("Error while deleting the downloaded file",M.toString(),(0,k.getErrorMessage)(z))}throw te}}async C(Y){try{await(0,C.getManifest)(Y)}catch(ee){throw new s.ExtensionManagementError((0,n.joinErrors)(ee).message,s.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=U;class ne extends J{constructor(Y,ee,j,P,M,K,te,z,W,q){super({id:(0,i.getGalleryExtensionId)(Y.publisher,Y.name)},ee,j,M,K,te,z,W,q),this.z=Y,this.A=ee,this.B=P}async h(Y){const ee=await super.h(Y);return this.E(ee,Y),ee}async y(Y){const ee=new i.ExtensionKey(this.identifier,this.z.version),P=(await this.n.scanExtensions(1,this.m.profileLocation)).find(te=>(0,i.areSameExtensions)(this.identifier,te.identifier)),M={isApplicationScoped:this.m.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||P?.isMachineScoped,isBuiltin:this.m.isBuiltin||P?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(P)if(this.l=3,ee.equals(new i.ExtensionKey(P.identifier,P.manifest.version)))try{await this.n.removeExtension(P,"existing")}catch{throw new Error(D.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&g.gt(P.manifest.version,this.z.version)&&await this.n.setUninstalled(P);else{const te=await this.w(ee);if(te)try{await this.n.removeExtension(te,"existing")}catch{throw new Error(D.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:y.resolve(this.A.fsPath),key:ee,metadata:M},Y),M]}async E(Y,ee){try{let[j]=await this.B.getExtensions([{id:Y.identifier.id,version:Y.manifest.version}],ee);if(j||([j]=await this.B.getExtensions([{id:Y.identifier.id}],ee)),j){const P={id:j.identifier.uuid,publisherDisplayName:j.publisherDisplayName,publisherId:j.publisherId,isPreReleaseVersion:j.properties.isPreReleaseVersion,preRelease:j.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata(Y,P,this.m.profileLocation)}}catch{}}}class x extends n.AbstractExtensionTask{constructor(Y,ee,j){super(),this.extension=Y,this.j=ee,this.k=j}async h(Y){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(pe[70],be([1,0,85,74,28,285,15,11,6,2,7,3,22,42,104]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{traceSocketEvent(E,w){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,w)}constructor(E,w=""){this.f=!0,this.debugLabel=w,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=N=>{if(this.traceSocketEvent("error",{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,R.onUnexpectedError)(N)}},this.socket.on("error",this.a),this.b=N=>{this.traceSocketEvent("close",{hadError:N}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const w=N=>{this.traceSocketEvent("read",N),E(k.VSBuffer.wrap(N))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(E){const w=N=>{E({type:0,hadError:N,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(E){const w=()=>{E()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,R.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,R.onUnexpectedError)(w)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const N=()=>{this.socket.off("close",N),this.socket.off("end",N),this.socket.off("error",N),this.socket.off("timeout",N),this.socket.off("drain",N),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",N),this.socket.on("end",N),this.socket.on("error",N),this.socket.on("timeout",N),this.socket.on("drain",N)})}}e.NodeSocket=p;var r;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(r||(r={}));var f;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(f||(f={}));class c extends m.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,w){this.socket.traceSocketEvent(E,w)}constructor(E,w,N,$){super(),this.f=this.B(new b.Emitter),this.g=this.B(new b.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:N?.byteLength||0,recordInflateBytes:$}),this.a=this.B(new u(this,w,N,$,this.f,(se,he)=>this.k(se,he))),this.B(this.a.onError(se=>{console.error(se),(0,R.onUnexpectedError)(se),this.g.fire({type:0,hadError:!0,error:se})})),this.b=new g.ChunkStream,this.B(this.socket.onData(se=>this.l(se))),this.B(this.socket.onClose(async se=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(se)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let w=0;for(;w<E.byteLength;)this.a.writeMessage(E.slice(w,Math.min(w+262144,E.byteLength))),w+=262144}k(E,w){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let N=2;E.byteLength<126?N+=0:E.byteLength<2**16?N+=2:N+=8;const $=k.VSBuffer.alloc(N);if(w?$.writeUInt8(194,0):$.writeUInt8(130,0),E.byteLength<126)$.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){$.writeUInt8(126,1);let se=1;$.writeUInt8(E.byteLength>>>8&255,++se),$.writeUInt8(E.byteLength>>>0&255,++se)}else{$.writeUInt8(127,1);let se=1;$.writeUInt8(0,++se),$.writeUInt8(0,++se),$.writeUInt8(0,++se),$.writeUInt8(0,++se),$.writeUInt8(E.byteLength>>>24&255,++se),$.writeUInt8(E.byteLength>>>16&255,++se),$.writeUInt8(E.byteLength>>>8&255,++se),$.writeUInt8(E.byteLength>>>0&255,++se)}this.socket.write(k.VSBuffer.concat([$,E]))}end(){this.h=!0,this.socket.end()}l(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const w=this.b.peek(this.j.readLen),N=w.readUInt8(0),$=(N&128)>>>7,se=(N&64)>>>6,he=w.readUInt8(1),ae=(he&128)>>>7,ue=he&127;this.j.state=2,this.j.readLen=2+(ae?4:0)+(ue===126?2:0)+(ue===127?8:0),this.j.fin=$,this.j.firstFrameOfMessage&&(this.j.compressed=!!se),this.j.firstFrameOfMessage=!!$,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const w=this.b.read(this.j.readLen),N=w.readUInt8(1),$=(N&128)>>>7;let se=N&127,he=1;se===126?se=w.readUInt8(++he)*2**8+w.readUInt8(++he):se===127&&(se=w.readUInt8(++he)*0+w.readUInt8(++he)*0+w.readUInt8(++he)*0+w.readUInt8(++he)*0+w.readUInt8(++he)*2**24+w.readUInt8(++he)*2**16+w.readUInt8(++he)*2**8+w.readUInt8(++he));let ae=0;$&&(ae=w.readUInt8(++he)*2**24+w.readUInt8(++he)*2**16+w.readUInt8(++he)*2**8+w.readUInt8(++he)),this.j.state=3,this.j.readLen=se,this.j.mask=ae,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const w=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",w),t(w,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",w),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(w,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=c;class u extends m.Disposable{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:k.VSBuffer.alloc(0)}constructor(E,w,N,$,se,he){super(),this.l=E,this.m=se,this.n=he,this.a=this.B(new b.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new b.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,w?(this.b=this.B(new D(this.l,$,N,{windowBits:15})),this.f=this.B(new O(this.l,{windowBits:15})),this.B(this.b.onError(ae=>this.a.fire(ae))),this.B(this.f.onError(ae=>this.a.fire(ae)))):(this.b=null,this.f=null)}writeMessage(E){this.g.push(E),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const E=this.g.shift();if(this.f){const w=await this.s(this.f,E);this.n(w,!0)}else this.n(E,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(E,w){return new Promise((N,$)=>{E.write(w),E.flush(se=>N(se))})}acceptFrame(E,w,N){this.h.push({data:E,isCompressed:w,isLastFrameOfMessage:N}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const w=await this.w(this.b,E.data,E.isLastFrameOfMessage);this.m.fire(w)}else this.m.fire(E.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(E,w,N){return new Promise(($,se)=>{E.write(w),N&&E.write(k.VSBuffer.fromByteArray([0,0,255,255])),E.flush(he=>$(he))})}}class D extends m.Disposable{get recordedInflateBytes(){return this.j?k.VSBuffer.concat(this.f):k.VSBuffer.alloc(0)}constructor(E,w,N,$){super(),this.h=E,this.j=w,this.a=this.B(new b.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)($),this.b.on("error",se=>{this.h.traceSocketEvent("zlibInflateError",{message:se?.message,code:se?.code}),this.a.fire(se)}),this.b.on("data",se=>{this.h.traceSocketEvent("zlibInflateData",se),this.g.push(k.VSBuffer.wrap(se))}),N&&(this.h.traceSocketEvent("zlibInflateInitialWrite",N.buffer),this.b.write(N.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const w=k.VSBuffer.concat(this.g);this.g.length=0,E(w)})}}class O extends m.Disposable{constructor(E,w){super(),this.g=E,this.a=this.B(new b.Emitter),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",N=>{this.g.traceSocketEvent("zlibDeflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.g.traceSocketEvent("zlibDeflateData",N),this.f.push(k.VSBuffer.wrap(N))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let w=k.VSBuffer.concat(this.f);this.f.length=0,w=w.slice(0,w.byteLength-4),E(w)})}}function t(C,E){if(E===0)return;const w=C.byteLength>>>2;for(let ue=0;ue<w;ue++){const ge=C.readUInt32BE(ue*4);C.writeUInt32BE(ge^E,ue*4)}const N=w*4,$=C.byteLength-N,se=E>>>24&255,he=E>>>16&255,ae=E>>>8&255;$>=1&&C.writeUInt8(C.readUInt8(N)^se,N),$>=2&&C.writeUInt8(C.readUInt8(N+1)^he,N+1),$>=3&&C.writeUInt8(C.readUInt8(N+2)^ae,N+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const n={[2]:107,[1]:103};function s(){const C=(0,v.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const E=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,o.tmpdir)(),w=(0,T.join)(E,`vscode-ipc-${C}.sock`);return a(w),w}e.createRandomIPCHandle=s;function i(C,E,w){const N=(0,S.createHash)("md5").update(C).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${w}-${E}-sock`;const $=w.substr(0,4),se=E.substr(0,6),he=N.substr(0,8);let ae;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?ae=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${he}-${$}-${se}.sock`):ae=(0,T.join)(C,`${$}-${se}.sock`),a(ae),ae}e.createStaticIPCHandle=i;function a(C){const E=n[y.platform];typeof E=="number"&&C.length>=E&&console.warn(`WARNING: IPC handle "${C}" is longer than ${E} chars, try a shorter --user-data-dir`)}class l extends h.IPCServer{static b(E){const w=b.Event.fromNodeEventEmitter(E,"connection");return b.Event.map(w,N=>({protocol:new g.Protocol(new p(N,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(N,"close"))}))}constructor(E){super(l.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=l;function d(C){return new Promise((E,w)=>{const N=(0,L.createServer)();N.on("error",w),N.listen(C,()=>{N.removeListener("error",w),E(new l(N))})})}e.serve=d;function I(C,E){return new Promise((w,N)=>{const $=(0,L.createConnection)(C,()=>{$.removeListener("error",N),w(g.Client.fromSocket(new p($,`ipc-client${E}`),E))});$.once("error",N)})}e.connect=I}),define(pe[138],be([1,0,83,14,15,11,8,24,25,84,12,43,234,285]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let g=e.RequestService=class extends y.AbstractRequestService{constructor(c,u,D,O){super(O),this.j=c,this.k=u,this.l=D,this.m(),this.B(c.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const c=this.j.getValue("http");this.f=c?.proxy,this.g=!!c?.proxyStrictSSL,this.h=c?.proxyAuthorization}async request(c,u){const{f:D,g:O}=this;let t;try{t=await(0,m.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(i){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,A.getErrorMessage)(i)))}const n={...process.env,...t},s=c.agent?c.agent:await(0,v.getProxyAgent)(c.url||"",n,{proxyUrl:D,strictSSL:O});return c.agent=s,c.strictSSL=O,this.h&&(c.headers={...c.headers||{},"Proxy-Authorization":this.h}),this.c(c.isChromiumNetwork?"electron":"node",c,()=>r(c,u))}async resolveProxy(c){}};e.RequestService=g=Le([Ae(0,R.IConfigurationService),Ae(1,b.INativeEnvironmentService),Ae(2,T.ILogService),Ae(3,T.ILoggerService)],g);async function p(f){return((0,S.parse)(f.url).protocol==="https:"?await new Promise((D,O)=>{le(["https"],D,O)}):await new Promise((D,O)=>{le(["http"],D,O)})).request}async function r(f,c){return L.Promises.withAsyncBody(async(u,D)=>{const O=(0,S.parse)(f.url),t=f.getRawRequest?f.getRawRequest(f):await p(f),n={hostname:O.hostname,port:O.port?parseInt(O.port):O.protocol==="https:"?443:80,protocol:O.protocol,path:O.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,k.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(n.auth=f.user+":"+f.password);const s=t(n,i=>{const a=(0,k.isNumber)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&a>0&&i.headers.location)r({...f,url:i.headers.location,followRedirects:a-1},c).then(u,D);else{let l=i;!f.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(l=i.pipe((0,h.createGunzip)())),u({res:i,stream:(0,o.streamToBufferReadableStream)(l)})}});s.on("error",D),f.timeout&&s.setTimeout(f.timeout),f.isChromiumNetwork&&s.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&s.write(f.data),s.end(),c.onCancellationRequested(()=>{s.abort(),D(new A.CancellationError)})})}e.nodeRequest=r}),define(pe[139],be([1,0,52,74,127,13,7,15,6,70,84,12,45,3,59,126,2,273,24]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function u(i={},a,l,d,I,C){const E=await(0,o.getNLSConfiguration)(l,d.userDataPath);let w={};if(a)try{w=await(0,T.getResolvedShellEnv)(C,I,d.args,process.env)}catch(ue){I.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ue)}const $={...process.env,...w,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(E,void 0,0),...i},se=d.isBuilt?(0,k.join)(d.appRoot,"bin"):(0,k.join)(d.appRoot,"resources","server","bin-dev"),he=(0,k.join)(se,"remote-cli");let ae=t($,"PATH");return ae?ae=he+k.delimiter+ae:ae=he,n($,"PATH",ae),d.args["without-browser-env-var"]||($.BROWSER=(0,k.join)(se,"helpers",h.isWindows?"browser.cmd":"browser.sh")),s($),$}e.buildUserEnvironment=u;class D{constructor(a,l){this.socket=a,this.initialDataChunk=l}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let a,l,d;return this.socket instanceof m.NodeSocket?(a=!0,l=!1,d=R.VSBuffer.alloc(0)):(a=!1,l=this.socket.permessageDeflate,d=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:a,permessageDeflate:l,inflateBytes:d.buffer.toString("base64")}}}let O=e.ExtensionHostConnection=class{constructor(a,l,d,I,C,E,w,N){this.i=a,this.j=C,this.l=E,this.m=w,this.n=N,this.b=new b.Emitter,this.onClose=this.b.event,this.c=!h.isWindows||!this.j.args["socket-path"],this.d=!1,this.f=l,this.g=null,this.h=new D(d,I),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(a){this.l.info(`${this.o}${a}`)}q(a){this.l.error(`${this.o}${a}`)}async r(a,l){const d=new r.DisposableStore;d.add(l.socket),d.add((0,r.toDisposable)(()=>{a.destroy()}));const I=()=>{d.dispose()};d.add(l.socket.onEnd(I)),d.add(l.socket.onClose(I)),d.add(b.Event.fromNodeEventEmitter(a,"end")(I)),d.add(b.Event.fromNodeEventEmitter(a,"close")(I)),d.add(b.Event.fromNodeEventEmitter(a,"error")(I)),d.add(l.socket.onData(C=>a.write(C.buffer))),d.add(b.Event.fromNodeEventEmitter(a,"data")(C=>{l.socket.write(R.VSBuffer.wrap(C))})),l.initialDataChunk.byteLength>0&&a.write(l.initialDataChunk.buffer)}async s(a,l){await l.socketDrain();const d=l.toIExtHostSocketMessage();let I;l.socket instanceof m.NodeSocket?I=l.socket.socket:I=l.socket.socket.socket,a.send(d,I)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const a={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(a)}acceptReconnection(a,l,d){this.f=a,this.p("The client has reconnected.");const I=new D(l,d);if(!this.g){this.h=I;return}this.s(this.g,I)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(a){try{let l=process.execArgv?process.execArgv.filter(he=>!/^--inspect(-brk)?=/.test(he)):[];a.port&&!process.pkg&&(l=[`--inspect${a.break?"-brk":""}=${a.port}`]);const d=await u(a.env,!0,a.language,this.j,this.l,this.n);(0,g.removeDangerousEnvVariables)(d);let I;if(this.c)(0,f.writeExtHostConnection)(new f.SocketExtHostConnection,d),I=null;else{const{namedPipeServer:he,pipeName:ae}=await this.u();(0,f.writeExtHostConnection)(new f.IPCExtHostConnection(ae),d),I=he}const C={env:d,execArgv:l,silent:!0},E=["--type=extensionHost","--transformURIs"],w=this.j.args["use-host-proxy"];E.push(`--useHostProxy=${w?"true":"false"}`),this.g=S.fork(A.FileAccess.asFileUri("bootstrap-fork").fsPath,E,C);const N=this.g.pid;this.p(`<${N}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const $=b.Event.fromNodeEventEmitter(this.g.stdout,"data"),se=b.Event.fromNodeEventEmitter(this.g.stderr,"data");if($(he=>this.p(`<${N}> ${he}`)),se(he=>this.p(`<${N}><stderr> ${he}`)),this.g.on("error",he=>{this.q(`<${N}> Extension Host Process had an error`),this.l.error(he),this.t()}),this.g.on("exit",(he,ae)=>{this.m.setExitInfo(this.i,{code:he,signal:ae}),this.p(`<${N}> Extension Host Process exited with code: ${he}, signal: ${ae}.`),this.t()}),I)I.on("connection",he=>{I.close(),this.r(he,this.h)});else{const he=ae=>{ae.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",he),this.s(this.g,this.h),this.h=null)};this.g.on("message",he)}}catch(l){console.error("ExtensionHostConnection errored"),l&&console.error(l)}}u(){return new Promise((a,l)=>{const d=(0,m.createRandomIPCHandle)(),I=L.createServer();I.on("error",l),I.listen(d,()=>{I?.removeListener("error",l),a({pipeName:d,namedPipeServer:I})})})}};e.ExtensionHostConnection=O=Le([Ae(4,v.IServerEnvironmentService),Ae(5,y.ILogService),Ae(6,p.IExtensionHostStatusService),Ae(7,c.IConfigurationService)],O);function t(i,a){const l=Object.keys(i).filter(I=>I.toLowerCase()===a.toLowerCase()),d=l.length>0?l[0]:a;return i[d]}function n(i,a,l){const d=Object.keys(i).filter(C=>C.toLowerCase()===a.toLowerCase()),I=d.length>0?d[0]:a;i[I]=l}function s(i){for(const a of Object.keys(i))i[a]===null&&delete i[a]}}),define(pe[286],be([1,0,81,12,63,114,24,43,138,37,31,30,124,137,80,108,54,2,109,66,13,16,26,45,117,82,118,11,4,7,29,232,79,36,122,62,3,57,128,32,44,67,125,123,111,112,194,287]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f,c,u,D,O,t,n,s,i,a,l,d,I,C,E,w,N,$,se,he,ae,ue,ge,_,ie,V,J,U,ne,x,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class Y extends f.Disposable{constructor(M,K){super(),this.a=M,this.b=K,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const M=await this.f();await M.invokeFunction(async K=>{const te=K.get(k.IConfigurationService),z=K.get(L.ILogService);he.isWindows&&(te.getValue("security.restrictUNCAccess")===!1?(0,re.disableUNCAccessRestrictions)():(0,re.addUNCHostToAllowlist)(te.getValue("security.allowedUNCHosts")));try{await this.g(M.createInstance(s.ExtensionManagementCLI,new L.ConsoleLogger(z.getLevel(),!1)))}catch(W){throw z.error(W),console.error((0,l.getErrorMessage)(W)),W}})}async f(){const M=new S.ServiceCollection,K={_serviceBrand:void 0,...r.default};M.set(t.IProductService,K);const te=new n.ServerEnvironmentService(this.a,K);M.set(n.IServerEnvironmentService,te);const z=new ne.LoggerService((0,L.getLogLevel)(te),te.logsHome);M.set(L.ILoggerService,z);const W=new U.LogService(this.B(z.createLogger("remoteCLI",{name:(0,x.localize)(0,null)})));M.set(L.ILogService,W),W.trace(`Remote configuration data at ${this.b}`),W.trace("process arguments:",this.a);const q=this.B(new c.FileService(W));M.set(O.IFileService,q),q.registerProvider(D.Schemas.file,this.B(new u.DiskFileSystemProvider(W)));const H=new $.UriIdentityService(q);M.set(N.IUriIdentityService,H);const Q=this.B(new V.ServerUserDataProfilesService(H,te,q,W));M.set(ge.IUserDataProfilesService,Q);const G=this.B(new A.ConfigurationService(Q.defaultProfile.settingsResource,q,new ie.NullPolicyService,W));return M.set(k.IConfigurationService,G),await Promise.all([G.initialize(),Q.init()]),M.set(R.IRequestService,new o.SyncDescriptor(b.RequestService)),M.set(w.IDownloadService,new o.SyncDescriptor(E.DownloadService)),M.set(T.ITelemetryService,m.NullTelemetryService),M.set(y.IExtensionGalleryService,new o.SyncDescriptor(v.ExtensionGalleryServiceWithNoStorageService)),M.set(_.IExtensionsProfileScannerService,new o.SyncDescriptor(J.ExtensionsProfileScannerService)),M.set(ae.IExtensionsScannerService,new o.SyncDescriptor(ue.ExtensionsScannerService)),M.set(g.IExtensionSignatureVerificationService,new o.SyncDescriptor(g.ExtensionSignatureVerificationService)),M.set(h.INativeServerExtensionManagementService,new o.SyncDescriptor(h.ExtensionManagementService)),M.set(i.ILanguagePackService,new o.SyncDescriptor(a.NativeLanguagePackService)),new p.InstantiationService(M)}async g(M){if(this.a["list-extensions"])return M.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const K={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return M.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),K,!!this.a.force)}else{if(this.a["uninstall-extension"])return M.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return M.locateExtension(this.a["locate-extension"])}}h(M){return M.map(K=>/\.vsix$/i.test(K)?d.URI.file((0,I.isAbsolute)(K)?K:(0,I.join)((0,C.cwd)(),K)):K)}}function ee(P){setTimeout(()=>process.exit(P),0)}async function j(P,M,K){if(P.help){const z=r.default.serverApplicationName+(he.isWindows?".cmd":"");console.log((0,se.buildHelpMessage)(r.default.nameLong,z,r.default.version,K,{noInputFiles:!0,noPipe:!0}));return}if(P.version){console.log((0,se.buildVersionMessage)(r.default.version,r.default.commit));return}const te=new Y(P,M);try{await te.run(),ee(0)}catch{ee(1)}finally{te.dispose()}}e.run=j}),define(pe[288],be([1,0,70,300,33,281,4,12,87]),function(le,e,S,L,o,A,k,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class m{constructor(v,h,g){this.b=v,this.c=h,this.f=g,this.a=L.createServer((p,r)=>this.h(p,r)),this.g().catch(p=>(h.error(p),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,h){const g=(r,f)=>{h.writeHead(r,{"content-type":"application/json"}),h.end(JSON.stringify(f||null),c=>c&&this.c.error(c))},p=[];v.setEncoding("utf8"),v.on("data",r=>p.push(r)),v.on("end",async()=>{try{const r=JSON.parse(p.join(""));let f;switch(r.type){case"open":f=await this.i(r);break;case"openExternal":f=await this.j(r);break;case"status":f=await this.l(r);break;case"extensionManagement":f=await this.k(r);break;default:g(404,`Unknown message type: ${r.type}`);break}g(200,f)}catch(r){const f=r instanceof Error?r.message:JSON.stringify(r);g(500,f),this.c.error("Error while processing pipe request",r)}})}async i(v){const{fileURIs:h,folderURIs:g,forceNewWindow:p,diffMode:r,mergeMode:f,addMode:c,forceReuseWindow:u,gotoLineMode:D,waitMarkerFilePath:O,remoteAuthority:t}=v,n=[];if(Array.isArray(g))for(const l of g)try{n.push({folderUri:k.URI.parse(l)})}catch{}if(Array.isArray(h))for(const l of h)try{(0,b.hasWorkspaceFileExtension)(l)?n.push({workspaceUri:k.URI.parse(l)}):n.push({fileUri:k.URI.parse(l)})}catch{}const s=O?k.URI.file(O):void 0,a={forceNewWindow:p,diffMode:r,mergeMode:f,addMode:c,gotoLineMode:D,forceReuseWindow:u,preferNewWindow:!u&&!s&&!c,waitMarkerFileURI:s,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",n,a),""}async j(v){for(const h of v.uris){const g=k.URI.parse(h),p=g.scheme==="file"?g:h;await this.b.executeCommand("_remoteCLI.openExternal",p)}}async k(v){const h=p=>p?.map(r=>/\.vsix$/i.test(r)?k.URI.parse(r):r),g={list:v.list,install:h(v.install),uninstall:h(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",g)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&o.existsSync(this.f)&&o.unlinkSync(this.f)}}e.CLIServerBase=m;let T=e.CLIServer=class extends m{constructor(v,h){super(v,h,(0,S.createRandomIPCHandle)())}};e.CLIServer=T=Le([Ae(0,A.IExtHostCommands),Ae(1,R.ILogService)],T)}),define(pe[289],be([1,0,28,6,21,2,7,3,4,70,68,288,120,86,268,270,139,8]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class c extends p.AbstractVariableResolverService{constructor(O,t,n,s,i){super({getFolderUri:a=>{const l=t.filter(d=>d.name===a);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.length,getConfigurationValue:(a,l)=>s[`config:${l}`],getExecPath:()=>O.VSCODE_EXEC_PATH,getAppRoot:()=>O.VSCODE_CWD,getFilePath:()=>{if(n)return k.normalize(n.fsPath)},getSelectedText:()=>s.selectedText,getLineNumber:()=>s.lineNumber,getExtension:async a=>{const d=(await i.getInstalled()).find(I=>I.identifier.id===a);return d&&{extensionLocation:d.location}}},void 0,Promise.resolve(S.homedir()),Promise.resolve(O))}}class u extends A.Disposable{constructor(O,t,n,s,i,a){super(),this.g=O,this.h=t,this.i=n,this.j=s,this.l=i,this.m=a,this.a=0,this.b=new Map,this.c=this.B(new L.Emitter),this.onExecuteCommand=this.c.event}async call(O,t,n){switch(t){case"$restartPtyHost":return this.i.restartPtyHost?.apply(this.i,n);case"$createProcess":{const s=(0,T.createURITransformer)(O.remoteAuthority);return this.n(s,n)}case"$attachToProcess":return this.i.attachToProcess.apply(this.i,n);case"$detachFromProcess":return this.i.detachFromProcess.apply(this.i,n);case"$listProcesses":return this.i.listProcesses.apply(this.i,n);case"$orphanQuestionReply":return this.i.orphanQuestionReply.apply(this.i,n);case"$acceptPtyHostResolvedVariables":return this.i.acceptPtyHostResolvedVariables?.apply(this.i,n);case"$start":return this.i.start.apply(this.i,n);case"$input":return this.i.input.apply(this.i,n);case"$acknowledgeDataEvent":return this.i.acknowledgeDataEvent.apply(this.i,n);case"$shutdown":return this.i.shutdown.apply(this.i,n);case"$resize":return this.i.resize.apply(this.i,n);case"$getInitialCwd":return this.i.getInitialCwd.apply(this.i,n);case"$getCwd":return this.i.getCwd.apply(this.i,n);case"$processBinary":return this.i.processBinary.apply(this.i,n);case"$sendCommandResult":return this.r(n[0],n[1],n[2]);case"$installAutoReply":return this.i.installAutoReply.apply(this.i,n);case"$uninstallAllAutoReplies":return this.i.uninstallAllAutoReplies.apply(this.i,n);case"$getDefaultSystemShell":return this.s.apply(this,n);case"$getProfiles":return this.t.apply(this,n);case"$getEnvironment":return this.u();case"$getWslPath":return this.w(n[0],n[1]);case"$getTerminalLayoutInfo":return this.i.getTerminalLayoutInfo(n);case"$setTerminalLayoutInfo":return this.i.setTerminalLayoutInfo(n);case"$serializeTerminalState":return this.i.serializeTerminalState.apply(this.i,n);case"$reviveTerminalProcesses":return this.i.reviveTerminalProcesses.apply(this.i,n);case"$getRevivedPtyNewId":return this.i.getRevivedPtyNewId.apply(this.i,n);case"$setUnicodeVersion":return this.i.setUnicodeVersion.apply(this.i,n);case"$reduceConnectionGraceTime":return this.y();case"$updateIcon":return this.i.updateIcon.apply(this.i,n);case"$updateTitle":return this.i.updateTitle.apply(this.i,n);case"$updateProperty":return this.i.updateProperty.apply(this.i,n);case"$refreshProperty":return this.i.refreshProperty.apply(this.i,n);case"$requestDetachInstance":return this.i.requestDetachInstance(n[0],n[1]);case"$acceptDetachedInstance":return this.i.acceptDetachInstanceReply(n[0],n[1]);case"$freePortKillProcess":return this.i.freePortKillProcess?.apply(this.i,n)}throw new Error(`IPC Command ${t} not found`)}listen(O,t,n){switch(t){case"$onPtyHostExitEvent":return this.i.onPtyHostExit||L.Event.None;case"$onPtyHostStartEvent":return this.i.onPtyHostStart||L.Event.None;case"$onPtyHostUnresponsiveEvent":return this.i.onPtyHostUnresponsive||L.Event.None;case"$onPtyHostResponsiveEvent":return this.i.onPtyHostResponsive||L.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.i.onPtyHostRequestResolveVariables||L.Event.None;case"$onProcessDataEvent":return this.i.onProcessData;case"$onProcessReadyEvent":return this.i.onProcessReady;case"$onProcessExitEvent":return this.i.onProcessExit;case"$onProcessReplayEvent":return this.i.onProcessReplay;case"$onProcessOrphanQuestion":return this.i.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.i.onDidRequestDetach||L.Event.None;case"$onDidChangeProperty":return this.i.onDidChangeProperty;default:break}throw new Error("Not supported")}async n(O,t){const n={name:t.shellLaunchConfig.name,executable:t.shellLaunchConfig.executable,args:t.shellLaunchConfig.args,cwd:typeof t.shellLaunchConfig.cwd=="string"||typeof t.shellLaunchConfig.cwd>"u"?t.shellLaunchConfig.cwd:b.URI.revive(O.transformIncoming(t.shellLaunchConfig.cwd)),env:t.shellLaunchConfig.env,useShellEnvironment:t.shellLaunchConfig.useShellEnvironment,reconnectionProperties:t.shellLaunchConfig.reconnectionProperties,type:t.shellLaunchConfig.type,isFeatureTerminal:t.shellLaunchConfig.isFeatureTerminal},s=await(0,r.buildUserEnvironment)(t.resolverEnv,!!t.shellLaunchConfig.useShellEnvironment,R.language,this.g,this.h,this.m);this.h.trace("baseEnv",s);const i=ge=>({uri:b.URI.revive(O.transformIncoming(ge.uri)),name:ge.name,index:ge.index,toResource:()=>{throw new Error("Not implemented")}}),a=t.workspaceFolders.map(i),l=t.activeWorkspaceFolder?i(t.activeWorkspaceFolder):void 0,d=t.activeFileResource?b.URI.revive(O.transformIncoming(t.activeFileResource)):void 0,I=new c(s,a,d,t.resolvedVariables,this.l),C=g.createVariableResolver(l,process.env,I),E=await g.getCwd(n,S.homedir(),C,l?.uri,t.configuration["terminal.integrated.cwd"],this.h);n.cwd=E;const w=R.isWindows?"terminal.integrated.env.windows":R.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",N=t.configuration[w],$=await g.createTerminalEnvironment(n,N,C,this.j.version,t.configuration["terminal.integrated.detectLocale"],s);if(!n.strictEnv){const ge=[];for(const[J,U,ne]of t.envVariableCollections)ge.push([J,{map:(0,h.deserializeEnvironmentVariableCollection)(U),descriptionMap:(0,h.deserializeEnvironmentDescriptionMap)(ne)}]);const _=new Map(ge),ie=new v.MergedEnvironmentVariableCollection(_),V=l?(0,f.withNullAsUndefined)(l):void 0;await ie.applyToProcessEnvironment($,{workspaceFolder:V},C)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:n,initialCwd:E,cols:t.cols,rows:t.rows,env:$});const se=(0,m.createRandomIPCHandle)();$.VSCODE_IPC_HOOK_CLI=se;const he=await this.i.createProcess(n,E,t.cols,t.rows,t.unicodeVersion,$,s,t.options,t.shouldPersistTerminal,t.workspaceId,t.workspaceName),ae={executeCommand:(ge,..._)=>this.p(he,ge,_,O)},ue=new y.CLIServerBase(ae,this.h,se);return this.i.onProcessExit(ge=>ge.id===he&&ue.dispose()),{persistentTerminalId:he,resolvedShellLaunchConfig:n}}p(O,t,n,s){let i,a;const l=new Promise((C,E)=>{i=C,a=E}),d=++this.a;this.b.set(d,{resolve:i,reject:a,uriTransformer:s});const I=(0,o.cloneAndChange)(n,C=>{if(C&&C.$mid===1)return s.transformOutgoing(C);if(C&&C instanceof b.URI)return s.transformOutgoingURI(C)});return this.c.fire({reqId:d,persistentProcessId:O,commandId:t,commandArgs:I}),l}r(O,t,n){const s=this.b.get(O);if(!s)return;this.b.delete(O);const i=(0,o.cloneAndChange)(n,a=>{if(a&&a.$mid===1)return s.uriTransformer.transformIncoming(a)});t?s.reject(i):s.resolve(i)}s(O){return this.i.getDefaultSystemShell(O)}async t(O,t,n,s){return this.i.getProfiles?.(O,t,n,s)||[]}u(){return{...process.env}}w(O,t){return this.i.getWslPath(O,t)}y(){return this.i.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=u}),define(pe[290],be([1,0,28,6,2,13,7,100,23,42,24,114,78,226,202,79,203,212,221,25,124,30,80,117,213,137,16,109,66,63,108,81,82,118,12,54,26,43,233,138,116,31,37,246,121,254,36,122,265,266,238,244,289,68,45,272,282,126,57,128,44,32,67,245,112,125,123,111,110,196,279,229,258,251]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f,c,u,D,O,t,n,s,i,a,l,d,I,C,E,w,N,$,se,he,ae,ue,ge,_,ie,V,J,U,ne,x,re,Y,ee,j,P,M,K,te,z,W,q,H,Q,G,Z,ce,Ee,De,ke,Fe,ze,me,Se,we,Ue,Be,et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const He="monacoworkbench";async function Ve(Re,Oe,$e,Ge){const qe=new E.ServiceCollection,tt=new Ke,Je={_serviceBrand:void 0,...se.default};qe.set(he.IProductService,Je);const Ye=new te.ServerEnvironmentService(Oe,Je);qe.set(u.IEnvironmentService,Ye),qe.set(u.INativeEnvironmentService,Ye);const at=new De.LoggerService((0,$.getLogLevel)(Ye),Ye.logsHome);qe.set($.ILoggerService,at),tt.registerChannel("logger",new me.LoggerChannel(at,ot=>it(ot.remoteAuthority)));const gt=at.createLogger("remoteagent",{name:(0,Se.localize)(0,null)}),st=new ze.LogService(gt,[new Xe((0,$.getLogLevel)(Ye))]);qe.set($.ILogService,st),setTimeout(()=>Te(Ye.logsHome.fsPath).then(null,ot=>st.error(ot)),1e4),st.onDidChangeLogLevel(ot=>(0,$.log)(st,ot,`Log level changed to ${(0,$.LogLevelToString)(st.getLevel())}`)),st.trace(`Remote configuration data at ${$e}`),st.trace("process arguments:",Ye.args),Array.isArray(Je.serverGreeting)&&st.info(`

${Je.serverGreeting.join(`
`)}

`),tt.registerChannel(g.ExtensionHostDebugBroadcastChannel.ChannelName,new g.ExtensionHostDebugBroadcastChannel);const Nt=new m.StaticRouter(ot=>ot.clientId==="renderer"),Et=Ge.add(new l.FileService(st));qe.set(a.IFileService,Et),Et.registerProvider(A.Schemas.file,Ge.add(new d.DiskFileSystemProvider(st)));const Ct=new re.UriIdentityService(Et);qe.set(x.IUriIdentityService,Ct);const dt=new y.ConfigurationService(Ye.machineSettingsResource,Et,new ce.NullPolicyService,st);qe.set(T.IConfigurationService,dt);const pt=new ke.ServerUserDataProfilesService(Ct,Ye,Et,st);qe.set(Z.IUserDataProfilesService,pt),tt.registerChannel("userDataProfiles",new Be.RemoteUserDataProfilesServiceChannel(pt,ot=>it(ot.remoteAuthority)));const[,,At]=await Promise.all([dt.initialize(),pt.init(),(0,R.getMachineId)(st.error.bind(st))]),Ft=new q.ExtensionHostStatusService;qe.set(q.IExtensionHostStatusService,Ft),qe.set(ae.IRequestService,new I.SyncDescriptor(ge.RequestService));let St=V.NullAppender;const Rt=(0,V.isInternalTelemetry)(Je,dt);if((0,V.supportsTelemetry)(Je,Ye)){Je.aiConfig&&Je.aiConfig.ariaKey&&(St=new Ee.OneDataSystemAppender(Rt,He,null,Je.aiConfig.ariaKey),Ge.add((0,o.toDisposable)(()=>St?.flush())));const ot={appenders:[St],commonProperties:(0,_.resolveCommonProperties)((0,S.release)(),(0,S.hostname)(),process.arch,Je.commit,Je.version+"-remote",At,Rt,"remoteAgent"),piiPaths:(0,V.getPiiPathsFromEnvironment)(Ye)},ye=Ye.args["telemetry-level"];let Ie=3;ye==="all"?Ie=3:ye==="error"?Ie=2:ye==="crash"?Ie=1:ye!==void 0&&(Ie=0),qe.set(P.IServerTelemetryService,new I.SyncDescriptor(P.ServerTelemetryService,[ot,Ie]))}else qe.set(P.IServerTelemetryService,P.ServerNullTelemetryService);qe.set(O.IExtensionGalleryService,new I.SyncDescriptor(D.ExtensionGalleryServiceWithNoStorageService));const Mt=tt.getChannel("download",Nt);qe.set(p.IDownloadService,new r.DownloadServiceChannelClient(Mt,()=>it("renderer"))),qe.set(G.IExtensionsProfileScannerService,new I.SyncDescriptor(Fe.ExtensionsProfileScannerService)),qe.set(H.IExtensionsScannerService,new I.SyncDescriptor(Q.ExtensionsScannerService)),qe.set(t.IExtensionSignatureVerificationService,new I.SyncDescriptor(t.ExtensionSignatureVerificationService)),qe.set(i.INativeServerExtensionManagementService,new I.SyncDescriptor(i.ExtensionManagementService));const ht=new C.InstantiationService(qe);qe.set(w.ILanguagePackService,ht.createInstance(N.NativeLanguagePackService));const Ut=ht.createInstance(et.NodePtyHostStarter,{graceTime:108e5,shortGraceTime:3e5,scrollback:dt.getValue("terminal.integrated.persistentSessionScrollback")??100}),Dt=ht.createInstance(ne.PtyHostService,Ut);return qe.set(U.IPtyService,Dt),qe.set(f.IEncryptionMainService,new I.SyncDescriptor(c.EncryptionMainService,[At])),qe.set(v.ICredentialsMainService,new I.SyncDescriptor(h.CredentialsWebMainService)),ht.invokeFunction(ot=>{const ye=ot.get(i.INativeServerExtensionManagementService),Ie=ot.get(H.IExtensionsScannerService),de=ot.get(O.IExtensionGalleryService),X=ot.get(w.ILanguagePackService),Pe=new Y.RemoteAgentEnvironmentChannel(Re,Ye,pt,Ft);tt.registerChannel("remoteextensionsenvironment",Pe);const Ne=new j.ServerTelemetryChannel(ot.get(P.IServerTelemetryService),St);tt.registerChannel("telemetry",Ne),tt.registerChannel(z.REMOTE_TERMINAL_CHANNEL_NAME,new M.RemoteTerminalChannel(Ye,st,Dt,Je,ye,dt));const We=new we.RemoteExtensionsScannerService(ht.createInstance(n.ExtensionManagementCLI,st),Ye,pt,Ie,st,de,X);tt.registerChannel(Ue.RemoteExtensionsScannerChannelName,new we.RemoteExtensionsScannerChannel(We,ft=>it(ft.remoteAuthority)));const je=new ee.RemoteAgentFileSystemProviderChannel(st,Ye);tt.registerChannel(W.REMOTE_FILE_SYSTEM_CHANNEL_NAME,je),tt.registerChannel("request",new ue.RequestChannel(ot.get(ae.IRequestService)));const Qe=new s.ExtensionManagementChannel(ye,ft=>it(ft.remoteAuthority));tt.registerChannel("extensions",Qe);const lt=m.ProxyChannel.fromService(ot.get(f.IEncryptionMainService));tt.registerChannel("encryption",lt);const vt=m.ProxyChannel.fromService(ot.get(v.ICredentialsMainService));return tt.registerChannel("credentials",vt),We.whenExtensionsReady().then(()=>ye.cleanUp()),Ge.add(new J.default(ot.get(ie.ITelemetryService))),{telemetryService:ot.get(ie.ITelemetryService)}}),{socketServer:tt,instantiationService:ht}}e.setupServerServices=Ve;const Ze=Object.create(null);function it(Re){return Ze[Re]||(Ze[Re]=(0,K.createURITransformer)(Re)),Ze[Re]}class Ke extends m.IPCServer{constructor(){const Oe=new L.Emitter;super(Oe.event),this.b=Oe}acceptConnection(Oe,$e){this.b.fire({protocol:Oe,onDidClientDisconnect:$e})}}e.SocketServer=Ke;class Xe extends $.AbstractLogger{constructor(Oe=$.DEFAULT_LOG_LEVEL){super(),this.setLevel(Oe),this.g=!!process.stdout.isTTY}trace(Oe,...$e){this.f($.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${fe()}]\x1B[0m`,Oe,...$e):console.log(`[${fe()}]`,Oe,...$e))}debug(Oe,...$e){this.f($.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${fe()}]\x1B[0m`,Oe,...$e):console.log(`[${fe()}]`,Oe,...$e))}info(Oe,...$e){this.f($.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${fe()}]\x1B[0m`,Oe,...$e):console.log(`[${fe()}]`,Oe,...$e))}warn(Oe,...$e){this.f($.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${fe()}]\x1B[0m`,Oe,...$e):console.warn(`[${fe()}]`,Oe,...$e))}error(Oe,...$e){this.f($.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${fe()}]\x1B[0m`,Oe,...$e):console.error(`[${fe()}]`,Oe,...$e))}dispose(){}flush(){}}function fe(){const Re=new Date;return`${Ce(Re.getHours())}:${Ce(Re.getMinutes())}:${Ce(Re.getSeconds())}`}function Ce(Re){return Re<10?`0${Re}`:String(Re)}async function Te(Re){const Oe=k.basename(Re),$e=k.dirname(Re),tt=(await b.Promises.readdir($e)).filter(Ye=>/^\d{8}T\d{6}$/.test(Ye)).sort().filter(Ye=>Ye!==Oe),Je=tt.slice(0,Math.max(0,tt.length-9));await Promise.all(Je.map(Ye=>b.Promises.rm(k.join($e,Ye))))}}),define(pe[291],be([1,0,85,33,74,292,83,140,15,11,39,2,13,7,41,3,17,4,22,148,287,104,70,24,5,12,26,56,31,139,259,260,45,290,262]),function(le,e,S,L,o,A,k,R,b,m,T,y,v,h,g,p,r,f,c,u,D,O,t,n,s,i,a,l,d,I,C,E,w,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=void 0;const se=5*60*1e3;let he=class extends y.Disposable{constructor(_,ie,V,J,U,ne,x,re){super(),this.k=_,this.l=ie,this.m=V,this.n=U,this.p=ne,this.r=x,this.s=re,this.h=ue.create(this.p),this.i=(0,l.getRemoteServerRootPath)(ne),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=J?this.s.createInstance($.WebClientServer,this.l):null,this.r.info("Extension host agent started."),this.F(!0)}async handleRequest(_,ie){if(_.method!=="GET")return(0,$.serveError)(_,ie,405,`Unsupported method ${_.method}`);if(!_.url)return(0,$.serveError)(_,ie,400,"Bad request.");const V=k.parse(_.url,!0);let J=V.pathname;if(!J)return(0,$.serveError)(_,ie,400,"Bad request.");if(J.startsWith(this.i)&&J.charCodeAt(this.i.length)===47&&(J=J.substring(this.i.length)),J==="/version")return ie.writeHead(200,{"Content-Type":"text/plain"}),void ie.end(this.p.commit||"");if(J==="/delay-shutdown")return this.H(),ie.writeHead(200),void ie.end("OK");if(!(0,E.requestHasValidConnectionToken)(this.l,_,V))return(0,$.serveError)(_,ie,403,"Forbidden.");if(J==="/vscode-remote-resource"){const U=V.query.path;if(typeof U!="string")return(0,$.serveError)(_,ie,400,"Bad request.");let ne;try{ne=f.URI.from({scheme:v.Schemas.file,path:U}).fsPath}catch{return(0,$.serveError)(_,ie,400,"Bad request.")}const x=Object.create(null);this.n.isBuilt&&((0,T.isEqualOrParent)(ne,this.n.builtinExtensionsPath,!p.isLinux)||(0,T.isEqualOrParent)(ne,this.n.extensionsPath,!p.isLinux))&&(x["Cache-Control"]="public, max-age=31536000"),x.Vary="Origin";const re=_.headers.origin;return re&&this.h.matches(re)&&(x["Access-Control-Allow-Origin"]=re),(0,$.serveFile)(ne,1,this.r,_,ie,x)}if(this.g){this.g.handle(_,ie,V);return}return ie.writeHead(404,{"Content-Type":"text/plain"}),void ie.end("Not found")}handleUpgrade(_,ie){let V=(0,c.generateUuid)(),J=!1,U=!1;if(_.url){const j=k.parse(_.url,!0).query;typeof j.reconnectionToken=="string"&&(V=j.reconnectionToken),j.reconnection==="true"&&(J=!0),j.skipWebSocketFrames==="true"&&(U=!0)}if(_.headers.upgrade===void 0||_.headers.upgrade.toLowerCase()!=="websocket"){ie.end("HTTP/1.1 400 Bad Request");return}const ne=_.headers["sec-websocket-key"],x=S.createHash("sha1");x.update(ne+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const Y=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${x.digest("base64")}`];let ee=!1;if(!U&&!this.n.args["disable-websocket-compression"]&&_.headers["sec-websocket-extensions"]){const j=Array.isArray(_.headers["sec-websocket-extensions"])?_.headers["sec-websocket-extensions"]:[_.headers["sec-websocket-extensions"]];for(const P of j)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(P)){if(/\b(permessage-deflate)\b/.test(P)){ee=!0,Y.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(P)){ee=!0,Y.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}ie.write(Y.join(`\r
`)+`\r
\r
`),ie.setTimeout(0),ie.setNoDelay(!0),U?this.v(new t.NodeSocket(ie,`server-connection-${V}`),J,V):this.v(new t.WebSocketNodeSocket(new t.NodeSocket(ie,`server-connection-${V}`),ee,null,!0),J,V)}handleServerError(_){this.r.error("Error occurred in server"),this.r.error(_)}t(_){let ie;return _ instanceof t.NodeSocket?ie=_.socket:ie=_.socket.socket,ie.remoteAddress||"<unknown>"}async u(_,ie,V){const J=ie.getSocket();this.r.error(`${_} ${V}.`);const U={type:"error",reason:V};ie.sendControl(b.VSBuffer.fromString(JSON.stringify(U))),ie.dispose(),await J.drain(),J.dispose()}v(_,ie,V){const J=this.t(_),U=`[${J}][${V.substr(0,8)}]`,ne=new O.PersistentProtocol({socket:_}),x=this.m?new this.m.validator:null,re=this.m?new this.m.signer:null;let Y;(function(M){M[M.WaitingForAuth=0]="WaitingForAuth",M[M.WaitingForConnectionType=1]="WaitingForConnectionType",M[M.Done=2]="Done",M[M.Error=3]="Error"})(Y||(Y={}));let ee=0;const j=M=>{ee=3,P.dispose(),this.u(U,ne,M)},P=ne.onControlMessage(M=>{if(ee===0){let K;try{K=JSON.parse(M.toString())}catch{return j("Malformed first message")}if(K.type!=="auth")return j("Invalid first message");if(this.l.type===2&&!this.l.validate(K.auth))return j("Unauthorized client refused: auth mismatch");let te=(0,c.generateUuid)();if(re)try{te=re.sign(K.data)}catch{}let z=(0,c.generateUuid)();if(x)try{z=x.createNewMessage(z)}catch{}const W={type:"sign",data:z,signedData:te};ne.sendControl(b.VSBuffer.fromString(JSON.stringify(W))),ee=1}else if(ee===1){let K;try{K=JSON.parse(M.toString())}catch{return j("Malformed second message")}if(K.type!=="connectionType")return j("Invalid second message");if(typeof K.signedData!="string")return j("Invalid second message field type");const te=K.commit,z=this.p.commit;if(te&&z&&te!==z)return j("Client refused: version mismatch");let W=!1;if(!x)W=!0;else if(this.l.validate(K.signedData))W=!0;else try{W=x.validate(K.signedData)==="ok"}catch{}if(!W){if(this.n.isBuilt)return j("Unauthorized client refused");this.r.error(`${U} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const q in this.b)this.b[q].shortenReconnectionGraceTimeIfNecessary();for(const q in this.a)this.a[q].shortenReconnectionGraceTimeIfNecessary();ee=2,P.dispose(),this.w(J,U,ne,_,ie,V,K)}})}async w(_,ie,V,J,U,ne,x){const re=x.desiredConnectionType===1?`${ie}[ManagementConnection]`:x.desiredConnectionType===2?`${ie}[ExtensionHostConnection]`:ie;if(x.desiredConnectionType===1)if(U){if(!this.b[ne])return this.f.has(ne)?this.u(re,V,"Unknown reconnection token (seen before)"):this.u(re,V,"Unknown reconnection token (never seen)");V.sendControl(b.VSBuffer.fromString(JSON.stringify({type:"ok"})));const Y=V.readEntireBuffer();V.dispose(),this.b[ne].acceptReconnection(_,J,Y)}else{if(this.b[ne])return this.u(re,V,"Duplicate reconnection token");V.sendControl(b.VSBuffer.fromString(JSON.stringify({type:"ok"})));const Y=new C.ManagementConnection(this.r,ne,_,V);this.k.acceptConnection(Y.protocol,Y.onClose),this.b[ne]=Y,this.f.add(ne),Y.onClose(()=>{delete this.b[ne]})}else if(x.desiredConnectionType===2){const Y=x.args||{language:"en"},ee=await this.C(Y);if(ee.port&&this.r.trace(`${re} - startParams debug port ${ee.port}`),this.r.trace(`${re} - startParams language: ${ee.language}`),this.r.trace(`${re} - startParams env: ${JSON.stringify(ee.env)}`),U){if(!this.a[ne])return this.f.has(ne)?this.u(re,V,"Unknown reconnection token (seen before)"):this.u(re,V,"Unknown reconnection token (never seen)");V.sendPause(),V.sendControl(b.VSBuffer.fromString(JSON.stringify(ee.port?{debugPort:ee.port}:{})));const j=V.readEntireBuffer();V.dispose(),this.a[ne].acceptReconnection(_,J,j)}else{if(this.a[ne])return this.u(re,V,"Duplicate reconnection token");V.sendPause(),V.sendControl(b.VSBuffer.fromString(JSON.stringify(ee.port?{debugPort:ee.port}:{})));const j=V.readEntireBuffer();V.dispose();const P=this.s.createInstance(I.ExtensionHostConnection,ne,_,J,j);this.a[ne]=P,this.f.add(ne),P.onClose(()=>{delete this.a[ne],this.D()}),P.start(ee)}}else if(x.desiredConnectionType===3){const Y=x.args;this.y(V,Y)}else return this.u(re,V,"Unknown initial data received")}async y(_,ie){const V=_.getSocket().socket,J=_.readEntireBuffer();_.dispose(),V.pause();const U=await this.z(ie.host,ie.port);J.byteLength>0&&U.write(J.buffer),U.on("end",()=>V.end()),U.on("close",()=>V.end()),U.on("error",()=>V.destroy()),V.on("end",()=>U.end()),V.on("close",()=>U.end()),V.on("error",()=>U.destroy()),U.pipe(V),V.pipe(U)}z(_,ie){return new Promise((V,J)=>{const U=o.createConnection({host:_,port:ie},()=>{U.removeListener("error",J),U.pause(),V(U)});U.once("error",J)})}C(_){return typeof _.port=="number"?(0,u.findFreePort)(_.port,10,5e3).then(ie=>(_.port=ie,_)):(_.debugId=void 0,_.port=void 0,_.break=void 0,Promise.resolve(_))}async D(){if(!this.n.args["enable-remote-auto-shutdown"])return;this.I(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.r.info("Last EH closed, waiting before shutting down"),this.F())}F(_=!1){this.n.args["enable-remote-auto-shutdown"]&&(this.n.args["remote-auto-shutdown-without-delay"]&&!_?this.G():this.j=setTimeout(()=>{this.j=void 0,this.G()},se))}G(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.r.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.r.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}H(){this.j&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.r.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.I(),this.F())}I(){this.j&&(console.log("Cancelling previous shutdown timeout"),this.r.info("Cancelling previous shutdown timeout"),clearTimeout(this.j),this.j=void 0)}};he=Le([Ae(4,w.IServerEnvironmentService),Ae(5,a.IProductService),Ae(6,i.ILogService),Ae(7,s.IInstantiationService)],he);async function ae(ge,_,ie){const V=await(0,E.determineServerConnectionToken)(_);V instanceof E.ServerConnectionTokenParseError&&(console.warn(V.message),process.exit(1));function J(W){(0,m.setUnexpectedErrorHandler)(q=>{(0,m.isSigPipeError)(q)&&q.stack&&/unexpectedErrorHandler/.test(q.stack)||W(q)})}const U=[];J(W=>{U.push(W),console.error(W)});let ne=!1;process.on("SIGPIPE",()=>{ne||(ne=!0,(0,m.onUnexpectedError)(new Error("Unexpected SIGPIPE")))});const x=new y.DisposableStore,{socketServer:re,instantiationService:Y}=await(0,N.setupServerServices)(V,_,ie,x);Y.invokeFunction(W=>{const q=W.get(i.ILogService);U.forEach(H=>q.error(H)),U.length=0,J(H=>q.error(H))}),Y.invokeFunction(W=>{const q=W.get(n.IConfigurationService);p.isWindows&&(q.getValue("security.restrictUNCAccess")===!1?(0,D.disableUNCAccessRestrictions)():(0,D.addUNCHostToAllowlist)(q.getValue("security.allowedUNCHosts")))}),Y.invokeFunction(W=>{const q=W.get(i.ILogService);if(p.isWindows&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const H=(0,h.join)(process.env.HOMEDRIVE,"node_modules"),Q=(0,h.dirname)((0,h.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),G=(0,h.join)(Q,"node_modules");if(L.existsSync(H)||L.existsSync(G)){const Z=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${H}
* ${G}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;q.warn(Z),console.warn(Z),process.exit(0)}}});const ee=Y.invokeFunction(W=>{const q=W.get(i.ILogService);if(L.existsSync((0,h.join)(v.FileAccess.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(Q){q.error(Q)}return null}),j=L.existsSync(v.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(j&&ge&&typeof ge!="string"){const W=V.type!==0?`?${v.connectionTokenQueryName}=${V.value}`:"";console.log(`Web UI available at http://localhost${ge.port===80?"":`:${ge.port}`}/${W}`)}const P=Y.createInstance(he,re,V,ee,j);g.mark("code/server/ready");const M=A.performance.now(),K=global.vscodeServerStartTime,te=global.vscodeServerListenTime,z=global.vscodeServerCodeLoadedTime;if(Y.invokeFunction(W=>{W.get(d.ITelemetryService).publicLog2("serverStart",{startTime:K,startedTime:te,codeLoadedTime:z,readyTime:M})}),_["print-startup-performance"]){const W=R.LoaderStats.get();let q="";q+=`

### Load AMD-module
`,q+=R.LoaderStats.toMarkdownTable(["Module","Duration"],W.amdLoad),q+=`

### Load commonjs-module
`,q+=R.LoaderStats.toMarkdownTable(["Module","Duration"],W.nodeRequire),q+=`

### Invoke AMD-module factory
`,q+=R.LoaderStats.toMarkdownTable(["Module","Duration"],W.amdInvoke),q+=`

### Invoke commonjs-module
`,q+=R.LoaderStats.toMarkdownTable(["Module","Duration"],W.nodeEval),q+=`Start-up time: ${te-K}
`,q+=`Code loading time: ${z-K}
`,q+=`Initialized time: ${M-K}
`,q+=`
`,console.log(q)}return P}e.createServer=ae;class ue{static create(_){const ie=_.webEndpointUrlTemplate,V=_.commit,J=_.quality;if(!ie||!V||!J)return new ue(null);const U=(0,c.generateUuid)(),x=new URL(ie.replace("{{uuid}}",U).replace("{{commit}}",V).replace("{{quality}}",J)).origin,re=(0,r.escapeRegExpCharacters)(x).replace(U,"[a-zA-Z0-9\\-]+");try{const Y=(0,r.createRegExp)(`^${re}$`,!0,{matchCase:!1});return new ue(Y)}catch{return new ue(null)}}constructor(_){this.a=_}matches(_){return this.a?this.a.test(_):!1}}}),define(pe[301],be([1,0,28,33,13,286,291,62,7,292,45,54,41]),function(le,e,S,L,o,A,k,R,b,m,T,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,v.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=m.performance.now();const h={onMultipleValues:(i,a)=>{console.error(`Option '${i}' can only be defined once. Using value ${a}.`)},onEmptyValue:i=>{console.error(`Ignoring option '${i}': Value must not be empty.`)},onUnknownOption:i=>{console.error(`Ignoring option '${i}': not supported for server.`)},onDeprecatedOption:(i,a)=>{console.warn(`Option '${i}' is deprecated: ${a}`)}},g=(0,R.parseArgs)(process.argv.slice(2),T.serverOptions,h),p=g["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,b.join)(S.homedir(),y.default.serverDataFolderName||".vscode-remote"),r=(0,b.join)(p,"data"),f=(0,b.join)(r,"User"),c=(0,b.join)(f,"globalStorage"),u=(0,b.join)(f,"History"),D=(0,b.join)(r,"Machine");g["user-data-dir"]=r;const O=(0,b.dirname)(o.FileAccess.asFileUri("").fsPath),t=(0,b.join)(O,"extensions");g["builtin-extensions-dir"]=t,g["extensions-dir"]=g["extensions-dir"]||(0,b.join)(p,"extensions"),[p,g["extensions-dir"],r,f,D,c,u].forEach(i=>{try{L.existsSync(i)||L.mkdirSync(i,{mode:448})}catch(a){console.error(a)}});function n(){(0,A.run)(g,p,T.serverOptions)}e.spawnCli=n;function s(i){return(0,k.createServer)(i,g,p)}e.createServer=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b380da4ef1ee00e224a15c1d4d9793e27c2b6302/core/vs/server/node/server.main.js.map
